////////////////////////////////////////////////////////////////////////////////
// File name: Logger.cpp
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// WWW page: http://kserg77.narod.ru
// Date: 2007 01 14
//
// Description:     
////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h" //     MFC /   Precompiled Headers

//#define __SDK__ // ,   SDK

#ifndef __AFX_H__
   #include <Windows.h>
   #include "CStringKS.h"
#endif

#include <commctrl.h>
#include <WindowsX.h>

namespace nsWinInet_API {
   #include <WinInet.h>
   #pragma comment(lib, "WinInet") // for InternetGetLastResponseInfo
}

#ifdef __SDK__
   namespace nsWinHTTP_API {
      #include <WinHTTP.h>
   }
#endif // __SDK__

//////////////////////////////////
#include <WinSock.h>
#include <UrlMon.h>
#include <oleidl.h>
#ifdef __SDK__
   #define _LPTARGETFRAME2_DEFINED // exclude <htiframe.h> from <htiface.h>
   #include <htiface.h>
   #include <TCError.h>
   #include <azRoles.h>
#endif // __SDK__
#include <MimeInfo.h>
#include <UrlHist.h>
#include <MSHTML.h>
#include <MSHTMHst.h>
#ifndef __SDK__
   #include <MsXml.h>
#else // __SDK__
   #include <MsXml2.h>
#endif // __SDK__
#include <mssoap30.h> // 'SOAP Toolkit 3.0' - "c:\Program Files\MSSOAP\Inc\mssoap30.h"
#include <ShlGuid.h>
#include <OAIDL.h>
#include <ObjIDL.h>
#include <comcat.h>
#include <LMErr.h>
#include <WinSpool.h>
#include <CommDlg.h>
#include <StdDef.h>
#include <CrtDbg.h>
#include <AtlDef.h>
#include <AtlConv.h> // USES_CONVERSION T2CW T2CA etc
#include <cguid.h>
#include <DispEx.h>
#ifdef __SDK__
   #include <CDONTS.h>
   #include <rtccore.h>
   #include <MSDaIppEr.h>
   #include <nserror.h>
#endif // __SDK__
#ifdef __AFX_H__
   #include <afxpriv.h>  // Internal AFX Windows messages (WM_AFXFIRST - WM_AFXLAST are reserved for MFC)
#endif // __AFX_H__

#ifdef __SDK__
   #include <winternl.h> // extInfo == info_NTStatus
   #include <ntstatus.h> // extInfo == info_NTStatus

   #include <Dimm.h>
   #include <StrSafe.h>
#endif // __SDK__

#ifdef __SDK__
   //#include <CdoEx.h>
   //#pragma comment(lib, "Uuid")
   //namespace CDO {
   //   #include <CdoExM.h>
   //}
#endif // __SDK__
#include <ShellAPI.h>

#include <io.h>

#include "Logger.h"

////////////////////////////////////////////////////////////////////////////////////////
//                               HELP Function
////////////////////////////////////////////////////////////////////////////////////////
namespace nsLogger {

   inline BOOL FileExist(LPCTSTR szPath) {
      DWORD dwAttr = GetFileAttributes(szPath);
      return ((dwAttr != 0xFFFFFFFF) && !(dwAttr & FILE_ATTRIBUTE_DIRECTORY));
   }

   CString GetFileVersion(HMODULE hModule) {
      TCHAR szFileName[MAX_PATH] = {0};
      ::GetModuleFileName(hModule, szFileName, MAX_PATH);
      CString strRes;
      DWORD dwErrCode = ERROR_SUCCESS;
      if (!FileExist(szFileName)) {
         dwErrCode = ::GetLastError();
      } else {
         DWORD dwSize = ::GetFileVersionInfoSize(szFileName, 0);
         if (dwSize == 0) {
            dwErrCode = ::GetLastError();
         } else {
            BYTE *pData = new BYTE [dwSize];
            if (pData == NULL) {
               dwErrCode = ERROR_OUTOFMEMORY;
            } else {
               BOOL bRes = ::GetFileVersionInfo(szFileName, 0, dwSize, pData);
               if (!bRes ) {
                  dwErrCode = ::GetLastError();
               } else {
                  VS_FIXEDFILEINFO *pFixeFileInfo = NULL;
                  UINT uLen = 0;
                  bRes = ::VerQueryValue(pData, _T("\\"), (void**)&pFixeFileInfo, &uLen);
                  if (!bRes) {
                     dwErrCode = ::GetLastError();
                  } else {
                     WORD v1 = HIWORD(pFixeFileInfo->dwFileVersionMS);
                     WORD v2 = LOWORD(pFixeFileInfo->dwFileVersionMS);
                     WORD v3 = HIWORD(pFixeFileInfo->dwFileVersionLS);
                     WORD v4 = LOWORD(pFixeFileInfo->dwFileVersionLS);
                     strRes.Format(_T("%i.%i.%i.%i"), int(v1),int(v2),int(v3),int(v4));
                  }
               }
               delete [] pData; pData = NULL;
            }
         }
      }
      ::SetLastError(dwErrCode);
      return strRes;
   }

__forceinline CString GUID2String(IN REFGUID guid) {
   CString strRes;
   OLECHAR szRes[39] = {0};
   if (::StringFromGUID2(guid, szRes, sizeof(szRes)>>1)) {
      strRes = szRes;
   } else {
      strRes.Format(_T("{%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}"),
         int(guid.Data1), int(guid.Data2), int(guid.Data3), int(guid.Data4[0]), int(guid.Data4[1]), int(guid.Data4[2]), int(guid.Data4[3]), int(guid.Data4[4]), int(guid.Data4[5]), int(guid.Data4[6]), int(guid.Data4[7]));
   }
   return strRes;
}

BOOL String2GUID(IN LPCTSTR szGUID, OUT GUID &guid) {
   BOOL bRes = FALSE;
   DWORD dwErrCode = ERROR_INVALID_PARAMETER;
   if (szGUID) {
      USES_CONVERSION;
      HRESULT hRes = ::CLSIDFromString(T2OLE(const_cast<TCHAR*>(szGUID)), &guid);
      switch (hRes) {
      case NOERROR           : bRes = TRUE ; dwErrCode = ERROR_SUCCESS;    break;
      case CO_E_CLASSSTRING  : bRes = FALSE; dwErrCode = ERROR_BAD_FORMAT; break; // The class string was improperly formatted.
      case REGDB_E_WRITEREGDB: // The CLSID corresponding to the class string was not found in the registry.
      default:
         if (szGUID) {
            dwErrCode = ERROR_INVALID_DATA;
            //    GUID
            // 0         1         2         3
            // 01234567890123456789012345678901234567
            // {01234567-0123-0123-0123-0123456789AB}
            CString strGUID(szGUID);
            strGUID.MakeUpper();
            static TCHAR szABC[] = _T("0123456789ABCDEF");
            if ((strGUID.GetLength() != 38) ||
                (szGUID[ 0] != _T('{')) ||
                (szGUID[ 9] != _T('-')) ||
                (szGUID[14] != _T('-')) ||
                (szGUID[19] != _T('-')) ||
                (szGUID[24] != _T('-')) ||
                (szGUID[37] != _T('}')) /**/||
                (!strGUID.Mid( 1, 8).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(10, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(15, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(20, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(25,12).SpanExcluding(szABC).IsEmpty())/**/
               )
            {
            } else {
               strGUID.Replace(_T('{'), _T(' '));
               strGUID.Replace(_T('-'), _T(' '));
               strGUID.Replace(_T('}'), _T(' '));
               /**
               strGUID = strGUID.Mid( 1, 8) + //
                         strGUID.Mid(10, 4) + // + _T(" ")
                         strGUID.Mid(15, 4) + // + _T(" ")
                         strGUID.Mid(20, 2) + // + _T(" ")
                         strGUID.Mid(22, 2) + // + _T(" ")
                         strGUID.Mid(25, 2) + // + _T(" ")
                         strGUID.Mid(27, 2) + // + _T(" ")
                         strGUID.Mid(29, 2) + // + _T(" ")
                         strGUID.Mid(31, 2) + // + _T(" ")
                         strGUID.Mid(33, 2) + // + _T(" ")
                         strGUID.Mid(35, 2);  // + _T(" ")
               /**/
               int iData1=0, iData2=0, iData3=0, iData4[8] = {0,0,0,0,0,0,0,0};
               if (
         #ifdef _stscanf_s
                  _stscanf_s
         #else
                  _stscanf
         #endif
                   ((LPCTSTR)strGUID, _T("%08X%04X%04X%02X%02X%02X%02X%02X%02X%02X%02X"),
                     &iData1, &iData2, &iData3,
                     &iData4[0], &iData4[1], &iData4[2], &iData4[3],
                     &iData4[4], &iData4[5], &iData4[6], &iData4[7]) == 11)
               {
                  guid.Data1 = iData1; guid.Data2 = iData2; guid.Data3 = iData3;
                  guid.Data4[0] = iData4[0];
                  guid.Data4[1] = iData4[1];
                  guid.Data4[2] = iData4[2];
                  guid.Data4[3] = iData4[3];
                  guid.Data4[4] = iData4[4];
                  guid.Data4[5] = iData4[5];
                  guid.Data4[6] = iData4[6];
                  guid.Data4[7] = iData4[7];
                  bRes = TRUE;
                  dwErrCode = ERROR_SUCCESS;
               } else {
                  dwErrCode = ERROR_INVALID_DATA; //::GetLastError();
               }
            }
         }
      } // swicth
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

CString ErrorCode2Str(IN HMODULE hModule, IN DWORD dwErrCode) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   LPTSTR szError = NULL;
   DWORD dwBaseLength = ::FormatMessage(
      FORMAT_MESSAGE_IGNORE_INSERTS |
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_HMODULE, // dwFlags
      hModule,                                                      // lpSource
      dwErrCode,                                                    // dwMessageId
      0,                                                            // dwLanguageId
      (LPTSTR)&szError,                                             // lpBuffer
      0,                                                            // nSize
      NULL );                                                       // * arguments

   CString strRes;
   if (dwBaseLength == 0) {
      dwErrCodeRes = ::GetLastError();
   } else {
      strRes = szError;
      strRes.Replace(_T("\r\n"), _T(" "));
      strRes.TrimRight();
   }
   if (szError) {
      ::LocalFree(szError);
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

CString ErrorCode2Str(IN LPCTSTR lpModuleName, IN DWORD dwErrCode) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   HMODULE hMod = ::GetModuleHandle(lpModuleName);
   BOOL bLoadLibrary = FALSE;
   if (hMod == NULL) {
      hMod = ::LoadLibrary(lpModuleName);
      bLoadLibrary = (hMod != NULL);
      if (!bLoadLibrary) {
         dwErrCodeRes = ::GetLastError();
      }
   }

   CString strRes;
   if (hMod) {
      strRes = nsLogger::ErrorCode2Str(hMod, dwErrCode);
      if (strRes.IsEmpty()) {
         dwErrCodeRes = ::GetLastError();
      }
   }

   if (bLoadLibrary) {
      BOOL bRes = ::FreeLibrary(hMod);
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

CString WinInetErrorCode2Str(DWORD dwErrCode) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   CString strRes = ErrorCode2Str(_T("WinInet.dll"), dwErrCode);
   if (strRes.IsEmpty()) {
      dwErrCodeRes = ::GetLastError();
   } else {
      strRes = _T("Internet API error. ") + strRes;

      if (dwErrCode == ERROR_INTERNET_EXTENDED_ERROR) {
         DWORD dwInetError = 0;
         DWORD dwExtLength = 0;
         BOOL bRes = nsWinInet_API::InternetGetLastResponseInfo(&dwInetError, NULL, &dwExtLength);
         DWORD dwErrCode2 = ::GetLastError();
         if ((dwErrCode2 != ERROR_INSUFFICIENT_BUFFER) || (dwExtLength==0)) {
            dwErrCodeRes = ::GetLastError();
         } else {
            TCHAR *szExtErrMsg = new TCHAR [dwExtLength = dwExtLength+1]; // + EOL
            if (szExtErrMsg == NULL) {
               dwErrCodeRes = ERROR_OUTOFMEMORY;
            } else {
               szExtErrMsg[0] = 0;
               BOOL bRes = nsWinInet_API::InternetGetLastResponseInfo(&dwInetError, szExtErrMsg, &dwExtLength);
               if (!bRes) {
                  dwErrCodeRes = ::GetLastError();
               } else {
                  strRes += szExtErrMsg;
               }

               delete [] szExtErrMsg;
            }
         }
      }
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

CString ErrorCode2Str(DWORD dwErrCode) {
   CString strRes;
   LPTSTR lpMsgBuf = NULL;
   DWORD dwRes = ::FormatMessage(
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
      NULL,
      dwErrCode,
      MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
      (LPTSTR)&lpMsgBuf,
      0,
      NULL
   );
   if (dwRes != 0) {
      strRes = lpMsgBuf;
      strRes.Replace(_T("\r\n"), _T(" "));
      strRes.TrimRight();
   } else {
      //DWORD dwErrCode2 = ::GetLastError(); // must be ERROR_MR_MID_NOT_FOUND ???
   }
   ::LocalFree(lpMsgBuf);
   return strRes;
}

#ifndef LOGGER_UNDEF
CString ErrorCode2Str(DWORD dwErrCode, CLogger::eInfoExt extInfo) {
   CString strRes;
   switch (extInfo) {
   case CLogger::info_NTStatus:
      strRes = ErrorCode2Str(_T("ntdll.dll"), dwErrCode);
      break;
#ifdef __SDK__
   case CLogger::info_WinHTTP:
      if ((dwErrCode >= WINHTTP_ERROR_BASE) && (dwErrCode <= 12999L)) {
         strRes = ErrorCode2Str(_T("WinHttp.dll"), dwErrCode);
      }
      break;
#endif // __SDK__
   default:
      if ((dwErrCode >= INTERNET_ERROR_BASE) && (dwErrCode <= 12999L)) {
#ifdef EXCLUDE_STATIC_LINK_WININET_LIBRARY //    ,    WinInet.dll   -  
         strRes = ErrorCode2Str(_T("WinInet.dll"), dwErrCode);
#else
         strRes = WinInetErrorCode2Str(dwErrCode);
#endif
      } else {
         strRes = ErrorCode2Str(dwErrCode);
      }
   }
   return strRes;
}

BOOL EnumGUIDsFromRegistry(IN LPCTSTR lpSubKey, IN CLogger::GUIDENUMPROC pEnumFunc, IN LPVOID lpUserData) {
   if (!lpSubKey || !lpSubKey[0] || !pEnumFunc) return FALSE;

   BOOL bRes = FALSE;
   HKEY hKey = NULL;
   DWORD dwErrCode = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, lpSubKey, 0, KEY_READ | KEY_ENUMERATE_SUB_KEYS, &hKey);
   if ((dwErrCode == ERROR_SUCCESS) && (hKey != NULL)) {
      int iIndex = 0;
      do {
         TCHAR szKeyName[1024] = {0};
         DWORD dwSizeKeyName = 1024;
         dwErrCode = ::RegEnumKeyEx(hKey, iIndex++, szKeyName, &dwSizeKeyName, NULL, NULL, NULL, NULL);
         if (dwErrCode != ERROR_SUCCESS) {
            break;
         } else {
            GUID guid = {0,0,0,{0,0,0,0,0,0,0,0}};
            if (nsLogger::String2GUID(szKeyName, guid)) {
               HKEY hKey2 = NULL;
               dwErrCode = ::RegOpenKeyEx(hKey, szKeyName, 0, KEY_READ, &hKey2);
               if (dwErrCode == ERROR_SUCCESS) {
                  TCHAR szValueName[1] = {0}; //     ,   0 !    1 ...
                  DWORD dwSizeValueName=1,
                        dwType,
                        dwSizeData=1024;
                  BYTE pbData[1024] = {0};

                  dwErrCode = ::RegEnumValue(hKey2, 0, szValueName, &dwSizeValueName, NULL, &dwType, pbData, &dwSizeData);
                  ::RegCloseKey(hKey2); hKey2 = NULL;
                  if ((dwErrCode == ERROR_SUCCESS) &&
                      (dwType == REG_SZ) &&
                      (szValueName[0] == 0))
                  {
                     LPCTSTR szRes = (LPCTSTR)pbData;
                     bRes = pEnumFunc(guid, (szRes && szRes[0]) ? szRes : szKeyName, lpUserData);
                     if (!bRes) break; // stop enumeration
                  }
               }
            }
         }
      } while(true);
   }
   ::RegCloseKey(hKey); hKey = NULL;
   return bRes;
}
#endif // LOGGER_UNDEF

struct CEqualsGUIDs_Func_Data {
   REFGUID  m_GUID;
   LPCTSTR  m_szSeparator;
   CString &m_strRes;
   CEqualsGUIDs_Func_Data(REFGUID guid, LPCTSTR szSeparator, CString &strRes) : m_GUID(guid), m_szSeparator(szSeparator), m_strRes(strRes) {}
};
BOOL CALLBACK EqualsGUIDs_Func(IN REFGUID guid, IN LPCTSTR szGUID, IN LPVOID lpUserData);

struct CCoCreateInstances_Func_Data {
   REFCLSID m_CLSID;
   LPCTSTR  m_szSeparator;
   CString &m_strRes;
   CCoCreateInstances_Func_Data(REFCLSID clsid, LPCTSTR szSeparator, CString &strRes) : m_CLSID(clsid), m_szSeparator(szSeparator), m_strRes(strRes) {}
};
BOOL CALLBACK CoCreateInstances_Func(IN REFGUID guid, IN LPCTSTR szGUID, IN LPVOID lpUserData);

struct CQueryInterfaces_Func_Data {
   IUnknown *m_pInterface;
   LPCTSTR   m_szSeparator;
   CString  &m_strRes;
   CQueryInterfaces_Func_Data(IUnknown *pInterface, LPCTSTR szSeparator, CString &strRes) : m_pInterface(pInterface), m_szSeparator(szSeparator), m_strRes(strRes) {}
};
BOOL CALLBACK QueryInterfaces_Func(IN REFGUID guid, IN LPCTSTR szGUID, IN LPVOID lpUserData);

inline HINSTANCE __stdcall GetInstanceFromAddress(PVOID pEip) { //  Alex Fedotov rsdn
   _ASSERTE(pEip != NULL);

   MEMORY_BASIC_INFORMATION mem;
   if (VirtualQuery(pEip, &mem, sizeof(mem)))
   {
      _ASSERTE((mem.Type == MEM_IMAGE) || (mem.Type == MEM_PRIVATE));
      _ASSERTE(mem.AllocationBase != NULL);
      return (HINSTANCE)mem.AllocationBase;
   }
   return NULL;
}

inline __declspec(naked) HINSTANCE __stdcall GetCurrentInstance() { //  Alex Fedotov rsdn
   /** / // VC 7.0  intrinsic-   _ReturnAddress,       .
         //        .
         //     ,   VC 6.0    (  ,    SP),
         //             VC 6.0 SP5
   MEMORY_BASIC_INFORMATION mem;
   if (VirtualQuery(_ReturnAddress(), &mem, sizeof(mem))) {
      _ASSERTE((mem.Type == MEM_IMAGE) || (mem.Type == MEM_PRIVATE));
      _ASSERTE(mem.AllocationBase != NULL);
      return (HINSTANCE)mem.AllocationBase;
   }
   return NULL;
   /**/
   __asm {
#ifdef _M_IX86
      mov   eax, [esp]
      push  eax
      jmp   GetInstanceFromAddress
#else
      #error This machine type is not supported.
#endif
   }
}

} // namespace nsLogger

////////////////////////////////////////////////////////////////////////////////////////
//                               IMPLEMENTATION CLogger
////////////////////////////////////////////////////////////////////////////////////////
#ifdef LOGGER_UNDEF

   namespace nsLogger {
      void Put(IN LPCTSTR szStr, ...) {
         va_list argList;
         va_start(argList, szStr);
         CString strRes; strRes.FormatV(szStr, argList);
         ::OutputDebugString(strRes);
         ::OutputDebugString(_T("\r\n"));
         va_end(argList);
      }

      void PutErrorCode(IN LPCTSTR szStr, IN DWORD dwErrCode) {
         CString strErr = nsLogger::ErrorCode2Str(dwErrCode);
         nsLogger::Put(_T("%sError code is %i%s"), szStr ? szStr : _T(""), dwErrCode, (LPCTSTR)(strErr.IsEmpty() ? _T("") : (LPCTSTR)(_T(" (")+strErr+_T(")"))));
      }
      void PutHResult(IN LPCTSTR szStr, IN DWORD dwErrCode) { PutErrorCode(szStr, dwErrCode); }
   } // namespace nsLogger

#else // LOGGER_UNDEF

#define LOG_PUT_LOCAL(funcName, logLevel) if (CLogger::logLevel <= m_LL) funcName(CLogger::logLevel,

#define CLogger_Constructor(logLevel, szFileName, szUserHint, pStream, bShowDate, bShowTime,                \
                            bShowLogLevel, bShowThreadId, bUnicodeWrite, bShowTimeFromFirstMessage)         \
 : m_pStream(NULL),                                                                                         \
   m_hFile  (NULL)                                                                                          \
{                                                                                                           \
   m_ftFirstMessage.dwHighDateTime = m_ftFirstMessage.dwLowDateTime = 0;                                    \
   ::GetLocalTime(&m_stLastLocalTime);                                                                      \
   ::InitializeCriticalSection(&m_cs);                                                                      \
   /*m_ftFirstMessage = ::GetSystemTimeAsFileTime();*/                                                      \
                                                                                                            \
   ShowDate(bShowDate);                                                                                     \
   ShowTime(bShowTime);                                                                                     \
   ShowTimeFromFirstMessage(bShowTimeFromFirstMessage);                                                     \
   ShowLogLevel(bShowLogLevel);                                                                             \
   ShowThreadId(bShowThreadId);                                                                             \
   SetLogLevel(logLevel);                                                                                   \
   SetUserHint(szUserHint);                                                                                 \
   SetUnicodeWrite(bUnicodeWrite);                                                                          \
   SetStream(pStream);                                                                                      \
   SetFileName(szFileName);                                                                                 \
   SetNewDayNewFile(FALSE);                                                                                 \
                                                                                                            \
   /*LOG_PUT_LOCAL(Put, LL_INFO) _T("//////////////=========  Open  Log [%s] =========//////////////"), (LPCTSTR)m_strFile); */\
}

CLogger::CLogger()
#ifdef UNICODE
   #ifdef _DEBUG
      CLogger_Constructor(CLogger::LL_DEBUG, _T("_Log.txt"), NULL, NULL, FALSE, TRUE, TRUE, TRUE, TRUE , FALSE)
   #else
      CLogger_Constructor(CLogger::LL_INFO , _T("_Log.txt"), NULL, NULL, FALSE, TRUE, TRUE, TRUE, TRUE , FALSE)
   #endif
#else
   #ifdef _DEBUG
      CLogger_Constructor(CLogger::LL_DEBUG, _T("_Log.txt"), NULL, NULL, FALSE, TRUE, TRUE, TRUE, FALSE, FALSE)
   #else
      CLogger_Constructor(CLogger::LL_INFO , _T("_Log.txt"), NULL, NULL, FALSE, TRUE, TRUE, TRUE, FALSE, FALSE)
   #endif
#endif

CLogger::CLogger(
   eLogLevel logLevel,
   LPCTSTR szFileName,
   LPCTSTR szUserHint,
   ISequentialStream *pStream,
   BOOL bShowDate,
   BOOL bShowTime,
   BOOL bShowLogLevel,
   BOOL bShowThreadId,
   BOOL bUnicodeWrite,
   BOOL bShowTimeFromFirstMessage
)
CLogger_Constructor(logLevel, szFileName, szUserHint, pStream, bShowDate, bShowTime, bShowLogLevel, bShowThreadId, bUnicodeWrite, bShowTimeFromFirstMessage)

CLogger::CLogger(
   eLogLevel logLevel,
   LPCTSTR szFileName,
   LPCTSTR szUserHint,
   ISequentialStream *pStream,
   BOOL bShowDate,
   BOOL bShowTime,
   BOOL bShowLogLevel,
   BOOL bShowThreadId
)
#ifdef UNICODE
   CLogger_Constructor(logLevel, szFileName, szUserHint, pStream, bShowDate, bShowTime, bShowLogLevel, bShowThreadId, TRUE , FALSE)
#else
   CLogger_Constructor(logLevel, szFileName, szUserHint, pStream, bShowDate, bShowTime, bShowLogLevel, bShowThreadId, FALSE, FALSE)
#endif

#undef CLogger_Constructor

CLogger::~CLogger() {
   //LOG_PUT_LOCAL(Put, LL_INFO) _T("//////////////=========  Close Log [%s] =========//////////////"), (LPCTSTR)m_strFile);
   SetFileName(NULL); // close file
   ::EnterCriticalSection(&m_cs);
   if (m_pStream) {
      m_pStream->Release(); m_pStream = NULL;
   }
   ::LeaveCriticalSection(&m_cs);
   ::DeleteCriticalSection(&m_cs);
}

void CLogger::ShowDate                (BOOL bShow) { ::EnterCriticalSection(&m_cs); m_bShowDate                 = bShow; ::LeaveCriticalSection(&m_cs); }
void CLogger::ShowTime                (BOOL bShow) { ::EnterCriticalSection(&m_cs); m_bShowTime                 = bShow; ::LeaveCriticalSection(&m_cs); }
void CLogger::ShowTimeFromFirstMessage(BOOL bShow) { ::EnterCriticalSection(&m_cs); m_bShowTimeFromFirstMessage = bShow; ::LeaveCriticalSection(&m_cs); }
void CLogger::ShowLogLevel            (BOOL bShow) { ::EnterCriticalSection(&m_cs); m_bShowLogLevel             = bShow; ::LeaveCriticalSection(&m_cs); }
void CLogger::ShowThreadId            (BOOL bShow) { ::EnterCriticalSection(&m_cs); m_bShowThreadId             = bShow; ::LeaveCriticalSection(&m_cs); }

CLogger::eLogLevel CLogger::GetLogLevel() const {return m_LL;}
BOOL               CLogger::SetLogLevel(eLogLevel logLevel) {
   ::EnterCriticalSection(&m_cs);
   m_LL = logLevel;
   ::LeaveCriticalSection(&m_cs);
   return TRUE;
}

BOOL CLogger::InterceptSTDOut(BOOL bAttach) {
   ::SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
   return FALSE;
   /** /
   BOOL bRes = FALSE;
   DWORD dwErrCode = NO_ERROR;
   #define PIPE_STDOUT_NAME _T("\\\\.\\pipe\\_Logger_std_out")
   HANDLE hPipe = ::CreateNamedPipe(
      PIPE_STDOUT_NAME,
      PIPE_ACCESS_DUPLEX,
      PIPE_TYPE_BYTE | PIPE_READMODE_BYTE,
      PIPE_UNLIMITED_INSTANCES,
      512, 512, 0,
      NULL);
   bRes = (hPipe != INVALID_HANDLE_VALUE);
   if (!bRes) {
      dwErrCode = ::GetLastError();
      LOG_PUT_LOCAL(PutErrorCode, LL_ERROR) _T("  CLogger::InterceptSTDOut: CreateNamedPipe: "), dwErrCode);
   } else {
      HANDLE hStd = ::CreateFile(
         PIPE_STDOUT_NAME,
         GENERIC_WRITE |GENERIC_READ,
         FILE_SHARE_WRITE |FILE_SHARE_READ,
         NULL,
         CREATE_ALWAYS,
         FILE_ATTRIBUTE_NORMAL,
         NULL);
      bRes = (hStd != INVALID_HANDLE_VALUE);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT_LOCAL(PutErrorCode, LL_ERROR) _T("  CLogger::InterceptSTDOut: CreateFile: "), dwErrCode);
      } else {
         bRes = ::ConnectNamedPipe(hPipe, NULL);
         if (!bRes) {
            dwErrCode = ::GetLastError();
            LOG_PUT_LOCAL(PutErrorCode, LL_ERROR) _T("  CLogger::InterceptSTDOut: ConnectNamedPipe: "), dwErrCode);
         } else {
            bRes  = ::SetStdHandle(STD_OUTPUT_HANDLE, hStd);
            bRes &= ::SetStdHandle(STD_ERROR_HANDLE , hStd);
      #ifndef _O_TEXT
         #define _O_TEXT 0x4000
      #endif
            stdout->_file = _open_osfhandle((long)hStd, _O_TEXT);
            bRes &= (stdout->_file != -1);
            stderr->_file = _open_osfhandle((long)hStd, _O_TEXT);
            bRes &= (stderr->_file != -1);
         }
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
   /**/
}

CString CLogger::GetFileName() const {return m_strFile;}
BOOL    CLogger::SetFileName(LPCTSTR szFileName) {
   ::EnterCriticalSection(&m_cs);

   if (m_hFile) { //     
      BY_HANDLE_FILE_INFORMATION fa = {0,{0,0},{0,0},{0,0},0,0,0,0,0,0};
      if (::GetFileInformationByHandle(m_hFile, &fa) == FALSE) {
         //DWORD dwErrCode = ::GetLastError();
         //if (dwErrCode == ERROR_INVALID_HANDLE)
         {
            m_hFile = NULL;
         }
      }
   }

   if (m_hFile && szFileName) {
      SetFileName(NULL);
   }

   BOOL bRes = FALSE;
   if (szFileName && szFileName[0]) {
      m_strFile.Empty();

      if (szFileName[1] != _T(':')) {
         TCHAR szPath[MAX_PATH] = {0};
         ::GetModuleFileName(NULL, szPath, MAX_PATH);
         {
            for (int i=lstrlen(szPath); i; i--)
               if (szPath[i] == _T('\\')) {
                  szPath[i+1] = _T('\0');
                  break;
               }
         }
         m_strFile = szPath;
         m_strFile += szFileName;
      } else {
         m_strFile = szFileName;
      }
      { // CreateFile
         if (m_hFile) {
            ::CloseHandle(m_hFile); m_hFile = NULL;
         }
         m_hFile = ::CreateFile(
            m_strFile,
            GENERIC_WRITE,
            FILE_SHARE_READ | FILE_SHARE_WRITE,
            NULL,
            OPEN_ALWAYS,
            FILE_ATTRIBUTE_NORMAL,
            NULL
         );
         if (m_hFile == INVALID_HANDLE_VALUE) {
            DWORD dwErrCode = ::GetLastError();
            m_hFile = NULL;
            CString strFile = m_strFile;
            m_strFile.Empty();
            LOG_PUT_LOCAL(PutErrorCode, LL_ERROR) _T("  CLogger::SetFileName: CreateFile: "), dwErrCode);
            LOG_PUT_LOCAL(Put         , LL_INFO) _T("  CLogger::SetFileName: Output data to the file [%s] aborted! "), (LPCTSTR)strFile);
         } else {
            if (m_bUnicodeWrite) { //   ,   "FF FE" -  UNICODE 
               BOOL bUnicodeHeader = FALSE;
               BY_HANDLE_FILE_INFORMATION fa = {0,{0,0},{0,0},{0,0},0,0,0,0,0,0};
               if (::GetFileInformationByHandle(m_hFile, &fa)) {
                  if ((fa.nFileSizeHigh == 0) &&
                      (fa.nFileSizeLow  == 0))
                  {
                     DWORD dwNBW = 0;
                     BOOL bRes2 = ::WriteFile(m_hFile, "\xFF\xFE", 2, &dwNBW, NULL) && (dwNBW == 2);
                  }
               }
            }

            HMODULE   hProcess = ::GetModuleHandle(NULL);        // this process
            HINSTANCE hModule  = nsLogger::GetCurrentInstance(); // this module
            TCHAR szPathProcess[MAX_PATH] = {0}; ::GetModuleFileName(hProcess, szPathProcess, MAX_PATH);
            if (hModule  == hProcess) {
               LOG_PUT_LOCAL(Put, LL_INFO) _T("//////////////=========  Open Log [%s]. (Process [%s] version - %s) =========//////////////"), (LPCTSTR)m_strFile, szPathProcess, (LPCTSTR)nsLogger::GetFileVersion(hProcess));
            } else {
               TCHAR szPathDLL[MAX_PATH] = {0}; ::GetModuleFileName(hModule, szPathDLL, MAX_PATH);
               LOG_PUT_LOCAL(Put, LL_INFO) _T("//////////////=========  Open Log [%s]. (Process [%s] version - %s. Module [%s] version - %s.) =========//////////////"), (LPCTSTR)m_strFile, szPathProcess, (LPCTSTR)nsLogger::GetFileVersion(hProcess), szPathDLL, (LPCTSTR)nsLogger::GetFileVersion(hModule));
            }
         }
         bRes = (m_hFile != NULL);
      }
   } else {
      if (m_hFile) {
         LOG_PUT_LOCAL(Put, LL_INFO) _T("//////////////=========  Close Log [%s] =========//////////////"), (LPCTSTR)m_strFile);
         ::CloseHandle(m_hFile); m_hFile = NULL;
         m_strFile.Empty();
      }
      bRes = TRUE;
   }

   ::LeaveCriticalSection(&m_cs);
   return bRes;
}

CString CLogger::GetUserHint() const {return m_strUserHint;}
BOOL    CLogger::SetUserHint(LPCTSTR szUserHint) {
   ::EnterCriticalSection(&m_cs);

   m_strUserHint.Empty();
   if (szUserHint) {
      static const int iMaxUserHint = 16;
      m_strUserHint.Format(_T("%.*s"), iMaxUserHint, szUserHint);
      if (m_strUserHint.GetLength() < iMaxUserHint) {
         m_strUserHint += CString(_T(' '), iMaxUserHint-m_strUserHint.GetLength());
      }
      m_strUserHint += _T("   ");
   }

   ::LeaveCriticalSection(&m_cs);
   return TRUE;
}

BOOL CLogger::GetStream(OUT ISequentialStream **ppStream) {
   ::EnterCriticalSection(&m_cs);
   BOOL bRes = FALSE;
   if (ppStream) {
      *ppStream = NULL;
      if (m_pStream) {
         *ppStream = m_pStream;
         ((IUnknown*)*ppStream)->AddRef();
      }
      bRes = TRUE;
   }
   ::LeaveCriticalSection(&m_cs);
   return bRes;
}

BOOL CLogger::SetStream(IN ISequentialStream *pStream) {
   ::EnterCriticalSection(&m_cs);
   if (m_pStream) {
      m_pStream->Release(); m_pStream = NULL;
   }
   if (pStream) {
      pStream->QueryInterface(IID_ISequentialStream, (void**)&m_pStream);
   }
   ::LeaveCriticalSection(&m_cs);
   return TRUE;
}

BOOL CLogger::GetUnicodeWrite() const { return m_bUnicodeWrite; }
void CLogger::SetUnicodeWrite(IN BOOL bUnicodeWrite) {
   ::EnterCriticalSection(&m_cs);
   m_bUnicodeWrite = bUnicodeWrite;
   ::LeaveCriticalSection(&m_cs);
}

BOOL CLogger::GetNewDayNewFile() const { return m_bNewDayNewFile; }
void CLogger::SetNewDayNewFile(IN BOOL bNewDayNewFile) {
   ::EnterCriticalSection(&m_cs);
   m_bNewDayNewFile = bNewDayNewFile;
   ::LeaveCriticalSection(&m_cs);
}

CString CLogger::Put(IN eLogLevel logLevel, IN LPCTSTR szStr, ...)
{
   va_list argList;
   va_start(argList, szStr);
   CString strRes = PutV(logLevel, szStr, argList);
   va_end(argList);
   return strRes;
}

CString CLogger::PutV(IN eLogLevel logLevel, IN LPCTSTR szStr, IN va_list argList) {
   if (logLevel > m_LL) {
      return CString();
   }

   SYSTEMTIME stLocal = {0,0,0,0,0,0,0,0};
   ::GetLocalTime(&stLocal);

   ::EnterCriticalSection(&m_cs);

   if (m_bNewDayNewFile &&
       m_hFile && ((m_stLastLocalTime.wYear  != stLocal.wYear ) ||
                   (m_stLastLocalTime.wMonth != stLocal.wMonth) ||
                   (m_stLastLocalTime.wDay   != stLocal.wDay  )))
   {
      //  .   .

      CString strDate; strDate.Format(_T("%04i.%02i.%02i"), int(m_stLastLocalTime.wYear), int(m_stLastLocalTime.wMonth), int(m_stLastLocalTime.wDay));

      m_stLastLocalTime = stLocal;

      CString strFileName(this->GetFileName());
      //      .
      int iFind1 = strFileName.ReverseFind(_T('.'));
      int iFind2 = strFileName.ReverseFind(_T('\\'));
      int iFind3 = strFileName.ReverseFind(_T('/'));
      CString strNewFileName; //     
      if ((iFind1 == -1) || ((iFind1 < iFind2) || (iFind1 < iFind3))) {
         //  
         strNewFileName = strFileName +_T('_')+strDate+_T(".log");
      } else {
         strNewFileName = strFileName.Left(iFind1) + _T('_')+strDate + strFileName.Right(strFileName.GetLength()-iFind1);
      }

      LOG_PUT_LOCAL(Put, LL_INFO) _T("  The day finished. Created new file. This file must renamed to the '%s'. "), (LPCTSTR)strNewFileName);

      SetFileName(NULL); //   

      //  
      BOOL bRes = ::MoveFile(strFileName, strNewFileName);
      if (!bRes) {
         SetFileName(strFileName);
         DWORD dwErrCode = ::GetLastError();
         LOG_PUT_LOCAL(PutErrorCode, LL_ERROR) _T("  CLogger::PutV: MoveFile('")+strFileName+_T("', '")+strNewFileName+_T("'): "), dwErrCode);
      } else {
         LOG_PUT_LOCAL(Put, LL_DEBUG) _T("  CLogger::PutV: File '%s' renamed to '%s'."), (LPCTSTR)strFileName, (LPCTSTR)strNewFileName);
      }

      //      
      SetFileName(strFileName);

      ::GetLocalTime(&stLocal);
   }
   m_stLastLocalTime = stLocal;

   FILETIME ftFromFirstMessage = {0,0};
   if (m_bShowTimeFromFirstMessage ||
       ((m_ftFirstMessage.dwHighDateTime == 0) &&
        (m_ftFirstMessage.dwLowDateTime  == 0))
      )
   {
      FILETIME ft = {0,0};
      ::GetSystemTimeAsFileTime(&ft);
      if ((m_ftFirstMessage.dwHighDateTime == 0) &&
          (m_ftFirstMessage.dwLowDateTime  == 0))
      {
         m_ftFirstMessage = ft;
      }
      LARGE_INTEGER li, liFM;
      li.LowPart  = ft.dwLowDateTime;
      li.HighPart = ft.dwHighDateTime;
      liFM.LowPart  = m_ftFirstMessage.dwLowDateTime;
      liFM.HighPart = m_ftFirstMessage.dwHighDateTime;
      li.QuadPart = li.QuadPart - liFM.QuadPart;
      ftFromFirstMessage.dwLowDateTime  = li.LowPart;
      ftFromFirstMessage.dwHighDateTime = li.HighPart;
   }

   CString strRes;
   if (szStr) {
      if (argList) {
         strRes.FormatV(szStr, argList);
      } else {
         strRes = szStr;
      }
   }
   strRes = _T('\x05') + strRes;

   if (m_bShowThreadId) {
      CString strTrID; strTrID.Format(_T("%08X   "), ::GetCurrentThreadId());
      strRes = _T('\x04') + strTrID + strRes;
   }

   if (m_bShowLogLevel) {
      CString strLogLevel;
      switch (logLevel) {
      case LL_FATAL  : strLogLevel = _T("FATAL     "); break;
      case LL_ERROR  : strLogLevel = _T("ERROR     "); break;
      case LL_WARNING: strLogLevel = _T("WARNING   "); break;
      case LL_INFO   : strLogLevel = _T("INFO      "); break;
      case LL_DEBUG  : strLogLevel = _T("DEBUG     "); break;
      }
      strRes = _T('\x03') + strLogLevel + strRes;
   }

   if (!m_strUserHint.IsEmpty()) {
      strRes = _T('\x02') + m_strUserHint + strRes;
   }

   if (m_bShowDate || m_bShowTime) {
      if (m_bShowTimeFromFirstMessage) {
         SYSTEMTIME stFromFirstMessage; ::FileTimeToSystemTime(&ftFromFirstMessage, &stFromFirstMessage);
         strRes = _T("\x01[") +
            SystemTime(stLocal, m_bShowDate, m_bShowTime) +
            _T("  ") + SystemTime(stFromFirstMessage, FALSE, TRUE) +
            _T("]   ") +
            strRes;
      } else {
         strRes = _T("\x01[") +
            SystemTime(stLocal, m_bShowDate, m_bShowTime) +
            _T("]   ") +
            strRes;
      }
   } else {
      if (m_bShowTimeFromFirstMessage) {
         SYSTEMTIME stFromFirstMessage; ::FileTimeToSystemTime(&ftFromFirstMessage, &stFromFirstMessage);
         strRes = _T("\x01[") +
            SystemTime(stFromFirstMessage, FALSE, TRUE) +
            _T("]   ") +
            strRes;
      }
   }

   if (m_hFile) {
      if (::SetFilePointer(m_hFile,0,NULL,FILE_END) == 0xFFFFFFFF) {
         DWORD dwErrCode = ::GetLastError();
         CString strFileName = GetFileName();
         SetFileName(NULL);
         LOG_PUT_LOCAL(PutErrorCode, LL_ERROR) _T("  CLogger::PutV: SetFilePointer: "), dwErrCode);
         SetFileName(strFileName);
      } else {
         static LPCWSTR szEOLW = L"\r\n";
         static LPCSTR  szEOLA =  "\r\n";
       //DWORD dwSize1 = m_bUnicodeWrite ? (lstrlenW(T2CW((LPCTSTR)strRes))<<1) : lstrlenA(T2CA((LPCTSTR)strRes)); //  !  1, 
         DWORD dwSize1 = strRes.GetLength() << (m_bUnicodeWrite ? 1 : 0);                                          //  !  2, 
         static DWORD dwSize2W = lstrlenW(szEOLW);
         static DWORD dwSize2A = lstrlenA(szEOLA);
         DWORD dwSize2 = m_bUnicodeWrite ? dwSize2W : dwSize2A;
         DWORD dwNBW1 = 0, dwNBW2 = 0;
         USES_CONVERSION;
         if (!::WriteFile(m_hFile, m_bUnicodeWrite ? (LPCVOID)T2CW((LPCTSTR)strRes) : (LPCVOID)T2CA((LPCTSTR)strRes), dwSize1, &dwNBW1, NULL) || (dwSize1 != dwNBW1) ||
             !::WriteFile(m_hFile, m_bUnicodeWrite ? (LPCVOID)              szEOLW  : (LPCVOID)              szEOLA , dwSize2, &dwNBW2, NULL) || (dwSize2 != dwNBW2))
         {
            DWORD dwErrCode = ::GetLastError();
            CString strFileName = GetFileName();
            SetFileName(NULL);
            LOG_PUT_LOCAL(PutErrorCode, LL_ERROR) _T("  CLogger::PutV: WriteFile: "), dwErrCode);
            SetFileName(strFileName);
         }
      }
   }
   if (m_pStream) {
      USES_CONVERSION;
      ULONG ulWritten = 0;
    //ULONG ulWrite = m_bUnicodeWrite ? (lstrlenW(T2CW((LPCTSTR)strRes))<<1) : lstrlenA(T2CA((LPCTSTR)strRes)) + (m_bUnicodeWrite ? sizeof(WCHAR) : sizeof(CHAR))/**/; //  !  1, 
      ULONG ulWrite = (strRes.GetLength() << (m_bUnicodeWrite ? 1 : 0))                                        + (m_bUnicodeWrite ? sizeof(WCHAR) : sizeof(CHAR))/**/; //  !  2, 
      m_pStream->Write(m_bUnicodeWrite ? (LPCVOID)T2CW((LPCTSTR)strRes) : (LPCVOID)T2CA((LPCTSTR)strRes), ulWrite, &ulWritten);
   }

#ifdef __AFX_H__
   /*
   {
      static const int iTraceMax = 511; // @TODO:       ,  -  ::AfxTrace()
      if (strRes.GetLength() <= iTraceMax) {
         ::AfxTrace(_T("%s"), (LPCTSTR)strRes);
      } else {
         CString strCopy = strRes;
         do {
            ::AfxTrace(_T("%s"), (LPCTSTR)strCopy.Left(iTraceMax));
            strCopy = strCopy.Mid(min(strCopy.GetLength(), iTraceMax));
         } while(!strCopy.IsEmpty());
      }
      ::AfxTrace(_T("\r\n"));
   }/**/
#endif // __AFX_H__
#ifdef _DEBUG
   {
      ::OutputDebugString(strRes);
      ::OutputDebugString(_T("\r\n"));
   }
#endif // _DEBUG

   ::LeaveCriticalSection(&m_cs);
   return strRes;
}

CString CLogger::PutErrorCode(IN eLogLevel logLevel, IN LPCTSTR szStr, IN DWORD dwErrCode, IN CLogger::eInfoExt extInfo, BOOL bSysMsg)
{   return Put(logLevel, _T("%sError code is %s (%s)"), szStr ? szStr : _T(""),
      (LPCTSTR)CLogger::ErrorCode            (dwErrCode, extInfo),
      (LPCTSTR)CLogger::ErrorCode_Description(dwErrCode, extInfo, bSysMsg));
}

CString CLogger::PutHResult(IN eLogLevel logLevel, IN LPCTSTR szStr, IN HRESULT hRes, BOOL bSysMsg)
{  return Put(logLevel, _T("%sHRESULT is %s (%s)"), szStr ? szStr : _T(""),
      (LPCTSTR)CLogger::HResult            (hRes),
      (LPCTSTR)CLogger::HResult_Description(hRes, bSysMsg));
}

////////////////////////////////////////////////////////////////////////////////////////
//                                        static member CLogger
////////////////////////////////////////////////////////////////////////////////////////

/* static */ CString CLogger::ErrorCode(LONG lErrCode, CLogger::eInfoExt extInfo, BOOL bDescription, BOOL bSysMsg) {
   CString strRes;
   if (bDescription && (extInfo != info_HResult) && bSysMsg) {
      strRes = nsLogger::ErrorCode2Str(lErrCode, extInfo);
      if (!strRes.IsEmpty())
         return strRes;
   }

#ifndef LOGGER_DUMMY
   #define CASE_ERRCODE1(val)                    case (val): strRes = _T(#val); break;
   #define CASE_ERRCODE2(val,       Description) case (val): strRes = ((bDescription) ? (Description) : _T(#val)); break;
   #define CASE_ERRCODE3(val, Name, Description) case (val): strRes = ((bDescription) ? (Description) : (Name)); break;
   //     (.. ) ERROR'  HRESULT'
   if (strRes.IsEmpty()) {
      switch (lErrCode) {
    //CASE_ERRCODE2(S_OK                                                               , _T("S_OK")                                                               , _T("Success codes"))
      CASE_ERRCODE3(ERROR_SUCCESS                                                      , (extInfo == info_HResult) ? _T("S_OK"): _T("ERROR_SUCCESS")              , (extInfo == info_HResult) ? _T("Success codes") : _T("The operation completed successfully."))
    //CASE_ERRCODE2(S_FALSE                                                            , _T("S_FALSE")                                                            , _T("Success codes"))
      CASE_ERRCODE3(ERROR_INVALID_FUNCTION                                             , (extInfo == info_HResult) ? _T("S_FALSE"): _T("ERROR_INVALID_FUNCTION")  , (extInfo == info_HResult) ? _T("Success codes") : _T("Incorrect function."))
      CASE_ERRCODE2(ERROR_FILE_NOT_FOUND                                               , _T("The system cannot find the file specified."))
      CASE_ERRCODE2(ERROR_PATH_NOT_FOUND                                               , _T("The system cannot find the path specified."))
      CASE_ERRCODE2(ERROR_TOO_MANY_OPEN_FILES                                          , _T("The system cannot open the file."))
      CASE_ERRCODE2(ERROR_ACCESS_DENIED                                                , _T("Access is denied."))
      CASE_ERRCODE2(ERROR_INVALID_HANDLE                                               , _T("The handle is invalid. (The handle that was passed to the API has been either invalidated or closed.)"))
      CASE_ERRCODE2(ERROR_ARENA_TRASHED                                                , _T("The storage control blocks were destroyed."))
      CASE_ERRCODE2(ERROR_NOT_ENOUGH_MEMORY                                            , _T("Windows error code. Not enough storage is available to process this command."))
      CASE_ERRCODE2(ERROR_INVALID_BLOCK                                                , _T("The storage control block address is invalid."))
      CASE_ERRCODE2(ERROR_BAD_ENVIRONMENT                                              , _T("The environment is incorrect."))
      CASE_ERRCODE2(ERROR_BAD_FORMAT                                                   , _T("An attempt was made to load a program with an incorrect format."))
      CASE_ERRCODE2(ERROR_INVALID_ACCESS                                               , _T("The access code is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_DATA                                                 , _T("The data is invalid."))
      CASE_ERRCODE2(ERROR_OUTOFMEMORY                                                  , _T("Not enough storage is available to complete this operation."))
      CASE_ERRCODE2(ERROR_INVALID_DRIVE                                                , _T("The system cannot find the drive specified."))
      CASE_ERRCODE2(ERROR_CURRENT_DIRECTORY                                            , _T("The directory cannot be removed."))
      CASE_ERRCODE2(ERROR_NOT_SAME_DEVICE                                              , _T("The system cannot move the file to a different disk drive."))
      CASE_ERRCODE2(ERROR_NO_MORE_FILES                                                , _T("There are no more files. (No more files have been found.)"))
      CASE_ERRCODE2(ERROR_WRITE_PROTECT                                                , _T("The media is write protected."))
      CASE_ERRCODE2(ERROR_BAD_UNIT                                                     , _T("The system cannot find the device specified."))
      CASE_ERRCODE2(ERROR_NOT_READY                                                    , _T("The device is not ready."))
      CASE_ERRCODE2(ERROR_BAD_COMMAND                                                  , _T("The device does not recognize the command."))
      CASE_ERRCODE2(ERROR_CRC                                                          , _T("Data error (cyclic redundancy check)."))
      CASE_ERRCODE2(ERROR_BAD_LENGTH                                                   , _T("The program issued a command but the command length is incorrect."))
      CASE_ERRCODE2(ERROR_SEEK                                                         , _T("The drive cannot locate a specific area or track on the disk."))
      CASE_ERRCODE2(ERROR_NOT_DOS_DISK                                                 , _T("The specified disk or diskette cannot be accessed."))
      CASE_ERRCODE2(ERROR_SECTOR_NOT_FOUND                                             , _T("The drive cannot find the sector requested."))
      CASE_ERRCODE2(ERROR_OUT_OF_PAPER                                                 , _T("The printer is out of paper."))
      CASE_ERRCODE2(ERROR_WRITE_FAULT                                                  , _T("The system cannot write to the specified device."))
      CASE_ERRCODE2(ERROR_READ_FAULT                                                   , _T("The system cannot read from the specified device."))
      CASE_ERRCODE2(ERROR_GEN_FAILURE                                                  , _T("A device attached to the system is not functioning."))
      CASE_ERRCODE2(ERROR_SHARING_VIOLATION                                            , _T("The process cannot access the file because it is being used by another process."))
      CASE_ERRCODE2(ERROR_LOCK_VIOLATION                                               , _T("The process cannot access the file because another process has locked a portion of the file."))
      CASE_ERRCODE2(ERROR_WRONG_DISK                                                   , _T("The wrong diskette is in the drive. Insert %2 (Volume Serial Number: %3) into drive %1."))
      CASE_ERRCODE2(ERROR_SHARING_BUFFER_EXCEEDED                                      , _T("Too many files opened for sharing."))
      CASE_ERRCODE2(ERROR_HANDLE_EOF                                                   , _T("Reached the end of the file."))
      CASE_ERRCODE2(ERROR_HANDLE_DISK_FULL                                             , _T("The disk is full."))
      CASE_ERRCODE2(ERROR_NOT_SUPPORTED                                                , _T("The request is not supported."))
      CASE_ERRCODE2(ERROR_REM_NOT_LIST                                                 , _T("Windows cannot find the network path. Verify that the network path is correct and the destination computer is not busy or turned off. If Windows still cannot find the network path, contact your network administrator."))
      CASE_ERRCODE2(ERROR_DUP_NAME                                                     , _T("You were not connected because a duplicate name exists on the network. Go to System in the Control Panel to change the computer name and try again."))
      CASE_ERRCODE2(ERROR_BAD_NETPATH                                                  , _T("The network path was not found."))
      CASE_ERRCODE2(ERROR_NETWORK_BUSY                                                 , _T("The network is busy."))
      CASE_ERRCODE2(ERROR_DEV_NOT_EXIST                                                , _T("The specified network resource or device is no longer available."))
      CASE_ERRCODE2(ERROR_TOO_MANY_CMDS                                                , _T("The network BIOS command limit has been reached."))
      CASE_ERRCODE2(ERROR_ADAP_HDW_ERR                                                 , _T("A network adapter hardware error occurred."))
      CASE_ERRCODE2(ERROR_BAD_NET_RESP                                                 , _T("The specified server cannot perform the requested operation."))
      CASE_ERRCODE2(ERROR_UNEXP_NET_ERR                                                , _T("An unexpected network error occurred."))
      CASE_ERRCODE2(ERROR_BAD_REM_ADAP                                                 , _T("The remote adapter is not compatible."))
      CASE_ERRCODE2(ERROR_PRINTQ_FULL                                                  , _T("The printer queue is full."))
      CASE_ERRCODE2(ERROR_NO_SPOOL_SPACE                                               , _T("Space to store the file waiting to be printed is not available on the server."))
      CASE_ERRCODE2(ERROR_PRINT_CANCELLED                                              , _T("Your file waiting to be printed was deleted."))
      CASE_ERRCODE2(ERROR_NETNAME_DELETED                                              , _T("The specified network name is no longer available."))
      CASE_ERRCODE2(ERROR_NETWORK_ACCESS_DENIED                                        , _T("Network access is denied."))
      CASE_ERRCODE2(ERROR_BAD_DEV_TYPE                                                 , _T("The network resource type is not correct."))
      CASE_ERRCODE2(ERROR_BAD_NET_NAME                                                 , _T("The network name cannot be found."))
      CASE_ERRCODE2(ERROR_TOO_MANY_NAMES                                               , _T("The name limit for the local computer network adapter card was exceeded."))
      CASE_ERRCODE2(ERROR_TOO_MANY_SESS                                                , _T("The network BIOS session limit was exceeded."))
      CASE_ERRCODE2(ERROR_SHARING_PAUSED                                               , _T("The remote server has been paused or is in the process of being started."))
      CASE_ERRCODE2(ERROR_REQ_NOT_ACCEP                                                , _T("No more connections can be made to this remote computer at this time because there are already as many connections as the computer can accept."))
      CASE_ERRCODE2(ERROR_REDIR_PAUSED                                                 , _T("The specified printer or disk device has been paused."))
      CASE_ERRCODE2(ERROR_FILE_EXISTS                                                  , _T("The file exists."))
      CASE_ERRCODE2(ERROR_CANNOT_MAKE                                                  , _T("The directory or file cannot be created."))
      CASE_ERRCODE2(ERROR_FAIL_I24                                                     , _T("Fail on INT 24."))
      CASE_ERRCODE2(ERROR_OUT_OF_STRUCTURES                                            , _T("Storage to process this request is not available."))
      CASE_ERRCODE2(ERROR_ALREADY_ASSIGNED                                             , _T("The local device name is already in use."))
      CASE_ERRCODE2(ERROR_INVALID_PASSWORD                                             , _T("The specified network password is not correct."))
      CASE_ERRCODE2(ERROR_INVALID_PARAMETER                                            , _T("The parameter is incorrect."))
      CASE_ERRCODE2(ERROR_NET_WRITE_FAULT                                              , _T("A write fault occurred on the network."))
      CASE_ERRCODE2(ERROR_NO_PROC_SLOTS                                                , _T("The system cannot start another process at this time."))
      CASE_ERRCODE2(ERROR_TOO_MANY_SEMAPHORES                                          , _T("Cannot create another system semaphore."))
      CASE_ERRCODE2(ERROR_EXCL_SEM_ALREADY_OWNED                                       , _T("The exclusive semaphore is owned by another process."))
      CASE_ERRCODE2(ERROR_SEM_IS_SET                                                   , _T("The semaphore is set and cannot be closed."))
      CASE_ERRCODE2(ERROR_TOO_MANY_SEM_REQUESTS                                        , _T("The semaphore cannot be set again."))
      CASE_ERRCODE2(ERROR_INVALID_AT_INTERRUPT_TIME                                    , _T("Cannot request exclusive semaphores at interrupt time."))
      CASE_ERRCODE2(ERROR_SEM_OWNER_DIED                                               , _T("The previous ownership of this semaphore has ended."))
      CASE_ERRCODE2(ERROR_SEM_USER_LIMIT                                               , _T("Insert the diskette for drive %1."))
      CASE_ERRCODE2(ERROR_DISK_CHANGE                                                  , _T("The program stopped because an alternate diskette was not inserted."))
      CASE_ERRCODE2(ERROR_DRIVE_LOCKED                                                 , _T("The disk is in use or locked by another process."))
      CASE_ERRCODE2(ERROR_BROKEN_PIPE                                                  , _T("The pipe has been ended."))
      CASE_ERRCODE2(ERROR_OPEN_FAILED                                                  , _T("The system cannot open the device or file specified."))
      CASE_ERRCODE2(ERROR_BUFFER_OVERFLOW                                              , _T("The file name is too long."))
      CASE_ERRCODE2(ERROR_DISK_FULL                                                    , _T("There is not enough space on the disk."))
      CASE_ERRCODE2(ERROR_NO_MORE_SEARCH_HANDLES                                       , _T("No more internal file identifiers available."))
      CASE_ERRCODE2(ERROR_INVALID_TARGET_HANDLE                                        , _T("The target internal file identifier is incorrect."))
      CASE_ERRCODE2(ERROR_INVALID_CATEGORY                                             , _T("The IOCTL call made by the application program is not correct."))
      CASE_ERRCODE2(ERROR_INVALID_VERIFY_SWITCH                                        , _T("The verify-on-write switch parameter value is not correct."))
      CASE_ERRCODE2(ERROR_BAD_DRIVER_LEVEL                                             , _T("The system does not support the command requested."))
      CASE_ERRCODE2(ERROR_CALL_NOT_IMPLEMENTED                                         , _T("This function is not supported on this system."))
      CASE_ERRCODE2(ERROR_SEM_TIMEOUT                                                  , _T("The semaphore timeout period has expired."))
      CASE_ERRCODE2(ERROR_INSUFFICIENT_BUFFER                                          , _T("The data area passed to a system call is too small. (The size of the buffer supplied to a function was insufficient to contain the returned data. The number of bytes required is usually returned in the buffer size parameter. See the specific function for details.)"))
      CASE_ERRCODE2(ERROR_INVALID_NAME                                                 , _T("The filename, directory name, or volume label syntax is incorrect."))
      CASE_ERRCODE2(ERROR_INVALID_LEVEL                                                , _T("The system call level is not correct."))
      CASE_ERRCODE2(ERROR_NO_VOLUME_LABEL                                              , _T("The disk has no volume label."))
      CASE_ERRCODE2(ERROR_MOD_NOT_FOUND                                                , _T("The specified module could not be found."))
      CASE_ERRCODE2(ERROR_PROC_NOT_FOUND                                               , _T("The specified procedure could not be found."))
      CASE_ERRCODE2(ERROR_WAIT_NO_CHILDREN                                             , _T("There are no child processes to wait for."))
      CASE_ERRCODE2(ERROR_CHILD_NOT_COMPLETE                                           , _T("The %1 application cannot be run in Win32 mode."))
      CASE_ERRCODE2(ERROR_DIRECT_ACCESS_HANDLE                                         , _T("Attempt to use a file handle to an open disk partition for an operation other than raw disk I/O."))
      CASE_ERRCODE2(ERROR_NEGATIVE_SEEK                                                , _T("An attempt was made to move the file pointer before the beginning of the file."))
      CASE_ERRCODE2(ERROR_SEEK_ON_DEVICE                                               , _T("The file pointer cannot be set on the specified device or file."))
      CASE_ERRCODE2(ERROR_IS_JOIN_TARGET                                               , _T("A JOIN or SUBST command cannot be used for a drive that contains previously joined drives."))
      CASE_ERRCODE2(ERROR_IS_JOINED                                                    , _T("An attempt was made to use a JOIN or SUBST command on a drive that has already been joined."))
      CASE_ERRCODE2(ERROR_IS_SUBSTED                                                   , _T("An attempt was made to use a JOIN or SUBST command on a drive that has already been substituted."))
      CASE_ERRCODE2(ERROR_NOT_JOINED                                                   , _T("The system tried to delete the JOIN of a drive that is not joined."))
      CASE_ERRCODE2(ERROR_NOT_SUBSTED                                                  , _T("The system tried to delete the substitution of a drive that is not substituted."))
      CASE_ERRCODE2(ERROR_JOIN_TO_JOIN                                                 , _T("The system tried to join a drive to a directory on a joined drive."))
      CASE_ERRCODE2(ERROR_SUBST_TO_SUBST                                               , _T("The system tried to substitute a drive to a directory on a substituted drive."))
      CASE_ERRCODE2(ERROR_JOIN_TO_SUBST                                                , _T("The system tried to join a drive to a directory on a substituted drive."))
      CASE_ERRCODE2(ERROR_SUBST_TO_JOIN                                                , _T("The system tried to SUBST a drive to a directory on a joined drive."))
      CASE_ERRCODE2(ERROR_BUSY_DRIVE                                                   , _T("The system cannot perform a JOIN or SUBST at this time."))
      CASE_ERRCODE2(ERROR_SAME_DRIVE                                                   , _T("The system cannot join or substitute a drive to or for a directory on the same drive."))
      CASE_ERRCODE2(ERROR_DIR_NOT_ROOT                                                 , _T("The directory is not a subdirectory of the root directory."))
      CASE_ERRCODE2(ERROR_DIR_NOT_EMPTY                                                , _T("The directory is not empty."))
      CASE_ERRCODE2(ERROR_IS_SUBST_PATH                                                , _T("The path specified is being used in a substitute."))
      CASE_ERRCODE2(ERROR_IS_JOIN_PATH                                                 , _T("Not enough resources are available to process this command."))
      CASE_ERRCODE2(ERROR_PATH_BUSY                                                    , _T("The path specified cannot be used at this time."))
      CASE_ERRCODE2(ERROR_IS_SUBST_TARGET                                              , _T("An attempt was made to join or substitute a drive for which a directory on the drive is the target of a previous substitute."))
      CASE_ERRCODE2(ERROR_SYSTEM_TRACE                                                 , _T("System trace information was not specified in your CONFIG.SYS file, or tracing is disallowed."))
      CASE_ERRCODE2(ERROR_INVALID_EVENT_COUNT                                          , _T("The number of specified semaphore events for DosMuxSemWait is not correct."))
      CASE_ERRCODE2(ERROR_TOO_MANY_MUXWAITERS                                          , _T("DosMuxSemWait did not execute; too many semaphores are already set."))
      CASE_ERRCODE2(ERROR_INVALID_LIST_FORMAT                                          , _T("The DosMuxSemWait list is not correct."))
      CASE_ERRCODE2(ERROR_LABEL_TOO_LONG                                               , _T("The volume label you entered exceeds the label character limit of the target file system."))
      CASE_ERRCODE2(ERROR_TOO_MANY_TCBS                                                , _T("Cannot create another thread."))
      CASE_ERRCODE2(ERROR_SIGNAL_REFUSED                                               , _T("The recipient process has refused the signal."))
      CASE_ERRCODE2(ERROR_DISCARDED                                                    , _T("The segment is already discarded and cannot be locked."))
      CASE_ERRCODE2(ERROR_NOT_LOCKED                                                   , _T("The segment is already unlocked."))
      CASE_ERRCODE2(ERROR_BAD_THREADID_ADDR                                            , _T("The address for the thread ID is not correct."))
      CASE_ERRCODE2(ERROR_BAD_ARGUMENTS                                                , _T("The argument string passed to DosExecPgm is not correct."))
      CASE_ERRCODE2(ERROR_BAD_PATHNAME                                                 , _T("The specified path is invalid."))
      CASE_ERRCODE2(ERROR_SIGNAL_PENDING                                               , _T("A signal is already pending."))
      CASE_ERRCODE2(ERROR_MAX_THRDS_REACHED                                            , _T("No more threads can be created in the system."))
      CASE_ERRCODE2(ERROR_LOCK_FAILED                                                  , _T("Unable to lock a region of a file."))
      CASE_ERRCODE2(ERROR_BUSY                                                         , _T("The requested resource is in use."))
      CASE_ERRCODE2(ERROR_CANCEL_VIOLATION                                             , _T("A lock request was not outstanding for the supplied cancel region."))
      CASE_ERRCODE2(ERROR_ATOMIC_LOCKS_NOT_SUPPORTED                                   , _T("The file system does not support atomic changes to the lock type."))
      CASE_ERRCODE2(ERROR_INVALID_SEGMENT_NUMBER                                       , _T("The system detected a segment number that was not correct."))
      CASE_ERRCODE2(ERROR_INVALID_ORDINAL                                              , _T("The operating system cannot run %1."))
      CASE_ERRCODE2(ERROR_ALREADY_EXISTS                                               , _T("Cannot create a file when that file already exists."))
      CASE_ERRCODE2(ERROR_INVALID_FLAG_NUMBER                                          , _T("The flag passed is not correct."))
      CASE_ERRCODE2(ERROR_SEM_NOT_FOUND                                                , _T("The specified system semaphore name was not found."))
      CASE_ERRCODE2(ERROR_INVALID_STARTING_CODESEG                                     , _T("The operating system cannot run %1."))
      CASE_ERRCODE2(ERROR_INVALID_STACKSEG                                             , _T("The operating system cannot run %1."))
      CASE_ERRCODE2(ERROR_INVALID_MODULETYPE                                           , _T("The operating system cannot run %1."))
      CASE_ERRCODE2(ERROR_INVALID_EXE_SIGNATURE                                        , _T("Cannot run %1 in Win32 mode."))
      CASE_ERRCODE2(ERROR_EXE_MARKED_INVALID                                           , _T("The operating system cannot run %1."))
      CASE_ERRCODE2(ERROR_BAD_EXE_FORMAT                                               , _T("%1 is not a valid Win32 application."))
      CASE_ERRCODE2(ERROR_ITERATED_DATA_EXCEEDS_64k                                    , _T("The operating system cannot run %1."))
      CASE_ERRCODE2(ERROR_INVALID_MINALLOCSIZE                                         , _T("The operating system cannot run %1."))
      CASE_ERRCODE2(ERROR_DYNLINK_FROM_INVALID_RING                                    , _T("The operating system cannot run this application program."))
      CASE_ERRCODE2(ERROR_IOPL_NOT_ENABLED                                             , _T("The operating system is not presently configured to run this application."))
      CASE_ERRCODE2(ERROR_INVALID_SEGDPL                                               , _T("The operating system cannot run %1."))
      CASE_ERRCODE2(ERROR_AUTODATASEG_EXCEEDS_64k                                      , _T("The operating system cannot run this application program."))
      CASE_ERRCODE2(ERROR_RING2SEG_MUST_BE_MOVABLE                                     , _T("The code segment cannot be greater than or equal to 64K."))
      CASE_ERRCODE2(ERROR_RELOC_CHAIN_XEEDS_SEGLIM                                     , _T("The operating system cannot run %1."))
      CASE_ERRCODE2(ERROR_INFLOOP_IN_RELOC_CHAIN                                       , _T("The operating system cannot run %1."))
      CASE_ERRCODE2(ERROR_ENVVAR_NOT_FOUND                                             , _T("The system could not find the environment option that was entered."))
      CASE_ERRCODE2(ERROR_NO_SIGNAL_SENT                                               , _T("No process in the command subtree has a signal handler."))
      CASE_ERRCODE2(ERROR_FILENAME_EXCED_RANGE                                         , _T("The filename or extension is too long."))
      CASE_ERRCODE2(ERROR_RING2_STACK_IN_USE                                           , _T("The ring 2 stack is in use."))
      CASE_ERRCODE2(ERROR_META_EXPANSION_TOO_LONG                                      , _T("The global filename characters, * or ?, are entered incorrectly or too many global filename characters are specified."))
      CASE_ERRCODE2(ERROR_INVALID_SIGNAL_NUMBER                                        , _T("The signal being posted is not correct."))
      CASE_ERRCODE2(ERROR_THREAD_1_INACTIVE                                            , _T("The signal handler cannot be set."))
      CASE_ERRCODE2(ERROR_LOCKED                                                       , _T("The segment is locked and cannot be reallocated."))
      CASE_ERRCODE2(ERROR_TOO_MANY_MODULES                                             , _T("Too many dynamic-link modules are attached to this program or dynamic-link module."))
      CASE_ERRCODE2(ERROR_NESTING_NOT_ALLOWED                                          , _T("Cannot nest calls to LoadModule."))
      CASE_ERRCODE2(ERROR_EXE_MACHINE_TYPE_MISMATCH                                    , _T("The image file %1 is valid, but is for a machine type other than the current machine."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY                              , _T("The image file %1 is signed, unable to modify."))
      CASE_ERRCODE2(ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY                       , _T("The image file %1 is strong signed, unable to modify."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_BAD_PIPE                                                     , _T("The pipe state is invalid."))
      CASE_ERRCODE2(ERROR_PIPE_BUSY                                                    , _T("All pipe instances are busy."))
      CASE_ERRCODE2(ERROR_NO_DATA                                                      , _T("The pipe is being closed."))
      CASE_ERRCODE2(ERROR_PIPE_NOT_CONNECTED                                           , _T("No process is on the other end of the pipe."))
      CASE_ERRCODE2(ERROR_MORE_DATA                                                    , _T("More data is available."))
      CASE_ERRCODE2(ERROR_VC_DISCONNECTED                                              , _T("The session was canceled."))
      CASE_ERRCODE2(ERROR_INVALID_EA_NAME                                              , _T("The specified extended attribute name was invalid."))
      CASE_ERRCODE2(ERROR_EA_LIST_INCONSISTENT                                         , _T("The extended attributes are inconsistent."))
      CASE_ERRCODE2(WAIT_TIMEOUT                                                       , _T("The wait operation timed out."))
      CASE_ERRCODE2(ERROR_NO_MORE_ITEMS                                                , _T("No more data is available. (No more items have been found.)"))
      CASE_ERRCODE2(ERROR_CANNOT_COPY                                                  , _T("The copy functions cannot be used."))
      CASE_ERRCODE2(ERROR_DIRECTORY                                                    , _T("The directory name is invalid."))
      CASE_ERRCODE2(ERROR_EAS_DIDNT_FIT                                                , _T("The extended attributes did not fit in the buffer."))
      CASE_ERRCODE2(ERROR_EA_FILE_CORRUPT                                              , _T("The extended attribute file on the mounted file system is corrupt."))
      CASE_ERRCODE2(ERROR_EA_TABLE_FULL                                                , _T("The extended attribute table file is full."))
      CASE_ERRCODE2(ERROR_INVALID_EA_HANDLE                                            , _T("The specified extended attribute handle is invalid."))
      CASE_ERRCODE2(ERROR_EAS_NOT_SUPPORTED                                            , _T("The mounted file system does not support extended attributes."))
      CASE_ERRCODE2(ERROR_NOT_OWNER                                                    , _T("Attempt to release mutex not owned by caller."))
      CASE_ERRCODE2(ERROR_TOO_MANY_POSTS                                               , _T("Too many posts were made to a semaphore."))
      CASE_ERRCODE2(ERROR_PARTIAL_COPY                                                 , _T("Only part of a ReadProcessMemory or WriteProcessMemory request was completed."))
      CASE_ERRCODE2(ERROR_OPLOCK_NOT_GRANTED                                           , _T("The oplock request is denied."))
      CASE_ERRCODE2(ERROR_INVALID_OPLOCK_PROTOCOL                                      , _T("An invalid oplock acknowledgment was received by the system."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_DISK_TOO_FRAGMENTED                                          , _T("The volume is too fragmented to complete this operation."))
      CASE_ERRCODE2(ERROR_DELETE_PENDING                                               , _T("The file cannot be opened because it is in the process of being deleted."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_MR_MID_NOT_FOUND                                             , _T("The system cannot find message text for message number 0x%1 in the message file for %2."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_SCOPE_NOT_FOUND                                              , _T("The scope specified was not found."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_INVALID_ADDRESS                                              , _T("Attempt to access invalid address."))
      CASE_ERRCODE2(ERROR_ARITHMETIC_OVERFLOW                                          , _T("Arithmetic result exceeded 32 bits."))
      CASE_ERRCODE2(ERROR_PIPE_CONNECTED                                               , _T("There is a process on other end of the pipe."))
      CASE_ERRCODE2(ERROR_PIPE_LISTENING                                               , _T("Waiting for a process to open the other end of the pipe."))
      CASE_ERRCODE2(ERROR_EA_ACCESS_DENIED                                             , _T("Access to the extended attribute was denied."))
      CASE_ERRCODE2(ERROR_OPERATION_ABORTED                                            , _T("The I/O operation has been aborted because of either a thread exit or an application request."))
      CASE_ERRCODE2(ERROR_IO_INCOMPLETE                                                , _T("Overlapped I/O event is not in a signaled state."))
      CASE_ERRCODE2(ERROR_IO_PENDING                                                   , _T("Overlapped I/O operation is in progress."))
      CASE_ERRCODE2(ERROR_NOACCESS                                                     , _T("Invalid access to memory location."))
      CASE_ERRCODE2(ERROR_SWAPERROR                                                    , _T("Error performing inpage operation."))
      CASE_ERRCODE2(ERROR_STACK_OVERFLOW                                               , _T("Recursion too deep; the stack overflowed."))
      CASE_ERRCODE2(ERROR_INVALID_MESSAGE                                              , _T("The window cannot act on the sent message."))
      CASE_ERRCODE2(ERROR_CAN_NOT_COMPLETE                                             , _T("Cannot complete this function."))
      CASE_ERRCODE2(ERROR_INVALID_FLAGS                                                , _T("Invalid flags."))
      CASE_ERRCODE2(ERROR_UNRECOGNIZED_VOLUME                                          , _T("The volume does not contain a recognized file system. Please make sure that all required file system drivers are loaded and that the volume is not corrupted."))
      CASE_ERRCODE2(ERROR_FILE_INVALID                                                 , _T("The volume for a file has been externally altered so that the opened file is no longer valid."))
      CASE_ERRCODE2(ERROR_FULLSCREEN_MODE                                              , _T("The requested operation cannot be performed in full-screen mode."))
      CASE_ERRCODE2(ERROR_NO_TOKEN                                                     , _T("An attempt was made to reference a token that does not exist."))
      CASE_ERRCODE2(ERROR_BADDB                                                        , _T("The configuration registry database is corrupt."))
      CASE_ERRCODE2(ERROR_BADKEY                                                       , _T("The configuration registry key is invalid."))
      CASE_ERRCODE2(ERROR_CANTOPEN                                                     , _T("The configuration registry key could not be opened."))
      CASE_ERRCODE2(ERROR_CANTREAD                                                     , _T("The configuration registry key could not be read."))
      CASE_ERRCODE2(ERROR_CANTWRITE                                                    , _T("The configuration registry key could not be written."))
      CASE_ERRCODE2(ERROR_REGISTRY_RECOVERED                                           , _T("One of the files in the registry database had to be recovered by use of a log or alternate copy. The recovery was successful."))
      CASE_ERRCODE2(ERROR_REGISTRY_CORRUPT                                             , _T("The registry is corrupted. The structure of one of the files containing registry data is corrupted, or the system's memory image of the file is corrupted, or the file could not be recovered because the alternate copy or log was absent or corrupted."))
      CASE_ERRCODE2(ERROR_REGISTRY_IO_FAILED                                           , _T("An I/O operation initiated by the registry failed unrecoverably. The registry could not read in, or write out, or flush, one of the files that contain the system's image of the registry."))
      CASE_ERRCODE2(ERROR_NOT_REGISTRY_FILE                                            , _T("The system has attempted to load or restore a file into the registry, but the specified file is not in a registry file format."))
      CASE_ERRCODE2(ERROR_KEY_DELETED                                                  , _T("Illegal operation attempted on a registry key that has been marked for deletion."))
      CASE_ERRCODE2(ERROR_NO_LOG_SPACE                                                 , _T("System could not allocate the required space in a registry log."))
      CASE_ERRCODE2(ERROR_KEY_HAS_CHILDREN                                             , _T("Cannot create a symbolic link in a registry key that already has subkeys or values."))
      CASE_ERRCODE2(ERROR_CHILD_MUST_BE_VOLATILE                                       , _T("Cannot create a stable subkey under a volatile parent key."))
      CASE_ERRCODE2(ERROR_NOTIFY_ENUM_DIR                                              , _T("A notify change request is being completed and the information is not being returned in the caller's buffer. The caller now needs to enumerate the files to find the changes."))
      CASE_ERRCODE2(ERROR_DEPENDENT_SERVICES_RUNNING                                   , _T("A stop control has been sent to a service that other running services are dependent on."))
      CASE_ERRCODE2(ERROR_INVALID_SERVICE_CONTROL                                      , _T("The requested control is not valid for this service."))
      CASE_ERRCODE2(ERROR_SERVICE_REQUEST_TIMEOUT                                      , _T("The service did not respond to the start or control request in a timely fashion."))
      CASE_ERRCODE2(ERROR_SERVICE_NO_THREAD                                            , _T("A thread could not be created for the service."))
      CASE_ERRCODE2(ERROR_SERVICE_DATABASE_LOCKED                                      , _T("The service database is locked."))
      CASE_ERRCODE2(ERROR_SERVICE_ALREADY_RUNNING                                      , _T("An instance of the service is already running."))
      CASE_ERRCODE2(ERROR_INVALID_SERVICE_ACCOUNT                                      , _T("The account name is invalid or does not exist, or the password is invalid for the account name specified."))
      CASE_ERRCODE2(ERROR_SERVICE_DISABLED                                             , _T("The service cannot be started, either because it is disabled or because it has no enabled devices associated with it."))
      CASE_ERRCODE2(ERROR_CIRCULAR_DEPENDENCY                                          , _T("Circular service dependency was specified."))
      CASE_ERRCODE2(ERROR_SERVICE_DOES_NOT_EXIST                                       , _T("The specified service does not exist as an installed service."))
      CASE_ERRCODE2(ERROR_SERVICE_CANNOT_ACCEPT_CTRL                                   , _T("The service cannot accept control messages at this time."))
      CASE_ERRCODE2(ERROR_SERVICE_NOT_ACTIVE                                           , _T("The service has not been started."))
      CASE_ERRCODE2(ERROR_FAILED_SERVICE_CONTROLLER_CONNECT                            , _T("The service process could not connect to the service controller."))
      CASE_ERRCODE2(ERROR_EXCEPTION_IN_SERVICE                                         , _T("An exception occurred in the service when handling the control request."))
      CASE_ERRCODE2(ERROR_DATABASE_DOES_NOT_EXIST                                      , _T("The database specified does not exist."))
      CASE_ERRCODE2(ERROR_SERVICE_SPECIFIC_ERROR                                       , _T("The service has returned a service-specific error code."))
      CASE_ERRCODE2(ERROR_PROCESS_ABORTED                                              , _T("The process terminated unexpectedly."))
      CASE_ERRCODE2(ERROR_SERVICE_DEPENDENCY_FAIL                                      , _T("The dependency service or group failed to start."))
      CASE_ERRCODE2(ERROR_SERVICE_LOGON_FAILED                                         , _T("The service did not start due to a logon failure."))
      CASE_ERRCODE2(ERROR_SERVICE_START_HANG                                           , _T("After starting, the service hung in a start-pending state."))
      CASE_ERRCODE2(ERROR_INVALID_SERVICE_LOCK                                         , _T("The specified service database lock is invalid."))
      CASE_ERRCODE2(ERROR_SERVICE_MARKED_FOR_DELETE                                    , _T("The specified service has been marked for deletion."))
      CASE_ERRCODE2(ERROR_SERVICE_EXISTS                                               , _T("The specified service already exists."))
      CASE_ERRCODE2(ERROR_ALREADY_RUNNING_LKG                                          , _T("The system is currently running with the last-known-good configuration."))
      CASE_ERRCODE2(ERROR_SERVICE_DEPENDENCY_DELETED                                   , _T("The dependency service does not exist or has been marked for deletion."))
      CASE_ERRCODE2(ERROR_BOOT_ALREADY_ACCEPTED                                        , _T("The current boot has already been accepted for use as the last-known-good control set."))
      CASE_ERRCODE2(ERROR_SERVICE_NEVER_STARTED                                        , _T("No attempts to start the service have been made since the last boot."))
      CASE_ERRCODE2(ERROR_DUPLICATE_SERVICE_NAME                                       , _T("The name is already in use as either a service name or a service display name."))
      CASE_ERRCODE2(ERROR_DIFFERENT_SERVICE_ACCOUNT                                    , _T("The account specified for this service is different from the account specified for other services running in the same process."))
      CASE_ERRCODE2(ERROR_CANNOT_DETECT_DRIVER_FAILURE                                 , _T("Failure actions can only be set for Win32 services, not for drivers."))
      CASE_ERRCODE2(ERROR_CANNOT_DETECT_PROCESS_ABORT                                  , _T("This service runs in the same process as the service control manager. Therefore, the service control manager cannot take action if this service's process terminates unexpectedly."))
      CASE_ERRCODE2(ERROR_NO_RECOVERY_PROGRAM                                          , _T("No recovery program has been configured for this service."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_SERVICE_NOT_IN_EXE                                           , _T("The executable program that this service is configured to run in does not implement the service."))
      CASE_ERRCODE2(ERROR_NOT_SAFEBOOT_SERVICE                                         , _T("This service cannot be started in Safe Mode."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_END_OF_MEDIA                                                 , _T("The physical end of the tape has been reached."))
      CASE_ERRCODE2(ERROR_FILEMARK_DETECTED                                            , _T("A tape access reached a filemark."))
      CASE_ERRCODE2(ERROR_BEGINNING_OF_MEDIA                                           , _T("The beginning of the tape or a partition was encountered."))
      CASE_ERRCODE2(ERROR_SETMARK_DETECTED                                             , _T("A tape access reached the end of a set of files."))
      CASE_ERRCODE2(ERROR_NO_DATA_DETECTED                                             , _T("No more data is on the tape."))
      CASE_ERRCODE2(ERROR_PARTITION_FAILURE                                            , _T("Tape could not be partitioned."))
      CASE_ERRCODE2(ERROR_INVALID_BLOCK_LENGTH                                         , _T("When accessing a new tape of a multivolume partition, the current block size is incorrect."))
      CASE_ERRCODE2(ERROR_DEVICE_NOT_PARTITIONED                                       , _T("Tape partition information could not be found when loading a tape."))
      CASE_ERRCODE2(ERROR_UNABLE_TO_LOCK_MEDIA                                         , _T("Unable to lock the media eject mechanism."))
      CASE_ERRCODE2(ERROR_UNABLE_TO_UNLOAD_MEDIA                                       , _T("Unable to unload the media."))
      CASE_ERRCODE2(ERROR_MEDIA_CHANGED                                                , _T("The media in the drive may have changed."))
      CASE_ERRCODE2(ERROR_BUS_RESET                                                    , _T("The I/O bus was reset."))
      CASE_ERRCODE2(ERROR_NO_MEDIA_IN_DRIVE                                            , _T("No media in drive."))
      CASE_ERRCODE2(ERROR_NO_UNICODE_TRANSLATION                                       , _T("No mapping for the Unicode character exists in the target multi-byte code page."))
      CASE_ERRCODE2(ERROR_DLL_INIT_FAILED                                              , _T("A dynamic link library (DLL) initialization routine failed."))
      CASE_ERRCODE2(ERROR_SHUTDOWN_IN_PROGRESS                                         , _T("A system shutdown is in progress."))
      CASE_ERRCODE2(ERROR_NO_SHUTDOWN_IN_PROGRESS                                      , _T("Unable to abort the system shutdown because no shutdown was in progress."))
      CASE_ERRCODE2(ERROR_IO_DEVICE                                                    , _T("The request could not be performed because of an I/O device error."))
      CASE_ERRCODE2(ERROR_SERIAL_NO_DEVICE                                             , _T("No serial device was successfully initialized. The serial driver will unload."))
      CASE_ERRCODE2(ERROR_IRQ_BUSY                                                     , _T("Unable to open a device that was sharing an interrupt request (IRQ) with other devices. At least one other device that uses that IRQ was already opened."))
      CASE_ERRCODE2(ERROR_MORE_WRITES                                                  , _T("A serial I/O operation was completed by another write to the serial port. (The IOCTL_SERIAL_XOFF_COUNTER reached zero.)"))
      CASE_ERRCODE2(ERROR_COUNTER_TIMEOUT                                              , _T("A serial I/O operation completed because the timeout period expired. (The IOCTL_SERIAL_XOFF_COUNTER did not reach zero.)"))
      CASE_ERRCODE2(ERROR_FLOPPY_ID_MARK_NOT_FOUND                                     , _T("No ID address mark was found on the floppy disk."))
      CASE_ERRCODE2(ERROR_FLOPPY_WRONG_CYLINDER                                        , _T("Mismatch between the floppy disk sector ID field and the floppy disk controller track address."))
      CASE_ERRCODE2(ERROR_FLOPPY_UNKNOWN_ERROR                                         , _T("The floppy disk controller reported an error that is not recognized by the floppy disk driver."))
      CASE_ERRCODE2(ERROR_FLOPPY_BAD_REGISTERS                                         , _T("The floppy disk controller returned inconsistent results in its registers."))
      CASE_ERRCODE2(ERROR_DISK_RECALIBRATE_FAILED                                      , _T("While accessing the hard disk, a recalibrate operation failed, even after retries."))
      CASE_ERRCODE2(ERROR_DISK_OPERATION_FAILED                                        , _T("While accessing the hard disk, a disk operation failed even after retries."))
      CASE_ERRCODE2(ERROR_DISK_RESET_FAILED                                            , _T("While accessing the hard disk, a disk controller reset was needed, but even that failed."))
      CASE_ERRCODE2(ERROR_EOM_OVERFLOW                                                 , _T("Physical end of tape encountered."))
      CASE_ERRCODE2(ERROR_NOT_ENOUGH_SERVER_MEMORY                                     , _T("Not enough server storage is available to process this command."))
      CASE_ERRCODE2(ERROR_POSSIBLE_DEADLOCK                                            , _T("A potential deadlock condition has been detected."))
      CASE_ERRCODE2(ERROR_MAPPED_ALIGNMENT                                             , _T("The base address or the file offset specified does not have the proper alignment."))
      CASE_ERRCODE2(ERROR_SET_POWER_STATE_VETOED                                       , _T("An attempt to change the system power state was vetoed by another application or driver."))
      CASE_ERRCODE2(ERROR_SET_POWER_STATE_FAILED                                       , _T("The system BIOS failed an attempt to change the system power state."))
      CASE_ERRCODE2(ERROR_TOO_MANY_LINKS                                               , _T("An attempt was made to create more links on a file than the file system supports."))
      CASE_ERRCODE2(ERROR_OLD_WIN_VERSION                                              , _T("The specified program requires a newer version of Windows."))
      CASE_ERRCODE2(ERROR_APP_WRONG_OS                                                 , _T("The specified program is not a Windows or MS-DOS program."))
      CASE_ERRCODE2(ERROR_SINGLE_INSTANCE_APP                                          , _T("Cannot start more than one instance of the specified program."))
      CASE_ERRCODE2(ERROR_RMODE_APP                                                    , _T("The specified program was written for an earlier version of Windows."))
      CASE_ERRCODE2(ERROR_INVALID_DLL                                                  , _T("One of the library files needed to run this application is damaged."))
      CASE_ERRCODE2(ERROR_NO_ASSOCIATION                                               , _T("No application is associated with the specified file for this operation."))
      CASE_ERRCODE2(ERROR_DDE_FAIL                                                     , _T("An error occurred in sending the command to the application."))
      CASE_ERRCODE2(ERROR_DLL_NOT_FOUND                                                , _T("One of the library files needed to run this application cannot be found."))
      CASE_ERRCODE2(ERROR_NO_MORE_USER_HANDLES                                         , _T("The current process has used all of its system allowance of handles for Window Manager objects."))
      CASE_ERRCODE2(ERROR_MESSAGE_SYNC_ONLY                                            , _T("The message can be used only with synchronous operations."))
      CASE_ERRCODE2(ERROR_SOURCE_ELEMENT_EMPTY                                         , _T("The indicated source element has no media."))
      CASE_ERRCODE2(ERROR_DESTINATION_ELEMENT_FULL                                     , _T("The indicated destination element already contains media."))
      CASE_ERRCODE2(ERROR_ILLEGAL_ELEMENT_ADDRESS                                      , _T("The indicated element does not exist."))
      CASE_ERRCODE2(ERROR_MAGAZINE_NOT_PRESENT                                         , _T("The indicated element is part of a magazine that is not present."))
      CASE_ERRCODE2(ERROR_DEVICE_REINITIALIZATION_NEEDED                               , _T("The indicated device requires reinitialization due to hardware errors."))
      CASE_ERRCODE2(ERROR_DEVICE_REQUIRES_CLEANING                                     , _T("The device has indicated that cleaning is required before further operations are attempted."))
      CASE_ERRCODE2(ERROR_DEVICE_DOOR_OPEN                                             , _T("The device has indicated that its door is open."))
      CASE_ERRCODE2(ERROR_DEVICE_NOT_CONNECTED                                         , _T("The device is not connected."))
      CASE_ERRCODE2(ERROR_NOT_FOUND                                                    , _T("Element not found."))
      CASE_ERRCODE2(ERROR_NO_MATCH                                                     , _T("There was no match for the specified key in the index."))
      CASE_ERRCODE2(ERROR_SET_NOT_FOUND                                                , _T("The property set specified does not exist on the object."))
      CASE_ERRCODE2(ERROR_POINT_NOT_FOUND                                              , _T("The point passed to GetMouseMovePointsEx is not in the buffer."))
      CASE_ERRCODE2(ERROR_NO_TRACKING_SERVICE                                          , _T("The tracking (workstation) service is not running."))
      CASE_ERRCODE2(ERROR_NO_VOLUME_ID                                                 , _T("The Volume ID could not be found."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_UNABLE_TO_REMOVE_REPLACED                                    , _T("Unable to remove the file to be replaced."))
      CASE_ERRCODE2(ERROR_UNABLE_TO_MOVE_REPLACEMENT                                   , _T("Unable to move the replacement file to the file to be replaced. The file to be replaced has retained its original name."))
      CASE_ERRCODE2(ERROR_UNABLE_TO_MOVE_REPLACEMENT_2                                 , _T("Unable to move the replacement file to the file to be replaced. The file to be replaced has been renamed using the backup name."))
      CASE_ERRCODE2(ERROR_JOURNAL_DELETE_IN_PROGRESS                                   , _T("The volume change journal is being deleted."))
      CASE_ERRCODE2(ERROR_JOURNAL_NOT_ACTIVE                                           , _T("The volume change journal is not active."))
      CASE_ERRCODE2(ERROR_POTENTIAL_FILE_FOUND                                         , _T("A file was found, but it may not be the correct file."))
      CASE_ERRCODE2(ERROR_JOURNAL_ENTRY_DELETED                                        , _T("The journal entry has been deleted from the journal."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_BAD_DEVICE                                                   , _T("The specified device name is invalid."))
      CASE_ERRCODE2(ERROR_CONNECTION_UNAVAIL                                           , _T("The device is not currently connected but it is a remembered connection."))
      CASE_ERRCODE2(ERROR_DEVICE_ALREADY_REMEMBERED                                    , _T("The local device name has a remembered connection to another network resource."))
      CASE_ERRCODE2(ERROR_NO_NET_OR_BAD_PATH                                           , _T("No network provider accepted the given network path."))
      CASE_ERRCODE2(ERROR_BAD_PROVIDER                                                 , _T("The specified network provider name is invalid."))
      CASE_ERRCODE2(ERROR_CANNOT_OPEN_PROFILE                                          , _T("Unable to open the network connection profile."))
      CASE_ERRCODE2(ERROR_BAD_PROFILE                                                  , _T("The network connection profile is corrupted."))
      CASE_ERRCODE2(ERROR_NOT_CONTAINER                                                , _T("Cannot enumerate a noncontainer."))
      CASE_ERRCODE2(ERROR_EXTENDED_ERROR                                               , _T("An extended error has occurred."))
      CASE_ERRCODE2(ERROR_INVALID_GROUPNAME                                            , _T("The format of the specified group name is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_COMPUTERNAME                                         , _T("The format of the specified computer name is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_EVENTNAME                                            , _T("The format of the specified event name is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_DOMAINNAME                                           , _T("The format of the specified domain name is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_SERVICENAME                                          , _T("The format of the specified service name is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_NETNAME                                              , _T("The format of the specified network name is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_SHARENAME                                            , _T("The format of the specified share name is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_PASSWORDNAME                                         , _T("The format of the specified password is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_MESSAGENAME                                          , _T("The format of the specified message name is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_MESSAGEDEST                                          , _T("The format of the specified message destination is invalid."))
      CASE_ERRCODE2(ERROR_SESSION_CREDENTIAL_CONFLICT                                  , _T("Multiple connections to a server or shared resource by the same user, using more than one user name, are not allowed. Disconnect all previous connections to the server or shared resource and try again."))
      CASE_ERRCODE2(ERROR_REMOTE_SESSION_LIMIT_EXCEEDED                                , _T("An attempt was made to establish a session to a network server, but there are already too many sessions established to that server."))
      CASE_ERRCODE2(ERROR_DUP_DOMAINNAME                                               , _T("The workgroup or domain name is already in use by another computer on the network."))
      CASE_ERRCODE2(ERROR_NO_NETWORK                                                   , _T("The network is not present or not started."))
      CASE_ERRCODE2(ERROR_CANCELLED                                                    , _T("The operation was canceled by the user."))
      CASE_ERRCODE2(ERROR_USER_MAPPED_FILE                                             , _T("The requested operation cannot be performed on a file with a user-mapped section open."))
      CASE_ERRCODE2(ERROR_CONNECTION_REFUSED                                           , _T("The remote system refused the network connection."))
      CASE_ERRCODE2(ERROR_GRACEFUL_DISCONNECT                                          , _T("The network connection was gracefully closed."))
      CASE_ERRCODE2(ERROR_ADDRESS_ALREADY_ASSOCIATED                                   , _T("The network transport endpoint already has an address associated with it."))
      CASE_ERRCODE2(ERROR_ADDRESS_NOT_ASSOCIATED                                       , _T("An address has not yet been associated with the network endpoint."))
      CASE_ERRCODE2(ERROR_CONNECTION_INVALID                                           , _T("An operation was attempted on a nonexistent network connection."))
      CASE_ERRCODE2(ERROR_CONNECTION_ACTIVE                                            , _T("An invalid operation was attempted on an active network connection."))
      CASE_ERRCODE2(ERROR_NETWORK_UNREACHABLE                                          , _T("The network location cannot be reached. For information about network troubleshooting, see Windows Help."))
      CASE_ERRCODE2(ERROR_HOST_UNREACHABLE                                             , _T("The network location cannot be reached. For information about network troubleshooting, see Windows Help."))
      CASE_ERRCODE2(ERROR_PROTOCOL_UNREACHABLE                                         , _T("The network location cannot be reached. For information about network troubleshooting, see Windows Help."))
      CASE_ERRCODE2(ERROR_PORT_UNREACHABLE                                             , _T("No service is operating at the destination network endpoint on the remote system."))
      CASE_ERRCODE2(ERROR_REQUEST_ABORTED                                              , _T("The request was aborted."))
      CASE_ERRCODE2(ERROR_CONNECTION_ABORTED                                           , _T("The network connection was aborted by the local system."))
      CASE_ERRCODE2(ERROR_RETRY                                                        , _T("The operation could not be completed. A retry should be performed."))
      CASE_ERRCODE2(ERROR_CONNECTION_COUNT_LIMIT                                       , _T("A connection to the server could not be made because the limit on the number of concurrent connections for this account has been reached."))
      CASE_ERRCODE2(ERROR_LOGIN_TIME_RESTRICTION                                       , _T("Attempting to log in during an unauthorized time of day for this account."))
      CASE_ERRCODE2(ERROR_LOGIN_WKSTA_RESTRICTION                                      , _T("The account is not authorized to log in from this station."))
      CASE_ERRCODE2(ERROR_INCORRECT_ADDRESS                                            , _T("The network address could not be used for the operation requested."))
      CASE_ERRCODE2(ERROR_ALREADY_REGISTERED                                           , _T("The service is already registered."))
      CASE_ERRCODE2(ERROR_SERVICE_NOT_FOUND                                            , _T("The specified service does not exist."))
      CASE_ERRCODE2(ERROR_NOT_AUTHENTICATED                                            , _T("The operation being requested was not performed because the user has not been authenticated."))
      CASE_ERRCODE2(ERROR_NOT_LOGGED_ON                                                , _T("The operation being requested was not performed because the user has not logged on to the network. The specified service does not exist."))
      CASE_ERRCODE2(ERROR_CONTINUE                                                     , _T("Continue with work in progress."))
      CASE_ERRCODE2(ERROR_ALREADY_INITIALIZED                                          , _T("An attempt was made to perform an initialization operation when initialization has already been completed."))
      CASE_ERRCODE2(ERROR_NO_MORE_DEVICES                                              , _T("No more local devices."))
      CASE_ERRCODE2(ERROR_NO_SUCH_SITE                                                 , _T("The specified site does not exist."))
      CASE_ERRCODE2(ERROR_DOMAIN_CONTROLLER_EXISTS                                     , _T("A domain controller with the specified name already exists."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_ONLY_IF_CONNECTED                                            , _T("This operation is supported only when you are connected to the server."))
      CASE_ERRCODE2(ERROR_OVERRIDE_NOCHANGES                                           , _T("The group policy framework should call the extension even if there are no changes."))
      CASE_ERRCODE2(ERROR_BAD_USER_PROFILE                                             , _T("The specified user does not have a valid profile."))
      CASE_ERRCODE2(ERROR_NOT_SUPPORTED_ON_SBS                                         , _T("This operation is not supported on a Microsoft Small Business Server."))
      CASE_ERRCODE2(ERROR_SERVER_SHUTDOWN_IN_PROGRESS                                  , _T("The server machine is shutting down."))
      CASE_ERRCODE2(ERROR_HOST_DOWN                                                    , _T("The remote system is not available. For information about network troubleshooting, see Windows Help."))
      CASE_ERRCODE2(ERROR_NON_ACCOUNT_SID                                              , _T("The security identifier provided is not from an account domain."))
      CASE_ERRCODE2(ERROR_NON_DOMAIN_SID                                               , _T("The security identifier provided does not have a domain component."))
      CASE_ERRCODE2(ERROR_APPHELP_BLOCK                                                , _T("AppHelp dialog canceled thus preventing the application from starting."))
      CASE_ERRCODE2(ERROR_ACCESS_DISABLED_BY_POLICY                                    , _T("Windows cannot open this program because it has been prevented by a software restriction policy. For more information, open Event Viewer or contact your system administrator."))
      CASE_ERRCODE2(ERROR_REG_NAT_CONSUMPTION                                          , _T("A program attempt to use an invalid register value. Normally caused by an uninitialized register. This error is Itanium specific."))
      CASE_ERRCODE2(ERROR_CSCSHARE_OFFLINE                                             , _T("The share is currently offline or does not exist."))
      CASE_ERRCODE2(ERROR_PKINIT_FAILURE                                               , _T("The kerberos protocol encountered an error while validating the KDC certificate during smartcard logon."))
      CASE_ERRCODE2(ERROR_SMARTCARD_SUBSYSTEM_FAILURE                                  , _T("The kerberos protocol encountered an error while attempting to utilize the smartcard subsystem."))
      CASE_ERRCODE2(ERROR_DOWNGRADE_DETECTED                                           , _T("The system detected a possible attempt to compromise security. Please ensure that you can contact the server that authenticated you."))
      CASE_ERRCODE2(ERROR_MACHINE_LOCKED                                               , _T("The machine is locked and cannot be shut down without the force option."))
      CASE_ERRCODE2(ERROR_CALLBACK_SUPPLIED_INVALID_DATA                               , _T("An application-defined callback gave invalid data when called."))
      CASE_ERRCODE2(ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED                             , _T("The group policy framework should call the extension in the synchronous foreground policy refresh."))
      CASE_ERRCODE2(ERROR_DRIVER_BLOCKED                                               , _T("This driver has been blocked from loading."))
      CASE_ERRCODE2(ERROR_INVALID_IMPORT_OF_NON_DLL                                    , _T("A dynamic link library (DLL) referenced a module that was neither a DLL nor the process's executable image."))
      CASE_ERRCODE2(ERROR_ACCESS_DISABLED_WEBBLADE                                     , _T("Windows cannot open this program since it has been disabled."))
      CASE_ERRCODE2(ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER                              , _T("Windows cannot open this program because the license enforcement system has been tampered with or become corrupted."))
      CASE_ERRCODE2(ERROR_RECOVERY_FAILURE                                             , _T("A transaction recovery failed."))
      CASE_ERRCODE2(ERROR_ALREADY_FIBER                                                , _T("The current thread has already been converted to a fiber."))
      CASE_ERRCODE2(ERROR_ALREADY_THREAD                                               , _T("The current thread has already been converted from a fiber."))
      CASE_ERRCODE2(ERROR_STACK_BUFFER_OVERRUN                                         , _T("The system detected an overrun of a stack-based buffer in this application. This overrun could potentially allow a malicious user to gain control of this application."))
      CASE_ERRCODE2(ERROR_PARAMETER_QUOTA_EXCEEDED                                     , _T("Data present in one of the parameters is more than the function can operate on."))
      CASE_ERRCODE2(ERROR_DEBUGGER_INACTIVE                                            , _T("An attempt to do an operation on a debug object failed because the object is in the process of being deleted."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_NOT_ALL_ASSIGNED                                             , _T("Not all privileges referenced are assigned to the caller."))
      CASE_ERRCODE2(ERROR_SOME_NOT_MAPPED                                              , _T("Some mapping between account names and security IDs was not done."))
      CASE_ERRCODE2(ERROR_NO_QUOTAS_FOR_ACCOUNT                                        , _T("No system quota limits are specifically set for this account."))
      CASE_ERRCODE2(ERROR_LOCAL_USER_SESSION_KEY                                       , _T("No encryption key is available. A well-known encryption key was returned."))
      CASE_ERRCODE2(ERROR_NULL_LM_PASSWORD                                             , _T("The password is too complex to be converted to a LAN Manager password. The LAN Manager password returned is a NULL string."))
      CASE_ERRCODE2(ERROR_UNKNOWN_REVISION                                             , _T("The revision level is unknown."))
      CASE_ERRCODE2(ERROR_REVISION_MISMATCH                                            , _T("Indicates two revision levels are incompatible."))
      CASE_ERRCODE2(ERROR_INVALID_OWNER                                                , _T("This security ID may not be assigned as the owner of this object."))
      CASE_ERRCODE2(ERROR_INVALID_PRIMARY_GROUP                                        , _T("This security ID may not be assigned as the primary group of an object."))
      CASE_ERRCODE2(ERROR_NO_IMPERSONATION_TOKEN                                       , _T("An attempt has been made to operate on an impersonation token by a thread that is not currently impersonating a client."))
      CASE_ERRCODE2(ERROR_CANT_DISABLE_MANDATORY                                       , _T("The group may not be disabled."))
      CASE_ERRCODE2(ERROR_NO_LOGON_SERVERS                                             , _T("There are currently no logon servers available to service the logon request."))
      CASE_ERRCODE2(ERROR_NO_SUCH_LOGON_SESSION                                        , _T("A specified logon session does not exist. It may already have been terminated."))
      CASE_ERRCODE2(ERROR_NO_SUCH_PRIVILEGE                                            , _T("A specified privilege does not exist."))
      CASE_ERRCODE2(ERROR_PRIVILEGE_NOT_HELD                                           , _T("A required privilege is not held by the client."))
      CASE_ERRCODE2(ERROR_INVALID_ACCOUNT_NAME                                         , _T("The name provided is not a properly formed account name."))
      CASE_ERRCODE2(ERROR_USER_EXISTS                                                  , _T("The specified user already exists."))
      CASE_ERRCODE2(ERROR_NO_SUCH_USER                                                 , _T("The specified user does not exist."))
      CASE_ERRCODE2(ERROR_GROUP_EXISTS                                                 , _T("The specified group already exists."))
      CASE_ERRCODE2(ERROR_NO_SUCH_GROUP                                                , _T("The specified group does not exist."))
      CASE_ERRCODE2(ERROR_MEMBER_IN_GROUP                                              , _T("Either the specified user account is already a member of the specified group, or the specified group cannot be deleted because it contains a member."))
      CASE_ERRCODE2(ERROR_MEMBER_NOT_IN_GROUP                                          , _T("The specified user account is not a member of the specified group account."))
      CASE_ERRCODE2(ERROR_LAST_ADMIN                                                   , _T("The last remaining administration account cannot be disabled or deleted."))
      CASE_ERRCODE2(ERROR_WRONG_PASSWORD                                               , _T("Unable to update the password. The value provided as the current password is incorrect."))
      CASE_ERRCODE2(ERROR_ILL_FORMED_PASSWORD                                          , _T("Unable to update the password. The value provided for the new password contains values that are not allowed in passwords."))
      CASE_ERRCODE2(ERROR_PASSWORD_RESTRICTION                                         , _T("Unable to update the password. The value provided for the new password does not meet the length, complexity, or history requirement of the domain."))
      CASE_ERRCODE2(ERROR_LOGON_FAILURE                                                , _T("Logon failure: unknown user name or bad password."))
      CASE_ERRCODE2(ERROR_ACCOUNT_RESTRICTION                                          , _T("Logon failure: user account restriction. Possible reasons are blank passwords not allowed, logon hour restrictions, or a policy restriction has been enforced."))
      CASE_ERRCODE2(ERROR_INVALID_LOGON_HOURS                                          , _T("Logon failure: account logon time restriction violation."))
      CASE_ERRCODE2(ERROR_INVALID_WORKSTATION                                          , _T("Logon failure: user not allowed to log on to this computer."))
      CASE_ERRCODE2(ERROR_PASSWORD_EXPIRED                                             , _T("Logon failure: the specified account password has expired."))
      CASE_ERRCODE2(ERROR_ACCOUNT_DISABLED                                             , _T("Logon failure: account currently disabled."))
      CASE_ERRCODE2(ERROR_NONE_MAPPED                                                  , _T("No mapping between account names and security IDs was done."))
      CASE_ERRCODE2(ERROR_TOO_MANY_LUIDS_REQUESTED                                     , _T("Too many local user identifiers (LUIDs) were requested at one time."))
      CASE_ERRCODE2(ERROR_LUIDS_EXHAUSTED                                              , _T("No more local user identifiers (LUIDs) are available."))
      CASE_ERRCODE2(ERROR_INVALID_SUB_AUTHORITY                                        , _T("The subauthority part of a security ID is invalid for this particular use."))
      CASE_ERRCODE2(ERROR_INVALID_ACL                                                  , _T("The access control list (ACL) structure is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_SID                                                  , _T("The security ID structure is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_SECURITY_DESCR                                       , _T("The security descriptor structure is invalid."))
      CASE_ERRCODE2(ERROR_BAD_INHERITANCE_ACL                                          , _T("The inherited access control list (ACL) or access control entry (ACE) could not be built."))
      CASE_ERRCODE2(ERROR_SERVER_DISABLED                                              , _T("The server is currently disabled."))
      CASE_ERRCODE2(ERROR_SERVER_NOT_DISABLED                                          , _T("The server is currently enabled."))
      CASE_ERRCODE2(ERROR_INVALID_ID_AUTHORITY                                         , _T("The value provided was an invalid value for an identifier authority."))
      CASE_ERRCODE2(ERROR_ALLOTTED_SPACE_EXCEEDED                                      , _T("No more memory is available for security information updates."))
      CASE_ERRCODE2(ERROR_INVALID_GROUP_ATTRIBUTES                                     , _T("The specified attributes are invalid, or incompatible with the attributes for the group as a whole."))
      CASE_ERRCODE2(ERROR_BAD_IMPERSONATION_LEVEL                                      , _T("Either a required impersonation level was not provided, or the provided impersonation level is invalid."))
      CASE_ERRCODE2(ERROR_CANT_OPEN_ANONYMOUS                                          , _T("Cannot open an anonymous level security token."))
      CASE_ERRCODE2(ERROR_BAD_VALIDATION_CLASS                                         , _T("The validation information class requested was invalid."))
      CASE_ERRCODE2(ERROR_BAD_TOKEN_TYPE                                               , _T("The type of the token is inappropriate for its attempted use."))
      CASE_ERRCODE2(ERROR_NO_SECURITY_ON_OBJECT                                        , _T("Unable to perform a security operation on an object that has no associated security."))
      CASE_ERRCODE2(ERROR_CANT_ACCESS_DOMAIN_INFO                                      , _T("Configuration information could not be read from the domain controller, either because the machine is unavailable, or access has been denied."))
      CASE_ERRCODE2(ERROR_INVALID_SERVER_STATE                                         , _T("The security account manager (SAM) or local security authority (LSA) server was in the wrong state to perform the security operation."))
      CASE_ERRCODE2(ERROR_INVALID_DOMAIN_STATE                                         , _T("The domain was in the wrong state to perform the security operation."))
      CASE_ERRCODE2(ERROR_INVALID_DOMAIN_ROLE                                          , _T("This operation is only allowed for the Primary Domain Controller of the domain."))
      CASE_ERRCODE2(ERROR_NO_SUCH_DOMAIN                                               , _T("The specified domain either does not exist or could not be contacted."))
      CASE_ERRCODE2(ERROR_DOMAIN_EXISTS                                                , _T("The specified domain already exists."))
      CASE_ERRCODE2(ERROR_DOMAIN_LIMIT_EXCEEDED                                        , _T("An attempt was made to exceed the limit on the number of domains per server."))
      CASE_ERRCODE2(ERROR_INTERNAL_DB_CORRUPTION                                       , _T("Unable to complete the requested operation because of either a catastrophic media failure or a data structure corruption on the disk."))
      CASE_ERRCODE2(ERROR_INTERNAL_ERROR                                               , _T("An internal error occurred."))
      CASE_ERRCODE2(ERROR_GENERIC_NOT_MAPPED                                           , _T("Generic access types were contained in an access mask which should already be mapped to nongeneric types."))
      CASE_ERRCODE2(ERROR_BAD_DESCRIPTOR_FORMAT                                        , _T("A security descriptor is not in the right format (absolute or self-relative)."))
      CASE_ERRCODE2(ERROR_NOT_LOGON_PROCESS                                            , _T("The requested action is restricted for use by logon processes only. The calling process has not registered as a logon process."))
      CASE_ERRCODE2(ERROR_LOGON_SESSION_EXISTS                                         , _T("Cannot start a new logon session with an ID that is already in use."))
      CASE_ERRCODE2(ERROR_NO_SUCH_PACKAGE                                              , _T("A specified authentication package is unknown."))
      CASE_ERRCODE2(ERROR_BAD_LOGON_SESSION_STATE                                      , _T("The logon session is not in a state that is consistent with the requested operation."))
      CASE_ERRCODE2(ERROR_LOGON_SESSION_COLLISION                                      , _T("The logon session ID is already in use."))
      CASE_ERRCODE2(ERROR_INVALID_LOGON_TYPE                                           , _T("A logon request contained an invalid logon type value."))
      CASE_ERRCODE2(ERROR_CANNOT_IMPERSONATE                                           , _T("Unable to impersonate using a named pipe until data has been read from that pipe."))
      CASE_ERRCODE2(ERROR_RXACT_INVALID_STATE                                          , _T("The transaction state of a registry subtree is incompatible with the requested operation."))
      CASE_ERRCODE2(ERROR_RXACT_COMMIT_FAILURE                                         , _T("An internal security database corruption has been encountered."))
      CASE_ERRCODE2(ERROR_SPECIAL_ACCOUNT                                              , _T("Cannot perform this operation on built-in accounts."))
      CASE_ERRCODE2(ERROR_SPECIAL_GROUP                                                , _T("Cannot perform this operation on this built-in special group."))
      CASE_ERRCODE2(ERROR_SPECIAL_USER                                                 , _T("Cannot perform this operation on this built-in special user."))
      CASE_ERRCODE2(ERROR_MEMBERS_PRIMARY_GROUP                                        , _T("The user cannot be removed from a group because the group is currently the user's primary group."))
      CASE_ERRCODE2(ERROR_TOKEN_ALREADY_IN_USE                                         , _T("The token is already in use as a primary token."))
      CASE_ERRCODE2(ERROR_NO_SUCH_ALIAS                                                , _T("The specified local group does not exist."))
      CASE_ERRCODE2(ERROR_MEMBER_NOT_IN_ALIAS                                          , _T("The specified account name is not a member of the local group."))
      CASE_ERRCODE2(ERROR_MEMBER_IN_ALIAS                                              , _T("The specified account name is already a member of the local group."))
      CASE_ERRCODE2(ERROR_ALIAS_EXISTS                                                 , _T("The specified local group already exists."))
      CASE_ERRCODE2(ERROR_LOGON_NOT_GRANTED                                            , _T("Logon failure: the user has not been granted the requested logon type at this computer."))
      CASE_ERRCODE2(ERROR_TOO_MANY_SECRETS                                             , _T("The maximum number of secrets that may be stored in a single system has been exceeded."))
      CASE_ERRCODE2(ERROR_SECRET_TOO_LONG                                              , _T("The length of a secret exceeds the maximum length allowed."))
      CASE_ERRCODE2(ERROR_INTERNAL_DB_ERROR                                            , _T("The local security authority database contains an internal inconsistency."))
      CASE_ERRCODE2(ERROR_TOO_MANY_CONTEXT_IDS                                         , _T("During a logon attempt, the user's security context accumulated too many security IDs."))
      CASE_ERRCODE2(ERROR_LOGON_TYPE_NOT_GRANTED                                       , _T("Logon failure: the user has not been granted the requested logon type at this computer."))
      CASE_ERRCODE2(ERROR_NT_CROSS_ENCRYPTION_REQUIRED                                 , _T("A cross-encrypted password is necessary to change a user password."))
      CASE_ERRCODE2(ERROR_NO_SUCH_MEMBER                                               , _T("A new member could not be added to or removed from the local group because the member does not exist."))
      CASE_ERRCODE2(ERROR_INVALID_MEMBER                                               , _T("A new member could not be added to a local group because the member has the wrong account type."))
      CASE_ERRCODE2(ERROR_TOO_MANY_SIDS                                                , _T("Too many security IDs have been specified."))
      CASE_ERRCODE2(ERROR_LM_CROSS_ENCRYPTION_REQUIRED                                 , _T("A cross-encrypted password is necessary to change this user password."))
      CASE_ERRCODE2(ERROR_NO_INHERITANCE                                               , _T("Indicates an ACL contains no inheritable components."))
      CASE_ERRCODE2(ERROR_FILE_CORRUPT                                                 , _T("The file or directory is corrupted and unreadable."))
      CASE_ERRCODE2(ERROR_DISK_CORRUPT                                                 , _T("The disk structure is corrupted and unreadable."))
      CASE_ERRCODE2(ERROR_NO_USER_SESSION_KEY                                          , _T("There is no user session key for the specified logon session."))
      CASE_ERRCODE2(ERROR_LICENSE_QUOTA_EXCEEDED                                       , _T("The service being accessed is licensed for a particular number of connections. No more connections can be made to the service at this time because there are already as many connections as the service can accept."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_WRONG_TARGET_NAME                                            , _T("Logon Failure: The target account name is incorrect."))
      CASE_ERRCODE2(ERROR_MUTUAL_AUTH_FAILED                                           , _T("Mutual Authentication failed. The server's password is out of date at the domain controller."))
      CASE_ERRCODE2(ERROR_TIME_SKEW                                                    , _T("There is a time and/or date difference between the client and server."))
      CASE_ERRCODE2(ERROR_CURRENT_DOMAIN_NOT_ALLOWED                                   , _T("This operation cannot be performed on the current domain."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_INVALID_WINDOW_HANDLE                                        , _T("Invalid window handle."))
      CASE_ERRCODE2(ERROR_INVALID_MENU_HANDLE                                          , _T("Invalid menu handle."))
      CASE_ERRCODE2(ERROR_INVALID_CURSOR_HANDLE                                        , _T("Invalid cursor handle."))
      CASE_ERRCODE2(ERROR_INVALID_ACCEL_HANDLE                                         , _T("Invalid accelerator table handle."))
      CASE_ERRCODE2(ERROR_INVALID_HOOK_HANDLE                                          , _T("Invalid hook handle."))
      CASE_ERRCODE2(ERROR_INVALID_DWP_HANDLE                                           , _T("Invalid handle to a multiple-window position structure."))
      CASE_ERRCODE2(ERROR_TLW_WITH_WSCHILD                                             , _T("Cannot create a top-level child window."))
      CASE_ERRCODE2(ERROR_CANNOT_FIND_WND_CLASS                                        , _T("Cannot find window class."))
      CASE_ERRCODE2(ERROR_WINDOW_OF_OTHER_THREAD                                       , _T("Invalid window; it belongs to other thread."))
      CASE_ERRCODE2(ERROR_HOTKEY_ALREADY_REGISTERED                                    , _T("Hot key is already registered."))
      CASE_ERRCODE2(ERROR_CLASS_ALREADY_EXISTS                                         , _T("Class already exists."))
      CASE_ERRCODE2(ERROR_CLASS_DOES_NOT_EXIST                                         , _T("Class does not exist."))
      CASE_ERRCODE2(ERROR_CLASS_HAS_WINDOWS                                            , _T("Class still has open windows."))
      CASE_ERRCODE2(ERROR_INVALID_INDEX                                                , _T("Invalid index."))
      CASE_ERRCODE2(ERROR_INVALID_ICON_HANDLE                                          , _T("Invalid icon handle."))
      CASE_ERRCODE2(ERROR_PRIVATE_DIALOG_INDEX                                         , _T("Using private DIALOG window words."))
      CASE_ERRCODE2(ERROR_LISTBOX_ID_NOT_FOUND                                         , _T("The list box identifier was not found."))
      CASE_ERRCODE2(ERROR_NO_WILDCARD_CHARACTERS                                       , _T("No wildcards were found."))
      CASE_ERRCODE2(ERROR_CLIPBOARD_NOT_OPEN                                           , _T("Thread does not have a clipboard open."))
      CASE_ERRCODE2(ERROR_HOTKEY_NOT_REGISTERED                                        , _T("Hot key is not registered."))
      CASE_ERRCODE2(ERROR_WINDOW_NOT_DIALOG                                            , _T("The window is not a valid dialog window."))
      CASE_ERRCODE2(ERROR_CONTROL_ID_NOT_FOUND                                         , _T("Control ID not found."))
      CASE_ERRCODE2(ERROR_INVALID_COMBOBOX_MESSAGE                                     , _T("Invalid message for a combo box because it does not have an edit control."))
      CASE_ERRCODE2(ERROR_WINDOW_NOT_COMBOBOX                                          , _T("The window is not a combo box."))
      CASE_ERRCODE2(ERROR_INVALID_EDIT_HEIGHT                                          , _T("Height must be less than 256."))
      CASE_ERRCODE2(ERROR_DC_NOT_FOUND                                                 , _T("Invalid device context (DC) handle."))
      CASE_ERRCODE2(ERROR_INVALID_HOOK_FILTER                                          , _T("Invalid hook procedure type."))
      CASE_ERRCODE2(ERROR_INVALID_FILTER_PROC                                          , _T("Invalid hook procedure."))
      CASE_ERRCODE2(ERROR_HOOK_NEEDS_HMOD                                              , _T("Cannot set nonlocal hook without a module handle."))
      CASE_ERRCODE2(ERROR_GLOBAL_ONLY_HOOK                                             , _T("This hook procedure can only be set globally."))
      CASE_ERRCODE2(ERROR_JOURNAL_HOOK_SET                                             , _T("The journal hook procedure is already installed."))
      CASE_ERRCODE2(ERROR_HOOK_NOT_INSTALLED                                           , _T("The hook procedure is not installed."))
      CASE_ERRCODE2(ERROR_INVALID_LB_MESSAGE                                           , _T("Invalid message for single-selection list box."))
      CASE_ERRCODE2(ERROR_SETCOUNT_ON_BAD_LB                                           , _T("LB_SETCOUNT sent to non-lazy list box."))
      CASE_ERRCODE2(ERROR_LB_WITHOUT_TABSTOPS                                          , _T("This list box does not support tab stops."))
      CASE_ERRCODE2(ERROR_DESTROY_OBJECT_OF_OTHER_THREAD                               , _T("Cannot destroy object created by another thread."))
      CASE_ERRCODE2(ERROR_CHILD_WINDOW_MENU                                            , _T("Child windows cannot have menus."))
      CASE_ERRCODE2(ERROR_NO_SYSTEM_MENU                                               , _T("The window does not have a system menu."))
      CASE_ERRCODE2(ERROR_INVALID_MSGBOX_STYLE                                         , _T("Invalid message box style."))
      CASE_ERRCODE2(ERROR_INVALID_SPI_VALUE                                            , _T("Invalid system-wide (SPI_*) parameter."))
      CASE_ERRCODE2(ERROR_SCREEN_ALREADY_LOCKED                                        , _T("Screen already locked."))
      CASE_ERRCODE2(ERROR_HWNDS_HAVE_DIFF_PARENT                                       , _T("All handles to windows in a multiple-window position structure must have the same parent."))
      CASE_ERRCODE2(ERROR_NOT_CHILD_WINDOW                                             , _T("The window is not a child window."))
      CASE_ERRCODE2(ERROR_INVALID_GW_COMMAND                                           , _T("Invalid GW_* command."))
      CASE_ERRCODE2(ERROR_INVALID_THREAD_ID                                            , _T("Invalid thread identifier."))
      CASE_ERRCODE2(ERROR_NON_MDICHILD_WINDOW                                          , _T("Cannot process a message from a window that is not a multiple document interface (MDI) window."))
      CASE_ERRCODE2(ERROR_POPUP_ALREADY_ACTIVE                                         , _T("Popup menu already active."))
      CASE_ERRCODE2(ERROR_NO_SCROLLBARS                                                , _T("The window does not have scroll bars."))
      CASE_ERRCODE2(ERROR_INVALID_SCROLLBAR_RANGE                                      , _T("Scroll bar range cannot be greater than MAXLONG."))
      CASE_ERRCODE2(ERROR_INVALID_SHOWWIN_COMMAND                                      , _T("Cannot show or remove the window in the way specified."))
      CASE_ERRCODE2(ERROR_NO_SYSTEM_RESOURCES                                          , _T("Insufficient system resources exist to complete the requested service."))
      CASE_ERRCODE2(ERROR_NONPAGED_SYSTEM_RESOURCES                                    , _T("Insufficient system resources exist to complete the requested service."))
      CASE_ERRCODE2(ERROR_PAGED_SYSTEM_RESOURCES                                       , _T("Insufficient system resources exist to complete the requested service."))
      CASE_ERRCODE2(ERROR_WORKING_SET_QUOTA                                            , _T("Insufficient quota to complete the requested service."))
      CASE_ERRCODE2(ERROR_PAGEFILE_QUOTA                                               , _T("Insufficient quota to complete the requested service."))
      CASE_ERRCODE2(ERROR_COMMITMENT_LIMIT                                             , _T("The paging file is too small for this operation to complete."))
      CASE_ERRCODE2(ERROR_MENU_ITEM_NOT_FOUND                                          , _T("A menu item was not found."))
      CASE_ERRCODE2(ERROR_INVALID_KEYBOARD_HANDLE                                      , _T("Invalid keyboard layout handle."))
      CASE_ERRCODE2(ERROR_HOOK_TYPE_NOT_ALLOWED                                        , _T("Hook type not allowed."))
      CASE_ERRCODE2(ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION                           , _T("This operation requires an interactive window station."))
      CASE_ERRCODE2(ERROR_TIMEOUT                                                      , _T("This operation returned because the timeout period expired."))
      CASE_ERRCODE2(ERROR_INVALID_MONITOR_HANDLE                                       , _T("Invalid monitor handle."))
      CASE_ERRCODE2(ERROR_EVENTLOG_FILE_CORRUPT                                        , _T("The event log file is corrupted."))
      CASE_ERRCODE2(ERROR_EVENTLOG_CANT_START                                          , _T("No event log file could be opened, so the event logging service did not start."))
      CASE_ERRCODE2(ERROR_LOG_FILE_FULL                                                , _T("The event log file is full."))
      CASE_ERRCODE2(ERROR_EVENTLOG_FILE_CHANGED                                        , _T("The event log file has changed between read operations."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_INSTALL_SERVICE_FAILURE                                      , _T("The Windows Installer service could not be accessed. This can occur if you are running Windows in safe mode, or if the Windows Installer is not correctly installed. Contact your support personnel for assistance."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_INSTALL_USEREXIT                                             , _T("User cancelled installation."))
      CASE_ERRCODE2(ERROR_INSTALL_FAILURE                                              , _T("Fatal error during installation."))
      CASE_ERRCODE2(ERROR_INSTALL_SUSPEND                                              , _T("Installation suspended, incomplete."))
      CASE_ERRCODE2(ERROR_UNKNOWN_PRODUCT                                              , _T("This action is only valid for products that are currently installed."))
      CASE_ERRCODE2(ERROR_UNKNOWN_FEATURE                                              , _T("Feature ID not registered."))
      CASE_ERRCODE2(ERROR_UNKNOWN_COMPONENT                                            , _T("Component ID not registered."))
      CASE_ERRCODE2(ERROR_UNKNOWN_PROPERTY                                             , _T("Unknown property."))
      CASE_ERRCODE2(ERROR_INVALID_HANDLE_STATE                                         , _T("Handle is in an invalid state."))
      CASE_ERRCODE2(ERROR_BAD_CONFIGURATION                                            , _T("The configuration data for this product is corrupt. Contact your support personnel."))
      CASE_ERRCODE2(ERROR_INDEX_ABSENT                                                 , _T("Component qualifier not present."))
      CASE_ERRCODE2(ERROR_INSTALL_SOURCE_ABSENT                                        , _T("The installation source for this product is not available. Verify that the source exists and that you can access it."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_INSTALL_PACKAGE_VERSION                                      , _T("This installation package cannot be installed by the Windows Installer service. You must install a Windows service pack that contains a newer version of the Windows Installer service."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_PRODUCT_UNINSTALLED                                          , _T("Product is uninstalled."))
      CASE_ERRCODE2(ERROR_BAD_QUERY_SYNTAX                                             , _T("SQL query syntax invalid or unsupported."))
      CASE_ERRCODE2(ERROR_INVALID_FIELD                                                , _T("Record field does not exist."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_DEVICE_REMOVED                                               , _T("The device has been removed."))
      CASE_ERRCODE2(ERROR_INSTALL_ALREADY_RUNNING                                      , _T("Another installation is already in progress. Complete that installation before proceeding with this install."))
      CASE_ERRCODE2(ERROR_INSTALL_PACKAGE_OPEN_FAILED                                  , _T("This installation package could not be opened. Verify that the package exists and that you can access it, or contact the application vendor to verify that this is a valid Windows Installer package."))
      CASE_ERRCODE2(ERROR_INSTALL_PACKAGE_INVALID                                      , _T("This installation package could not be opened. Contact the application vendor to verify that this is a valid Windows Installer package."))
      CASE_ERRCODE2(ERROR_INSTALL_UI_FAILURE                                           , _T("There was an error starting the Windows Installer service user interface. Contact your support personnel."))
      CASE_ERRCODE2(ERROR_INSTALL_LOG_FAILURE                                          , _T("Error opening installation log file. Verify that the specified log file location exists and that you can write to it."))
      CASE_ERRCODE2(ERROR_INSTALL_LANGUAGE_UNSUPPORTED                                 , _T("The language of this installation package is not supported by your system."))
      CASE_ERRCODE2(ERROR_INSTALL_TRANSFORM_FAILURE                                    , _T("Error applying transforms. Verify that the specified transform paths are valid."))
      CASE_ERRCODE2(ERROR_INSTALL_PACKAGE_REJECTED                                     , _T("This installation is forbidden by system policy. Contact your system administrator."))
      CASE_ERRCODE2(ERROR_FUNCTION_NOT_CALLED                                          , _T("Function could not be executed."))
      CASE_ERRCODE2(ERROR_FUNCTION_FAILED                                              , _T("Function failed during execution."))
      CASE_ERRCODE2(ERROR_INVALID_TABLE                                                , _T("Invalid or unknown table specified."))
      CASE_ERRCODE2(ERROR_DATATYPE_MISMATCH                                            , _T("Data supplied is of wrong type."))
      CASE_ERRCODE2(ERROR_UNSUPPORTED_TYPE                                             , _T("Data of this type is not supported."))
      CASE_ERRCODE2(ERROR_CREATE_FAILED                                                , _T("The Windows Installer service failed to start. Contact your support personnel."))
      CASE_ERRCODE2(ERROR_INSTALL_TEMP_UNWRITABLE                                      , _T("The Temp folder is on a drive that is full or inaccessible. Free up space on the drive or verify that you have write permission on the Temp folder."))
      CASE_ERRCODE2(ERROR_INSTALL_PLATFORM_UNSUPPORTED                                 , _T("This installation package is not supported by this processor type. Contact your product vendor."))
      CASE_ERRCODE2(ERROR_INSTALL_NOTUSED                                              , _T("Component not used on this computer."))
      CASE_ERRCODE2(ERROR_PATCH_PACKAGE_OPEN_FAILED                                    , _T("This patch package could not be opened. Verify that the patch package exists and that you can access it, or contact the application vendor to verify that this is a valid Windows Installer patch package."))
      CASE_ERRCODE2(ERROR_PATCH_PACKAGE_INVALID                                        , _T("This patch package could not be opened. Contact the application vendor to verify that this is a valid Windows Installer patch package."))
      CASE_ERRCODE2(ERROR_PATCH_PACKAGE_UNSUPPORTED                                    , _T("This patch package cannot be processed by the Windows Installer service. You must install a Windows service pack that contains a newer version of the Windows Installer service."))
      CASE_ERRCODE2(ERROR_PRODUCT_VERSION                                              , _T("Another version of this product is already installed. Installation of this version cannot continue. To configure or remove the existing version of this product, use Add/Remove Programs on the Control Panel."))
      CASE_ERRCODE2(ERROR_INVALID_COMMAND_LINE                                         , _T("Invalid command line argument. Consult the Windows Installer SDK for detailed command line help."))
      CASE_ERRCODE2(ERROR_INSTALL_REMOTE_DISALLOWED                                    , _T("Only administrators have permission to add, remove, or configure server software during a Terminal Services remote session. If you want to install or configure software on the server, contact your network administrator."))
      CASE_ERRCODE2(ERROR_SUCCESS_REBOOT_INITIATED                                     , _T("The requested operation completed successfully. The system will be restarted so the changes can take effect."))
      CASE_ERRCODE2(ERROR_PATCH_TARGET_NOT_FOUND                                       , _T("The upgrade patch cannot be installed by the Windows Installer service because the program to be upgraded may be missing, or the upgrade patch may update a different version of the program. Verify that the program to be upgraded exists on your computer and that you have the correct upgrade patch."))
      CASE_ERRCODE2(ERROR_PATCH_PACKAGE_REJECTED                                       , _T("The patch package is not permitted by software restriction policy."))
      CASE_ERRCODE2(ERROR_INSTALL_TRANSFORM_REJECTED                                   , _T("One or more customizations are not permitted by software restriction policy."))
      CASE_ERRCODE2(ERROR_INSTALL_REMOTE_PROHIBITED                                    , _T("The Windows Installer does not permit installation from a Remote Desktop Connection."))
#endif // __SDK__
      CASE_ERRCODE2(RPC_S_INVALID_STRING_BINDING                                       , _T("The string binding is invalid."))
      CASE_ERRCODE2(RPC_S_WRONG_KIND_OF_BINDING                                        , _T("The binding handle is not the correct type."))
      CASE_ERRCODE2(RPC_S_INVALID_BINDING                                              , _T("The binding handle is invalid."))
      CASE_ERRCODE2(RPC_S_PROTSEQ_NOT_SUPPORTED                                        , _T("The RPC protocol sequence is not supported."))
      CASE_ERRCODE2(RPC_S_INVALID_RPC_PROTSEQ                                          , _T("The RPC protocol sequence is invalid."))
      CASE_ERRCODE2(RPC_S_INVALID_STRING_UUID                                          , _T("The string universal unique identifier (UUID) is invalid."))
      CASE_ERRCODE2(RPC_S_INVALID_ENDPOINT_FORMAT                                      , _T("The endpoint format is invalid."))
      CASE_ERRCODE2(RPC_S_INVALID_NET_ADDR                                             , _T("The network address is invalid."))
      CASE_ERRCODE2(RPC_S_NO_ENDPOINT_FOUND                                            , _T("No endpoint was found."))
      CASE_ERRCODE2(RPC_S_INVALID_TIMEOUT                                              , _T("The timeout value is invalid."))
      CASE_ERRCODE2(RPC_S_OBJECT_NOT_FOUND                                             , _T("The object universal unique identifier (UUID) was not found."))
      CASE_ERRCODE2(RPC_S_ALREADY_REGISTERED                                           , _T("The object universal unique identifier (UUID) has already been registered."))
      CASE_ERRCODE2(RPC_S_TYPE_ALREADY_REGISTERED                                      , _T("The type universal unique identifier (UUID) has already been registered."))
      CASE_ERRCODE2(RPC_S_ALREADY_LISTENING                                            , _T("The RPC server is already listening."))
      CASE_ERRCODE2(RPC_S_NO_PROTSEQS_REGISTERED                                       , _T("No protocol sequences have been registered."))
      CASE_ERRCODE2(RPC_S_NOT_LISTENING                                                , _T("The RPC server is not listening."))
      CASE_ERRCODE2(RPC_S_UNKNOWN_MGR_TYPE                                             , _T("The manager type is unknown."))
      CASE_ERRCODE2(RPC_S_UNKNOWN_IF                                                   , _T("The interface is unknown."))
      CASE_ERRCODE2(RPC_S_NO_BINDINGS                                                  , _T("There are no bindings."))
      CASE_ERRCODE2(RPC_S_NO_PROTSEQS                                                  , _T("There are no protocol sequences."))
      CASE_ERRCODE2(RPC_S_CANT_CREATE_ENDPOINT                                         , _T("The endpoint cannot be created."))
      CASE_ERRCODE2(RPC_S_OUT_OF_RESOURCES                                             , _T("Not enough resources are available to complete this operation."))
      CASE_ERRCODE2(RPC_S_SERVER_UNAVAILABLE                                           , _T("The RPC server is unavailable."))
      CASE_ERRCODE2(RPC_S_SERVER_TOO_BUSY                                              , _T("The RPC server is too busy to complete this operation."))
      CASE_ERRCODE2(RPC_S_INVALID_NETWORK_OPTIONS                                      , _T("The network options are invalid."))
      CASE_ERRCODE2(RPC_S_NO_CALL_ACTIVE                                               , _T("There are no remote procedure calls active on this thread."))
      CASE_ERRCODE2(RPC_S_CALL_FAILED                                                  , _T("The remote procedure call failed."))
      CASE_ERRCODE2(RPC_S_CALL_FAILED_DNE                                              , _T("The remote procedure call failed and did not execute."))
      CASE_ERRCODE2(RPC_S_PROTOCOL_ERROR                                               , _T("A remote procedure call (RPC) protocol error occurred."))
      CASE_ERRCODE2(RPC_S_UNSUPPORTED_TRANS_SYN                                        , _T("The transfer syntax is not supported by the RPC server."))
      CASE_ERRCODE2(RPC_S_UNSUPPORTED_TYPE                                             , _T("The universal unique identifier (UUID) type is not supported."))
      CASE_ERRCODE2(RPC_S_INVALID_TAG                                                  , _T("The tag is invalid."))
      CASE_ERRCODE2(RPC_S_INVALID_BOUND                                                , _T("The array bounds are invalid."))
      CASE_ERRCODE2(RPC_S_NO_ENTRY_NAME                                                , _T("The binding does not contain an entry name."))
      CASE_ERRCODE2(RPC_S_INVALID_NAME_SYNTAX                                          , _T("The name syntax is invalid."))
      CASE_ERRCODE2(RPC_S_UNSUPPORTED_NAME_SYNTAX                                      , _T("The name syntax is not supported."))
      CASE_ERRCODE2(RPC_S_UUID_NO_ADDRESS                                              , _T("No network address is available to use to construct a universal unique identifier (UUID)."))
      CASE_ERRCODE2(RPC_S_DUPLICATE_ENDPOINT                                           , _T("The endpoint is a duplicate."))
      CASE_ERRCODE2(RPC_S_UNKNOWN_AUTHN_TYPE                                           , _T("The authentication type is unknown."))
      CASE_ERRCODE2(RPC_S_MAX_CALLS_TOO_SMALL                                          , _T("The maximum number of calls is too small."))
      CASE_ERRCODE2(RPC_S_STRING_TOO_LONG                                              , _T("The string is too long."))
      CASE_ERRCODE2(RPC_S_PROTSEQ_NOT_FOUND                                            , _T("The RPC protocol sequence was not found."))
      CASE_ERRCODE2(RPC_S_PROCNUM_OUT_OF_RANGE                                         , _T("The procedure number is out of range."))
      CASE_ERRCODE2(RPC_S_BINDING_HAS_NO_AUTH                                          , _T("The binding does not contain any authentication information."))
      CASE_ERRCODE2(RPC_S_UNKNOWN_AUTHN_SERVICE                                        , _T("The authentication service is unknown."))
      CASE_ERRCODE2(RPC_S_UNKNOWN_AUTHN_LEVEL                                          , _T("The authentication level is unknown."))
      CASE_ERRCODE2(RPC_S_INVALID_AUTH_IDENTITY                                        , _T("The security context is invalid."))
      CASE_ERRCODE2(RPC_S_UNKNOWN_AUTHZ_SERVICE                                        , _T("The authorization service is unknown."))
      CASE_ERRCODE2(EPT_S_INVALID_ENTRY                                                , _T("The entry is invalid."))
      CASE_ERRCODE2(EPT_S_CANT_PERFORM_OP                                              , _T("The server endpoint cannot perform the operation."))
      CASE_ERRCODE2(EPT_S_NOT_REGISTERED                                               , _T("There are no more endpoints available from the endpoint mapper."))
      CASE_ERRCODE2(RPC_S_NOTHING_TO_EXPORT                                            , _T("No interfaces have been exported."))
      CASE_ERRCODE2(RPC_S_INCOMPLETE_NAME                                              , _T("The entry name is incomplete."))
      CASE_ERRCODE2(RPC_S_INVALID_VERS_OPTION                                          , _T("The version option is invalid."))
      CASE_ERRCODE2(RPC_S_NO_MORE_MEMBERS                                              , _T("There are no more members."))
      CASE_ERRCODE2(RPC_S_NOT_ALL_OBJS_UNEXPORTED                                      , _T("There is nothing to unexport."))
      CASE_ERRCODE2(RPC_S_INTERFACE_NOT_FOUND                                          , _T("The interface was not found."))
      CASE_ERRCODE2(RPC_S_ENTRY_ALREADY_EXISTS                                         , _T("The entry already exists."))
      CASE_ERRCODE2(RPC_S_ENTRY_NOT_FOUND                                              , _T("The entry is not found."))
      CASE_ERRCODE2(RPC_S_NAME_SERVICE_UNAVAILABLE                                     , _T("The name service is unavailable."))
      CASE_ERRCODE2(RPC_S_INVALID_NAF_ID                                               , _T("The network address family is invalid."))
      CASE_ERRCODE2(RPC_S_CANNOT_SUPPORT                                               , _T("The requested operation is not supported."))
      CASE_ERRCODE2(RPC_S_NO_CONTEXT_AVAILABLE                                         , _T("No security context is available to allow impersonation."))
      CASE_ERRCODE2(RPC_S_INTERNAL_ERROR                                               , _T("An internal error occurred in a remote procedure call (RPC)."))
      CASE_ERRCODE2(RPC_S_ZERO_DIVIDE                                                  , _T("The RPC server attempted an integer division by zero."))
      CASE_ERRCODE2(RPC_S_ADDRESS_ERROR                                                , _T("An addressing error occurred in the RPC server."))
      CASE_ERRCODE2(RPC_S_FP_DIV_ZERO                                                  , _T("A floating-point operation at the RPC server caused a division by zero."))
      CASE_ERRCODE2(RPC_S_FP_UNDERFLOW                                                 , _T("A floating-point underflow occurred at the RPC server."))
      CASE_ERRCODE2(RPC_S_FP_OVERFLOW                                                  , _T("A floating-point overflow occurred at the RPC server."))
      CASE_ERRCODE2(RPC_X_NO_MORE_ENTRIES                                              , _T("The list of RPC servers available for the binding of auto handles has been exhausted."))
      CASE_ERRCODE2(RPC_X_SS_CHAR_TRANS_OPEN_FAIL                                      , _T("Unable to open the character translation table file."))
      CASE_ERRCODE2(RPC_X_SS_CHAR_TRANS_SHORT_FILE                                     , _T("The file containing the character translation table has fewer than 512 bytes."))
      CASE_ERRCODE2(RPC_X_SS_IN_NULL_CONTEXT                                           , _T("A null context handle was passed from the client to the host during a remote procedure call."))
      CASE_ERRCODE2(RPC_X_SS_CONTEXT_DAMAGED                                           , _T("The context handle changed during a remote procedure call."))
      CASE_ERRCODE2(RPC_X_SS_HANDLES_MISMATCH                                          , _T("The binding handles passed to a remote procedure call do not match."))
      CASE_ERRCODE2(RPC_X_SS_CANNOT_GET_CALL_HANDLE                                    , _T("The stub is unable to get the remote procedure call handle."))
      CASE_ERRCODE2(RPC_X_NULL_REF_POINTER                                             , _T("A null reference pointer was passed to the stub."))
      CASE_ERRCODE2(RPC_X_ENUM_VALUE_OUT_OF_RANGE                                      , _T("The enumeration value is out of range."))
      CASE_ERRCODE2(RPC_X_BYTE_COUNT_TOO_SMALL                                         , _T("The byte count is too small."))
      CASE_ERRCODE2(RPC_X_BAD_STUB_DATA                                                , _T("The stub received bad data."))
      CASE_ERRCODE2(ERROR_INVALID_USER_BUFFER                                          , _T("The supplied user buffer is not valid for the requested operation."))
      CASE_ERRCODE2(ERROR_UNRECOGNIZED_MEDIA                                           , _T("The disk media is not recognized. It may not be formatted."))
      CASE_ERRCODE2(ERROR_NO_TRUST_LSA_SECRET                                          , _T("The workstation does not have a trust secret."))
      CASE_ERRCODE2(ERROR_NO_TRUST_SAM_ACCOUNT                                         , _T("The security database on the server does not have a computer account for this workstation trust relationship."))
      CASE_ERRCODE2(ERROR_TRUSTED_DOMAIN_FAILURE                                       , _T("The trust relationship between the primary domain and the trusted domain failed."))
      CASE_ERRCODE2(ERROR_TRUSTED_RELATIONSHIP_FAILURE                                 , _T("The trust relationship between this workstation and the primary domain failed."))
      CASE_ERRCODE2(ERROR_TRUST_FAILURE                                                , _T("The network logon failed."))
      CASE_ERRCODE2(RPC_S_CALL_IN_PROGRESS                                             , _T("A remote procedure call is already in progress for this thread."))
      CASE_ERRCODE2(ERROR_NETLOGON_NOT_STARTED                                         , _T("An attempt was made to logon, but the network logon service was not started."))
      CASE_ERRCODE2(ERROR_ACCOUNT_EXPIRED                                              , _T("The user's account has expired."))
      CASE_ERRCODE2(ERROR_REDIRECTOR_HAS_OPEN_HANDLES                                  , _T("The redirector is in use and cannot be unloaded."))
      CASE_ERRCODE2(ERROR_PRINTER_DRIVER_ALREADY_INSTALLED                             , _T("The specified printer driver is already installed."))
      CASE_ERRCODE2(ERROR_UNKNOWN_PORT                                                 , _T("The specified port is unknown."))
      CASE_ERRCODE2(ERROR_UNKNOWN_PRINTER_DRIVER                                       , _T("The printer driver is unknown."))
      CASE_ERRCODE2(ERROR_UNKNOWN_PRINTPROCESSOR                                       , _T("The print processor is unknown."))
      CASE_ERRCODE2(ERROR_INVALID_SEPARATOR_FILE                                       , _T("The specified separator file is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_PRIORITY                                             , _T("The specified priority is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_PRINTER_NAME                                         , _T("The printer name is invalid."))
      CASE_ERRCODE2(ERROR_PRINTER_ALREADY_EXISTS                                       , _T("The printer already exists."))
      CASE_ERRCODE2(ERROR_INVALID_PRINTER_COMMAND                                      , _T("The printer command is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_DATATYPE                                             , _T("The specified datatype is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_ENVIRONMENT                                          , _T("The environment specified is invalid."))
      CASE_ERRCODE2(RPC_S_NO_MORE_BINDINGS                                             , _T("There are no more bindings."))
      CASE_ERRCODE2(ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT                            , _T("The account used is an interdomain trust account. Use your global user account or local user account to access this server."))
      CASE_ERRCODE2(ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT                            , _T("The account used is a computer account. Use your global user account or local user account to access this server."))
      CASE_ERRCODE2(ERROR_NOLOGON_SERVER_TRUST_ACCOUNT                                 , _T("The account used is a server trust account. Use your global user account or local user account to access this server."))
      CASE_ERRCODE2(ERROR_DOMAIN_TRUST_INCONSISTENT                                    , _T("The name or security ID (SID) of the domain specified is inconsistent with the trust information for that domain."))
      CASE_ERRCODE2(ERROR_SERVER_HAS_OPEN_HANDLES                                      , _T("The server is in use and cannot be unloaded."))
      CASE_ERRCODE2(ERROR_RESOURCE_DATA_NOT_FOUND                                      , _T("The specified image file did not contain a resource section."))
      CASE_ERRCODE2(ERROR_RESOURCE_TYPE_NOT_FOUND                                      , _T("The specified resource type cannot be found in the image file."))
      CASE_ERRCODE2(ERROR_RESOURCE_NAME_NOT_FOUND                                      , _T("The specified resource name cannot be found in the image file."))
      CASE_ERRCODE2(ERROR_RESOURCE_LANG_NOT_FOUND                                      , _T("The specified resource language ID cannot be found in the image file."))
      CASE_ERRCODE2(ERROR_NOT_ENOUGH_QUOTA                                             , _T("Not enough quota is available to process this command."))
      CASE_ERRCODE2(RPC_S_NO_INTERFACES                                                , _T("No interfaces have been registered."))
      CASE_ERRCODE2(RPC_S_CALL_CANCELLED                                               , _T("The remote procedure call was cancelled."))
      CASE_ERRCODE2(RPC_S_BINDING_INCOMPLETE                                           , _T("The binding handle does not contain all required information."))
      CASE_ERRCODE2(RPC_S_COMM_FAILURE                                                 , _T("A communications failure occurred during a remote procedure call."))
      CASE_ERRCODE2(RPC_S_UNSUPPORTED_AUTHN_LEVEL                                      , _T("The requested authentication level is not supported."))
      CASE_ERRCODE2(RPC_S_NO_PRINC_NAME                                                , _T("No principal name registered."))
      CASE_ERRCODE2(RPC_S_NOT_RPC_ERROR                                                , _T("The error specified is not a valid Windows RPC error code."))
      CASE_ERRCODE2(RPC_S_UUID_LOCAL_ONLY                                              , _T("A UUID that is valid only on this computer has been allocated."))
      CASE_ERRCODE2(RPC_S_SEC_PKG_ERROR                                                , _T("A security package specific error occurred."))
      CASE_ERRCODE2(RPC_S_NOT_CANCELLED                                                , _T("Thread is not canceled."))
      CASE_ERRCODE2(RPC_X_INVALID_ES_ACTION                                            , _T("Invalid operation on the encoding/decoding handle."))
      CASE_ERRCODE2(RPC_X_WRONG_ES_VERSION                                             , _T("Incompatible version of the serializing package."))
      CASE_ERRCODE2(RPC_X_WRONG_STUB_VERSION                                           , _T("Incompatible version of the RPC stub."))
      CASE_ERRCODE2(RPC_X_INVALID_PIPE_OBJECT                                          , _T("The RPC pipe object is invalid or corrupted."))
      CASE_ERRCODE2(RPC_X_WRONG_PIPE_ORDER                                             , _T("An invalid operation was attempted on an RPC pipe object."))
      CASE_ERRCODE2(RPC_X_WRONG_PIPE_VERSION                                           , _T("Unsupported RPC pipe version."))
      CASE_ERRCODE2(RPC_S_GROUP_MEMBER_NOT_FOUND                                       , _T("The group member was not found."))
      CASE_ERRCODE2(EPT_S_CANT_CREATE                                                  , _T("The endpoint mapper database entry could not be created."))
      CASE_ERRCODE2(RPC_S_INVALID_OBJECT                                               , _T("The object universal unique identifier (UUID) is the nil UUID."))
      CASE_ERRCODE2(ERROR_INVALID_TIME                                                 , _T("The specified time is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_FORM_NAME                                            , _T("The specified form name is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_FORM_SIZE                                            , _T("The specified form size is invalid."))
      CASE_ERRCODE2(ERROR_ALREADY_WAITING                                              , _T("The specified printer handle is already being waited on"))
      CASE_ERRCODE2(ERROR_PRINTER_DELETED                                              , _T("The specified printer has been deleted."))
      CASE_ERRCODE2(ERROR_INVALID_PRINTER_STATE                                        , _T("The state of the printer is invalid."))
      CASE_ERRCODE2(ERROR_PASSWORD_MUST_CHANGE                                         , _T("The user's password must be changed before logging on the first time."))
      CASE_ERRCODE2(ERROR_DOMAIN_CONTROLLER_NOT_FOUND                                  , _T("Could not find the domain controller for this domain."))
      CASE_ERRCODE2(ERROR_ACCOUNT_LOCKED_OUT                                           , _T("The referenced account is currently locked out and may not be logged on to."))
      CASE_ERRCODE2(OR_INVALID_OXID                                                    , _T("The object exporter specified was not found."))
      CASE_ERRCODE2(OR_INVALID_OID                                                     , _T("The object specified was not found."))
      CASE_ERRCODE2(OR_INVALID_SET                                                     , _T("The object resolver set specified was not found."))
      CASE_ERRCODE2(RPC_S_SEND_INCOMPLETE                                              , _T("Some data remains to be sent in the request buffer."))
      CASE_ERRCODE2(RPC_S_INVALID_ASYNC_HANDLE                                         , _T("Invalid asynchronous remote procedure call handle."))
      CASE_ERRCODE2(RPC_S_INVALID_ASYNC_CALL                                           , _T("Invalid asynchronous RPC call handle for this operation."))
      CASE_ERRCODE2(RPC_X_PIPE_CLOSED                                                  , _T("The RPC pipe object has already been closed."))
      CASE_ERRCODE2(RPC_X_PIPE_DISCIPLINE_ERROR                                        , _T("The RPC call completed before all pipes were processed."))
      CASE_ERRCODE2(RPC_X_PIPE_EMPTY                                                   , _T("No more data is available from the RPC pipe."))
      CASE_ERRCODE2(ERROR_NO_SITENAME                                                  , _T("No site name is available for this machine."))
      CASE_ERRCODE2(ERROR_CANT_ACCESS_FILE                                             , _T("The file cannot be accessed by the system."))
      CASE_ERRCODE2(ERROR_CANT_RESOLVE_FILENAME                                        , _T("The name of the file cannot be resolved by the system."))
#ifdef __SDK__
      CASE_ERRCODE2(RPC_S_ENTRY_TYPE_MISMATCH                                          , _T("The entry is not of the expected type."))
      CASE_ERRCODE2(RPC_S_NOT_ALL_OBJS_EXPORTED                                        , _T("Not all object UUIDs could be exported to the specified entry."))
      CASE_ERRCODE2(RPC_S_INTERFACE_NOT_EXPORTED                                       , _T("Interface could not be exported to the specified entry."))
      CASE_ERRCODE2(RPC_S_PROFILE_NOT_ADDED                                            , _T("The specified profile entry could not be added."))
      CASE_ERRCODE2(RPC_S_PRF_ELT_NOT_ADDED                                            , _T("The specified profile element could not be added."))
      CASE_ERRCODE2(RPC_S_PRF_ELT_NOT_REMOVED                                          , _T("The specified profile element could not be removed."))
      CASE_ERRCODE2(RPC_S_GRP_ELT_NOT_ADDED                                            , _T("The group element could not be added."))
      CASE_ERRCODE2(RPC_S_GRP_ELT_NOT_REMOVED                                          , _T("The group element could not be removed."))
      CASE_ERRCODE2(ERROR_KM_DRIVER_BLOCKED                                            , _T("The printer driver is not compatible with a policy enabled on your computer that blocks NT 4.0 drivers."))
      CASE_ERRCODE2(ERROR_CONTEXT_EXPIRED                                              , _T("The context has expired and can no longer be used."))
      CASE_ERRCODE2(ERROR_PER_USER_TRUST_QUOTA_EXCEEDED                                , _T("The current user's delegated trust creation quota has been exceeded."))
      CASE_ERRCODE2(ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED                                , _T("The total delegated trust creation quota has been exceeded."))
      CASE_ERRCODE2(ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED                             , _T("The current user's delegated trust deletion quota has been exceeded."))
      CASE_ERRCODE2(ERROR_AUTHENTICATION_FIREWALL_FAILED                               , _T("Logon Failure: The machine you are logging onto is protected by an authentication firewall.  The specified account is not allowed to authenticate to the machine."))
      CASE_ERRCODE2(ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED                             , _T("Remote connections to the Print Spooler are blocked by a policy set on your machine."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_INVALID_PIXEL_FORMAT                                         , _T("The pixel format is invalid."))
      CASE_ERRCODE2(ERROR_BAD_DRIVER                                                   , _T("The specified driver is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_WINDOW_STYLE                                         , _T("The window style or class attribute is invalid for this operation."))
      CASE_ERRCODE2(ERROR_METAFILE_NOT_SUPPORTED                                       , _T("The requested metafile operation is not supported."))
      CASE_ERRCODE2(ERROR_TRANSFORM_NOT_SUPPORTED                                      , _T("The requested transformation operation is not supported."))
      CASE_ERRCODE2(ERROR_CLIPPING_NOT_SUPPORTED                                       , _T("The requested clipping operation is not supported."))
      CASE_ERRCODE2(ERROR_INVALID_CMM                                                  , _T("The specified color management module is invalid."))
      CASE_ERRCODE2(ERROR_INVALID_PROFILE                                              , _T("The specified color profile is invalid."))
      CASE_ERRCODE2(ERROR_TAG_NOT_FOUND                                                , _T("The specified tag was not found."))
      CASE_ERRCODE2(ERROR_TAG_NOT_PRESENT                                              , _T("A required tag is not present."))
      CASE_ERRCODE2(ERROR_DUPLICATE_TAG                                                , _T("The specified tag is already present."))
      CASE_ERRCODE2(ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE                           , _T("The specified color profile is not associated with any device."))
      CASE_ERRCODE2(ERROR_PROFILE_NOT_FOUND                                            , _T("The specified color profile was not found."))
      CASE_ERRCODE2(ERROR_INVALID_COLORSPACE                                           , _T("The specified color space is invalid."))
      CASE_ERRCODE2(ERROR_ICM_NOT_ENABLED                                              , _T("Image Color Management is not enabled."))
      CASE_ERRCODE2(ERROR_DELETING_ICM_XFORM                                           , _T("There was an error while deleting the color transform."))
      CASE_ERRCODE2(ERROR_INVALID_TRANSFORM                                            , _T("The specified color transform is invalid."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_COLORSPACE_MISMATCH                                          , _T("The specified transform does not match the bitmap's color space."))
      CASE_ERRCODE2(ERROR_INVALID_COLORINDEX                                           , _T("The specified named color index is not present in the profile."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_CONNECTED_OTHER_PASSWORD                                     , _T("The network connection was made successfully, but the user had to be prompted for a password other than the one originally specified."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT                             , _T("The network connection was made successfully using default credentials."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_BAD_USERNAME                                                 , _T("The specified username is invalid."))
      CASE_ERRCODE2(ERROR_NOT_CONNECTED                                                , _T("This network connection does not exist."))
      CASE_ERRCODE2(ERROR_OPEN_FILES                                                   , _T("This network connection has files open or requests pending."))
      CASE_ERRCODE2(ERROR_ACTIVE_CONNECTIONS                                           , _T("Active connections still exist."))
      CASE_ERRCODE2(ERROR_DEVICE_IN_USE                                                , _T("The device is in use by an active process and cannot be disconnected."))
      CASE_ERRCODE2(ERROR_UNKNOWN_PRINT_MONITOR                                        , _T("The specified print monitor is unknown."))
      CASE_ERRCODE2(ERROR_PRINTER_DRIVER_IN_USE                                        , _T("The specified printer driver is currently in use."))
      CASE_ERRCODE2(ERROR_SPOOL_FILE_NOT_FOUND                                         , _T("The spool file was not found."))
      CASE_ERRCODE2(ERROR_SPL_NO_STARTDOC                                              , _T("A StartDocPrinter call was not issued."))
      CASE_ERRCODE2(ERROR_SPL_NO_ADDJOB                                                , _T("An AddJob call was not issued."))
      CASE_ERRCODE2(ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED                            , _T("The specified print processor has already been installed."))
      CASE_ERRCODE2(ERROR_PRINT_MONITOR_ALREADY_INSTALLED                              , _T("The specified print monitor has already been installed."))
      CASE_ERRCODE2(ERROR_INVALID_PRINT_MONITOR                                        , _T("The specified print monitor does not have the required functions."))
      CASE_ERRCODE2(ERROR_PRINT_MONITOR_IN_USE                                         , _T("The specified print monitor is currently in use."))
      CASE_ERRCODE2(ERROR_PRINTER_HAS_JOBS_QUEUED                                      , _T("The requested operation is not allowed when there are jobs queued to the printer."))
      CASE_ERRCODE2(ERROR_SUCCESS_REBOOT_REQUIRED                                      , _T("The requested operation is successful. Changes will not be effective until the system is rebooted."))
      CASE_ERRCODE2(ERROR_SUCCESS_RESTART_REQUIRED                                     , _T("The requested operation is successful. Changes will not be effective until the service is restarted."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_PRINTER_NOT_FOUND                                            , _T("No printers were found."))
      CASE_ERRCODE2(ERROR_PRINTER_DRIVER_WARNED                                        , _T("The printer driver is known to be unreliable."))
      CASE_ERRCODE2(ERROR_PRINTER_DRIVER_BLOCKED                                       , _T("The printer driver is known to harm the system."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_WINS_INTERNAL                                                , _T("WINS encountered an error while processing the command."))
      CASE_ERRCODE2(ERROR_CAN_NOT_DEL_LOCAL_WINS                                       , _T("The local WINS cannot be deleted."))
      CASE_ERRCODE2(ERROR_STATIC_INIT                                                  , _T("The importation from the file failed."))
      CASE_ERRCODE2(ERROR_INC_BACKUP                                                   , _T("The backup failed. Was a full backup done before?"))
      CASE_ERRCODE2(ERROR_FULL_BACKUP                                                  , _T("The backup failed. Check the directory to which you are backing the database."))
      CASE_ERRCODE2(ERROR_REC_NON_EXISTENT                                             , _T("The name does not exist in the WINS database."))
      CASE_ERRCODE2(ERROR_RPL_NOT_ALLOWED                                              , _T("Replication with a nonconfigured partner is not allowed."))
      CASE_ERRCODE2(ERROR_DHCP_ADDRESS_CONFLICT                                        , _T("The DHCP client has obtained an IP address that is already in use on the network. The local interface will be disabled until the DHCP client can obtain a new address."))
      CASE_ERRCODE2(ERROR_WMI_GUID_NOT_FOUND                                           , _T("The GUID passed was not recognized as valid by a WMI data provider."))
      CASE_ERRCODE2(ERROR_WMI_INSTANCE_NOT_FOUND                                       , _T("The instance name passed was not recognized as valid by a WMI data provider."))
      CASE_ERRCODE2(ERROR_WMI_ITEMID_NOT_FOUND                                         , _T("The data item ID passed was not recognized as valid by a WMI data provider."))
      CASE_ERRCODE2(ERROR_WMI_TRY_AGAIN                                                , _T("The WMI request could not be completed and should be retried."))
      CASE_ERRCODE2(ERROR_WMI_DP_NOT_FOUND                                             , _T("The WMI data provider could not be located."))
      CASE_ERRCODE2(ERROR_WMI_UNRESOLVED_INSTANCE_REF                                  , _T("The WMI data provider references an instance set that has not been registered."))
      CASE_ERRCODE2(ERROR_WMI_ALREADY_ENABLED                                          , _T("The WMI data block or event notification has already been enabled."))
      CASE_ERRCODE2(ERROR_WMI_GUID_DISCONNECTED                                        , _T("The WMI data block is no longer available."))
      CASE_ERRCODE2(ERROR_WMI_SERVER_UNAVAILABLE                                       , _T("The WMI data service is not available."))
      CASE_ERRCODE2(ERROR_WMI_DP_FAILED                                                , _T("The WMI data provider failed to carry out the request."))
      CASE_ERRCODE2(ERROR_WMI_INVALID_MOF                                              , _T("The WMI MOF information is not valid."))
      CASE_ERRCODE2(ERROR_WMI_INVALID_REGINFO                                          , _T("The WMI registration information is not valid."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_WMI_ALREADY_DISABLED                                         , _T("The WMI data block or event notification has already been disabled."))
      CASE_ERRCODE2(ERROR_WMI_READ_ONLY                                                , _T("The WMI data item or data block is read only."))
      CASE_ERRCODE2(ERROR_WMI_SET_FAILURE                                              , _T("The WMI data item or data block could not be changed."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_INVALID_MEDIA                                                , _T("The media identifier does not represent a valid medium."))
      CASE_ERRCODE2(ERROR_INVALID_LIBRARY                                              , _T("The library identifier does not represent a valid library."))
      CASE_ERRCODE2(ERROR_INVALID_MEDIA_POOL                                           , _T("The media pool identifier does not represent a valid media pool."))
      CASE_ERRCODE2(ERROR_DRIVE_MEDIA_MISMATCH                                         , _T("The drive and medium are not compatible or exist in different libraries."))
      CASE_ERRCODE2(ERROR_MEDIA_OFFLINE                                                , _T("The medium currently exists in an offline library and must be online to perform this operation."))
      CASE_ERRCODE2(ERROR_LIBRARY_OFFLINE                                              , _T("The operation cannot be performed on an offline library."))
      CASE_ERRCODE2(ERROR_EMPTY                                                        , _T("The library, drive, or media pool is empty."))
      CASE_ERRCODE2(ERROR_NOT_EMPTY                                                    , _T("The library, drive, or media pool must be empty to perform this operation."))
      CASE_ERRCODE2(ERROR_MEDIA_UNAVAILABLE                                            , _T("No media is currently available in this media pool or library."))
      CASE_ERRCODE2(ERROR_RESOURCE_DISABLED                                            , _T("A resource required for this operation is disabled."))
      CASE_ERRCODE2(ERROR_INVALID_CLEANER                                              , _T("The media identifier does not represent a valid cleaner."))
      CASE_ERRCODE2(ERROR_UNABLE_TO_CLEAN                                              , _T("The drive cannot be cleaned or does not support cleaning."))
      CASE_ERRCODE2(ERROR_OBJECT_NOT_FOUND                                             , _T("The object identifier does not represent a valid object."))
      CASE_ERRCODE2(ERROR_DATABASE_FAILURE                                             , _T("Unable to read from or write to the database."))
      CASE_ERRCODE2(ERROR_DATABASE_FULL                                                , _T("The database is full."))
      CASE_ERRCODE2(ERROR_MEDIA_INCOMPATIBLE                                           , _T("The medium is not compatible with the device or media pool."))
      CASE_ERRCODE2(ERROR_RESOURCE_NOT_PRESENT                                         , _T("The resource required for this operation does not exist."))
      CASE_ERRCODE2(ERROR_INVALID_OPERATION                                            , _T("The operation identifier is not valid."))
      CASE_ERRCODE2(ERROR_MEDIA_NOT_AVAILABLE                                          , _T("The media is not mounted or ready for use."))
      CASE_ERRCODE2(ERROR_DEVICE_NOT_AVAILABLE                                         , _T("The device is not ready for use."))
      CASE_ERRCODE2(ERROR_REQUEST_REFUSED                                              , _T("The operator or administrator has refused the request."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_INVALID_DRIVE_OBJECT                                         , _T("The drive identifier does not represent a valid drive."))
      CASE_ERRCODE2(ERROR_LIBRARY_FULL                                                 , _T("Library is full. No slot is available for use."))
      CASE_ERRCODE2(ERROR_MEDIUM_NOT_ACCESSIBLE                                        , _T("The transport cannot access the medium."))
      CASE_ERRCODE2(ERROR_UNABLE_TO_LOAD_MEDIUM                                        , _T("Unable to load the medium into the drive."))
      CASE_ERRCODE2(ERROR_UNABLE_TO_INVENTORY_DRIVE                                    , _T("Unable to retrieve status about the drive."))
      CASE_ERRCODE2(ERROR_UNABLE_TO_INVENTORY_SLOT                                     , _T("Unable to retrieve status about the slot."))
      CASE_ERRCODE2(ERROR_UNABLE_TO_INVENTORY_TRANSPORT                                , _T("Unable to retrieve status about the transport."))
      CASE_ERRCODE2(ERROR_TRANSPORT_FULL                                               , _T("Cannot use the transport because it is already in use."))
      CASE_ERRCODE2(ERROR_CONTROLLING_IEPORT                                           , _T("Unable to open or close the inject/eject port."))
      CASE_ERRCODE2(ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA                                , _T("Unable to eject the media because it is in a drive."))
      CASE_ERRCODE2(ERROR_CLEANER_SLOT_SET                                             , _T("A cleaner slot is already reserved."))
      CASE_ERRCODE2(ERROR_CLEANER_SLOT_NOT_SET                                         , _T("A cleaner slot is not reserved."))
      CASE_ERRCODE2(ERROR_CLEANER_CARTRIDGE_SPENT                                      , _T("The cleaner cartridge has performed the maximum number of drive cleanings."))
      CASE_ERRCODE2(ERROR_UNEXPECTED_OMID                                              , _T("Unexpected on-medium identifier."))
      CASE_ERRCODE2(ERROR_CANT_DELETE_LAST_ITEM                                        , _T("The last remaining item in this group or resource cannot be deleted."))
      CASE_ERRCODE2(ERROR_MESSAGE_EXCEEDS_MAX_SIZE                                     , _T("The message provided exceeds the maximum size allowed for this parameter."))
      CASE_ERRCODE2(ERROR_VOLUME_CONTAINS_SYS_FILES                                    , _T("The volume contains system or paging files."))
      CASE_ERRCODE2(ERROR_INDIGENOUS_TYPE                                              , _T("The media type cannot be removed from this library since at least one drive in the library reports it can support this media type."))
      CASE_ERRCODE2(ERROR_NO_SUPPORTING_DRIVES                                         , _T("This offline media cannot be mounted on this system since no enabled drives are present which can be used."))
      CASE_ERRCODE2(ERROR_CLEANER_CARTRIDGE_INSTALLED                                  , _T("A cleaner cartridge is present in the tape library."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_FILE_OFFLINE                                                 , _T("The remote storage service was not able to recall the file."))
      CASE_ERRCODE2(ERROR_REMOTE_STORAGE_NOT_ACTIVE                                    , _T("The remote storage service is not operational at this time."))
      CASE_ERRCODE2(ERROR_REMOTE_STORAGE_MEDIA_ERROR                                   , _T("The remote storage service encountered a media error."))
      CASE_ERRCODE2(ERROR_NOT_A_REPARSE_POINT                                          , _T("The file or directory is not a reparse point."))
      CASE_ERRCODE2(ERROR_REPARSE_ATTRIBUTE_CONFLICT                                   , _T("The reparse point attribute cannot be set because it conflicts with an existing attribute."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_INVALID_REPARSE_DATA                                         , _T("The data present in the reparse point buffer is invalid."))
      CASE_ERRCODE2(ERROR_REPARSE_TAG_INVALID                                          , _T("The tag present in the reparse point buffer is invalid."))
      CASE_ERRCODE2(ERROR_REPARSE_TAG_MISMATCH                                         , _T("There is a mismatch between the tag specified in the request and the tag present in the reparse point."))
      CASE_ERRCODE2(ERROR_VOLUME_NOT_SIS_ENABLED                                       , _T("Single Instance Storage is not available on this volume."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_DEPENDENT_RESOURCE_EXISTS                                    , _T("The cluster resource cannot be moved to another group because other resources are dependent on it."))
      CASE_ERRCODE2(ERROR_DEPENDENCY_NOT_FOUND                                         , _T("The cluster resource dependency cannot be found."))
      CASE_ERRCODE2(ERROR_DEPENDENCY_ALREADY_EXISTS                                    , _T("The cluster resource cannot be made dependent on the specified resource because it is already dependent."))
      CASE_ERRCODE2(ERROR_RESOURCE_NOT_ONLINE                                          , _T("The cluster resource is not online."))
      CASE_ERRCODE2(ERROR_HOST_NODE_NOT_AVAILABLE                                      , _T("A cluster node is not available for this operation."))
      CASE_ERRCODE2(ERROR_RESOURCE_NOT_AVAILABLE                                       , _T("The cluster resource is not available."))
      CASE_ERRCODE2(ERROR_RESOURCE_NOT_FOUND                                           , _T("The cluster resource could not be found."))
      CASE_ERRCODE2(ERROR_SHUTDOWN_CLUSTER                                             , _T("The cluster is being shut down."))
      CASE_ERRCODE2(ERROR_CANT_EVICT_ACTIVE_NODE                                       , _T("A cluster node cannot be evicted from the cluster unless the node is down."))
      CASE_ERRCODE2(ERROR_OBJECT_ALREADY_EXISTS                                        , _T("The object already exists."))
      CASE_ERRCODE2(ERROR_OBJECT_IN_LIST                                               , _T("The object is already in the list."))
      CASE_ERRCODE2(ERROR_GROUP_NOT_AVAILABLE                                          , _T("The cluster group is not available for any new requests."))
      CASE_ERRCODE2(ERROR_GROUP_NOT_FOUND                                              , _T("The cluster group could not be found."))
      CASE_ERRCODE2(ERROR_GROUP_NOT_ONLINE                                             , _T("The operation could not be completed because the cluster group is not online."))
      CASE_ERRCODE2(ERROR_HOST_NODE_NOT_RESOURCE_OWNER                                 , _T("The cluster node is not the owner of the resource."))
      CASE_ERRCODE2(ERROR_HOST_NODE_NOT_GROUP_OWNER                                    , _T("The cluster node is not the owner of the group."))
      CASE_ERRCODE2(ERROR_RESMON_CREATE_FAILED                                         , _T("The cluster resource could not be created in the specified resource monitor."))
      CASE_ERRCODE2(ERROR_RESMON_ONLINE_FAILED                                         , _T("The cluster resource could not be brought online by the resource monitor."))
      CASE_ERRCODE2(ERROR_RESOURCE_ONLINE                                              , _T("The operation could not be completed because the cluster resource is online."))
      CASE_ERRCODE2(ERROR_QUORUM_RESOURCE                                              , _T("The cluster resource could not be deleted or brought offline because it is the quorum resource."))
      CASE_ERRCODE2(ERROR_NOT_QUORUM_CAPABLE                                           , _T("The cluster could not make the specified resource a quorum resource because it is not capable of being a quorum resource."))
      CASE_ERRCODE2(ERROR_CLUSTER_SHUTTING_DOWN                                        , _T("The cluster software is shutting down."))
      CASE_ERRCODE2(ERROR_INVALID_STATE                                                , _T("The group or resource is not in the correct state to perform the requested operation."))
      CASE_ERRCODE2(ERROR_RESOURCE_PROPERTIES_STORED                                   , _T("The properties were stored but not all changes will take effect until the next time the resource is brought online."))
      CASE_ERRCODE2(ERROR_NOT_QUORUM_CLASS                                             , _T("The cluster could not make the specified resource a quorum resource because it does not belong to a shared storage class."))
      CASE_ERRCODE2(ERROR_CORE_RESOURCE                                                , _T("The cluster resource could not be deleted since it is a core resource."))
      CASE_ERRCODE2(ERROR_QUORUM_RESOURCE_ONLINE_FAILED                                , _T("The quorum resource failed to come online."))
      CASE_ERRCODE2(ERROR_QUORUMLOG_OPEN_FAILED                                        , _T("The quorum log could not be created or mounted successfully."))
      CASE_ERRCODE2(ERROR_CLUSTERLOG_CORRUPT                                           , _T("The cluster log is corrupt."))
      CASE_ERRCODE2(ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE                            , _T("The record could not be written to the cluster log since it exceeds the maximum size."))
      CASE_ERRCODE2(ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE                                   , _T("The cluster log exceeds its maximum size."))
      CASE_ERRCODE2(ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND                                , _T("No checkpoint record was found in the cluster log."))
      CASE_ERRCODE2(ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE                                  , _T("The minimum required disk space needed for logging is not available."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_QUORUM_OWNER_ALIVE                                           , _T("The cluster node failed to take control of the quorum resource because the resource is owned by another active node."))
      CASE_ERRCODE2(ERROR_NETWORK_NOT_AVAILABLE                                        , _T("A cluster network is not available for this operation."))
      CASE_ERRCODE2(ERROR_NODE_NOT_AVAILABLE                                           , _T("A cluster node is not available for this operation."))
      CASE_ERRCODE2(ERROR_ALL_NODES_NOT_AVAILABLE                                      , _T("All cluster nodes must be running to perform this operation."))
      CASE_ERRCODE2(ERROR_RESOURCE_FAILED                                              , _T("A cluster resource failed."))
      CASE_ERRCODE2(ERROR_CLUSTER_INVALID_NODE                                         , _T("The cluster node is not valid."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_EXISTS                                          , _T("The cluster node already exists."))
      CASE_ERRCODE2(ERROR_CLUSTER_JOIN_IN_PROGRESS                                     , _T("A node is in the process of joining the cluster."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_NOT_FOUND                                       , _T("The cluster node was not found."))
      CASE_ERRCODE2(ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND                                 , _T("The cluster local node information was not found."))
      CASE_ERRCODE2(ERROR_CLUSTER_NETWORK_EXISTS                                       , _T("The cluster network already exists."))
      CASE_ERRCODE2(ERROR_CLUSTER_NETWORK_NOT_FOUND                                    , _T("The cluster network was not found."))
      CASE_ERRCODE2(ERROR_CLUSTER_NETINTERFACE_EXISTS                                  , _T("The cluster network interface already exists."))
      CASE_ERRCODE2(ERROR_CLUSTER_NETINTERFACE_NOT_FOUND                               , _T("The cluster network interface was not found."))
      CASE_ERRCODE2(ERROR_CLUSTER_INVALID_REQUEST                                      , _T("The cluster request is not valid for this object."))
      CASE_ERRCODE2(ERROR_CLUSTER_INVALID_NETWORK_PROVIDER                             , _T("The cluster network provider is not valid."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_DOWN                                            , _T("The cluster node is down."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_UNREACHABLE                                     , _T("The cluster node is not reachable."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_NOT_MEMBER                                      , _T("The cluster node is not a member of the cluster."))
      CASE_ERRCODE2(ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS                                 , _T("A cluster join operation is not in progress."))
      CASE_ERRCODE2(ERROR_CLUSTER_INVALID_NETWORK                                      , _T("The cluster network is not valid."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_UP                                              , _T("The cluster node is up."))
      CASE_ERRCODE2(ERROR_CLUSTER_IPADDR_IN_USE                                        , _T("The cluster IP address is already in use."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_NOT_PAUSED                                      , _T("The cluster node is not paused."))
      CASE_ERRCODE2(ERROR_CLUSTER_NO_SECURITY_CONTEXT                                  , _T("No cluster security context is available."))
      CASE_ERRCODE2(ERROR_CLUSTER_NETWORK_NOT_INTERNAL                                 , _T("The cluster network is not configured for internal cluster communication."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_ALREADY_UP                                      , _T("The cluster node is already up."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_ALREADY_DOWN                                    , _T("The cluster node is already down."))
      CASE_ERRCODE2(ERROR_CLUSTER_NETWORK_ALREADY_ONLINE                               , _T("The cluster network is already online."))
      CASE_ERRCODE2(ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE                              , _T("The cluster network is already offline."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_ALREADY_MEMBER                                  , _T("The cluster node is already a member of the cluster."))
      CASE_ERRCODE2(ERROR_CLUSTER_LAST_INTERNAL_NETWORK                                , _T("The cluster network is the only one configured for internal cluster communication between two or more active cluster nodes. The internal communication capability cannot be removed from the network."))
      CASE_ERRCODE2(ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS                               , _T("One or more cluster resources depend on the network to provide service to clients. The client access capability cannot be removed from the network."))
      CASE_ERRCODE2(ERROR_INVALID_OPERATION_ON_QUORUM                                  , _T("This operation cannot be performed on the cluster resource as it the quorum resource. You may not bring the quorum resource offline or modify its possible owners list."))
      CASE_ERRCODE2(ERROR_DEPENDENCY_NOT_ALLOWED                                       , _T("The cluster quorum resource is not allowed to have any dependencies."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_PAUSED                                          , _T("The cluster node is paused."))
      CASE_ERRCODE2(ERROR_NODE_CANT_HOST_RESOURCE                                      , _T("The cluster resource cannot be brought online. The owner node cannot run this resource."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_NOT_READY                                       , _T("The cluster node is not ready to perform the requested operation."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_SHUTTING_DOWN                                   , _T("The cluster node is shutting down."))
      CASE_ERRCODE2(ERROR_CLUSTER_JOIN_ABORTED                                         , _T("The cluster join operation was aborted."))
      CASE_ERRCODE2(ERROR_CLUSTER_INCOMPATIBLE_VERSIONS                                , _T("The cluster join operation failed due to incompatible software versions between the joining node and its sponsor."))
      CASE_ERRCODE2(ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED                         , _T("This resource cannot be created because the cluster has reached the limit on the number of resources it can monitor."))
      CASE_ERRCODE2(ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED                                , _T("The system configuration changed during the cluster join or form operation. The join or form operation was aborted."))
      CASE_ERRCODE2(ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND                              , _T("The specified resource type was not found."))
      CASE_ERRCODE2(ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED                                , _T("The specified node does not support a resource of this type. This may be due to version inconsistencies or due to the absence of the resource DLL on this node."))
      CASE_ERRCODE2(ERROR_CLUSTER_RESNAME_NOT_FOUND                                    , _T("The specified resource name is supported by this resource DLL. This may be due to a bad (or changed) name supplied to the resource DLL."))
      CASE_ERRCODE2(ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED                           , _T("No authentication package could be registered with the RPC server."))
      CASE_ERRCODE2(ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST                                , _T("You cannot bring the group online because the owner of the group is not in the preferred list for the group. To change the owner node for the group, move the group."))
      CASE_ERRCODE2(ERROR_CLUSTER_DATABASE_SEQMISMATCH                                 , _T("The join operation failed because the cluster database sequence number has changed or is incompatible with the locker node. This may happen during a join operation if the cluster database was changing during the join."))
      CASE_ERRCODE2(ERROR_RESMON_INVALID_STATE                                         , _T("The resource monitor will not allow the fail operation to be performed while the resource is in its current state. This may happen if the resource is in a pending state."))
      CASE_ERRCODE2(ERROR_CLUSTER_GUM_NOT_LOCKER                                       , _T("A non locker code got a request to reserve the lock for making global updates."))
      CASE_ERRCODE2(ERROR_QUORUM_DISK_NOT_FOUND                                        , _T("The quorum disk could not be located by the cluster service."))
      CASE_ERRCODE2(ERROR_DATABASE_BACKUP_CORRUPT                                      , _T("The backup up cluster database is possibly corrupt."))
      CASE_ERRCODE2(ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT                            , _T("A DFS root already exists in this cluster node."))
      CASE_ERRCODE2(ERROR_RESOURCE_PROPERTY_UNCHANGEABLE                               , _T("An attempt to modify a resource property failed because it conflicts with another existing property."))
      CASE_ERRCODE2(ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE                             , _T("An operation was attempted that is incompatible with the current membership state of the node."))
      CASE_ERRCODE2(ERROR_CLUSTER_QUORUMLOG_NOT_FOUND                                  , _T("The quorum resource does not contain the quorum log."))
      CASE_ERRCODE2(ERROR_CLUSTER_MEMBERSHIP_HALT                                      , _T("The membership engine requested shutdown of the cluster service on this node."))
      CASE_ERRCODE2(ERROR_CLUSTER_INSTANCE_ID_MISMATCH                                 , _T("The join operation failed because the cluster instance ID of the joining node does not match the cluster instance ID of the sponsor node."))
      CASE_ERRCODE2(ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP                             , _T("A matching network for the specified IP address could not be found. Please also specify a subnet mask and a cluster network."))
      CASE_ERRCODE2(ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH                          , _T("The actual data type of the property did not match the expected data type of the property."))
      CASE_ERRCODE2(ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP                                , _T("The cluster node was evicted from the cluster successfully, but the node was not cleaned up. Extended status information explaining why the node was not cleaned up is available."))
      CASE_ERRCODE2(ERROR_CLUSTER_PARAMETER_MISMATCH                                   , _T("Two or more parameter values specified for a resource's properties are in conflict."))
      CASE_ERRCODE2(ERROR_NODE_CANNOT_BE_CLUSTERED                                     , _T("This computer cannot be made a member of a cluster."))
      CASE_ERRCODE2(ERROR_CLUSTER_WRONG_OS_VERSION                                     , _T("This computer cannot be made a member of a cluster because it does not have the correct version of Windows installed."))
      CASE_ERRCODE2(ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME                         , _T("A cluster cannot be created with the specified cluster name because that cluster name is already in use. Specify a different name for the cluster."))
      CASE_ERRCODE2(ERROR_CLUSCFG_ALREADY_COMMITTED                                    , _T("The cluster configuration action has already been committed."))
      CASE_ERRCODE2(ERROR_CLUSCFG_ROLLBACK_FAILED                                      , _T("The cluster configuration action could not be rolled back."))
      CASE_ERRCODE2(ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT                    , _T("The drive letter assigned to a system disk on one node conflicted with the driver letter assigned to a disk on another node."))
      CASE_ERRCODE2(ERROR_CLUSTER_OLD_VERSION                                          , _T("One or more nodes in the cluster are running a version of Windows that does not support this operation."))
      CASE_ERRCODE2(ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME                        , _T("The name of the corresponding computer account doesn't match the Network Name for this resource."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_ENCRYPTION_FAILED                                            , _T("The specified file could not be encrypted."))
      CASE_ERRCODE2(ERROR_DECRYPTION_FAILED                                            , _T("The specified file could not be decrypted."))
      CASE_ERRCODE2(ERROR_FILE_ENCRYPTED                                               , _T("The specified file is encrypted and the user does not have the ability to decrypt it."))
      CASE_ERRCODE2(ERROR_NO_RECOVERY_POLICY                                           , _T("There is no valid encryption recovery policy configured for this system."))
      CASE_ERRCODE2(ERROR_NO_EFS                                                       , _T("The required encryption driver is not loaded for this system."))
      CASE_ERRCODE2(ERROR_WRONG_EFS                                                    , _T("The file was encrypted with a different encryption driver than is currently loaded."))
      CASE_ERRCODE2(ERROR_NO_USER_KEYS                                                 , _T("There are no EFS keys defined for the user."))
      CASE_ERRCODE2(ERROR_FILE_NOT_ENCRYPTED                                           , _T("The specified file is not encrypted."))
      CASE_ERRCODE2(ERROR_NOT_EXPORT_FORMAT                                            , _T("The specified file is not in the defined EFS export format."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_FILE_READ_ONLY                                               , _T("The specified file is read only."))
      CASE_ERRCODE2(ERROR_DIR_EFS_DISALLOWED                                           , _T("The directory has been disabled for encryption."))
      CASE_ERRCODE2(ERROR_EFS_SERVER_NOT_TRUSTED                                       , _T("The server is not trusted for remote encryption operation."))
      CASE_ERRCODE2(ERROR_BAD_RECOVERY_POLICY                                          , _T("Recovery policy configured for this system contains invalid recovery certificate."))
      CASE_ERRCODE2(ERROR_EFS_ALG_BLOB_TOO_BIG                                         , _T("The encryption algorithm used on the source file needs a bigger key buffer than the one on the destination file."))
      CASE_ERRCODE2(ERROR_VOLUME_NOT_SUPPORT_EFS                                       , _T("The disk partition does not support file encryption."))
      CASE_ERRCODE2(ERROR_EFS_DISABLED                                                 , _T("This machine is disabled for file encryption."))
      CASE_ERRCODE2(ERROR_EFS_VERSION_NOT_SUPPORT                                      , _T("A newer system is required to decrypt this encrypted file."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_NO_BROWSER_SERVERS_FOUND                                     , _T("The list of servers for this workgroup is not currently available."))
#ifdef __SDK__
      CASE_ERRCODE2(SCHED_E_SERVICE_NOT_LOCALSYSTEM                                    , _T("The Task Scheduler service must be configured to run in the System account to function properly. Individual tasks may be configured to run in other accounts."))
      CASE_ERRCODE2(ERROR_CTX_WINSTATION_NAME_INVALID                                  , _T("The specified session name is invalid."))
      CASE_ERRCODE2(ERROR_CTX_INVALID_PD                                               , _T("The specified protocol driver is invalid."))
      CASE_ERRCODE2(ERROR_CTX_PD_NOT_FOUND                                             , _T("The specified protocol driver was not found in the system path."))
      CASE_ERRCODE2(ERROR_CTX_WD_NOT_FOUND                                             , _T("The specified terminal connection driver was not found in the system path."))
      CASE_ERRCODE2(ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY                               , _T("A registry key for event logging could not be created for this session."))
      CASE_ERRCODE2(ERROR_CTX_SERVICE_NAME_COLLISION                                   , _T("A service with the same name already exists on the system."))
      CASE_ERRCODE2(ERROR_CTX_CLOSE_PENDING                                            , _T("A close operation is pending on the session."))
      CASE_ERRCODE2(ERROR_CTX_NO_OUTBUF                                                , _T("There are no free output buffers available."))
      CASE_ERRCODE2(ERROR_CTX_MODEM_INF_NOT_FOUND                                      , _T("The MODEM.INF file was not found."))
      CASE_ERRCODE2(ERROR_CTX_INVALID_MODEMNAME                                        , _T("The modem name was not found in MODEM.INF."))
      CASE_ERRCODE2(ERROR_CTX_MODEM_RESPONSE_ERROR                                     , _T("The modem did not accept the command sent to it. Verify that the configured modem name matches the attached modem."))
      CASE_ERRCODE2(ERROR_CTX_MODEM_RESPONSE_TIMEOUT                                   , _T("The modem did not respond to the command sent to it. Verify that the modem is properly cabled and powered on."))
      CASE_ERRCODE2(ERROR_CTX_MODEM_RESPONSE_NO_CARRIER                                , _T("Carrier detect has failed or carrier has been dropped due to disconnect."))
      CASE_ERRCODE2(ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE                               , _T("Dial tone not detected within the required time. Verify that the phone cable is properly attached and functional."))
      CASE_ERRCODE2(ERROR_CTX_MODEM_RESPONSE_BUSY                                      , _T("Busy signal detected at remote site on callback."))
      CASE_ERRCODE2(ERROR_CTX_MODEM_RESPONSE_VOICE                                     , _T("Voice detected at remote site on callback."))
      CASE_ERRCODE2(ERROR_CTX_TD_ERROR                                                 , _T("Transport driver error"))
      CASE_ERRCODE2(ERROR_CTX_WINSTATION_NOT_FOUND                                     , _T("The specified session cannot be found."))
      CASE_ERRCODE2(ERROR_CTX_WINSTATION_ALREADY_EXISTS                                , _T("The specified session name is already in use."))
      CASE_ERRCODE2(ERROR_CTX_WINSTATION_BUSY                                          , _T("The requested operation cannot be completed because the terminal connection is currently busy processing a connect, disconnect, reset, or delete operation."))
      CASE_ERRCODE2(ERROR_CTX_BAD_VIDEO_MODE                                           , _T("An attempt has been made to connect to a session whose video mode is not supported by the current client."))
      CASE_ERRCODE2(ERROR_CTX_GRAPHICS_INVALID                                         , _T("The application attempted to enable DOS graphics mode. DOS graphics mode is not supported."))
      CASE_ERRCODE2(ERROR_CTX_LOGON_DISABLED                                           , _T("Your interactive logon privilege has been disabled. Please contact your administrator."))
      CASE_ERRCODE2(ERROR_CTX_NOT_CONSOLE                                              , _T("The requested operation can be performed only on the system console. This is most often the result of a driver or system DLL requiring direct console access."))
      CASE_ERRCODE2(ERROR_CTX_CLIENT_QUERY_TIMEOUT                                     , _T("The client failed to respond to the server connect message."))
      CASE_ERRCODE2(ERROR_CTX_CONSOLE_DISCONNECT                                       , _T("Disconnecting the console session is not supported."))
      CASE_ERRCODE2(ERROR_CTX_CONSOLE_CONNECT                                          , _T("Reconnecting a disconnected session to the console is not supported."))
      CASE_ERRCODE2(ERROR_CTX_SHADOW_DENIED                                            , _T("The request to control another session remotely was denied."))
      CASE_ERRCODE2(ERROR_CTX_WINSTATION_ACCESS_DENIED                                 , _T("The requested session access is denied."))
      CASE_ERRCODE2(ERROR_CTX_INVALID_WD                                               , _T("The specified terminal connection driver is invalid."))
      CASE_ERRCODE2(ERROR_CTX_SHADOW_INVALID                                           , _T("The requested session cannot be controlled remotely. This may be because the session is disconnected or does not currently have a user logged on."))
      CASE_ERRCODE2(ERROR_CTX_SHADOW_DISABLED                                          , _T("The requested session is not configured to allow remote control."))
      CASE_ERRCODE2(ERROR_CTX_CLIENT_LICENSE_IN_USE                                    , _T("Your request to connect to this Terminal Server has been rejected. Your Terminal Server client license number is currently being used by another user. Please call your system administrator to obtain a unique license number."))
      CASE_ERRCODE2(ERROR_CTX_CLIENT_LICENSE_NOT_SET                                   , _T("Your request to connect to this Terminal Server has been rejected. Your Terminal Server client license number has not been entered for this copy of the Terminal Server client. Please contact your system administrator."))
      CASE_ERRCODE2(ERROR_CTX_LICENSE_NOT_AVAILABLE                                    , _T("The system has reached its licensed logon limit. Please try again later."))
      CASE_ERRCODE2(ERROR_CTX_LICENSE_CLIENT_INVALID                                   , _T("The client you are using is not licensed to use this system. Your logon request is denied."))
      CASE_ERRCODE2(ERROR_CTX_LICENSE_EXPIRED                                          , _T("The system license has expired. Your logon request is denied."))
      CASE_ERRCODE2(ERROR_CTX_SHADOW_NOT_RUNNING                                       , _T("Remote control could not be terminated because the specified session is not currently being remotely controlled."))
      CASE_ERRCODE2(ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE                              , _T("The remote control of the console was terminated because the display mode was changed. Changing the display mode in a remote control session is not supported."))
      CASE_ERRCODE2(ERROR_ACTIVATION_COUNT_EXCEEDED                                    , _T("Activation has already been reset the maximum number of times for this installation. Your activation timer will not be cleared."))
      CASE_ERRCODE2(FRS_ERR_INVALID_API_SEQUENCE                                       , _T("The file replication service API was called incorrectly."))
      CASE_ERRCODE2(FRS_ERR_STARTING_SERVICE                                           , _T("The file replication service cannot be started."))
      CASE_ERRCODE2(FRS_ERR_STOPPING_SERVICE                                           , _T("The file replication service cannot be stopped."))
      CASE_ERRCODE2(FRS_ERR_INTERNAL_API                                               , _T("The file replication service API terminated the request. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_INTERNAL                                                   , _T("The file replication service terminated the request. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_SERVICE_COMM                                               , _T("The file replication service cannot be contacted. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_INSUFFICIENT_PRIV                                          , _T("The file replication service cannot satisfy the request because the user has insufficient privileges. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_AUTHENTICATION                                             , _T("The file replication service cannot satisfy the request because authenticated RPC is not available. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_PARENT_INSUFFICIENT_PRIV                                   , _T("The file replication service cannot satisfy the request because the user has insufficient privileges on the domain controller. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_PARENT_AUTHENTICATION                                      , _T("The file replication service cannot satisfy the request because authenticated RPC is not available on the domain controller. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_CHILD_TO_PARENT_COMM                                       , _T("The file replication service cannot communicate with the file replication service on the domain controller. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_PARENT_TO_CHILD_COMM                                       , _T("The file replication service on the domain controller cannot communicate with the file replication service on this computer. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_SYSVOL_POPULATE                                            , _T("The file replication service cannot populate the system volume because of an internal error. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_SYSVOL_POPULATE_TIMEOUT                                    , _T("The file replication service cannot populate the system volume because of an internal timeout. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_SYSVOL_IS_BUSY                                             , _T("The file replication service cannot process the request. The system volume is busy with a previous request."))
      CASE_ERRCODE2(FRS_ERR_SYSVOL_DEMOTE                                              , _T("The file replication service cannot stop replicating the system volume because of an internal error. The event log may have more information."))
      CASE_ERRCODE2(FRS_ERR_INVALID_SERVICE_PARAMETER                                  , _T("The file replication service detected an invalid parameter."))
#endif // __SDK__
      CASE_ERRCODE2(ERROR_DS_NOT_INSTALLED                                             , _T("An error occurred while installing the directory service. For more information, see the event log."))
      CASE_ERRCODE2(ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY                              , _T("The directory service evaluated group memberships locally."))
      CASE_ERRCODE2(ERROR_DS_NO_ATTRIBUTE_OR_VALUE                                     , _T("The specified directory service attribute or value does not exist."))
      CASE_ERRCODE2(ERROR_DS_INVALID_ATTRIBUTE_SYNTAX                                  , _T("The attribute syntax specified to the directory service is invalid."))
      CASE_ERRCODE2(ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED                                  , _T("The attribute type specified to the directory service is not defined."))
      CASE_ERRCODE2(ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS                                 , _T("The specified directory service attribute or value already exists."))
      CASE_ERRCODE2(ERROR_DS_BUSY                                                      , _T("The directory service is busy."))
      CASE_ERRCODE2(ERROR_DS_UNAVAILABLE                                               , _T("The directory service is unavailable."))
      CASE_ERRCODE2(ERROR_DS_NO_RIDS_ALLOCATED                                         , _T("The directory service was unable to allocate a relative identifier."))
      CASE_ERRCODE2(ERROR_DS_NO_MORE_RIDS                                              , _T("The directory service has exhausted the pool of relative identifiers."))
      CASE_ERRCODE2(ERROR_DS_INCORRECT_ROLE_OWNER                                      , _T("The requested operation could not be performed because the directory service is not the master for that type of operation."))
      CASE_ERRCODE2(ERROR_DS_RIDMGR_INIT_ERROR                                         , _T("The directory service was unable to initialize the subsystem that allocates relative identifiers."))
      CASE_ERRCODE2(ERROR_DS_OBJ_CLASS_VIOLATION                                       , _T("The requested operation did not satisfy one or more constraints associated with the class of the object."))
      CASE_ERRCODE2(ERROR_DS_CANT_ON_NON_LEAF                                          , _T("The directory service can perform the requested operation only on a leaf object."))
      CASE_ERRCODE2(ERROR_DS_CANT_ON_RDN                                               , _T("The directory service cannot perform the requested operation on the RDN attribute of an object."))
      CASE_ERRCODE2(ERROR_DS_CANT_MOD_OBJ_CLASS                                        , _T("The directory service detected an attempt to modify the object class of an object."))
      CASE_ERRCODE2(ERROR_DS_CROSS_DOM_MOVE_ERROR                                      , _T("The requested cross-domain move operation could not be performed."))
      CASE_ERRCODE2(ERROR_DS_GC_NOT_AVAILABLE                                          , _T("Unable to contact the global catalog server."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_SHARED_POLICY                                                , _T("The policy object is shared and can only be modified at the root."))
      CASE_ERRCODE2(ERROR_POLICY_OBJECT_NOT_FOUND                                      , _T("The policy object does not exist."))
      CASE_ERRCODE2(ERROR_POLICY_ONLY_IN_DS                                            , _T("The requested policy information is only in the directory service."))
      CASE_ERRCODE2(ERROR_PROMOTION_ACTIVE                                             , _T("A domain controller promotion is currently active."))
      CASE_ERRCODE2(ERROR_NO_PROMOTION_ACTIVE                                          , _T("A domain controller promotion is not currently active"))
      CASE_ERRCODE2(ERROR_DS_OPERATIONS_ERROR                                          , _T("An operations error occurred."))
      CASE_ERRCODE2(ERROR_DS_PROTOCOL_ERROR                                            , _T("A protocol error occurred."))
      CASE_ERRCODE2(ERROR_DS_TIMELIMIT_EXCEEDED                                        , _T("The time limit for this request was exceeded."))
      CASE_ERRCODE2(ERROR_DS_SIZELIMIT_EXCEEDED                                        , _T("The size limit for this request was exceeded."))
      CASE_ERRCODE2(ERROR_DS_ADMIN_LIMIT_EXCEEDED                                      , _T("The administrative limit for this request was exceeded."))
      CASE_ERRCODE2(ERROR_DS_COMPARE_FALSE                                             , _T("The compare response was false."))
      CASE_ERRCODE2(ERROR_DS_COMPARE_TRUE                                              , _T("The compare response was true."))
      CASE_ERRCODE2(ERROR_DS_AUTH_METHOD_NOT_SUPPORTED                                 , _T("The requested authentication method is not supported by the server."))
      CASE_ERRCODE2(ERROR_DS_STRONG_AUTH_REQUIRED                                      , _T("A more secure authentication method is required for this server."))
      CASE_ERRCODE2(ERROR_DS_INAPPROPRIATE_AUTH                                        , _T("Inappropriate authentication."))
      CASE_ERRCODE2(ERROR_DS_AUTH_UNKNOWN                                              , _T("The authentication mechanism is unknown."))
      CASE_ERRCODE2(ERROR_DS_REFERRAL                                                  , _T("A referral was returned from the server."))
      CASE_ERRCODE2(ERROR_DS_UNAVAILABLE_CRIT_EXTENSION                                , _T("The server does not support the requested critical extension."))
      CASE_ERRCODE2(ERROR_DS_CONFIDENTIALITY_REQUIRED                                  , _T("This request requires a secure connection."))
      CASE_ERRCODE2(ERROR_DS_INAPPROPRIATE_MATCHING                                    , _T("Inappropriate matching."))
      CASE_ERRCODE2(ERROR_DS_CONSTRAINT_VIOLATION                                      , _T("A constraint violation occurred."))
      CASE_ERRCODE2(ERROR_DS_NO_SUCH_OBJECT                                            , _T("There is no such object on the server."))
      CASE_ERRCODE2(ERROR_DS_ALIAS_PROBLEM                                             , _T("There is an alias problem."))
      CASE_ERRCODE2(ERROR_DS_INVALID_DN_SYNTAX                                         , _T("An invalid dn syntax has been specified."))
      CASE_ERRCODE2(ERROR_DS_IS_LEAF                                                   , _T("The object is a leaf object."))
      CASE_ERRCODE2(ERROR_DS_ALIAS_DEREF_PROBLEM                                       , _T("There is an alias dereferencing problem."))
      CASE_ERRCODE2(ERROR_DS_UNWILLING_TO_PERFORM                                      , _T("The server is unwilling to process the request."))
      CASE_ERRCODE2(ERROR_DS_LOOP_DETECT                                               , _T("A loop has been detected."))
      CASE_ERRCODE2(ERROR_DS_NAMING_VIOLATION                                          , _T("There is a naming violation."))
      CASE_ERRCODE2(ERROR_DS_OBJECT_RESULTS_TOO_LARGE                                  , _T("The result set is too large."))
      CASE_ERRCODE2(ERROR_DS_AFFECTS_MULTIPLE_DSAS                                     , _T("The operation affects multiple DSAs"))
      CASE_ERRCODE2(ERROR_DS_SERVER_DOWN                                               , _T("The server is not operational."))
      CASE_ERRCODE2(ERROR_DS_LOCAL_ERROR                                               , _T("A local error has occurred."))
      CASE_ERRCODE2(ERROR_DS_ENCODING_ERROR                                            , _T("An encoding error has occurred."))
      CASE_ERRCODE2(ERROR_DS_DECODING_ERROR                                            , _T("A decoding error has occurred."))
      CASE_ERRCODE2(ERROR_DS_FILTER_UNKNOWN                                            , _T("The search filter cannot be recognized."))
      CASE_ERRCODE2(ERROR_DS_PARAM_ERROR                                               , _T("One or more parameters are illegal."))
      CASE_ERRCODE2(ERROR_DS_NOT_SUPPORTED                                             , _T("The specified method is not supported."))
      CASE_ERRCODE2(ERROR_DS_NO_RESULTS_RETURNED                                       , _T("No results were returned."))
      CASE_ERRCODE2(ERROR_DS_CONTROL_NOT_FOUND                                         , _T("The specified control is not supported by the server."))
      CASE_ERRCODE2(ERROR_DS_CLIENT_LOOP                                               , _T("A referral loop was detected by the client."))
      CASE_ERRCODE2(ERROR_DS_REFERRAL_LIMIT_EXCEEDED                                   , _T("The preset referral limit was exceeded."))
      CASE_ERRCODE2(ERROR_DS_SORT_CONTROL_MISSING                                      , _T("The search requires a SORT control."))
      CASE_ERRCODE2(ERROR_DS_OFFSET_RANGE_ERROR                                        , _T("The search results exceed the offset range specified."))
      CASE_ERRCODE2(ERROR_DS_ROOT_MUST_BE_NC                                           , _T("The root object must be the head of a naming context. The root object cannot have an instantiated parent."))
      CASE_ERRCODE2(ERROR_DS_ADD_REPLICA_INHIBITED                                     , _T("The add replica operation cannot be performed. The naming context must be writeable in order to create the replica."))
      CASE_ERRCODE2(ERROR_DS_ATT_NOT_DEF_IN_SCHEMA                                     , _T("A reference to an attribute that is not defined in the schema occurred."))
      CASE_ERRCODE2(ERROR_DS_MAX_OBJ_SIZE_EXCEEDED                                     , _T("The maximum size of an object has been exceeded."))
      CASE_ERRCODE2(ERROR_DS_OBJ_STRING_NAME_EXISTS                                    , _T("An attempt was made to add an object to the directory with a name that is already in use."))
      CASE_ERRCODE2(ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA                                  , _T("An attempt was made to add an object of a class that does not have an RDN defined in the schema."))
      CASE_ERRCODE2(ERROR_DS_RDN_DOESNT_MATCH_SCHEMA                                   , _T("An attempt was made to add an object using an RDN that is not the RDN defined in the schema."))
      CASE_ERRCODE2(ERROR_DS_NO_REQUESTED_ATTS_FOUND                                   , _T("None of the requested attributes were found on the objects."))
      CASE_ERRCODE2(ERROR_DS_USER_BUFFER_TO_SMALL                                      , _T("The user buffer is too small."))
      CASE_ERRCODE2(ERROR_DS_ATT_IS_NOT_ON_OBJ                                         , _T("The attribute specified in the operation is not present on the object."))
      CASE_ERRCODE2(ERROR_DS_ILLEGAL_MOD_OPERATION                                     , _T("Illegal modify operation. Some aspect of the modification is not permitted."))
      CASE_ERRCODE2(ERROR_DS_OBJ_TOO_LARGE                                             , _T("The specified object is too large."))
      CASE_ERRCODE2(ERROR_DS_BAD_INSTANCE_TYPE                                         , _T("The specified instance type is not valid."))
      CASE_ERRCODE2(ERROR_DS_MASTERDSA_REQUIRED                                        , _T("The operation must be performed at a master DSA."))
      CASE_ERRCODE2(ERROR_DS_OBJECT_CLASS_REQUIRED                                     , _T("The object class attribute must be specified."))
      CASE_ERRCODE2(ERROR_DS_MISSING_REQUIRED_ATT                                      , _T("A required attribute is missing."))
      CASE_ERRCODE2(ERROR_DS_ATT_NOT_DEF_FOR_CLASS                                     , _T("An attempt was made to modify an object to include an attribute that is not legal for its class"))
      CASE_ERRCODE2(ERROR_DS_ATT_ALREADY_EXISTS                                        , _T("The specified attribute is already present on the object."))
      CASE_ERRCODE2(ERROR_DS_CANT_ADD_ATT_VALUES                                       , _T("The specified attribute is not present, or has no values."))
      CASE_ERRCODE2(ERROR_DS_SINGLE_VALUE_CONSTRAINT                                   , _T("Multiple values were specified for an attribute that can have only one value."))
      CASE_ERRCODE2(ERROR_DS_RANGE_CONSTRAINT                                          , _T("A value for the attribute was not in the acceptable range of values."))
      CASE_ERRCODE2(ERROR_DS_ATT_VAL_ALREADY_EXISTS                                    , _T("The specified value already exists."))
      CASE_ERRCODE2(ERROR_DS_CANT_REM_MISSING_ATT                                      , _T("The attribute cannot be removed because it is not present on the object."))
      CASE_ERRCODE2(ERROR_DS_CANT_REM_MISSING_ATT_VAL                                  , _T("The attribute value cannot be removed because it is not present on the object."))
      CASE_ERRCODE2(ERROR_DS_ROOT_CANT_BE_SUBREF                                       , _T("The specified root object cannot be a subref."))
      CASE_ERRCODE2(ERROR_DS_NO_CHAINING                                               , _T("Chaining is not permitted."))
      CASE_ERRCODE2(ERROR_DS_NO_CHAINED_EVAL                                           , _T("Chained evaluation is not permitted."))
      CASE_ERRCODE2(ERROR_DS_NO_PARENT_OBJECT                                          , _T("The operation could not be performed because the object's parent is either uninstantiated or deleted."))
      CASE_ERRCODE2(ERROR_DS_PARENT_IS_AN_ALIAS                                        , _T("Having a parent that is an alias is not permitted. Aliases are leaf objects."))
      CASE_ERRCODE2(ERROR_DS_CANT_MIX_MASTER_AND_REPS                                  , _T("The object and parent must be of the same type, either both masters or both replicas."))
      CASE_ERRCODE2(ERROR_DS_CHILDREN_EXIST                                            , _T("The operation cannot be performed because child objects exist. This operation can only be performed on a leaf object."))
      CASE_ERRCODE2(ERROR_DS_OBJ_NOT_FOUND                                             , _T("Directory object not found."))
      CASE_ERRCODE2(ERROR_DS_ALIASED_OBJ_MISSING                                       , _T("The aliased object is missing."))
      CASE_ERRCODE2(ERROR_DS_BAD_NAME_SYNTAX                                           , _T("The object name has bad syntax."))
      CASE_ERRCODE2(ERROR_DS_ALIAS_POINTS_TO_ALIAS                                     , _T("It is not permitted for an alias to refer to another alias."))
      CASE_ERRCODE2(ERROR_DS_CANT_DEREF_ALIAS                                          , _T("The alias cannot be dereferenced."))
      CASE_ERRCODE2(ERROR_DS_OUT_OF_SCOPE                                              , _T("The operation is out of scope."))
      CASE_ERRCODE2(ERROR_DS_OBJECT_BEING_REMOVED                                      , _T("The operation cannot continue because the object is in the process of being removed."))
      CASE_ERRCODE2(ERROR_DS_CANT_DELETE_DSA_OBJ                                       , _T("The DSA object cannot be deleted."))
      CASE_ERRCODE2(ERROR_DS_GENERIC_ERROR                                             , _T("A directory service error has occurred."))
      CASE_ERRCODE2(ERROR_DS_DSA_MUST_BE_INT_MASTER                                    , _T("The operation can only be performed on an internal master DSA object."))
      CASE_ERRCODE2(ERROR_DS_CLASS_NOT_DSA                                             , _T("The object must be of class DSA."))
      CASE_ERRCODE2(ERROR_DS_INSUFF_ACCESS_RIGHTS                                      , _T("Insufficient access rights to perform the operation."))
      CASE_ERRCODE2(ERROR_DS_ILLEGAL_SUPERIOR                                          , _T("The object cannot be added because the parent is not on the list of possible superiors."))
      CASE_ERRCODE2(ERROR_DS_ATTRIBUTE_OWNED_BY_SAM                                    , _T("Access to the attribute is not permitted because the attribute is owned by the Security Accounts Manager (SAM)."))
      CASE_ERRCODE2(ERROR_DS_NAME_TOO_MANY_PARTS                                       , _T("The name has too many parts."))
      CASE_ERRCODE2(ERROR_DS_NAME_TOO_LONG                                             , _T("The name is too long."))
      CASE_ERRCODE2(ERROR_DS_NAME_VALUE_TOO_LONG                                       , _T("The name value is too long."))
      CASE_ERRCODE2(ERROR_DS_NAME_UNPARSEABLE                                          , _T("The directory service encountered an error parsing a name."))
      CASE_ERRCODE2(ERROR_DS_NAME_TYPE_UNKNOWN                                         , _T("The directory service cannot get the attribute type for a name."))
      CASE_ERRCODE2(ERROR_DS_NOT_AN_OBJECT                                             , _T("The name does not identify an object; the name identifies a phantom."))
      CASE_ERRCODE2(ERROR_DS_SEC_DESC_TOO_SHORT                                        , _T("The security descriptor is too short."))
      CASE_ERRCODE2(ERROR_DS_SEC_DESC_INVALID                                          , _T("The security descriptor is invalid."))
      CASE_ERRCODE2(ERROR_DS_NO_DELETED_NAME                                           , _T("Failed to create name for deleted object."))
      CASE_ERRCODE2(ERROR_DS_SUBREF_MUST_HAVE_PARENT                                   , _T("The parent of a new subref must exist."))
      CASE_ERRCODE2(ERROR_DS_NCNAME_MUST_BE_NC                                         , _T("The object must be a naming context."))
      CASE_ERRCODE2(ERROR_DS_CANT_ADD_SYSTEM_ONLY                                      , _T("It is not permitted to add an attribute which is owned by the system."))
      CASE_ERRCODE2(ERROR_DS_CLASS_MUST_BE_CONCRETE                                    , _T("The class of the object must be structural; you cannot instantiate an abstract class."))
      CASE_ERRCODE2(ERROR_DS_INVALID_DMD                                               , _T("The schema object could not be found."))
      CASE_ERRCODE2(ERROR_DS_OBJ_GUID_EXISTS                                           , _T("A local object with this GUID (dead or alive) already exists."))
      CASE_ERRCODE2(ERROR_DS_NOT_ON_BACKLINK                                           , _T("The operation cannot be performed on a back link."))
      CASE_ERRCODE2(ERROR_DS_NO_CROSSREF_FOR_NC                                        , _T("The cross reference for the specified naming context could not be found."))
      CASE_ERRCODE2(ERROR_DS_SHUTTING_DOWN                                             , _T("The operation could not be performed because the directory service is shutting down."))
      CASE_ERRCODE2(ERROR_DS_UNKNOWN_OPERATION                                         , _T("The directory service request is invalid."))
      CASE_ERRCODE2(ERROR_DS_INVALID_ROLE_OWNER                                        , _T("The role owner attribute could not be read."))
      CASE_ERRCODE2(ERROR_DS_COULDNT_CONTACT_FSMO                                      , _T("The requested FSMO operation failed. The current FSMO holder could not be reached."))
      CASE_ERRCODE2(ERROR_DS_CROSS_NC_DN_RENAME                                        , _T("Modification of a DN across a naming context is not permitted."))
      CASE_ERRCODE2(ERROR_DS_CANT_MOD_SYSTEM_ONLY                                      , _T("The attribute cannot be modified because it is owned by the system."))
      CASE_ERRCODE2(ERROR_DS_REPLICATOR_ONLY                                           , _T("Only the replicator can perform this function."))
      CASE_ERRCODE2(ERROR_DS_OBJ_CLASS_NOT_DEFINED                                     , _T("The specified class is not defined."))
      CASE_ERRCODE2(ERROR_DS_OBJ_CLASS_NOT_SUBCLASS                                    , _T("The specified class is not a subclass."))
      CASE_ERRCODE2(ERROR_DS_NAME_REFERENCE_INVALID                                    , _T("The name reference is invalid."))
      CASE_ERRCODE2(ERROR_DS_CROSS_REF_EXISTS                                          , _T("A cross reference already exists."))
      CASE_ERRCODE2(ERROR_DS_CANT_DEL_MASTER_CROSSREF                                  , _T("It is not permitted to delete a master cross reference."))
      CASE_ERRCODE2(ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD                                , _T("Subtree notifications are only supported on NC heads."))
      CASE_ERRCODE2(ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX                                 , _T("Notification filter is too complex."))
      CASE_ERRCODE2(ERROR_DS_DUP_RDN                                                   , _T("Schema update failed: duplicate RDN."))
      CASE_ERRCODE2(ERROR_DS_DUP_OID                                                   , _T("Schema update failed: duplicate OID"))
      CASE_ERRCODE2(ERROR_DS_DUP_MAPI_ID                                               , _T("Schema update failed: duplicate MAPI identifier."))
      CASE_ERRCODE2(ERROR_DS_DUP_SCHEMA_ID_GUID                                        , _T("Schema update failed: duplicate schema-id GUID."))
      CASE_ERRCODE2(ERROR_DS_DUP_LDAP_DISPLAY_NAME                                     , _T("Schema update failed: duplicate LDAP display name."))
      CASE_ERRCODE2(ERROR_DS_SEMANTIC_ATT_TEST                                         , _T("Schema update failed: range-lower less than range upper"))
      CASE_ERRCODE2(ERROR_DS_SYNTAX_MISMATCH                                           , _T("Schema update failed: syntax mismatch"))
      CASE_ERRCODE2(ERROR_DS_EXISTS_IN_MUST_HAVE                                       , _T("Schema deletion failed: attribute is used in must-contain"))
      CASE_ERRCODE2(ERROR_DS_EXISTS_IN_MAY_HAVE                                        , _T("Schema deletion failed: attribute is used in may-contain"))
      CASE_ERRCODE2(ERROR_DS_NONEXISTENT_MAY_HAVE                                      , _T("Schema update failed: attribute in may-contain does not exist"))
      CASE_ERRCODE2(ERROR_DS_NONEXISTENT_MUST_HAVE                                     , _T("Schema update failed: attribute in must-contain does not exist"))
      CASE_ERRCODE2(ERROR_DS_AUX_CLS_TEST_FAIL                                         , _T("Schema update failed: class in aux-class list does not exist or is not an auxiliary class"))
      CASE_ERRCODE2(ERROR_DS_NONEXISTENT_POSS_SUP                                      , _T("Schema update failed: class in poss-superiors does not exist"))
      CASE_ERRCODE2(ERROR_DS_SUB_CLS_TEST_FAIL                                         , _T("Schema update failed: class in subclassof list does not exist or does not satisfy hierarchy rules"))
      CASE_ERRCODE2(ERROR_DS_BAD_RDN_ATT_ID_SYNTAX                                     , _T("Schema update failed: Rdn-Att-Id has wrong syntax"))
      CASE_ERRCODE2(ERROR_DS_EXISTS_IN_AUX_CLS                                         , _T("Schema deletion failed: class is used as auxiliary class"))
      CASE_ERRCODE2(ERROR_DS_EXISTS_IN_SUB_CLS                                         , _T("Schema deletion failed: class is used as sub class"))
      CASE_ERRCODE2(ERROR_DS_EXISTS_IN_POSS_SUP                                        , _T("Schema deletion failed: class is used as poss superior"))
      CASE_ERRCODE2(ERROR_DS_RECALCSCHEMA_FAILED                                       , _T("Schema update failed in recalculating validation cache."))
      CASE_ERRCODE2(ERROR_DS_TREE_DELETE_NOT_FINISHED                                  , _T("The tree deletion is not finished."))
      CASE_ERRCODE2(ERROR_DS_CANT_DELETE                                               , _T("The requested delete operation could not be performed."))
      CASE_ERRCODE2(ERROR_DS_ATT_SCHEMA_REQ_ID                                         , _T("Cannot read the governs class identifier for the schema record."))
      CASE_ERRCODE2(ERROR_DS_BAD_ATT_SCHEMA_SYNTAX                                     , _T("The attribute schema has bad syntax."))
      CASE_ERRCODE2(ERROR_DS_CANT_CACHE_ATT                                            , _T("The attribute could not be cached."))
      CASE_ERRCODE2(ERROR_DS_CANT_CACHE_CLASS                                          , _T("The class could not be cached."))
      CASE_ERRCODE2(ERROR_DS_CANT_REMOVE_ATT_CACHE                                     , _T("The attribute could not be removed from the cache."))
      CASE_ERRCODE2(ERROR_DS_CANT_REMOVE_CLASS_CACHE                                   , _T("The class could not be removed from the cache."))
      CASE_ERRCODE2(ERROR_DS_CANT_RETRIEVE_DN                                          , _T("The distinguished name attribute could not be read."))
      CASE_ERRCODE2(ERROR_DS_MISSING_SUPREF                                            , _T("No superior reference has been configured for the directory service. The directory service is therefore unable to issue referrals to objects outside this forest."))
      CASE_ERRCODE2(ERROR_DS_CANT_RETRIEVE_INSTANCE                                    , _T("The instance type attribute could not be retrieved."))
      CASE_ERRCODE2(ERROR_DS_CODE_INCONSISTENCY                                        , _T("An internal error has occurred."))
      CASE_ERRCODE2(ERROR_DS_DATABASE_ERROR                                            , _T("A database error has occurred."))
      CASE_ERRCODE2(ERROR_DS_GOVERNSID_MISSING                                         , _T("The attribute GOVERNSID is missing."))
      CASE_ERRCODE2(ERROR_DS_MISSING_EXPECTED_ATT                                      , _T("An expected attribute is missing."))
      CASE_ERRCODE2(ERROR_DS_NCNAME_MISSING_CR_REF                                     , _T("The specified naming context is missing a cross reference."))
      CASE_ERRCODE2(ERROR_DS_SECURITY_CHECKING_ERROR                                   , _T("A security checking error has occurred."))
      CASE_ERRCODE2(ERROR_DS_SCHEMA_NOT_LOADED                                         , _T("The schema is not loaded."))
      CASE_ERRCODE2(ERROR_DS_SCHEMA_ALLOC_FAILED                                       , _T("Schema allocation failed. Please check if the machine is running low on memory."))
      CASE_ERRCODE2(ERROR_DS_ATT_SCHEMA_REQ_SYNTAX                                     , _T("Failed to obtain the required syntax for the attribute schema."))
      CASE_ERRCODE2(ERROR_DS_GCVERIFY_ERROR                                            , _T("The global catalog verification failed. The global catalog is not available or does not support the operation. Some part of the directory is currently not available."))
      CASE_ERRCODE2(ERROR_DS_DRA_SCHEMA_MISMATCH                                       , _T("The replication operation failed because of a schema mismatch between the servers involved."))
      CASE_ERRCODE2(ERROR_DS_CANT_FIND_DSA_OBJ                                         , _T("The DSA object could not be found."))
      CASE_ERRCODE2(ERROR_DS_CANT_FIND_EXPECTED_NC                                     , _T("The naming context could not be found."))
      CASE_ERRCODE2(ERROR_DS_CANT_FIND_NC_IN_CACHE                                     , _T("The naming context could not be found in the cache."))
      CASE_ERRCODE2(ERROR_DS_CANT_RETRIEVE_CHILD                                       , _T("The child object could not be retrieved."))
      CASE_ERRCODE2(ERROR_DS_SECURITY_ILLEGAL_MODIFY                                   , _T("The modification was not permitted for security reasons."))
      CASE_ERRCODE2(ERROR_DS_CANT_REPLACE_HIDDEN_REC                                   , _T("The operation cannot replace the hidden record."))
      CASE_ERRCODE2(ERROR_DS_BAD_HIERARCHY_FILE                                        , _T("The hierarchy file is invalid."))
      CASE_ERRCODE2(ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED                              , _T("The attempt to build the hierarchy table failed."))
      CASE_ERRCODE2(ERROR_DS_CONFIG_PARAM_MISSING                                      , _T("The directory configuration parameter is missing from the registry."))
      CASE_ERRCODE2(ERROR_DS_COUNTING_AB_INDICES_FAILED                                , _T("The attempt to count the address book indices failed."))
      CASE_ERRCODE2(ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED                             , _T("The allocation of the hierarchy table failed."))
      CASE_ERRCODE2(ERROR_DS_INTERNAL_FAILURE                                          , _T("The directory service encountered an internal failure."))
      CASE_ERRCODE2(ERROR_DS_UNKNOWN_ERROR                                             , _T("The directory service encountered an unknown failure."))
      CASE_ERRCODE2(ERROR_DS_ROOT_REQUIRES_CLASS_TOP                                   , _T("A root object requires a class of 'top'."))
      CASE_ERRCODE2(ERROR_DS_REFUSING_FSMO_ROLES                                       , _T("This directory server is shutting down, and cannot take ownership of new floating single-master operation roles."))
      CASE_ERRCODE2(ERROR_DS_MISSING_FSMO_SETTINGS                                     , _T("The directory service is missing mandatory configuration information, and is unable to determine the ownership of floating single-master operation roles."))
      CASE_ERRCODE2(ERROR_DS_UNABLE_TO_SURRENDER_ROLES                                 , _T("The directory service was unable to transfer ownership of one or more floating single-master operation roles to other servers."))
      CASE_ERRCODE2(ERROR_DS_DRA_GENERIC                                               , _T("The replication operation failed."))
      CASE_ERRCODE2(ERROR_DS_DRA_INVALID_PARAMETER                                     , _T("An invalid parameter was specified for this replication operation."))
      CASE_ERRCODE2(ERROR_DS_DRA_BUSY                                                  , _T("The directory service is too busy to complete the replication operation at this time."))
      CASE_ERRCODE2(ERROR_DS_DRA_BAD_DN                                                , _T("The distinguished name specified for this replication operation is invalid."))
      CASE_ERRCODE2(ERROR_DS_DRA_BAD_NC                                                , _T("The naming context specified for this replication operation is invalid."))
      CASE_ERRCODE2(ERROR_DS_DRA_DN_EXISTS                                             , _T("The distinguished name specified for this replication operation already exists."))
      CASE_ERRCODE2(ERROR_DS_DRA_INTERNAL_ERROR                                        , _T("The replication system encountered an internal error."))
      CASE_ERRCODE2(ERROR_DS_DRA_INCONSISTENT_DIT                                      , _T("The replication operation encountered a database inconsistency."))
      CASE_ERRCODE2(ERROR_DS_DRA_CONNECTION_FAILED                                     , _T("The server specified for this replication operation could not be contacted."))
      CASE_ERRCODE2(ERROR_DS_DRA_BAD_INSTANCE_TYPE                                     , _T("The replication operation encountered an object with an invalid instance type."))
      CASE_ERRCODE2(ERROR_DS_DRA_OUT_OF_MEM                                            , _T("The replication operation failed to allocate memory."))
      CASE_ERRCODE2(ERROR_DS_DRA_MAIL_PROBLEM                                          , _T("The replication operation encountered an error with the mail system."))
      CASE_ERRCODE2(ERROR_DS_DRA_REF_ALREADY_EXISTS                                    , _T("The replication reference information for the target server already exists."))
      CASE_ERRCODE2(ERROR_DS_DRA_REF_NOT_FOUND                                         , _T("The replication reference information for the target server does not exist."))
      CASE_ERRCODE2(ERROR_DS_DRA_OBJ_IS_REP_SOURCE                                     , _T("The naming context cannot be removed because it is replicated to another server."))
      CASE_ERRCODE2(ERROR_DS_DRA_DB_ERROR                                              , _T("The replication operation encountered a database error."))
      CASE_ERRCODE2(ERROR_DS_DRA_NO_REPLICA                                            , _T("The naming context is in the process of being removed or is not replicated from the specified server."))
      CASE_ERRCODE2(ERROR_DS_DRA_ACCESS_DENIED                                         , _T("Replication access was denied."))
      CASE_ERRCODE2(ERROR_DS_DRA_NOT_SUPPORTED                                         , _T("The requested operation is not supported by this version of the directory service."))
      CASE_ERRCODE2(ERROR_DS_DRA_RPC_CANCELLED                                         , _T("The replication remote procedure call was cancelled."))
      CASE_ERRCODE2(ERROR_DS_DRA_SOURCE_DISABLED                                       , _T("The source server is currently rejecting replication requests."))
      CASE_ERRCODE2(ERROR_DS_DRA_SINK_DISABLED                                         , _T("The destination server is currently rejecting replication requests."))
      CASE_ERRCODE2(ERROR_DS_DRA_NAME_COLLISION                                        , _T("The replication operation failed due to a collision of object names."))
      CASE_ERRCODE2(ERROR_DS_DRA_SOURCE_REINSTALLED                                    , _T("The replication source has been reinstalled."))
      CASE_ERRCODE2(ERROR_DS_DRA_MISSING_PARENT                                        , _T("The replication operation failed because a required parent object is missing."))
      CASE_ERRCODE2(ERROR_DS_DRA_PREEMPTED                                             , _T("The replication operation was preempted."))
      CASE_ERRCODE2(ERROR_DS_DRA_ABANDON_SYNC                                          , _T("The replication synchronization attempt was abandoned because of a lack of updates."))
      CASE_ERRCODE2(ERROR_DS_DRA_SHUTDOWN                                              , _T("The replication operation was terminated because the system is shutting down."))
      CASE_ERRCODE2(ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET                              , _T("The replication synchronization attempt failed as the destination partial attribute set is not a subset of source partial attribute set."))
      CASE_ERRCODE2(ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA                             , _T("The replication synchronization attempt failed because a master replica attempted to sync from a partial replica."))
      CASE_ERRCODE2(ERROR_DS_DRA_EXTN_CONNECTION_FAILED                                , _T("The server specified for this replication operation was contacted, but that server was unable to contact an additional server needed to complete the operation."))
      CASE_ERRCODE2(ERROR_DS_INSTALL_SCHEMA_MISMATCH                                   , _T("The version of the Active Directory schema of the source forest is not compatible with the version of Active Directory on this computer."))
      CASE_ERRCODE2(ERROR_DS_DUP_LINK_ID                                               , _T("Schema update failed: An attribute with the same link identifier already exists."))
      CASE_ERRCODE2(ERROR_DS_NAME_ERROR_RESOLVING                                      , _T("Name translation: Generic processing error."))
      CASE_ERRCODE2(ERROR_DS_NAME_ERROR_NOT_FOUND                                      , _T("Name translation: Could not find the name or insufficient right to see name."))
      CASE_ERRCODE2(ERROR_DS_NAME_ERROR_NOT_UNIQUE                                     , _T("Name translation: Input name mapped to more than one output name."))
      CASE_ERRCODE2(ERROR_DS_NAME_ERROR_NO_MAPPING                                     , _T("Name translation: Input name found, but not the associated output format."))
      CASE_ERRCODE2(ERROR_DS_NAME_ERROR_DOMAIN_ONLY                                    , _T("Name translation: Unable to resolve completely, only the domain was found."))
      CASE_ERRCODE2(ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING                         , _T("Name translation: Unable to perform purely syntactical mapping at the client without going out to the wire."))
      CASE_ERRCODE2(ERROR_DS_CONSTRUCTED_ATT_MOD                                       , _T("Modification of a constructed attribute is not allowed."))
      CASE_ERRCODE2(ERROR_DS_WRONG_OM_OBJ_CLASS                                        , _T("The OM-Object-Class specified is incorrect for an attribute with the specified syntax."))
      CASE_ERRCODE2(ERROR_DS_DRA_REPL_PENDING                                          , _T("The replication request has been posted; waiting for reply."))
      CASE_ERRCODE2(ERROR_DS_DS_REQUIRED                                               , _T("The requested operation requires a directory service, and none was available."))
      CASE_ERRCODE2(ERROR_DS_INVALID_LDAP_DISPLAY_NAME                                 , _T("The LDAP display name of the class or attribute contains non-ASCII characters."))
      CASE_ERRCODE2(ERROR_DS_NON_BASE_SEARCH                                           , _T("The requested search operation is only supported for base searches."))
      CASE_ERRCODE2(ERROR_DS_CANT_RETRIEVE_ATTS                                        , _T("The search failed to retrieve attributes from the database."))
      CASE_ERRCODE2(ERROR_DS_BACKLINK_WITHOUT_LINK                                     , _T("The schema update operation tried to add a backward link attribute that has no corresponding forward link."))
      CASE_ERRCODE2(ERROR_DS_EPOCH_MISMATCH                                            , _T("Source and destination of a cross domain move do not agree on the object's epoch number. Either source or destination does not have the latest version of the object."))
      CASE_ERRCODE2(ERROR_DS_SRC_NAME_MISMATCH                                         , _T("Source and destination of a cross domain move do not agree on the object's current name. Either source or destination does not have the latest version of the object."))
      CASE_ERRCODE2(ERROR_DS_SRC_AND_DST_NC_IDENTICAL                                  , _T("Source and destination of a cross domain move operation are identical. Caller should use local move operation instead of cross domain move operation."))
      CASE_ERRCODE2(ERROR_DS_DST_NC_MISMATCH                                           , _T("Source and destination for a cross domain move are not in agreement on the naming contexts in the forest. Either source or destination does not have the latest version of the Partitions container."))
      CASE_ERRCODE2(ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC                                , _T("Destination of a cross domain move is not authoritative for the destination naming context."))
      CASE_ERRCODE2(ERROR_DS_SRC_GUID_MISMATCH                                         , _T("Source and destination of a cross domain move do not agree on the identity of the source object. Either source or destination does not have the latest version of the source object."))
      CASE_ERRCODE2(ERROR_DS_CANT_MOVE_DELETED_OBJECT                                  , _T("Object being moved across domains is already known to be deleted by the destination server. The source server does not have the latest version of the source object."))
      CASE_ERRCODE2(ERROR_DS_PDC_OPERATION_IN_PROGRESS                                 , _T("Another operation which requires exclusive access to the PDC PSMO is already in progress."))
      CASE_ERRCODE2(ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD                                 , _T("A cross domain move operation failed such that the two versions of the moved object exist - one each in the source and destination domains. The destination object needs to be removed to restore the system to a consistent state."))
      CASE_ERRCODE2(ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION                               , _T("This object may not be moved across domain boundaries either because cross domain moves for this class are disallowed, or the object has some special characteristics, e.g.: trust account or restricted RID, which prevent its move."))
      CASE_ERRCODE2(ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS                           , _T("Can't move objects with memberships across domain boundaries as once moved, this would violate the membership conditions of the account group. Remove the object from any account group memberships and retry."))
      CASE_ERRCODE2(ERROR_DS_NC_MUST_HAVE_NC_PARENT                                    , _T("A naming context head must be the immediate child of another naming context head, not of an interior node."))
      CASE_ERRCODE2(ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE                                 , _T("The directory cannot validate the proposed naming context name because it does not hold a replica of the naming context above the proposed naming context. Please ensure that the domain naming master role is held by a server that is configured as a global catalog server, and that the server is up to date with its replication partners. (Applies only to Windows 2000 Domain Naming masters)"))
      CASE_ERRCODE2(ERROR_DS_DST_DOMAIN_NOT_NATIVE                                     , _T("Destination domain must be in native mode."))
      CASE_ERRCODE2(ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER                          , _T("The operation cannot be performed because the server does not have an infrastructure container in the domain of interest."))
      CASE_ERRCODE2(ERROR_DS_CANT_MOVE_ACCOUNT_GROUP                                   , _T("Cross-domain move of non-empty account groups is not allowed."))
      CASE_ERRCODE2(ERROR_DS_CANT_MOVE_RESOURCE_GROUP                                  , _T("Cross-domain move of non-empty resource groups is not allowed."))
      CASE_ERRCODE2(ERROR_DS_INVALID_SEARCH_FLAG                                       , _T("The search flags for the attribute are invalid. The ANR bit is valid only on attributes of Unicode or Teletex strings."))
      CASE_ERRCODE2(ERROR_DS_NO_TREE_DELETE_ABOVE_NC                                   , _T("Tree deletions starting at an object which has an NC head as a descendant are not allowed."))
      CASE_ERRCODE2(ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE                              , _T("The directory service failed to lock a tree in preparation for a tree deletion because the tree was in use."))
      CASE_ERRCODE2(ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE                  , _T("The directory service failed to identify the list of objects to delete while attempting a tree deletion."))
      CASE_ERRCODE2(ERROR_DS_SAM_INIT_FAILURE                                          , _T("Security Accounts Manager initialization failed because of the following error: %1. Error Status: 0x%2. Click OK to shut down the system and reboot into Directory Services Restore Mode. Check the event log for detailed information."))
      CASE_ERRCODE2(ERROR_DS_SENSITIVE_GROUP_VIOLATION                                 , _T("Only an administrator can modify the membership list of an administrative group."))
      CASE_ERRCODE2(ERROR_DS_CANT_MOD_PRIMARYGROUPID                                   , _T("Cannot change the primary group ID of a domain controller account."))
      CASE_ERRCODE2(ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD                                   , _T("An attempt is made to modify the base schema."))
      CASE_ERRCODE2(ERROR_DS_NONSAFE_SCHEMA_CHANGE                                     , _T("Adding a new mandatory attribute to an existing class, deleting a mandatory attribute from an existing class, or adding an optional attribute to the special class Top that is not a backlink attribute (directly or through inheritance, for example, by adding or deleting an auxiliary class) is not allowed."))
      CASE_ERRCODE2(ERROR_DS_SCHEMA_UPDATE_DISALLOWED                                  , _T("Schema update is not allowed on this DC because the DC is not the schema FSMO Role Owner."))
      CASE_ERRCODE2(ERROR_DS_CANT_CREATE_UNDER_SCHEMA                                  , _T("An object of this class cannot be created under the schema container. You can only create attribute-schema and class-schema objects under the schema container."))
      CASE_ERRCODE2(ERROR_DS_INSTALL_NO_SRC_SCH_VERSION                                , _T("The replica/child install failed to get the objectVersion attribute on the schema container on the source DC. Either the attribute is missing on the schema container or the credentials supplied do not have permission to read it."))
      CASE_ERRCODE2(ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE                         , _T("The replica/child install failed to read the objectVersion attribute in the SCHEMA section of the file schema.ini in the system32 directory."))
      CASE_ERRCODE2(ERROR_DS_INVALID_GROUP_TYPE                                        , _T("The specified group type is invalid."))
      CASE_ERRCODE2(ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN                        , _T("Cannot nest global groups in a mixed domain if the group is security-enabled."))
      CASE_ERRCODE2(ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN                         , _T("Cannot nest local groups in a mixed domain if the group is security-enabled."))
      CASE_ERRCODE2(ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER                             , _T("A global group cannot have a local group as a member."))
      CASE_ERRCODE2(ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER                         , _T("A global group cannot have a universal group as a member."))
      CASE_ERRCODE2(ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER                          , _T("A universal group cannot have a local group as a member."))
      CASE_ERRCODE2(ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER                       , _T("A global group cannot have a cross-domain member."))
      CASE_ERRCODE2(ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER                  , _T("A local group cannot have another cross-domain local group as a member."))
      CASE_ERRCODE2(ERROR_DS_HAVE_PRIMARY_MEMBERS                                      , _T("A group with primary members cannot change to a security-disabled group."))
      CASE_ERRCODE2(ERROR_DS_STRING_SD_CONVERSION_FAILED                               , _T("The schema cache load failed to convert the string default SD on a class-schema object."))
      CASE_ERRCODE2(ERROR_DS_NAMING_MASTER_GC                                          , _T("Only DSAs configured to be Global Catalog servers should be allowed to hold the Domain Naming Master FSMO role. (Applies only to Windows 2000 servers)"))
      CASE_ERRCODE2(ERROR_DS_DNS_LOOKUP_FAILURE                                        , _T("The DSA operation is unable to proceed because of a DNS lookup failure."))
      CASE_ERRCODE2(ERROR_DS_COULDNT_UPDATE_SPNS                                       , _T("While processing a change to the DNS Host Name for an object, the Service Principal Name values could not be kept in sync."))
      CASE_ERRCODE2(ERROR_DS_CANT_RETRIEVE_SD                                          , _T("The Security Descriptor attribute could not be read."))
      CASE_ERRCODE2(ERROR_DS_KEY_NOT_UNIQUE                                            , _T("The object requested was not found, but an object with that key was found."))
      CASE_ERRCODE2(ERROR_DS_WRONG_LINKED_ATT_SYNTAX                                   , _T("The syntax of the linked attributed being added is incorrect. Forward links can only have syntax 2.5.5.1, 2.5.5.7, and 2.5.5.14, and backlinks can only have syntax 2.5.5.1."))
      CASE_ERRCODE2(ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD                                 , _T("Security Account Manager needs to get the boot password."))
      CASE_ERRCODE2(ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY                                   , _T("Security Account Manager needs to get the boot key from floppy disk."))
      CASE_ERRCODE2(ERROR_DS_CANT_START                                                , _T("Directory Service cannot start."))
      CASE_ERRCODE2(ERROR_DS_INIT_FAILURE                                              , _T("Directory Services could not start."))
      CASE_ERRCODE2(ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION                              , _T("The connection between client and server requires packet privacy or better."))
      CASE_ERRCODE2(ERROR_DS_SOURCE_DOMAIN_IN_FOREST                                   , _T("The source domain may not be in the same forest as destination."))
      CASE_ERRCODE2(ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST                          , _T("The destination domain must be in the forest."))
      CASE_ERRCODE2(ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED                          , _T("The operation requires that destination domain auditing be enabled."))
      CASE_ERRCODE2(ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN                               , _T("The operation couldn't locate a DC for the source domain."))
      CASE_ERRCODE2(ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER                                 , _T("The source object must be a group or user."))
      CASE_ERRCODE2(ERROR_DS_SRC_SID_EXISTS_IN_FOREST                                  , _T("The source object's SID already exists in destination forest."))
      CASE_ERRCODE2(ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH                         , _T("The source and destination object must be of the same type."))
      CASE_ERRCODE2(ERROR_SAM_INIT_FAILURE                                             , _T("Security Accounts Manager initialization failed because of the following error: %1. Error Status: 0x%2. Click OK to shut down the system and reboot into Safe Mode. Check the event log for detailed information."))
      CASE_ERRCODE2(ERROR_DS_DRA_SCHEMA_INFO_SHIP                                      , _T("Schema information could not be included in the replication request."))
      CASE_ERRCODE2(ERROR_DS_DRA_SCHEMA_CONFLICT                                       , _T("The replication operation could not be completed due to a schema incompatibility."))
      CASE_ERRCODE2(ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT                               , _T("The replication operation could not be completed due to a previous schema incompatibility."))
      CASE_ERRCODE2(ERROR_DS_DRA_OBJ_NC_MISMATCH                                       , _T("The replication update could not be applied because either the source or the destination has not yet received information regarding a recent cross-domain move operation."))
      CASE_ERRCODE2(ERROR_DS_NC_STILL_HAS_DSAS                                         , _T("The requested domain could not be deleted because there exist domain controllers that still host this domain."))
      CASE_ERRCODE2(ERROR_DS_GC_REQUIRED                                               , _T("The requested operation can be performed only on a global catalog server."))
      CASE_ERRCODE2(ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY                                , _T("A local group can only be a member of other local groups in the same domain."))
      CASE_ERRCODE2(ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS                                , _T("Foreign security principals cannot be members of universal groups."))
      CASE_ERRCODE2(ERROR_DS_CANT_ADD_TO_GC                                            , _T("The attribute is not allowed to be replicated to the GC because of security reasons."))
      CASE_ERRCODE2(ERROR_DS_NO_CHECKPOINT_WITH_PDC                                    , _T("The checkpoint with the PDC could not be taken because there are too many modifications being processed currently."))
      CASE_ERRCODE2(ERROR_DS_SOURCE_AUDITING_NOT_ENABLED                               , _T("The operation requires that source domain auditing be enabled."))
      CASE_ERRCODE2(ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC                               , _T("Security principal objects can only be created inside domain naming contexts."))
      CASE_ERRCODE2(ERROR_DS_INVALID_NAME_FOR_SPN                                      , _T("A Service Principal Name (SPN) could not be constructed because the provided hostname is not in the necessary format."))
      CASE_ERRCODE2(ERROR_DS_FILTER_USES_CONTRUCTED_ATTRS                              , _T("A Filter was passed that uses constructed attributes."))
      CASE_ERRCODE2(ERROR_DS_UNICODEPWD_NOT_IN_QUOTES                                  , _T("The unicodePwd attribute value must be enclosed in double quotes."))
      CASE_ERRCODE2(ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED                            , _T("Your computer could not be joined to the domain. You have exceeded the maximum number of computer accounts you are allowed to create in this domain. Contact your system administrator to have this limit reset or increased."))
      CASE_ERRCODE2(ERROR_DS_MUST_BE_RUN_ON_DST_DC                                     , _T("For security reasons, the operation must be run on the destination DC."))
      CASE_ERRCODE2(ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER                             , _T("For security reasons, the source DC must be NT4SP4 or greater."))
      CASE_ERRCODE2(ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ                             , _T("Critical Directory Service System objects cannot be deleted during tree delete operations. The tree delete may have been partially performed."))
      CASE_ERRCODE2(ERROR_DS_INIT_FAILURE_CONSOLE                                      , _T("Directory Services could not start because of the following error: %1. Error Status: 0x%2. Please click OK to shutdown the system. You can use the recovery console to diagnose the system further."))
      CASE_ERRCODE2(ERROR_DS_SAM_INIT_FAILURE_CONSOLE                                  , _T("Security Accounts Manager initialization failed because of the following error: %1. Error Status: 0x%2. Please click OK to shutdown the system. You can use the recovery console to diagnose the system further."))
      CASE_ERRCODE2(ERROR_DS_FOREST_VERSION_TOO_HIGH                                   , _T("The version of the operating system installed is incompatible with the current forest functional level. You must upgrade to a new version of the operating system before this server can become a domain controller in this forest."))
      CASE_ERRCODE2(ERROR_DS_DOMAIN_VERSION_TOO_HIGH                                   , _T("The version of the operating system installed is incompatible with the current domain functional level. You must upgrade to a new version of the operating system before this server can become a domain controller in this domain."))
      CASE_ERRCODE2(ERROR_DS_FOREST_VERSION_TOO_LOW                                    , _T("This version of the operating system installed on this server no longer supports the current forest functional level. You must raise the forest functional level before this server can become a domain controller in this forest."))
      CASE_ERRCODE2(ERROR_DS_DOMAIN_VERSION_TOO_LOW                                    , _T("This version of the operating system installed on this server no longer supports the current domain functional level. You must raise the domain functional level before this server can become a domain controller in this domain."))
      CASE_ERRCODE2(ERROR_DS_INCOMPATIBLE_VERSION                                      , _T("The version of the operating system installed on this server is incompatible with the functional level of the domain or forest."))
      CASE_ERRCODE2(ERROR_DS_LOW_DSA_VERSION                                           , _T("The functional level of the domain (or forest) cannot be raised to the requested value, because there exist one or more domain controllers in the domain (or forest) that are at a lower incompatible functional level."))
      CASE_ERRCODE2(ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN                        , _T("The forest functional level cannot be raised to the requested level since one or more domains are still in mixed domain mode. All domains in the forest must be in native mode before you can raise the forest functional level."))
      CASE_ERRCODE2(ERROR_DS_NOT_SUPPORTED_SORT_ORDER                                  , _T("The sort order requested is not supported."))
      CASE_ERRCODE2(ERROR_DS_NAME_NOT_UNIQUE                                           , _T("The requested name already exists as a unique identifier."))
      CASE_ERRCODE2(ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4                            , _T("The machine account was created pre-NT4. The account needs to be recreated."))
      CASE_ERRCODE2(ERROR_DS_OUT_OF_VERSION_STORE                                      , _T("The database is out of version store."))
      CASE_ERRCODE2(ERROR_DS_INCOMPATIBLE_CONTROLS_USED                                , _T("Unable to continue operation because multiple conflicting controls were used."))
      CASE_ERRCODE2(ERROR_DS_NO_REF_DOMAIN                                             , _T("Unable to find a valid security descriptor reference domain for this partition."))
      CASE_ERRCODE2(ERROR_DS_RESERVED_LINK_ID                                          , _T("Schema update failed: The link identifier is reserved."))
      CASE_ERRCODE2(ERROR_DS_LINK_ID_NOT_AVAILABLE                                     , _T("Schema update failed: There are no link identifiers available."))
      CASE_ERRCODE2(ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER                             , _T("An account group cannot have a universal group as a member."))
      CASE_ERRCODE2(ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE                      , _T("Rename or move operations on naming context heads or read-only objects are not allowed."))
      CASE_ERRCODE2(ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC                               , _T("Move operations on objects in the schema naming context are not allowed."))
      CASE_ERRCODE2(ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG                               , _T("A system flag has been set on the object and does not allow the object to be moved or renamed."))
      CASE_ERRCODE2(ERROR_DS_MODIFYDN_WRONG_GRANDPARENT                                , _T("This object is not allowed to change its grandparent container. Moves are not forbidden on this object, but are restricted to sibling containers."))
      CASE_ERRCODE2(ERROR_DS_NAME_ERROR_TRUST_REFERRAL                                 , _T("Unable to resolve completely, a referral to another forest is generated."))
      CASE_ERRCODE2(ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER                             , _T("The requested action is not supported on standard server."))
      CASE_ERRCODE2(ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD                             , _T("Could not access a partition of the Active Directory located on a remote server. Make sure at least one server is running for the partition in question."))
      CASE_ERRCODE2(ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2                              , _T("The directory cannot validate the proposed naming context (or partition) name because it does not hold a replica nor can it contact a replica of the naming context above the proposed naming context. Please ensure that the parent naming context is properly registered in DNS, and at least one replica of this naming context is reachable by the Domain Naming master."))
      CASE_ERRCODE2(ERROR_DS_THREAD_LIMIT_EXCEEDED                                     , _T("The thread limit for this request was exceeded."))
      CASE_ERRCODE2(ERROR_DS_NOT_CLOSEST                                               , _T("The Global catalog server is not in the closet site."))
      CASE_ERRCODE2(ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF                        , _T("The DS cannot derive a service principal name (SPN) with which to mutually authenticate the target server because the corresponding server object in the local DS database has no serverReference attribute."))
      CASE_ERRCODE2(ERROR_DS_SINGLE_USER_MODE_FAILED                                   , _T("The Directory Service failed to enter single user mode."))
      CASE_ERRCODE2(ERROR_DS_NTDSCRIPT_SYNTAX_ERROR                                    , _T("The Directory Service cannot parse the script because of a syntax error."))
      CASE_ERRCODE2(ERROR_DS_NTDSCRIPT_PROCESS_ERROR                                   , _T("The Directory Service cannot process the script because of an error."))
      CASE_ERRCODE2(ERROR_DS_DIFFERENT_REPL_EPOCHS                                     , _T("The directory service cannot perform the requested operation because the servers involved are of different replication epochs (which is usually related to a domain rename that is in progress)."))
      CASE_ERRCODE2(ERROR_DS_DRS_EXTENSIONS_CHANGED                                    , _T("The directory service binding must be renegotiated due to a change in the server extensions information."))
      CASE_ERRCODE2(ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR             , _T("Operation not allowed on a disabled cross ref."))
      CASE_ERRCODE2(ERROR_DS_NO_MSDS_INTID                                             , _T("Schema update failed: No values for msDS-IntId are available."))
      CASE_ERRCODE2(ERROR_DS_DUP_MSDS_INTID                                            , _T("Schema update failed: Duplicate msDS-INtId. Retry the operation."))
      CASE_ERRCODE2(ERROR_DS_EXISTS_IN_RDNATTID                                        , _T("Schema deletion failed: attribute is used in rDNAttID."))
      CASE_ERRCODE2(ERROR_DS_AUTHORIZATION_FAILED                                      , _T("The directory service failed to authorize the request."))
      CASE_ERRCODE2(ERROR_DS_INVALID_SCRIPT                                            , _T("The Directory Service cannot process the script because it is invalid."))
      CASE_ERRCODE2(ERROR_DS_REMOTE_CROSSREF_OP_FAILED                                 , _T("The remote create cross reference operation failed on the Domain Naming Master FSMO. The operation's error is in the extended data."))
      CASE_ERRCODE2(ERROR_DS_CROSS_REF_BUSY                                            , _T("A cross reference is in use locally with the same name."))
      CASE_ERRCODE2(ERROR_DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN                        , _T("The DS cannot derive a service principal name (SPN) with which to mutually authenticate the target server because the server's domain has been deleted from the forest."))
      CASE_ERRCODE2(ERROR_DS_CANT_DEMOTE_WITH_WRITEABLE_NC                             , _T("Writeable NCs prevent this DC from demoting."))
      CASE_ERRCODE2(ERROR_DS_DUPLICATE_ID_FOUND                                        , _T("The requested object has a non-unique identifier and cannot be retrieved."))
      CASE_ERRCODE2(ERROR_DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT                        , _T("Insufficient attributes were given to create an object. This object may not exist because it may have been deleted and already garbage collected."))
      CASE_ERRCODE2(ERROR_DS_GROUP_CONVERSION_ERROR                                    , _T("The group cannot be converted due to attribute restrictions on the requested group type."))
      CASE_ERRCODE2(ERROR_DS_CANT_MOVE_APP_BASIC_GROUP                                 , _T("Cross-domain move of non-empty basic application groups is not allowed."))
      CASE_ERRCODE2(ERROR_DS_CANT_MOVE_APP_QUERY_GROUP                                 , _T("Cross-domain move on non-empty query based application groups is not allowed."))
      CASE_ERRCODE2(ERROR_DS_ROLE_NOT_VERIFIED                                         , _T("The role owner could not be verified because replication of its partition has not occurred recently."))
      CASE_ERRCODE2(ERROR_DS_WKO_CONTAINER_CANNOT_BE_SPECIAL                           , _T("The target container for a redirection of a well-known object container cannot already be a special container."))
      CASE_ERRCODE2(ERROR_DS_DOMAIN_RENAME_IN_PROGRESS                                 , _T("The Directory Service cannot perform the requested operation because a domain rename operation is in progress."))
      CASE_ERRCODE2(ERROR_DS_EXISTING_AD_CHILD_NC                                      , _T("The Active Directory detected an Active Directory child partition below the requested new partition name. The Active Directory's partition hierarchy must be created in a top-down method."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_FORMAT_ERROR                                       , _T("DNS server unable to interpret format."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_SERVER_FAILURE                                     , _T("DNS server failure."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_NAME_ERROR                                         , _T("DNS name does not exist."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_NOT_IMPLEMENTED                                    , _T("DNS request not supported by name server."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_REFUSED                                            , _T("DNS operation refused."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_YXDOMAIN                                           , _T("DNS name that ought not exist, does exist."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_YXRRSET                                            , _T("DNS RR set that ought not exist, does exist."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_NXRRSET                                            , _T("DNS RR set that ought to exist, does not exist."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_NOTAUTH                                            , _T("DNS server not authoritative for zone."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_NOTZONE                                            , _T("DNS name in update or prereq is not in zone."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_BADSIG                                             , _T("DNS signature failed to verify."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_BADKEY                                             , _T("DNS bad key."))
      CASE_ERRCODE2(DNS_ERROR_RCODE_BADTIME                                            , _T("DNS signature validity expired."))
      CASE_ERRCODE2(DNS_INFO_NO_RECORDS                                                , _T("No records found for given DNS query."))
      CASE_ERRCODE2(DNS_ERROR_BAD_PACKET                                               , _T("Bad DNS packet."))
      CASE_ERRCODE2(DNS_ERROR_NO_PACKET                                                , _T("No DNS packet."))
      CASE_ERRCODE2(DNS_ERROR_RCODE                                                    , _T("DNS error, check rcode."))
      CASE_ERRCODE2(DNS_ERROR_UNSECURE_PACKET                                          , _T("Unsecured DNS packet."))
      CASE_ERRCODE2(DNS_ERROR_INVALID_TYPE                                             , _T("Invalid DNS type."))
      CASE_ERRCODE2(DNS_ERROR_INVALID_IP_ADDRESS                                       , _T("Invalid IP address."))
      CASE_ERRCODE2(DNS_ERROR_INVALID_PROPERTY                                         , _T("Invalid property."))
      CASE_ERRCODE2(DNS_ERROR_TRY_AGAIN_LATER                                          , _T("Try DNS operation again later."))
      CASE_ERRCODE2(DNS_ERROR_NOT_UNIQUE                                               , _T("Record for given name and type is not unique."))
      CASE_ERRCODE2(DNS_ERROR_NON_RFC_NAME                                             , _T("DNS name does not comply with RFC specifications."))
      CASE_ERRCODE2(DNS_STATUS_FQDN                                                    , _T("DNS name is a fully-qualified DNS name."))
      CASE_ERRCODE2(DNS_STATUS_DOTTED_NAME                                             , _T("DNS name is dotted (multi-label)."))
      CASE_ERRCODE2(DNS_STATUS_SINGLE_PART_NAME                                        , _T("DNS name is a single-part name."))
      CASE_ERRCODE2(DNS_ERROR_INVALID_NAME_CHAR                                        , _T("DSN name contains an invalid character."))
      CASE_ERRCODE2(DNS_ERROR_NUMERIC_NAME                                             , _T("DNS name is entirely numeric."))
      CASE_ERRCODE2(DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER                               , _T("The operation requested is not permitted on a DNS root server."))
      CASE_ERRCODE2(DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION                             , _T("The record could not be created because this part of the DNS namespace has been delegated to another server."))
      CASE_ERRCODE2(DNS_ERROR_CANNOT_FIND_ROOT_HINTS                                   , _T("The DNS server could not find a set of root hints."))
      CASE_ERRCODE2(DNS_ERROR_INCONSISTENT_ROOT_HINTS                                  , _T("The DNS server found root hints but they were not consistent across all adapters."))
      CASE_ERRCODE2(DNS_ERROR_ZONE_DOES_NOT_EXIST                                      , _T("DNS zone does not exist."))
      CASE_ERRCODE2(DNS_ERROR_NO_ZONE_INFO                                             , _T("DNS zone information not available."))
      CASE_ERRCODE2(DNS_ERROR_INVALID_ZONE_OPERATION                                   , _T("Invalid operation for DNS zone."))
      CASE_ERRCODE2(DNS_ERROR_ZONE_CONFIGURATION_ERROR                                 , _T("Invalid DNS zone configuration."))
      CASE_ERRCODE2(DNS_ERROR_ZONE_HAS_NO_SOA_RECORD                                   , _T("DNS zone has no start of authority (SOA) record."))
      CASE_ERRCODE2(DNS_ERROR_ZONE_HAS_NO_NS_RECORDS                                   , _T("DNS zone has no name server (NS) record."))
      CASE_ERRCODE2(DNS_ERROR_ZONE_LOCKED                                              , _T("DNS zone is locked."))
      CASE_ERRCODE2(DNS_ERROR_ZONE_CREATION_FAILED                                     , _T("DNS zone creation failed."))
      CASE_ERRCODE2(DNS_ERROR_ZONE_ALREADY_EXISTS                                      , _T("DNS zone already exists."))
      CASE_ERRCODE2(DNS_ERROR_AUTOZONE_ALREADY_EXISTS                                  , _T("DNS automatic zone already exists."))
      CASE_ERRCODE2(DNS_ERROR_INVALID_ZONE_TYPE                                        , _T("Invalid DNS zone type."))
      CASE_ERRCODE2(DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP                             , _T("Secondary DNS zone requires master IP address."))
      CASE_ERRCODE2(DNS_ERROR_ZONE_NOT_SECONDARY                                       , _T("DNS zone not secondary."))
      CASE_ERRCODE2(DNS_ERROR_NEED_SECONDARY_ADDRESSES                                 , _T("Need secondary IP address."))
      CASE_ERRCODE2(DNS_ERROR_WINS_INIT_FAILED                                         , _T("WINS initialization failed."))
      CASE_ERRCODE2(DNS_ERROR_NEED_WINS_SERVERS                                        , _T("Need WINS servers."))
      CASE_ERRCODE2(DNS_ERROR_NBSTAT_INIT_FAILED                                       , _T("NBTSTAT initialization call failed."))
      CASE_ERRCODE2(DNS_ERROR_SOA_DELETE_INVALID                                       , _T("Invalid delete of start of authority (SOA)"))
      CASE_ERRCODE2(DNS_ERROR_FORWARDER_ALREADY_EXISTS                                 , _T("A conditional forwarding zone already exists for that name."))
      CASE_ERRCODE2(DNS_ERROR_ZONE_REQUIRES_MASTER_IP                                  , _T("This zone must be configured with one or more master DNS server IP addresses."))
      CASE_ERRCODE2(DNS_ERROR_ZONE_IS_SHUTDOWN                                         , _T("The operation cannot be performed because this zone is shutdown."))
      CASE_ERRCODE2(DNS_ERROR_PRIMARY_REQUIRES_DATAFILE                                , _T("Primary DNS zone requires datafile."))
      CASE_ERRCODE2(DNS_ERROR_INVALID_DATAFILE_NAME                                    , _T("Invalid datafile name for DNS zone."))
      CASE_ERRCODE2(DNS_ERROR_DATAFILE_OPEN_FAILURE                                    , _T("Failed to open datafile for DNS zone."))
      CASE_ERRCODE2(DNS_ERROR_FILE_WRITEBACK_FAILED                                    , _T("Failed to write datafile for DNS zone."))
      CASE_ERRCODE2(DNS_ERROR_DATAFILE_PARSING                                         , _T("Failure while reading datafile for DNS zone."))
      CASE_ERRCODE2(DNS_ERROR_RECORD_DOES_NOT_EXIST                                    , _T("DNS record does not exist."))
      CASE_ERRCODE2(DNS_ERROR_RECORD_FORMAT                                            , _T("DNS record format error."))
      CASE_ERRCODE2(DNS_ERROR_NODE_CREATION_FAILED                                     , _T("Node creation failure in DNS."))
      CASE_ERRCODE2(DNS_ERROR_UNKNOWN_RECORD_TYPE                                      , _T("Unknown DNS record type."))
      CASE_ERRCODE2(DNS_ERROR_RECORD_TIMED_OUT                                         , _T("DNS record timed out."))
      CASE_ERRCODE2(DNS_ERROR_NAME_NOT_IN_ZONE                                         , _T("Name not in DNS zone."))
      CASE_ERRCODE2(DNS_ERROR_CNAME_LOOP                                               , _T("CNAME loop detected."))
      CASE_ERRCODE2(DNS_ERROR_NODE_IS_CNAME                                            , _T("Node is a CNAME DNS record."))
      CASE_ERRCODE2(DNS_ERROR_CNAME_COLLISION                                          , _T("A CNAME record already exists for given name."))
      CASE_ERRCODE2(DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT                                 , _T("Record only at DNS zone root."))
      CASE_ERRCODE2(DNS_ERROR_RECORD_ALREADY_EXISTS                                    , _T("DNS record already exists."))
      CASE_ERRCODE2(DNS_ERROR_SECONDARY_DATA                                           , _T("Secondary DNS zone data error."))
      CASE_ERRCODE2(DNS_ERROR_NO_CREATE_CACHE_DATA                                     , _T("Could not create DNS cache data."))
      CASE_ERRCODE2(DNS_ERROR_NAME_DOES_NOT_EXIST                                      , _T("DNS name does not exist."))
      CASE_ERRCODE2(DNS_WARNING_PTR_CREATE_FAILED                                      , _T("Could not create pointer (PTR) record."))
      CASE_ERRCODE2(DNS_WARNING_DOMAIN_UNDELETED                                       , _T("DNS domain was undeleted."))
      CASE_ERRCODE2(DNS_ERROR_DS_UNAVAILABLE                                           , _T("The directory service is unavailable."))
      CASE_ERRCODE2(DNS_ERROR_DS_ZONE_ALREADY_EXISTS                                   , _T("DNS zone already exists in the directory service."))
      CASE_ERRCODE2(DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE                                   , _T("DNS server not creating or reading the boot file for the directory service integrated DNS zone."))
      CASE_ERRCODE2(DNS_INFO_AXFR_COMPLETE                                             , _T("DNS AXFR (zone transfer) complete."))
      CASE_ERRCODE2(DNS_ERROR_AXFR                                                     , _T("DNS zone transfer failed."))
      CASE_ERRCODE2(DNS_INFO_ADDED_LOCAL_WINS                                          , _T("Added local WINS server."))
      CASE_ERRCODE2(DNS_STATUS_CONTINUE_NEEDED                                         , _T("Secure update call needs to continue update request."))
      CASE_ERRCODE2(DNS_ERROR_NO_TCPIP                                                 , _T("TCP/IP network protocol not installed."))
      CASE_ERRCODE2(DNS_ERROR_NO_DNS_SERVERS                                           , _T("No DNS servers configured for local system."))
      CASE_ERRCODE2(DNS_ERROR_DP_DOES_NOT_EXIST                                        , _T("The specified directory partition does not exist."))
      CASE_ERRCODE2(DNS_ERROR_DP_ALREADY_EXISTS                                        , _T("The specified directory partition already exists."))
      CASE_ERRCODE2(DNS_ERROR_DP_NOT_ENLISTED                                          , _T("The DNS server is not enlisted in the specified directory partition."))
      CASE_ERRCODE2(DNS_ERROR_DP_ALREADY_ENLISTED                                      , _T("The DNS server is already enlisted in the specified directory partition."))
      CASE_ERRCODE2(DNS_ERROR_DP_NOT_AVAILABLE                                         , _T("The directory partition is not available at this time. Please wait a few minutes and try again."))
#endif // __SDK__
      CASE_ERRCODE2(WSAEINTR                                                           , _T("A blocking operation was interrupted by a call to WSACancelBlockingCall."))
      CASE_ERRCODE2(WSAEBADF                                                           , _T("The file handle supplied is not valid."))
      CASE_ERRCODE2(WSAEACCES                                                          , _T("An attempt was made to access a socket in a way forbidden by its access permissions."))
      CASE_ERRCODE2(WSAEFAULT                                                          , _T("The system detected an invalid pointer address in attempting to use a pointer argument in a call."))
      CASE_ERRCODE2(WSAEINVAL                                                          , _T("An invalid argument was supplied."))
      CASE_ERRCODE2(WSAEMFILE                                                          , _T("Too many open sockets."))
      CASE_ERRCODE2(WSAEWOULDBLOCK                                                     , _T("A non-blocking socket operation could not be completed immediately."))
      CASE_ERRCODE2(WSAEINPROGRESS                                                     , _T("A blocking operation is currently executing."))
      CASE_ERRCODE2(WSAEALREADY                                                        , _T("An operation was attempted on a non-blocking socket that already had an operation in progress."))
      CASE_ERRCODE2(WSAENOTSOCK                                                        , _T("An operation was attempted on something that is not a socket."))
      CASE_ERRCODE2(WSAEDESTADDRREQ                                                    , _T("A required address was omitted from an operation on a socket."))
      CASE_ERRCODE2(WSAEMSGSIZE                                                        , _T("A message sent on a datagram socket was larger than the internal message buffer or some other network limit, or the buffer used to receive a datagram into was smaller than the datagram itself."))
      CASE_ERRCODE2(WSAEPROTOTYPE                                                      , _T("A protocol was specified in the socket function call that does not support the semantics of the socket type requested."))
      CASE_ERRCODE2(WSAENOPROTOOPT                                                     , _T("An unknown, invalid, or unsupported option or level was specified in a getsockopt or setsockopt call."))
      CASE_ERRCODE2(WSAEPROTONOSUPPORT                                                 , _T("The requested protocol has not been configured into the system, or no implementation for it exists."))
      CASE_ERRCODE2(WSAESOCKTNOSUPPORT                                                 , _T("The support for the specified socket type does not exist in this address family."))
      CASE_ERRCODE2(WSAEOPNOTSUPP                                                      , _T("The attempted operation is not supported for the type of object referenced."))
      CASE_ERRCODE2(WSAEPFNOSUPPORT                                                    , _T("The protocol family has not been configured into the system or no implementation for it exists."))
      CASE_ERRCODE2(WSAEAFNOSUPPORT                                                    , _T("An address incompatible with the requested protocol was used."))
      CASE_ERRCODE2(WSAEADDRINUSE                                                      , _T("Only one usage of each socket address (protocol/network address/port) is normally permitted."))
      CASE_ERRCODE2(WSAEADDRNOTAVAIL                                                   , _T("The requested address is not valid in its context."))
      CASE_ERRCODE2(WSAENETDOWN                                                        , _T("A socket operation encountered a dead network."))
      CASE_ERRCODE2(WSAENETUNREACH                                                     , _T("A socket operation was attempted to an unreachable network."))
      CASE_ERRCODE2(WSAENETRESET                                                       , _T("The connection has been broken due to keep-alive activity detecting a failure while the operation was in progress."))
      CASE_ERRCODE2(WSAECONNABORTED                                                    , _T("An established connection was aborted by the software in your host machine."))
      CASE_ERRCODE2(WSAECONNRESET                                                      , _T("An existing connection was forcibly closed by the remote host."))
      CASE_ERRCODE2(WSAENOBUFS                                                         , _T("An operation on a socket could not be performed because the system lacked sufficient buffer space or because a queue was full."))
      CASE_ERRCODE2(WSAEISCONN                                                         , _T("A connect request was made on an already connected socket."))
      CASE_ERRCODE2(WSAENOTCONN                                                        , _T("A request to send or receive data was disallowed because the socket is not connected and (when sending on a datagram socket using a sendto call) no address was supplied."))
      CASE_ERRCODE2(WSAESHUTDOWN                                                       , _T("A request to send or receive data was disallowed because the socket had already been shut down in that direction with a previous shutdown call."))
      CASE_ERRCODE2(WSAETOOMANYREFS                                                    , _T("Too many references to some kernel object."))
      CASE_ERRCODE2(WSAETIMEDOUT                                                       , _T("A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond."))
      CASE_ERRCODE2(WSAECONNREFUSED                                                    , _T("No connection could be made because the target machine actively refused it."))
      CASE_ERRCODE2(WSAELOOP                                                           , _T("Cannot translate name."))
      CASE_ERRCODE2(WSAENAMETOOLONG                                                    , _T("Name component or name was too long."))
      CASE_ERRCODE2(WSAEHOSTDOWN                                                       , _T("A socket operation failed because the destination host was down."))
      CASE_ERRCODE2(WSAEHOSTUNREACH                                                    , _T("A socket operation was attempted to an unreachable host."))
      CASE_ERRCODE2(WSAENOTEMPTY                                                       , _T("Cannot remove a directory that is not empty."))
      CASE_ERRCODE2(WSAEPROCLIM                                                        , _T("A Windows Sockets implementation may have a limit on the number of applications that may use it simultaneously."))
      CASE_ERRCODE2(WSAEUSERS                                                          , _T("Ran out of quota."))
      CASE_ERRCODE2(WSAEDQUOT                                                          , _T("Ran out of disk quota."))
      CASE_ERRCODE2(WSAESTALE                                                          , _T("File handle reference is no longer available."))
      CASE_ERRCODE2(WSAEREMOTE                                                         , _T("Item is not available locally."))
      CASE_ERRCODE2(WSASYSNOTREADY                                                     , _T("WSAStartup cannot function at this time because the underlying system it uses to provide network services is currently unavailable."))
      CASE_ERRCODE2(WSAVERNOTSUPPORTED                                                 , _T("The Windows Sockets version requested is not supported."))
      CASE_ERRCODE2(WSANOTINITIALISED                                                  , _T("Either the application has not called WSAStartup, or WSAStartup failed."))
      CASE_ERRCODE2(WSAEDISCON                                                         , _T("Returned by WSARecv or WSARecvFrom to indicate the remote party has initiated a graceful shutdown sequence."))
#ifdef __SDK__
      CASE_ERRCODE2(WSAENOMORE                                                         , _T("No more results can be returned by WSALookupServiceNext."))
      CASE_ERRCODE2(WSAECANCELLED                                                      , _T("A call to WSALookupServiceEnd was made while this call was still processing. The call has been canceled."))
      CASE_ERRCODE2(WSAEINVALIDPROCTABLE                                               , _T("The procedure call table is invalid."))
      CASE_ERRCODE2(WSAEINVALIDPROVIDER                                                , _T("The requested service provider is invalid."))
      CASE_ERRCODE2(WSAEPROVIDERFAILEDINIT                                             , _T("The requested service provider could not be loaded or initialized."))
      CASE_ERRCODE2(WSASYSCALLFAILURE                                                  , _T("A system call that should never fail has failed."))
      CASE_ERRCODE2(WSASERVICE_NOT_FOUND                                               , _T("No such service is known. The service cannot be found in the specified name space."))
      CASE_ERRCODE2(WSATYPE_NOT_FOUND                                                  , _T("The specified class was not found."))
      CASE_ERRCODE2(WSA_E_NO_MORE                                                      , _T("No more results can be returned by WSALookupServiceNext."))
      CASE_ERRCODE2(WSA_E_CANCELLED                                                    , _T("A call to WSALookupServiceEnd was made while this call was still processing. The call has been canceled."))
      CASE_ERRCODE2(WSAEREFUSED                                                        , _T("A database query failed because it was actively refused."))
#endif // __SDK__
      CASE_ERRCODE2(WSAHOST_NOT_FOUND                                                  , _T("No such host is known."))
      CASE_ERRCODE2(WSATRY_AGAIN                                                       , _T("This is usually a temporary error during hostname resolution and means that the local server did not receive a response from an authoritative server."))
      CASE_ERRCODE2(WSANO_RECOVERY                                                     , _T("A non-recoverable error occurred during a database lookup."))
      CASE_ERRCODE2(WSANO_DATA                                                         , _T("The requested name is valid, but no data of the requested type was found."))
#ifdef __SDK__
      CASE_ERRCODE2(WSA_QOS_RECEIVERS                                                  , _T("At least one reserve has arrived."))
      CASE_ERRCODE2(WSA_QOS_SENDERS                                                    , _T("At least one path has arrived."))
      CASE_ERRCODE2(WSA_QOS_NO_SENDERS                                                 , _T("There are no senders."))
      CASE_ERRCODE2(WSA_QOS_NO_RECEIVERS                                               , _T("There are no receivers."))
      CASE_ERRCODE2(WSA_QOS_REQUEST_CONFIRMED                                          , _T("Reserve has been confirmed."))
      CASE_ERRCODE2(WSA_QOS_ADMISSION_FAILURE                                          , _T("Error due to lack of resources."))
      CASE_ERRCODE2(WSA_QOS_POLICY_FAILURE                                             , _T("Rejected for administrative reasons - bad credentials."))
      CASE_ERRCODE2(WSA_QOS_BAD_STYLE                                                  , _T("Unknown or conflicting style."))
      CASE_ERRCODE2(WSA_QOS_BAD_OBJECT                                                 , _T("Problem with some part of the filterspec or providerspecific buffer in general."))
      CASE_ERRCODE2(WSA_QOS_TRAFFIC_CTRL_ERROR                                         , _T("Problem with some part of the flowspec."))
      CASE_ERRCODE2(WSA_QOS_GENERIC_ERROR                                              , _T("General QOS error."))
      CASE_ERRCODE2(WSA_QOS_ESERVICETYPE                                               , _T("An invalid or unrecognized service type was found in the flowspec."))
      CASE_ERRCODE2(WSA_QOS_EFLOWSPEC                                                  , _T("An invalid or inconsistent flowspec was found in the QOS structure."))
      CASE_ERRCODE2(WSA_QOS_EPROVSPECBUF                                               , _T("Invalid QOS provider-specific buffer."))
      CASE_ERRCODE2(WSA_QOS_EFILTERSTYLE                                               , _T("An invalid QOS filter style was used."))
      CASE_ERRCODE2(WSA_QOS_EFILTERTYPE                                                , _T("An invalid QOS filter type was used."))
      CASE_ERRCODE2(WSA_QOS_EFILTERCOUNT                                               , _T("An incorrect number of QOS FILTERSPECs were specified in the FLOWDESCRIPTOR."))
      CASE_ERRCODE2(WSA_QOS_EOBJLENGTH                                                 , _T("An object with an invalid ObjectLength field was specified in the QOS provider-specific buffer."))
      CASE_ERRCODE2(WSA_QOS_EFLOWCOUNT                                                 , _T("An incorrect number of flow descriptors was specified in the QOS structure."))
      CASE_ERRCODE2(WSA_QOS_EUNKOWNPSOBJ                                               , _T("An unrecognized object was found in the QOS provider-specific buffer."))
      CASE_ERRCODE2(WSA_QOS_EPOLICYOBJ                                                 , _T("An invalid policy object was found in the QOS provider-specific buffer."))
      CASE_ERRCODE2(WSA_QOS_EFLOWDESC                                                  , _T("An invalid QOS flow descriptor was found in the flow descriptor list."))
      CASE_ERRCODE2(WSA_QOS_EPSFLOWSPEC                                                , _T("An invalid or inconsistent flowspec was found in the QOS provider-specific buffer."))
      CASE_ERRCODE2(WSA_QOS_EPSFILTERSPEC                                              , _T("An invalid FILTERSPEC was found in the QOS provider-specific buffer."))
      CASE_ERRCODE2(WSA_QOS_ESDMODEOBJ                                                 , _T("An invalid shape discard mode object was found in the QOS provider-specific buffer."))
      CASE_ERRCODE2(WSA_QOS_ESHAPERATEOBJ                                              , _T("An invalid shaping rate object was found in the QOS provider-specific buffer."))
      CASE_ERRCODE2(WSA_QOS_RESERVED_PETYPE                                            , _T("A reserved policy element was found in the QOS provider-specific buffer."))
      CASE_ERRCODE2(ERROR_IPSEC_QM_POLICY_EXISTS                                       , _T("The specified quick mode policy already exists."))
      CASE_ERRCODE2(ERROR_IPSEC_QM_POLICY_NOT_FOUND                                    , _T("The specified quick mode policy was not found."))
      CASE_ERRCODE2(ERROR_IPSEC_QM_POLICY_IN_USE                                       , _T("The specified quick mode policy is being used."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_POLICY_EXISTS                                       , _T("The specified main mode policy already exists."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_POLICY_NOT_FOUND                                    , _T("The specified main mode policy was not found."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_POLICY_IN_USE                                       , _T("The specified main mode policy is being used."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_FILTER_EXISTS                                       , _T("The specified main mode filter already exists."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_FILTER_NOT_FOUND                                    , _T("The specified main mode filter was not found."))
      CASE_ERRCODE2(ERROR_IPSEC_TRANSPORT_FILTER_EXISTS                                , _T("The specified transport mode filter already exists."))
      CASE_ERRCODE2(ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND                             , _T("The specified transport mode filter does not exist."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_AUTH_EXISTS                                         , _T("The specified main mode authentication list exists."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_AUTH_NOT_FOUND                                      , _T("The specified main mode authentication list was not found."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_AUTH_IN_USE                                         , _T("The specified quick mode policy is being used."))
      CASE_ERRCODE2(ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND                            , _T("The specified main mode policy was not found."))
      CASE_ERRCODE2(ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND                              , _T("The specified quick mode policy was not found."))
      CASE_ERRCODE2(ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND                            , _T("The manifest file contains one or more syntax errors."))
      CASE_ERRCODE2(ERROR_IPSEC_TUNNEL_FILTER_EXISTS                                   , _T("The application attempted to activate a disabled activation context."))
      CASE_ERRCODE2(ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND                                , _T("The requested lookup key was not found in any active activation context."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_FILTER_PENDING_DELETION                             , _T("The Main Mode filter is pending deletion."))
      CASE_ERRCODE2(ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION                      , _T("The transport filter is pending deletion."))
      CASE_ERRCODE2(ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION                         , _T("The tunnel filter is pending deletion."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_POLICY_PENDING_DELETION                             , _T("The Main Mode policy is pending deletion."))
      CASE_ERRCODE2(ERROR_IPSEC_MM_AUTH_PENDING_DELETION                               , _T("The Main Mode authentication bundle is pending deletion."))
      CASE_ERRCODE2(ERROR_IPSEC_QM_POLICY_PENDING_DELETION                             , _T("The Quick Mode policy is pending deletion."))
      CASE_ERRCODE2(WARNING_IPSEC_MM_POLICY_PRUNED                                     , _T("The Main Mode policy was successfully added, but some of the requested offers are not supported."))
      CASE_ERRCODE2(WARNING_IPSEC_QM_POLICY_PRUNED                                     , _T("The Quick Mode policy was successfully added, but some of the requested offers are not supported."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_AUTH_FAIL                                          , _T("IKE authentication credentials are unacceptable."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_ATTRIB_FAIL                                        , _T("IKE security attributes are unacceptable."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_NEGOTIATION_PENDING                                , _T("IKE Negotiation in progress."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR                           , _T("General processing error."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_TIMED_OUT                                          , _T("Negotiation timed out."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_NO_CERT                                            , _T("IKE failed to find valid machine certificate."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_SA_DELETED                                         , _T("IKE SA deleted by peer before establishment completed."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_SA_REAPED                                          , _T("IKE SA deleted before establishment completed."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_MM_ACQUIRE_DROP                                    , _T("Negotiation request sat in Queue too long."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_QM_ACQUIRE_DROP                                    , _T("Negotiation request sat in Queue too long."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_QUEUE_DROP_MM                                      , _T("Negotiation request sat in Queue too long."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM                                   , _T("Negotiation request sat in Queue too long."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_DROP_NO_RESPONSE                                   , _T("No response from peer."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_MM_DELAY_DROP                                      , _T("Negotiation took too long."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_QM_DELAY_DROP                                      , _T("Negotiation took too long."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_ERROR                                              , _T("Unknown error occurred."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_CRL_FAILED                                         , _T("Certificate Revocation Check failed."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_KEY_USAGE                                  , _T("Invalid certificate key usage."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_CERT_TYPE                                  , _T("Invalid certificate type."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_NO_PRIVATE_KEY                                     , _T("No private key associated with machine certificate."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_DH_FAIL                                            , _T("Failure in Diffie-Helman computation."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_HEADER                                     , _T("Invalid header."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_NO_POLICY                                          , _T("No policy configured."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_SIGNATURE                                  , _T("Failed to verify signature."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_KERBEROS_ERROR                                     , _T("Failed to authenticate using Kerberos."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_NO_PUBLIC_KEY                                      , _T("Peer's certificate did not have a public key."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR                                        , _T("Error processing error payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_SA                                     , _T("Error processing SA payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_PROP                                   , _T("Error processing Proposal payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_TRANS                                  , _T("Error processing Transform payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_KE                                     , _T("Error processing KE payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_ID                                     , _T("Error processing ID payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_CERT                                   , _T("Error processing Cert payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ                               , _T("Error processing Certificate Request payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_HASH                                   , _T("Error processing Hash payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_SIG                                    , _T("Error processing Signature payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_NONCE                                  , _T("Error processing Nonce payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY                                 , _T("Error processing Notify payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_DELETE                                 , _T("Error processing Delete Payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR                                 , _T("Error processing VendorId payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_PAYLOAD                                    , _T("Invalid payload received."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_LOAD_SOFT_SA                                       , _T("Soft SA loaded."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN                                  , _T("Soft SA torn down."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_COOKIE                                     , _T("Invalid cookie received.."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_NO_PEER_CERT                                       , _T("Peer failed to send valid machine certificate."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_PEER_CRL_FAILED                                    , _T("Certification Revocation check of peer's certificate failed."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_POLICY_CHANGE                                      , _T("New policy invalidated SAs formed with old policy."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_NO_MM_POLICY                                       , _T("There is no available Main Mode IKE policy."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_NOTCBPRIV                                          , _T("Failed to enabled TCB privilege."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_SECLOADFAIL                                        , _T("Failed to load SECURITY.DLL."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_FAILSSPINIT                                        , _T("Failed to obtain security function table dispatch address from SSPI."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_FAILQUERYSSP                                       , _T("Failed to query Kerberos package to obtain max token size."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_SRVACQFAIL                                         , _T("Failed to obtain Kerberos server credentials for ISAKMP/ERROR_IPSEC_IKE service. Kerberos authentication will not function. The most likely reason for this is lack of domain membership. This is normal if your computer is a member of a workgroup."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_SRVQUERYCRED                                       , _T("Failed to determine SSPI principal name for ISAKMP/ERROR_IPSEC_IKE service (QueryCredentialsAttributes)."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_GETSPIFAIL                                         , _T("Failed to obtain new SPI for the inbound SA from Ipsec driver. The most common cause for this is that the driver does not have the correct filter. Check your policy to verify the filters."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_FILTER                                     , _T("Given filter is invalid."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_OUT_OF_MEMORY                                      , _T("Memory allocation failed."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED                              , _T("Failed to add Security Association to IPSec Driver. The most common cause for this is if the IKE negotiation took too long to complete. If the problem persists, reduce the load on the faulting machine."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_POLICY                                     , _T("Invalid policy."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_UNKNOWN_DOI                                        , _T("Invalid DOI."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_SITUATION                                  , _T("Invalid situation."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_DH_FAILURE                                         , _T("Diffie-Hellman failure."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_GROUP                                      , _T("Invalid Diffie-Hellman group."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_ENCRYPT                                            , _T("Error encrypting payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_DECRYPT                                            , _T("Error decrypting payload."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_POLICY_MATCH                                       , _T("Policy match error."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_UNSUPPORTED_ID                                     , _T("Unsupported ID."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_HASH                                       , _T("Hash verification failed."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_HASH_ALG                                   , _T("Invalid hash algorithm."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_HASH_SIZE                                  , _T("Invalid hash size."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG                                , _T("Invalid encryption algorithm."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_AUTH_ALG                                   , _T("Invalid authentication algorithm."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_SIG                                        , _T("Invalid certificate signature."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_LOAD_FAILED                                        , _T("Load failed."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_RPC_DELETE                                         , _T("Deleted via RPC call."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_BENIGN_REINIT                                      , _T("Temporary state created to perform reinit. This is not a real failure."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY                  , _T("The lifetime value received in the Responder Lifetime Notify is below the Windows 2000 configured minimum value. Please fix the policy on the peer machine."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN                                , _T("Key length in certificate is too small for configured security requirements."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_MM_LIMIT                                           , _T("Max number of established MM SAs to peer exceeded."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_NEGOTIATION_DISABLED                               , _T("IKE received a policy that disables negotiation."))
      CASE_ERRCODE2(ERROR_IPSEC_IKE_NEG_STATUS_END                                     , _T("ERROR_IPSEC_IKE_NEG_STATUS_END"))
      CASE_ERRCODE2(ERROR_SXS_SECTION_NOT_FOUND                                        , _T("The requested section was not present in the activation context."))
      CASE_ERRCODE2(ERROR_SXS_CANT_GEN_ACTCTX                                          , _T("This application has failed to start because the application configuration is incorrect. Reinstalling the application may fix this problem."))
      CASE_ERRCODE2(ERROR_SXS_INVALID_ACTCTXDATA_FORMAT                                , _T("The application binding data format is invalid."))
      CASE_ERRCODE2(ERROR_SXS_ASSEMBLY_NOT_FOUND                                       , _T("The referenced assembly is not installed on your system."))
      CASE_ERRCODE2(ERROR_SXS_MANIFEST_FORMAT_ERROR                                    , _T("The manifest file does not begin with the required tag and format information."))
      CASE_ERRCODE2(ERROR_SXS_MANIFEST_PARSE_ERROR                                     , _T("The manifest file contains one or more syntax errors."))
      CASE_ERRCODE2(ERROR_SXS_ACTIVATION_CONTEXT_DISABLED                              , _T("The application attempted to activate a disabled activation context."))
      CASE_ERRCODE2(ERROR_SXS_KEY_NOT_FOUND                                            , _T("The requested lookup key was not found in any active activation context."))
      CASE_ERRCODE2(ERROR_SXS_VERSION_CONFLICT                                         , _T("A component version required by the application conflicts with another component version already active."))
      CASE_ERRCODE2(ERROR_SXS_WRONG_SECTION_TYPE                                       , _T("The type requested activation context section does not match the query API used."))
      CASE_ERRCODE2(ERROR_SXS_THREAD_QUERIES_DISABLED                                  , _T("Lack of system resources has required isolated activation to be disabled for the current thread of execution."))
      CASE_ERRCODE2(ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET                              , _T("An attempt to set the process default activation context failed because the process default activation context was already set."))
      CASE_ERRCODE2(ERROR_SXS_UNKNOWN_ENCODING_GROUP                                   , _T("The encoding group identifier specified is not recognized."))
      CASE_ERRCODE2(ERROR_SXS_UNKNOWN_ENCODING                                         , _T("The encoding requested is not recognized."))
      CASE_ERRCODE2(ERROR_SXS_INVALID_XML_NAMESPACE_URI                                , _T("The manifest contains a reference to an invalid URI."))
      CASE_ERRCODE2(ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED                   , _T("The application manifest contains a reference to a dependent assembly which is not installed."))
      CASE_ERRCODE2(ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED                   , _T("The manifest for an assembly used by the application has a reference to a dependent assembly which is not installed."))
      CASE_ERRCODE2(ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE                      , _T("The manifest contains an attribute for the assembly identity which is not valid."))
      CASE_ERRCODE2(ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE              , _T("The manifest is missing the required default namespace specification on the assembly element."))
      CASE_ERRCODE2(ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE              , _T("The manifest has a default namespace specified on the assembly element but its value is not 'urn:schemas-microsoft-com:asm.v1'."))
      CASE_ERRCODE2(ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT           , _T("The private manifest probe has crossed the reparse-point-associated path."))
      CASE_ERRCODE2(ERROR_SXS_DUPLICATE_DLL_NAME                                       , _T("Two or more components referenced directly or indirectly by the application manifest have files by the same name."))
      CASE_ERRCODE2(ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME                               , _T("Two or more components referenced directly or indirectly by the application manifest have window classes with the same name."))
      CASE_ERRCODE2(ERROR_SXS_DUPLICATE_CLSID                                          , _T("Two or more components referenced directly or indirectly by the application manifest have the same COM server CLSIDs."))
      CASE_ERRCODE2(ERROR_SXS_DUPLICATE_IID                                            , _T("Two or more components referenced directly or indirectly by the application manifest have proxies for the same COM interface IIDs."))
      CASE_ERRCODE2(ERROR_SXS_DUPLICATE_TLBID                                          , _T("Two or more components referenced directly or indirectly by the application manifest have the same COM type library TLBIDs."))
      CASE_ERRCODE2(ERROR_SXS_DUPLICATE_PROGID                                         , _T("Two or more components referenced directly or indirectly by the application manifest have the same COM ProgIDs."))
      CASE_ERRCODE2(ERROR_SXS_DUPLICATE_ASSEMBLY_NAME                                  , _T("Two or more components referenced directly or indirectly by the application manifest are different versions of the same component which is not permitted."))
      CASE_ERRCODE2(ERROR_SXS_FILE_HASH_MISMATCH                                       , _T("A component's file does not match the verification information present in the component manifest."))
      CASE_ERRCODE2(ERROR_SXS_POLICY_PARSE_ERROR                                       , _T("The policy manifest contains one or more syntax errors."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_MISSINGQUOTE                                       , _T("Manifest Parse Error: A string literal was expected, but no opening quote character was found."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_COMMENTSYNTAX                                      , _T("Manifest Parse Error: Incorrect syntax was used in a comment."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_BADSTARTNAMECHAR                                   , _T("Manifest Parse Error: A name was started with an invalid character."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_BADNAMECHAR                                        , _T("Manifest Parse Error: A name contained an invalid character."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_BADCHARINSTRING                                    , _T("Manifest Parse Error: A string literal contained an invalid character."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_XMLDECLSYNTAX                                      , _T("Manifest Parse Error: Invalid syntax for an XML declaration."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_BADCHARDATA                                        , _T("Manifest Parse Error: An invalid character was found in text content."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_MISSINGWHITESPACE                                  , _T("Manifest Parse Error: Required white space was missing."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_EXPECTINGTAGEND                                    , _T("Manifest Parse Error: The character '>' was expected."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_MISSINGSEMICOLON                                   , _T("Manifest Parse Error: A semi colon character was expected."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNBALANCEDPAREN                                    , _T("Manifest Parse Error: Unbalanced parentheses."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_INTERNALERROR                                      , _T("Manifest Parse Error: Internal error."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE                              , _T("Manifest Parse Error: White space is not allowed at this location."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_INCOMPLETE_ENCODING                                , _T("Manifest Parse Error: End of file reached in invalid state for current encoding."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_MISSING_PAREN                                      , _T("Manifest Parse Error: Missing parenthesis."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE                                , _T("Manifest Parse Error: A single or double closing quote character (\' or \") is missing."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_MULTIPLE_COLONS                                    , _T("Manifest Parse Error: Multiple colons are not allowed in a name."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_INVALID_DECIMAL                                    , _T("Manifest Parse Error: Invalid character for decimal digit."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_INVALID_HEXIDECIMAL                                , _T("Manifest Parse Error: Invalid character for hexadecimal digit."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_INVALID_UNICODE                                    , _T("Manifest Parse Error: Invalid Unicode character value for this platform."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK                           , _T("Manifest Parse Error: Expecting white space or '?'."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNEXPECTEDENDTAG                                   , _T("Manifest Parse Error: End tag was not expected at this location."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNCLOSEDTAG                                        , _T("Manifest Parse Error: The following tags were not closed: %1."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_DUPLICATEATTRIBUTE                                 , _T("Manifest Parse Error: Duplicate attribute."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_MULTIPLEROOTS                                      , _T("Manifest Parse Error: Only one top level element is allowed in an XML document."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_INVALIDATROOTLEVEL                                 , _T("Manifest Parse Error: Invalid at the top level of the document."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_BADXMLDECL                                         , _T("Manifest Parse Error: Invalid XML declaration."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_MISSINGROOT                                        , _T("Manifest Parse Error: XML document must have a top level element."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNEXPECTEDEOF                                      , _T("Manifest Parse Error: Unexpected end of file."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_BADPEREFINSUBSET                                   , _T("Manifest Parse Error: Parameter entities cannot be used inside markup declarations in an internal subset."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNCLOSEDSTARTTAG                                   , _T("Manifest Parse Error: Element was not closed."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNCLOSEDENDTAG                                     , _T("Manifest Parse Error: End element was missing the character '>'."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNCLOSEDSTRING                                     , _T("Manifest Parse Error: A string literal was not closed."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNCLOSEDCOMMENT                                    , _T("Manifest Parse Error: A comment was not closed."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNCLOSEDDECL                                       , _T("Manifest Parse Error: A declaration was not closed."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNCLOSEDCDATA                                      , _T("Manifest Parse Error: A CDATA section was not closed."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_RESERVEDNAMESPACE                                  , _T("Manifest Parse Error: The namespace prefix is not allowed to start with the reserved string 'xml'."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_INVALIDENCODING                                    , _T("Manifest Parse Error: System does not support the specified encoding."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_INVALIDSWITCH                                      , _T("Manifest Parse Error: Switch from current encoding to specified encoding not supported."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_BADXMLCASE                                         , _T("Manifest Parse Error: The name 'xml' is reserved and must be lower case."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_INVALID_STANDALONE                                 , _T("Manifest Parse Error: The standalone attribute must have the value 'yes' or 'no'."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_UNEXPECTED_STANDALONE                              , _T("Manifest Parse Error: The standalone attribute cannot be used in external entities."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_INVALID_VERSION                                    , _T("Manifest Parse Error: Invalid version number."))
      CASE_ERRCODE2(ERROR_SXS_XML_E_MISSINGEQUALS                                      , _T("Manifest Parse Error: Missing equals sign between attribute and attribute value."))
      CASE_ERRCODE2(ERROR_SXS_PROTECTION_RECOVERY_FAILED                               , _T("Assembly Protection Error: Unable to recover the specified assembly."))
      CASE_ERRCODE2(ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT                          , _T("Assembly Protection Error: The public key for an assembly was too short to be allowed."))
      CASE_ERRCODE2(ERROR_SXS_PROTECTION_CATALOG_NOT_VALID                             , _T("Assembly Protection Error: The catalog for an assembly is not valid, or does not match the assembly's manifest."))
      CASE_ERRCODE2(ERROR_SXS_UNTRANSLATABLE_HRESULT                                   , _T("An HRESULT could not be translated to a corresponding Win32 error code."))
      CASE_ERRCODE2(ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING                          , _T("Assembly Protection Error: The catalog for an assembly is missing."))
      CASE_ERRCODE2(ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE                      , _T("The supplied assembly identity is missing one or more attributes which must be present in this context."))
      CASE_ERRCODE2(ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME                 , _T("The supplied assembly identity has one or more attribute names that contain characters not permitted in XML names."))

      CASE_ERRCODE2(ERROR_INCOMPATIBLE_TCI_VERSION                                     , _T("Traffic Control error. Incompatible TC version number"))
      CASE_ERRCODE2(ERROR_INVALID_SERVICE_TYPE                                         , _T("Traffic Control error. Unspecified or bad intserv service type"))
      CASE_ERRCODE2(ERROR_INVALID_TOKEN_RATE                                           , _T("Traffic Control error. Unspecified or bad TokenRate"))
      CASE_ERRCODE2(ERROR_INVALID_PEAK_RATE                                            , _T("Traffic Control error. Bad PeakBandwidth"))
      CASE_ERRCODE2(ERROR_INVALID_SD_MODE                                              , _T("Traffic Control error. Invalid ShapeDiscardMode"))
      CASE_ERRCODE2(ERROR_INVALID_QOS_PRIORITY                                         , _T("Traffic Control error. Invalid priority value"))
      CASE_ERRCODE2(ERROR_INVALID_TRAFFIC_CLASS                                        , _T("Traffic Control error. Invalid traffic class value"))
      CASE_ERRCODE2(ERROR_INVALID_ADDRESS_TYPE                                         , _T("Traffic Control error. Invalid address type"))
      CASE_ERRCODE2(ERROR_DUPLICATE_FILTER                                             , _T("Traffic Control error. Attempt to install identical filter on same flow"))
      CASE_ERRCODE2(ERROR_FILTER_CONFLICT                                              , _T("Traffic Control error. Attempt to install conflicting filter"))
      CASE_ERRCODE2(ERROR_ADDRESS_TYPE_NOT_SUPPORTED                                   , _T("Traffic Control error. This address type is not supportedED"))
      CASE_ERRCODE2(ERROR_TC_SUPPORTED_OBJECTS_EXIST                                   , _T("Traffic Control error. This object can not be deleted since its suporting opened objectsST"))
      CASE_ERRCODE2(ERROR_INCOMPATABLE_QOS                                             , _T("Traffic Control error. Incompatable QoS parameters"))
      CASE_ERRCODE2(ERROR_TC_NOT_SUPPORTED                                             , _T("Traffic Control error. Traffic Control is not supported in the system"))
      CASE_ERRCODE2(ERROR_TC_OBJECT_LENGTH_INVALID                                     , _T("Traffic Control error. TcObjectsLength is inconsistent with CfInfoSize"))
      CASE_ERRCODE2(ERROR_INVALID_FLOW_MODE                                            , _T("Traffic Control error. Adding an Intserv flow in Diffserv mode or vice versa"))
      CASE_ERRCODE2(ERROR_INVALID_DIFFSERV_FLOW                                        , _T("Traffic Control error. Invalid Diffserv flow"))
      CASE_ERRCODE2(ERROR_DS_MAPPING_EXISTS                                            , _T("Traffic Control error. DS codepoint already exists"))
      CASE_ERRCODE2(ERROR_INVALID_SHAPE_RATE                                           , _T("Traffic Control error. Invalid Shape Rate specified"))
      CASE_ERRCODE2(ERROR_INVALID_DS_CLASS                                             , _T("Traffic Control error. Invalid DCLASS"))
      CASE_ERRCODE2(ERROR_TOO_MANY_CLIENTS                                             , _T("Traffic Control error. Too many GPC clients"))
#endif // __SDK__


      CASE_ERRCODE2(NERR_BASE                                                          , _T("Is the base of error codes from network utilities (network error definitions)."))
      CASE_ERRCODE2(NERR_NetNotStarted                                                 , _T("The workstation driver is not installed."))
      CASE_ERRCODE2(NERR_UnknownServer                                                 , _T("The server could not be located."))
      CASE_ERRCODE2(NERR_ShareMem                                                      , _T("An internal error occurred.  The network cannot access a shared memory segment."))
      CASE_ERRCODE2(NERR_NoNetworkResource                                             , _T("A network resource shortage occurred ."))
      CASE_ERRCODE2(NERR_RemoteOnly                                                    , _T("This operation is not supported on workstations."))
      CASE_ERRCODE2(NERR_DevNotRedirected                                              , _T("The device is not connected."))
      CASE_ERRCODE2(NERR_ServerNotStarted                                              , _T("The Server service is not started."))
      CASE_ERRCODE2(NERR_ItemNotFound                                                  , _T("The queue is empty."))
      CASE_ERRCODE2(NERR_UnknownDevDir                                                 , _T("The device or directory does not exist."))
      CASE_ERRCODE2(NERR_RedirectedPath                                                , _T("The operation is invalid on a redirected resource."))
      CASE_ERRCODE2(NERR_DuplicateShare                                                , _T("The name has already been shared."))
      CASE_ERRCODE2(NERR_NoRoom                                                        , _T("The server is currently out of the requested resource."))
      CASE_ERRCODE2(NERR_TooManyItems                                                  , _T("Requested addition of items exceeds the maximum allowed."))
      CASE_ERRCODE2(NERR_InvalidMaxUsers                                               , _T("The Peer service supports only two simultaneous users."))
      CASE_ERRCODE2(NERR_BufTooSmall                                                   , _T("The API return buffer is too small."))
      CASE_ERRCODE2(NERR_RemoteErr                                                     , _T("A remote API error occurred."))
      CASE_ERRCODE2(NERR_LanmanIniError                                                , _T("An error occurred when opening or reading the configuration file."))
      CASE_ERRCODE2(NERR_NetworkError                                                  , _T("A general network error occurred."))
      CASE_ERRCODE2(NERR_WkstaInconsistentState                                        , _T("The Workstation service is in an inconsistent state. Restart the computer before restarting the Workstation service."))
      CASE_ERRCODE2(NERR_WkstaNotStarted                                               , _T("The Workstation service has not been started."))
      CASE_ERRCODE2(NERR_BrowserNotStarted                                             , _T("The requested information is not available."))
      CASE_ERRCODE2(NERR_InternalError                                                 , _T("An internal Windows error occurred."))
      CASE_ERRCODE2(NERR_BadTransactConfig                                             , _T("The server is not configured for transactions."))
      CASE_ERRCODE2(NERR_InvalidAPI                                                    , _T("The requested API is not supported on the remote server."))
      CASE_ERRCODE2(NERR_BadEventName                                                  , _T("The event name is invalid."))
      CASE_ERRCODE2(NERR_DupNameReboot                                                 , _T("The computer name already exists on the network. Change it and restart the computer."))
      CASE_ERRCODE2(NERR_CfgCompNotFound                                               , _T("Config API related. The specified component could not be found in the configuration information."))
      CASE_ERRCODE2(NERR_CfgParamNotFound                                              , _T("Config API related. The specified parameter could not be found in the configuration information."))
      CASE_ERRCODE2(NERR_LineTooLong                                                   , _T("Config API related. A line in the configuration file is too long."))
      CASE_ERRCODE2(NERR_QNotFound                                                     , _T("Spooler API related. The printer does not exist."))
      CASE_ERRCODE2(NERR_JobNotFound                                                   , _T("Spooler API related. The print job does not exist."))
      CASE_ERRCODE2(NERR_DestNotFound                                                  , _T("Spooler API related. The printer destination cannot be found."))
      CASE_ERRCODE2(NERR_DestExists                                                    , _T("Spooler API related. The printer destination already exists."))
      CASE_ERRCODE2(NERR_QExists                                                       , _T("Spooler API related. The printer queue already exists."))
      CASE_ERRCODE2(NERR_QNoRoom                                                       , _T("Spooler API related. No more printers can be added."))
      CASE_ERRCODE2(NERR_JobNoRoom                                                     , _T("Spooler API related. No more print jobs can be added."))
      CASE_ERRCODE2(NERR_DestNoRoom                                                    , _T("Spooler API related. No more printer destinations can be added."))
      CASE_ERRCODE2(NERR_DestIdle                                                      , _T("Spooler API related. This printer destination is idle and cannot accept control operations."))
      CASE_ERRCODE2(NERR_DestInvalidOp                                                 , _T("Spooler API related. This printer destination request contains an invalid control function."))
      CASE_ERRCODE2(NERR_ProcNoRespond                                                 , _T("Spooler API related. The print processor is not responding."))
      CASE_ERRCODE2(NERR_SpoolerNotLoaded                                              , _T("Spooler API related. The spooler is not running."))
      CASE_ERRCODE2(NERR_DestInvalidState                                              , _T("Spooler API related. This operation cannot be performed on the print destination in its current state."))
      CASE_ERRCODE2(NERR_QInvalidState                                                 , _T("Spooler API related. This operation cannot be performed on the printer queue in its current state."))
      CASE_ERRCODE2(NERR_JobInvalidState                                               , _T("Spooler API related. This operation cannot be performed on the print job in its current state."))
      CASE_ERRCODE2(NERR_SpoolNoMemory                                                 , _T("Spooler API related. A spooler memory allocation failure occurred."))
      CASE_ERRCODE2(NERR_DriverNotFound                                                , _T("Spooler API related. The device driver does not exist."))
      CASE_ERRCODE2(NERR_DataTypeInvalid                                               , _T("Spooler API related. The data type is not supported by the print processor."))
      CASE_ERRCODE2(NERR_ProcNotFound                                                  , _T("Spooler API related. The print processor is not installed."))
      CASE_ERRCODE2(NERR_ServiceTableLocked                                            , _T("Service API related. The service database is locked."))
      CASE_ERRCODE2(NERR_ServiceTableFull                                              , _T("Service API related. The service table is full."))
      CASE_ERRCODE2(NERR_ServiceInstalled                                              , _T("Service API related. The requested service has already been started."))
      CASE_ERRCODE2(NERR_ServiceEntryLocked                                            , _T("Service API related. The service does not respond to control actions."))
      CASE_ERRCODE2(NERR_ServiceNotInstalled                                           , _T("Service API related. The service has not been started."))
      CASE_ERRCODE2(NERR_BadServiceName                                                , _T("Service API related. The service name is invalid."))
      CASE_ERRCODE2(NERR_ServiceCtlTimeout                                             , _T("Service API related. The service is not responding to the control function."))
      CASE_ERRCODE2(NERR_ServiceCtlBusy                                                , _T("Service API related. The service control is busy."))
      CASE_ERRCODE2(NERR_BadServiceProgName                                            , _T("Service API related. The configuration file contains an invalid service program name."))
      CASE_ERRCODE2(NERR_ServiceNotCtrl                                                , _T("Service API related. The service could not be controlled in its present state."))
      CASE_ERRCODE2(NERR_ServiceKillProc                                               , _T("Service API related. The service ended abnormally."))
      CASE_ERRCODE2(NERR_ServiceCtlNotValid                                            , _T("Service API related. The requested pause, continue, or stop is not valid for this service."))
      CASE_ERRCODE2(NERR_NotInDispatchTbl                                              , _T("Service API related. The service control dispatcher could not find the service name in the dispatch table."))
      CASE_ERRCODE2(NERR_BadControlRecv                                                , _T("Service API related. The service control dispatcher pipe read failed."))
      CASE_ERRCODE2(NERR_ServiceNotStarting                                            , _T("Service API related. A thread for the new service could not be created."))
      CASE_ERRCODE2(NERR_AlreadyLoggedOn                                               , _T("Wksta and Logon API related. This workstation is already logged on to the local-area network."))
      CASE_ERRCODE2(NERR_NotLoggedOn                                                   , _T("Wksta and Logon API related. The workstation is not logged on to the local-area network."))
    //CASE_ERRCODE2(NERR_BadUsername                                                   , _T("Wksta and Logon API related. The user name or group name parameter is invalid."))
      CASE_ERRCODE2(NERR_BadPassword                                                   , _T("Wksta and Logon API related. The password parameter is invalid."))
      CASE_ERRCODE2(NERR_UnableToAddName_W                                             , _T("Wksta and Logon API related. @W The logon processor did not add the message alias."))
      CASE_ERRCODE2(NERR_UnableToAddName_F                                             , _T("Wksta and Logon API related. The logon processor did not add the message alias."))
      CASE_ERRCODE2(NERR_UnableToDelName_W                                             , _T("Wksta and Logon API related. @W The logoff processor did not delete the message alias."))
      CASE_ERRCODE2(NERR_UnableToDelName_F                                             , _T("Wksta and Logon API related. The logoff processor did not delete the message alias."))
      CASE_ERRCODE2(NERR_LogonsPaused                                                  , _T("Wksta and Logon API related. Network logons are paused."))
      CASE_ERRCODE2(NERR_LogonServerConflict                                           , _T("Wksta and Logon API related. A centralized logon-server conflict occurred."))
      CASE_ERRCODE2(NERR_LogonNoUserPath                                               , _T("Wksta and Logon API related. The server is configured without a valid user path."))
      CASE_ERRCODE2(NERR_LogonScriptError                                              , _T("Wksta and Logon API related. An error occurred while loading or running the logon script."))
      CASE_ERRCODE2(NERR_StandaloneLogon                                               , _T("Wksta and Logon API related. The logon server was not specified.  Your computer will be logged on as STANDALONE."))
      CASE_ERRCODE2(NERR_LogonServerNotFound                                           , _T("Wksta and Logon API related. The logon server could not be found."))
      CASE_ERRCODE2(NERR_LogonDomainExists                                             , _T("Wksta and Logon API related. There is already a logon domain for this computer."))
      CASE_ERRCODE2(NERR_NonValidatedLogon                                             , _T("Wksta and Logon API related. The logon server could not validate the logon."))
      CASE_ERRCODE2(NERR_ACFNotFound                                                   , _T("ACF API related (access, user, group). The security database could not be found."))
      CASE_ERRCODE2(NERR_GroupNotFound                                                 , _T("ACF API related (access, user, group). The group name could not be found."))
      CASE_ERRCODE2(NERR_UserNotFound                                                  , _T("ACF API related (access, user, group). The user name could not be found."))
      CASE_ERRCODE2(NERR_ResourceNotFound                                              , _T("ACF API related (access, user, group). The resource name could not be found."))
      CASE_ERRCODE2(NERR_GroupExists                                                   , _T("ACF API related (access, user, group). The group already exists."))
      CASE_ERRCODE2(NERR_UserExists                                                    , _T("ACF API related (access, user, group). The account already exists."))
      CASE_ERRCODE2(NERR_ResourceExists                                                , _T("ACF API related (access, user, group). The resource permission list already exists."))
      CASE_ERRCODE2(NERR_NotPrimary                                                    , _T("ACF API related (access, user, group). This operation is only allowed on the primary domain controller of the domain."))
      CASE_ERRCODE2(NERR_ACFNotLoaded                                                  , _T("ACF API related (access, user, group). The security database has not been started."))
      CASE_ERRCODE2(NERR_ACFNoRoom                                                     , _T("ACF API related (access, user, group). There are too many names in the user accounts database."))
      CASE_ERRCODE2(NERR_ACFFileIOFail                                                 , _T("ACF API related (access, user, group). A disk I/O failure occurred."))
      CASE_ERRCODE2(NERR_ACFTooManyLists                                               , _T("ACF API related (access, user, group). The limit of 64 entries per resource was exceeded."))
      CASE_ERRCODE2(NERR_UserLogon                                                     , _T("ACF API related (access, user, group). Deleting a user with a session is not allowed."))
      CASE_ERRCODE2(NERR_ACFNoParent                                                   , _T("ACF API related (access, user, group). The parent directory could not be located."))
      CASE_ERRCODE2(NERR_CanNotGrowSegment                                             , _T("ACF API related (access, user, group). Unable to add to the security database session cache segment."))
      CASE_ERRCODE2(NERR_SpeGroupOp                                                    , _T("ACF API related (access, user, group). This operation is not allowed on this special group."))
      CASE_ERRCODE2(NERR_NotInCache                                                    , _T("ACF API related (access, user, group). This user is not cached in user accounts database session cache."))
      CASE_ERRCODE2(NERR_UserInGroup                                                   , _T("ACF API related (access, user, group). The user already belongs to this group."))
      CASE_ERRCODE2(NERR_UserNotInGroup                                                , _T("ACF API related (access, user, group). The user does not belong to this group."))
      CASE_ERRCODE2(NERR_AccountUndefined                                              , _T("ACF API related (access, user, group). This user account is undefined."))
      CASE_ERRCODE2(NERR_AccountExpired                                                , _T("ACF API related (access, user, group). This user account has expired."))
      CASE_ERRCODE2(NERR_InvalidWorkstation                                            , _T("ACF API related (access, user, group). The user is not allowed to log on from this workstation."))
      CASE_ERRCODE2(NERR_InvalidLogonHours                                             , _T("ACF API related (access, user, group). The user is not allowed to log on at this time."))
      CASE_ERRCODE2(NERR_PasswordExpired                                               , _T("ACF API related (access, user, group). The password of this user has expired."))
      CASE_ERRCODE2(NERR_PasswordCantChange                                            , _T("ACF API related (access, user, group). The password of this user cannot change."))
      CASE_ERRCODE2(NERR_PasswordHistConflict                                          , _T("ACF API related (access, user, group). This password cannot be used now."))
      CASE_ERRCODE2(NERR_PasswordTooShort                                              , _T("ACF API related (access, user, group). The password does not meet the password policy requirements. Check the minimum password length, password complexity and password history requirements."))
      CASE_ERRCODE2(NERR_PasswordTooRecent                                             , _T("ACF API related (access, user, group). The password of this user is too recent to change."))
      CASE_ERRCODE2(NERR_InvalidDatabase                                               , _T("ACF API related (access, user, group). The security database is corrupted."))
      CASE_ERRCODE2(NERR_DatabaseUpToDate                                              , _T("ACF API related (access, user, group). No updates are necessary to this replicant network/local security database."))
      CASE_ERRCODE2(NERR_SyncRequired                                                  , _T("ACF API related (access, user, group). This replicant database is outdated; synchronization is required."))
    //CASE_ERRCODE2(NERR_UseNotFound                                                   , _T("Use API related. The network connection could not be found."))
      CASE_ERRCODE2(NERR_BadAsgType                                                    , _T("Use API related. This asg_type is invalid."))
      CASE_ERRCODE2(NERR_DeviceIsShared                                                , _T("Use API related. This device is currently being shared."))
      CASE_ERRCODE2(NERR_NoComputerName                                                , _T("Message Server related. The computer name could not be added as a message alias.  The name may already exist on the network."))
      CASE_ERRCODE2(NERR_MsgAlreadyStarted                                             , _T("Message Server related. The Messenger service is already started."))
      CASE_ERRCODE2(NERR_MsgInitFailed                                                 , _T("Message Server related. The Messenger service failed to start."))
      CASE_ERRCODE2(NERR_NameNotFound                                                  , _T("Message Server related. The message alias could not be found on the network."))
      CASE_ERRCODE2(NERR_AlreadyForwarded                                              , _T("Message Server related. This message alias has already been forwarded."))
      CASE_ERRCODE2(NERR_AddForwarded                                                  , _T("Message Server related. This message alias has been added but is still forwarded."))
      CASE_ERRCODE2(NERR_AlreadyExists                                                 , _T("Message Server related. This message alias already exists locally."))
      CASE_ERRCODE2(NERR_TooManyNames                                                  , _T("Message Server related. The maximum number of added message aliases has been exceeded."))
      CASE_ERRCODE2(NERR_DelComputerName                                               , _T("Message Server related. The computer name could not be deleted."))
      CASE_ERRCODE2(NERR_LocalForward                                                  , _T("Message Server related. Messages cannot be forwarded back to the same workstation."))
      CASE_ERRCODE2(NERR_GrpMsgProcessor                                               , _T("Message Server related. An error occurred in the domain message processor."))
      CASE_ERRCODE2(NERR_PausedRemote                                                  , _T("Message Server related. The message was sent, but the recipient has paused the Messenger service."))
      CASE_ERRCODE2(NERR_BadReceive                                                    , _T("Message Server related. The message was sent but not received."))
      CASE_ERRCODE2(NERR_NameInUse                                                     , _T("Message Server related. The message alias is currently in use. Try again later."))
      CASE_ERRCODE2(NERR_MsgNotStarted                                                 , _T("Message Server related. The Messenger service has not been started."))
      CASE_ERRCODE2(NERR_NotLocalName                                                  , _T("Message Server related. The name is not on the local computer."))
      CASE_ERRCODE2(NERR_NoForwardName                                                 , _T("Message Server related. The forwarded message alias could not be found on the network."))
      CASE_ERRCODE2(NERR_RemoteFull                                                    , _T("Message Server related. The message alias table on the remote station is full."))
      CASE_ERRCODE2(NERR_NameNotForwarded                                              , _T("Message Server related. Messages for this alias are not currently being forwarded."))
      CASE_ERRCODE2(NERR_TruncatedBroadcast                                            , _T("Message Server related. The broadcast message was truncated."))
      CASE_ERRCODE2(NERR_InvalidDevice                                                 , _T("Message Server related. This is an invalid device name."))
      CASE_ERRCODE2(NERR_WriteFault                                                    , _T("Message Server related. A write fault occurred."))
      CASE_ERRCODE2(NERR_DuplicateName                                                 , _T("Message Server related. A duplicate message alias exists on the network."))
      CASE_ERRCODE2(NERR_DeleteLater                                                   , _T("Message Server related. @W This message alias will be deleted later."))
      CASE_ERRCODE2(NERR_IncompleteDel                                                 , _T("Message Server related. The message alias was not successfully deleted from all networks."))
#ifdef __SDK__
      CASE_ERRCODE2(NERR_MultipleNets                                                  , _T("Message Server related. This operation is not supported on computers with multiple networks."))
      CASE_ERRCODE2(NERR_NetNameNotFound                                               , _T("Server API related. This shared resource does not exist."))
#endif // __SDK__
      CASE_ERRCODE2(NERR_DeviceNotShared                                               , _T("Server API related. This device is not shared."))
      CASE_ERRCODE2(NERR_ClientNameNotFound                                            , _T("Server API related. A session does not exist with that computer name."))
      CASE_ERRCODE2(NERR_FileIdNotFound                                                , _T("Server API related. There is not an open file with that identification number."))
      CASE_ERRCODE2(NERR_ExecFailure                                                   , _T("Server API related. A failure occurred when executing a remote administration command."))
      CASE_ERRCODE2(NERR_TmpFile                                                       , _T("Server API related. A failure occurred when opening a remote temporary file."))
      CASE_ERRCODE2(NERR_TooMuchData                                                   , _T("Server API related. The data returned from a remote administration command has been truncated to 64K."))
      CASE_ERRCODE2(NERR_DeviceShareConflict                                           , _T("Server API related. This device cannot be shared as both a spooled and a non-spooled resource."))
      CASE_ERRCODE2(NERR_BrowserTableIncomplete                                        , _T("Server API related. The information in the list of servers may be incorrect."))
      CASE_ERRCODE2(NERR_NotLocalDomain                                                , _T("Server API related. The computer is not active in this domain."))
      CASE_ERRCODE2(NERR_IsDfsShare                                                    , _T("Server API related. The share must be removed from the Distributed File System before it can be deleted."))
      CASE_ERRCODE2(NERR_DevInvalidOpCode                                              , _T("CharDev API related. The operation is invalid for this device."))
      CASE_ERRCODE2(NERR_DevNotFound                                                   , _T("CharDev API related. This device cannot be shared."))
      CASE_ERRCODE2(NERR_DevNotOpen                                                    , _T("CharDev API related. This device was not open."))
      CASE_ERRCODE2(NERR_BadQueueDevString                                             , _T("CharDev API related. This device name list is invalid."))
      CASE_ERRCODE2(NERR_BadQueuePriority                                              , _T("CharDev API related. The queue priority is invalid."))
      CASE_ERRCODE2(NERR_NoCommDevs                                                    , _T("CharDev API related. There are no shared communication devices."))
      CASE_ERRCODE2(NERR_QueueNotFound                                                 , _T("CharDev API related. The queue you specified does not exist."))
      CASE_ERRCODE2(NERR_BadDevString                                                  , _T("CharDev API related. This list of devices is invalid."))
      CASE_ERRCODE2(NERR_BadDev                                                        , _T("CharDev API related. The requested device is invalid."))
      CASE_ERRCODE2(NERR_InUseBySpooler                                                , _T("CharDev API related. This device is already in use by the spooler."))
      CASE_ERRCODE2(NERR_CommDevInUse                                                  , _T("CharDev API related. This device is already in use as a communication device."))
      CASE_ERRCODE2(NERR_InvalidComputer                                               , _T("NetICanonicalize and NetIType and NetIMakeLMFileName, NetIListCanon and NetINameCheck. This computer name is invalid."))
      CASE_ERRCODE2(NERR_MaxLenExceeded                                                , _T("NetICanonicalize and NetIType and NetIMakeLMFileName, NetIListCanon and NetINameCheck. The string and prefix specified are too long."))
      CASE_ERRCODE2(NERR_BadComponent                                                  , _T("NetICanonicalize and NetIType and NetIMakeLMFileName, NetIListCanon and NetINameCheck. This path component is invalid."))
      CASE_ERRCODE2(NERR_CantType                                                      , _T("NetICanonicalize and NetIType and NetIMakeLMFileName, NetIListCanon and NetINameCheck. Could not determine the type of input."))
      CASE_ERRCODE2(NERR_TooManyEntries                                                , _T("NetICanonicalize and NetIType and NetIMakeLMFileName, NetIListCanon and NetINameCheck. The buffer for types is not big enough."))
      CASE_ERRCODE2(NERR_ProfileFileTooBig                                             , _T("NetProfile. Profile files cannot exceed 64K."))
      CASE_ERRCODE2(NERR_ProfileOffset                                                 , _T("NetProfile. The start offset is out of range."))
      CASE_ERRCODE2(NERR_ProfileCleanup                                                , _T("NetProfile. The system cannot delete current connections to network resources."))
      CASE_ERRCODE2(NERR_ProfileUnknownCmd                                             , _T("NetProfile. The system was unable to parse the command line in this file."))
      CASE_ERRCODE2(NERR_ProfileLoadErr                                                , _T("NetProfile. An error occurred while loading the profile file."))
      CASE_ERRCODE2(NERR_ProfileSaveErr                                                , _T("NetProfile. @W Errors occurred while saving the profile file.  The profile was partially saved."))
      CASE_ERRCODE2(NERR_LogOverflow                                                   , _T("NetAudit and NetErrorLog. Log file %1 is full."))
      CASE_ERRCODE2(NERR_LogFileChanged                                                , _T("NetAudit and NetErrorLog. This log file has changed between reads."))
      CASE_ERRCODE2(NERR_LogFileCorrupt                                                , _T("NetAudit and NetErrorLog. Log file %1 is corrupt."))
      CASE_ERRCODE2(NERR_SourceIsDir                                                   , _T("NetRemote. The source path cannot be a directory."))
      CASE_ERRCODE2(NERR_BadSource                                                     , _T("NetRemote. The source path is illegal."))
      CASE_ERRCODE2(NERR_BadDest                                                       , _T("NetRemote. The destination path is illegal."))
      CASE_ERRCODE2(NERR_DifferentServers                                              , _T("NetRemote. The source and destination paths are on different servers."))
      CASE_ERRCODE2(NERR_RunSrvPaused                                                  , _T("NetRemote. The Run server you requested is paused."))
      CASE_ERRCODE2(NERR_ErrCommRunSrv                                                 , _T("NetRemote. An error occurred when communicating with a Run server."))
      CASE_ERRCODE2(NERR_ErrorExecingGhost                                             , _T("NetRemote. An error occurred when starting a background process."))
      CASE_ERRCODE2(NERR_ShareNotFound                                                 , _T("NetRemote. The shared resource you are connected to could not be found."))
      CASE_ERRCODE2(NERR_InvalidLana                                                   , _T("NetWksta.sys (redir) error code. The LAN adapter number is invalid."))
    //CASE_ERRCODE2(NERR_OpenFiles                                                     , _T("NetWksta.sys (redir) error code. There are open files on the connection."))
    //CASE_ERRCODE2(NERR_ActiveConns                                                   , _T("NetWksta.sys (redir) error code. Active connections still exist."))
      CASE_ERRCODE2(NERR_BadPasswordCore                                               , _T("NetWksta.sys (redir) error code. This share name or password is invalid."))
    //CASE_ERRCODE2(NERR_DevInUse                                                      , _T("NetWksta.sys (redir) error code. The device is being accessed by an active process."))
      CASE_ERRCODE2(NERR_LocalDrive                                                    , _T("NetWksta.sys (redir) error code. The drive letter is in use locally."))
      CASE_ERRCODE2(NERR_AlertExists                                                   , _T("Alert error codes. The specified client is already registered for the specified event."))
      CASE_ERRCODE2(NERR_TooManyAlerts                                                 , _T("Alert error codes. The alert table is full."))
      CASE_ERRCODE2(NERR_NoSuchAlert                                                   , _T("Alert error codes. An invalid or nonexistent alert name was raised."))
      CASE_ERRCODE2(NERR_BadRecipient                                                  , _T("Alert error codes. The alert recipient is invalid."))
      CASE_ERRCODE2(NERR_AcctLimitExceeded                                             , _T("Alert error codes. A user's session with this server has been deleted because the user's logon hours are no longer valid."))
      CASE_ERRCODE2(NERR_InvalidLogSeek                                                , _T("Additional Error and Audit log code. The log file does not contain the requested record number."))
      CASE_ERRCODE2(NERR_BadUasConfig                                                  , _T("Additional UAS and NETLOGON code. The user accounts database is not configured correctly."))
      CASE_ERRCODE2(NERR_InvalidUASOp                                                  , _T("Additional UAS and NETLOGON code. This operation is not permitted when the Netlogon service is running."))
      CASE_ERRCODE2(NERR_LastAdmin                                                     , _T("Additional UAS and NETLOGON code. This operation is not allowed on the last administrative account."))
      CASE_ERRCODE2(NERR_DCNotFound                                                    , _T("Additional UAS and NETLOGON code. Could not find domain controller for this domain."))
      CASE_ERRCODE2(NERR_LogonTrackingError                                            , _T("Additional UAS and NETLOGON code. Could not set logon information for this user."))
      CASE_ERRCODE2(NERR_NetlogonNotStarted                                            , _T("Additional UAS and NETLOGON code. The Netlogon service has not been started."))
      CASE_ERRCODE2(NERR_CanNotGrowUASFile                                             , _T("Additional UAS and NETLOGON code. Unable to add to the user accounts database."))
      CASE_ERRCODE2(NERR_TimeDiffAtDC                                                  , _T("Additional UAS and NETLOGON code. This server's clock is not synchronized with the primary domain controller's clock."))
      CASE_ERRCODE2(NERR_PasswordMismatch                                              , _T("Additional UAS and NETLOGON code. A password mismatch has been detected."))
      CASE_ERRCODE2(NERR_NoSuchServer                                                  , _T("Server Integration error code. The server identification does not specify a valid server."))
      CASE_ERRCODE2(NERR_NoSuchSession                                                 , _T("Server Integration error code. The session identification does not specify a valid session."))
      CASE_ERRCODE2(NERR_NoSuchConnection                                              , _T("Server Integration error code. The connection identification does not specify a valid connection."))
      CASE_ERRCODE2(NERR_TooManyServers                                                , _T("Server Integration error code. There is no space for another entry in the table of available servers."))
      CASE_ERRCODE2(NERR_TooManySessions                                               , _T("Server Integration error code. The server has reached the maximum number of sessions it supports."))
      CASE_ERRCODE2(NERR_TooManyConnections                                            , _T("Server Integration error code. The server has reached the maximum number of connections it supports."))
      CASE_ERRCODE2(NERR_TooManyFiles                                                  , _T("Server Integration error code. The server cannot open more files because it has reached its maximum number."))
      CASE_ERRCODE2(NERR_NoAlternateServers                                            , _T("Server Integration error code. There are no alternate servers registered on this server."))
      CASE_ERRCODE2(NERR_TryDownLevel                                                  , _T("Try down-level (remote admin protocol) version of API instead."))
      CASE_ERRCODE2(NERR_UPSDriverNotStarted                                           , _T("UPS error code. The UPS driver could not be accessed by the UPS service."))
      CASE_ERRCODE2(NERR_UPSInvalidConfig                                              , _T("UPS error code. The UPS service is not configured correctly."))
      CASE_ERRCODE2(NERR_UPSInvalidCommPort                                            , _T("UPS error code. The UPS service could not access the specified Comm Port."))
      CASE_ERRCODE2(NERR_UPSSignalAsserted                                             , _T("UPS error code. The UPS indicated a line fail or low battery situation. Service not started."))
      CASE_ERRCODE2(NERR_UPSShutdownFailed                                             , _T("UPS error code. The UPS service failed to perform a system shut down."))
      CASE_ERRCODE2(NERR_BadDosRetCode                                                 , _T("Remoteboot error code (used by RPLBOOT.SYS). The program below returned an MS-DOS error code:"))
      CASE_ERRCODE2(NERR_ProgNeedsExtraMem                                             , _T("Remoteboot error code (used by RPLBOOT.SYS). The program below needs more memory:"))
      CASE_ERRCODE2(NERR_BadDosFunction                                                , _T("Remoteboot error code (used by RPLBOOT.SYS). The program below called an unsupported MS-DOS function:"))
      CASE_ERRCODE2(NERR_RemoteBootFailed                                              , _T("Remoteboot error code (used by RPLLOADR.COM). The workstation failed to boot."))
      CASE_ERRCODE2(NERR_BadFileCheckSum                                               , _T("Remoteboot error code (used by RPLBOOT.SYS). The file below is corrupt."))
      CASE_ERRCODE2(NERR_NoRplBootSystem                                               , _T("Remoteboot error code (used by RPLBOOT.SYS). No loader is specified in the boot-block definition file."))
      CASE_ERRCODE2(NERR_RplLoadrNetBiosErr                                            , _T("Remoteboot error code (used by RPLLOADR.COM). NetBIOS returned an error: The NCB and SMB are dumped above."))
      CASE_ERRCODE2(NERR_RplLoadrDiskErr                                               , _T("Remoteboot error code (used by RPLLOADR.COM). A disk I/O error occurred."))
      CASE_ERRCODE2(NERR_ImageParamErr                                                 , _T("Remoteboot error code (used by RPLLOADR.COM). Image parameter substitution failed."))
      CASE_ERRCODE2(NERR_TooManyImageParams                                            , _T("Remoteboot error code (used by RPLLOADR.COM). Too many image parameters cross disk sector boundaries."))
      CASE_ERRCODE2(NERR_NonDosFloppyUsed                                              , _T("Remoteboot error code (used by RPLLOADR.COM). The image was not generated from an MS-DOS diskette formatted with /S."))
      CASE_ERRCODE2(NERR_RplBootRestart                                                , _T("Remoteboot error code (used by RPLLOADR.COM). Remote boot will be restarted later."))
      CASE_ERRCODE2(NERR_RplSrvrCallFailed                                             , _T("Remoteboot error code (used by RPLLOADR.COM). The call to the Remoteboot server failed."))
      CASE_ERRCODE2(NERR_CantConnectRplSrvr                                            , _T("Remoteboot error code (used by RPLLOADR.COM). Cannot connect to the Remoteboot server."))
      CASE_ERRCODE2(NERR_CantOpenImageFile                                             , _T("Remoteboot error code (used by RPLLOADR.COM). Cannot open image file on the Remoteboot server."))
      CASE_ERRCODE2(NERR_CallingRplSrvr                                                , _T("Remoteboot error code (used by RPLLOADR.COM). Connecting to the Remoteboot server..."))
      CASE_ERRCODE2(NERR_StartingRplBoot                                               , _T("Remoteboot error code (used by RPLLOADR.COM). Connecting to the Remoteboot server..."))
      CASE_ERRCODE2(NERR_RplBootServiceTerm                                            , _T("Remoteboot error code (the alerter message of REMOTEBOOT (RPLSERVR.EXE)). Remote boot service was stopped; check the error log for the cause of the problem."))
      CASE_ERRCODE2(NERR_RplBootStartFailed                                            , _T("Remoteboot error code (for when REMOTEBOOT can't start). Remote boot startup failed; check the error log for the cause of the problem."))
      CASE_ERRCODE2(NERR_RPL_CONNECTED                                                 , _T("Remoteboot error code (for a disallowed 2nd rpl connection). A second connection to a Remoteboot resource is not allowed."))
      CASE_ERRCODE2(NERR_BrowserConfiguredToNotRun                                     , _T("Browser service API error code. The browser service was configured with MaintainServerList=No."))
      CASE_ERRCODE2(NERR_RplNoAdaptersStarted                                          , _T("Additional Remoteboot error code. Service failed to start since none of the network adapters started with this service."))
      CASE_ERRCODE2(NERR_RplBadRegistry                                                , _T("Additional Remoteboot error code. Service failed to start due to bad startup information in the registry."))
      CASE_ERRCODE2(NERR_RplBadDatabase                                                , _T("Additional Remoteboot error code. Service failed to start because its database is absent or corrupt."))
      CASE_ERRCODE2(NERR_RplRplfilesShare                                              , _T("Additional Remoteboot error code. Service failed to start because RPLFILES share is absent."))
      CASE_ERRCODE2(NERR_RplNotRplServer                                               , _T("Additional Remoteboot error code. Service failed to start because RPLUSER group is absent."))
      CASE_ERRCODE2(NERR_RplCannotEnum                                                 , _T("Additional Remoteboot error code. Cannot enumerate service records."))
      CASE_ERRCODE2(NERR_RplWkstaInfoCorrupted                                         , _T("Additional Remoteboot error code. Workstation record information has been corrupted."))
      CASE_ERRCODE2(NERR_RplWkstaNotFound                                              , _T("Additional Remoteboot error code. Workstation record was not found."))
      CASE_ERRCODE2(NERR_RplWkstaNameUnavailable                                       , _T("Additional Remoteboot error code. Workstation name is in use by some other workstation."))
      CASE_ERRCODE2(NERR_RplProfileInfoCorrupted                                       , _T("Additional Remoteboot error code. Profile record information has been corrupted."))
      CASE_ERRCODE2(NERR_RplProfileNotFound                                            , _T("Additional Remoteboot error code. Profile record was not found."))
      CASE_ERRCODE2(NERR_RplProfileNameUnavailable                                     , _T("Additional Remoteboot error code. Profile name is in use by some other profile."))
      CASE_ERRCODE2(NERR_RplProfileNotEmpty                                            , _T("Additional Remoteboot error code. There are workstations using this profile."))
      CASE_ERRCODE2(NERR_RplConfigInfoCorrupted                                        , _T("Additional Remoteboot error code. Configuration record information has been corrupted."))
      CASE_ERRCODE2(NERR_RplConfigNotFound                                             , _T("Additional Remoteboot error code. Configuration record was not found."))
      CASE_ERRCODE2(NERR_RplAdapterInfoCorrupted                                       , _T("Additional Remoteboot error code. Adapter id record information has been corrupted."))
      CASE_ERRCODE2(NERR_RplInternal                                                   , _T("Additional Remoteboot error code. An internal service error has occurred."))
      CASE_ERRCODE2(NERR_RplVendorInfoCorrupted                                        , _T("Additional Remoteboot error code. Vendor id record information has been corrupted."))
      CASE_ERRCODE2(NERR_RplBootInfoCorrupted                                          , _T("Additional Remoteboot error code. Boot block record information has been corrupted."))
      CASE_ERRCODE2(NERR_RplWkstaNeedsUserAcct                                         , _T("Additional Remoteboot error code. The user account for this workstation record is missing."))
      CASE_ERRCODE2(NERR_RplNeedsRPLUSERAcct                                           , _T("Additional Remoteboot error code. The RPLUSER local group could not be found."))
      CASE_ERRCODE2(NERR_RplBootNotFound                                               , _T("Additional Remoteboot error code. Boot block record was not found."))
      CASE_ERRCODE2(NERR_RplIncompatibleProfile                                        , _T("Additional Remoteboot error code. Chosen profile is incompatible with this workstation."))
      CASE_ERRCODE2(NERR_RplAdapterNameUnavailable                                     , _T("Additional Remoteboot error code. Chosen network adapter id is in use by some other workstation."))
      CASE_ERRCODE2(NERR_RplConfigNotEmpty                                             , _T("Additional Remoteboot error code. There are profiles using this configuration."))
      CASE_ERRCODE2(NERR_RplBootInUse                                                  , _T("Additional Remoteboot error code. There are workstations, profiles or configurations using this boot block."))
      CASE_ERRCODE2(NERR_RplBackupDatabase                                             , _T("Additional Remoteboot error code. Service failed to backup Remoteboot database."))
      CASE_ERRCODE2(NERR_RplAdapterNotFound                                            , _T("Additional Remoteboot error code. Adapter record was not found."))
      CASE_ERRCODE2(NERR_RplVendorNotFound                                             , _T("Additional Remoteboot error code. Vendor record was not found."))
      CASE_ERRCODE2(NERR_RplVendorNameUnavailable                                      , _T("Additional Remoteboot error code. Vendor name is in use by some other vendor record."))
      CASE_ERRCODE2(NERR_RplBootNameUnavailable                                        , _T("Additional Remoteboot error code. (boot name, vendor id) is in use by some other boot block record."))
      CASE_ERRCODE2(NERR_RplConfigNameUnavailable                                      , _T("Additional Remoteboot error code. Configuration name is in use by some other configuration."))
      CASE_ERRCODE2(NERR_DfsInternalCorruption                                         , _T("Dfs API error code. The internal database maintained by the DFS service is corrupt"))
      CASE_ERRCODE2(NERR_DfsVolumeDataCorrupt                                          , _T("Dfs API error code. One of the records in the internal DFS database is corrupt"))
      CASE_ERRCODE2(NERR_DfsNoSuchVolume                                               , _T("Dfs API error code. There is no DFS name whose entry path matches the input Entry Path"))
      CASE_ERRCODE2(NERR_DfsVolumeAlreadyExists                                        , _T("Dfs API error code. A root or link with the given name already exists"))
      CASE_ERRCODE2(NERR_DfsAlreadyShared                                              , _T("Dfs API error code. The server share specified is already shared in the DFS"))
      CASE_ERRCODE2(NERR_DfsNoSuchShare                                                , _T("Dfs API error code. The indicated server share does not support the indicated DFS namespace"))
      CASE_ERRCODE2(NERR_DfsNotALeafVolume                                             , _T("Dfs API error code. The operation is not valid on this portion of the namespace"))
      CASE_ERRCODE2(NERR_DfsLeafVolume                                                 , _T("Dfs API error code. The operation is not valid on this portion of the namespace"))
      CASE_ERRCODE2(NERR_DfsVolumeHasMultipleServers                                   , _T("Dfs API error code. The operation is ambiguous because the link has multiple servers"))
      CASE_ERRCODE2(NERR_DfsCantCreateJunctionPoint                                    , _T("Dfs API error code. Unable to create a link"))
      CASE_ERRCODE2(NERR_DfsServerNotDfsAware                                          , _T("Dfs API error code. The server is not DFS Aware"))
      CASE_ERRCODE2(NERR_DfsBadRenamePath                                              , _T("Dfs API error code. The specified rename target path is invalid"))
      CASE_ERRCODE2(NERR_DfsVolumeIsOffline                                            , _T("Dfs API error code. The specified DFS link is offline"))
      CASE_ERRCODE2(NERR_DfsNoSuchServer                                               , _T("Dfs API error code. The specified server is not a server for this link"))
      CASE_ERRCODE2(NERR_DfsCyclicalName                                               , _T("Dfs API error code. A cycle in the DFS name was detected"))
      CASE_ERRCODE2(NERR_DfsNotSupportedInServerDfs                                    , _T("Dfs API error code. The operation is not supported on a server-based DFS"))
#ifdef __SDK__
      CASE_ERRCODE2(NERR_DfsDuplicateService                                           , _T("Dfs API error code. This link is already supported by the specified server-share"))
      CASE_ERRCODE2(NERR_DfsCantRemoveLastServerShare                                  , _T("Dfs API error code. Can't remove the last server-share supporting this root or link"))
      CASE_ERRCODE2(NERR_DfsVolumeIsInterDfs                                           , _T("Dfs API error code. The operation is not supported for an Inter-DFS link"))
      CASE_ERRCODE2(NERR_DfsInconsistent                                               , _T("Dfs API error code. The internal state of the DFS Service has become inconsistent"))
      CASE_ERRCODE2(NERR_DfsServerUpgraded                                             , _T("Dfs API error code. The DFS Service has been installed on the specified server"))
      CASE_ERRCODE2(NERR_DfsDataIsIdentical                                            , _T("Dfs API error code. The DFS data being reconciled is identical"))
      CASE_ERRCODE2(NERR_DfsCantRemoveDfsRoot                                          , _T("Dfs API error code. The DFS root cannot be deleted - Uninstall DFS if required"))
      CASE_ERRCODE2(NERR_DfsChildOrParentInDfs                                         , _T("Dfs API error code. A child or parent directory of the share is already in a DFS"))
#endif // __SDK__
      CASE_ERRCODE2(NERR_DfsInternalError                                              , _T("Dfs API error code. DFS internal error"))
      CASE_ERRCODE2(NERR_SetupAlreadyJoined                                            , _T("Net setup error code. This machine is already joined to a domain."))
      CASE_ERRCODE2(NERR_SetupNotJoined                                                , _T("Net setup error code. This machine is not currently joined to a domain."))
      CASE_ERRCODE2(NERR_SetupDomainController                                         , _T("Net setup error code. This machine is a domain controller and cannot be unjoined from a domain."))
#ifdef __SDK__
      CASE_ERRCODE2(NERR_DefaultJoinRequired                                           , _T("Net setup error code. The destination domain controller does not support creating machine accounts in OUs."))
      CASE_ERRCODE2(NERR_InvalidWorkgroupName                                          , _T("Net setup error code. The specified workgroup name is invalid."))
      CASE_ERRCODE2(NERR_NameUsesIncompatibleCodePage                                  , _T("Net setup error code. The specified computer name is incompatible with the default language used on the domain controller."))
      CASE_ERRCODE2(NERR_ComputerAccountNotFound                                       , _T("Net setup error code. The specified computer account could not be found."))
      CASE_ERRCODE2(NERR_PersonalSku                                                   , _T("Net setup error code. This version of Windows cannot be joined to a domain."))
      CASE_ERRCODE2(NERR_PasswordMustChange                                            , _T("Some Password and account error result. Password must change at next logon"))
      CASE_ERRCODE2(NERR_AccountLockedOut                                              , _T("Some Password and account error result. Account is locked out"))
      CASE_ERRCODE2(NERR_PasswordTooLong                                               , _T("Some Password and account error result. Password is too long"))
      CASE_ERRCODE2(NERR_PasswordNotComplexEnough                                      , _T("Some Password and account error result. Password doesn't meet the complexity policy"))
      CASE_ERRCODE2(NERR_PasswordFilterError                                           , _T("Some Password and account error result. Password doesn't meet the requirements of the filter dll's"))
#endif // __SDK__
      CASE_ERRCODE2(MAX_NERR                                                           , _T("This is the last error in NERR range (network error definitions)."))

      // BEGIN part extInfo == info_WinInet
      CASE_ERRCODE2(INTERNET_ERROR_BASE                                                , _T("Internet API error"))
      CASE_ERRCODE2(ERROR_INTERNET_OUT_OF_HANDLES                                      , _T("Internet API error. No more handles could be generated at this time."))
      CASE_ERRCODE2(ERROR_INTERNET_TIMEOUT                                             , _T("Internet API error. The request has timed out."))
      CASE_ERRCODE2(ERROR_INTERNET_EXTENDED_ERROR                                      , _T("Internet API error. An extended error was returned from the server. This is typically a string or buffer containing a verbose error message. Call InternetGetLastResponseInfo to retrieve the error text."))
      CASE_ERRCODE2(ERROR_INTERNET_INTERNAL_ERROR                                      , _T("Internet API error. An internal error has occurred."))
      CASE_ERRCODE2(ERROR_INTERNET_INVALID_URL                                         , _T("Internet API error. The URL is invalid."))
      CASE_ERRCODE2(ERROR_INTERNET_UNRECOGNIZED_SCHEME                                 , _T("Internet API error. The URL scheme could not be recognized, or is not supported."))
      CASE_ERRCODE2(ERROR_INTERNET_NAME_NOT_RESOLVED                                   , _T("Internet API error. The server name could not be resolved."))
      CASE_ERRCODE2(ERROR_INTERNET_PROTOCOL_NOT_FOUND                                  , _T("Internet API error. The requested protocol could not be located."))
      CASE_ERRCODE2(ERROR_INTERNET_INVALID_OPTION                                      , _T("Internet API error. A request to InternetQueryOption or InternetSetOption specified an invalid option value."))
      CASE_ERRCODE2(ERROR_INTERNET_BAD_OPTION_LENGTH                                   , _T("Internet API error. The length of an option supplied to InternetQueryOption or InternetSetOption is incorrect for the type of option specified."))
      CASE_ERRCODE2(ERROR_INTERNET_OPTION_NOT_SETTABLE                                 , _T("Internet API error. The requested option cannot be set, only queried."))
      CASE_ERRCODE2(ERROR_INTERNET_SHUTDOWN                                            , _T("Internet API error. WinINet support is being shut down or unloaded."))
      CASE_ERRCODE2(ERROR_INTERNET_INCORRECT_USER_NAME                                 , _T("Internet API error. The request to connect and log on to an FTP server could not be completed because the supplied user name is incorrect."))
      CASE_ERRCODE2(ERROR_INTERNET_INCORRECT_PASSWORD                                  , _T("Internet API error. The request to connect and log on to an FTP server could not be completed because the supplied password is incorrect."))
      CASE_ERRCODE2(ERROR_INTERNET_LOGIN_FAILURE                                       , _T("Internet API error. The request to connect and log on to an FTP server failed."))
      CASE_ERRCODE2(ERROR_INTERNET_INVALID_OPERATION                                   , _T("Internet API error. The requested operation is invalid."))
      CASE_ERRCODE2(ERROR_INTERNET_OPERATION_CANCELLED                                 , _T("Internet API error. The operation was canceled, usually because the handle on which the request was operating was closed before the operation completed."))
      CASE_ERRCODE2(ERROR_INTERNET_INCORRECT_HANDLE_TYPE                               , _T("Internet API error. The type of handle supplied is incorrect for this operation."))
      CASE_ERRCODE2(ERROR_INTERNET_INCORRECT_HANDLE_STATE                              , _T("Internet API error. The requested operation cannot be carried out because the handle supplied is not in the correct state."))
      CASE_ERRCODE2(ERROR_INTERNET_NOT_PROXY_REQUEST                                   , _T("Internet API error. The request cannot be made via a proxy."))
      CASE_ERRCODE2(ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND                            , _T("Internet API error. A required registry value could not be located."))
      CASE_ERRCODE2(ERROR_INTERNET_BAD_REGISTRY_PARAMETER                              , _T("Internet API error. A required registry value was located but is an incorrect type or has an invalid value."))
      CASE_ERRCODE2(ERROR_INTERNET_NO_DIRECT_ACCESS                                    , _T("Internet API error. Direct network access cannot be made at this time."))
      CASE_ERRCODE2(ERROR_INTERNET_NO_CONTEXT                                          , _T("Internet API error. An asynchronous request could not be made because a zero context value was supplied."))
      CASE_ERRCODE2(ERROR_INTERNET_NO_CALLBACK                                         , _T("Internet API error. An asynchronous request could not be made because a callback function has not been set."))
      CASE_ERRCODE2(ERROR_INTERNET_REQUEST_PENDING                                     , _T("Internet API error. The required operation could not be completed because one or more requests are pending."))
      CASE_ERRCODE2(ERROR_INTERNET_INCORRECT_FORMAT                                    , _T("Internet API error. The format of the request is invalid."))
      CASE_ERRCODE2(ERROR_INTERNET_ITEM_NOT_FOUND                                      , _T("Internet API error. The requested item could not be located."))
      CASE_ERRCODE2(ERROR_INTERNET_CANNOT_CONNECT                                      , _T("Internet API error. The attempt to connect to the server failed."))
      CASE_ERRCODE2(ERROR_INTERNET_CONNECTION_ABORTED                                  , _T("Internet API error. The connection with the server has been terminated."))
      CASE_ERRCODE2(ERROR_INTERNET_CONNECTION_RESET                                    , _T("Internet API error. The connection with the server has been reset."))
      CASE_ERRCODE2(ERROR_INTERNET_FORCE_RETRY                                         , _T("Internet API error. The function needs to redo the request."))
      CASE_ERRCODE2(ERROR_INTERNET_INVALID_PROXY_REQUEST                               , _T("Internet API error. The request to the proxy was invalid."))
      CASE_ERRCODE2(ERROR_INTERNET_NEED_UI                                             , _T("Internet API error. A user interface or other blocking operation has been requested."))
      CASE_ERRCODE2(ERROR_INTERNET_HANDLE_EXISTS                                       , _T("Internet API error. The request failed because the handle already exists."))
      CASE_ERRCODE2(ERROR_INTERNET_SEC_CERT_DATE_INVALID                               , _T("Internet API error. SSL certificate date that was received from the server is bad. The certificate is expired."))
      CASE_ERRCODE2(ERROR_INTERNET_SEC_CERT_CN_INVALID                                 , _T("Internet API error. SSL certificate common name (host name field) is incorrectfor example, if you entered www.server.com and the common name on the certificate says www.different.com."))
      CASE_ERRCODE2(ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR                              , _T("Internet API error. The application is moving from a non-SSL to an SSL connection because of a redirect."))
      CASE_ERRCODE2(ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR                              , _T("Internet API error. The application is moving from an SSL to an non-SSL connection because of a redirect."))
      CASE_ERRCODE2(ERROR_INTERNET_MIXED_SECURITY                                      , _T("Internet API error. The content is not entirely secure. Some of the content being viewed may have come from unsecured servers."))
      CASE_ERRCODE2(ERROR_INTERNET_CHG_POST_IS_NON_SECURE                              , _T("Internet API error. The application is posting and attempting to change multiple lines of text on a server that is not secure."))
      CASE_ERRCODE2(ERROR_INTERNET_POST_IS_NON_SECURE                                  , _T("Internet API error. The application is posting data to a server that is not secure."))
      CASE_ERRCODE2(ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED                             , _T("Internet API error. The server is requesting client authentication."))
      CASE_ERRCODE2(ERROR_INTERNET_INVALID_CA                                          , _T("Internet API error. The function is unfamiliar with the Certificate Authority that generated the server's certificate."))
      CASE_ERRCODE2(ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP                               , _T("Internet API error. Client authorization is not set up on this computer."))
      CASE_ERRCODE2(ERROR_INTERNET_ASYNC_THREAD_FAILED                                 , _T("Internet API error. The application could not start an asynchronous thread."))
      CASE_ERRCODE2(ERROR_INTERNET_REDIRECT_SCHEME_CHANGE                              , _T("Internet API error. The function could not handle the redirection, because the scheme changed (for example, HTTP to FTP)."))
      CASE_ERRCODE2(ERROR_INTERNET_DIALOG_PENDING                                      , _T("Internet API error. Another thread has a password dialog box in progress."))
      CASE_ERRCODE2(ERROR_INTERNET_RETRY_DIALOG                                        , _T("Internet API error. The dialog box should be retried."))
      CASE_ERRCODE2(ERROR_INTERNET_HTTPS_HTTP_SUBMIT_REDIR                             , _T("Internet API error. The data being submitted to an SSL connection is being redirected to a non-SSL connection."))
      CASE_ERRCODE2(ERROR_INTERNET_INSERT_CDROM                                        , _T("Internet API error. The request requires a CD-ROM to be inserted in the CD-ROM drive to locate the resource requested."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_INTERNET_FORTEZZA_LOGIN_NEEDED                               , _T("Internet API error. The requested resource requires Fortezza authentication."))
      CASE_ERRCODE2(ERROR_INTERNET_SEC_CERT_ERRORS                                     , _T("Internet API error. The SSL certificate contains errors."))
      CASE_ERRCODE2(ERROR_INTERNET_SEC_CERT_NO_REV                                     , _T("Internet API error"))
      CASE_ERRCODE2(ERROR_INTERNET_SEC_CERT_REV_FAILED                                 , _T("Internet API error"))
      CASE_ERRCODE2(ERROR_FTP_TRANSFER_IN_PROGRESS                                     , _T("FTP API error. The requested operation cannot be made on the FTP session handle because an operation is already in progress."))
      CASE_ERRCODE2(ERROR_FTP_DROPPED                                                  , _T("FTP API error. The FTP operation was not completed because the session was aborted."))
      CASE_ERRCODE2(ERROR_FTP_NO_PASSIVE_MODE                                          , _T("FTP API error. Passive mode is not available on the server."))
      CASE_ERRCODE2(ERROR_GOPHER_PROTOCOL_ERROR                                        , _T("Gopher API error. An error was detected while parsing data returned from the Gopher server."))
      CASE_ERRCODE2(ERROR_GOPHER_NOT_FILE                                              , _T("Gopher API error. The request must be made for a file locator."))
      CASE_ERRCODE2(ERROR_GOPHER_DATA_ERROR                                            , _T("Gopher API error. An error was detected while receiving data from the Gopher server."))
      CASE_ERRCODE2(ERROR_GOPHER_END_OF_DATA                                           , _T("Gopher API error. The end of the data has been reached."))
      CASE_ERRCODE2(ERROR_GOPHER_INVALID_LOCATOR                                       , _T("Gopher API error. The supplied locator is not valid. "))
      CASE_ERRCODE2(ERROR_GOPHER_INCORRECT_LOCATOR_TYPE                                , _T("Gopher API error. The type of the locator is not correct for this operation."))
      CASE_ERRCODE2(ERROR_GOPHER_NOT_GOPHER_PLUS                                       , _T("Gopher API error. The requested operation can be made only against a Gopher+ server, or with a locator that specifies a Gopher+ operation."))
      CASE_ERRCODE2(ERROR_GOPHER_ATTRIBUTE_NOT_FOUND                                   , _T("Gopher API error. The requested attribute could not be located."))
      CASE_ERRCODE2(ERROR_GOPHER_UNKNOWN_LOCATOR                                       , _T("Gopher API error. The locator type is unknown."))
      CASE_ERRCODE2(ERROR_HTTP_HEADER_NOT_FOUND                                        , _T("HTTP API error. The requested header could not be located."))
      CASE_ERRCODE2(ERROR_HTTP_DOWNLEVEL_SERVER                                        , _T("HTTP API error. The server did not return any headers."))
      CASE_ERRCODE2(ERROR_HTTP_INVALID_SERVER_RESPONSE                                 , _T("HTTP API error. The server response could not be parsed."))
      CASE_ERRCODE2(ERROR_HTTP_INVALID_HEADER                                          , _T("HTTP API error. The supplied header is invalid."))
      CASE_ERRCODE2(ERROR_HTTP_INVALID_QUERY_REQUEST                                   , _T("HTTP API error. The request made to HttpQueryInfo is invalid."))
      CASE_ERRCODE2(ERROR_HTTP_HEADER_ALREADY_EXISTS                                   , _T("HTTP API error. The header could not be added because it already exists."))
      CASE_ERRCODE2(ERROR_HTTP_REDIRECT_FAILED                                         , _T("HTTP API error. The redirection failed because either the scheme changed (for example, HTTP to FTP) or all attempts made to redirect failed (default is five attempts)."))
      CASE_ERRCODE2(ERROR_HTTP_NOT_REDIRECTED                                          , _T("HTTP API error. The HTTP request was not redirected."))
      CASE_ERRCODE2(ERROR_HTTP_COOKIE_NEEDS_CONFIRMATION                               , _T("HTTP API error. The HTTP cookie requires confirmation."))
      CASE_ERRCODE2(ERROR_HTTP_COOKIE_DECLINED                                         , _T("HTTP API error. The HTTP cookie was declined by the server."))
      CASE_ERRCODE2(ERROR_HTTP_REDIRECT_NEEDS_CONFIRMATION                             , _T("HTTP API error. The redirection requires user confirmation."))
      CASE_ERRCODE2(ERROR_INTERNET_SECURITY_CHANNEL_ERROR                              , _T("Additional Internet API error code. The application experienced an internal error loading the SSL libraries."))
      CASE_ERRCODE2(ERROR_INTERNET_UNABLE_TO_CACHE_FILE                                , _T("Additional Internet API error code. The function was unable to cache the file."))
      CASE_ERRCODE2(ERROR_INTERNET_TCPIP_NOT_INSTALLED                                 , _T("Additional Internet API error code. The required protocol stack is not loaded and the application cannot start WinSock."))
      CASE_ERRCODE2(ERROR_INTERNET_DISCONNECTED                                        , _T("Additional Internet API error code. The Internet connection has been lost."))
      CASE_ERRCODE2(ERROR_INTERNET_SERVER_UNREACHABLE                                  , _T("Additional Internet API error code. The Web site or server indicated is unreachable."))
      CASE_ERRCODE2(ERROR_INTERNET_PROXY_SERVER_UNREACHABLE                            , _T("Additional Internet API error code. The designated proxy server cannot be reached."))
      CASE_ERRCODE2(ERROR_INTERNET_BAD_AUTO_PROXY_SCRIPT                               , _T("Additional Internet API error code. There was an error in the automatic proxy configuration script."))
      CASE_ERRCODE2(ERROR_INTERNET_UNABLE_TO_DOWNLOAD_SCRIPT                           , _T("Additional Internet API error code. The automatic proxy configuration script could not be downloaded. The INTERNET_FLAG_MUST_CACHE_REQUEST flag was set."))
      CASE_ERRCODE2(ERROR_INTERNET_SEC_INVALID_CERT                                    , _T("Additional Internet API error code. SSL certificate is invalid."))
      CASE_ERRCODE2(ERROR_INTERNET_SEC_CERT_REVOKED                                    , _T("Additional Internet API error code. SSL certificate was revoked."))
      CASE_ERRCODE2(ERROR_INTERNET_FAILED_DUETOSECURITYCHECK                           , _T("InternetAutodial specific error. The function failed due to a security check."))
      CASE_ERRCODE2(ERROR_INTERNET_NOT_INITIALIZED                                     , _T("InternetAutodial specific error. Initialization of the WinINet API has not occurred. Indicates that a higher-level function, such as InternetOpen, has not been called yet."))
      CASE_ERRCODE2(ERROR_INTERNET_NEED_MSN_SSPI_PKG                                   , _T("InternetAutodial specific error. Not currently implemented (2003)"))
      CASE_ERRCODE2(ERROR_INTERNET_LOGIN_FAILURE_DISPLAY_ENTITY_BODY                   , _T("InternetAutodial specific error. The MS-Logoff digest header has been returned from the Web site. This header specifically instructs the digest package to purge credentials for the associated realm. This error will only be returned if INTERNET_ERROR_MASK_LOGIN_FAILURE_DISPLAY_ENTITY_BODY has been set."))
#endif // __SDK__
      // END part extInfo == info_WinInet

      // BEGIN part extInfo == info_HResult
    //CASE_ERRCODE2(S_OK                                                               , _T("Success codes"))
    //CASE_ERRCODE2(S_FALSE                                                            , _T("Success codes"))
      CASE_ERRCODE2(E_UNEXPECTED                                                       , _T("Catastrophic failure"))
      CASE_ERRCODE2(E_NOTIMPL                                                          , _T("Not implemented"))
      CASE_ERRCODE2(E_OUTOFMEMORY                                                      , _T("Ran out of memory"))
      CASE_ERRCODE2(E_INVALIDARG                                                       , _T("One or more arguments are invalid"))
      CASE_ERRCODE2(E_NOINTERFACE                                                      , _T("No such interface supported"))
      CASE_ERRCODE2(E_POINTER                                                          , _T("Invalid pointer"))
      CASE_ERRCODE2(E_HANDLE                                                           , _T("Invalid handle"))
      CASE_ERRCODE2(E_ABORT                                                            , _T("Operation aborted"))
      CASE_ERRCODE2(E_FAIL                                                             , _T("Unspecified error"))
      CASE_ERRCODE2(E_ACCESSDENIED                                                     , _T("General access denied error"))
      CASE_ERRCODE2(E_PENDING                                                          , _T("The read operation is pending (The data necessary to complete this operation is not yet available)."))
      CASE_ERRCODE2(CO_E_INIT_TLS                                                      , _T("Thread local storage failure"))
      CASE_ERRCODE2(CO_E_INIT_SHARED_ALLOCATOR                                         , _T("Get shared memory allocator failure"))
      CASE_ERRCODE2(CO_E_INIT_MEMORY_ALLOCATOR                                         , _T("Get memory allocator failure"))
      CASE_ERRCODE2(CO_E_INIT_CLASS_CACHE                                              , _T("Unable to initialize class cache"))
      CASE_ERRCODE2(CO_E_INIT_RPC_CHANNEL                                              , _T("Unable to initialize RPC services"))
      CASE_ERRCODE2(CO_E_INIT_TLS_SET_CHANNEL_CONTROL                                  , _T("Cannot set thread local storage channel control"))
      CASE_ERRCODE2(CO_E_INIT_TLS_CHANNEL_CONTROL                                      , _T("Could not allocate thread local storage channel control"))
      CASE_ERRCODE2(CO_E_INIT_UNACCEPTED_USER_ALLOCATOR                                , _T("The user supplied memory allocator is unacceptable"))
      CASE_ERRCODE2(CO_E_INIT_SCM_MUTEX_EXISTS                                         , _T("The OLE service mutex already exists"))
      CASE_ERRCODE2(CO_E_INIT_SCM_FILE_MAPPING_EXISTS                                  , _T("The OLE service file mapping already exists"))
      CASE_ERRCODE2(CO_E_INIT_SCM_MAP_VIEW_OF_FILE                                     , _T("Unable to map view of file for OLE service"))
      CASE_ERRCODE2(CO_E_INIT_SCM_EXEC_FAILURE                                         , _T("Failure attempting to launch OLE service"))
      CASE_ERRCODE2(CO_E_INIT_ONLY_SINGLE_THREADED                                     , _T("There was an attempt to call CoInitialize a second time while single threaded"))
      CASE_ERRCODE2(CO_E_CANT_REMOTE                                                   , _T("A Remote activation was necessary but was not allowed"))
      CASE_ERRCODE2(CO_E_BAD_SERVER_NAME                                               , _T("A Remote activation was necessary but the server name provided was invalid"))
      CASE_ERRCODE2(CO_E_WRONG_SERVER_IDENTITY                                         , _T("The class is configured to run as a security id different from the caller"))
      CASE_ERRCODE2(CO_E_OLE1DDE_DISABLED                                              , _T("Use of Ole1 services requiring DDE windows is disabled"))
      CASE_ERRCODE2(CO_E_RUNAS_SYNTAX                                                  , _T("A RunAs specification must be <domain name>\\<user name> or simply <user name>"))
      CASE_ERRCODE2(CO_E_CREATEPROCESS_FAILURE                                         , _T("The server process could not be started.  The pathname may be incorrect."))
      CASE_ERRCODE2(CO_E_RUNAS_CREATEPROCESS_FAILURE                                   , _T("The server process could not be started as the configured identity.  The pathname may be incorrect or unavailable."))
      CASE_ERRCODE2(CO_E_RUNAS_LOGON_FAILURE                                           , _T("The server process could not be started because the configured identity is incorrect.  Check the username and password."))
      CASE_ERRCODE2(CO_E_LAUNCH_PERMSSION_DENIED                                       , _T("The client is not allowed to launch this server."))
      CASE_ERRCODE2(CO_E_START_SERVICE_FAILURE                                         , _T("The service providing this server could not be started."))
      CASE_ERRCODE2(CO_E_REMOTE_COMMUNICATION_FAILURE                                  , _T("This computer was unable to communicate with the computer providing the server."))
      CASE_ERRCODE2(CO_E_SERVER_START_TIMEOUT                                          , _T("The server did not respond after being launched."))
      CASE_ERRCODE2(CO_E_CLSREG_INCONSISTENT                                           , _T("The registration information for this server is inconsistent or incomplete."))
      CASE_ERRCODE2(CO_E_IIDREG_INCONSISTENT                                           , _T("The registration information for this interface is inconsistent or incomplete."))
      CASE_ERRCODE2(CO_E_NOT_SUPPORTED                                                 , _T("The operation attempted is not supported."))
      CASE_ERRCODE2(CO_E_RELOAD_DLL                                                    , _T("A dll must be loaded."))
      CASE_ERRCODE2(CO_E_MSI_ERROR                                                     , _T("A Microsoft Software Installer error was encountered."))
#ifdef __SDK__
      CASE_ERRCODE2(CO_E_ATTEMPT_TO_CREATE_OUTSIDE_CLIENT_CONTEXT                      , _T("The specified activation could not occur in the client context as specified."))
      CASE_ERRCODE2(CO_E_SERVER_PAUSED                                                 , _T("Activations on the server are paused."))
      CASE_ERRCODE2(CO_E_SERVER_NOT_PAUSED                                             , _T("Activations on the server are not paused."))
      CASE_ERRCODE2(CO_E_CLASS_DISABLED                                                , _T("The component or application containing the component has been disabled."))
      CASE_ERRCODE2(CO_E_CLRNOTAVAILABLE                                               , _T("The common language runtime is not available"))
      CASE_ERRCODE2(CO_E_ASYNC_WORK_REJECTED                                           , _T("The thread-pool rejected the submitted asynchronous work."))
      CASE_ERRCODE2(CO_E_SERVER_INIT_TIMEOUT                                           , _T("The server started, but did not finish initializing in a timely fashion."))
      CASE_ERRCODE2(CO_E_NO_SECCTX_IN_ACTIVATE                                         , _T("Unable to complete the call since there is no COM+ security context inside IObjectControl.Activate."))
      CASE_ERRCODE2(CO_E_TRACKER_CONFIG                                                , _T("The provided tracker configuration is invalid"))
      CASE_ERRCODE2(CO_E_THREADPOOL_CONFIG                                             , _T("The provided thread pool configuration is invalid"))
      CASE_ERRCODE2(CO_E_SXS_CONFIG                                                    , _T("The provided side-by-side configuration is invalid"))
      CASE_ERRCODE2(CO_E_MALFORMED_SPN                                                 , _T("The server principal name (SPN) obtained during security negotiation is malformed."))
#endif // __SDK__
      CASE_ERRCODE2(OLE_E_OLEVERB                                                      , _T("Invalid OLEVERB structure"))
      CASE_ERRCODE2(OLE_E_ADVF                                                         , _T("Invalid advise flags"))
      CASE_ERRCODE2(OLE_E_ENUM_NOMORE                                                  , _T("Can't enumerate any more, because the associated data is missing"))
      CASE_ERRCODE2(OLE_E_ADVISENOTSUPPORTED                                           , _T("This implementation doesn't take advises"))
      CASE_ERRCODE2(OLE_E_NOCONNECTION                                                 , _T("There is no connection for this connection ID"))
      CASE_ERRCODE2(OLE_E_NOTRUNNING                                                   , _T("Need to run the object to perform this operation"))
      CASE_ERRCODE2(OLE_E_NOCACHE                                                      , _T("There is no cache to operate on"))
      CASE_ERRCODE2(OLE_E_BLANK                                                        , _T("Uninitialized object"))
      CASE_ERRCODE2(OLE_E_CLASSDIFF                                                    , _T("Linked object's source class has changed"))
      CASE_ERRCODE2(OLE_E_CANT_GETMONIKER                                              , _T("Not able to get the moniker of the object"))
      CASE_ERRCODE2(OLE_E_CANT_BINDTOSOURCE                                            , _T("Not able to bind to the source"))
      CASE_ERRCODE2(OLE_E_STATIC                                                       , _T("Object is static; operation not allowed"))
      CASE_ERRCODE2(OLE_E_PROMPTSAVECANCELLED                                          , _T("User canceled out of save dialog"))
      CASE_ERRCODE2(OLE_E_INVALIDRECT                                                  , _T("Invalid rectangle"))
      CASE_ERRCODE2(OLE_E_WRONGCOMPOBJ                                                 , _T("compobj.dll is too old for the ole2.dll initialized"))
      CASE_ERRCODE2(OLE_E_INVALIDHWND                                                  , _T("Invalid window handle"))
      CASE_ERRCODE2(OLE_E_NOT_INPLACEACTIVE                                            , _T("Object is not in any of the inplace active states"))
      CASE_ERRCODE2(OLE_E_CANTCONVERT                                                  , _T("Not able to convert object"))
      CASE_ERRCODE2(OLE_E_NOSTORAGE                                                    , _T("Not able to perform the operation because object is not given storage yet"))
      CASE_ERRCODE2(DV_E_FORMATETC                                                     , _T("Invalid FORMATETC structure"))
      CASE_ERRCODE2(DV_E_DVTARGETDEVICE                                                , _T("Invalid DVTARGETDEVICE structure"))
      CASE_ERRCODE2(DV_E_STGMEDIUM                                                     , _T("Invalid STDGMEDIUM structure"))
      CASE_ERRCODE2(DV_E_STATDATA                                                      , _T("Invalid STATDATA structure"))
      CASE_ERRCODE2(DV_E_LINDEX                                                        , _T("Invalid lindex"))
      CASE_ERRCODE2(DV_E_TYMED                                                         , _T("Invalid tymed"))
      CASE_ERRCODE2(DV_E_CLIPFORMAT                                                    , _T("Invalid clipboard format"))
      CASE_ERRCODE2(DV_E_DVASPECT                                                      , _T("Invalid aspect(s)"))
      CASE_ERRCODE2(DV_E_DVTARGETDEVICE_SIZE                                           , _T("tdSize parameter of the DVTARGETDEVICE structure is invalid"))
      CASE_ERRCODE2(DV_E_NOIVIEWOBJECT                                                 , _T("Object doesn't support IViewObject interface"))
      CASE_ERRCODE2(DRAGDROP_E_NOTREGISTERED                                           , _T("Trying to revoke a drop target that has not been registered"))
      CASE_ERRCODE2(DRAGDROP_E_ALREADYREGISTERED                                       , _T("This window has already been registered as a drop target"))
      CASE_ERRCODE3(DRAGDROP_E_INVALIDHWND,
                _T("DRAGDROP_E_INVALIDHWND or CdoE_NO_SUPPORT")                        , _T("Invalid window handle; or CdoE_NO_SUPPORT"))
      CASE_ERRCODE3(CLASS_E_NOAGGREGATION,
                _T("CLASS_E_NOAGGREGATION or CdoE_VERSION")                            , _T("Class does not support aggregation (or class object is remote); or CdoE_VERSION"))
      CASE_ERRCODE3(CLASS_E_CLASSNOTAVAILABLE,
                _T("CLASS_E_CLASSNOTAVAILABLE or CdoE_LOGON_FAILED")                   , _T("ClassFactory cannot supply requested class; or CdoE_LOGON_FAILED"))
      CASE_ERRCODE3(CLASS_E_NOTLICENSED,
                _T("CLASS_E_NOTLICENSED or CdoE_SESSION_LIMIT")                        , _T("Class is not licensed for use; or CdoE_SESSION_LIMIT"))
      CASE_ERRCODE2(VIEW_E_DRAW                                                        , _T("Error drawing view"))
      CASE_ERRCODE2(REGDB_E_READREGDB                                                  , _T("Could not read key from registry"))
      CASE_ERRCODE2(REGDB_E_WRITEREGDB                                                 , _T("Could not write key to registry"))
      CASE_ERRCODE2(REGDB_E_KEYMISSING                                                 , _T("Could not find the key in the registry"))
      CASE_ERRCODE2(REGDB_E_INVALIDVALUE                                               , _T("Invalid value for registry"))
      CASE_ERRCODE2(REGDB_E_CLASSNOTREG                                                , _T("Class not registered"))
      CASE_ERRCODE2(REGDB_E_IIDNOTREG                                                  , _T("Interface not registered"))
#ifdef __SDK__
      CASE_ERRCODE2(REGDB_E_BADTHREADINGMODEL                                          , _T("Threading model entry is not valid"))
#endif // __SDK__
      CASE_ERRCODE2(CAT_E_CATIDNOEXIST                                                 , _T("CATID does not exist"))
      CASE_ERRCODE2(CAT_E_NODESCRIPTION                                                , _T("Description not found"))
      CASE_ERRCODE2(CS_E_PACKAGE_NOTFOUND                                              , _T("No package in the software installation data in the Active Directory meets this criteria."))
      CASE_ERRCODE2(CS_E_NOT_DELETABLE                                                 , _T("Deleting this will break the referential integrity of the software installation data in the Active Directory."))
      CASE_ERRCODE2(CS_E_CLASS_NOTFOUND                                                , _T("The CLSID was not found in the software installation data in the Active Directory."))
      CASE_ERRCODE2(CS_E_INVALID_VERSION                                               , _T("The software installation data in the Active Directory is corrupt."))
      CASE_ERRCODE2(CS_E_NO_CLASSSTORE                                                 , _T("There is no software installation data in the Active Directory."))
#ifdef __SDK__
      CASE_ERRCODE2(CS_E_OBJECT_NOTFOUND                                               , _T("There is no software installation data object in the Active Directory."))
      CASE_ERRCODE2(CS_E_OBJECT_ALREADY_EXISTS                                         , _T("The software installation data object in the Active Directory already exists."))
      CASE_ERRCODE2(CS_E_INVALID_PATH                                                  , _T("The path to the software installation data in the Active Directory is not correct."))
      CASE_ERRCODE2(CS_E_NETWORK_ERROR                                                 , _T("A network error interrupted the operation."))
      CASE_ERRCODE2(CS_E_ADMIN_LIMIT_EXCEEDED                                          , _T("The size of this object exceeds the maximum size set by the Administrator."))
      CASE_ERRCODE2(CS_E_SCHEMA_MISMATCH                                               , _T("The schema for the software installation data in the Active Directory does not match the required schema."))
      CASE_ERRCODE2(CS_E_INTERNAL_ERROR                                                , _T("An error occurred in the software installation data in the Active Directory."))
#endif // __SDK__
      CASE_ERRCODE2(CACHE_E_NOCACHE_UPDATED                                            , _T("Cache not updated"))
      CASE_ERRCODE2(OLEOBJ_E_NOVERBS                                                   , _T("No verbs for OLE object"))
      CASE_ERRCODE2(OLEOBJ_E_INVALIDVERB                                               , _T("Invalid verb for OLE object"))
      CASE_ERRCODE2(INPLACE_E_NOTUNDOABLE                                              , _T("Undo is not available"))
      CASE_ERRCODE2(INPLACE_E_NOTOOLSPACE                                              , _T("Space for tools is not available"))
      CASE_ERRCODE2(CONVERT10_E_OLESTREAM_GET                                          , _T("OLESTREAM Get method failed"))
      CASE_ERRCODE2(CONVERT10_E_OLESTREAM_PUT                                          , _T("OLESTREAM Put method failed"))
      CASE_ERRCODE2(CONVERT10_E_OLESTREAM_FMT                                          , _T("Contents of the OLESTREAM not in correct format"))
      CASE_ERRCODE2(CONVERT10_E_OLESTREAM_BITMAP_TO_DIB                                , _T("There was an error in a Windows GDI call while converting the bitmap to a DIB"))
      CASE_ERRCODE2(CONVERT10_E_STG_FMT                                                , _T("Contents of the IStorage not in correct format"))
      CASE_ERRCODE2(CONVERT10_E_STG_NO_STD_STREAM                                      , _T("Contents of IStorage is missing one of the standard streams"))
      CASE_ERRCODE2(CONVERT10_E_STG_DIB_TO_BITMAP                                      , _T("There was an error in a Windows GDI call while converting the DIB to a bitmap."))
      CASE_ERRCODE2(CLIPBRD_E_CANT_OPEN                                                , _T("OpenClipboard Failed"))
      CASE_ERRCODE2(CLIPBRD_E_CANT_EMPTY                                               , _T("EmptyClipboard Failed"))
      CASE_ERRCODE2(CLIPBRD_E_CANT_SET                                                 , _T("SetClipboard Failed"))
      CASE_ERRCODE2(CLIPBRD_E_BAD_DATA                                                 , _T("Data on clipboard is invalid"))
      CASE_ERRCODE2(CLIPBRD_E_CANT_CLOSE                                               , _T("CloseClipboard Failed"))
      CASE_ERRCODE2(MK_E_CONNECTMANUALLY                                               , _T("Moniker needs to be connected manually"))
      CASE_ERRCODE2(MK_E_EXCEEDEDDEADLINE                                              , _T("Operation exceeded deadline"))
      CASE_ERRCODE2(MK_E_NEEDGENERIC                                                   , _T("Moniker needs to be generic"))
      CASE_ERRCODE2(MK_E_UNAVAILABLE                                                   , _T("Operation unavailable"))
      CASE_ERRCODE2(MK_E_SYNTAX                                                        , _T("Invalid syntax"))
      CASE_ERRCODE2(MK_E_NOOBJECT                                                      , _T("No object for moniker"))
      CASE_ERRCODE2(MK_E_INVALIDEXTENSION                                              , _T("Bad extension for file"))
      CASE_ERRCODE2(MK_E_INTERMEDIATEINTERFACENOTSUPPORTED                             , _T("Intermediate operation failed"))
      CASE_ERRCODE2(MK_E_NOTBINDABLE                                                   , _T("Moniker is not bindable"))
      CASE_ERRCODE2(MK_E_NOTBOUND                                                      , _T("Moniker is not bound"))
      CASE_ERRCODE2(MK_E_CANTOPENFILE                                                  , _T("Moniker cannot open file"))
      CASE_ERRCODE2(MK_E_MUSTBOTHERUSER                                                , _T("User input required for operation to succeed"))
      CASE_ERRCODE2(MK_E_NOINVERSE                                                     , _T("Moniker class has no inverse"))
      CASE_ERRCODE2(MK_E_NOSTORAGE                                                     , _T("Moniker does not refer to storage"))
      CASE_ERRCODE2(MK_E_NOPREFIX                                                      , _T("No common prefix"))
      CASE_ERRCODE2(MK_E_ENUMERATION_FAILED                                            , _T("Moniker could not be enumerated"))
      CASE_ERRCODE2(CO_E_NOTINITIALIZED                                                , _T("CoInitialize has not been called."))
      CASE_ERRCODE2(CO_E_ALREADYINITIALIZED                                            , _T("CoInitialize has already been called."))
      CASE_ERRCODE2(CO_E_CANTDETERMINECLASS                                            , _T("Class of object cannot be determined"))
      CASE_ERRCODE2(CO_E_CLASSSTRING                                                   , _T("Invalid class string"))
      CASE_ERRCODE2(CO_E_IIDSTRING                                                     , _T("Invalid interface string"))
      CASE_ERRCODE2(CO_E_APPNOTFOUND                                                   , _T("Application not found"))
      CASE_ERRCODE2(CO_E_APPSINGLEUSE                                                  , _T("Application cannot be run more than once"))
      CASE_ERRCODE2(CO_E_ERRORINAPP                                                    , _T("Some error in application program"))
      CASE_ERRCODE2(CO_E_DLLNOTFOUND                                                   , _T("DLL for class not found"))
      CASE_ERRCODE2(CO_E_ERRORINDLL                                                    , _T("Error in the DLL"))
      CASE_ERRCODE2(CO_E_WRONGOSFORAPP                                                 , _T("Wrong OS or OS version for application"))
      CASE_ERRCODE2(CO_E_OBJNOTREG                                                     , _T("Object is not registered"))
      CASE_ERRCODE2(CO_E_OBJISREG                                                      , _T("Object is already registered"))
      CASE_ERRCODE2(CO_E_OBJNOTCONNECTED                                               , _T("Object is not connected to server"))
      CASE_ERRCODE2(CO_E_APPDIDNTREG                                                   , _T("Application was launched but it didn't register a class factory"))
      CASE_ERRCODE2(CO_E_RELEASED                                                      , _T("Object has been released"))
#ifdef __SDK__
      CASE_ERRCODE3(EVENT_E_FIRST,
                _T("EVENT_E_FIRST or CdoE_END_OF_SESSION")                             , _T("EVENT_E_FIRST or CdoE_END_OF_SESSION"))
      CASE_ERRCODE1(EVENT_E_LAST)
    //CASE_ERRCODE1(EVENT_S_FIRST)
      CASE_ERRCODE1(EVENT_S_LAST)

      CASE_ERRCODE2(EVENT_S_SOME_SUBSCRIBERS_FAILED                                    , _T("An event was able to invoke some but not all of the subscribers"))
      CASE_ERRCODE3(EVENT_E_ALL_SUBSCRIBERS_FAILED,
                _T("EVENT_E_ALL_SUBSCRIBERS_FAILED or CdoE_UNKNOWN_ENTRYID")           , _T("An event was unable to invoke any of the subscribers; or CdoE_UNKNOWN_ENTRYID"))
      CASE_ERRCODE2(EVENT_S_NOSUBSCRIBERS                                              , _T("An event was delivered but there were no subscribers"))
      CASE_ERRCODE2(EVENT_E_QUERYSYNTAX                                                , _T("A syntax error occurred trying to evaluate a query string"))
      CASE_ERRCODE2(EVENT_E_QUERYFIELD                                                 , _T("An invalid field name was used in a query string"))
      CASE_ERRCODE2(EVENT_E_INTERNALEXCEPTION                                          , _T("An unexpected exception was raised"))
      CASE_ERRCODE2(EVENT_E_INTERNALERROR                                              , _T("An unexpected internal error was detected"))
      CASE_ERRCODE2(EVENT_E_INVALID_PER_USER_SID                                       , _T("The owner SID on a per-user subscription doesn't exist"))
      CASE_ERRCODE2(EVENT_E_USER_EXCEPTION                                             , _T("A user-supplied component or subscriber raised an exception"))
      CASE_ERRCODE2(EVENT_E_TOO_MANY_METHODS                                           , _T("An interface has too many methods to fire events from"))
      CASE_ERRCODE2(EVENT_E_MISSING_EVENTCLASS                                         , _T("A subscription cannot be stored unless its event class already exists"))
      CASE_ERRCODE2(EVENT_E_NOT_ALL_REMOVED                                            , _T("Not all the objects requested could be removed"))
      CASE_ERRCODE2(EVENT_E_COMPLUS_NOT_INSTALLED                                      , _T("COM+ is required for this operation, but is not installed"))
      CASE_ERRCODE2(EVENT_E_CANT_MODIFY_OR_DELETE_UNCONFIGURED_OBJECT                  , _T("Cannot modify or delete an object that was not added using the COM+ Admin SDK"))
      CASE_ERRCODE2(EVENT_E_CANT_MODIFY_OR_DELETE_CONFIGURED_OBJECT                    , _T("Cannot modify or delete an object that was added using the COM+ Admin SDK"))
      CASE_ERRCODE2(EVENT_E_INVALID_EVENT_CLASS_PARTITION                              , _T("The event class for this subscription is in an invalid partition"))
      CASE_ERRCODE2(EVENT_E_PER_USER_SID_NOT_LOGGED_ON                                 , _T("The owner of the PerUser subscription is not logged on to the system specified"))
      CASE_ERRCODE2(XACT_E_ALREADYOTHERSINGLEPHASE                                     , _T("Another single phase resource manager has already been enlisted in this transaction."))
      CASE_ERRCODE2(XACT_E_CANTRETAIN                                                  , _T("A retaining commit or abort is not supported"))
      CASE_ERRCODE2(XACT_E_COMMITFAILED                                                , _T("The transaction failed to commit for an unknown reason. The transaction was aborted."))
      CASE_ERRCODE2(XACT_E_COMMITPREVENTED                                             , _T("Cannot call commit on this transaction object because the calling application did not initiate the transaction."))
      CASE_ERRCODE2(XACT_E_HEURISTICABORT                                              , _T("Instead of committing, the resource heuristically aborted."))
      CASE_ERRCODE2(XACT_E_HEURISTICCOMMIT                                             , _T("Instead of aborting, the resource heuristically committed."))
      CASE_ERRCODE2(XACT_E_HEURISTICDAMAGE                                             , _T("Some of the states of the resource were committed while others were aborted, likely because of heuristic decisions."))
      CASE_ERRCODE2(XACT_E_HEURISTICDANGER                                             , _T("Some of the states of the resource may have been committed while others may have been aborted, likely because of heuristic decisions."))
      CASE_ERRCODE2(XACT_E_ISOLATIONLEVEL                                              , _T("The requested isolation level is not valid or supported."))
      CASE_ERRCODE2(XACT_E_NOASYNC                                                     , _T("The transaction manager doesn't support an asynchronous operation for this method."))
      CASE_ERRCODE2(XACT_E_NOENLIST                                                    , _T("Unable to enlist in the transaction."))
      CASE_ERRCODE2(XACT_E_NOISORETAIN                                                 , _T("The requested semantics of retention of isolation across retaining commit and abort boundaries cannot be supported by this transaction implementation, or isoFlags was not equal to zero."))
      CASE_ERRCODE2(XACT_E_NORESOURCE                                                  , _T("There is no resource presently associated with this enlistment"))
      CASE_ERRCODE2(XACT_E_NOTCURRENT                                                  , _T("The transaction failed to commit due to the failure of optimistic concurrency control in at least one of the resource managers."))
      CASE_ERRCODE2(XACT_E_NOTRANSACTION                                               , _T("The transaction has already been implicitly or explicitly committed or aborted"))
      CASE_ERRCODE2(XACT_E_NOTSUPPORTED                                                , _T("An invalid combination of flags was specified"))
      CASE_ERRCODE2(XACT_E_UNKNOWNRMGRID                                               , _T("The resource manager id is not associated with this transaction or the transaction manager."))
      CASE_ERRCODE2(XACT_E_WRONGSTATE                                                  , _T("This method was called in the wrong state"))
      CASE_ERRCODE2(XACT_E_WRONGUOW                                                    , _T("The indicated unit of work does not match the unit of work expected by the resource manager."))
      CASE_ERRCODE2(XACT_E_XTIONEXISTS                                                 , _T("An enlistment in a transaction already exists."))
      CASE_ERRCODE2(XACT_E_NOIMPORTOBJECT                                              , _T("An import object for the transaction could not be found."))
      CASE_ERRCODE2(XACT_E_INVALIDCOOKIE                                               , _T("The transaction cookie is invalid."))
      CASE_ERRCODE2(XACT_E_INDOUBT                                                     , _T("The transaction status is in doubt. A communication failure occurred, or a transaction manager or resource manager has failed"))
      CASE_ERRCODE2(XACT_E_NOTIMEOUT                                                   , _T("A time-out was specified, but time-outs are not supported."))
      CASE_ERRCODE2(XACT_E_ALREADYINPROGRESS                                           , _T("The requested operation is already in progress for the transaction."))
      CASE_ERRCODE2(XACT_E_ABORTED                                                     , _T("The transaction has already been aborted."))
      CASE_ERRCODE2(XACT_E_LOGFULL                                                     , _T("The Transaction Manager returned a log full error."))
      CASE_ERRCODE2(XACT_E_TMNOTAVAILABLE                                              , _T("The Transaction Manager is not available."))
      CASE_ERRCODE2(XACT_E_CONNECTION_DOWN                                             , _T("A connection with the transaction manager was lost."))
      CASE_ERRCODE2(XACT_E_CONNECTION_DENIED                                           , _T("A request to establish a connection with the transaction manager was denied."))
      CASE_ERRCODE2(XACT_E_REENLISTTIMEOUT                                             , _T("Resource manager reenlistment to determine transaction status timed out."))
      CASE_ERRCODE2(XACT_E_TIP_CONNECT_FAILED                                          , _T("This transaction manager failed to establish a connection with another TIP transaction manager."))
      CASE_ERRCODE2(XACT_E_TIP_PROTOCOL_ERROR                                          , _T("This transaction manager encountered a protocol error with another TIP transaction manager."))
      CASE_ERRCODE2(XACT_E_TIP_PULL_FAILED                                             , _T("This transaction manager could not propagate a transaction from another TIP transaction manager."))
      CASE_ERRCODE2(XACT_E_DEST_TMNOTAVAILABLE                                         , _T("The Transaction Manager on the destination machine is not available."))
      CASE_ERRCODE2(XACT_E_TIP_DISABLED                                                , _T("The Transaction Manager has disabled its support for TIP."))
      CASE_ERRCODE2(XACT_E_NETWORK_TX_DISABLED                                         , _T("The transaction manager has disabled its support for remote/network transactions."))
      CASE_ERRCODE2(XACT_E_PARTNER_NETWORK_TX_DISABLED                                 , _T("The partner transaction manager has disabled its support for remote/network transactions."))
      CASE_ERRCODE2(XACT_E_XA_TX_DISABLED                                              , _T("The transaction manager has disabled its support for XA transactions."))
      CASE_ERRCODE2(XACT_E_UNABLE_TO_READ_DTC_CONFIG                                   , _T("MSDTC was unable to read its configuration information."))
      CASE_ERRCODE2(XACT_E_UNABLE_TO_LOAD_DTC_PROXY                                    , _T("MSDTC was unable to load the dtc proxy dll."))
      CASE_ERRCODE2(XACT_E_ABORTING                                                    , _T("The local transaction has aborted."))
      CASE_ERRCODE2(XACT_E_CLERKNOTFOUND                                               , _T("XACT_E_CLERKNOTFOUND"))
      CASE_ERRCODE2(XACT_E_CLERKEXISTS                                                 , _T("XACT_E_CLERKEXISTS"))
      CASE_ERRCODE2(XACT_E_RECOVERYINPROGRESS                                          , _T("XACT_E_RECOVERYINPROGRESS"))
      CASE_ERRCODE2(XACT_E_TRANSACTIONCLOSED                                           , _T("XACT_E_TRANSACTIONCLOSED"))
      CASE_ERRCODE2(XACT_E_INVALIDLSN                                                  , _T("XACT_E_INVALIDLSN"))
      CASE_ERRCODE2(XACT_E_REPLAYREQUEST                                               , _T("XACT_E_REPLAYREQUEST"))
      CASE_ERRCODE2(XACT_S_ASYNC                                                       , _T("An asynchronous operation was specified. The operation has begun, but its outcome is not known yet."))
      CASE_ERRCODE2(XACT_S_DEFECT                                                      , _T("XACT_S_DEFECT"))
      CASE_ERRCODE2(XACT_S_READONLY                                                    , _T("The method call succeeded because the transaction was read-only."))
      CASE_ERRCODE2(XACT_S_SOMENORETAIN                                                , _T("The transaction was successfully aborted. However, this is a coordinated transaction, and some number of enlisted resources were aborted outright because they could not support abort-retaining semantics"))
      CASE_ERRCODE2(XACT_S_OKINFORM                                                    , _T("No changes were made during this call, but the sink wants another chance to look if any other sinks make further changes."))
      CASE_ERRCODE2(XACT_S_MADECHANGESCONTENT                                          , _T("The sink is content and wishes the transaction to proceed. Changes were made to one or more resources during this call."))
      CASE_ERRCODE2(XACT_S_MADECHANGESINFORM                                           , _T("The sink is for the moment and wishes the transaction to proceed, but if other changes are made following this return by other event sinks then this sink wants another chance to look"))
      CASE_ERRCODE2(XACT_S_ALLNORETAIN                                                 , _T("The transaction was successfully aborted. However, the abort was non-retaining."))
      CASE_ERRCODE2(XACT_S_ABORTING                                                    , _T("An abort operation was already in progress."))
      CASE_ERRCODE2(XACT_S_SINGLEPHASE                                                 , _T("The resource manager has performed a single-phase commit of the transaction."))
      CASE_ERRCODE2(XACT_S_LOCALLY_OK                                                  , _T("The local transaction has not aborted."))
      CASE_ERRCODE2(XACT_S_LASTRESOURCEMANAGER                                         , _T("The resource manager has requested to be the coordinator (last resource manager) for the transaction."))
      CASE_ERRCODE2(CONTEXT_E_ABORTED                                                  , _T("The root transaction wanted to commit, but transaction aborted"))
      CASE_ERRCODE2(CONTEXT_E_ABORTING                                                 , _T("You made a method call on a COM+ component that has a transaction that has already aborted or in the process of aborting."))
      CASE_ERRCODE2(CONTEXT_E_NOCONTEXT                                                , _T("There is no MTS object context"))
      CASE_ERRCODE2(CONTEXT_E_WOULD_DEADLOCK                                           , _T("The component is configured to use synchronization and this method call would cause a deadlock to occur."))
      CASE_ERRCODE2(CONTEXT_E_SYNCH_TIMEOUT                                            , _T("The component is configured to use synchronization and a thread has timed out waiting to enter the context."))
      CASE_ERRCODE2(CONTEXT_E_OLDREF                                                   , _T("You made a method call on a COM+ component that has a transaction that has already committed or aborted."))
      CASE_ERRCODE2(CONTEXT_E_ROLENOTFOUND                                             , _T("The specified role was not configured for the application"))
      CASE_ERRCODE2(CONTEXT_E_TMNOTAVAILABLE                                           , _T("COM+ was unable to talk to the Microsoft Distributed Transaction Coordinator"))
      CASE_ERRCODE2(CO_E_ACTIVATIONFAILED                                              , _T("An unexpected error occurred during COM+ Activation."))
      CASE_ERRCODE2(CO_E_ACTIVATIONFAILED_EVENTLOGGED                                  , _T("COM+ Activation failed. Check the event log for more information"))
      CASE_ERRCODE2(CO_E_ACTIVATIONFAILED_CATALOGERROR                                 , _T("COM+ Activation failed due to a catalog or configuration error."))
      CASE_ERRCODE2(CO_E_ACTIVATIONFAILED_TIMEOUT                                      , _T("COM+ activation failed because the activation could not be completed in the specified amount of time."))
      CASE_ERRCODE2(CO_E_INITIALIZATIONFAILED                                          , _T("COM+ Activation failed because an initialization function failed.  Check the event log for more information."))
      CASE_ERRCODE2(CONTEXT_E_NOJIT                                                    , _T("The requested operation requires that JIT be in the current context and it is not"))
      CASE_ERRCODE2(CONTEXT_E_NOTRANSACTION                                            , _T("The requested operation requires that the current context have a Transaction, and it does not"))
      CASE_ERRCODE2(CO_E_THREADINGMODEL_CHANGED                                        , _T("The components threading model has changed after install into a COM+ Application.  Please re-install component."))
      CASE_ERRCODE2(CO_E_NOIISINTRINSICS                                               , _T("IIS intrinsics not available.  Start your work with IIS."))
      CASE_ERRCODE2(CO_E_NOCOOKIES                                                     , _T("An attempt to write a cookie failed."))
      CASE_ERRCODE2(CO_E_DBERROR                                                       , _T("An attempt to use a database generated a database specific error."))
      CASE_ERRCODE2(CO_E_NOTPOOLED                                                     , _T("The COM+ component you created must use object pooling to work."))
      CASE_ERRCODE2(CO_E_NOTCONSTRUCTED                                                , _T("The COM+ component you created must use object construction to work correctly."))
      CASE_ERRCODE2(CO_E_NOSYNCHRONIZATION                                             , _T("The COM+ component requires synchronization, and it is not configured for it."))
      CASE_ERRCODE2(CO_E_ISOLEVELMISMATCH                                              , _T("The TxIsolation Level property for the COM+ component being created is stronger than the TxIsolationLevel for the 'root' component for the transaction.  The creation failed."))
#endif // __SDK__
      CASE_ERRCODE2(OLE_S_USEREG                                                       , _T("Use the registry database to provide the requested information"))
      CASE_ERRCODE2(OLE_S_STATIC                                                       , _T("Success, but static"))
      CASE_ERRCODE2(OLE_S_MAC_CLIPFORMAT                                               , _T("Macintosh clipboard format"))
      CASE_ERRCODE2(DRAGDROP_S_DROP                                                    , _T("Successful drop took place"))
      CASE_ERRCODE2(DRAGDROP_S_CANCEL                                                  , _T("Drag-drop operation canceled"))
      CASE_ERRCODE2(DRAGDROP_S_USEDEFAULTCURSORS                                       , _T("Use the default cursor"))
      CASE_ERRCODE2(DATA_S_SAMEFORMATETC                                               , _T("Data has same FORMATETC"))
      CASE_ERRCODE2(VIEW_S_ALREADY_FROZEN                                              , _T("View is already frozen"))
      CASE_ERRCODE2(CACHE_S_FORMATETC_NOTSUPPORTED                                     , _T("FORMATETC not supported"))
      CASE_ERRCODE2(CACHE_S_SAMECACHE                                                  , _T("Same cache"))
      CASE_ERRCODE2(CACHE_S_SOMECACHES_NOTUPDATED                                      , _T("Some cache(s) not updated"))
      CASE_ERRCODE2(OLEOBJ_S_INVALIDVERB                                               , _T("Invalid verb for OLE object"))
      CASE_ERRCODE2(OLEOBJ_S_CANNOT_DOVERB_NOW                                         , _T("Verb number is valid but verb cannot be done now"))
      CASE_ERRCODE2(OLEOBJ_S_INVALIDHWND                                               , _T("Invalid window handle passed"))
      CASE_ERRCODE2(INPLACE_S_TRUNCATED                                                , _T("Message is too long; some of it had to be truncated before displaying"))
      CASE_ERRCODE2(CONVERT10_S_NO_PRESENTATION                                        , _T("Unable to convert OLESTREAM to IStorage"))
      CASE_ERRCODE2(MK_S_REDUCED_TO_SELF                                               , _T("Moniker reduced to itself"))
      CASE_ERRCODE2(MK_S_ME                                                            , _T("Common prefix is this moniker"))
      CASE_ERRCODE2(MK_S_HIM                                                           , _T("Common prefix is input moniker"))
      CASE_ERRCODE2(MK_S_US                                                            , _T("Common prefix is both monikers"))
      CASE_ERRCODE2(MK_S_MONIKERALREADYREGISTERED                                      , _T("Moniker is already registered in running object table"))
#ifdef __SDK__
      CASE_ERRCODE2(SCHED_S_TASK_READY                                                 , _T("The task is ready to run at its next scheduled time."))
      CASE_ERRCODE2(SCHED_S_TASK_RUNNING                                               , _T("The task is currently running."))
      CASE_ERRCODE2(SCHED_S_TASK_DISABLED                                              , _T("The task will not run at the scheduled times because it has been disabled."))
      CASE_ERRCODE2(SCHED_S_TASK_HAS_NOT_RUN                                           , _T("The task has not yet run."))
      CASE_ERRCODE2(SCHED_S_TASK_NO_MORE_RUNS                                          , _T("There are no more runs scheduled for this task."))
      CASE_ERRCODE2(SCHED_S_TASK_NOT_SCHEDULED                                         , _T("One or more of the properties that are needed to run this task on a schedule have not been set."))
      CASE_ERRCODE2(SCHED_S_TASK_TERMINATED                                            , _T("The last run of the task was terminated by the user."))
      CASE_ERRCODE2(SCHED_S_TASK_NO_VALID_TRIGGERS                                     , _T("Either the task has no triggers or the existing triggers are disabled or not set."))
      CASE_ERRCODE2(SCHED_S_EVENT_TRIGGER                                              , _T("Event triggers don't have set run times."))
      CASE_ERRCODE2(SCHED_E_TRIGGER_NOT_FOUND                                          , _T("Trigger not found."))
      CASE_ERRCODE2(SCHED_E_TASK_NOT_READY                                             , _T("One or more of the properties that are needed to run this task have not been set."))
      CASE_ERRCODE2(SCHED_E_TASK_NOT_RUNNING                                           , _T("There is no running instance of the task to terminate."))
      CASE_ERRCODE2(SCHED_E_SERVICE_NOT_INSTALLED                                      , _T("The Task Scheduler Service is not installed on this computer."))
      CASE_ERRCODE2(SCHED_E_CANNOT_OPEN_TASK                                           , _T("The task object could not be opened."))
      CASE_ERRCODE2(SCHED_E_INVALID_TASK                                               , _T("The object is either an invalid task object or is not a task object."))
      CASE_ERRCODE2(SCHED_E_ACCOUNT_INFORMATION_NOT_SET                                , _T("No account information could be found in the Task Scheduler security database for the task indicated."))
      CASE_ERRCODE2(SCHED_E_ACCOUNT_NAME_NOT_FOUND                                     , _T("Unable to establish existence of the account specified."))
      CASE_ERRCODE2(SCHED_E_ACCOUNT_DBASE_CORRUPT                                      , _T("Corruption was detected in the Task Scheduler security database; the database has been reset."))
      CASE_ERRCODE2(SCHED_E_NO_SECURITY_SERVICES                                       , _T("Task Scheduler security services are available only on Windows NT."))
      CASE_ERRCODE2(SCHED_E_UNKNOWN_OBJECT_VERSION                                     , _T("The task object version is either unsupported or invalid."))
      CASE_ERRCODE2(SCHED_E_UNSUPPORTED_ACCOUNT_OPTION                                 , _T("The task has been configured with an unsupported combination of account settings and run time options."))
      CASE_ERRCODE2(SCHED_E_SERVICE_NOT_RUNNING                                        , _T("The Task Scheduler Service is not running."))
#endif // __SDK__
      CASE_ERRCODE2(CO_E_CLASS_CREATE_FAILED                                           , _T("Attempt to create a class object failed"))
      CASE_ERRCODE2(CO_E_SCM_ERROR                                                     , _T("OLE service could not bind object"))
      CASE_ERRCODE2(CO_E_SCM_RPC_FAILURE                                               , _T("RPC communication failed with OLE service"))
      CASE_ERRCODE2(CO_E_BAD_PATH                                                      , _T("Bad path to object"))
      CASE_ERRCODE2(CO_E_SERVER_EXEC_FAILURE                                           , _T("Server execution failed"))
      CASE_ERRCODE2(CO_E_OBJSRV_RPC_FAILURE                                            , _T("OLE service could not communicate with the object server"))
      CASE_ERRCODE2(MK_E_NO_NORMALIZED                                                 , _T("Moniker path could not be normalized"))
      CASE_ERRCODE2(CO_E_SERVER_STOPPING                                               , _T("Object server is stopping when OLE service contacts it"))
      CASE_ERRCODE2(MEM_E_INVALID_ROOT                                                 , _T("An invalid root block pointer was specified"))
      CASE_ERRCODE2(MEM_E_INVALID_LINK                                                 , _T("An allocation chain contained an invalid link pointer"))
      CASE_ERRCODE2(MEM_E_INVALID_SIZE                                                 , _T("The requested allocation size was too large"))
      CASE_ERRCODE2(CO_S_NOTALLINTERFACES                                              , _T("Not all the requested interfaces were available"))
#ifdef __SDK__
      CASE_ERRCODE2(CO_S_MACHINENAMENOTFOUND                                           , _T("The specified machine name was not found in the cache."))
#endif // __SDK__
      CASE_ERRCODE2(DISP_E_UNKNOWNINTERFACE                                            , _T("Unknown interface."))
      CASE_ERRCODE2(DISP_E_MEMBERNOTFOUND                                              , _T("Member not found."))
      CASE_ERRCODE2(DISP_E_PARAMNOTFOUND                                               , _T("Parameter not found."))
      CASE_ERRCODE2(DISP_E_TYPEMISMATCH                                                , _T("Type mismatch."))
      CASE_ERRCODE2(DISP_E_UNKNOWNNAME                                                 , _T("Unknown name."))
      CASE_ERRCODE2(DISP_E_NONAMEDARGS                                                 , _T("No named arguments."))
      CASE_ERRCODE2(DISP_E_BADVARTYPE                                                  , _T("Bad variable type."))
      CASE_ERRCODE2(DISP_E_EXCEPTION                                                   , _T("Exception occurred."))
      CASE_ERRCODE2(DISP_E_OVERFLOW                                                    , _T("Out of present range."))
      CASE_ERRCODE2(DISP_E_BADINDEX                                                    , _T("Invalid index."))
      CASE_ERRCODE2(DISP_E_UNKNOWNLCID                                                 , _T("Unknown language."))
      CASE_ERRCODE2(DISP_E_ARRAYISLOCKED                                               , _T("Memory is locked."))
      CASE_ERRCODE2(DISP_E_BADPARAMCOUNT                                               , _T("Invalid number of parameters."))
      CASE_ERRCODE2(DISP_E_PARAMNOTOPTIONAL                                            , _T("Parameter not optional."))
      CASE_ERRCODE2(DISP_E_BADCALLEE                                                   , _T("Invalid callee."))
      CASE_ERRCODE2(DISP_E_NOTACOLLECTION                                              , _T("Does not support a collection."))
      CASE_ERRCODE2(DISP_E_DIVBYZERO                                                   , _T("Division by zero."))
#ifdef __SDK__
      CASE_ERRCODE2(DISP_E_BUFFERTOOSMALL                                              , _T("Buffer too small"))
#endif // __SDK__
      CASE_ERRCODE2(TYPE_E_BUFFERTOOSMALL                                              , _T("Buffer too small."))
      CASE_ERRCODE2(TYPE_E_FIELDNOTFOUND                                               , _T("Field name not defined in the record."))
      CASE_ERRCODE2(TYPE_E_INVDATAREAD                                                 , _T("Old format or invalid type library."))
      CASE_ERRCODE2(TYPE_E_UNSUPFORMAT                                                 , _T("Old format or invalid type library."))
      CASE_ERRCODE2(TYPE_E_REGISTRYACCESS                                              , _T("Error accessing the OLE registry."))
      CASE_ERRCODE2(TYPE_E_LIBNOTREGISTERED                                            , _T("Library not registered."))
      CASE_ERRCODE2(TYPE_E_UNDEFINEDTYPE                                               , _T("Bound to unknown type."))
      CASE_ERRCODE2(TYPE_E_QUALIFIEDNAMEDISALLOWED                                     , _T("Qualified name disallowed."))
      CASE_ERRCODE2(TYPE_E_INVALIDSTATE                                                , _T("Invalid forward reference, or reference to uncompiled type."))
      CASE_ERRCODE2(TYPE_E_WRONGTYPEKIND                                               , _T("Type mismatch."))
      CASE_ERRCODE2(TYPE_E_ELEMENTNOTFOUND                                             , _T("Element not found."))
      CASE_ERRCODE2(TYPE_E_AMBIGUOUSNAME                                               , _T("Ambiguous name."))
      CASE_ERRCODE2(TYPE_E_NAMECONFLICT                                                , _T("Name already exists in the library."))
      CASE_ERRCODE2(TYPE_E_UNKNOWNLCID                                                 , _T("Unknown LCID."))
      CASE_ERRCODE2(TYPE_E_DLLFUNCTIONNOTFOUND                                         , _T("Function not defined in specified DLL."))
      CASE_ERRCODE2(TYPE_E_BADMODULEKIND                                               , _T("Wrong module kind for the operation."))
      CASE_ERRCODE2(TYPE_E_SIZETOOBIG                                                  , _T("Size may not exceed 64K."))
      CASE_ERRCODE2(TYPE_E_DUPLICATEID                                                 , _T("Duplicate ID in inheritance hierarchy."))
      CASE_ERRCODE2(TYPE_E_INVALIDID                                                   , _T("Incorrect inheritance depth in standard OLE hmember."))
      CASE_ERRCODE2(TYPE_E_TYPEMISMATCH                                                , _T("Type mismatch."))
      CASE_ERRCODE2(TYPE_E_OUTOFBOUNDS                                                 , _T("Invalid number of arguments."))
      CASE_ERRCODE2(TYPE_E_IOERROR                                                     , _T("I/O Error."))
      CASE_ERRCODE2(TYPE_E_CANTCREATETMPFILE                                           , _T("Error creating unique tmp file."))
      CASE_ERRCODE2(TYPE_E_CANTLOADLIBRARY                                             , _T("Error loading type library/DLL."))
      CASE_ERRCODE2(TYPE_E_INCONSISTENTPROPFUNCS                                       , _T("Inconsistent property functions."))
      CASE_ERRCODE2(TYPE_E_CIRCULARTYPE                                                , _T("Circular dependency between types/modules."))
      CASE_ERRCODE2(STG_E_INVALIDFUNCTION                                              , _T("Unable to perform requested operation."))
      CASE_ERRCODE2(STG_E_FILENOTFOUND                                                 , _T("%1 could not be found."))
      CASE_ERRCODE2(STG_E_PATHNOTFOUND                                                 , _T("The path %1 could not be found."))
      CASE_ERRCODE2(STG_E_TOOMANYOPENFILES                                             , _T("There are insufficient resources to open another file."))
      CASE_ERRCODE2(STG_E_ACCESSDENIED                                                 , _T("Access Denied."))
      CASE_ERRCODE2(STG_E_INVALIDHANDLE                                                , _T("Attempted an operation on an invalid object."))
      CASE_ERRCODE2(STG_E_INSUFFICIENTMEMORY                                           , _T("There is insufficient memory available to complete operation."))
      CASE_ERRCODE2(STG_E_INVALIDPOINTER                                               , _T("Invalid pointer error."))
      CASE_ERRCODE2(STG_E_NOMOREFILES                                                  , _T("There are no more entries to return."))
      CASE_ERRCODE2(STG_E_DISKISWRITEPROTECTED                                         , _T("Disk is write-protected."))
      CASE_ERRCODE2(STG_E_SEEKERROR                                                    , _T("An error occurred during a seek operation."))
      CASE_ERRCODE2(STG_E_WRITEFAULT                                                   , _T("A disk error occurred during a write operation."))
      CASE_ERRCODE2(STG_E_READFAULT                                                    , _T("A disk error occurred during a read operation."))
      CASE_ERRCODE2(STG_E_SHAREVIOLATION                                               , _T("A share violation has occurred."))
      CASE_ERRCODE2(STG_E_LOCKVIOLATION                                                , _T("A lock violation has occurred."))
      CASE_ERRCODE2(STG_E_FILEALREADYEXISTS                                            , _T("%1 already exists."))
      CASE_ERRCODE2(STG_E_INVALIDPARAMETER                                             , _T("Invalid parameter error."))
      CASE_ERRCODE2(STG_E_MEDIUMFULL                                                   , _T("There is insufficient disk space to complete operation."))
      CASE_ERRCODE2(STG_E_PROPSETMISMATCHED                                            , _T("Illegal write of non-simple property to simple property set."))
      CASE_ERRCODE2(STG_E_ABNORMALAPIEXIT                                              , _T("An API call exited abnormally."))
      CASE_ERRCODE2(STG_E_INVALIDHEADER                                                , _T("The file %1 is not a valid compound file."))
      CASE_ERRCODE2(STG_E_INVALIDNAME                                                  , _T("The name %1 is not valid."))
      CASE_ERRCODE2(STG_E_UNKNOWN                                                      , _T("An unexpected error occurred."))
      CASE_ERRCODE2(STG_E_UNIMPLEMENTEDFUNCTION                                        , _T("That function is not implemented."))
      CASE_ERRCODE2(STG_E_INVALIDFLAG                                                  , _T("Invalid flag error."))
      CASE_ERRCODE2(STG_E_INUSE                                                        , _T("Attempted to use an object that is busy."))
      CASE_ERRCODE2(STG_E_NOTCURRENT                                                   , _T("The storage has been changed since the last commit."))
      CASE_ERRCODE2(STG_E_REVERTED                                                     , _T("Attempted to use an object that has ceased to exist."))
      CASE_ERRCODE2(STG_E_CANTSAVE                                                     , _T("Can't save."))
      CASE_ERRCODE2(STG_E_OLDFORMAT                                                    , _T("The compound file %1 was produced with an incompatible version of storage."))
      CASE_ERRCODE2(STG_E_OLDDLL                                                       , _T("The compound file %1 was produced with a newer version of storage."))
      CASE_ERRCODE2(STG_E_SHAREREQUIRED                                                , _T("Share.exe or equivalent is required for operation."))
      CASE_ERRCODE2(STG_E_NOTFILEBASEDSTORAGE                                          , _T("Illegal operation called on non-file based storage."))
      CASE_ERRCODE2(STG_E_EXTANTMARSHALLINGS                                           , _T("Illegal operation called on object with extant marshallings."))
      CASE_ERRCODE2(STG_E_DOCFILECORRUPT                                               , _T("The docfile has been corrupted."))
      CASE_ERRCODE2(STG_E_BADBASEADDRESS                                               , _T("OLE32.DLL has been loaded at the wrong address."))
#ifdef __SDK__
      CASE_ERRCODE2(STG_E_DOCFILETOOLARGE                                              , _T("The compound file is too large for the current implementation"))
      CASE_ERRCODE2(STG_E_NOTSIMPLEFORMAT                                              , _T("The compound file was not created with the STGM_SIMPLE flag"))
#endif // __SDK__
      CASE_ERRCODE2(STG_E_INCOMPLETE                                                   , _T("The file download was aborted abnormally.  The file is incomplete."))
      CASE_ERRCODE2(STG_E_TERMINATED                                                   , _T("The file download has been terminated."))
      CASE_ERRCODE2(STG_S_CONVERTED                                                    , _T("The underlying file was converted to compound file format."))
      CASE_ERRCODE2(STG_S_BLOCK                                                        , _T("The storage operation should block until more data is available."))
      CASE_ERRCODE2(STG_S_RETRYNOW                                                     , _T("The storage operation should retry immediately."))
      CASE_ERRCODE2(STG_S_MONITORING                                                   , _T("The notified event sink will not influence the storage operation."))
      CASE_ERRCODE2(STG_S_MULTIPLEOPENS                                                , _T("Multiple opens prevent consolidated. (commit succeeded)."))
      CASE_ERRCODE2(STG_S_CONSOLIDATIONFAILED                                          , _T("Consolidation of the storage file failed. (commit succeeded)."))
      CASE_ERRCODE2(STG_S_CANNOTCONSOLIDATE                                            , _T("Consolidation of the storage file is inappropriate. (commit succeeded)."))
#ifdef __SDK__
      CASE_ERRCODE2(STG_E_STATUS_COPY_PROTECTION_FAILURE                               , _T("Generic Copy Protection Error."))
      CASE_ERRCODE2(STG_E_CSS_AUTHENTICATION_FAILURE                                   , _T("Copy Protection Error - DVD CSS Authentication failed."))
      CASE_ERRCODE2(STG_E_CSS_KEY_NOT_PRESENT                                          , _T("Copy Protection Error - The given sector does not have a valid CSS key."))
      CASE_ERRCODE2(STG_E_CSS_KEY_NOT_ESTABLISHED                                      , _T("Copy Protection Error - DVD session key not established."))
      CASE_ERRCODE2(STG_E_CSS_SCRAMBLED_SECTOR                                         , _T("Copy Protection Error - The read failed because the sector is encrypted."))
      CASE_ERRCODE2(STG_E_CSS_REGION_MISMATCH                                          , _T("Copy Protection Error - The current DVD's region does not correspond to the region setting of the drive."))
      CASE_ERRCODE2(STG_E_RESETS_EXHAUSTED                                             , _T("Copy Protection Error - The drive's region setting may be permanent or the number of user resets has been exhausted."))
#endif // __SDK__
      CASE_ERRCODE2(RPC_E_CALL_REJECTED                                                , _T("Call was rejected by callee."))
      CASE_ERRCODE2(RPC_E_CALL_CANCELED                                                , _T("Call was canceled by the message filter."))
      CASE_ERRCODE2(RPC_E_CANTPOST_INSENDCALL                                          , _T("The caller is dispatching an intertask SendMessage call and cannot call out via PostMessage."))
      CASE_ERRCODE2(RPC_E_CANTCALLOUT_INASYNCCALL                                      , _T("The caller is dispatching an asynchronous call and cannot make an outgoing call on behalf of this call."))
      CASE_ERRCODE2(RPC_E_CANTCALLOUT_INEXTERNALCALL                                   , _T("It is illegal to call out while inside message filter."))
      CASE_ERRCODE2(RPC_E_CONNECTION_TERMINATED                                        , _T("The connection terminated or is in a bogus state and cannot be used any more. Other connections are still valid."))
      CASE_ERRCODE2(RPC_E_SERVER_DIED                                                  , _T("The callee (server [not server application]) is not available and disappeared; all connections are invalid. The call may have executed."))
      CASE_ERRCODE2(RPC_E_CLIENT_DIED                                                  , _T("The caller (client) disappeared while the callee (server) was processing a call."))
      CASE_ERRCODE2(RPC_E_INVALID_DATAPACKET                                           , _T("The data packet with the marshalled parameter data is incorrect."))
      CASE_ERRCODE2(RPC_E_CANTTRANSMIT_CALL                                            , _T("The call was not transmitted properly; the message queue was full and was not emptied after yielding."))
      CASE_ERRCODE2(RPC_E_CLIENT_CANTMARSHAL_DATA                                      , _T("The client (caller) cannot marshall the parameter data - low memory, etc."))
      CASE_ERRCODE2(RPC_E_CLIENT_CANTUNMARSHAL_DATA                                    , _T("The client (caller) cannot unmarshall the return data - low memory, etc."))
      CASE_ERRCODE2(RPC_E_SERVER_CANTMARSHAL_DATA                                      , _T("The server (callee) cannot marshall the return data - low memory, etc."))
      CASE_ERRCODE2(RPC_E_SERVER_CANTUNMARSHAL_DATA                                    , _T("The server (callee) cannot unmarshall the parameter data - low memory, etc."))
      CASE_ERRCODE2(RPC_E_INVALID_DATA                                                 , _T("Received data is invalid; could be server or client data."))
      CASE_ERRCODE2(RPC_E_INVALID_PARAMETER                                            , _T("A particular parameter is invalid and cannot be (un)marshalled."))
      CASE_ERRCODE2(RPC_E_CANTCALLOUT_AGAIN                                            , _T("There is no second outgoing call on same channel in DDE conversation."))
      CASE_ERRCODE2(RPC_E_SERVER_DIED_DNE                                              , _T("The callee (server [not server application]) is not available and disappeared; all connections are invalid. The call did not execute."))
      CASE_ERRCODE2(RPC_E_SYS_CALL_FAILED                                              , _T("System call failed."))
      CASE_ERRCODE2(RPC_E_OUT_OF_RESOURCES                                             , _T("Could not allocate some required resource (memory, events, ...)"))
      CASE_ERRCODE2(RPC_E_ATTEMPTED_MULTITHREAD                                        , _T("Attempted to make calls on more than one thread in single threaded mode."))
      CASE_ERRCODE2(RPC_E_NOT_REGISTERED                                               , _T("The requested interface is not registered on the server object."))
      CASE_ERRCODE2(RPC_E_FAULT                                                        , _T("RPC could not call the server or could not return the results of calling the server."))
      CASE_ERRCODE2(RPC_E_SERVERFAULT                                                  , _T("The server threw an exception."))
      CASE_ERRCODE2(RPC_E_CHANGED_MODE                                                 , _T("Cannot change thread mode after it is set."))
      CASE_ERRCODE2(RPC_E_INVALIDMETHOD                                                , _T("The method called does not exist on the server."))
      CASE_ERRCODE2(RPC_E_DISCONNECTED                                                 , _T("The object invoked has disconnected from its clients."))
      CASE_ERRCODE2(RPC_E_RETRY                                                        , _T("The object invoked chose not to process the call now.  Try again later."))
      CASE_ERRCODE2(RPC_E_SERVERCALL_RETRYLATER                                        , _T("The message filter indicated that the application is busy."))
      CASE_ERRCODE2(RPC_E_SERVERCALL_REJECTED                                          , _T("The message filter rejected the call."))
      CASE_ERRCODE2(RPC_E_INVALID_CALLDATA                                             , _T("A call control interfaces was called with invalid data."))
      CASE_ERRCODE2(RPC_E_CANTCALLOUT_ININPUTSYNCCALL                                  , _T("An outgoing call cannot be made since the application is dispatching an input-synchronous call."))
      CASE_ERRCODE2(RPC_E_WRONG_THREAD                                                 , _T("The application called an interface that was marshalled for a different thread."))
      CASE_ERRCODE2(RPC_E_THREAD_NOT_INIT                                              , _T("CoInitialize has not been called on the current thread."))
      CASE_ERRCODE2(RPC_E_VERSION_MISMATCH                                             , _T("The version of OLE on the client and server machines does not match."))
      CASE_ERRCODE2(RPC_E_INVALID_HEADER                                               , _T("OLE received a packet with an invalid header."))
      CASE_ERRCODE2(RPC_E_INVALID_EXTENSION                                            , _T("OLE received a packet with an invalid extension."))
      CASE_ERRCODE2(RPC_E_INVALID_IPID                                                 , _T("The requested object or interface does not exist."))
      CASE_ERRCODE2(RPC_E_INVALID_OBJECT                                               , _T("The requested object does not exist."))
      CASE_ERRCODE2(RPC_S_CALLPENDING                                                  , _T("OLE has sent a request and is waiting for a reply."))
      CASE_ERRCODE2(RPC_S_WAITONTIMER                                                  , _T("OLE is waiting before retrying a request."))
      CASE_ERRCODE2(RPC_E_CALL_COMPLETE                                                , _T("Call context cannot be accessed after call completed."))
      CASE_ERRCODE2(RPC_E_UNSECURE_CALL                                                , _T("Impersonate on unsecure calls is not supported."))
      CASE_ERRCODE2(RPC_E_TOO_LATE                                                     , _T("Security must be initialized before any interfaces are marshalled or unmarshalled. It cannot be changed once initialized."))
      CASE_ERRCODE2(RPC_E_NO_GOOD_SECURITY_PACKAGES                                    , _T("No security packages are installed on this machine or the user is not logged on or there are no compatible security packages between the client and server."))
      CASE_ERRCODE2(RPC_E_ACCESS_DENIED                                                , _T("Access is denied."))
      CASE_ERRCODE2(RPC_E_REMOTE_DISABLED                                              , _T("Remote calls are not allowed for this process."))
      CASE_ERRCODE2(RPC_E_INVALID_OBJREF                                               , _T("The marshaled interface data packet (OBJREF) has an invalid or unknown format."))
      CASE_ERRCODE2(RPC_E_NO_CONTEXT                                                   , _T("No context is associated with this call. This happens for some custom marshalled calls and on the client side of the call."))
      CASE_ERRCODE2(RPC_E_TIMEOUT                                                      , _T("This operation returned because the timeout period expired."))
      CASE_ERRCODE2(RPC_E_NO_SYNC                                                      , _T("There are no synchronize objects to wait on."))
#ifdef __SDK__
      CASE_ERRCODE2(RPC_E_FULLSIC_REQUIRED                                             , _T("Full subject issuer chain SSL principal name expected from the server."))
      CASE_ERRCODE2(RPC_E_INVALID_STD_NAME                                             , _T("Principal name is not a valid MSSTD name."))
#endif // __SDK__
      CASE_ERRCODE2(CO_E_FAILEDTOIMPERSONATE                                           , _T("Unable to impersonate DCOM client"))
      CASE_ERRCODE2(CO_E_FAILEDTOGETSECCTX                                             , _T("Unable to obtain server's security context"))
      CASE_ERRCODE2(CO_E_FAILEDTOOPENTHREADTOKEN                                       , _T("Unable to open the access token of the current thread"))
      CASE_ERRCODE2(CO_E_FAILEDTOGETTOKENINFO                                          , _T("Unable to obtain user info from an access token"))
      CASE_ERRCODE2(CO_E_TRUSTEEDOESNTMATCHCLIENT                                      , _T("The client who called IAccessControl::IsAccessPermitted was not the trustee provided to the method"))
      CASE_ERRCODE2(CO_E_FAILEDTOQUERYCLIENTBLANKET                                    , _T("Unable to obtain the client's security blanket"))
      CASE_ERRCODE2(CO_E_FAILEDTOSETDACL                                               , _T("Unable to set a discretionary ACL into a security descriptor"))
      CASE_ERRCODE2(CO_E_ACCESSCHECKFAILED                                             , _T("The system function, AccessCheck, returned false"))
      CASE_ERRCODE2(CO_E_NETACCESSAPIFAILED                                            , _T("Either NetAccessDel or NetAccessAdd returned an error code."))
      CASE_ERRCODE2(CO_E_WRONGTRUSTEENAMESYNTAX                                        , _T("One of the trustee strings provided by the user did not conform to the <Domain>\\<Name> syntax and it was not the '*' string"))
      CASE_ERRCODE2(CO_E_INVALIDSID                                                    , _T("One of the security identifiers provided by the user was invalid"))
      CASE_ERRCODE2(CO_E_CONVERSIONFAILED                                              , _T("Unable to convert a wide character trustee string to a multibyte trustee string"))
      CASE_ERRCODE2(CO_E_NOMATCHINGSIDFOUND                                            , _T("Unable to find a security identifier that corresponds to a trustee string provided by the user"))
      CASE_ERRCODE2(CO_E_LOOKUPACCSIDFAILED                                            , _T("The system function, LookupAccountSID, failed"))
      CASE_ERRCODE2(CO_E_NOMATCHINGNAMEFOUND                                           , _T("Unable to find a trustee name that corresponds to a security identifier provided by the user"))
      CASE_ERRCODE2(CO_E_LOOKUPACCNAMEFAILED                                           , _T("The system function, LookupAccountName, failed"))
      CASE_ERRCODE2(CO_E_SETSERLHNDLFAILED                                             , _T("Unable to set or reset a serialization handle"))
      CASE_ERRCODE2(CO_E_FAILEDTOGETWINDIR                                             , _T("Unable to obtain the Windows directory"))
      CASE_ERRCODE2(CO_E_PATHTOOLONG                                                   , _T("Path too long"))
      CASE_ERRCODE2(CO_E_FAILEDTOGENUUID                                               , _T("Unable to generate a uuid."))
      CASE_ERRCODE2(CO_E_FAILEDTOCREATEFILE                                            , _T("Unable to create file"))
      CASE_ERRCODE2(CO_E_FAILEDTOCLOSEHANDLE                                           , _T("Unable to close a serialization handle or a file handle."))
      CASE_ERRCODE2(CO_E_EXCEEDSYSACLLIMIT                                             , _T("The number of ACEs in an ACL exceeds the system limit."))
      CASE_ERRCODE2(CO_E_ACESINWRONGORDER                                              , _T("Not all the DENY_ACCESS ACEs are arranged in front of the GRANT_ACCESS ACEs in the stream."))
      CASE_ERRCODE2(CO_E_INCOMPATIBLESTREAMVERSION                                     , _T("The version of ACL format in the stream is not supported by this implementation of IAccessControl"))
      CASE_ERRCODE2(CO_E_FAILEDTOOPENPROCESSTOKEN                                      , _T("Unable to open the access token of the server process"))
      CASE_ERRCODE2(CO_E_DECODEFAILED                                                  , _T("Unable to decode the ACL in the stream provided by the user"))
      CASE_ERRCODE2(CO_E_ACNOTINITIALIZED                                              , _T("The COM IAccessControl object is not initialized"))
#ifdef __SDK__
      CASE_ERRCODE2(CO_E_CANCEL_DISABLED                                               , _T("Call Cancellation is disabled"))
#endif // __SDK__
      CASE_ERRCODE2(RPC_E_UNEXPECTED                                                   , _T("An internal error occurred."))
#ifdef __SDK__
      CASE_ERRCODE2(ERROR_AUDITING_DISABLED                                            , _T("The specified event is currently not being audited."))
      CASE_ERRCODE2(ERROR_ALL_SIDS_FILTERED                                            , _T("The SID filtering operation removed all SIDs."))
#endif // __SDK__
      CASE_ERRCODE2(NTE_BAD_UID                                                        , _T("Bad UID."))
      CASE_ERRCODE2(NTE_BAD_HASH                                                       , _T("Bad Hash."))
      CASE_ERRCODE2(NTE_BAD_KEY                                                        , _T("Bad Key."))
      CASE_ERRCODE2(NTE_BAD_LEN                                                        , _T("Bad Length."))
      CASE_ERRCODE2(NTE_BAD_DATA                                                       , _T("Bad Data."))
      CASE_ERRCODE2(NTE_BAD_SIGNATURE                                                  , _T("Invalid Signature."))
      CASE_ERRCODE2(NTE_BAD_VER                                                        , _T("Bad Version of provider."))
      CASE_ERRCODE2(NTE_BAD_ALGID                                                      , _T("Invalid algorithm specified."))
      CASE_ERRCODE2(NTE_BAD_FLAGS                                                      , _T("Invalid flags specified."))
      CASE_ERRCODE2(NTE_BAD_TYPE                                                       , _T("Invalid type specified."))
      CASE_ERRCODE2(NTE_BAD_KEY_STATE                                                  , _T("Key not valid for use in specified state."))
      CASE_ERRCODE2(NTE_BAD_HASH_STATE                                                 , _T("Hash not valid for use in specified state."))
      CASE_ERRCODE2(NTE_NO_KEY                                                         , _T("Key does not exist."))
      CASE_ERRCODE2(NTE_NO_MEMORY                                                      , _T("Insufficient memory available for the operation."))
      CASE_ERRCODE2(NTE_EXISTS                                                         , _T("Object already exists."))
      CASE_ERRCODE2(NTE_PERM                                                           , _T("Access denied."))
      CASE_ERRCODE2(NTE_NOT_FOUND                                                      , _T("Object was not found."))
      CASE_ERRCODE2(NTE_DOUBLE_ENCRYPT                                                 , _T("Data already encrypted."))
      CASE_ERRCODE2(NTE_BAD_PROVIDER                                                   , _T("Invalid provider specified."))
      CASE_ERRCODE2(NTE_BAD_PROV_TYPE                                                  , _T("Invalid provider type specified."))
      CASE_ERRCODE2(NTE_BAD_PUBLIC_KEY                                                 , _T("Provider's public key is invalid."))
      CASE_ERRCODE2(NTE_BAD_KEYSET                                                     , _T("Keyset does not exist"))
      CASE_ERRCODE2(NTE_PROV_TYPE_NOT_DEF                                              , _T("Provider type not defined."))
      CASE_ERRCODE2(NTE_PROV_TYPE_ENTRY_BAD                                            , _T("Provider type as registered is invalid."))
      CASE_ERRCODE2(NTE_KEYSET_NOT_DEF                                                 , _T("The keyset is not defined."))
      CASE_ERRCODE2(NTE_KEYSET_ENTRY_BAD                                               , _T("Keyset as registered is invalid."))
      CASE_ERRCODE2(NTE_PROV_TYPE_NO_MATCH                                             , _T("Provider type does not match registered value."))
      CASE_ERRCODE2(NTE_SIGNATURE_FILE_BAD                                             , _T("The digital signature file is corrupt."))
      CASE_ERRCODE2(NTE_PROVIDER_DLL_FAIL                                              , _T("Provider DLL failed to initialize correctly."))
      CASE_ERRCODE2(NTE_PROV_DLL_NOT_FOUND                                             , _T("Provider DLL could not be found."))
      CASE_ERRCODE2(NTE_BAD_KEYSET_PARAM                                               , _T("The Keyset parameter is invalid."))
      CASE_ERRCODE2(NTE_FAIL                                                           , _T("An internal error occurred."))
      CASE_ERRCODE2(NTE_SYS_ERR                                                        , _T("A base error occurred."))
#ifdef __SDK__
      CASE_ERRCODE2(NTE_SILENT_CONTEXT                                                 , _T("Provider could not perform the action since the context was acquired as silent."))
      CASE_ERRCODE2(NTE_TOKEN_KEYSET_STORAGE_FULL                                      , _T("The security token does not have storage space available for an additional container."))
      CASE_ERRCODE2(NTE_TEMPORARY_PROFILE                                              , _T("The profile for the user is a temporary profile."))
      CASE_ERRCODE2(NTE_FIXEDPARAMETER                                                 , _T("The key parameters could not be set because the CSP uses fixed parameters."))
      CASE_ERRCODE2(SEC_E_INSUFFICIENT_MEMORY                                          , _T("Not enough memory is available to complete this request"))
      CASE_ERRCODE2(SEC_E_INVALID_HANDLE                                               , _T("The handle specified is invalid"))
      CASE_ERRCODE2(SEC_E_UNSUPPORTED_FUNCTION                                         , _T("The function requested is not supported"))
      CASE_ERRCODE2(SEC_E_TARGET_UNKNOWN                                               , _T("The specified target is unknown or unreachable"))
      CASE_ERRCODE2(SEC_E_INTERNAL_ERROR                                               , _T("The Local Security Authority cannot be contacted"))
      CASE_ERRCODE2(SEC_E_SECPKG_NOT_FOUND                                             , _T("The requested security package does not exist"))
      CASE_ERRCODE2(SEC_E_NOT_OWNER                                                    , _T("The caller is not the owner of the desired credentials"))
      CASE_ERRCODE2(SEC_E_CANNOT_INSTALL                                               , _T("The security package failed to initialize, and cannot be installed"))
      CASE_ERRCODE2(SEC_E_INVALID_TOKEN                                                , _T("The token supplied to the function is invalid"))
      CASE_ERRCODE2(SEC_E_CANNOT_PACK                                                  , _T("The security package is not able to marshall the logon buffer, so the logon attempt has failed"))
      CASE_ERRCODE2(SEC_E_QOP_NOT_SUPPORTED                                            , _T("The per-message Quality of Protection is not supported by the security package"))
      CASE_ERRCODE2(SEC_E_NO_IMPERSONATION                                             , _T("The security context does not allow impersonation of the client"))
      CASE_ERRCODE2(SEC_E_LOGON_DENIED                                                 , _T("The logon attempt failed"))
      CASE_ERRCODE2(SEC_E_UNKNOWN_CREDENTIALS                                          , _T("The credentials supplied to the package were not recognized"))
      CASE_ERRCODE2(SEC_E_NO_CREDENTIALS                                               , _T("No credentials are available in the security package"))
      CASE_ERRCODE2(SEC_E_MESSAGE_ALTERED                                              , _T("The message or signature supplied for verification has been altered"))
      CASE_ERRCODE2(SEC_E_OUT_OF_SEQUENCE                                              , _T("The message supplied for verification is out of sequence"))
      CASE_ERRCODE2(SEC_E_NO_AUTHENTICATING_AUTHORITY                                  , _T("No authority could be contacted for authentication."))
      CASE_ERRCODE2(SEC_I_CONTINUE_NEEDED                                              , _T("The function completed successfully, but must be called again to complete the context"))
      CASE_ERRCODE2(SEC_I_COMPLETE_NEEDED                                              , _T("The function completed successfully, but CompleteToken must be called"))
      CASE_ERRCODE2(SEC_I_COMPLETE_AND_CONTINUE                                        , _T("The function completed successfully, but both CompleteToken and this function must be called to complete the context"))
      CASE_ERRCODE2(SEC_I_LOCAL_LOGON                                                  , _T("The logon was completed, but no network authority was available. The logon was made using locally known information"))
      CASE_ERRCODE2(SEC_E_BAD_PKGID                                                    , _T("The requested security package does not exist"))
      CASE_ERRCODE2(SEC_E_CONTEXT_EXPIRED                                              , _T("The context has expired and can no longer be used."))
      CASE_ERRCODE2(SEC_I_CONTEXT_EXPIRED                                              , _T("The context has expired and can no longer be used."))
      CASE_ERRCODE2(SEC_E_INCOMPLETE_MESSAGE                                           , _T("The supplied message is incomplete.  The signature was not verified."))
      CASE_ERRCODE2(SEC_E_INCOMPLETE_CREDENTIALS                                       , _T("The credentials supplied were not complete, and could not be verified. The context could not be initialized."))
      CASE_ERRCODE2(SEC_E_BUFFER_TOO_SMALL                                             , _T("The buffers supplied to a function was too small."))
      CASE_ERRCODE2(SEC_I_INCOMPLETE_CREDENTIALS                                       , _T("The credentials supplied were not complete, and could not be verified. Additional information can be returned from the context."))
      CASE_ERRCODE2(SEC_I_RENEGOTIATE                                                  , _T("The context data must be renegotiated with the peer."))
      CASE_ERRCODE2(SEC_E_WRONG_PRINCIPAL                                              , _T("The target principal name is incorrect."))
      CASE_ERRCODE2(SEC_I_NO_LSA_CONTEXT                                               , _T("There is no LSA mode context associated with this context."))
      CASE_ERRCODE2(SEC_E_TIME_SKEW                                                    , _T("The clocks on the client and server machines are skewed."))
      CASE_ERRCODE2(SEC_E_UNTRUSTED_ROOT                                               , _T("The certificate chain was issued by an authority that is not trusted."))
      CASE_ERRCODE2(SEC_E_ILLEGAL_MESSAGE                                              , _T("The message received was unexpected or badly formatted."))
      CASE_ERRCODE2(SEC_E_CERT_UNKNOWN                                                 , _T("An unknown error occurred while processing the certificate."))
      CASE_ERRCODE2(SEC_E_CERT_EXPIRED                                                 , _T("The received certificate has expired."))
      CASE_ERRCODE2(SEC_E_ENCRYPT_FAILURE                                              , _T("The specified data could not be encrypted."))
      CASE_ERRCODE2(SEC_E_DECRYPT_FAILURE                                              , _T("The specified data could not be decrypted."))
      CASE_ERRCODE2(SEC_E_ALGORITHM_MISMATCH                                           , _T("The client and server cannot communicate, because they do not possess a common algorithm."))
      CASE_ERRCODE2(SEC_E_SECURITY_QOS_FAILED                                          , _T("The security context could not be established due to a failure in the requested quality of service (e.g. mutual authentication or delegation)."))
      CASE_ERRCODE2(SEC_E_UNFINISHED_CONTEXT_DELETED                                   , _T("A security context was deleted before the context was completed.  This is considered a logon failure."))
      CASE_ERRCODE2(SEC_E_NO_TGT_REPLY                                                 , _T("The client is trying to negotiate a context and the server requires user-to-user but didn't send a TGT reply."))
      CASE_ERRCODE2(SEC_E_NO_IP_ADDRESSES                                              , _T("Unable to accomplish the requested task because the local machine does not have any IP addresses."))
      CASE_ERRCODE2(SEC_E_WRONG_CREDENTIAL_HANDLE                                      , _T("The supplied credential handle does not match the credential associated with the security context."))
      CASE_ERRCODE2(SEC_E_CRYPTO_SYSTEM_INVALID                                        , _T("The crypto system or checksum function is invalid because a required function is unavailable."))
      CASE_ERRCODE2(SEC_E_MAX_REFERRALS_EXCEEDED                                       , _T("The number of maximum ticket referrals has been exceeded."))
      CASE_ERRCODE2(SEC_E_MUST_BE_KDC                                                  , _T("The local machine must be a Kerberos KDC (domain controller) and it is not."))
      CASE_ERRCODE2(SEC_E_STRONG_CRYPTO_NOT_SUPPORTED                                  , _T("The other end of the security negotiation is requires strong crypto but it is not supported on the local machine."))
      CASE_ERRCODE2(SEC_E_TOO_MANY_PRINCIPALS                                          , _T("The KDC reply contained more than one principal name."))
      CASE_ERRCODE2(SEC_E_NO_PA_DATA                                                   , _T("Expected to find PA data for a hint of what etype to use, but it was not found."))
      CASE_ERRCODE2(SEC_E_PKINIT_NAME_MISMATCH                                         , _T("The client certificate does not contain a valid UPN, or does not match the client name in the logon request.  Please contact your administrator."))
      CASE_ERRCODE2(SEC_E_SMARTCARD_LOGON_REQUIRED                                     , _T("Smartcard logon is required and was not used."))
      CASE_ERRCODE2(SEC_E_SHUTDOWN_IN_PROGRESS                                         , _T("A system shutdown is in progress."))
      CASE_ERRCODE2(SEC_E_KDC_INVALID_REQUEST                                          , _T("An invalid request was sent to the KDC."))
      CASE_ERRCODE2(SEC_E_KDC_UNABLE_TO_REFER                                          , _T("The KDC was unable to generate a referral for the service requested."))
      CASE_ERRCODE2(SEC_E_KDC_UNKNOWN_ETYPE                                            , _T("The encryption type requested is not supported by the KDC."))
      CASE_ERRCODE2(SEC_E_UNSUPPORTED_PREAUTH                                          , _T("An unsupported preauthentication mechanism was presented to the kerberos package."))
      CASE_ERRCODE2(SEC_E_DELEGATION_REQUIRED                                          , _T("The requested operation cannot be completed.  The computer must be trusted for delegation and the current user account must be configured to allow delegation."))
      CASE_ERRCODE2(SEC_E_BAD_BINDINGS                                                 , _T("Client's supplied SSPI channel bindings were incorrect."))
      CASE_ERRCODE2(SEC_E_MULTIPLE_ACCOUNTS                                            , _T("The received certificate was mapped to multiple accounts."))
      CASE_ERRCODE2(SEC_E_NO_KERB_KEY                                                  , _T("SEC_E_NO_KERB_KEY"))
      CASE_ERRCODE2(SEC_E_CERT_WRONG_USAGE                                             , _T("The certificate is not valid for the requested usage."))
      CASE_ERRCODE2(SEC_E_DOWNGRADE_DETECTED                                           , _T("The system detected a possible attempt to compromise security.  Please ensure that you can contact the server that authenticated you."))
      CASE_ERRCODE2(SEC_E_SMARTCARD_CERT_REVOKED                                       , _T("The smartcard certificate used for authentication has been revoked. Please contact your system administrator. There may be additional information in the event log."))
      CASE_ERRCODE2(SEC_E_ISSUING_CA_UNTRUSTED                                         , _T("An untrusted certificate authority was detected While processing the smartcard certificate used for authentication. Please contact your system administrator."))
      CASE_ERRCODE2(SEC_E_REVOCATION_OFFLINE_C                                         , _T("The revocation status of the smartcard certificate used for authentication could not be determined. Please contact your system administrator."))
      CASE_ERRCODE2(SEC_E_PKINIT_CLIENT_FAILURE                                        , _T("The smartcard certificate used for authentication was not trusted. Please contact your system administrator."))
      CASE_ERRCODE2(SEC_E_SMARTCARD_CERT_EXPIRED                                       , _T("The smartcard certificate used for authentication has expired. Please contact your system administrator."))
      CASE_ERRCODE2(SEC_E_NO_S4U_PROT_SUPPORT                                          , _T("The Kerberos subsystem encountered an error.  A service for user protocol request was made against a domain controller which does not support service for user."))
      CASE_ERRCODE2(SEC_E_CROSSREALM_DELEGATION_FAILURE                                , _T("An attempt was made by this server to make a Kerberos constrained delegation request for a target outside of the server's realm.  This is not supported, and indicates a misconfiguration on this server's allowed to delegate to list.  Please contact your administrator."))
      CASE_ERRCODE2(SEC_E_REVOCATION_OFFLINE_KDC                                       , _T("The revocation status of the domain controller certificate used for smartcard authentication could not be determined.  There is additional information in the system event log. Please contact your system administrator."))
      CASE_ERRCODE2(SEC_E_ISSUING_CA_UNTRUSTED_KDC                                     , _T("An untrusted certificate authority was detected while processing the domain controller certificate used for authentication.  There is additional information in the system event log.  Please contact your system administrator."))
      CASE_ERRCODE2(SEC_E_KDC_CERT_EXPIRED                                             , _T("The domain controller certificate used for smartcard logon has expired. Please contact your system administrator with the contents of your system event log."))
      CASE_ERRCODE2(SEC_E_KDC_CERT_REVOKED                                             , _T("The domain controller certificate used for smartcard logon has been revoked. Please contact your system administrator with the contents of your system event log."))
#endif // __SDK__
      CASE_ERRCODE2(CRYPT_E_MSG_ERROR                                                  , _T("An error occurred while performing an operation on a cryptographic message."))
      CASE_ERRCODE2(CRYPT_E_UNKNOWN_ALGO                                               , _T("Unknown cryptographic algorithm."))
      CASE_ERRCODE2(CRYPT_E_OID_FORMAT                                                 , _T("The object identifier is poorly formatted."))
      CASE_ERRCODE2(CRYPT_E_INVALID_MSG_TYPE                                           , _T("Invalid cryptographic message type."))
      CASE_ERRCODE2(CRYPT_E_UNEXPECTED_ENCODING                                        , _T("Unexpected cryptographic message encoding."))
      CASE_ERRCODE2(CRYPT_E_AUTH_ATTR_MISSING                                          , _T("The cryptographic message does not contain an expected authenticated attribute."))
      CASE_ERRCODE2(CRYPT_E_HASH_VALUE                                                 , _T("The hash value is not correct."))
      CASE_ERRCODE2(CRYPT_E_INVALID_INDEX                                              , _T("The index value is not valid."))
      CASE_ERRCODE2(CRYPT_E_ALREADY_DECRYPTED                                          , _T("The content of the cryptographic message has already been decrypted."))
      CASE_ERRCODE2(CRYPT_E_NOT_DECRYPTED                                              , _T("The content of the cryptographic message has not been decrypted yet."))
      CASE_ERRCODE2(CRYPT_E_RECIPIENT_NOT_FOUND                                        , _T("The enveloped-data message does not contain the specified recipient."))
      CASE_ERRCODE2(CRYPT_E_CONTROL_TYPE                                               , _T("Invalid control type."))
      CASE_ERRCODE2(CRYPT_E_ISSUER_SERIALNUMBER                                        , _T("Invalid issuer and/or serial number."))
      CASE_ERRCODE2(CRYPT_E_SIGNER_NOT_FOUND                                           , _T("Cannot find the original signer."))
      CASE_ERRCODE2(CRYPT_E_ATTRIBUTES_MISSING                                         , _T("The cryptographic message does not contain all of the requested attributes."))
      CASE_ERRCODE2(CRYPT_E_STREAM_MSG_NOT_READY                                       , _T("The streamed cryptographic message is not ready to return data."))
      CASE_ERRCODE2(CRYPT_E_STREAM_INSUFFICIENT_DATA                                   , _T("The streamed cryptographic message requires more data to complete the decode operation."))
#ifdef __SDK__
      CASE_ERRCODE2(CRYPT_I_NEW_PROTECTION_REQUIRED                                    , _T("The protected data needs to be re-protected."))
#endif // __SDK__
      CASE_ERRCODE2(CRYPT_E_BAD_LEN                                                    , _T("The length specified for the output data was insufficient."))
      CASE_ERRCODE2(CRYPT_E_BAD_ENCODE                                                 , _T("An error occurred during encode or decode operation."))
      CASE_ERRCODE2(CRYPT_E_FILE_ERROR                                                 , _T("An error occurred while reading or writing to a file."))
      CASE_ERRCODE2(CRYPT_E_NOT_FOUND                                                  , _T("Cannot find object or property."))
      CASE_ERRCODE2(CRYPT_E_EXISTS                                                     , _T("The object or property already exists."))
      CASE_ERRCODE2(CRYPT_E_NO_PROVIDER                                                , _T("No provider was specified for the store or object."))
      CASE_ERRCODE2(CRYPT_E_SELF_SIGNED                                                , _T("The specified certificate is self signed."))
      CASE_ERRCODE2(CRYPT_E_DELETED_PREV                                               , _T("The previous certificate or CRL context was deleted."))
      CASE_ERRCODE2(CRYPT_E_NO_MATCH                                                   , _T("Cannot find the requested object."))
      CASE_ERRCODE2(CRYPT_E_UNEXPECTED_MSG_TYPE                                        , _T("The certificate does not have a property that references a private key."))
      CASE_ERRCODE2(CRYPT_E_NO_KEY_PROPERTY                                            , _T("Cannot find the certificate and private key for decryption."))
      CASE_ERRCODE2(CRYPT_E_NO_DECRYPT_CERT                                            , _T("Cannot find the certificate and private key to use for decryption."))
      CASE_ERRCODE2(CRYPT_E_BAD_MSG                                                    , _T("Not a cryptographic message or the cryptographic message is not formatted correctly."))
      CASE_ERRCODE2(CRYPT_E_NO_SIGNER                                                  , _T("The signed cryptographic message does not have a signer for the specified signer index."))
      CASE_ERRCODE2(CRYPT_E_PENDING_CLOSE                                              , _T("Final closure is pending until additional frees or closes."))
      CASE_ERRCODE2(CRYPT_E_REVOKED                                                    , _T("The certificate is revoked."))
      CASE_ERRCODE2(CRYPT_E_NO_REVOCATION_DLL                                          , _T("No Dll or exported function was found to verify revocation."))
      CASE_ERRCODE2(CRYPT_E_NO_REVOCATION_CHECK                                        , _T("The revocation function was unable to check revocation for the certificate."))
      CASE_ERRCODE2(CRYPT_E_REVOCATION_OFFLINE                                         , _T("The revocation function was unable to check revocation because the revocation server was offline."))
      CASE_ERRCODE2(CRYPT_E_NOT_IN_REVOCATION_DATABASE                                 , _T("The certificate is not in the revocation server's database."))
      CASE_ERRCODE2(CRYPT_E_INVALID_NUMERIC_STRING                                     , _T("The string contains a non-numeric character."))
      CASE_ERRCODE2(CRYPT_E_INVALID_PRINTABLE_STRING                                   , _T("The string contains a non-printable character."))
      CASE_ERRCODE2(CRYPT_E_INVALID_IA5_STRING                                         , _T("The string contains a character not in the 7 bit ASCII character set."))
      CASE_ERRCODE2(CRYPT_E_INVALID_X500_STRING                                        , _T("The string contains an invalid X500 name attribute key, oid, value or delimiter."))
      CASE_ERRCODE2(CRYPT_E_NOT_CHAR_STRING                                            , _T("The dwValueType for the CERT_NAME_VALUE is not one of the character strings.  Most likely it is either a CERT_RDN_ENCODED_BLOB or CERT_TDN_OCTED_STRING."))
      CASE_ERRCODE2(CRYPT_E_FILERESIZED                                                , _T("The Put operation can not continue.  The file needs to be resized.  However, there is already a signature present.  A complete signing operation must be done."))
      CASE_ERRCODE2(CRYPT_E_SECURITY_SETTINGS                                          , _T("The cryptographic operation failed due to a local security option setting."))
      CASE_ERRCODE2(CRYPT_E_NO_VERIFY_USAGE_DLL                                        , _T("No DLL or exported function was found to verify subject usage."))
      CASE_ERRCODE2(CRYPT_E_NO_VERIFY_USAGE_CHECK                                      , _T("The called function was unable to do a usage check on the subject."))
      CASE_ERRCODE2(CRYPT_E_VERIFY_USAGE_OFFLINE                                       , _T("Since the server was offline, the called function was unable to complete the usage check."))
      CASE_ERRCODE2(CRYPT_E_NOT_IN_CTL                                                 , _T("The subject was not found in a Certificate Trust List (CTL)."))
      CASE_ERRCODE2(CRYPT_E_NO_TRUSTED_SIGNER                                          , _T("None of the signers of the cryptographic message or certificate trust list is trusted."))
#ifdef __SDK__
      CASE_ERRCODE2(CRYPT_E_MISSING_PUBKEY_PARA                                        , _T("The public key's algorithm parameters are missing."))
#endif // __SDK__
      CASE_ERRCODE2(CRYPT_E_OSS_ERROR                                                  , _T("OSS Certificate encode/decode error code base. See asn1code.h for a definition of the OSS runtime errors. The OSS error values are offset by CRYPT_E_OSS_ERROR."))
#ifdef __SDK__
      CASE_ERRCODE2(OSS_MORE_BUF                                                       , _T("OSS ASN.1 Error: Output Buffer is too small."))
      CASE_ERRCODE2(OSS_NEGATIVE_UINTEGER                                              , _T("OSS ASN.1 Error: Signed integer is encoded as a unsigned integer."))
      CASE_ERRCODE2(OSS_PDU_RANGE                                                      , _T("OSS ASN.1 Error: Unknown ASN.1 data type."))
      CASE_ERRCODE2(OSS_MORE_INPUT                                                     , _T("OSS ASN.1 Error: Output buffer is too small, the decoded data has been truncated."))
      CASE_ERRCODE2(OSS_DATA_ERROR                                                     , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_BAD_ARG                                                        , _T("OSS ASN.1 Error: Invalid argument."))
      CASE_ERRCODE2(OSS_BAD_VERSION                                                    , _T("OSS ASN.1 Error: Encode/Decode version mismatch."))
      CASE_ERRCODE2(OSS_OUT_MEMORY                                                     , _T("OSS ASN.1 Error: Out of memory."))
      CASE_ERRCODE2(OSS_PDU_MISMATCH                                                   , _T("OSS ASN.1 Error: Encode/Decode Error."))
      CASE_ERRCODE2(OSS_LIMITED                                                        , _T("OSS ASN.1 Error: Internal Error."))
      CASE_ERRCODE2(OSS_BAD_PTR                                                        , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_BAD_TIME                                                       , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_INDEFINITE_NOT_SUPPORTED                                       , _T("OSS ASN.1 Error: Unsupported BER indefinite-length encoding."))
      CASE_ERRCODE2(OSS_MEM_ERROR                                                      , _T("OSS ASN.1 Error: Access violation."))
      CASE_ERRCODE2(OSS_BAD_TABLE                                                      , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_TOO_LONG                                                       , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_CONSTRAINT_VIOLATED                                            , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_FATAL_ERROR                                                    , _T("OSS ASN.1 Error: Internal Error."))
      CASE_ERRCODE2(OSS_ACCESS_SERIALIZATION_ERROR                                     , _T("OSS ASN.1 Error: Multi-threading conflict."))
      CASE_ERRCODE2(OSS_NULL_TBL                                                       , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_NULL_FCN                                                       , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_BAD_ENCRULES                                                   , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_UNAVAIL_ENCRULES                                               , _T("OSS ASN.1 Error: Encode/Decode function not implemented."))
      CASE_ERRCODE2(OSS_CANT_OPEN_TRACE_WINDOW                                         , _T("OSS ASN.1 Error: Trace file error."))
      CASE_ERRCODE2(OSS_UNIMPLEMENTED                                                  , _T("OSS ASN.1 Error: Function not implemented."))
      CASE_ERRCODE2(OSS_OID_DLL_NOT_LINKED                                             , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_CANT_OPEN_TRACE_FILE                                           , _T("OSS ASN.1 Error: Trace file error."))
      CASE_ERRCODE2(OSS_TRACE_FILE_ALREADY_OPEN                                        , _T("OSS ASN.1 Error: Trace file error."))
      CASE_ERRCODE2(OSS_TABLE_MISMATCH                                                 , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_TYPE_NOT_SUPPORTED                                             , _T("OSS ASN.1 Error: Invalid data."))
      CASE_ERRCODE2(OSS_REAL_DLL_NOT_LINKED                                            , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_REAL_CODE_NOT_LINKED                                           , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_OUT_OF_RANGE                                                   , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_COPIER_DLL_NOT_LINKED                                          , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_CONSTRAINT_DLL_NOT_LINKED                                      , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_COMPARATOR_DLL_NOT_LINKED                                      , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_COMPARATOR_CODE_NOT_LINKED                                     , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_MEM_MGR_DLL_NOT_LINKED                                         , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_PDV_DLL_NOT_LINKED                                             , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_PDV_CODE_NOT_LINKED                                            , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_API_DLL_NOT_LINKED                                             , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_BERDER_DLL_NOT_LINKED                                          , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_PER_DLL_NOT_LINKED                                             , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_OPEN_TYPE_ERROR                                                , _T("OSS ASN.1 Error: Program link error."))
      CASE_ERRCODE2(OSS_MUTEX_NOT_CREATED                                              , _T("OSS ASN.1 Error: System resource error."))
      CASE_ERRCODE2(OSS_CANT_CLOSE_TRACE_FILE                                          , _T("OSS ASN.1 Error: Trace file error."))
      CASE_ERRCODE2(CRYPT_E_ASN1_ERROR                                                 , _T("ASN1 Certificate encode/decode error code base. The ASN1 error values are offset by CRYPT_E_ASN1_ERROR."))
      CASE_ERRCODE2(CRYPT_E_ASN1_INTERNAL                                              , _T("ASN1 internal encode or decode error."))
      CASE_ERRCODE2(CRYPT_E_ASN1_EOD                                                   , _T("ASN1 unexpected end of data."))
      CASE_ERRCODE2(CRYPT_E_ASN1_CORRUPT                                               , _T("ASN1 corrupted data."))
      CASE_ERRCODE2(CRYPT_E_ASN1_LARGE                                                 , _T("ASN1 value too large."))
      CASE_ERRCODE2(CRYPT_E_ASN1_CONSTRAINT                                            , _T("ASN1 constraint violated."))
      CASE_ERRCODE2(CRYPT_E_ASN1_MEMORY                                                , _T("ASN1 out of memory."))
      CASE_ERRCODE2(CRYPT_E_ASN1_OVERFLOW                                              , _T("ASN1 buffer overflow."))
      CASE_ERRCODE2(CRYPT_E_ASN1_BADPDU                                                , _T("ASN1 function not supported for this PDU."))
      CASE_ERRCODE2(CRYPT_E_ASN1_BADARGS                                               , _T("ASN1 bad arguments to function call."))
      CASE_ERRCODE2(CRYPT_E_ASN1_BADREAL                                               , _T("ASN1 bad real value."))
      CASE_ERRCODE2(CRYPT_E_ASN1_BADTAG                                                , _T("ASN1 bad tag value met."))
      CASE_ERRCODE2(CRYPT_E_ASN1_CHOICE                                                , _T("ASN1 bad choice value."))
      CASE_ERRCODE2(CRYPT_E_ASN1_RULE                                                  , _T("ASN1 bad encoding rule."))
      CASE_ERRCODE2(CRYPT_E_ASN1_UTF8                                                  , _T("ASN1 bad unicode (UTF8)."))
      CASE_ERRCODE2(CRYPT_E_ASN1_PDU_TYPE                                              , _T("ASN1 bad PDU type."))
      CASE_ERRCODE2(CRYPT_E_ASN1_NYI                                                   , _T("ASN1 not yet implemented."))
      CASE_ERRCODE2(CRYPT_E_ASN1_EXTENDED                                              , _T("ASN1 skipped unknown extension(s)."))
      CASE_ERRCODE2(CRYPT_E_ASN1_NOEOD                                                 , _T("ASN1 end of data expected"))
#endif // __SDK__
      CASE_ERRCODE2(CERTSRV_E_BAD_REQUESTSUBJECT                                       , _T("The request subject name is invalid or too long."))
      CASE_ERRCODE2(CERTSRV_E_NO_REQUEST                                               , _T("The request does not exist."))
      CASE_ERRCODE2(CERTSRV_E_BAD_REQUESTSTATUS                                        , _T("The request's current status does not allow this operation."))
      CASE_ERRCODE2(CERTSRV_E_PROPERTY_EMPTY                                           , _T("The requested property value is empty."))
#ifdef __SDK__
      CASE_ERRCODE2(CERTSRV_E_INVALID_CA_CERTIFICATE                                   , _T("The certification authority's certificate contains invalid data."))
      CASE_ERRCODE2(CERTSRV_E_SERVER_SUSPENDED                                         , _T("Certificate service has been suspended for a database restore operation."))
      CASE_ERRCODE2(CERTSRV_E_ENCODING_LENGTH                                          , _T("The certificate contains an encoded length that is potentially incompatible with older enrollment software."))
      CASE_ERRCODE2(CERTSRV_E_ROLECONFLICT                                             , _T("The operation is denied. The user has multiple roles assigned and the certification authority is configured to enforce role separation."))
      CASE_ERRCODE2(CERTSRV_E_RESTRICTEDOFFICER                                        , _T("The operation is denied. It can only be performed by a certificate manager that is allowed to manage certificates for the current requester."))
      CASE_ERRCODE2(CERTSRV_E_KEY_ARCHIVAL_NOT_CONFIGURED                              , _T("Cannot archive private key.  The certification authority is not configured for key archival."))
      CASE_ERRCODE2(CERTSRV_E_NO_VALID_KRA                                             , _T("Cannot archive private key.  The certification authority could not verify one or more key recovery certificates."))
      CASE_ERRCODE2(CERTSRV_E_BAD_REQUEST_KEY_ARCHIVAL                                 , _T("The request is incorrectly formatted.  The encrypted private key must be in an unauthenticated attribute in an outermost signature."))
      CASE_ERRCODE2(CERTSRV_E_NO_CAADMIN_DEFINED                                       , _T("At least one security principal must have the permission to manage this CA."))
      CASE_ERRCODE2(CERTSRV_E_BAD_RENEWAL_CERT_ATTRIBUTE                               , _T("The request contains an invalid renewal certificate attribute."))
      CASE_ERRCODE2(CERTSRV_E_NO_DB_SESSIONS                                           , _T("An attempt was made to open a Certification Authority database session, but there are already too many active sessions.  The server may need to be configured to allow additional sessions."))
      CASE_ERRCODE2(CERTSRV_E_ALIGNMENT_FAULT                                          , _T("A memory reference caused a data alignment fault."))
      CASE_ERRCODE2(CERTSRV_E_ENROLL_DENIED                                            , _T("The permissions on this certification authority do not allow the current user to enroll for certificates."))
      CASE_ERRCODE2(CERTSRV_E_TEMPLATE_DENIED                                          , _T("The permissions on the certificate template do not allow the current user to enroll for this type of certificate."))
      CASE_ERRCODE2(CERTSRV_E_DOWNLEVEL_DC_SSL_OR_UPGRADE                              , _T("The contacted domain controller cannot support signed LDAP traffic.  Update the domain controller or configure Certificate Services to use SSL for Active Directory access."))
      CASE_ERRCODE2(CERTSRV_E_UNSUPPORTED_CERT_TYPE                                    , _T("The requested certificate template is not supported by this CA."))
      CASE_ERRCODE2(CERTSRV_E_NO_CERT_TYPE                                             , _T("The request contains no certificate template information."))
      CASE_ERRCODE2(CERTSRV_E_TEMPLATE_CONFLICT                                        , _T("The request contains conflicting template information."))
      CASE_ERRCODE2(CERTSRV_E_SUBJECT_ALT_NAME_REQUIRED                                , _T("The request is missing a required Subject Alternate name extension."))
      CASE_ERRCODE2(CERTSRV_E_ARCHIVED_KEY_REQUIRED                                    , _T("The request is missing a required private key for archival by the server."))
      CASE_ERRCODE2(CERTSRV_E_SMIME_REQUIRED                                           , _T("The request is missing a required SMIME capabilities extension."))
      CASE_ERRCODE2(CERTSRV_E_BAD_RENEWAL_SUBJECT                                      , _T("The request was made on behalf of a subject other than the caller.  The certificate template must be configured to require at least one signature to authorize the request."))
      CASE_ERRCODE2(CERTSRV_E_BAD_TEMPLATE_VERSION                                     , _T("The request template version is newer than the supported template version."))
      CASE_ERRCODE2(CERTSRV_E_TEMPLATE_POLICY_REQUIRED                                 , _T("The template is missing a required signature policy attribute."))
      CASE_ERRCODE2(CERTSRV_E_SIGNATURE_POLICY_REQUIRED                                , _T("The request is missing required signature policy information."))
      CASE_ERRCODE2(CERTSRV_E_SIGNATURE_COUNT                                          , _T("The request is missing one or more required signatures."))
      CASE_ERRCODE2(CERTSRV_E_SIGNATURE_REJECTED                                       , _T("One or more signatures did not include the required application or issuance policies.  The request is missing one or more required valid signatures."))
      CASE_ERRCODE2(CERTSRV_E_ISSUANCE_POLICY_REQUIRED                                 , _T("The request is missing one or more required signature issuance policies."))
      CASE_ERRCODE2(CERTSRV_E_SUBJECT_UPN_REQUIRED                                     , _T("The UPN is unavailable and cannot be added to the Subject Alternate name."))
      CASE_ERRCODE2(CERTSRV_E_SUBJECT_DIRECTORY_GUID_REQUIRED                          , _T("The Active Directory GUID is unavailable and cannot be added to the Subject Alternate name."))
      CASE_ERRCODE2(CERTSRV_E_SUBJECT_DNS_REQUIRED                                     , _T("The DNS name is unavailable and cannot be added to the Subject Alternate name."))
      CASE_ERRCODE2(CERTSRV_E_ARCHIVED_KEY_UNEXPECTED                                  , _T("The request includes a private key for archival by the server, but key archival is not enabled for the specified certificate template."))
      CASE_ERRCODE2(CERTSRV_E_KEY_LENGTH                                               , _T("The public key does not meet the minimum size required by the specified certificate template."))
      CASE_ERRCODE2(CERTSRV_E_SUBJECT_EMAIL_REQUIRED                                   , _T("The EMail name is unavailable and cannot be added to the Subject or Subject Alternate name."))
      CASE_ERRCODE2(CERTSRV_E_UNKNOWN_CERT_TYPE                                        , _T("One or more certificate templates to be enabled on this certification authority could not be found."))
      CASE_ERRCODE2(CERTSRV_E_CERT_TYPE_OVERLAP                                        , _T("The certificate template renewal period is longer than the certificate validity period.  The template should be reconfigured or the CA certificate renewed."))
      CASE_ERRCODE2(XENROLL_E_KEY_NOT_EXPORTABLE                                       , _T("The key is not exportable."))
      CASE_ERRCODE2(XENROLL_E_CANNOT_ADD_ROOT_CERT                                     , _T("You cannot add the root CA certificate into your local store."))
      CASE_ERRCODE2(XENROLL_E_RESPONSE_KA_HASH_NOT_FOUND                               , _T("The key archival hash attribute was not found in the response."))
      CASE_ERRCODE2(XENROLL_E_RESPONSE_UNEXPECTED_KA_HASH                              , _T("An unexpected key archival hash attribute was found in the response."))
      CASE_ERRCODE2(XENROLL_E_RESPONSE_KA_HASH_MISMATCH                                , _T("There is a key archival hash mismatch between the request and the response."))
      CASE_ERRCODE2(XENROLL_E_KEYSPEC_SMIME_MISMATCH                                   , _T("Signing certificate cannot include SMIME extension."))
#endif // __SDK__
      CASE_ERRCODE2(TRUST_E_SYSTEM_ERROR                                               , _T("A system-level error occurred while verifying trust."))
      CASE_ERRCODE2(TRUST_E_NO_SIGNER_CERT                                             , _T("The certificate for the signer of the message is invalid or not found."))
      CASE_ERRCODE2(TRUST_E_COUNTER_SIGNER                                             , _T("One of the counter signatures was invalid."))
      CASE_ERRCODE2(TRUST_E_CERT_SIGNATURE                                             , _T("The signature of the certificate can not be verified."))
      CASE_ERRCODE2(TRUST_E_TIME_STAMP                                                 , _T("The timestamp signature and/or certificate could not be verified or is malformed."))
      CASE_ERRCODE2(TRUST_E_BAD_DIGEST                                                 , _T("The digital signature of the object did not verify."))
      CASE_ERRCODE2(TRUST_E_BASIC_CONSTRAINTS                                          , _T("A certificate's basic constraint extension has not been observed."))
      CASE_ERRCODE2(TRUST_E_FINANCIAL_CRITERIA                                         , _T("The certificate does not meet or contain the Authenticode(tm) financial extensions."))
#ifdef __SDK__
      CASE_ERRCODE2(MSSIPOTF_E_OUTOFMEMRANGE                                           , _T("Tried to reference a part of the file outside the proper range."))
      CASE_ERRCODE2(MSSIPOTF_E_CANTGETOBJECT                                           , _T("Could not retrieve an object from the file."))
      CASE_ERRCODE2(MSSIPOTF_E_NOHEADTABLE                                             , _T("Could not find the head table in the file."))
      CASE_ERRCODE2(MSSIPOTF_E_BAD_MAGICNUMBER                                         , _T("The magic number in the head table is incorrect."))
      CASE_ERRCODE2(MSSIPOTF_E_BAD_OFFSET_TABLE                                        , _T("The offset table has incorrect values."))
      CASE_ERRCODE2(MSSIPOTF_E_TABLE_TAGORDER                                          , _T("Duplicate table tags or tags out of alphabetical order."))
      CASE_ERRCODE2(MSSIPOTF_E_TABLE_LONGWORD                                          , _T("A table does not start on a long word boundary."))
      CASE_ERRCODE2(MSSIPOTF_E_BAD_FIRST_TABLE_PLACEMENT                               , _T("First table does not appear after header information."))
      CASE_ERRCODE2(MSSIPOTF_E_TABLES_OVERLAP                                          , _T("Two or more tables overlap."))
      CASE_ERRCODE2(MSSIPOTF_E_TABLE_PADBYTES                                          , _T("Too many pad bytes between tables or pad bytes are not 0."))
      CASE_ERRCODE2(MSSIPOTF_E_FILETOOSMALL                                            , _T("File is too small to contain the last table."))
      CASE_ERRCODE2(MSSIPOTF_E_TABLE_CHECKSUM                                          , _T("A table checksum is incorrect."))
      CASE_ERRCODE2(MSSIPOTF_E_FILE_CHECKSUM                                           , _T("The file checksum is incorrect."))
      CASE_ERRCODE2(MSSIPOTF_E_FAILED_POLICY                                           , _T("The signature does not have the correct attributes for the policy."))
      CASE_ERRCODE2(MSSIPOTF_E_FAILED_HINTS_CHECK                                      , _T("The file did not pass the hints check."))
      CASE_ERRCODE2(MSSIPOTF_E_NOT_OPENTYPE                                            , _T("The file is not an OpenType file."))
      CASE_ERRCODE2(MSSIPOTF_E_FILE                                                    , _T("Failed on a file operation (open, map, read, write)."))
      CASE_ERRCODE2(MSSIPOTF_E_CRYPT                                                   , _T("A call to a CryptoAPI function failed."))
      CASE_ERRCODE2(MSSIPOTF_E_BADVERSION                                              , _T("There is a bad version number in the file."))
      CASE_ERRCODE2(MSSIPOTF_E_DSIG_STRUCTURE                                          , _T("The structure of the DSIG table is incorrect."))
      CASE_ERRCODE2(MSSIPOTF_E_PCONST_CHECK                                            , _T("A check failed in a partially constant table."))
      CASE_ERRCODE2(MSSIPOTF_E_STRUCTURE                                               , _T("Some kind of structural error."))
#endif // __SDK__
      CASE_ERRCODE2(TRUST_E_PROVIDER_UNKNOWN                                           , _T("Unknown trust provider."))
      CASE_ERRCODE2(TRUST_E_ACTION_UNKNOWN                                             , _T("The trust verification action specified is not supported by the specified trust provider."))
      CASE_ERRCODE2(TRUST_E_SUBJECT_FORM_UNKNOWN                                       , _T("The form specified for the subject is not one supported or known by the specified trust provider."))
      CASE_ERRCODE2(TRUST_E_SUBJECT_NOT_TRUSTED                                        , _T("The subject is not trusted for the specified action."))
      CASE_ERRCODE2(DIGSIG_E_ENCODE                                                    , _T("Error due to problem in ASN.1 encoding process."))
      CASE_ERRCODE2(DIGSIG_E_DECODE                                                    , _T("Error due to problem in ASN.1 decoding process."))
      CASE_ERRCODE2(DIGSIG_E_EXTENSIBILITY                                             , _T("Reading / writing Extensions where Attributes are appropriate, and visa versa."))
      CASE_ERRCODE2(DIGSIG_E_CRYPTO                                                    , _T("Unspecified cryptographic failure."))
      CASE_ERRCODE2(PERSIST_E_SIZEDEFINITE                                             , _T("The size of the data could not be determined."))
      CASE_ERRCODE2(PERSIST_E_SIZEINDEFINITE                                           , _T("The size of the indefinite-sized data could not be determined."))
      CASE_ERRCODE2(PERSIST_E_NOTSELFSIZING                                            , _T("This object does not read and write self-sizing data."))
      CASE_ERRCODE2(TRUST_E_NOSIGNATURE                                                , _T("No signature was present in the subject."))
      CASE_ERRCODE2(CERT_E_EXPIRED                                                     , _T("A required certificate is not within its validity period when verifying against the current system clock or the timestamp in the signed file."))
      CASE_ERRCODE2(CERT_E_VALIDITYPERIODNESTING                                       , _T("The validity periods of the certification chain do not nest correctly."))
      CASE_ERRCODE2(CERT_E_ROLE                                                        , _T("A certificate that can only be used as an end-entity is being used as a CA or visa versa."))
      CASE_ERRCODE2(CERT_E_PATHLENCONST                                                , _T("A path length constraint in the certification chain has been violated."))
      CASE_ERRCODE2(CERT_E_CRITICAL                                                    , _T("A certificate contains an unknown extension that is marked 'critical'."))
      CASE_ERRCODE2(CERT_E_PURPOSE                                                     , _T("A certificate being used for a purpose other than the ones specified by its CA."))
      CASE_ERRCODE2(CERT_E_ISSUERCHAINING                                              , _T("A parent of a given certificate in fact did not issue that child certificate."))
      CASE_ERRCODE2(CERT_E_MALFORMED                                                   , _T("A certificate is missing or has an empty value for an important field, such as a subject or issuer name."))
      CASE_ERRCODE2(CERT_E_UNTRUSTEDROOT                                               , _T("A certificate chain processed, but terminated in a root certificate which is not trusted by the trust provider."))
      CASE_ERRCODE2(CERT_E_CHAINING                                                    , _T("A certificate chain could not be built to a trusted root authority."))
      CASE_ERRCODE2(TRUST_E_FAIL                                                       , _T("Generic trust failure."))
      CASE_ERRCODE2(CERT_E_REVOKED                                                     , _T("A certificate was explicitly revoked by its issuer."))
      CASE_ERRCODE2(CERT_E_UNTRUSTEDTESTROOT                                           , _T("The certification path terminates with the test root which is not trusted with the current policy settings."))
      CASE_ERRCODE2(CERT_E_REVOCATION_FAILURE                                          , _T("The revocation process could not continue - the certificate(s) could not be checked."))
      CASE_ERRCODE2(CERT_E_CN_NO_MATCH                                                 , _T("The certificate's CN name does not match the passed value."))
      CASE_ERRCODE2(CERT_E_WRONG_USAGE                                                 , _T("The certificate is not valid for the requested usage."))
#ifdef __SDK__
      CASE_ERRCODE2(TRUST_E_EXPLICIT_DISTRUST                                          , _T("The certificate was explicitly marked as untrusted by the user."))
      CASE_ERRCODE2(CERT_E_UNTRUSTEDCA                                                 , _T("A certification chain processed correctly, but one of the CA certificates is not trusted by the policy provider."))
      CASE_ERRCODE2(CERT_E_INVALID_POLICY                                              , _T("The certificate has invalid policy."))
      CASE_ERRCODE2(CERT_E_INVALID_NAME                                                , _T("The certificate has an invalid name. The name is not included in the permitted list or is explicitly excluded."))
#endif // __SDK__
      CASE_ERRCODE2(SPAPI_E_EXPECTED_SECTION_NAME                                      , _T("A non-empty line was encountered in the INF before the start of a section."))
      CASE_ERRCODE2(SPAPI_E_BAD_SECTION_NAME_LINE                                      , _T("A section name marker in the INF is not complete, or does not exist on a line by itself."))
      CASE_ERRCODE2(SPAPI_E_SECTION_NAME_TOO_LONG                                      , _T("An INF section was encountered whose name exceeds the maximum section name length."))
      CASE_ERRCODE2(SPAPI_E_GENERAL_SYNTAX                                             , _T("The syntax of the INF is invalid."))
      CASE_ERRCODE2(SPAPI_E_WRONG_INF_STYLE                                            , _T("The style of the INF is different than what was requested."))
      CASE_ERRCODE2(SPAPI_E_SECTION_NOT_FOUND                                          , _T("The required section was not found in the INF."))
      CASE_ERRCODE2(SPAPI_E_LINE_NOT_FOUND                                             , _T("The required line was not found in the INF."))
#ifdef __SDK__
      CASE_ERRCODE2(SPAPI_E_NO_BACKUP                                                  , _T("The files affected by the installation of this file queue have not been backed up for uninstall."))
#endif // __SDK__
      CASE_ERRCODE2(SPAPI_E_NO_ASSOCIATED_CLASS                                        , _T("The INF or the device information set or element does not have an associated install class."))
      CASE_ERRCODE2(SPAPI_E_CLASS_MISMATCH                                             , _T("The INF or the device information set or element does not match the specified install class."))
      CASE_ERRCODE2(SPAPI_E_DUPLICATE_FOUND                                            , _T("An existing device was found that is a duplicate of the device being manually installed."))
      CASE_ERRCODE2(SPAPI_E_NO_DRIVER_SELECTED                                         , _T("There is no driver selected for the device information set or element."))
      CASE_ERRCODE2(SPAPI_E_KEY_DOES_NOT_EXIST                                         , _T("The requested device registry key does not exist."))
      CASE_ERRCODE2(SPAPI_E_INVALID_DEVINST_NAME                                       , _T("The device instance name is invalid."))
      CASE_ERRCODE2(SPAPI_E_INVALID_CLASS                                              , _T("The install class is not present or is invalid."))
      CASE_ERRCODE2(SPAPI_E_DEVINST_ALREADY_EXISTS                                     , _T("The device instance cannot be created because it already exists."))
      CASE_ERRCODE2(SPAPI_E_DEVINFO_NOT_REGISTERED                                     , _T("The operation cannot be performed on a device information element that has not been registered."))
      CASE_ERRCODE2(SPAPI_E_INVALID_REG_PROPERTY                                       , _T("The device property code is invalid."))
      CASE_ERRCODE2(SPAPI_E_NO_INF                                                     , _T("The INF from which a driver list is to be built does not exist."))
      CASE_ERRCODE2(SPAPI_E_NO_SUCH_DEVINST                                            , _T("The device instance does not exist in the hardware tree."))
      CASE_ERRCODE2(SPAPI_E_CANT_LOAD_CLASS_ICON                                       , _T("The icon representing this install class cannot be loaded."))
      CASE_ERRCODE2(SPAPI_E_INVALID_CLASS_INSTALLER                                    , _T("The class installer registry entry is invalid."))
      CASE_ERRCODE2(SPAPI_E_DI_DO_DEFAULT                                              , _T("The class installer has indicated that the default action should be performed for this installation request."))
      CASE_ERRCODE2(SPAPI_E_DI_NOFILECOPY                                              , _T("The operation does not require any files to be copied."))
      CASE_ERRCODE2(SPAPI_E_INVALID_HWPROFILE                                          , _T("The specified hardware profile does not exist."))
      CASE_ERRCODE2(SPAPI_E_NO_DEVICE_SELECTED                                         , _T("There is no device information element currently selected for this device information set."))
      CASE_ERRCODE2(SPAPI_E_DEVINFO_LIST_LOCKED                                        , _T("The operation cannot be performed because the device information set is locked."))
      CASE_ERRCODE2(SPAPI_E_DEVINFO_DATA_LOCKED                                        , _T("The operation cannot be performed because the device information element is locked."))
      CASE_ERRCODE2(SPAPI_E_DI_BAD_PATH                                                , _T("The specified path does not contain any applicable device INFs."))
      CASE_ERRCODE2(SPAPI_E_NO_CLASSINSTALL_PARAMS                                     , _T("No class installer parameters have been set for the device information set or element."))
      CASE_ERRCODE2(SPAPI_E_FILEQUEUE_LOCKED                                           , _T("The operation cannot be performed because the file queue is locked."))
      CASE_ERRCODE2(SPAPI_E_BAD_SERVICE_INSTALLSECT                                    , _T("A service installation section in this INF is invalid."))
      CASE_ERRCODE2(SPAPI_E_NO_CLASS_DRIVER_LIST                                       , _T("There is no class driver list for the device information element."))
      CASE_ERRCODE2(SPAPI_E_NO_ASSOCIATED_SERVICE                                      , _T("The installation failed because a function driver was not specified for this device instance."))
      CASE_ERRCODE2(SPAPI_E_NO_DEFAULT_DEVICE_INTERFACE                                , _T("There is presently no default device interface designated for this interface class."))
      CASE_ERRCODE2(SPAPI_E_DEVICE_INTERFACE_ACTIVE                                    , _T("The operation cannot be performed because the device interface is currently active."))
      CASE_ERRCODE2(SPAPI_E_DEVICE_INTERFACE_REMOVED                                   , _T("The operation cannot be performed because the device interface has been removed from the system."))
      CASE_ERRCODE2(SPAPI_E_BAD_INTERFACE_INSTALLSECT                                  , _T("An interface installation section in this INF is invalid."))
      CASE_ERRCODE2(SPAPI_E_NO_SUCH_INTERFACE_CLASS                                    , _T("This interface class does not exist in the system."))
      CASE_ERRCODE2(SPAPI_E_INVALID_REFERENCE_STRING                                   , _T("The reference string supplied for this interface device is invalid."))
      CASE_ERRCODE2(SPAPI_E_INVALID_MACHINENAME                                        , _T("The specified machine name does not conform to UNC naming conventions."))
      CASE_ERRCODE2(SPAPI_E_REMOTE_COMM_FAILURE                                        , _T("A general remote communication error occurred."))
      CASE_ERRCODE2(SPAPI_E_MACHINE_UNAVAILABLE                                        , _T("The machine selected for remote communication is not available at this time."))
      CASE_ERRCODE2(SPAPI_E_NO_CONFIGMGR_SERVICES                                      , _T("The Plug and Play service is not available on the remote machine."))
      CASE_ERRCODE2(SPAPI_E_INVALID_PROPPAGE_PROVIDER                                  , _T("The property page provider registry entry is invalid."))
      CASE_ERRCODE2(SPAPI_E_NO_SUCH_DEVICE_INTERFACE                                   , _T("The requested device interface is not present in the system."))
      CASE_ERRCODE2(SPAPI_E_DI_POSTPROCESSING_REQUIRED                                 , _T("The device's co-installer has additional work to perform after installation is complete."))
      CASE_ERRCODE2(SPAPI_E_INVALID_COINSTALLER                                        , _T("The device's co-installer is invalid."))
      CASE_ERRCODE2(SPAPI_E_NO_COMPAT_DRIVERS                                          , _T("There are no compatible drivers for this device."))
      CASE_ERRCODE2(SPAPI_E_NO_DEVICE_ICON                                             , _T("There is no icon that represents this device or device type."))
      CASE_ERRCODE2(SPAPI_E_INVALID_INF_LOGCONFIG                                      , _T("A logical configuration specified in this INF is invalid."))
      CASE_ERRCODE2(SPAPI_E_DI_DONT_INSTALL                                            , _T("The class installer has denied the request to install or upgrade this device."))
      CASE_ERRCODE2(SPAPI_E_INVALID_FILTER_DRIVER                                      , _T("One of the filter drivers installed for this device is invalid."))
#ifdef __SDK__
      CASE_ERRCODE2(SPAPI_E_NON_WINDOWS_NT_DRIVER                                      , _T("The driver selected for this device does not support Windows XP."))
      CASE_ERRCODE2(SPAPI_E_NON_WINDOWS_DRIVER                                         , _T("The driver selected for this device does not support Windows."))
      CASE_ERRCODE2(SPAPI_E_NO_CATALOG_FOR_OEM_INF                                     , _T("The third-party INF does not contain digital signature information."))
      CASE_ERRCODE2(SPAPI_E_DEVINSTALL_QUEUE_NONNATIVE                                 , _T("An invalid attempt was made to use a device installation file queue for verification of digital signatures relative to other platforms."))
      CASE_ERRCODE2(SPAPI_E_NOT_DISABLEABLE                                            , _T("The device cannot be disabled."))
      CASE_ERRCODE2(SPAPI_E_CANT_REMOVE_DEVINST                                        , _T("The device could not be dynamically removed."))
      CASE_ERRCODE2(SPAPI_E_INVALID_TARGET                                             , _T("Cannot copy to specified target."))
      CASE_ERRCODE2(SPAPI_E_DRIVER_NONNATIVE                                           , _T("Driver is not intended for this platform."))
      CASE_ERRCODE2(SPAPI_E_IN_WOW64                                                   , _T("Operation not allowed in WOW64."))
      CASE_ERRCODE2(SPAPI_E_SET_SYSTEM_RESTORE_POINT                                   , _T("The operation involving unsigned file copying was rolled back, so that a system restore point could be set."))
      CASE_ERRCODE2(SPAPI_E_INCORRECTLY_COPIED_INF                                     , _T("An INF was copied into the Windows INF directory in an improper manner."))
      CASE_ERRCODE2(SPAPI_E_SCE_DISABLED                                               , _T("The Security Configuration Editor (SCE) APIs have been disabled on this Embedded product."))
      CASE_ERRCODE2(SPAPI_E_UNKNOWN_EXCEPTION                                          , _T("An unknown exception was encountered."))
      CASE_ERRCODE2(SPAPI_E_PNP_REGISTRY_ERROR                                         , _T("A problem was encountered when accessing the Plug and Play registry database."))
      CASE_ERRCODE2(SPAPI_E_REMOTE_REQUEST_UNSUPPORTED                                 , _T("The requested operation is not supported for a remote machine."))
      CASE_ERRCODE2(SPAPI_E_NOT_AN_INSTALLED_OEM_INF                                   , _T("The specified file is not an installed OEM INF."))
      CASE_ERRCODE2(SPAPI_E_INF_IN_USE_BY_DEVICES                                      , _T("One or more devices are presently installed using the specified INF."))
      CASE_ERRCODE2(SPAPI_E_DI_FUNCTION_OBSOLETE                                       , _T("The requested device install operation is obsolete."))
      CASE_ERRCODE2(SPAPI_E_NO_AUTHENTICODE_CATALOG                                    , _T("A file could not be verified because it does not have an associated catalog signed via Authenticode(tm)."))
      CASE_ERRCODE2(SPAPI_E_AUTHENTICODE_DISALLOWED                                    , _T("Authenticode(tm) signature verification is not supported for the specified INF."))
      CASE_ERRCODE2(SPAPI_E_AUTHENTICODE_TRUSTED_PUBLISHER                             , _T("The INF was signed with an Authenticode(tm) catalog from a trusted publisher."))
      CASE_ERRCODE2(SPAPI_E_AUTHENTICODE_TRUST_NOT_ESTABLISHED                         , _T("The publisher of an Authenticode(tm) signed catalog has not yet been established as trusted."))
      CASE_ERRCODE2(SPAPI_E_AUTHENTICODE_PUBLISHER_NOT_TRUSTED                         , _T("The publisher of an Authenticode(tm) signed catalog was not established as trusted."))
      CASE_ERRCODE2(SPAPI_E_SIGNATURE_OSATTRIBUTE_MISMATCH                             , _T("The software was tested for compliance with Windows Logo requirements on a different version of Windows, and may not be compatible with this version."))
      CASE_ERRCODE2(SPAPI_E_ONLY_VALIDATE_VIA_AUTHENTICODE                             , _T("The file may only be validated by a catalog signed via Authenticode(tm)."))
      CASE_ERRCODE2(SPAPI_E_UNRECOVERABLE_STACK_OVERFLOW                               , _T("An unrecoverable stack overflow was encountered."))
#endif // __SDK__
      CASE_ERRCODE2(SPAPI_E_ERROR_NOT_INSTALLED                                        , _T("No installed components were detected."))
#ifdef __SDK__
    //CASE_ERRCODE2(SCARD_S_SUCCESS                                                    , _T("no error"))
      CASE_ERRCODE2(SCARD_F_INTERNAL_ERROR                                             , _T("An internal consistency check failed."))
      CASE_ERRCODE2(SCARD_E_CANCELLED                                                  , _T("The action was cancelled by an SCardCancel request."))
      CASE_ERRCODE2(SCARD_E_INVALID_HANDLE                                             , _T("The supplied handle was invalid."))
      CASE_ERRCODE2(SCARD_E_INVALID_PARAMETER                                          , _T("One or more of the supplied parameters could not be properly interpreted."))
      CASE_ERRCODE2(SCARD_E_INVALID_TARGET                                             , _T("Registry startup information is missing or invalid."))
      CASE_ERRCODE2(SCARD_E_NO_MEMORY                                                  , _T("Not enough memory available to complete this command."))
      CASE_ERRCODE2(SCARD_F_WAITED_TOO_LONG                                            , _T("An internal consistency timer has expired."))
      CASE_ERRCODE2(SCARD_E_INSUFFICIENT_BUFFER                                        , _T("The data buffer to receive returned data is too small for the returned data."))
      CASE_ERRCODE2(SCARD_E_UNKNOWN_READER                                             , _T("The specified reader name is not recognized."))
      CASE_ERRCODE2(SCARD_E_TIMEOUT                                                    , _T("The user-specified timeout value has expired."))
      CASE_ERRCODE2(SCARD_E_SHARING_VIOLATION                                          , _T("The smart card cannot be accessed because of other connections outstanding."))
      CASE_ERRCODE2(SCARD_E_NO_SMARTCARD                                               , _T("The operation requires a Smart Card, but no Smart Card is currently in the device."))
      CASE_ERRCODE2(SCARD_E_UNKNOWN_CARD                                               , _T("The specified smart card name is not recognized."))
      CASE_ERRCODE2(SCARD_E_CANT_DISPOSE                                               , _T("The system could not dispose of the media in the requested manner."))
      CASE_ERRCODE2(SCARD_E_PROTO_MISMATCH                                             , _T("The requested protocols are incompatible with the protocol currently in use with the smart card."))
      CASE_ERRCODE2(SCARD_E_NOT_READY                                                  , _T("The reader or smart card is not ready to accept commands."))
      CASE_ERRCODE2(SCARD_E_INVALID_VALUE                                              , _T("One or more of the supplied parameters values could not be properly interpreted."))
      CASE_ERRCODE2(SCARD_E_SYSTEM_CANCELLED                                           , _T("The action was cancelled by the system, presumably to log off or shut down."))
      CASE_ERRCODE2(SCARD_F_COMM_ERROR                                                 , _T("An internal communications error has been detected."))
      CASE_ERRCODE2(SCARD_F_UNKNOWN_ERROR                                              , _T("An internal error has been detected, but the source is unknown."))
      CASE_ERRCODE2(SCARD_E_INVALID_ATR                                                , _T("An ATR obtained from the registry is not a valid ATR string."))
      CASE_ERRCODE2(SCARD_E_NOT_TRANSACTED                                             , _T("An attempt was made to end a non-existent transaction."))
      CASE_ERRCODE2(SCARD_E_READER_UNAVAILABLE                                         , _T("The specified reader is not currently available for use."))
      CASE_ERRCODE2(SCARD_P_SHUTDOWN                                                   , _T("The operation has been aborted to allow the server application to exit."))
      CASE_ERRCODE2(SCARD_E_PCI_TOO_SMALL                                              , _T("The PCI Receive buffer was too small."))
      CASE_ERRCODE2(SCARD_E_READER_UNSUPPORTED                                         , _T("The reader driver does not meet minimal requirements for support."))
      CASE_ERRCODE2(SCARD_E_DUPLICATE_READER                                           , _T("The reader driver did not produce a unique reader name."))
      CASE_ERRCODE2(SCARD_E_CARD_UNSUPPORTED                                           , _T("The smart card does not meet minimal requirements for support."))
      CASE_ERRCODE2(SCARD_E_NO_SERVICE                                                 , _T("The Smart card resource manager is not running."))
      CASE_ERRCODE2(SCARD_E_SERVICE_STOPPED                                            , _T("The Smart card resource manager has shut down."))
      CASE_ERRCODE2(SCARD_E_UNEXPECTED                                                 , _T("An unexpected card error has occurred."))
      CASE_ERRCODE2(SCARD_E_ICC_INSTALLATION                                           , _T("No Primary Provider can be found for the smart card."))
      CASE_ERRCODE2(SCARD_E_ICC_CREATEORDER                                            , _T("The requested order of object creation is not supported."))
      CASE_ERRCODE2(SCARD_E_UNSUPPORTED_FEATURE                                        , _T("This smart card does not support the requested feature."))
      CASE_ERRCODE2(SCARD_E_DIR_NOT_FOUND                                              , _T("The identified directory does not exist in the smart card."))
      CASE_ERRCODE2(SCARD_E_FILE_NOT_FOUND                                             , _T("The identified file does not exist in the smart card."))
      CASE_ERRCODE2(SCARD_E_NO_DIR                                                     , _T("The supplied path does not represent a smart card directory."))
      CASE_ERRCODE2(SCARD_E_NO_FILE                                                    , _T("The supplied path does not represent a smart card file."))
      CASE_ERRCODE2(SCARD_E_NO_ACCESS                                                  , _T("Access is denied to this file."))
      CASE_ERRCODE2(SCARD_E_WRITE_TOO_MANY                                             , _T("The smartcard does not have enough memory to store the information."))
      CASE_ERRCODE2(SCARD_E_BAD_SEEK                                                   , _T("There was an error trying to set the smart card file object pointer."))
      CASE_ERRCODE2(SCARD_E_INVALID_CHV                                                , _T("The supplied PIN is incorrect."))
      CASE_ERRCODE2(SCARD_E_UNKNOWN_RES_MNG                                            , _T("An unrecognized error code was returned from a layered component."))
      CASE_ERRCODE2(SCARD_E_NO_SUCH_CERTIFICATE                                        , _T("The requested certificate does not exist."))
      CASE_ERRCODE2(SCARD_E_CERTIFICATE_UNAVAILABLE                                    , _T("The requested certificate could not be obtained."))
      CASE_ERRCODE2(SCARD_E_NO_READERS_AVAILABLE                                       , _T("Cannot find a smart card reader."))
      CASE_ERRCODE2(SCARD_E_COMM_DATA_LOST                                             , _T("A communications error with the smart card has been detected.  Retry the operation."))
      CASE_ERRCODE2(SCARD_E_NO_KEY_CONTAINER                                           , _T("The requested key container does not exist on the smart card."))
      CASE_ERRCODE2(SCARD_E_SERVER_TOO_BUSY                                            , _T("The Smart card resource manager is too busy to complete this operation."))
      CASE_ERRCODE2(SCARD_W_UNSUPPORTED_CARD                                           , _T("The reader cannot communicate with the smart card, due to ATR configuration conflicts."))
      CASE_ERRCODE2(SCARD_W_UNRESPONSIVE_CARD                                          , _T("The smart card is not responding to a reset."))
      CASE_ERRCODE2(SCARD_W_UNPOWERED_CARD                                             , _T("Power has been removed from the smart card, so that further communication is not possible."))
      CASE_ERRCODE2(SCARD_W_RESET_CARD                                                 , _T("The smart card has been reset, so any shared state information is invalid."))
      CASE_ERRCODE2(SCARD_W_REMOVED_CARD                                               , _T("The smart card has been removed, so that further communication is not possible."))
      CASE_ERRCODE2(SCARD_W_SECURITY_VIOLATION                                         , _T("Access was denied because of a security violation."))
      CASE_ERRCODE2(SCARD_W_WRONG_CHV                                                  , _T("The card cannot be accessed because the wrong PIN was presented."))
      CASE_ERRCODE2(SCARD_W_CHV_BLOCKED                                                , _T("The card cannot be accessed because the maximum number of PIN entry attempts has been reached."))
      CASE_ERRCODE2(SCARD_W_EOF                                                        , _T("The end of the smart card file has been reached."))
      CASE_ERRCODE2(SCARD_W_CANCELLED_BY_USER                                          , _T("The action was cancelled by the user."))
      CASE_ERRCODE2(SCARD_W_CARD_NOT_AUTHENTICATED                                     , _T("No PIN was presented to the smart card."))
      CASE_ERRCODE2(COMADMIN_E_OBJECTERRORS                                            , _T("Errors occurred accessing one or more objects - the ErrorInfo collection may have more detail"))
      CASE_ERRCODE2(COMADMIN_E_OBJECTINVALID                                           , _T("One or more of the object's properties are missing or invalid"))
      CASE_ERRCODE2(COMADMIN_E_KEYMISSING                                              , _T("The object was not found in the catalog"))
      CASE_ERRCODE2(COMADMIN_E_ALREADYINSTALLED                                        , _T("The object is already registered"))
      CASE_ERRCODE2(COMADMIN_E_APP_FILE_WRITEFAIL                                      , _T("Error occurred writing to the application file"))
      CASE_ERRCODE2(COMADMIN_E_APP_FILE_READFAIL                                       , _T("Error occurred reading the application file"))
      CASE_ERRCODE2(COMADMIN_E_APP_FILE_VERSION                                        , _T("Invalid version number in application file"))
      CASE_ERRCODE2(COMADMIN_E_BADPATH                                                 , _T("The file path is invalid"))
      CASE_ERRCODE2(COMADMIN_E_APPLICATIONEXISTS                                       , _T("The application is already installed"))
      CASE_ERRCODE2(COMADMIN_E_ROLEEXISTS                                              , _T("The role already exists"))
      CASE_ERRCODE2(COMADMIN_E_CANTCOPYFILE                                            , _T("An error occurred copying the file"))
      CASE_ERRCODE2(COMADMIN_E_NOUSER                                                  , _T("One or more users are not valid"))
      CASE_ERRCODE2(COMADMIN_E_INVALIDUSERIDS                                          , _T("One or more users in the application file are not valid"))
      CASE_ERRCODE2(COMADMIN_E_NOREGISTRYCLSID                                         , _T("The component's CLSID is missing or corrupt"))
      CASE_ERRCODE2(COMADMIN_E_BADREGISTRYPROGID                                       , _T("The component's progID is missing or corrupt"))
      CASE_ERRCODE2(COMADMIN_E_AUTHENTICATIONLEVEL                                     , _T("Unable to set required authentication level for update request"))
      CASE_ERRCODE2(COMADMIN_E_USERPASSWDNOTVALID                                      , _T("The identity or password set on the application is not valid"))
      CASE_ERRCODE2(COMADMIN_E_CLSIDORIIDMISMATCH                                      , _T("Application file CLSIDs or IIDs do not match corresponding DLLs"))
      CASE_ERRCODE2(COMADMIN_E_REMOTEINTERFACE                                         , _T("Interface information is either missing or changed"))
      CASE_ERRCODE2(COMADMIN_E_DLLREGISTERSERVER                                       , _T("DllRegisterServer failed on component install"))
      CASE_ERRCODE2(COMADMIN_E_NOSERVERSHARE                                           , _T("No server file share available"))
      CASE_ERRCODE2(COMADMIN_E_DLLLOADFAILED                                           , _T("DLL could not be loaded"))
      CASE_ERRCODE2(COMADMIN_E_BADREGISTRYLIBID                                        , _T("The registered TypeLib ID is not valid"))
      CASE_ERRCODE2(COMADMIN_E_APPDIRNOTFOUND                                          , _T("Application install directory not found"))
      CASE_ERRCODE2(COMADMIN_E_REGISTRARFAILED                                         , _T("Errors occurred while in the component registrar"))
      CASE_ERRCODE2(COMADMIN_E_COMPFILE_DOESNOTEXIST                                   , _T("The file does not exist"))
      CASE_ERRCODE2(COMADMIN_E_COMPFILE_LOADDLLFAIL                                    , _T("The DLL could not be loaded"))
      CASE_ERRCODE2(COMADMIN_E_COMPFILE_GETCLASSOBJ                                    , _T("GetClassObject failed in the DLL"))
      CASE_ERRCODE2(COMADMIN_E_COMPFILE_CLASSNOTAVAIL                                  , _T("The DLL does not support the components listed in the TypeLib"))
      CASE_ERRCODE2(COMADMIN_E_COMPFILE_BADTLB                                         , _T("The TypeLib could not be loaded"))
      CASE_ERRCODE2(COMADMIN_E_COMPFILE_NOTINSTALLABLE                                 , _T("The file does not contain components or component information"))
      CASE_ERRCODE2(COMADMIN_E_NOTCHANGEABLE                                           , _T("Changes to this object and its sub-objects have been disabled"))
      CASE_ERRCODE2(COMADMIN_E_NOTDELETEABLE                                           , _T("The delete function has been disabled for this object"))
      CASE_ERRCODE2(COMADMIN_E_SESSION                                                 , _T("The server catalog version is not supported"))
      CASE_ERRCODE2(COMADMIN_E_COMP_MOVE_LOCKED                                        , _T("The component move was disallowed, because the source or destination application is either a system application or currently locked against changes"))
      CASE_ERRCODE2(COMADMIN_E_COMP_MOVE_BAD_DEST                                      , _T("The component move failed because the destination application no longer exists"))
      CASE_ERRCODE2(COMADMIN_E_REGISTERTLB                                             , _T("The system was unable to register the TypeLib"))
      CASE_ERRCODE2(COMADMIN_E_SYSTEMAPP                                               , _T("This operation can not be performed on the system application"))
      CASE_ERRCODE2(COMADMIN_E_COMPFILE_NOREGISTRAR                                    , _T("The component registrar referenced in this file is not available"))
      CASE_ERRCODE2(COMADMIN_E_COREQCOMPINSTALLED                                      , _T("A component in the same DLL is already installed"))
      CASE_ERRCODE2(COMADMIN_E_SERVICENOTINSTALLED                                     , _T("The service is not installed"))
      CASE_ERRCODE2(COMADMIN_E_PROPERTYSAVEFAILED                                      , _T("One or more property settings are either invalid or in conflict with each other"))
      CASE_ERRCODE2(COMADMIN_E_OBJECTEXISTS                                            , _T("The object you are attempting to add or rename already exists"))
      CASE_ERRCODE2(COMADMIN_E_COMPONENTEXISTS                                         , _T("The component already exists"))
      CASE_ERRCODE2(COMADMIN_E_REGFILE_CORRUPT                                         , _T("The registration file is corrupt"))
      CASE_ERRCODE2(COMADMIN_E_PROPERTY_OVERFLOW                                       , _T("The property value is too large"))
      CASE_ERRCODE2(COMADMIN_E_NOTINREGISTRY                                           , _T("Object was not found in registry"))
      CASE_ERRCODE2(COMADMIN_E_OBJECTNOTPOOLABLE                                       , _T("This object is not poolable"))
      CASE_ERRCODE2(COMADMIN_E_APPLID_MATCHES_CLSID                                    , _T("A CLSID with the same GUID as the new application ID is already installed on this machine"))
      CASE_ERRCODE2(COMADMIN_E_ROLE_DOES_NOT_EXIST                                     , _T("A role assigned to a component, interface, or method did not exist in the application"))
      CASE_ERRCODE2(COMADMIN_E_START_APP_NEEDS_COMPONENTS                              , _T("You must have components in an application in order to start the application"))
      CASE_ERRCODE2(COMADMIN_E_REQUIRES_DIFFERENT_PLATFORM                             , _T("This operation is not enabled on this platform"))
      CASE_ERRCODE2(COMADMIN_E_CAN_NOT_EXPORT_APP_PROXY                                , _T("Application Proxy is not exportable"))
      CASE_ERRCODE2(COMADMIN_E_CAN_NOT_START_APP                                       , _T("Failed to start application because it is either a library application or an application proxy"))
      CASE_ERRCODE2(COMADMIN_E_CAN_NOT_EXPORT_SYS_APP                                  , _T("System application is not exportable"))
      CASE_ERRCODE2(COMADMIN_E_CANT_SUBSCRIBE_TO_COMPONENT                             , _T("Can not subscribe to this component (the component may have been imported)"))
      CASE_ERRCODE2(COMADMIN_E_EVENTCLASS_CANT_BE_SUBSCRIBER                           , _T("An event class cannot also be a subscriber component"))
      CASE_ERRCODE2(COMADMIN_E_LIB_APP_PROXY_INCOMPATIBLE                              , _T("Library applications and application proxies are incompatible"))
      CASE_ERRCODE2(COMADMIN_E_BASE_PARTITION_ONLY                                     , _T("This function is valid for the base partition only"))
      CASE_ERRCODE2(COMADMIN_E_START_APP_DISABLED                                      , _T("You cannot start an application that has been disabled"))
      CASE_ERRCODE2(COMADMIN_E_CAT_DUPLICATE_PARTITION_NAME                            , _T("The specified partition name is already in use on this computer"))
      CASE_ERRCODE2(COMADMIN_E_CAT_INVALID_PARTITION_NAME                              , _T("The specified partition name is invalid. Check that the name contains at least one visible character"))
      CASE_ERRCODE2(COMADMIN_E_CAT_PARTITION_IN_USE                                    , _T("The partition cannot be deleted because it is the default partition for one or more users"))
      CASE_ERRCODE2(COMADMIN_E_FILE_PARTITION_DUPLICATE_FILES                          , _T("The partition cannot be exported, because one or more components in the partition have the same file name"))
      CASE_ERRCODE2(COMADMIN_E_CAT_IMPORTED_COMPONENTS_NOT_ALLOWED                     , _T("Applications that contain one or more imported components cannot be installed into a non-base partition"))
      CASE_ERRCODE2(COMADMIN_E_AMBIGUOUS_APPLICATION_NAME                              , _T("The application name is not unique and cannot be resolved to an application id"))
      CASE_ERRCODE2(COMADMIN_E_AMBIGUOUS_PARTITION_NAME                                , _T("The partition name is not unique and cannot be resolved to a partition id"))
      CASE_ERRCODE2(COMADMIN_E_REGDB_NOTINITIALIZED                                    , _T("The COM+ registry database has not been initialized"))
      CASE_ERRCODE2(COMADMIN_E_REGDB_NOTOPEN                                           , _T("The COM+ registry database is not open"))
      CASE_ERRCODE2(COMADMIN_E_REGDB_SYSTEMERR                                         , _T("The COM+ registry database detected a system error"))
      CASE_ERRCODE2(COMADMIN_E_REGDB_ALREADYRUNNING                                    , _T("The COM+ registry database is already running"))
      CASE_ERRCODE2(COMADMIN_E_MIG_VERSIONNOTSUPPORTED                                 , _T("This version of the COM+ registry database cannot be migrated"))
      CASE_ERRCODE2(COMADMIN_E_MIG_SCHEMANOTFOUND                                      , _T("The schema version to be migrated could not be found in the COM+ registry database"))
      CASE_ERRCODE2(COMADMIN_E_CAT_BITNESSMISMATCH                                     , _T("There was a type mismatch between binaries"))
      CASE_ERRCODE2(COMADMIN_E_CAT_UNACCEPTABLEBITNESS                                 , _T("A binary of unknown or invalid type was provided"))
      CASE_ERRCODE2(COMADMIN_E_CAT_WRONGAPPBITNESS                                     , _T("There was a type mismatch between a binary and an application"))
      CASE_ERRCODE2(COMADMIN_E_CAT_PAUSE_RESUME_NOT_SUPPORTED                          , _T("The application cannot be paused or resumed"))
      CASE_ERRCODE2(COMADMIN_E_CAT_SERVERFAULT                                         , _T("The COM+ Catalog Server threw an exception during execution"))
      CASE_ERRCODE2(COMQC_E_APPLICATION_NOT_QUEUED                                     , _T("Only COM+ Applications marked 'queued' can be invoked using the 'queue' moniker"))
      CASE_ERRCODE2(COMQC_E_NO_QUEUEABLE_INTERFACES                                    , _T("At least one interface must be marked 'queued' in order to create a queued component instance with the 'queue' moniker"))
      CASE_ERRCODE2(COMQC_E_QUEUING_SERVICE_NOT_AVAILABLE                              , _T("MSMQ is required for the requested operation and is not installed"))
      CASE_ERRCODE2(COMQC_E_NO_IPERSISTSTREAM                                          , _T("Unable to marshal an interface that does not support IPersistStream"))
      CASE_ERRCODE2(COMQC_E_BAD_MESSAGE                                                , _T("The message is improperly formatted or was damaged in transit"))
      CASE_ERRCODE2(COMQC_E_UNAUTHENTICATED                                            , _T("An unauthenticated message was received by an application that accepts only authenticated messages"))
      CASE_ERRCODE2(COMQC_E_UNTRUSTED_ENQUEUER                                         , _T("The message was requeued or moved by a user not in the 'QC Trusted User' role"))
      CASE_ERRCODE2(MSDTC_E_DUPLICATE_RESOURCE                                         , _T("Cannot create a duplicate resource of type Distributed Transaction Coordinator"))
      CASE_ERRCODE2(COMADMIN_E_OBJECT_PARENT_MISSING                                   , _T("One of the objects being inserted or updated does not belong to a valid parent collection"))
      CASE_ERRCODE2(COMADMIN_E_OBJECT_DOES_NOT_EXIST                                   , _T("One of the specified objects cannot be found"))
      CASE_ERRCODE2(COMADMIN_E_APP_NOT_RUNNING                                         , _T("The specified application is not currently running"))
      CASE_ERRCODE2(COMADMIN_E_INVALID_PARTITION                                       , _T("The partition(s) specified are not valid."))
      CASE_ERRCODE2(COMADMIN_E_SVCAPP_NOT_POOLABLE_OR_RECYCLABLE                       , _T("COM+ applications that run as NT service may not be pooled or recycled"))
      CASE_ERRCODE2(COMADMIN_E_USER_IN_SET                                             , _T("One or more users are already assigned to a local partition set."))
      CASE_ERRCODE2(COMADMIN_E_CANTRECYCLELIBRARYAPPS                                  , _T("Library applications may not be recycled."))
      CASE_ERRCODE2(COMADMIN_E_CANTRECYCLESERVICEAPPS                                  , _T("Applications running as NT services may not be recycled."))
      CASE_ERRCODE2(COMADMIN_E_PROCESSALREADYRECYCLED                                  , _T("The process has already been recycled."))
      CASE_ERRCODE2(COMADMIN_E_PAUSEDPROCESSMAYNOTBERECYCLED                           , _T("A paused process may not be recycled."))
      CASE_ERRCODE2(COMADMIN_E_CANTMAKEINPROCSERVICE                                   , _T("Library applications may not be NT services."))
      CASE_ERRCODE2(COMADMIN_E_PROGIDINUSEBYCLSID                                      , _T("The ProgID provided to the copy operation is invalid. The ProgID is in use by another registered CLSID."))
      CASE_ERRCODE2(COMADMIN_E_DEFAULT_PARTITION_NOT_IN_SET                            , _T("The partition specified as default is not a member of the partition set."))
      CASE_ERRCODE2(COMADMIN_E_RECYCLEDPROCESSMAYNOTBEPAUSED                           , _T("A recycled process may not be paused."))
      CASE_ERRCODE2(COMADMIN_E_PARTITION_ACCESSDENIED                                  , _T("Access to the specified partition is denied."))
      CASE_ERRCODE2(COMADMIN_E_PARTITION_MSI_ONLY                                      , _T("Only Application Files (*.MSI files) can be installed into partitions."))
      CASE_ERRCODE2(COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_1_0_FORMAT                   , _T("Applications containing one or more legacy components may not be exported to 1.0 format."))
      CASE_ERRCODE2(COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_NONBASE_PARTITIONS           , _T("Legacy components may not exist in non-base partitions."))
      CASE_ERRCODE2(COMADMIN_E_COMP_MOVE_SOURCE                                        , _T("A component cannot be moved (or copied) from the System Application, an application proxy or a non-changeable application"))
      CASE_ERRCODE2(COMADMIN_E_COMP_MOVE_DEST                                          , _T("A component cannot be moved (or copied) to the System Application, an application proxy or a non-changeable application"))
      CASE_ERRCODE2(COMADMIN_E_COMP_MOVE_PRIVATE                                       , _T("A private component cannot be moved (or copied) to a library application or to the base partition"))
      CASE_ERRCODE2(COMADMIN_E_BASEPARTITION_REQUIRED_IN_SET                           , _T("The Base Application Partition exists in all partition sets and cannot be removed."))
      CASE_ERRCODE2(COMADMIN_E_CANNOT_ALIAS_EVENTCLASS                                 , _T("Alas, Event Class components cannot be aliased."))
      CASE_ERRCODE2(COMADMIN_E_PRIVATE_ACCESSDENIED                                    , _T("Access is denied because the component is private."))
      CASE_ERRCODE2(COMADMIN_E_SAFERINVALID                                            , _T("The specified SAFER level is invalid."))
      CASE_ERRCODE2(COMADMIN_E_REGISTRY_ACCESSDENIED                                   , _T("The specified user cannot write to the system registry"))
      CASE_ERRCODE2(COMADMIN_E_PARTITIONS_DISABLED                                     , _T("COM+ partitions are currently disabled."))
#endif // __SDK__

      CASE_ERRCODE2(INET_E_USE_DEFAULT_PROTOCOLHANDLER                                 , _T("Use the default protocol handler/action."))
      CASE_ERRCODE2(INET_E_USE_DEFAULT_SETTING                                         , _T("Use the default settings."))
      CASE_ERRCODE2(INET_E_QUERYOPTION_UNKNOWN                                         , _T("The requested option is unknown."))
      CASE_ERRCODE2(INET_E_REDIRECTING                                                 , _T("The request is being redirected. (Attempt to redirect the navigation failed.)"))
      CASE_ERRCODE2(INET_E_INVALID_URL                                                 , _T("The URL could not be parsed. (URL string is not valid.)"))
      CASE_ERRCODE2(INET_E_NO_SESSION                                                  , _T("No Internet session was established. (No session found.)"))
      CASE_ERRCODE2(INET_E_CANNOT_CONNECT                                              , _T("The attempt to connect to the Internet has failed. (Unable to connect to server.)"))
      CASE_ERRCODE2(INET_E_RESOURCE_NOT_FOUND                                          , _T("The server or proxy was not found. (Requested resource is not found.)"))
      CASE_ERRCODE2(INET_E_OBJECT_NOT_FOUND                                            , _T("The object was not found. (Requested object is not found.)"))
      CASE_ERRCODE2(INET_E_DATA_NOT_AVAILABLE                                          , _T("An Internet connection was established, but the data cannot be retrieved. (Requested data is not available.)"))
      CASE_ERRCODE2(INET_E_DOWNLOAD_FAILURE                                            , _T("The download has failed (the connection was interrupted). (Failure occurred during download.)"))
      CASE_ERRCODE2(INET_E_AUTHENTICATION_REQUIRED                                     , _T("Authentication is needed to access the object. (Requested navigation requires authentication.)"))
      CASE_ERRCODE2(INET_E_NO_VALID_MEDIA                                              , _T("The object is not in one of the acceptable Multipurpose Internet Mail Extensions (MIME) types. (Required media not available or valid.)"))
      CASE_ERRCODE2(INET_E_CONNECTION_TIMEOUT                                          , _T("The Internet connection has timed out. (Connection timed out.)"))
      CASE_ERRCODE2(INET_E_INVALID_REQUEST                                             , _T("The request was invalid. (Request is invalid.)"))
      CASE_ERRCODE2(INET_E_UNKNOWN_PROTOCOL                                            , _T("The protocol is not known and no pluggable protocols have been entered that match. (Protocol is not recognized.)"))
      CASE_ERRCODE2(INET_E_SECURITY_PROBLEM                                            , _T("A security problem was encountered. (Navigation request has encountered a security issue.)"))
      CASE_ERRCODE2(INET_E_CANNOT_LOAD_DATA                                            , _T("The object could not be loaded. (Unable to load data from the server.)"))
      CASE_ERRCODE2(INET_E_CANNOT_INSTANTIATE_OBJECT                                   , _T("CoCreateInstance failed. (Unable to create an instance of the object.)"))
      CASE_ERRCODE2(INET_E_REDIRECT_TO_DIR                                             , _T("The request is being redirected to a directory. (Navigation redirected to a directory.)"))
      CASE_ERRCODE2(INET_E_CANNOT_LOCK_REQUEST                                         , _T("The requested resource could not be locked. (Unable to lock request with the server.)"))
#ifdef __SDK__
      CASE_ERRCODE2(INET_E_USE_EXTEND_BINDING                                          , _T("Reissue request with extended binding."))
      CASE_ERRCODE2(INET_E_TERMINATED_BIND                                             , _T("Binding is terminated."))
      CASE_ERRCODE2(INET_E_CODE_DOWNLOAD_DECLINED                                      , _T("The component download was declined by the user. (Permission to download is declined.)"))
      CASE_ERRCODE2(INET_E_RESULT_DISPATCHED                                           , _T("The binding has already been completed and the result has been dispatched, so your abort call has been canceled. (Result is dispatched.)"))
      CASE_ERRCODE2(INET_E_CANNOT_REPLACE_SFP_FILE                                     , _T("The exact version requested by a component download cannot be found. (Cannot replace a protected System File Protection (SFP) file.)"))
#endif // __SDK__

#ifdef __SDK__
      CASE_ERRCODE2(OLESCRIPT_E_SYNTAX                                                 , _T("An unspecified syntax error occurred in the scriptlet/procedure."))
#endif // __SDK__

      CASE_ERRCODE2(MK_S_ASYNCHRONOUS                                                  , _T("MK_S_ASYNCHRONOUS"))
      CASE_ERRCODE2(0x800A083E                                                         , _T("Can't move focus to the control because it is invisible, not enabled, or of a type that does not accept the focus."))

#ifdef __SDK__
      CASE_ERRCODE2(IPP_E_FIRST                                                        , _T("Internet Publishing Provider first error message"))
      CASE_ERRCODE2(IPP_E_SYNCCONFLICT                                                 , _T("The server resource has changed since the local copy on your computer was obtained."))
      CASE_ERRCODE2(IPP_E_FILENOTDIRTY                                                 , _T("The copy of the resource on your computer has not been modified since it was downloaded from the server."))
      CASE_ERRCODE2(IPP_E_MARKFOROFFLINE_FAILED                                        , _T("The attempt to mark or unmark the resource for offline use failed."))
      CASE_ERRCODE2(IPP_E_OFFLINE                                                      , _T("The requested operation could not be completed because the resource is offline."))
      CASE_ERRCODE2(IPP_E_UNSYNCHRONIZED                                               , _T("The requested operation could not be completed because the resource has been modified on your computer but has not been synchronized with the server."))
      CASE_ERRCODE2(IPP_E_SERVERTYPE_NOT_SUPPORTED                                     , _T("This server type is not currently supported."))
      CASE_ERRCODE2(IPP_E_MDAC_VERSION                                                 , _T("The Microsoft Data Access Components (MDAC) are either not present on this computer or are an old version. (MSDAIPP 1.0 requires MDAC 2.1)"))
      CASE_ERRCODE2(IPP_E_COLLECTIONEXISTS                                             , _T("The move or copy operation failed because a collection with that name already exists."))
      CASE_ERRCODE2(IPP_E_CANNOTCREATEOFFLINE                                          , _T("The requested resource could not be created because parent cache entry does not exist."))
      CASE_ERRCODE2(IPP_E_STATUS_CANNOTCOMPLETE                                        , _T("This is an internal MSDAIPP.DLL error."))
      CASE_ERRCODE2(IPP_E_RESELECTPROVIDER                                             , _T("This is an internal MSDAIPP.DLL error."))
      CASE_ERRCODE2(IPP_E_CLIENTMUSTEMULATE                                            , _T("This is an internal MSDAIPP.DLL error."))
      CASE_ERRCODE2(IPP_S_WEAKRESERVE                                                  , _T("This is an internal MSDAIPP.DLL error."))
      CASE_ERRCODE2(IPP_S_TRUNCATED                                                    , _T("This is an internal MSDAIPP.DLL error."))
      CASE_ERRCODE2(IPP_E_LAST                                                         , _T("Internet Publishing Provider last error message"))

      CASE_ERRCODE2(NS_S_CALLPENDING                                                   , _T("The requested operation is pending completion."))
      CASE_ERRCODE2(NS_S_CALLABORTED                                                   , _T("The requested operation was aborted by the client."))
      CASE_ERRCODE2(NS_S_STREAM_TRUNCATED                                              , _T("The stream was purposefully stopped before completion."))
      CASE_ERRCODE2(NS_W_SERVER_BANDWIDTH_LIMIT                                        , _T("The maximum filebitrate value specified is greater than the server's configured maximum bandwidth."))
      CASE_ERRCODE2(NS_W_FILE_BANDWIDTH_LIMIT                                          , _T("The maximum bandwidth value specified is less than the maximum filebitrate."))
      CASE_ERRCODE2(NS_E_NOCONNECTION                                                  , _T("There is no connection established with the Windows Media server. The operation failed."))
      CASE_ERRCODE2(NS_E_CANNOTCONNECT                                                 , _T("Unable to establish a connection to the server."))
      CASE_ERRCODE2(NS_E_CANNOTDESTROYTITLE                                            , _T("Unable to destroy the title."))
      CASE_ERRCODE2(NS_E_CANNOTRENAMETITLE                                             , _T("Unable to rename the title."))
      CASE_ERRCODE2(NS_E_CANNOTOFFLINEDISK                                             , _T("Unable to offline disk."))
      CASE_ERRCODE2(NS_E_CANNOTONLINEDISK                                              , _T("Unable to online disk."))
      CASE_ERRCODE2(NS_E_NOREGISTEREDWALKER                                            , _T("There is no file parser registered for this type of file."))
      CASE_ERRCODE2(NS_E_NOFUNNEL                                                      , _T("There is no data connection established."))
      CASE_ERRCODE2(NS_E_NO_LOCALPLAY                                                  , _T("Failed to load the local play DLL."))
      CASE_ERRCODE2(NS_E_NETWORK_BUSY                                                  , _T("The network is busy."))
      CASE_ERRCODE2(NS_E_TOO_MANY_SESS                                                 , _T("The server session limit was exceeded."))
      CASE_ERRCODE2(NS_E_ALREADY_CONNECTED                                             , _T("The network connection already exists."))
      CASE_ERRCODE2(NS_E_INVALID_INDEX                                                 , _T("Index %1 is invalid."))
      CASE_ERRCODE2(NS_E_PROTOCOL_MISMATCH                                             , _T("There is no protocol or protocol version supported by both the client and the server."))
      CASE_ERRCODE2(NS_E_TIMEOUT                                                       , _T("The server, a computer set up to offer multimedia content to other computers, could not handle your request for multimedia content in a timely manner.  Please try again later."))
      CASE_ERRCODE2(NS_E_NET_WRITE                                                     , _T("Error writing to the network."))
      CASE_ERRCODE2(NS_E_NET_READ                                                      , _T("Error reading from the network."))
      CASE_ERRCODE2(NS_E_DISK_WRITE                                                    , _T("Error writing to a disk."))
      CASE_ERRCODE2(NS_E_DISK_READ                                                     , _T("Error reading from a disk."))
      CASE_ERRCODE2(NS_E_FILE_WRITE                                                    , _T("Error writing to a file."))
      CASE_ERRCODE2(NS_E_FILE_READ                                                     , _T("Error reading from a file."))
      CASE_ERRCODE2(NS_E_FILE_NOT_FOUND                                                , _T("The system cannot find the file specified."))
      CASE_ERRCODE2(NS_E_FILE_EXISTS                                                   , _T("The file already exists."))
      CASE_ERRCODE2(NS_E_INVALID_NAME                                                  , _T("The file name, directory name, or volume label syntax is incorrect."))
      CASE_ERRCODE2(NS_E_FILE_OPEN_FAILED                                              , _T("Failed to open a file."))
      CASE_ERRCODE2(NS_E_FILE_ALLOCATION_FAILED                                        , _T("Unable to allocate a file."))
      CASE_ERRCODE2(NS_E_FILE_INIT_FAILED                                              , _T("Unable to initialize a file."))
      CASE_ERRCODE2(NS_E_FILE_PLAY_FAILED                                              , _T("Unable to play a file."))
      CASE_ERRCODE2(NS_E_SET_DISK_UID_FAILED                                           , _T("Could not set the disk UID."))
      CASE_ERRCODE2(NS_E_INDUCED                                                       , _T("An error was induced for testing purposes."))
      CASE_ERRCODE2(NS_E_CCLINK_DOWN                                                   , _T("Two Content Servers failed to communicate."))
      CASE_ERRCODE2(NS_E_INTERNAL                                                      , _T("An unknown error occurred."))
      CASE_ERRCODE2(NS_E_BUSY                                                          , _T("The requested resource is in use."))
      CASE_ERRCODE2(NS_E_UNRECOGNIZED_STREAM_TYPE                                      , _T("The specified protocol is not recognized. Be sure that the file name and syntax, such as slashes, are correct for the protocol."))
      CASE_ERRCODE2(NS_E_NETWORK_SERVICE_FAILURE                                       , _T("The network service provider failed."))
      CASE_ERRCODE2(NS_E_NETWORK_RESOURCE_FAILURE                                      , _T("An attempt to acquire a network resource failed."))
      CASE_ERRCODE2(NS_E_CONNECTION_FAILURE                                            , _T("The network connection has failed."))
      CASE_ERRCODE2(NS_E_SHUTDOWN                                                      , _T("The session is being terminated locally."))
      CASE_ERRCODE2(NS_E_INVALID_REQUEST                                               , _T("The request is invalid in the current state."))
      CASE_ERRCODE2(NS_E_INSUFFICIENT_BANDWIDTH                                        , _T("There is insufficient bandwidth available to fulfill the request."))
      CASE_ERRCODE2(NS_E_NOT_REBUILDING                                                , _T("The disk is not rebuilding."))
      CASE_ERRCODE2(NS_E_LATE_OPERATION                                                , _T("An operation requested for a particular time could not be carried out on schedule."))
      CASE_ERRCODE2(NS_E_INVALID_DATA                                                  , _T("Invalid or corrupt data was encountered."))
      CASE_ERRCODE2(NS_E_FILE_BANDWIDTH_LIMIT                                          , _T("The bandwidth required to stream a file is higher than the maximum file bandwidth allowed on the server."))
      CASE_ERRCODE2(NS_E_OPEN_FILE_LIMIT                                               , _T("The client cannot have any more files open simultaneously."))
      CASE_ERRCODE2(NS_E_BAD_CONTROL_DATA                                              , _T("The server received invalid data from the client on the control connection."))
      CASE_ERRCODE2(NS_E_NO_STREAM                                                     , _T("There is no stream available."))
      CASE_ERRCODE2(NS_E_STREAM_END                                                    , _T("There is no more data in the stream."))
      CASE_ERRCODE2(NS_E_SERVER_NOT_FOUND                                              , _T("The specified server could not be found."))
      CASE_ERRCODE2(NS_E_DUPLICATE_NAME                                                , _T("The specified name is already in use."))
      CASE_ERRCODE2(NS_E_DUPLICATE_ADDRESS                                             , _T("The specified address is already in use."))
      CASE_ERRCODE2(NS_E_BAD_MULTICAST_ADDRESS                                         , _T("The specified address is not a valid multicast address."))
      CASE_ERRCODE2(NS_E_BAD_ADAPTER_ADDRESS                                           , _T("The specified adapter address is invalid."))
      CASE_ERRCODE2(NS_E_BAD_DELIVERY_MODE                                             , _T("The specified delivery mode is invalid."))
      CASE_ERRCODE2(NS_E_INVALID_CHANNEL                                               , _T("The specified station does not exist."))
      CASE_ERRCODE2(NS_E_INVALID_STREAM                                                , _T("The specified stream does not exist."))
      CASE_ERRCODE2(NS_E_INVALID_ARCHIVE                                               , _T("The specified archive could not be opened."))
      CASE_ERRCODE2(NS_E_NOTITLES                                                      , _T("The system cannot find any titles on the server."))
      CASE_ERRCODE2(NS_E_INVALID_CLIENT                                                , _T("The system cannot find the client specified."))
      CASE_ERRCODE2(NS_E_INVALID_BLACKHOLE_ADDRESS                                     , _T("The Blackhole Address is not initialized."))
      CASE_ERRCODE2(NS_E_INCOMPATIBLE_FORMAT                                           , _T("The station does not support the stream format."))
      CASE_ERRCODE2(NS_E_INVALID_KEY                                                   , _T("The specified key is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_PORT                                                  , _T("The specified port is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_TTL                                                   , _T("The specified TTL is not valid."))
      CASE_ERRCODE2(NS_E_STRIDE_REFUSED                                                , _T("The request to fast forward or rewind could not be fulfilled."))
      CASE_ERRCODE2(NS_E_MMSAUTOSERVER_CANTFINDWALKER                                  , _T("Unable to load the appropriate file parser."))
      CASE_ERRCODE2(NS_E_MAX_BITRATE                                                   , _T("Cannot exceed the maximum bandwidth limit."))
      CASE_ERRCODE2(NS_E_LOGFILEPERIOD                                                 , _T("Invalid value for LogFilePeriod."))
      CASE_ERRCODE2(NS_E_MAX_CLIENTS                                                   , _T("Cannot exceed the maximum client limit."))
      CASE_ERRCODE2(NS_E_LOG_FILE_SIZE                                                 , _T("The maximum log file size has been reached."))
      CASE_ERRCODE2(NS_E_MAX_FILERATE                                                  , _T("Cannot exceed the maximum file rate."))
      CASE_ERRCODE2(NS_E_WALKER_UNKNOWN                                                , _T("Unknown file type."))
      CASE_ERRCODE2(NS_E_WALKER_SERVER                                                 , _T("The specified file, %1, cannot be loaded onto the specified server, %2."))
      CASE_ERRCODE2(NS_E_WALKER_USAGE                                                  , _T("There was a usage error with file parser."))
      CASE_ERRCODE2(NS_I_TIGER_START                                                   , _T("The Title Server %1 is running."))
      CASE_ERRCODE2(NS_E_TIGER_FAIL                                                    , _T("The Title Server %1 has failed."))
      CASE_ERRCODE2(NS_I_CUB_START                                                     , _T("Content Server %1(cub ID) (%2(cub name)) is starting."))
      CASE_ERRCODE2(NS_I_CUB_RUNNING                                                   , _T("Content Server %1(cub ID) (%2(cub name)) is running."))
      CASE_ERRCODE2(NS_E_CUB_FAIL                                                      , _T("Content Server %1(cub ID) (%2(cub name)) has failed."))
      CASE_ERRCODE2(NS_I_DISK_START                                                    , _T("Disk %1(tiger disk ID) ( %2(device name) ) on Content Server %3(cub ID), is running."))
      CASE_ERRCODE2(NS_E_DISK_FAIL                                                     , _T("Disk %1(tiger disk ID) ( %2(device name) ) on Content Server %3(cub ID), has failed."))
      CASE_ERRCODE2(NS_I_DISK_REBUILD_STARTED                                          , _T("Started rebuilding disk %1(tiger disk ID) ( %2(device name) ) on Content Server %3(cub ID)."))
      CASE_ERRCODE2(NS_I_DISK_REBUILD_FINISHED                                         , _T("Finished rebuilding disk %1(tiger disk ID) ( %2(device name) ) on Content Server %3(cub ID)."))
      CASE_ERRCODE2(NS_I_DISK_REBUILD_ABORTED                                          , _T("Aborted rebuilding disk %1(tiger disk ID) ( %2(device name) ) on Content Server %3(cub ID)."))
      CASE_ERRCODE2(NS_I_LIMIT_FUNNELS                                                 , _T("A NetShow administrator at network location %1(tiger disk ID) set the data stream limit to %2(device name) streams."))
      CASE_ERRCODE2(NS_I_START_DISK                                                    , _T("A NetShow administrator at network location %1(tiger disk ID) started disk %2(device name)."))
      CASE_ERRCODE2(NS_I_STOP_DISK                                                     , _T("A NetShow administrator at network location %1(tiger disk ID) stopped disk %2(device name)."))
      CASE_ERRCODE2(NS_I_STOP_CUB                                                      , _T("A NetShow administrator at network location %1(tiger disk ID) stopped Content Server %2(device name)."))
      CASE_ERRCODE2(NS_I_KILL_USERSESSION                                              , _T("A NetShow administrator at network location %1(tiger disk ID) aborted user session %2(device name) from the system."))
      CASE_ERRCODE2(NS_I_KILL_CONNECTION                                               , _T("A NetShow administrator at network location %1(tiger disk ID) aborted obsolete connection %2(device name) from the system."))
      CASE_ERRCODE2(NS_I_REBUILD_DISK                                                  , _T("A NetShow administrator at network location %1(tiger disk ID) started rebuilding disk %2(device name)."))
      CASE_ERRCODE2(NS_W_UNKNOWN_EVENT                                                 , _T("Unknown %1(tiger disk ID) event encountered."))
      CASE_ERRCODE2(NS_E_MAX_FUNNELS_ALERT                                             , _T("The NetShow data stream limit of %1(tiger disk ID) streams was reached."))
      CASE_ERRCODE2(NS_E_ALLOCATE_FILE_FAIL                                            , _T("The NetShow Video Server was unable to allocate a %1(tiger disk ID) block file named %2(device name)."))
      CASE_ERRCODE2(NS_E_PAGING_ERROR                                                  , _T("A Content Server was unable to page a block."))
      CASE_ERRCODE2(NS_E_BAD_BLOCK0_VERSION                                            , _T("Disk %1(tiger disk ID) has unrecognized control block version %2(device name)."))
      CASE_ERRCODE2(NS_E_BAD_DISK_UID                                                  , _T("Disk %1(tiger disk ID) has incorrect uid %2(device name)."))
      CASE_ERRCODE2(NS_E_BAD_FSMAJOR_VERSION                                           , _T("Disk %1(tiger disk ID) has unsupported file system major version %2(device name)."))
      CASE_ERRCODE2(NS_E_BAD_STAMPNUMBER                                               , _T("Disk %1(tiger disk ID) has bad stamp number in control block."))
      CASE_ERRCODE2(NS_E_PARTIALLY_REBUILT_DISK                                        , _T("Disk %1(tiger disk ID) is partially reconstructed."))
      CASE_ERRCODE2(NS_E_ENACTPLAN_GIVEUP                                              , _T("EnactPlan gives up."))
      CASE_ERRCODE2(MCMADM_I_NO_EVENTS                                                 , _T("Event initialization failed, there will be no MCM events."))
      CASE_ERRCODE2(MCMADM_E_REGKEY_NOT_FOUND                                          , _T("The key was not found in the registry."))
      CASE_ERRCODE2(NS_E_NO_FORMATS                                                    , _T("The publishing point cannot be started because the server does not have the appropriate stream formats. Use the Multicast Announcement Wizard to create a new announcement for this publishing point."))
      CASE_ERRCODE2(NS_E_NO_REFERENCES                                                 , _T("No reference URLs were found in an ASX file."))
      CASE_ERRCODE2(NS_E_WAVE_OPEN                                                     , _T("Error opening wave device, the device might be in use."))
      CASE_ERRCODE2(NS_I_LOGGING_FAILED                                                , _T("The logging operation failed."))
      CASE_ERRCODE2(NS_E_CANNOTCONNECTEVENTS                                           , _T("Unable to establish a connection to the NetShow event monitor service."))
      CASE_ERRCODE2(NS_I_LIMIT_BANDWIDTH                                               , _T("A NetShow administrator at network location %1(tiger disk ID) set the maximum bandwidth limit to %2(device name) bps."))
      CASE_ERRCODE2(NS_E_NO_DEVICE                                                     , _T("No device driver is present on the system."))
      CASE_ERRCODE2(NS_E_NO_SPECIFIED_DEVICE                                           , _T("No specified device driver is present."))
      CASE_ERRCODE2(NS_E_NOTHING_TO_DO                                                 , _T("NS_E_NOTHING_TO_DO"))
      CASE_ERRCODE2(NS_E_NO_MULTICAST                                                  , _T("Not receiving data from the server."))
      CASE_ERRCODE2(NS_E_MONITOR_GIVEUP                                                , _T("Netshow Events Monitor is not operational and has been disconnected."))
      CASE_ERRCODE2(NS_E_REMIRRORED_DISK                                               , _T("Disk %1(tiger disk ID) is remirrored."))
      CASE_ERRCODE2(NS_E_INSUFFICIENT_DATA                                             , _T("Insufficient data found."))
      CASE_ERRCODE2(NS_E_ASSERT                                                        , _T("%1(tiger disk ID) failed in file %2(device name) line %3(cub ID)."))
      CASE_ERRCODE2(NS_E_BAD_ADAPTER_NAME                                              , _T("The specified adapter name is invalid."))
      CASE_ERRCODE2(NS_E_NOT_LICENSED                                                  , _T("The application is not licensed for this feature."))
      CASE_ERRCODE2(NS_E_NO_SERVER_CONTACT                                             , _T("Unable to contact the server."))
      CASE_ERRCODE2(NS_E_TOO_MANY_TITLES                                               , _T("Maximum number of titles exceeded."))
      CASE_ERRCODE2(NS_E_TITLE_SIZE_EXCEEDED                                           , _T("Maximum size of a title exceeded."))
      CASE_ERRCODE2(NS_E_UDP_DISABLED                                                  , _T("UDP protocol not enabled. Not trying %1(tiger disk ID)!ls!."))
      CASE_ERRCODE2(NS_E_TCP_DISABLED                                                  , _T("TCP protocol not enabled. Not trying %1(tiger disk ID)!ls!."))
      CASE_ERRCODE2(NS_E_HTTP_DISABLED                                                 , _T("HTTP protocol not enabled. Not trying %1(tiger disk ID)!ls!."))
      CASE_ERRCODE2(NS_E_LICENSE_EXPIRED                                               , _T("The product license has expired."))
      CASE_ERRCODE2(NS_E_TITLE_BITRATE                                                 , _T("Source file exceeds the per title maximum bitrate. See NetShow Theater documentation for more information."))
      CASE_ERRCODE2(NS_E_EMPTY_PROGRAM_NAME                                            , _T("The program name cannot be empty."))
      CASE_ERRCODE2(NS_E_MISSING_CHANNEL                                               , _T("Station %1(tiger disk ID) does not exist."))
      CASE_ERRCODE2(NS_E_NO_CHANNELS                                                   , _T("You need to define at least one station before this operation can complete."))
      CASE_ERRCODE2(NS_E_INVALID_INDEX2                                                , _T("The index specified is invalid."))
      CASE_ERRCODE2(NS_E_CUB_FAIL_LINK                                                 , _T("Content Server %1(tiger disk ID) (%2(device name)) has failed its link to Content Server %3(cub ID)."))
      CASE_ERRCODE2(NS_I_CUB_UNFAIL_LINK                                               , _T("Content Server %1(tiger disk ID) (%2(device name)) has established its link to Content Server %3(cub ID)."))
      CASE_ERRCODE2(NS_E_BAD_CUB_UID                                                   , _T("Content Server %1(tiger disk ID) (%2(device name)) has incorrect uid %3(cub ID)."))
      CASE_ERRCODE2(NS_I_RESTRIPE_START                                                , _T("Restripe operation has started."))
      CASE_ERRCODE2(NS_I_RESTRIPE_DONE                                                 , _T("Restripe operation has completed."))
      CASE_ERRCODE2(NS_E_GLITCH_MODE                                                   , _T("Server unreliable because multiple components failed."))
      CASE_ERRCODE2(NS_I_RESTRIPE_DISK_OUT                                             , _T("Content disk %1(tiger disk ID) (%2(device name)) on Content Server %3(cub ID) has been restriped out."))
      CASE_ERRCODE2(NS_I_RESTRIPE_CUB_OUT                                              , _T("Content server %1(tiger disk ID) (%2(device name)) has been restriped out."))
      CASE_ERRCODE2(NS_I_DISK_STOP                                                     , _T("Disk %1(tiger disk ID) ( %2(ID device name) ) on Content Server %3(cub ID), has been offlined."))
      CASE_ERRCODE2(NS_I_CATATONIC_FAILURE                                             , _T("Disk %1(tiger disk ID) ( %2(device name) ) on Content Server %3(cub ID), will be failed because it is catatonic."))
      CASE_ERRCODE2(NS_I_CATATONIC_AUTO_UNFAIL                                         , _T("Disk %1(tiger disk ID) ( %2(device name) ) on Content Server %3(cub ID), auto online from catatonic state."))
      CASE_ERRCODE2(NS_E_NO_MEDIA_PROTOCOL                                             , _T("Content Server %1(tiger disk ID) (%2(device name)) is unable to communicate with the Media System Network Protocol."))
      CASE_ERRCODE2(NS_E_INVALID_INPUT_FORMAT                                          , _T("The input media format is invalid."))
      CASE_ERRCODE2(NS_E_MSAUDIO_NOT_INSTALLED                                         , _T("The MSAudio codec is not installed on this system."))
      CASE_ERRCODE2(NS_E_UNEXPECTED_MSAUDIO_ERROR                                      , _T("An unexpected error occurred with the MSAudio codec."))
      CASE_ERRCODE2(NS_E_INVALID_OUTPUT_FORMAT                                         , _T("The output media format is invalid."))
      CASE_ERRCODE2(NS_E_NOT_CONFIGURED                                                , _T("The object must be fully configured before audio samples can be processed."))
      CASE_ERRCODE2(NS_E_PROTECTED_CONTENT                                             , _T("You need a license to perform the requested operation on this media file."))
      CASE_ERRCODE2(NS_E_LICENSE_REQUIRED                                              , _T("You need a license to perform the requested operation on this media file."))
      CASE_ERRCODE2(NS_E_TAMPERED_CONTENT                                              , _T("This media file is corrupted or invalid. Contact the content provider for a new file."))
      CASE_ERRCODE2(NS_E_LICENSE_OUTOFDATE                                             , _T("The license for this media file has expired. Get a new license or contact the content provider for further assistance."))
      CASE_ERRCODE2(NS_E_LICENSE_INCORRECT_RIGHTS                                      , _T("You are not allowed to open this file. Contact the content provider for further assistance."))
      CASE_ERRCODE2(NS_E_AUDIO_CODEC_NOT_INSTALLED                                     , _T("The requested audio codec is not installed on this system."))
      CASE_ERRCODE2(NS_E_AUDIO_CODEC_ERROR                                             , _T("An unexpected error occurred with the audio codec."))
      CASE_ERRCODE2(NS_E_VIDEO_CODEC_NOT_INSTALLED                                     , _T("The requested video codec is not installed on this system."))
      CASE_ERRCODE2(NS_E_VIDEO_CODEC_ERROR                                             , _T("An unexpected error occurred with the video codec."))
      CASE_ERRCODE2(NS_E_INVALIDPROFILE                                                , _T("The Profile is invalid."))
      CASE_ERRCODE2(NS_E_INCOMPATIBLE_VERSION                                          , _T("A new version of the SDK is needed to play the requested content."))
      CASE_ERRCODE2(NS_S_REBUFFERING                                                   , _T("The requested operation has caused the source to rebuffer."))
      CASE_ERRCODE2(NS_S_DEGRADING_QUALITY                                             , _T("The requested operation has caused the source to degrade codec quality."))
      CASE_ERRCODE2(NS_E_OFFLINE_MODE                                                  , _T("The requested URL is not available in offline mode."))
      CASE_ERRCODE2(NS_E_NOT_CONNECTED                                                 , _T("The requested URL cannot be accessed because there is no network connection."))
      CASE_ERRCODE2(NS_E_TOO_MUCH_DATA                                                 , _T("The encoding process was unable to keep up with the amount of supplied data."))
      CASE_ERRCODE2(NS_E_UNSUPPORTED_PROPERTY                                          , _T("The given property is not supported."))
      CASE_ERRCODE2(NS_E_8BIT_WAVE_UNSUPPORTED                                         , _T("Windows Media Player cannot copy the files to the CD because they are 8-bit. Convert the files to 16-bit, 44-kHz stereo files by using Sound Recorder or another audio-processing program, and then try again."))
      CASE_ERRCODE2(NS_E_NO_MORE_SAMPLES                                               , _T("There are no more samples in the current range."))
      CASE_ERRCODE2(NS_E_INVALID_SAMPLING_RATE                                         , _T("The given sampling rate is invalid."))
      CASE_ERRCODE2(NS_E_MAX_PACKET_SIZE_TOO_SMALL                                     , _T("The given maximum packet size is too small to accommodate this profile"))
      CASE_ERRCODE2(NS_E_LATE_PACKET                                                   , _T("The packet arrived too late to be of use"))
      CASE_ERRCODE2(NS_E_DUPLICATE_PACKET                                              , _T("The packet is a duplicate of one received before"))
      CASE_ERRCODE2(NS_E_SDK_BUFFERTOOSMALL                                            , _T("Supplied buffer is too small"))
      CASE_ERRCODE2(NS_E_INVALID_NUM_PASSES                                            , _T("The wrong number of preprocessing passes was used for the stream's output type"))
      CASE_ERRCODE2(NS_E_ATTRIBUTE_READ_ONLY                                           , _T("An attempt was made to add, modify, or delete a read only attribute"))
      CASE_ERRCODE2(NS_E_ATTRIBUTE_NOT_ALLOWED                                         , _T("An attempt was made to add attribute that is not allowed for the given media type"))
      CASE_ERRCODE2(NS_E_INVALID_EDL                                                   , _T("The EDL provided is invalid"))
      CASE_ERRCODE2(NS_E_DATA_UNIT_EXTENSION_TOO_LARGE                                 , _T("The Data Unit Extension data was too large to be used."))
      CASE_ERRCODE2(NS_E_CODEC_DMO_ERROR                                               , _T("An unexpected error occurred with a DMO codec."))
      CASE_ERRCODE2(NS_E_NO_CD                                                         , _T("There is no CD in the CD-ROM drive. Insert a CD, and try again."))
      CASE_ERRCODE2(NS_E_CANT_READ_DIGITAL                                             , _T("Unable to perform digital reads on this compact disc drive.  Please try analog playback via the Tools Options menu."))
      CASE_ERRCODE2(NS_E_DEVICE_DISCONNECTED                                           , _T("Windows Media Player no longer detects a connected portable device. Reconnect your portable device, and then try copying the file again."))
      CASE_ERRCODE2(NS_E_DEVICE_NOT_SUPPORT_FORMAT                                     , _T("Windows Media Player cannot play the file. The portable device does not support the specified format."))
      CASE_ERRCODE2(NS_E_SLOW_READ_DIGITAL                                             , _T("Windows Media Player encountered a problem while attempting to play the CD using digital playback. The Player has automatically switched the CD-ROM drive to analog playback. To switch back to digital CD playback, use the Devices tab."))
      CASE_ERRCODE2(NS_E_MIXER_INVALID_LINE                                            , _T("An invalid line error occurred in the mixer."))
      CASE_ERRCODE2(NS_E_MIXER_INVALID_CONTROL                                         , _T("An invalid control error occurred in the mixer."))
      CASE_ERRCODE2(NS_E_MIXER_INVALID_VALUE                                           , _T("An invalid value error occurred in the mixer."))
      CASE_ERRCODE2(NS_E_MIXER_UNKNOWN_MMRESULT                                        , _T("An unrecognized MMRESULT occurred in the mixer."))
      CASE_ERRCODE2(NS_E_USER_STOP                                                     , _T("User has stopped the operation."))
      CASE_ERRCODE2(NS_E_MP3_FORMAT_NOT_FOUND                                          , _T("Windows Media Player cannot copy the file because a compatible MP3 encoder is not installed on your computer. Install a compatible MP3 encoder, or choose a different format to copy to (such as Windows Media Audio)."))
      CASE_ERRCODE2(NS_E_CD_READ_ERROR_NO_CORRECTION                                   , _T("Windows Media Player cannot read the CD. It may contain flaws. Turn on error correction and try again."))
      CASE_ERRCODE2(NS_E_CD_READ_ERROR                                                 , _T("Windows Media Player cannot read the CD. Be sure the CD is free of dirt and scratches and the CD-ROM drive is functioning properly."))
      CASE_ERRCODE2(NS_E_CD_SLOW_COPY                                                  , _T("To speed up the copy process, do not play CD tracks while copying."))
      CASE_ERRCODE2(NS_E_CD_COPYTO_CD                                                  , _T("Cannot copy directly from a CDROM to a CD drive."))
      CASE_ERRCODE2(NS_E_MIXER_NODRIVER                                                , _T("Could not open a sound mixer driver."))
      CASE_ERRCODE2(NS_E_REDBOOK_ENABLED_WHILE_COPYING                                 , _T("Windows Media Player has detected that a setting for the CD-ROM drive will cause audio CDs to copy incorrectly; no audio is copied. Change the CD-ROM drive setting in Device Manager, and then try again."))
      CASE_ERRCODE2(NS_E_CD_REFRESH                                                    , _T("Trying to refresh the CD playlist."))
      CASE_ERRCODE2(NS_E_CD_DRIVER_PROBLEM                                             , _T("Windows Media Player must switch to analog  mode  because there is a problem reading the CD-ROM drive in digital mode. Verify that the CD-ROM drive is installed correctly or try to update the drivers for the CD-ROM drive, and then try to use digital mode again."))
      CASE_ERRCODE2(NS_E_WONT_DO_DIGITAL                                               , _T("Windows Media Player must switch to analog mode because there is a problem reading the CD-ROM drive  in digital mode."))
      CASE_ERRCODE2(NS_E_WMPXML_NOERROR                                                , _T("A call was made to GetParseError on the XML parser but there was no error to retrieve."))
      CASE_ERRCODE2(NS_E_WMPXML_ENDOFDATA                                              , _T("The XML Parser ran out of data while parsing."))
      CASE_ERRCODE2(NS_E_WMPXML_PARSEERROR                                             , _T("A generic parse error occurred in the XML parser but no information is available."))
      CASE_ERRCODE2(NS_E_WMPXML_ATTRIBUTENOTFOUND                                      , _T("A call get GetNamedAttribute or GetNamedAttributeIndex on the XML parser resulted in the index not being found."))
      CASE_ERRCODE2(NS_E_WMPXML_PINOTFOUND                                             , _T("A call was made go GetNamedPI on the XML parser, but the requested Processing Instruction was not found."))
      CASE_ERRCODE2(NS_E_WMPXML_EMPTYDOC                                               , _T("Persist was called on the XML parser, but the parser has no data to persist."))
      CASE_ERRCODE2(NS_E_WMP_WINDOWSAPIFAILURE                                         , _T("A Windows API call failed but no error information was available."))
      CASE_ERRCODE2(NS_E_WMP_RECORDING_NOT_ALLOWED                                     , _T("Windows Media Player cannot copy the file. Either the license restricts copying, or you must obtain a license to copy the file."))
      CASE_ERRCODE2(NS_E_DEVICE_NOT_READY                                              , _T("Windows Media Player no longer detects a connected portable device. Reconnect your portable device, and try again."))
      CASE_ERRCODE2(NS_E_DAMAGED_FILE                                                  , _T("Windows Media Player cannot play the file because it is either damaged or corrupt."))
      CASE_ERRCODE2(NS_E_MPDB_GENERIC                                                  , _T("An error occurred when the Player was attempting to access information in your media library. Try closing and then reopening the Player."))
      CASE_ERRCODE2(NS_E_FILE_FAILED_CHECKS                                            , _T("The file cannot be added to Media Library because it is smaller than the minimum-size requirement. Adjust the size requirements, and then try again."))
      CASE_ERRCODE2(NS_E_MEDIA_LIBRARY_FAILED                                          , _T("Windows Media Player could not create Media Library. Check with your system administrator to get the necessary permissions to create Media Library on your computer, and then try installing the Player again."))
      CASE_ERRCODE2(NS_E_SHARING_VIOLATION                                             , _T("The file is already in use. Close other programs that may be using the file, or stop playing the file, and try again."))
      CASE_ERRCODE2(NS_E_NO_ERROR_STRING_FOUND                                         , _T("Windows Media Player has encountered an unknown error."))
      CASE_ERRCODE2(NS_E_WMPOCX_NO_REMOTE_CORE                                         , _T("The Windows Media Player control was unable to connect to remote media services, but will continue with local media services."))
      CASE_ERRCODE2(NS_E_WMPOCX_NO_ACTIVE_CORE                                         , _T("The requested method or property is not available because the Windows Media Player control has not been properly activated."))
      CASE_ERRCODE2(NS_E_WMPOCX_NOT_RUNNING_REMOTELY                                   , _T("Windows Media Player ActiveX control is not running in remote mode."))
      CASE_ERRCODE2(NS_E_WMPOCX_NO_REMOTE_WINDOW                                       , _T("An error occurred when trying to get remote Windows Media Player window."))
      CASE_ERRCODE2(NS_E_WMPOCX_ERRORMANAGERNOTAVAILABLE                               , _T("Windows Media Player has encountered an unknown error."))
      CASE_ERRCODE2(NS_E_PLUGIN_NOTSHUTDOWN                                            , _T("Windows Media Player was not closed properly. A damaged or incompatible plug-in may have caused the problem to occur. As a precaution, all third-party plug-ins have been disabled."))
      CASE_ERRCODE2(NS_E_WMP_CANNOT_FIND_FOLDER                                        , _T("Windows Media Player cannot find the specified path. Be sure the path is typed correctly. If it is, the path does not exist in the specified location, or the computer where the path is located is offline."))
      CASE_ERRCODE2(NS_E_WMP_STREAMING_RECORDING_NOT_ALLOWED                           , _T("Windows Media Player cannot copy streaming media."))
      CASE_ERRCODE2(NS_E_WMP_PLUGINDLL_NOTFOUND                                        , _T("Windows Media Player cannot find the selected plug-in. The Player will try to remove it from the menu. To use this plug-in, install it again."))
      CASE_ERRCODE2(NS_E_NEED_TO_ASK_USER                                              , _T("Action requires input from the user."))
      CASE_ERRCODE2(NS_E_WMPOCX_PLAYER_NOT_DOCKED                                      , _T("The Windows Media Player control must be in a docked state for this action to succeed."))
      CASE_ERRCODE2(NS_E_WMP_EXTERNAL_NOTREADY                                         , _T("Media Player external object is not ready."))
      CASE_ERRCODE2(NS_E_WMP_MLS_STALE_DATA                                            , _T("Metadata is stale. The operation failed."))
      CASE_ERRCODE2(NS_E_WMP_UI_SUBCONTROLSNOTSUPPORTED                                , _T("The control (%s) does not support creation of sub-controls, yet (%d) sub-controls have been specified."))
      CASE_ERRCODE2(NS_E_WMP_UI_VERSIONMISMATCH                                        , _T("Version mismatch: (%.1f required, %.1f found)."))
      CASE_ERRCODE2(NS_E_WMP_UI_NOTATHEMEFILE                                          , _T("The layout manager was given valid XML that wasn't a theme file."))
      CASE_ERRCODE2(NS_E_WMP_UI_SUBELEMENTNOTFOUND                                     , _T("The %s subelement could not be found on the %s object."))
      CASE_ERRCODE2(NS_E_WMP_UI_VERSIONPARSE                                           , _T("An error occurred parsing the version tag. Valid version tags are of the form: <?wmp version='1.0'?>."))
      CASE_ERRCODE2(NS_E_WMP_UI_VIEWIDNOTFOUND                                         , _T("The view specified in for the 'currentViewID' property (%s) was not found in this theme file."))
      CASE_ERRCODE2(NS_E_WMP_UI_PASSTHROUGH                                            , _T("This error used internally for hit testing."))
      CASE_ERRCODE2(NS_E_WMP_UI_OBJECTNOTFOUND                                         , _T("Attributes were specified for the %s object, but the object was not available to send them to."))
      CASE_ERRCODE2(NS_E_WMP_UI_SECONDHANDLER                                          , _T("The %s event already has a handler, the second handler was ignored."))
      CASE_ERRCODE2(NS_E_WMP_UI_NOSKININZIP                                            , _T("No .wms file found in skin archive."))
      CASE_ERRCODE2(NS_S_WMP_UI_VERSIONMISMATCH                                        , _T("An upgrade may be needed for the theme manager to correctly show this skin. Skin reports version: %.1f."))
      CASE_ERRCODE2(NS_S_WMP_EXCEPTION                                                 , _T("An error occurred in one of the UI components."))
      CASE_ERRCODE2(NS_E_WMP_URLDOWNLOADFAILED                                         , _T("Windows Media Player cannot save the file."))
      CASE_ERRCODE2(NS_E_WMPOCX_UNABLE_TO_LOAD_SKIN                                    , _T("The Windows Media Player Control was unable to load the requested uiMode and could not successfully roll back to the existing uiMode."))
      CASE_ERRCODE2(NS_E_WMP_INVALID_SKIN                                              , _T("The skin file is invalid."))
      CASE_ERRCODE2(NS_E_WMP_SENDMAILFAILED                                            , _T("Windows Media Player cannot send the link because your e-mail program is not responding. Verify that your e-mail program is configured properly, and then try again. For more information about e-mail, see Windows Help"))
      CASE_ERRCODE2(NS_E_WMP_SAVEAS_READONLY                                           , _T("The Windows Media Player cannot overwrite a read only file. Choose another file to save as or change the file attributes."))
      CASE_ERRCODE2(NS_E_WMP_RBC_JPGMAPPINGIMAGE                                       , _T("JPG Images are not recommended for use as a mappingImage."))
      CASE_ERRCODE2(NS_E_WMP_JPGTRANSPARENCY                                           , _T("JPG Images are not recommended when using a transparencyColor."))
      CASE_ERRCODE2(NS_E_WMP_INVALID_MAX_VAL                                           , _T("The Max property cannot be less than Min property."))
      CASE_ERRCODE2(NS_E_WMP_INVALID_MIN_VAL                                           , _T("The Min property cannot be greater than Max property."))
      CASE_ERRCODE2(NS_E_WMP_CS_JPGPOSITIONIMAGE                                       , _T("JPG Images are not recommended for use as a positionImage."))
      CASE_ERRCODE2(NS_E_WMP_CS_NOTEVENLYDIVISIBLE                                     , _T("The (%s) image's size is not evenly divisible by the positionImage's size."))
      CASE_ERRCODE2(NS_E_WMPZIP_NOTAZIPFILE                                            , _T("The ZIP reader opened a file and its signature didn't match that of ZIP files."))
      CASE_ERRCODE2(NS_E_WMPZIP_CORRUPT                                                , _T("The ZIP reader has detected that the file is corrupt."))
      CASE_ERRCODE2(NS_E_WMPZIP_FILENOTFOUND                                           , _T("GetFileStream, SaveToFile, or SaveTemp file was called on the ZIP reader with a filename that was not found in the zip file."))
      CASE_ERRCODE2(NS_E_WMP_IMAGE_FILETYPE_UNSUPPORTED                                , _T("Image type not supported."))
      CASE_ERRCODE2(NS_E_WMP_IMAGE_INVALID_FORMAT                                      , _T("Image file may be corrupt."))
      CASE_ERRCODE2(NS_E_WMP_GIF_UNEXPECTED_ENDOFFILE                                  , _T("Unexpected end of file. GIF file may be corrupt."))
      CASE_ERRCODE2(NS_E_WMP_GIF_INVALID_FORMAT                                        , _T("Invalid GIF file."))
      CASE_ERRCODE2(NS_E_WMP_GIF_BAD_VERSION_NUMBER                                    , _T("Invalid GIF version. Only 87a or 89a supported."))
      CASE_ERRCODE2(NS_E_WMP_GIF_NO_IMAGE_IN_FILE                                      , _T("No images found in GIF file."))
      CASE_ERRCODE2(NS_E_WMP_PNG_INVALIDFORMAT                                         , _T("Invalid PNG image file format."))
      CASE_ERRCODE2(NS_E_WMP_PNG_UNSUPPORTED_BITDEPTH                                  , _T("PNG bitdepth not supported."))
      CASE_ERRCODE2(NS_E_WMP_PNG_UNSUPPORTED_COMPRESSION                               , _T("Compression format defined in PNG file not supported,"))
      CASE_ERRCODE2(NS_E_WMP_PNG_UNSUPPORTED_FILTER                                    , _T("Filter method defined in PNG file not supported."))
      CASE_ERRCODE2(NS_E_WMP_PNG_UNSUPPORTED_INTERLACE                                 , _T("Interlace method defined in PNG file not supported."))
      CASE_ERRCODE2(NS_E_WMP_PNG_UNSUPPORTED_BAD_CRC                                   , _T("Bad CRC in PNG file."))
      CASE_ERRCODE2(NS_E_WMP_BMP_INVALID_BITMASK                                       , _T("Invalid bitmask in BMP file."))
      CASE_ERRCODE2(NS_E_WMP_BMP_TOPDOWN_DIB_UNSUPPORTED                               , _T("Topdown DIB not supported."))
      CASE_ERRCODE2(NS_E_WMP_BMP_BITMAP_NOT_CREATED                                    , _T("Bitmap could not be created."))
      CASE_ERRCODE2(NS_E_WMP_BMP_COMPRESSION_UNSUPPORTED                               , _T("Compression format defined in BMP not supported."))
      CASE_ERRCODE2(NS_E_WMP_BMP_INVALID_FORMAT                                        , _T("Invalid Bitmap format."))
      CASE_ERRCODE2(NS_E_WMP_JPG_JERR_ARITHCODING_NOTIMPL                              , _T("JPEG Arithmetic coding not supported."))
      CASE_ERRCODE2(NS_E_WMP_JPG_INVALID_FORMAT                                        , _T("Invalid JPEG format."))
      CASE_ERRCODE2(NS_E_WMP_JPG_BAD_DCTSIZE                                           , _T("Invalid JPEG format."))
      CASE_ERRCODE2(NS_E_WMP_JPG_BAD_VERSION_NUMBER                                    , _T("Internal version error. Unexpected JPEG library version."))
      CASE_ERRCODE2(NS_E_WMP_JPG_BAD_PRECISION                                         , _T("Internal JPEG Library error. Unsupported JPEG data precision."))
      CASE_ERRCODE2(NS_E_WMP_JPG_CCIR601_NOTIMPL                                       , _T("JPEG CCIR601 not supported."))
      CASE_ERRCODE2(NS_E_WMP_JPG_NO_IMAGE_IN_FILE                                      , _T("No image found in JPEG file."))
      CASE_ERRCODE2(NS_E_WMP_JPG_READ_ERROR                                            , _T("Could not read JPEG file."))
      CASE_ERRCODE2(NS_E_WMP_JPG_FRACT_SAMPLE_NOTIMPL                                  , _T("JPEG Fractional sampling not supported."))
      CASE_ERRCODE2(NS_E_WMP_JPG_IMAGE_TOO_BIG                                         , _T("JPEG image too large. Maximum image size supported is 65500 X 65500."))
      CASE_ERRCODE2(NS_E_WMP_JPG_UNEXPECTED_ENDOFFILE                                  , _T("Unexpected end of file reached in JPEG file."))
      CASE_ERRCODE2(NS_E_WMP_JPG_SOF_UNSUPPORTED                                       , _T("Unsupported JPEG SOF marker found."))
      CASE_ERRCODE2(NS_E_WMP_JPG_UNKNOWN_MARKER                                        , _T("Unknown JPEG marker found."))
      CASE_ERRCODE2(NS_S_WMP_LOADED_GIF_IMAGE                                          , _T("Successfully loaded a GIF file."))
      CASE_ERRCODE2(NS_S_WMP_LOADED_PNG_IMAGE                                          , _T("Successfully loaded a PNG file."))
      CASE_ERRCODE2(NS_S_WMP_LOADED_BMP_IMAGE                                          , _T("Successfully loaded a BMP file."))
      CASE_ERRCODE2(NS_S_WMP_LOADED_JPG_IMAGE                                          , _T("Successfully loaded a JPG file."))
      CASE_ERRCODE2(NS_E_WMG_RATEUNAVAILABLE                                           , _T("The requested playback rate is unavailable on this content."))
      CASE_ERRCODE2(NS_E_WMG_PLUGINUNAVAILABLE                                         , _T("The rendering or digital signal processing plugin could not be instantiated."))
      CASE_ERRCODE2(NS_E_WMG_CANNOTQUEUE                                               , _T("The file cannot be queued for seamless playback."))
      CASE_ERRCODE2(NS_E_WMG_PREROLLLICENSEACQUISITIONNOTALLOWED                       , _T("Windows Media Player cannot acquire the license for a file that is being prerolled."))
      CASE_ERRCODE2(NS_E_WMG_UNEXPECTEDPREROLLSTATUS                                   , _T("Windows Media Player received an unexpected message while attempting to preroll a file."))
      CASE_ERRCODE2(NS_E_WMG_INVALIDSTATE                                              , _T("Operation attempted in an invalid graph state."))
      CASE_ERRCODE2(NS_E_WMG_SINKALREADYEXISTS                                         , _T("A renderer cannot be inserted in a stream while one already exists."))
      CASE_ERRCODE2(NS_E_WMG_NOSDKINTERFACE                                            , _T("A necessary WM SDK interface to complete the operation doesn't exist at this time."))
      CASE_ERRCODE2(NS_E_WMG_NOTALLOUTPUTSRENDERED                                     , _T("Windows Media Player cannot play the file. The file may be formatted with an unsupported codec, or the Player could not download the codec."))
      CASE_ERRCODE2(NS_E_WMG_FILETRANSFERNOTALLOWED                                    , _T("File transfer streams are not allowed in the stand alone player."))
      CASE_ERRCODE2(NS_E_WMR_UNSUPPORTEDSTREAM                                         , _T("Windows Media Player cannot play the file. The Player does not support the format you are trying to play."))
      CASE_ERRCODE2(NS_E_WMR_PINNOTFOUND                                               , _T("An operation was attempted on a pin that doesn't exist in the DirectShow filter graph."))
      CASE_ERRCODE2(NS_E_WMR_WAITINGONFORMATSWITCH                                     , _T("Specified operation cannot be completed while waiting for a media format change from the SDK."))
      CASE_ERRCODE2(NS_E_WMR_NOSOURCEFILTER                                            , _T("Specified operation cannot be completed because the source filter does not exist."))
      CASE_ERRCODE2(NS_E_WMR_PINTYPENOMATCH                                            , _T("The specified type does not match this pin."))
      CASE_ERRCODE2(NS_E_WMR_NOCALLBACKAVAILABLE                                       , _T("The WMR Source Filter does not have a callback available."))
      CASE_ERRCODE2(NS_S_WMR_ALREADYRENDERED                                           , _T("The specified stream has already been rendered."))
      CASE_ERRCODE2(NS_S_WMR_PINTYPEPARTIALMATCH                                       , _T("The specified type partially matches this pin type."))
      CASE_ERRCODE2(NS_S_WMR_PINTYPEFULLMATCH                                          , _T("The specified type fully matches this pin type."))
      CASE_ERRCODE2(NS_E_WMR_SAMPLEPROPERTYNOTSET                                      , _T("The specified property has not been set on this sample."))
      CASE_ERRCODE2(NS_E_WMR_CANNOT_RENDER_BINARY_STREAM                               , _T("A plugin is required to correctly play this file. To determine if this plugin is available to download from the Web, click Web Help."))
      CASE_ERRCODE2(NS_E_WMG_LICENSE_TAMPERED                                          , _T("The file cannot be played, the content has been tampered."))
      CASE_ERRCODE2(NS_E_WMR_WILLNOT_RENDER_BINARY_STREAM                              , _T("The content you are trying to play is protected content and the player will not render binary streams from protected content."))
      CASE_ERRCODE2(NS_E_WMX_UNRECOGNIZED_PLAYLIST_FORMAT                              , _T("The format of this file was not recognized as a valid playlist format."))
      CASE_ERRCODE2(NS_E_ASX_INVALIDFORMAT                                             , _T("This file was believed to be an ASX playlist, but the format was not recognized."))
      CASE_ERRCODE2(NS_E_ASX_INVALIDVERSION                                            , _T("The version of this playlist is not supported. Click More Information to go to the Microsoft web site and see if there is a newer version of the player to install."))
      CASE_ERRCODE2(NS_E_ASX_INVALID_REPEAT_BLOCK                                      , _T("Format of a REPEAT loop within the current playlist file is invalid."))
      CASE_ERRCODE2(NS_E_ASX_NOTHING_TO_WRITE                                          , _T("Windows Media Player cannot export the playlist because it is empty."))
      CASE_ERRCODE2(NS_E_URLLIST_INVALIDFORMAT                                         , _T("Windows Media Player does not recognize this file as a supported playlist."))
      CASE_ERRCODE2(NS_E_WMX_ATTRIBUTE_DOES_NOT_EXIST                                  , _T("The specified attribute does not exist."))
      CASE_ERRCODE2(NS_E_WMX_ATTRIBUTE_ALREADY_EXISTS                                  , _T("The specified attribute already exists."))
      CASE_ERRCODE2(NS_E_WMX_ATTRIBUTE_UNRETRIEVABLE                                   , _T("Can not retrieve the specified attribute."))
      CASE_ERRCODE2(NS_E_WMX_ITEM_DOES_NOT_EXIST                                       , _T("The specified item does not exist in the current playlist."))
      CASE_ERRCODE2(NS_E_WMX_ITEM_TYPE_ILLEGAL                                         , _T("Items of the specified type can not be created within the current playlist."))
      CASE_ERRCODE2(NS_E_WMX_ITEM_UNSETTABLE                                           , _T("The specified item can not be set in the current playlist."))
      CASE_ERRCODE2(NS_E_WMX_PLAYLIST_EMPTY                                            , _T("The specified playlist is empty."))
      CASE_ERRCODE2(NS_E_MLS_SMARTPLAYLIST_FILTER_NOT_REGISTERED                       , _T("Playlist load error: The specified autoplaylist contains a filter type which is either invalid or is not installed on this computer"))
      CASE_ERRCODE2(NS_E_WMX_INVALID_FORMAT_OVER_NESTING                               , _T("Windows Media Player cannot play the file because the associated Windows Media metafile playlist is not valid."))
      CASE_ERRCODE2(NS_E_WMPCORE_NOSOURCEURLSTRING                                     , _T("Windows Media Player cannot find the file. Be sure the path is typed correctly. If it is, the file may not exist in the specified location, or the computer where the file is stored may be offline."))
      CASE_ERRCODE2(NS_E_WMPCORE_COCREATEFAILEDFORGITOBJECT                            , _T("Failed to create the Global Interface Table."))
      CASE_ERRCODE2(NS_E_WMPCORE_FAILEDTOGETMARSHALLEDEVENTHANDLERINTERFACE            , _T("Failed to get the marshaled graph event handler interface."))
      CASE_ERRCODE2(NS_E_WMPCORE_BUFFERTOOSMALL                                        , _T("Buffer is too small for copying media type."))
      CASE_ERRCODE2(NS_E_WMPCORE_UNAVAILABLE                                           , _T("Current state of the player does not allow the operation."))
      CASE_ERRCODE2(NS_E_WMPCORE_INVALIDPLAYLISTMODE                                   , _T("Playlist manager does not understand the current play mode (shuffle, normal etc)."))
      CASE_ERRCODE2(NS_E_WMPCORE_ITEMNOTINPLAYLIST                                     , _T("The item is not in the playlist."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLISTEMPTY                                         , _T("There are no items in this playlist. Add items to the playlist, and try again."))
      CASE_ERRCODE2(NS_E_WMPCORE_NOBROWSER                                             , _T("The Web site cannot be accessed. A Web browser is not detected on your computer."))
      CASE_ERRCODE2(NS_E_WMPCORE_UNRECOGNIZED_MEDIA_URL                                , _T("Windows Media Player cannot find the specified file. Be sure the path is typed correctly. If it is, the file does not exist in the specified location, or the computer where the file is stored is offline."))
      CASE_ERRCODE2(NS_E_WMPCORE_GRAPH_NOT_IN_LIST                                     , _T("Graph with the specified URL was not found in the prerolled graph list."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_EMPTY_OR_SINGLE_MEDIA                        , _T("There is only one item in the playlist."))
      CASE_ERRCODE2(NS_E_WMPCORE_ERRORSINKNOTREGISTERED                                , _T("An error sink was never registered for the calling object."))
      CASE_ERRCODE2(NS_E_WMPCORE_ERRORMANAGERNOTAVAILABLE                              , _T("The error manager is not available to respond to errors."))
      CASE_ERRCODE2(NS_E_WMPCORE_WEBHELPFAILED                                         , _T("Failed launching WebHelp URL."))
      CASE_ERRCODE2(NS_E_WMPCORE_MEDIA_ERROR_RESUME_FAILED                             , _T("Could not resume playing next item in playlist."))
      CASE_ERRCODE2(NS_E_WMPCORE_NO_REF_IN_ENTRY                                       , _T("Windows Media Player cannot play the file because the associated Windows Media metafile playlist is not valid."))
      CASE_ERRCODE2(NS_E_WMPCORE_WMX_LIST_ATTRIBUTE_NAME_EMPTY                         , _T("An empty string for playlist attribute name was found."))
      CASE_ERRCODE2(NS_E_WMPCORE_WMX_LIST_ATTRIBUTE_NAME_ILLEGAL                       , _T("An invalid playlist attribute name was found."))
      CASE_ERRCODE2(NS_E_WMPCORE_WMX_LIST_ATTRIBUTE_VALUE_EMPTY                        , _T("An empty string for a playlist attribute value was found."))
      CASE_ERRCODE2(NS_E_WMPCORE_WMX_LIST_ATTRIBUTE_VALUE_ILLEGAL                      , _T("An illegal value for a playlist attribute was found."))
      CASE_ERRCODE2(NS_E_WMPCORE_WMX_LIST_ITEM_ATTRIBUTE_NAME_EMPTY                    , _T("An empty string for a playlist item attribute name was found."))
      CASE_ERRCODE2(NS_E_WMPCORE_WMX_LIST_ITEM_ATTRIBUTE_NAME_ILLEGAL                  , _T("An illegal value for a playlist item attribute name was found."))
      CASE_ERRCODE2(NS_E_WMPCORE_WMX_LIST_ITEM_ATTRIBUTE_VALUE_EMPTY                   , _T("An illegal value for a playlist item attribute was found."))
      CASE_ERRCODE2(NS_E_WMPCORE_LIST_ENTRY_NO_REF                                     , _T("No entries found in the playlist file."))
      CASE_ERRCODE2(NS_E_WMPCORE_MISNAMED_FILE                                         , _T("Windows Media Player cannot play the file. The file is either corrupt or the Player does not support the format you are trying to play."))
      CASE_ERRCODE2(NS_E_WMPCORE_CODEC_NOT_TRUSTED                                     , _T("The codec downloaded for this media does not appear to be properly signed. Installation is not possible."))
      CASE_ERRCODE2(NS_E_WMPCORE_CODEC_NOT_FOUND                                       , _T("Windows Media Player cannot play the file. One or more codecs required to play the file could not be found."))
      CASE_ERRCODE2(NS_E_WMPCORE_CODEC_DOWNLOAD_NOT_ALLOWED                            , _T("Some of the codecs required by this media are not installed on your system. Since the option for automatic codec acquisition is disabled, no codecs will be downloaded."))
      CASE_ERRCODE2(NS_E_WMPCORE_ERROR_DOWNLOADING_PLAYLIST                            , _T("Failed to download the playlist file."))
      CASE_ERRCODE2(NS_E_WMPCORE_FAILED_TO_BUILD_PLAYLIST                              , _T("Failed to build the playlist."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_ITEM_ALTERNATE_NONE                          , _T("Playlist has no alternates to switch into."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_ITEM_ALTERNATE_EXHAUSTED                     , _T("No more playlist alternates available to switch to."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_ITEM_ALTERNATE_NAME_NOT_FOUND                , _T("Could not find the name of the alternate playlist to switch into."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_ITEM_ALTERNATE_MORPH_FAILED                  , _T("Failed to switch to an alternate for this media."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_ITEM_ALTERNATE_INIT_FAILED                   , _T("Failed to initialize an alternate for the media."))
      CASE_ERRCODE2(NS_E_WMPCORE_MEDIA_ALTERNATE_REF_EMPTY                             , _T("No URL specified for the roll over Refs in the playlist file."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_NO_EVENT_NAME                                , _T("Encountered a playlist with no name."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_EVENT_ATTRIBUTE_ABSENT                       , _T("A required attribute in the event block of the playlist was not found."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_EVENT_EMPTY                                  , _T("No items were found in the event block of the playlist."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_STACK_EMPTY                                  , _T("No playlist was found while returning from a nested playlist."))
      CASE_ERRCODE2(NS_E_WMPCORE_CURRENT_MEDIA_NOT_ACTIVE                              , _T("The media item is not active currently."))
      CASE_ERRCODE2(NS_E_WMPCORE_USER_CANCEL                                           , _T("Open was aborted by user."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_REPEAT_EMPTY                                 , _T("No items were found inside the playlist repeat block."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_REPEAT_START_MEDIA_NONE                      , _T("Media object corresponding to start of a playlist repeat block was not found."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_REPEAT_END_MEDIA_NONE                        , _T("Media object corresponding to the end of a playlist repeat block was not found."))
      CASE_ERRCODE2(NS_E_WMPCORE_INVALID_PLAYLIST_URL                                  , _T("Playlist URL supplied to the playlist manager is invalid."))
      CASE_ERRCODE2(NS_E_WMPCORE_MISMATCHED_RUNTIME                                    , _T("Windows Media Player cannot play the file because it is corrupted."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_IMPORT_FAILED_NO_ITEMS                       , _T("Windows Media Player cannot import the playlist to Media Library because the playlist is empty."))
      CASE_ERRCODE2(NS_E_WMPCORE_VIDEO_TRANSFORM_FILTER_INSERTION                      , _T("An error has occurred that could prevent the changing of the video contrast on this media."))
      CASE_ERRCODE2(NS_E_WMPCORE_MEDIA_UNAVAILABLE                                     , _T("Windows Media Player cannot play this file. Connect to the Internet or insert the removable media on which the file is located, and then try to play the file again."))
      CASE_ERRCODE2(NS_E_WMPCORE_WMX_ENTRYREF_NO_REF                                   , _T("The playlist contains an ENTRYREF for which no href was parsed. Check the syntax of playlist file."))
      CASE_ERRCODE2(NS_E_WMPCORE_NO_PLAYABLE_MEDIA_IN_PLAYLIST                         , _T("Windows Media Player cannot play any items in this playlist. For additional information, right-click an item that cannot be played, and then click Error Details."))
      CASE_ERRCODE2(NS_E_WMPCORE_PLAYLIST_EMPTY_NESTED_PLAYLIST_SKIPPED_ITEMS          , _T("Windows Media Player cannot play some or all of the playlist items."))
      CASE_ERRCODE2(NS_E_WMPCORE_BUSY                                                  , _T("Windows Media Player cannot play the file at this time. Try again later."))
      CASE_ERRCODE2(NS_E_WMPCORE_MEDIA_CHILD_PLAYLIST_UNAVAILABLE                      , _T("There is no child playlist available for this media item at this time."))
      CASE_ERRCODE2(NS_E_WMPCORE_MEDIA_NO_CHILD_PLAYLIST                               , _T("There is no child playlist for this media item."))
      CASE_ERRCODE2(NS_E_WMPCORE_FILE_NOT_FOUND                                        , _T("Windows Media Player cannot play one or more files. Right-click the file, and then click Error Details to view information about the error."))
      CASE_ERRCODE2(NS_E_WMPCORE_TEMP_FILE_NOT_FOUND                                   , _T("The temporary file was not found."))
      CASE_ERRCODE2(NS_E_WMDM_REVOKED                                                  , _T("Windows Media Player cannot transfer media to the portable device without an update.  Please click More Information to find out how to update your device."))
      CASE_ERRCODE2(NS_E_DDRAW_GENERIC                                                 , _T("Windows Media Player cannot play the video stream because of a problem with your video card."))
      CASE_ERRCODE2(NS_E_DISPLAY_MODE_CHANGE_FAILED                                    , _T("Windows Media Player failed to change the screen mode for fullscreen video playback."))
      CASE_ERRCODE2(NS_E_PLAYLIST_CONTAINS_ERRORS                                      , _T("One or more items in the playlist cannot be played. For more details, right-click an item in the playlist, and then click Error Details."))
      CASE_ERRCODE2(NS_E_CHANGING_PROXY_NAME                                           , _T("Can't change proxy name if the proxy setting is not set to custom."))
      CASE_ERRCODE2(NS_E_CHANGING_PROXY_PORT                                           , _T("Can't change proxy port if the proxy setting is not set to custom."))
      CASE_ERRCODE2(NS_E_CHANGING_PROXY_EXCEPTIONLIST                                  , _T("Can't change proxy exception list if the proxy setting is not set to custom."))
      CASE_ERRCODE2(NS_E_CHANGING_PROXYBYPASS                                          , _T("Can't change proxy bypass flag if the proxy setting is not set to custom."))
      CASE_ERRCODE2(NS_E_CHANGING_PROXY_PROTOCOL_NOT_FOUND                             , _T("Can't find specified protocol."))
      CASE_ERRCODE2(NS_E_GRAPH_NOAUDIOLANGUAGE                                         , _T("Can't change language settings.  Either the graph has no audio, or the audio only supports one language."))
      CASE_ERRCODE2(NS_E_GRAPH_NOAUDIOLANGUAGESELECTED                                 , _T("The graph has no audio language selected."))
      CASE_ERRCODE2(NS_E_CORECD_NOTAMEDIACD                                            , _T("This is not a media CD."))
      CASE_ERRCODE2(NS_E_WMPCORE_MEDIA_URL_TOO_LONG                                    , _T("Windows Media Player cannot play this file because the URL is too long."))
      CASE_ERRCODE2(NS_E_WMPFLASH_CANT_FIND_COM_SERVER                                 , _T("Windows Media Player needs the Macromedia Flash Player to play this content. Windows Media Player was not able to detect the Flash player on your system. To play the selected item, you must install the Macromedia Flash Player from the Macromedia Web site, and then try to play the item again."))
      CASE_ERRCODE2(NS_E_WMPFLASH_INCOMPATIBLEVERSION                                  , _T("To play the selected item, you must install an updated version of the Macromedia Flash Player from the Macromedia Web site, and then try to play the item again."))
      CASE_ERRCODE2(NS_E_WMPOCXGRAPH_IE_DISALLOWS_ACTIVEX_CONTROLS                     , _T("The use of ActiveX controls has been turned off in Internet Explorer. As a result Windows Media Player will not be able to playback this content."))
      CASE_ERRCODE2(NS_E_NEED_CORE_REFERENCE                                           , _T("The use of this method requires an existing reference to the Player object."))
      CASE_ERRCODE2(NS_E_MEDIACD_READ_ERROR                                            , _T("There was an error reading from the CD-ROM."))
      CASE_ERRCODE2(NS_E_IE_DISALLOWS_ACTIVEX_CONTROLS                                 , _T("Internet Explorer is set to disallow ActiveX controls."))
      CASE_ERRCODE2(NS_E_FLASH_PLAYBACK_NOT_ALLOWED                                    , _T("Flash playback has been turned off in Windows Media Player."))
      CASE_ERRCODE2(NS_E_UNABLE_TO_CREATE_RIP_LOCATION                                 , _T("Media Player was unable to create a valid location to copy the CD track."))
      CASE_ERRCODE2(NS_E_WMPCORE_SOME_CODECS_MISSING                                   , _T("One or more codecs required to open this content could not be found."))
      CASE_ERRCODE2(NS_S_WMPCORE_PLAYLISTCLEARABORT                                    , _T("Failed to clear playlist because it was aborted by user."))
      CASE_ERRCODE2(NS_S_WMPCORE_PLAYLISTREMOVEITEMABORT                               , _T("Failed to remove item in the playlist since it was aborted by user."))
      CASE_ERRCODE2(NS_S_WMPCORE_PLAYLIST_CREATION_PENDING                             , _T("Playlist is being generated asynchronously."))
      CASE_ERRCODE2(NS_S_WMPCORE_MEDIA_VALIDATION_PENDING                              , _T("Validation of the media is pending..."))
      CASE_ERRCODE2(NS_S_WMPCORE_PLAYLIST_REPEAT_SECONDARY_SEGMENTS_IGNORED            , _T("Encountered more than one Repeat block during ASX processing."))
      CASE_ERRCODE2(NS_S_WMPCORE_COMMAND_NOT_AVAILABLE                                 , _T("Current state of WMP disallows calling this method or property."))
      CASE_ERRCODE2(NS_S_WMPCORE_PLAYLIST_NAME_AUTO_GENERATED                          , _T("Name for the playlist has been auto generated."))
      CASE_ERRCODE2(NS_S_WMPCORE_PLAYLIST_IMPORT_MISSING_ITEMS                         , _T("The imported playlist does not contain all items from the original."))
      CASE_ERRCODE2(NS_S_WMPCORE_PLAYLIST_COLLAPSED_TO_SINGLE_MEDIA                    , _T("The M3U playlist has been ignored because it only contains one item."))
      CASE_ERRCODE2(NS_S_WMPCORE_MEDIA_CHILD_PLAYLIST_OPEN_PENDING                     , _T("The open for the child playlist associated with this media is pending."))
      CASE_ERRCODE2(NS_S_WMPCORE_MORE_NODES_AVAIABLE                                   , _T("More nodes support the interface requested, but the array for returning them is full."))
      CASE_ERRCODE2(NS_E_WMPIM_USEROFFLINE                                             , _T("Windows Media Player has detected that you are not connected to the Internet. Connect to the Internet, and then try again."))
      CASE_ERRCODE2(NS_E_WMPIM_USERCANCELED                                            , _T("User cancelled attempt to connect to the Internet."))
      CASE_ERRCODE2(NS_E_WMPIM_DIALUPFAILED                                            , _T("Attempt to dial connection to the Internet failed."))
      CASE_ERRCODE2(NS_E_WINSOCK_ERROR_STRING                                          , _T("Windows Media Player has encountered an unknown network error."))
      CASE_ERRCODE2(NS_E_WMPBR_NOLISTENER                                              , _T("No window is currently listening to Backup and Restore events."))
      CASE_ERRCODE2(NS_E_WMPBR_BACKUPCANCEL                                            , _T("Backup of your licenses has been cancelled.  Please try again to ensure license backup."))
      CASE_ERRCODE2(NS_E_WMPBR_RESTORECANCEL                                           , _T("The licenses were not restored because the restoration was cancelled."))
      CASE_ERRCODE2(NS_E_WMPBR_ERRORWITHURL                                            , _T("An error occurred during the backup or restore operation that requires a web page be displayed to the user."))
      CASE_ERRCODE2(NS_E_WMPBR_NAMECOLLISION                                           , _T("The licenses were not backed up because the backup was cancelled."))
      CASE_ERRCODE2(NS_S_WMPBR_SUCCESS                                                 , _T("Backup or Restore successful!."))
      CASE_ERRCODE2(NS_S_WMPBR_PARTIALSUCCESS                                          , _T("Transfer complete with limitations."))
      CASE_ERRCODE2(NS_E_WMPBR_DRIVE_INVALID                                           , _T("The location specified for restoring licenses is not valid. Choose another location, and then try again."))
      CASE_ERRCODE2(NS_S_WMPEFFECT_TRANSPARENT                                         , _T("Request to the effects control to change transparency status to transparent."))
      CASE_ERRCODE2(NS_S_WMPEFFECT_OPAQUE                                              , _T("Request to the effects control to change transparency status to opaque."))
      CASE_ERRCODE2(NS_S_OPERATION_PENDING                                             , _T("The requested application pane is performing an operation and will not be relased."))
      CASE_ERRCODE2(NS_E_DVD_NO_SUBPICTURE_STREAM                                      , _T("Windows Media Player cannot display subtitles or highlights in menus. Reinstall the DVD decoder or contact your device manufacturer to obtain an updated decoder, and then try again."))
      CASE_ERRCODE2(NS_E_DVD_COPY_PROTECT                                              , _T("Windows Media Player cannot play this DVD because a problem occurred with digital copyright protection."))
      CASE_ERRCODE2(NS_E_DVD_AUTHORING_PROBLEM                                         , _T("Windows Media Player cannot play this DVD because the disc is incompatible with the Player."))
      CASE_ERRCODE2(NS_E_DVD_INVALID_DISC_REGION                                       , _T("Windows Media Player cannot play this DVD because the disc prohibits playback in your region of the world. You must obtain a disc that is intended for your geographic region."))
      CASE_ERRCODE2(NS_E_DVD_COMPATIBLE_VIDEO_CARD                                     , _T("Windows Media Player cannot play this DVD because your video card does not support DVD playback."))
      CASE_ERRCODE2(NS_E_DVD_MACROVISION                                               , _T("Windows Media Player cannot play this DVD because a problem occurred with copyright protection."))
      CASE_ERRCODE2(NS_E_DVD_SYSTEM_DECODER_REGION                                     , _T("Windows Media Player cannot play this DVD because the region assigned to your DVD drive does not match the region assigned to your DVD decoder."))
      CASE_ERRCODE2(NS_E_DVD_DISC_DECODER_REGION                                       , _T("Windows Media Player cannot play this DVD because the disc prohibits playback in your region of the world. To play the disc by using the Player, you must obtain a disc that is intended for your geographic region."))
      CASE_ERRCODE2(NS_E_DVD_NO_VIDEO_STREAM                                           , _T("Windows Media Player is currently unable to play DVD video. Try decreasing the number of colors displayed on your monitor or decreasing the screen resolution. For additional solutions, click More Information to access the DVD Troubleshooter."))
      CASE_ERRCODE2(NS_E_DVD_NO_AUDIO_STREAM                                           , _T("Windows Media Player cannot play DVD audio. Verify that your sound card is set up correctly, and then try again."))
      CASE_ERRCODE2(NS_E_DVD_GRAPH_BUILDING                                            , _T("Windows Media Player cannot play DVD video. Close any open files and quit any other running programs, and then try again. If the problem continues, restart your computer."))
      CASE_ERRCODE2(NS_E_DVD_NO_DECODER                                                , _T("Windows Media Player cannot play this DVD because a compatible DVD decoder is not installed on your computer."))
      CASE_ERRCODE2(NS_E_DVD_PARENTAL                                                  , _T("Windows Media Player cannot play this DVD segment because the segment has a parental rating higher than the rating you are authorized to view."))
      CASE_ERRCODE2(NS_E_DVD_CANNOT_JUMP                                               , _T("Windows Media Player cannot skip to the requested location in the DVD at this time."))
      CASE_ERRCODE2(NS_E_DVD_DEVICE_CONTENTION                                         , _T("Windows Media Player cannot play this DVD because it is currently in use by another program. Quit the other program that is using the DVD, and then try to play it again."))
      CASE_ERRCODE2(NS_E_DVD_NO_VIDEO_MEMORY                                           , _T("Windows Media Player cannot play DVD video. Double-click Display in Control Panel to lower your screen resolution and color quality settings."))
      CASE_ERRCODE2(NS_E_DVD_CANNOT_COPY_PROTECTED                                     , _T("Windows Media Player cannot copy this DVD because it is copy protected."))
      CASE_ERRCODE2(NS_E_DVD_REQUIRED_PROPERTY_NOT_SET                                 , _T("One of more of the required properties has not been set."))
      CASE_ERRCODE2(NS_E_DVD_INVALID_TITLE_CHAPTER                                     , _T("The specified title and/or chapter number does not exist on this DVD."))
      CASE_ERRCODE2(NS_E_NO_CD_BURNER                                                  , _T("A CD recorder (burner) was not detected. Connect a CD recorder, and try copying again."))
      CASE_ERRCODE2(NS_E_DEVICE_IS_NOT_READY                                           , _T("Windows Media Player does not detect any storage media in the selected device. Insert media into the device."))
      CASE_ERRCODE2(NS_E_PDA_UNSUPPORTED_FORMAT                                        , _T("Windows Media Player cannot play the specified file. Your portable device does not support the specified format."))
      CASE_ERRCODE2(NS_E_NO_PDA                                                        , _T("Windows Media Player cannot detect a connected portable device. Connect your portable device, and try again."))
      CASE_ERRCODE2(NS_E_PDA_UNSPECIFIED_ERROR                                         , _T("Windows Media Player has encountered an error on the portable device."))
      CASE_ERRCODE2(NS_E_MEMSTORAGE_BAD_DATA                                           , _T("Windows Media Player encountered an internal error in accessing a memory-based storage during a CD burning task."))
      CASE_ERRCODE2(NS_E_PDA_FAIL_SELECT_DEVICE                                        , _T("Windows Media Player encountered an internal error when selecting a PDA or CD device."))
      CASE_ERRCODE2(NS_E_PDA_FAIL_READ_WAVE_FILE                                       , _T("Windows Media Player failed to open or read data from a wave file."))
      CASE_ERRCODE2(NS_E_IMAPI_LOSSOFSTREAMING                                         , _T("Windows Media Player did not copy all the selected items. The Player has reduced the recording speed of your CD drive to solve the problem. To copy all the selected items, insert a blank CD in the drive, and try again."))
      CASE_ERRCODE2(NS_E_PDA_DEVICE_FULL                                               , _T("There is not enough storage space on the portable device to complete this operation. Delete some unneeded files on the portable device, and then try again."))
      CASE_ERRCODE2(NS_E_FAIL_LAUNCH_ROXIO_PLUGIN                                      , _T("Windows Media Player cannot copy the files to the CD. Verify that a CD-R or CD-RW drive is connected to your computer, and then try again. If the problem continues, reinstall the Player."))
      CASE_ERRCODE2(NS_E_PDA_DEVICE_FULL_IN_SESSION                                    , _T("Windows Media Player failed to copy some files to device because the device is out of space."))
      CASE_ERRCODE2(NS_E_IMAPI_MEDIUM_INVALIDTYPE                                      , _T("The medium in the drive is invalid. Please insert a blank CD-R or a CD-RW into the drive, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_PROTOCOL_PROBLEM                                          , _T("Windows Media Player could not open the specified URL. Be sure Windows Media Player is configured to use all available protocols, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_NO_DISK_SPACE                                             , _T("Windows Media Player cannot open the file because there is not enough disk space on your computer. Delete some unneeded files on your hard disk, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_LOGON_FAILURE                                             , _T("Windows Media Player cannot copy or play the file because the server denied access to it. Verify that you have access rights to the file, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_CANNOT_FIND_FILE                                          , _T("Windows Media Player cannot find the specified file. Be sure the path is typed correctly. If it is, the file does not exist at the specified location, or the computer where the file is stored is offline."))
      CASE_ERRCODE2(NS_E_WMP_SERVER_INACCESSIBLE                                       , _T("Windows Media Player cannot connect to the server. The server name may be incorrect or the server is busy. Try again later."))
      CASE_ERRCODE2(NS_E_WMP_UNSUPPORTED_FORMAT                                        , _T("Windows Media Player cannot play the file. The file is either corrupt or the Player does not support the format you are trying to play."))
      CASE_ERRCODE2(NS_E_WMP_DSHOW_UNSUPPORTED_FORMAT                                  , _T("Windows Media Player cannot play the file. The file may be formatted with an unsupported codec, or the Internet security setting on your computer is set too high. Lower your browser's security setting, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_PLAYLIST_EXISTS                                           , _T("Windows Media Player cannot create the playlist because the name already exists. Type a different playlist name."))
      CASE_ERRCODE2(NS_E_WMP_NONMEDIA_FILES                                            , _T("Windows Media Player could not delete the playlist because it contains non-digital media files. Any digital media files in the playlist were deleted. Use Windows Explorer to delete non-digital media files, and then try deleting the playlist again."))
      CASE_ERRCODE2(NS_E_WMP_INVALID_ASX                                               , _T("Windows Media Player cannot play the file because the associated playlist is not valid."))
      CASE_ERRCODE2(NS_E_WMP_ALREADY_IN_USE                                            , _T("Windows Media Player is already in use. Stop playing any content and close all Player dialog boxes and then try again."))
      CASE_ERRCODE2(NS_E_WMP_IMAPI_FAILURE                                             , _T("Windows Media Player has encountered an unknown error with your recordable disc."))
      CASE_ERRCODE2(NS_E_WMP_WMDM_FAILURE                                              , _T("Windows Media Player has encountered an unknown error with your portable device.  Reconnect your portable device and try again."))
      CASE_ERRCODE2(NS_E_WMP_CODEC_NEEDED_WITH_4CC                                     , _T("The %s codec is required to play this file. To determine if this codec is available to download from the Web, click Web Help."))
      CASE_ERRCODE2(NS_E_WMP_CODEC_NEEDED_WITH_FORMATTAG                               , _T("The audio codec identified by the format tag %s is required to play this file. To determine if this codec is available to download from the Web, click Web Help."))
      CASE_ERRCODE2(NS_E_WMP_MSSAP_NOT_AVAILABLE                                       , _T("To play this file, you must install the latest Windows XP service pack.  To install the service pack from the Windows Update Web site, click Web Help."))
      CASE_ERRCODE2(NS_E_WMP_WMDM_INTERFACEDEAD                                        , _T("Windows Media Player no longer detects a portable device. Reconnect your portable device, and try again."))
      CASE_ERRCODE2(NS_E_WMP_WMDM_NOTCERTIFIED                                         , _T("Windows Media Player cannot copy the file because the portable device does not support protected files."))
      CASE_ERRCODE2(NS_E_WMP_WMDM_LICENSE_NOTEXIST                                     , _T("Windows Media Player cannot copy the file because a license for this file could not be found on your computer. If you obtained this file from a Web site, return to the site, and try downloading the file again."))
      CASE_ERRCODE2(NS_E_WMP_WMDM_LICENSE_EXPIRED                                      , _T("Windows Media Player cannot copy the file because the license for this file has expired. If you obtained this file from a Web site, return to the site, and try downloading the file again."))
      CASE_ERRCODE2(NS_E_WMP_WMDM_BUSY                                                 , _T("The portable device is already in use. Wait until the current process finishes or quit other programs that may be using the portable device, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_WMDM_NORIGHTS                                             , _T("Windows Media Player cannot copy the file because the license or device restricts it."))
      CASE_ERRCODE2(NS_E_WMP_WMDM_INCORRECT_RIGHTS                                     , _T("Windows Media Player cannot copy the file because the license associated with the file restricts it."))
      CASE_ERRCODE2(NS_E_WMP_IMAPI_GENERIC                                             , _T("Windows Media Player cannot copy files to the recordable disc."))
      CASE_ERRCODE2(NS_E_WMP_IMAPI_DEVICE_NOTPRESENT                                   , _T("Windows Media Player cannot copy files to the recordable disc. Verify that the CD-R or CD-RW drive is connected, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_IMAPI_STASHINUSE                                          , _T("The CD-R or CD-RW drive may already be in use. Wait until the current process finishes or quit other programs that may be using the CD-R or CD-RW drive, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_IMAPI_LOSS_OF_STREAMING                                   , _T("Windows Media Player cannot copy files to the recordable disc."))
      CASE_ERRCODE2(NS_E_WMP_SERVER_UNAVAILABLE                                        , _T("Windows Media Player cannot play the file because the server is busy. Try again later."))
      CASE_ERRCODE2(NS_E_WMP_FILE_OPEN_FAILED                                          , _T("Windows Media Player cannot open the file."))
      CASE_ERRCODE2(NS_E_WMP_VERIFY_ONLINE                                             , _T("To play the file, Windows Media Player must obtain a license from the Internet. Connect to the Internet, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_SERVER_NOT_RESPONDING                                     , _T("Windows Media Player cannot play the file because the server is not responding. If you entered a URL or path to play the file, verify that it is correct. If you clicked a link to play the file, the link may not be valid."))
      CASE_ERRCODE2(NS_E_WMP_DRM_CORRUPT_BACKUP                                        , _T("Windows Media Player cannot restore your licenses because no backed up licenses were found on your computer."))
      CASE_ERRCODE2(NS_E_WMP_DRM_LICENSE_SERVER_UNAVAILABLE                            , _T("To play the file, Windows Media Player must obtain a license from the Internet. However, the license server is currently not available. Try again later."))
      CASE_ERRCODE2(NS_E_WMP_NETWORK_FIREWALL                                          , _T("Windows Media Player cannot play the file. A network firewall may be preventing the Player from opening the file by using the UDP transport protocol. To play this file, try opening the file without specifying UDP."))
      CASE_ERRCODE2(NS_E_WMP_NO_REMOVABLE_MEDIA                                        , _T("Insert the removable media, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_PROXY_CONNECT_TIMEOUT                                     , _T("Windows Media Player cannot play the file because the proxy server is not responding. The proxy server may be temporarily unavailable or your Player proxy settings may not be valid."))
      CASE_ERRCODE2(NS_E_WMP_NEED_UPGRADE                                              , _T("To play this file, you must upgrade to the latest version of Windows Media Player. To upgrade the Player, on the Help menu, click Check For Player Updates, and then follow the instructions."))
      CASE_ERRCODE2(NS_E_WMP_AUDIO_HW_PROBLEM                                          , _T("Windows Media Player cannot play the file because there is a problem with your sound device. There may not be a sound device installed on your computer, it may be in use by another program, or it may not be functioning properly."))
      CASE_ERRCODE2(NS_E_WMP_INVALID_PROTOCOL                                          , _T("Windows Media Player cannot play the file because the specified protocol is not supported. In the Open URL dialog, try opening the file using a different transport protocol (for example, \"http:\")or \"rtsp:\")."))
      CASE_ERRCODE2(NS_E_WMP_INVALID_LIBRARY_ADD                                       , _T("Windows Media Player cannot add the file to Media Library because the file format is not supported."))
      CASE_ERRCODE2(NS_E_WMP_MMS_NOT_SUPPORTED                                         , _T("Windows Media Player cannot play the file because the specified protocol is not supported. In the Open URL dialog, try opening the file using a different transport protocol (for example, \"mms:\")."))
      CASE_ERRCODE2(NS_E_WMP_NO_PROTOCOLS_SELECTED                                     , _T("Windows Media Player cannot play the file because there are no streaming protocols selected. Select one or more protocols, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_GOFULLSCREEN_FAILED                                       , _T("To use the Full Screen command, you may need to adjust your Windows display settings. Open Display in Control Panel, and try setting Hardware acceleration to Full."))
      CASE_ERRCODE2(NS_E_WMP_NETWORK_ERROR                                             , _T("Windows Media Player cannot play the file because a network error occurred."))
      CASE_ERRCODE2(NS_E_WMP_CONNECT_TIMEOUT                                           , _T("Windows Media Player cannot play the file because the server is not responding. Verify that you are connected to the network, and then try again later."))
      CASE_ERRCODE2(NS_E_WMP_MULTICAST_DISABLED                                        , _T("Windows Media Player cannot play the file because the multicast protocol is not enabled. On the Tools menu, click Options, click the Network tab, and then select the Multicast check box."))
      CASE_ERRCODE2(NS_E_WMP_SERVER_DNS_TIMEOUT                                        , _T("Windows Media Player cannot play the file because a network problem occurred. Verify that you are connected to the network, and then try again later."))
      CASE_ERRCODE2(NS_E_WMP_PROXY_NOT_FOUND                                           , _T("Windows Media Player cannot play the file because the network proxy server could not be found. Verify your proxy settings, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_TAMPERED_CONTENT                                          , _T("Windows Media Player cannot play the file because it is damaged or corrupted."))
      CASE_ERRCODE2(NS_E_WMP_OUTOFMEMORY                                               , _T("Your computer is running low on memory. Quit other programs, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_AUDIO_CODEC_NOT_INSTALLED                                 , _T("Windows Media Player cannot play the file because the required audio codec is not installed on your computer."))
      CASE_ERRCODE2(NS_E_WMP_VIDEO_CODEC_NOT_INSTALLED                                 , _T("Windows Media Player cannot play the file because the required video codec is not installed on your computer."))
      CASE_ERRCODE2(NS_E_WMP_IMAPI_DEVICE_INVALIDTYPE                                  , _T("Windows Media Player cannot copy the files to the recordable disc."))
      CASE_ERRCODE2(NS_E_WMP_DRM_DRIVER_AUTH_FAILURE                                   , _T("Windows Media Player cannot play the licensed file because there is a problem with your sound device. Try installing a new device driver or use a different sound device."))
      CASE_ERRCODE2(NS_E_WMP_NETWORK_RESOURCE_FAILURE                                  , _T("Windows Media Player encountered a network problem. Restart the Player."))
      CASE_ERRCODE2(NS_E_WMP_UPGRADE_APPLICATION                                       , _T("Windows Media Player is not installed properly. Reinstall the Player."))
      CASE_ERRCODE2(NS_E_WMP_UNKNOWN_ERROR                                             , _T("Windows Media Player encountered an unknown error."))
      CASE_ERRCODE2(NS_E_WMP_INVALID_KEY                                               , _T("Windows Media Player cannot play the file because the required codec is not valid."))
      CASE_ERRCODE2(NS_E_WMP_CD_ANOTHER_USER                                           , _T("The CD drive is in use by another user. Wait for the operation to complete, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_DRM_NEEDS_AUTHORIZATION                                   , _T("Windows Media Player cannot play the licensed file because the required security upgrade is not available for download."))
      CASE_ERRCODE2(NS_E_WMP_BAD_DRIVER                                                , _T("Windows Media Player cannot play the file because there may be a problem with your sound or video device. Try installing a new device driver."))
      CASE_ERRCODE2(NS_E_WMP_ACCESS_DENIED                                             , _T("Windows Media Player cannot access the file."))
      CASE_ERRCODE2(NS_E_WMP_LICENSE_RESTRICTS                                         , _T("Windows Media Player cannot copy the file to the device because the license restricts it."))
      CASE_ERRCODE2(NS_E_WMP_INVALID_REQUEST                                           , _T("Windows Media Player cannot perform the requested action at this time."))
      CASE_ERRCODE2(NS_E_WMP_CD_STASH_NO_SPACE                                         , _T("Windows Media Player cannot copy the files because there is not enough free disk space to store the temporary files. Delete some unneeded files on your hard disk, and then try again."))
      CASE_ERRCODE2(NS_E_WMP_DRM_NEW_HARDWARE                                          , _T("Windows Media Player cannot play the file because the associated license is either corrupted or not valid. The license may no longer be valid if you have replaced hardware components in your computer."))
      CASE_ERRCODE2(NS_E_WMP_DRM_INVALID_SIG                                           , _T("The required security upgrade cannot be validated. Try installing the latest Internet Explorer service pack. To install the service pack from the Windows Update Web site, click Web Help."))
      CASE_ERRCODE2(NS_E_WMP_DRM_CANNOT_RESTORE                                        , _T("Windows Media Player cannot restore your licenses because you have exceeded the restore limit for the day. Try again tomorrow."))
      CASE_ERRCODE2(NS_E_CD_NO_BUFFERS_READ                                            , _T("Windows Media Player encountered an error when reading the CD-ROM drive in digital mode. You can try to use digital mode again, or you can switch the Player to analog mode."))
      CASE_ERRCODE2(NS_E_CD_EMPTY_TRACK_QUEUE                                          , _T("No CD track was specified for playback."))
      CASE_ERRCODE2(NS_E_CD_NO_READER                                                  , _T("The CD filter was not able to create the CD reader."))
      CASE_ERRCODE2(NS_E_CD_ISRC_INVALID                                               , _T("Invalid ISRC code."))
      CASE_ERRCODE2(NS_E_CD_MEDIA_CATALOG_NUMBER_INVALID                               , _T("Invalid Media Catalog Number."))
      CASE_ERRCODE2(NS_E_SLOW_READ_DIGITAL_WITH_ERRORCORRECTION                        , _T("Media Player has detected that your CD drive cannot play back audio CDs correctly because the drive is too slow with error correction turned on. Please turn off error correction for this drive."))
      CASE_ERRCODE2(NS_E_CD_SPEEDDETECT_NOT_ENOUGH_READS                               , _T("The CD track is too small to make a good estimate of the CD's speed."))
      CASE_ERRCODE2(NS_E_CD_QUEUEING_DISABLED                                          , _T("Cannot queue the given CD track as queuing is disabled."))
      CASE_ERRCODE2(NS_E_WMP_POLICY_VALUE_NOT_CONFIGURED                               , _T("Media Player failed to read a policy. This can happen when the policy is not present in the registry or when there is a failure to read from the registry."))
      CASE_ERRCODE2(NS_E_WMP_HWND_NOTFOUND                                             , _T("Windows Media Player main window not found. The download manager needs to find it to work properly. Please try to run Windows Media Player again."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_WRONG_NO_FILES                                    , _T("Windows media player encountered a download with wrong number of files. This may happen if some other application is trying to create jobs with same signature as Windows Media Player."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_COMPLETECANCELLEDJOB                              , _T("Windows Media Player tried to complete a download that was already cancelled. The file will not be available."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_CANCELCOMPLETEDJOB                                , _T("Windows Media Player tried to cancel a download that was already completed. The file will not be removed."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_NOJOBPOINTER                                      , _T("Windows Media Player is trying to access an invalid download."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_INVALIDJOBSIGNATURE                               , _T("This download was not created by Windows Media Player."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_FAILED_TO_CREATE_TEMPFILE                         , _T("The Windows Media Player download manager failed to create a temporary file name. This may happen if the path in invalid or if the disk is full. Please check your system and try again."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_PLUGIN_FAILEDINITIALIZE                           , _T("The Windows Media Player download manager plugin failed to initialize. This may happen if the system is out of resources. Please check your system and try again."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_PLUGIN_FAILEDTOMOVEFILE                           , _T("The Windows Media Player download manager failed to move the file."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_CALLFUNCFAILED                                    , _T("Download manager failed to accomplish a task. This happened because the system has no resources to allocate."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_CALLFUNCTIMEOUT                                   , _T("The Windows Media Player download manager failed to accomplish a task because the task took too long to execute."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_CALLFUNCENDED                                     , _T("The Windows Media Player download manager failed to accomplish a task because Windows Media Player is terminating the service. The task will be recovered when Windows Media Player starts again."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_WMDUNPACKFAILED                                   , _T("The Windows Media Player download manager failed to unpack a WMD package that was transferred. The file will be deleted and the operation will not be successfully completed."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_FAILEDINITIALIZE                                  , _T("The Windows Media Player download manager failed to initialize. This may happen if the system is out of resources. Please check your system and try again."))
      CASE_ERRCODE2(NS_E_INTERFACE_NOT_REGISTERED_IN_GIT                               , _T("Windows Media Player failed to access a required functionality. This could be caused by wrong system or media player dlls being loaded."))
      CASE_ERRCODE2(NS_E_BKGDOWNLOAD_INVALID_FILE_NAME                                 , _T("Windows Media Player failed to get the file name of the requested download. The requested download will be canceled."))
      CASE_ERRCODE2(NS_E_IMAGE_DOWNLOAD_FAILED                                         , _T("An error was encountered downloading the image."))
      CASE_ERRCODE2(NS_E_WMP_UDRM_NOUSERLIST                                           , _T("There was a problem while trying to get the list of activated users for this machine. The License acquisition process will be stopped."))
      CASE_ERRCODE2(NS_E_WMP_DRM_NOT_ACQUIRING                                         , _T("The Windows Media Player is trying to acquire a license for a file that is not being used anymore. The License acquisition process will stop."))
      CASE_ERRCODE2(NS_E_WMP_BSTR_TOO_LONG                                             , _T("The parameter is invalid."))
      CASE_ERRCODE2(NS_E_WMP_AUTOPLAY_INVALID_STATE                                    , _T("Invalid state for this request."))
      CASE_ERRCODE2(NS_E_CURL_NOTSAFE                                                  , _T("The URL is not safe for the operation specified."))
      CASE_ERRCODE2(NS_E_CURL_INVALIDCHAR                                              , _T("The URL contains one or more invalid characters."))
      CASE_ERRCODE2(NS_E_CURL_INVALIDHOSTNAME                                          , _T("The URL contains an invalid hostname."))
      CASE_ERRCODE2(NS_E_CURL_INVALIDPATH                                              , _T("The URL contains an invalid path."))
      CASE_ERRCODE2(NS_E_CURL_INVALIDSCHEME                                            , _T("The URL contains an invalid scheme."))
      CASE_ERRCODE2(NS_E_CURL_INVALIDURL                                               , _T("The URL is invalid."))
      CASE_ERRCODE2(NS_E_CURL_CANTWALK                                                 , _T("The URL would change the root."))
      CASE_ERRCODE2(NS_E_CURL_INVALIDPORT                                              , _T("The URL port is invalid."))
      CASE_ERRCODE2(NS_E_CURLHELPER_NOTADIRECTORY                                      , _T("The URL is not a directory."))
      CASE_ERRCODE2(NS_E_CURLHELPER_NOTAFILE                                           , _T("The URL is not a file."))
      CASE_ERRCODE2(NS_E_CURL_CANTDECODE                                               , _T("The URL contains characters that could not be decoded.  The URL may be truncated or incomplete."))
      CASE_ERRCODE2(NS_E_CURLHELPER_NOTRELATIVE                                        , _T("The specified relative URL is actually not a relative URL."))
      CASE_ERRCODE2(NS_E_CURL_INVALIDBUFFERSIZE                                        , _T("The buffer is smaller than the size specified."))
      CASE_ERRCODE2(NS_E_SUBSCRIPTIONSERVICE_PLAYBACK_DISALLOWED                       , _T("This content is provided by a music service. The content cannot be played, possibly because a valid license does not exist. Please contact the music service with questions."))
      CASE_ERRCODE2(NS_E_ADVANCEDEDIT_TOO_MANY_PICTURES                                , _T("Not all your images were saved to the file. Only 7MB of images may be saved to a media file."))
      CASE_ERRCODE2(NS_E_REDIRECT                                                      , _T("The client redirected to another server."))
      CASE_ERRCODE2(NS_E_STALE_PRESENTATION                                            , _T("The streaming media description is no longer current."))
      CASE_ERRCODE2(NS_E_NAMESPACE_WRONG_PERSIST                                       , _T("It is not possible to create a persistent namespace node under a transient parent node."))
      CASE_ERRCODE2(NS_E_NAMESPACE_WRONG_TYPE                                          , _T("It is not possible to store a value in a namespace node that has a different value type."))
      CASE_ERRCODE2(NS_E_NAMESPACE_NODE_CONFLICT                                       , _T("It is not possible to remove the root namespace node."))
      CASE_ERRCODE2(NS_E_NAMESPACE_NODE_NOT_FOUND                                      , _T("The specified namespace node could not be found."))
      CASE_ERRCODE2(NS_E_NAMESPACE_BUFFER_TOO_SMALL                                    , _T("The buffer supplied to hold namespace node string is too small."))
      CASE_ERRCODE2(NS_E_NAMESPACE_TOO_MANY_CALLBACKS                                  , _T("The callback list on a namespace node is at the maximum size."))
      CASE_ERRCODE2(NS_E_NAMESPACE_DUPLICATE_CALLBACK                                  , _T("It is not possible to register an already-registered callback on a namespace node."))
      CASE_ERRCODE2(NS_E_NAMESPACE_CALLBACK_NOT_FOUND                                  , _T("Cannot find the callback in the namespace when attempting to remove the callback."))
      CASE_ERRCODE2(NS_E_NAMESPACE_NAME_TOO_LONG                                       , _T("The namespace node name exceeds the allowed maximum length."))
      CASE_ERRCODE2(NS_E_NAMESPACE_DUPLICATE_NAME                                      , _T("Cannot create a namespace node that already exists."))
      CASE_ERRCODE2(NS_E_NAMESPACE_EMPTY_NAME                                          , _T("The namespace node name cannot be a null string."))
      CASE_ERRCODE2(NS_E_NAMESPACE_INDEX_TOO_LARGE                                     , _T("Finding a child namespace node by index failed because the index exceeded the number of children."))
      CASE_ERRCODE2(NS_E_NAMESPACE_BAD_NAME                                            , _T("The namespace node name is invalid."))
      CASE_ERRCODE2(NS_E_NAMESPACE_WRONG_SECURITY                                      , _T("It is not possible to store a value in a namespace node that has a different security type."))
      CASE_ERRCODE2(NS_E_CACHE_ARCHIVE_CONFLICT                                        , _T("The archive request conflicts with other requests in progress."))
      CASE_ERRCODE2(NS_E_CACHE_ORIGIN_SERVER_NOT_FOUND                                 , _T("The specified origin server cannot be found."))
      CASE_ERRCODE2(NS_E_CACHE_ORIGIN_SERVER_TIMEOUT                                   , _T("The specified origin server is not responding."))
      CASE_ERRCODE2(NS_E_CACHE_NOT_BROADCAST                                           , _T("The internal code for HTTP status code 412 Precondition Failed due to not broadcast type."))
      CASE_ERRCODE2(NS_E_CACHE_CANNOT_BE_CACHED                                        , _T("The internal code for HTTP status code 403 Forbidden due to not cacheable."))
      CASE_ERRCODE2(NS_E_CACHE_NOT_MODIFIED                                            , _T("The internal code for HTTP status code 304 Not Modified."))
      CASE_ERRCODE2(NS_E_CANNOT_REMOVE_PUBLISHING_POINT                                , _T("It is not possible to remove a cache or proxy publishing point."))
      CASE_ERRCODE2(NS_E_CANNOT_REMOVE_PLUGIN                                          , _T("It is not possible to remove the last instance of a type of plug-in."))
      CASE_ERRCODE2(NS_E_WRONG_PUBLISHING_POINT_TYPE                                   , _T("Cache and proxy publishing points do not support this property or method."))
      CASE_ERRCODE2(NS_E_UNSUPPORTED_LOAD_TYPE                                         , _T("The plug-in does not support the specified load type."))
      CASE_ERRCODE2(NS_E_INVALID_PLUGIN_LOAD_TYPE_CONFIGURATION                        , _T("The plug-in does not support any load types. The plug-in must support at least one load type."))
      CASE_ERRCODE2(NS_E_INVALID_PUBLISHING_POINT_NAME                                 , _T("The publishing point name is invalid."))
      CASE_ERRCODE2(NS_E_TOO_MANY_MULTICAST_SINKS                                      , _T("Only one multicast data writer plug-in can be enabled for a publishing point."))
      CASE_ERRCODE2(NS_E_PUBLISHING_POINT_INVALID_REQUEST_WHILE_STARTED                , _T("The requested operation cannot be completed while the publishing point is started."))
      CASE_ERRCODE2(NS_E_MULTICAST_PLUGIN_NOT_ENABLED                                  , _T("A multicast data writer plug-in must be enabled in order for this operation to be completed."))
      CASE_ERRCODE2(NS_E_INVALID_OPERATING_SYSTEM_VERSION                              , _T("This feature requires WIndows Server 2003, Enterprise Edition."))
      CASE_ERRCODE2(NS_E_PUBLISHING_POINT_REMOVED                                      , _T("The requested operation cannot be completed because the specified publishing point has been removed."))
      CASE_ERRCODE2(NS_E_INVALID_PUSH_PUBLISHING_POINT_START_REQUEST                   , _T("Push publishing points are started when the encoder starts pushing the stream. This publishing point cannot be started by the server administrator."))
      CASE_ERRCODE2(NS_E_UNSUPPORTED_LANGUAGE                                          , _T("The specified language is not supported."))
      CASE_ERRCODE2(NS_E_WRONG_OS_VERSION                                              , _T("Windows Media Services will only run on Windows Server 2003, Standard Edition and Windows Server 2003, Enterprise Edition."))
      CASE_ERRCODE2(NS_E_PUBLISHING_POINT_STOPPED                                      , _T("The operation cannot be completed because the publishing point has been stopped."))
      CASE_ERRCODE2(NS_E_PLAYLIST_ENTRY_ALREADY_PLAYING                                , _T("The playlist entry is already playing."))
      CASE_ERRCODE2(NS_E_EMPTY_PLAYLIST                                                , _T("The playlist or directory you are requesting does not contain content."))
      CASE_ERRCODE2(NS_E_PLAYLIST_PARSE_FAILURE                                        , _T("The server was unable to parse the requested playlist file."))
      CASE_ERRCODE2(NS_E_PLAYLIST_UNSUPPORTED_ENTRY                                    , _T("The requested operation is not supported for this type of playlist entry."))
      CASE_ERRCODE2(NS_E_PLAYLIST_ENTRY_NOT_IN_PLAYLIST                                , _T("Cannot jump to a playlist entry that is not inserted in the playlist."))
      CASE_ERRCODE2(NS_E_PLAYLIST_ENTRY_SEEK                                           , _T("Cannot seek to the desired playlist entry."))
      CASE_ERRCODE2(NS_E_PLAYLIST_RECURSIVE_PLAYLISTS                                  , _T("Cannot play recursive playlist."))
      CASE_ERRCODE2(NS_E_PLAYLIST_TOO_MANY_NESTED_PLAYLISTS                            , _T("The number of nested playlists exceeded the limit the server can handle."))
      CASE_ERRCODE2(NS_E_PLAYLIST_SHUTDOWN                                             , _T("Cannot execute the requested operation because the playlist has been shut down by the Media Server."))
      CASE_ERRCODE2(NS_E_PLAYLIST_END_RECEDING                                         , _T("The playlist has ended while receding."))
      CASE_ERRCODE2(NS_I_PLAYLIST_CHANGE_RECEDING                                      , _T("The playlist change occurred while receding."))
      CASE_ERRCODE2(NS_E_DATAPATH_NO_SINK                                              , _T("The data path does not have an associated data writer plug-in."))
      CASE_ERRCODE2(NS_S_PUBLISHING_POINT_STARTED_WITH_FAILED_SINKS                    , _T("The publishing point successfully started, but one or more of the requested data writer plug-ins failed."))
      CASE_ERRCODE2(NS_E_INVALID_PUSH_TEMPLATE                                         , _T("The specified push template is invalid."))
      CASE_ERRCODE2(NS_E_INVALID_PUSH_PUBLISHING_POINT                                 , _T("The specified push publishing point is invalid."))
      CASE_ERRCODE2(NS_E_CRITICAL_ERROR                                                , _T("The requested operation cannot be performed because the server or publishing point is in a critical error state."))
      CASE_ERRCODE2(NS_E_NO_NEW_CONNECTIONS                                            , _T("The content can not be played because the server is not currently accepting connections. Try connecting at a later time."))
      CASE_ERRCODE2(NS_E_WSX_INVALID_VERSION                                           , _T("The version of this playlist is not supported by the server."))
      CASE_ERRCODE2(NS_E_HEADER_MISMATCH                                               , _T("The command does not apply to the current media header user by a server component."))
      CASE_ERRCODE2(NS_E_PUSH_DUPLICATE_PUBLISHING_POINT_NAME                          , _T("The specified publishing point name is already in use."))
      CASE_ERRCODE2(NS_E_NO_SCRIPT_ENGINE                                              , _T("There is no script engine available for this file."))
      CASE_ERRCODE2(NS_E_PLUGIN_ERROR_REPORTED                                         , _T("The plug-in has reported an error. See the Troubleshooting tab or the NT Application Event Log for details."))
      CASE_ERRCODE2(NS_E_SOURCE_PLUGIN_NOT_FOUND                                       , _T("No enabled data source plug-in is available to access the requested content."))
      CASE_ERRCODE2(NS_E_PLAYLIST_PLUGIN_NOT_FOUND                                     , _T("No enabled playlist parser plug-in is available to access the requested content."))
      CASE_ERRCODE2(NS_E_DATA_SOURCE_ENUMERATION_NOT_SUPPORTED                         , _T("The data source plug-in does not support enumeration."))
      CASE_ERRCODE2(NS_E_MEDIA_PARSER_INVALID_FORMAT                                   , _T("The server cannot stream the selected file because it is either damaged or corrupt. Select a different file."))
      CASE_ERRCODE2(NS_E_SCRIPT_DEBUGGER_NOT_INSTALLED                                 , _T("The plug-in cannot be enabled because a compatible script debugger is not installed on this system.  Install a script debugger, or disable the script debugger option on the general tab of the plug-in's properties page and try again."))
      CASE_ERRCODE2(NS_E_FEATURE_REQUIRES_ENTERPRISE_SERVER                            , _T("The plug-in cannot be loaded because it requires Windows Server 2003, Enterprise Edition."))
      CASE_ERRCODE2(NS_E_WIZARD_RUNNING                                                , _T("Another wizard is currently running. Please close the other wizard or wait until it finishes before attempting to run this wizard again."))
      CASE_ERRCODE2(NS_E_INVALID_LOG_URL                                               , _T("Invalid log URL. Multicast logging URL must look like \"http://servername/isapibackend.dll\")."))
      CASE_ERRCODE2(NS_E_INVALID_MTU_RANGE                                             , _T("Invalid MTU specified. The valid range for maximum packet size is between 36  and 65507 bytes ."))
      CASE_ERRCODE2(NS_E_INVALID_PLAY_STATISTICS                                       , _T("Invalid play statistics for logging ."))
      CASE_ERRCODE2(NS_E_LOG_NEED_TO_BE_SKIPPED                                        , _T("The log needs to be skipped ."))
      CASE_ERRCODE2(NS_E_HTTP_TEXT_DATACONTAINER_SIZE_LIMIT_EXCEEDED                   , _T("The size of the data exceeded the limit the WMS HTTP Download Data Source plugin can handle."))
      CASE_ERRCODE2(NS_E_PORT_IN_USE                                                   , _T("One usage of each socket address (protocol/network address/port) is permitted. Verify that other services or applications are not attempting to use the same port and then try to enable the plug-in again."))
      CASE_ERRCODE2(NS_E_PORT_IN_USE_HTTP                                              , _T("One usage of each socket address (protocol/network address/port) is permitted. Verify that other services (such as IIS) or applications are not attempting to use the same port and then try to enable the plug-in again."))
      CASE_ERRCODE2(NS_E_HTTP_TEXT_DATACONTAINER_INVALID_SERVER_RESPONSE               , _T("The WMS HTTP Download Data Source plugin was unable to receive the remote server's response."))
      CASE_ERRCODE2(NS_E_ARCHIVE_REACH_QUOTA                                           , _T("The archive plug-in has reached its quota."))
      CASE_ERRCODE2(NS_E_ARCHIVE_ABORT_DUE_TO_BCAST                                    , _T("The archive plug-in aborted because the source was from broadcast."))
      CASE_ERRCODE2(NS_E_ARCHIVE_GAP_DETECTED                                          , _T("The archive plug-in detected an interrupt in the source."))
      CASE_ERRCODE2(NS_E_AUTHORIZATION_FILE_NOT_FOUND                                  , _T("The system cannot find the file specified."))
      CASE_ERRCODE2(NS_E_BAD_MARKIN                                                    , _T("The mark-in time should be greater than 0 and less than the mark-out time."))
      CASE_ERRCODE2(NS_E_BAD_MARKOUT                                                   , _T("The mark-out time should be greater than the mark-in time and less than the file duration."))
      CASE_ERRCODE2(NS_E_NOMATCHING_MEDIASOURCE                                        , _T("No matching media type is found in the source %1(tiger disk ID)."))
      CASE_ERRCODE2(NS_E_UNSUPPORTED_SOURCETYPE                                        , _T("The specified source type is not supported."))
      CASE_ERRCODE2(NS_E_TOO_MANY_AUDIO                                                , _T("It is not possible to specify more than one audio input."))
      CASE_ERRCODE2(NS_E_TOO_MANY_VIDEO                                                , _T("It is not possible to specify more than two video inputs."))
      CASE_ERRCODE2(NS_E_NOMATCHING_ELEMENT                                            , _T("No matching element is found in the list."))
      CASE_ERRCODE2(NS_E_MISMATCHED_MEDIACONTENT                                       , _T("The profile's media types must match the media types defined for the session."))
      CASE_ERRCODE2(NS_E_CANNOT_DELETE_ACTIVE_SOURCEGROUP                              , _T("It is not possible to remove an active source while encoding."))
      CASE_ERRCODE2(NS_E_AUDIODEVICE_BUSY                                              , _T("It is not possible to open the specified audio capture device because it is currently in use."))
      CASE_ERRCODE2(NS_E_AUDIODEVICE_UNEXPECTED                                        , _T("It is not possible to open the specified audio capture device because an unexpected error has occurred."))
      CASE_ERRCODE2(NS_E_AUDIODEVICE_BADFORMAT                                         , _T("The audio capture device does not support the specified audio format."))
      CASE_ERRCODE2(NS_E_VIDEODEVICE_BUSY                                              , _T("It is not possible to open the specified video capture device because it is currently in use."))
      CASE_ERRCODE2(NS_E_VIDEODEVICE_UNEXPECTED                                        , _T("It is not possible to open the specified video capture device because an unexpected error has occurred."))
      CASE_ERRCODE2(NS_E_INVALIDCALL_WHILE_ENCODER_RUNNING                             , _T("This operation is not allowed while encoding."))
      CASE_ERRCODE2(NS_E_NO_PROFILE_IN_SOURCEGROUP                                     , _T("No profile is set for the source."))
      CASE_ERRCODE2(NS_E_VIDEODRIVER_UNSTABLE                                          , _T("The video capture driver returned an unrecoverable error.  It is now in an unstable state."))
      CASE_ERRCODE2(NS_E_VIDCAPSTARTFAILED                                             , _T("It was not possible to start the video device."))
      CASE_ERRCODE2(NS_E_VIDSOURCECOMPRESSION                                          , _T("The video source does not support the requested output format or color depth."))
      CASE_ERRCODE2(NS_E_VIDSOURCESIZE                                                 , _T("The video source does not support the requested capture size."))
      CASE_ERRCODE2(NS_E_ICMQUERYFORMAT                                                , _T("It was not possible to obtain output information from the video compressor."))
      CASE_ERRCODE2(NS_E_VIDCAPCREATEWINDOW                                            , _T("It was not possible to create a video capture window."))
      CASE_ERRCODE2(NS_E_VIDCAPDRVINUSE                                                , _T("There is already a stream active on this video device."))
      CASE_ERRCODE2(NS_E_NO_MEDIAFORMAT_IN_SOURCE                                      , _T("No media format is set in source."))
      CASE_ERRCODE2(NS_E_NO_VALID_OUTPUT_STREAM                                        , _T("Cannot find a valid output stream from the source."))
      CASE_ERRCODE2(NS_E_NO_VALID_SOURCE_PLUGIN                                        , _T("It was not possible to find a valid source plug-in for the specified source."))
      CASE_ERRCODE2(NS_E_NO_ACTIVE_SOURCEGROUP                                         , _T("No source is currently active."))
      CASE_ERRCODE2(NS_E_NO_SCRIPT_STREAM                                              , _T("No script stream is set in the current source."))
      CASE_ERRCODE2(NS_E_INVALIDCALL_WHILE_ARCHIVAL_RUNNING                            , _T("This operation is not allowed while archiving."))
      CASE_ERRCODE2(NS_E_INVALIDPACKETSIZE                                             , _T("The setting for the maximum packet size is not valid."))
      CASE_ERRCODE2(NS_E_PLUGIN_CLSID_INVALID                                          , _T("The plug-in CLSID specified is not valid."))
      CASE_ERRCODE2(NS_E_UNSUPPORTED_ARCHIVETYPE                                       , _T("This archive type is not supported."))
      CASE_ERRCODE2(NS_E_UNSUPPORTED_ARCHIVEOPERATION                                  , _T("This archive operation is not supported."))
      CASE_ERRCODE2(NS_E_ARCHIVE_FILENAME_NOTSET                                       , _T("The local archive file name was not set."))
      CASE_ERRCODE2(NS_E_SOURCEGROUP_NOTPREPARED                                       , _T("The source is not yet prepared."))
      CASE_ERRCODE2(NS_E_PROFILE_MISMATCH                                              , _T("Profiles on the sources do not match."))
      CASE_ERRCODE2(NS_E_INCORRECTCLIPSETTINGS                                         , _T("The specified crop values are not valid."))
      CASE_ERRCODE2(NS_E_NOSTATSAVAILABLE                                              , _T("No statistics are available at this time."))
      CASE_ERRCODE2(NS_E_NOTARCHIVING                                                  , _T("The encoder is not archiving."))
      CASE_ERRCODE2(NS_E_INVALIDCALL_WHILE_ENCODER_STOPPED                             , _T("This operation is only allowed during encoding."))
      CASE_ERRCODE2(NS_E_NOSOURCEGROUPS                                                , _T("This SourceGroupCollection doesn't contain any SourceGroups."))
      CASE_ERRCODE2(NS_E_INVALIDINPUTFPS                                               , _T("This source does not have a frame rate of 30 fps. Therefore, it is not possible to apply the inverse telecine filter to the source."))
      CASE_ERRCODE2(NS_E_NO_DATAVIEW_SUPPORT                                           , _T("It is not possible to display your source or output video in the Video panel."))
      CASE_ERRCODE2(NS_E_CODEC_UNAVAILABLE                                             , _T("One or more codecs required to open this content could not be found."))
      CASE_ERRCODE2(NS_E_ARCHIVE_SAME_AS_INPUT                                         , _T("The archive file has the same name as an input file. Change one of the names before continuing."))
      CASE_ERRCODE2(NS_E_SOURCE_NOTSPECIFIED                                           , _T("The source has not been set up completely."))
      CASE_ERRCODE2(NS_E_NO_REALTIME_TIMECOMPRESSION                                   , _T("It is not possible to apply time compression to a broadcast session."))
      CASE_ERRCODE2(NS_E_UNSUPPORTED_ENCODER_DEVICE                                    , _T("It is not possible to open this device."))
      CASE_ERRCODE2(NS_E_UNEXPECTED_DISPLAY_SETTINGS                                   , _T("It is not possible to start encoding because the display size or color has changed since the current session was defined. Restore the previous settings or create a new session."))
      CASE_ERRCODE2(NS_E_NO_AUDIODATA                                                  , _T("No audio data has been received for several seconds. Check the audio source and restart the encoder."))
      CASE_ERRCODE2(NS_E_INPUTSOURCE_PROBLEM                                           , _T("One or all of the specified sources are not working properly. Check that the sources are configured correctly."))
      CASE_ERRCODE2(NS_E_WME_VERSION_MISMATCH                                          , _T("The supplied configuration file is not supported by this version of the encoder."))
      CASE_ERRCODE2(NS_E_NO_REALTIME_PREPROCESS                                        , _T("It is not possible to use image preprocessing with live encoding."))
      CASE_ERRCODE2(NS_E_NO_REPEAT_PREPROCESS                                          , _T("It is not possible to use two-pass encoding when the source is set to loop."))
      CASE_ERRCODE2(NS_E_CANNOT_PAUSE_LIVEBROADCAST                                    , _T("It is not possible to pause encoding during a broadcast."))
      CASE_ERRCODE2(NS_E_DRM_PROFILE_NOT_SET                                           , _T("A DRM profile has not been set for the current session."))
      CASE_ERRCODE2(NS_E_DUPLICATE_DRMPROFILE                                          , _T("The profile ID is already used by a DRM profile. Specify a different profile ID."))
      CASE_ERRCODE2(NS_E_INVALID_DEVICE                                                , _T("The setting of the selected device does not support control for playing back tapes."))
      CASE_ERRCODE2(NS_E_SPEECHEDL_ON_NON_MIXEDMODE                                    , _T("You must specify a mixed voice and audio mode in order to use an optimization definition file."))
      CASE_ERRCODE2(NS_E_DRM_PASSWORD_TOO_LONG                                         , _T("The specified password is too long. Type a password with fewer than 8 characters."))
      CASE_ERRCODE2(NS_E_DEVCONTROL_FAILED_SEEK                                        , _T("It is not possible to seek to the specified mark-in point."))
      CASE_ERRCODE2(NS_E_INTERLACE_REQUIRE_SAMESIZE                                    , _T("When you choose to maintain the interlacing in your video, the output video size must match the input video size."))
      CASE_ERRCODE2(NS_E_TOO_MANY_DEVICECONTROL                                        , _T("Only one device control plug-in can control a device."))
      CASE_ERRCODE2(NS_E_NO_MULTIPASS_FOR_LIVEDEVICE                                   , _T("You must also enable storing content to hard disk temporarily in order to use two-pass encoding with the input device."))
      CASE_ERRCODE2(NS_E_MISSING_AUDIENCE                                              , _T("An audience is missing from the output stream configuration."))
      CASE_ERRCODE2(NS_E_AUDIENCE_CONTENTTYPE_MISMATCH                                 , _T("All audiences in the output tree must have the same content type."))
      CASE_ERRCODE2(NS_E_MISSING_SOURCE_INDEX                                          , _T("A source index is missing from the output stream configuration."))
      CASE_ERRCODE2(NS_E_NUM_LANGUAGE_MISMATCH                                         , _T("The same source index in different audiences should have the same number of languages."))
      CASE_ERRCODE2(NS_E_LANGUAGE_MISMATCH                                             , _T("The same source index in different audiences should have the same languages."))
      CASE_ERRCODE2(NS_E_VBRMODE_MISMATCH                                              , _T("The same source index in different audiences should use the same VBR encoding mode."))
      CASE_ERRCODE2(NS_E_INVALID_INPUT_AUDIENCE_INDEX                                  , _T("The bit rate index specified is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_INPUT_LANGUAGE                                        , _T("The specified language is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_INPUT_STREAM                                          , _T("The specified source type is not valid."))
      CASE_ERRCODE2(NS_E_EXPECT_MONO_WAV_INPUT                                         , _T("The source must be a mono channel .wav file."))
      CASE_ERRCODE2(NS_E_INPUT_WAVFORMAT_MISMATCH                                      , _T("All the source .wav files must have the same format."))
      CASE_ERRCODE2(NS_E_RECORDQ_DISK_FULL                                             , _T("The hard disk being used for temporary storage of content has reached the minimum allowed disk space. Create more space on the hard disk and restart encoding."))
      CASE_ERRCODE2(NS_E_NO_PAL_INVERSE_TELECINE                                       , _T("It is not possible to apply the inverse telecine feature to PAL content."))
      CASE_ERRCODE2(NS_E_ACTIVE_SG_DEVICE_DISCONNECTED                                 , _T("A capture device in the current active source is no longer available."))
      CASE_ERRCODE2(NS_E_ACTIVE_SG_DEVICE_CONTROL_DISCONNECTED                         , _T("A device used in the current active source for device control is no longer available."))
      CASE_ERRCODE2(NS_E_NO_FRAMES_SUBMITTED_TO_ANALYZER                               , _T("No frames have been submitted to the analyzer for analysis."))
      CASE_ERRCODE2(NS_E_INPUT_DOESNOT_SUPPORT_SMPTE                                   , _T("The source video does not support time codes."))
      CASE_ERRCODE2(NS_E_NO_SMPTE_WITH_MULTIPLE_SOURCEGROUPS                           , _T("It is not possible to generate a time code when there are multiple sources in a session."))
      CASE_ERRCODE2(NS_E_BAD_CONTENTEDL                                                , _T("The voice codec optimization definition file can not be found or is corrupted."))
      CASE_ERRCODE2(NS_E_INTERLACEMODE_MISMATCH                                        , _T("The same source index in different audiences should have the same interlace mode."))
      CASE_ERRCODE2(NS_E_NONSQUAREPIXELMODE_MISMATCH                                   , _T("The same source index in different audiences should have the same nonsquare pixel mode."))
      CASE_ERRCODE2(NS_E_SMPTEMODE_MISMATCH                                            , _T("The same source index in different audiences should have the same time code mode."))
      CASE_ERRCODE2(NS_E_END_OF_TAPE                                                   , _T("Either the end of the tape has been reached or there is no tape. Check the device and tape."))
      CASE_ERRCODE2(NS_E_NO_MEDIA_IN_AUDIENCE                                          , _T("No audio or video input has been specified."))
      CASE_ERRCODE2(NS_E_NO_AUDIENCES                                                  , _T("The profile must contain a bit rate."))
      CASE_ERRCODE2(NS_E_NO_AUDIO_COMPAT                                               , _T("You must specify at least one audio stream to be compatible with Windows Media Player 7.1."))
      CASE_ERRCODE2(NS_E_INVALID_VBR_COMPAT                                            , _T("Using a VBR encoding mode is not compatible with Windows Media Player 7.1."))
      CASE_ERRCODE2(NS_E_NO_PROFILE_NAME                                               , _T("You must specify a profile name."))
      CASE_ERRCODE2(NS_E_INVALID_VBR_WITH_UNCOMP                                       , _T("It is not possible to use a VBR encoding mode with uncompressed audio or video."))
      CASE_ERRCODE2(NS_E_MULTIPLE_VBR_AUDIENCES                                        , _T("It is not possible to use MBR encoding with VBR encoding."))
      CASE_ERRCODE2(NS_E_UNCOMP_COMP_COMBINATION                                       , _T("It is not possible to mix uncompressed and compressed content in a session."))
      CASE_ERRCODE2(NS_E_MULTIPLE_AUDIO_CODECS                                         , _T("All audiences must use the same audio codec."))
      CASE_ERRCODE2(NS_E_MULTIPLE_AUDIO_FORMATS                                        , _T("All audiences should use the same audio format to be compatible with Windows Media Player 7.1."))
      CASE_ERRCODE2(NS_E_AUDIO_BITRATE_STEPDOWN                                        , _T("The audio bit rate for an audience with a higher total bit rate must be greater than one with a lower total bit rate."))
      CASE_ERRCODE2(NS_E_INVALID_AUDIO_PEAKRATE                                        , _T("The audio peak bit rate setting is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_AUDIO_PEAKRATE_2                                      , _T("The audio peak bit rate setting must be greater than the audio bit rate setting."))
      CASE_ERRCODE2(NS_E_INVALID_AUDIO_BUFFERMAX                                       , _T("The setting for the maximum buffer size for audio is not valid."))
      CASE_ERRCODE2(NS_E_MULTIPLE_VIDEO_CODECS                                         , _T("All audiences must use the same video codec."))
      CASE_ERRCODE2(NS_E_MULTIPLE_VIDEO_SIZES                                          , _T("All audiences should use the same video size to be compatible with Windows Media Player 7.1."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_BITRATE                                         , _T("The video bit rate setting is not valid."))
      CASE_ERRCODE2(NS_E_VIDEO_BITRATE_STEPDOWN                                        , _T("The video bit rate for an audience with a higher total bit rate must be greater than one with a lower total bit rate."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_PEAKRATE                                        , _T("The video peak bit rate setting is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_PEAKRATE_2                                      , _T("The video peak bit rate setting must be greater than the video bit rate setting."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_WIDTH                                           , _T("The video width setting is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_HEIGHT                                          , _T("The video height setting is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_FPS                                             , _T("The video frame rate setting is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_KEYFRAME                                        , _T("The video key frame setting is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_IQUALITY                                        , _T("The video image quality setting is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_CQUALITY                                        , _T("The video codec quality setting is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_BUFFER                                          , _T("The video buffer setting is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_BUFFERMAX                                       , _T("The setting for the maximum buffer size for video is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_BUFFERMAX_2                                     , _T("The value of the video maximum buffer size setting must be greater than the video buffer size setting."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_WIDTH_ALIGN                                     , _T("The alignment of the video width is not valid."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_HEIGHT_ALIGN                                    , _T("The alignment of the video height is not valid."))
      CASE_ERRCODE2(NS_E_MULTIPLE_SCRIPT_BITRATES                                      , _T("All bit rates must have the same script bit rate."))
      CASE_ERRCODE2(NS_E_INVALID_SCRIPT_BITRATE                                        , _T("The script bit rate specified is not valid."))
      CASE_ERRCODE2(NS_E_MULTIPLE_FILE_BITRATES                                        , _T("All bit rates must have the same file transfer bit rate."))
      CASE_ERRCODE2(NS_E_INVALID_FILE_BITRATE                                          , _T("The file transfer bit rate is not valid."))
      CASE_ERRCODE2(NS_E_SAME_AS_INPUT_COMBINATION                                     , _T("All audiences in a profile should either be same as input or have video width and height specified."))
      CASE_ERRCODE2(NS_E_SOURCE_CANNOT_LOOP                                            , _T("This source type does not support looping."))
      CASE_ERRCODE2(NS_E_INVALID_FOLDDOWN_COEFFICIENTS                                 , _T("The fold-down value needs to be between -144 and 0."))
      CASE_ERRCODE2(NS_E_DRMPROFILE_NOTFOUND                                           , _T("The specified DRM profile does not exist in the system."))
      CASE_ERRCODE2(NS_E_INVALID_TIMECODE                                              , _T("The specified time code is not valid."))
      CASE_ERRCODE2(NS_E_NO_AUDIO_TIMECOMPRESSION                                      , _T("It is not possible to apply time compression to a video-only session."))
      CASE_ERRCODE2(NS_E_NO_TWOPASS_TIMECOMPRESSION                                    , _T("It is not possible to apply time compression to a session that is using two-pass encoding."))
      CASE_ERRCODE2(NS_E_TIMECODE_REQUIRES_VIDEOSTREAM                                 , _T("It is not possible to generate a time code for an audio-only session."))
      CASE_ERRCODE2(NS_E_NO_MBR_WITH_TIMECODE                                          , _T("It is not possible to generate a time code when you are encoding content at multiple bit rates."))
      CASE_ERRCODE2(NS_E_INVALID_INTERLACEMODE                                         , _T("The video codec selected does not support maintaining interlacing in video."))
      CASE_ERRCODE2(NS_E_INVALID_INTERLACE_COMPAT                                      , _T("Maintaining interlacing in video is not compatible with Windows Media Player 7.1."))
      CASE_ERRCODE2(NS_E_INVALID_NONSQUAREPIXEL_COMPAT                                 , _T("Allowing nonsquare pixel output is not compatible with Windows Media Player 7.1."))
      CASE_ERRCODE2(NS_E_INVALID_SOURCE_WITH_DEVICE_CONTROL                            , _T("Only capture devices can be used with device control."))
      CASE_ERRCODE2(NS_E_CANNOT_GENERATE_BROADCAST_INFO_FOR_QUALITYVBR                 , _T("It is not possible to generate the stream format file if you are using quality-based VBR encoding for the audio or video stream. Instead use the Windows Media file generated after encoding to create the announcement file."))
      CASE_ERRCODE2(NS_E_EXCEED_MAX_DRM_PROFILE_LIMIT                                  , _T("It is not possible to create a DRM profile because the maximum number of profiles has been reached. You must delete some DRM profiles before creating new ones."))
      CASE_ERRCODE2(NS_E_DEVICECONTROL_UNSTABLE                                        , _T("The device is in an unstable state. Check that the device is functioning properly and a tape is in place."))
      CASE_ERRCODE2(NS_E_INVALID_PIXEL_ASPECT_RATIO                                    , _T("The pixel aspect ratio value must be between 1 and 255."))
      CASE_ERRCODE2(NS_E_AUDIENCE__LANGUAGE_CONTENTTYPE_MISMATCH                       , _T("All streams with different languages in the same audience must have same properties."))
      CASE_ERRCODE2(NS_E_INVALID_PROFILE_CONTENTTYPE                                   , _T("The profile must contain at least one audio or video stream."))
      CASE_ERRCODE2(NS_E_TRANSFORM_PLUGIN_NOT_FOUND                                    , _T("The transform plug-in could not be found."))
      CASE_ERRCODE2(NS_E_TRANSFORM_PLUGIN_INVALID                                      , _T("The transform plug-in is not valid. It may be damaged or you may not have the required permissions to access the plug-in."))
      CASE_ERRCODE2(NS_E_EDL_REQUIRED_FOR_DEVICE_MULTIPASS                             , _T("To use two-pass encoding, you must enable device control and setup an edit decision list (EDL) that has at least one entry."))
      CASE_ERRCODE2(NS_E_INVALID_VIDEO_WIDTH_FOR_INTERLACED_ENCODING                   , _T("When you choose to maintain the interlacing in your video, the output video size must be a multiple of 4."))
      CASE_ERRCODE2(NS_E_DRM_INVALID_APPLICATION                                       , _T("A problem has occurred in the Digital Rights Management component. Contact product support for this application."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_STORE_ERROR                                       , _T("License storage is not working. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_SECURE_STORE_ERROR                                        , _T("Secure storage is not working. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_STORE_SAVE_ERROR                                  , _T("License acquisition did not work. Acquire a new license or contact the content provider for further assistance."))
      CASE_ERRCODE2(NS_E_DRM_SECURE_STORE_UNLOCK_ERROR                                 , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_INVALID_CONTENT                                           , _T("The media file is corrupted. Contact the content provider to get a new file."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_OPEN_LICENSE                                    , _T("The license is corrupted. Acquire a new license."))
      CASE_ERRCODE2(NS_E_DRM_INVALID_LICENSE                                           , _T("The license is corrupted or invalid. Acquire a new license"))
      CASE_ERRCODE2(NS_E_DRM_INVALID_MACHINE                                           , _T("Licenses cannot be copied from one computer to another. Use License Management to transfer licenses, or get a new license for the media file."))
      CASE_ERRCODE2(NS_E_DRM_ENUM_LICENSE_FAILED                                       , _T("License storage is not working. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_INVALID_LICENSE_REQUEST                                   , _T("The media file is corrupted. Contact the content provider to get a new file."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_INITIALIZE                                      , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_ACQUIRE_LICENSE                                 , _T("The license could not be acquired. Try again later."))
      CASE_ERRCODE2(NS_E_DRM_INVALID_LICENSE_ACQUIRED                                  , _T("License acquisition did not work. Acquire a new license or contact the content provider for further assistance."))
      CASE_ERRCODE2(NS_E_DRM_NO_RIGHTS                                                 , _T("The requested operation cannot be performed on this file."))
      CASE_ERRCODE2(NS_E_DRM_KEY_ERROR                                                 , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_ENCRYPT_ERROR                                             , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_DECRYPT_ERROR                                             , _T("The media file is corrupted. Contact the content provider to get a new file."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_INVALID_XML                                       , _T("The license is corrupted. Acquire a new license."))
      CASE_ERRCODE2(NS_S_DRM_LICENSE_ACQUIRED                                          , _T("Status message: The license was acquired."))
      CASE_ERRCODE2(NS_S_DRM_INDIVIDUALIZED                                            , _T("Status message: The security upgrade has been completed."))
      CASE_ERRCODE2(NS_E_DRM_NEEDS_INDIVIDUALIZATION                                   , _T("A security upgrade is required to perform the operation on this media file."))
      CASE_ERRCODE2(NS_E_DRM_ALREADY_INDIVIDUALIZED                                    , _T("You already have the latest security components. No upgrade is necessary at this time."))
      CASE_ERRCODE2(NS_E_DRM_ACTION_NOT_QUERIED                                        , _T("The application cannot perform this action. Contact product support for this application."))
      CASE_ERRCODE2(NS_E_DRM_ACQUIRING_LICENSE                                         , _T("You cannot begin a new license acquisition process until the current one has been completed."))
      CASE_ERRCODE2(NS_E_DRM_INDIVIDUALIZING                                           , _T("You cannot begin a new security upgrade until the current one has been completed."))
      CASE_ERRCODE2(NS_E_DRM_PARAMETERS_MISMATCHED                                     , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_LICENSE_OBJECT                           , _T("A license cannot be created for this media file. Reinstall the application."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_INDI_OBJECT                              , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_ENCRYPT_OBJECT                           , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_DECRYPT_OBJECT                           , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_PROPERTIES_OBJECT                        , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_BACKUP_OBJECT                            , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_INDIVIDUALIZE_ERROR                                       , _T("The security upgrade failed. Try again later."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_OPEN_ERROR                                        , _T("License storage is not working. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_CLOSE_ERROR                                       , _T("License storage is not working. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_GET_LICENSE_ERROR                                         , _T("License storage is not working. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_QUERY_ERROR                                               , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_REPORT_ERROR                                              , _T("A problem has occurred in the Digital Rights Management component. Contact product support for this application."))
      CASE_ERRCODE2(NS_E_DRM_GET_LICENSESTRING_ERROR                                   , _T("License storage is not working. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_GET_CONTENTSTRING_ERROR                                   , _T("The media file is corrupted. Contact the content provider to get a new file."))
      CASE_ERRCODE2(NS_E_DRM_MONITOR_ERROR                                             , _T("A problem has occurred in the Digital Rights Management component. Try again later."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_SET_PARAMETER                                   , _T("The application has made an invalid call to the Digital Rights Management component. Contact product support for this application."))
      CASE_ERRCODE2(NS_E_DRM_INVALID_APPDATA                                           , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_INVALID_APPDATA_VERSION                                   , _T("A problem has occurred in the Digital Rights Management component. Contact product support for this application."))
      CASE_ERRCODE2(NS_E_DRM_BACKUP_EXISTS                                             , _T("Licenses are already backed up in this location."))
      CASE_ERRCODE2(NS_E_DRM_BACKUP_CORRUPT                                            , _T("One or more backed-up licenses are missing or corrupt."))
      CASE_ERRCODE2(NS_E_DRM_BACKUPRESTORE_BUSY                                        , _T("You cannot begin a new backup process until the current process has been completed."))
      CASE_ERRCODE2(NS_S_DRM_MONITOR_CANCELLED                                         , _T("Status message: License monitoring has been cancelled."))
      CASE_ERRCODE2(NS_S_DRM_ACQUIRE_CANCELLED                                         , _T("Status message: License acquisition has been cancelled."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_UNUSABLE                                          , _T("The license is invalid. Contact the content provider for further assistance."))
      CASE_ERRCODE2(NS_E_DRM_INVALID_PROPERTY                                          , _T("A required property was not set by the application. Contact product support for this application."))
      CASE_ERRCODE2(NS_E_DRM_SECURE_STORE_NOT_FOUND                                    , _T("A problem has occurred in the Digital Rights Management component of this application. Try to acquire a license again."))
      CASE_ERRCODE2(NS_E_DRM_CACHED_CONTENT_ERROR                                      , _T("A license cannot be found for this media file. Use License Management to transfer a license for this file from the original computer, or acquire a new license."))
      CASE_ERRCODE2(NS_E_DRM_INDIVIDUALIZATION_INCOMPLETE                              , _T("A problem occurred during the security upgrade. Try again later."))
      CASE_ERRCODE2(NS_E_DRM_DRIVER_AUTH_FAILURE                                       , _T("Certified driver components are required to play this media file. Contact Windows Update to see whether updated drivers are available for your hardware."))
      CASE_ERRCODE2(NS_E_DRM_NEED_UPGRADE_MSSAP                                        , _T("One or more of the Secure Audio Path components were not found or an entry point in those components was not found."))
      CASE_ERRCODE2(NS_E_DRM_REOPEN_CONTENT                                            , _T("Status message: Reopen the file."))
      CASE_ERRCODE2(NS_E_DRM_DRIVER_DIGIOUT_FAILURE                                    , _T("Certain driver functionality is required to play this media file. Contact Windows Update to see whether updated drivers are available for your hardware."))
      CASE_ERRCODE2(NS_E_DRM_INVALID_SECURESTORE_PASSWORD                              , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_APPCERT_REVOKED                                           , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_RESTORE_FRAUD                                             , _T("You cannot restore your license(s)."))
      CASE_ERRCODE2(NS_E_DRM_HARDWARE_INCONSISTENT                                     , _T("The licenses for your media files are corrupted. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_SDMI_TRIGGER                                              , _T("To transfer this media file, you must upgrade the application."))
      CASE_ERRCODE2(NS_E_DRM_SDMI_NOMORECOPIES                                         , _T("You cannot make any more copies of this media file."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_HEADER_OBJECT                            , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_KEYS_OBJECT                              , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_NOTACQUIRED                                       , _T("Unable to obtain license."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_CODING_OBJECT                            , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_STATE_DATA_OBJECT                        , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_BUFFER_TOO_SMALL                                          , _T("The buffer supplied is not sufficient."))
      CASE_ERRCODE2(NS_E_DRM_UNSUPPORTED_PROPERTY                                      , _T("The property requested is not supported."))
      CASE_ERRCODE2(NS_E_DRM_ERROR_BAD_NET_RESP                                        , _T("The specified server cannot perform the requested operation."))
      CASE_ERRCODE2(NS_E_DRM_STORE_NOTALLSTORED                                        , _T("Some of the licenses could not be stored."))
      CASE_ERRCODE2(NS_E_DRM_SECURITY_COMPONENT_SIGNATURE_INVALID                      , _T("The Digital Rights Management security upgrade component could not be validated. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_INVALID_DATA                                              , _T("Invalid or corrupt data was encountered."))
      CASE_ERRCODE2(NS_E_DRM_POLICY_DISABLE_ONLINE                                     , _T("Unable to contact the server for the requested operation."))
      CASE_ERRCODE2(NS_E_DRM_UNABLE_TO_CREATE_AUTHENTICATION_OBJECT                    , _T("A problem has occurred in the Digital Rights Management component. Contact Microsoft product support."))
      CASE_ERRCODE2(NS_E_DRM_NOT_CONFIGURED                                            , _T("Not all of the necessary properties for DRM have been set."))
      CASE_ERRCODE2(NS_E_DRM_DEVICE_ACTIVATION_CANCELED                                , _T("The portable device does not have the security required to copy protected files to it. To obtain the additional security, try to copy the file to your portable device again. When a message appears, click OK."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_EXPIRED                                           , _T("The license for this file has expired and is no longer valid. Contact your content provider for further assistance."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_NOTENABLED                                        , _T("The license for this file is not valid yet, but will be at a future date."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_APPSECLOW                                         , _T("The license for this file requires a higher level of security than the player you are currently using has. Try using a different player or download a newer version of your current player."))
      CASE_ERRCODE2(NS_E_DRM_STORE_NEEDINDI                                            , _T("The license cannot be stored as it requires security upgrade of Digital Rights Management component."))
      CASE_ERRCODE2(NS_E_DRM_STORE_NOTALLOWED                                          , _T("Your machine does not meet the requirements for storing the license."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_APP_NOTALLOWED                                    , _T("The license for this file requires an upgraded version of your player or a different player."))
      CASE_ERRCODE2(NS_S_DRM_NEEDS_INDIVIDUALIZATION                                   , _T("A security upgrade is required to perform the operation on this media file."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_CERT_EXPIRED                                      , _T("The license server's certificate expired. Make sure your system clock is set correctly. Contact your content provider for further assistance. "))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_SECLOW                                            , _T("The license for this file requires a higher level of security than the player you are currently using has. Try using a different player or download a newer version of your current player."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_CONTENT_REVOKED                                   , _T("The content owner for the license you just acquired is no longer supporting their content. Contact the content owner for a newer version of the content."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_NOSAP                                             , _T("The license for this file requires a feature that is not supported in your current player or operating system. You can try with newer version of your current player or contact your content provider for further assistance."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_NOSVP                                             , _T("The license for this file requires a feature that is not supported in your current player or operating system. You can try with newer version of your current player or contact your content provider for further assistance."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_NOWDM                                             , _T("The license for this file requires Windows Driver Model (WDM) audio drivers. Contact your sound card manufacturer for further assistance."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_NOTRUSTEDCODEC                                    , _T("The license for this file requires a higher level of security than the player you are currently using has. Try using a different player or download a newer version of your current player."))
      CASE_ERRCODE2(NS_E_DRM_NEEDS_UPGRADE_TEMPFILE                                    , _T("An updated version of your media player is required to play the selected content."))
      CASE_ERRCODE2(NS_E_DRM_NEED_UPGRADE_PD                                           , _T("A new version of the Digital Rights Management component is required. Contact product support for this application to get the latest version."))
      CASE_ERRCODE2(NS_E_DRM_SIGNATURE_FAILURE                                         , _T("Failed to either create or verify the content header."))
      CASE_ERRCODE2(NS_E_DRM_LICENSE_SERVER_INFO_MISSING                               , _T("Could not read the necessary information from the system registry."))
      CASE_ERRCODE2(NS_E_DRM_BUSY                                                      , _T("The DRM subsystem is currently locked by another application or user.  Try again later."))
      CASE_ERRCODE2(NS_E_DRM_PD_TOO_MANY_DEVICES                                       , _T("There are too many target devices registered on the portable media."))
      CASE_ERRCODE2(NS_E_DRM_INDIV_FRAUD                                               , _T("The security upgrade cannot be completed because the allowed number of daily upgrades has been exceeded. Try again tomorrow."))
      CASE_ERRCODE2(NS_E_DRM_INDIV_NO_CABS                                             , _T("The security upgrade cannot be completed because the server is unable to perform the operation. Try again later."))
      CASE_ERRCODE2(NS_E_DRM_INDIV_SERVICE_UNAVAILABLE                                 , _T("The security upgrade cannot be performed because the server is not available. Try again later."))
      CASE_ERRCODE2(NS_E_DRM_RESTORE_SERVICE_UNAVAILABLE                               , _T("Windows Media Player cannot restore your licenses because the server is not available. Try again later."))
      CASE_ERRCODE2(NS_S_REBOOT_RECOMMENDED                                            , _T("The requested operation is successful.  Some cleanup will not be complete until the system is rebooted."))
      CASE_ERRCODE2(NS_S_REBOOT_REQUIRED                                               , _T("The requested operation is successful.  The system will not function correctly until the system is rebooted."))
      CASE_ERRCODE2(NS_E_REBOOT_RECOMMENDED                                            , _T("The requested operation failed.  Some cleanup will not be complete until the system is rebooted."))
      CASE_ERRCODE2(NS_E_REBOOT_REQUIRED                                               , _T("The requested operation failed.  The system will not function correctly until the system is rebooted."))
      CASE_ERRCODE2(NS_E_UNKNOWN_PROTOCOL                                              , _T("The specified protocol is not supported."))
      CASE_ERRCODE2(NS_E_REDIRECT_TO_PROXY                                             , _T("The client is redirected to a proxy server."))
      CASE_ERRCODE2(NS_E_INTERNAL_SERVER_ERROR                                         , _T("The server encountered an unexpected condition which prevented it from fulfilling the request."))
      CASE_ERRCODE2(NS_E_BAD_REQUEST                                                   , _T("The request could not be understood by the server."))
      CASE_ERRCODE2(NS_E_ERROR_FROM_PROXY                                              , _T("The proxy experienced an error while attempting to contact the media server."))
      CASE_ERRCODE2(NS_E_PROXY_TIMEOUT                                                 , _T("The proxy did not receive a timely response while attempting to contact the media server."))
      CASE_ERRCODE2(NS_E_SERVER_UNAVAILABLE                                            , _T("The server is currently unable to handle the request due to a temporary overloading or maintenance of the server."))
      CASE_ERRCODE2(NS_E_REFUSED_BY_SERVER                                             , _T("The server is refusing to fulfill the requested operation."))
      CASE_ERRCODE2(NS_E_INCOMPATIBLE_SERVER                                           , _T("The server is not a compatible streaming media server."))
      CASE_ERRCODE2(NS_E_MULTICAST_DISABLED                                            , _T("The content cannot be streamed because the Multicast protocol has been disabled."))
      CASE_ERRCODE2(NS_E_INVALID_REDIRECT                                              , _T("The server redirected the player to an invalid location."))
      CASE_ERRCODE2(NS_E_ALL_PROTOCOLS_DISABLED                                        , _T("The content cannot be streamed because all protocols have been disabled."))
      CASE_ERRCODE2(NS_E_MSBD_NO_LONGER_SUPPORTED                                      , _T("The MSBD protocol is no longer supported. Please use HTTP to connect to the Windows Media stream."))
      CASE_ERRCODE2(NS_E_PROXY_NOT_FOUND                                               , _T("The proxy server could not be located. Please check your proxy server configuration."))
      CASE_ERRCODE2(NS_E_CANNOT_CONNECT_TO_PROXY                                       , _T("Unable to establish a connection to the proxy server. Please check your proxy server configuration."))
      CASE_ERRCODE2(NS_E_SERVER_DNS_TIMEOUT                                            , _T("Unable to locate the media server. The operation timed out."))
      CASE_ERRCODE2(NS_E_PROXY_DNS_TIMEOUT                                             , _T("Unable to locate the proxy server. The operation timed out."))
      CASE_ERRCODE2(NS_E_CLOSED_ON_SUSPEND                                             , _T("Media closed because Windows was shut down."))
      CASE_ERRCODE2(NS_E_CANNOT_READ_PLAYLIST_FROM_MEDIASERVER                         , _T("Unable to read the contents of a playlist file from a media server."))
      CASE_ERRCODE2(NS_E_SESSION_NOT_FOUND                                             , _T("Session not found."))
      CASE_ERRCODE2(NS_E_REQUIRE_STREAMING_CLIENT                                      , _T("Content requires a streaming media client."))
      CASE_ERRCODE2(NS_E_PLAYLIST_ENTRY_HAS_CHANGED                                    , _T("A command applies to a previous playlist entry."))
      CASE_ERRCODE2(NS_E_PROXY_ACCESSDENIED                                            , _T("The proxy server is denying access.  The username and/or password might be incorrect."))
      CASE_ERRCODE2(NS_E_PROXY_SOURCE_ACCESSDENIED                                     , _T("The proxy could not provide valid authentication credentials to the media server."))
      CASE_ERRCODE2(NS_E_NETWORK_SINK_WRITE                                            , _T("The network sink failed to write data to the network."))
      CASE_ERRCODE2(NS_E_FIREWALL                                                      , _T("Packets are not being received from the server. The packets might be blocked by a filtering device, such as a network firewall."))
      CASE_ERRCODE2(NS_E_MMS_NOT_SUPPORTED                                             , _T("The MMS protocol is not supported. Please use HTTP or RTSP to connect to the Windows Media stream."))
      CASE_ERRCODE2(NS_E_SERVER_ACCESSDENIED                                           , _T("The Windows Media server is denying access.  The username and/or password might be incorrect."))
      CASE_ERRCODE2(NS_E_RESOURCE_GONE                                                 , _T("The Publishing Point or file on the Windows Media Server is no longer available."))
      CASE_ERRCODE2(NS_E_NO_EXISTING_PACKETIZER                                        , _T("There is no existing packetizer plugin for a stream."))
      CASE_ERRCODE2(NS_E_BAD_SYNTAX_IN_SERVER_RESPONSE                                 , _T("The response from the media server could not be understood. This might be caused by an incompatible proxy server or media server."))
      CASE_ERRCODE2(NS_I_RECONNECTED                                                   , _T("The client is reconnected."))
      CASE_ERRCODE2(NS_E_RESET_SOCKET_CONNECTION                                       , _T("The Windows Media Server reset the network connection."))
      CASE_ERRCODE2(NS_I_NOLOG_STOP                                                    , _T("Forcing a switch to a pending header on start."))
      CASE_ERRCODE2(NS_E_TOO_MANY_HOPS                                                 , _T("The request could not reach the media server (too many hops)."))
      CASE_ERRCODE2(NS_I_EXISTING_PACKETIZER                                           , _T("There is already an existing packetizer plugin for the stream."))
      CASE_ERRCODE2(NS_I_MANUAL_PROXY                                                  , _T("The proxy setting is manual."))
      CASE_ERRCODE2(NS_E_TOO_MUCH_DATA_FROM_SERVER                                     , _T("The server is sending too much data. The connection has been terminated."))
      CASE_ERRCODE2(NS_E_CONNECT_TIMEOUT                                               , _T("It was not possible to establish a connection to the media server in a timely manner. The media server may be down for maintenance, or it may be necessary to use a proxy server to access this media server."))
      CASE_ERRCODE2(NS_E_PROXY_CONNECT_TIMEOUT                                         , _T("It was not possible to establish a connection to the proxy server in a timely manner. Please check your proxy server configuration."))
      CASE_ERRCODE2(NS_E_SESSION_INVALID                                               , _T("Session not found."))
      CASE_ERRCODE2(NS_S_EOSRECEDING                                                   , _T("EOS hit during rewinding."))
      CASE_ERRCODE2(NS_E_PACKETSINK_UNKNOWN_FEC_STREAM                                 , _T("Unknown packet sink stream."))
      CASE_ERRCODE2(NS_E_PUSH_CANNOTCONNECT                                            , _T("Unable to establish a connection to the server. Ensure Windows Media Services is started and the HTTP Server control protocol is properly enabled."))
      CASE_ERRCODE2(NS_E_INCOMPATIBLE_PUSH_SERVER                                      , _T("The Server service that received the HTTP push request is not a compatible version of Windows Media Services (WMS).  This error may indicate the push request was received by IIS instead of WMS.  Ensure WMS is started and has the HTTP Server control protocol properly enabled and try again."))
      CASE_ERRCODE2(NS_S_CHANGENOTICE                                                  , _T("Internal."))
      CASE_ERRCODE2(NS_E_END_OF_PLAYLIST                                               , _T("The playlist has reached its end."))
      CASE_ERRCODE2(NS_E_USE_FILE_SOURCE                                               , _T("Use file source."))
      CASE_ERRCODE2(NS_E_PROPERTY_NOT_FOUND                                            , _T("The property was not found."))
      CASE_ERRCODE2(NS_E_PROPERTY_READ_ONLY                                            , _T("The property is read only."))
      CASE_ERRCODE2(NS_E_TABLE_KEY_NOT_FOUND                                           , _T("The table key was not found."))
      CASE_ERRCODE2(NS_E_INVALID_QUERY_OPERATOR                                        , _T("Invalid query operator."))
      CASE_ERRCODE2(NS_E_INVALID_QUERY_PROPERTY                                        , _T("Invalid query property."))
      CASE_ERRCODE2(NS_E_PROPERTY_NOT_SUPPORTED                                        , _T("The property is not supported."))
      CASE_ERRCODE2(NS_E_SCHEMA_CLASSIFY_FAILURE                                       , _T("Schema classification failure."))
      CASE_ERRCODE2(NS_E_METADATA_FORMAT_NOT_SUPPORTED                                 , _T("The metadata format is not supported."))
      CASE_ERRCODE2(NS_E_METADATA_NO_EDITING_CAPABILITY                                , _T("Cannot edit the metadata."))
      CASE_ERRCODE2(NS_E_METADATA_CANNOT_SET_LOCALE                                    , _T("Cannot set the locale id."))
      CASE_ERRCODE2(NS_E_METADATA_LANGUAGE_NOT_SUPORTED                                , _T("The language is not supported in the format."))
      CASE_ERRCODE2(NS_E_METADATA_NO_RFC1766_NAME_FOR_LOCALE                           , _T("There is no RFC1766 name translation for the supplied locale id."))
      CASE_ERRCODE2(NS_E_METADATA_NOT_AVAILABLE                                        , _T("The metadata (or metadata item) is not available."))
      CASE_ERRCODE2(NS_E_METADATA_CACHE_DATA_NOT_AVAILABLE                             , _T("The cached metadata (or metadata item) is not available."))
      CASE_ERRCODE2(NS_E_METADATA_INVALID_DOCUMENT_TYPE                                , _T("The metadata document is invalid."))
      CASE_ERRCODE2(NS_E_METADATA_IDENTIFIER_NOT_AVAILABLE                             , _T("The metadata content identifier is not available."))
      CASE_ERRCODE2(NS_E_METADATA_CANNOT_RETRIEVE_FROM_OFFLINE_CACHE                   , _T("Cannot retrieve metadata from the offline metadata cache."))
#endif // __SDK__

#ifdef __SDK__
    //CASE_ERRCODE1(CdoE_CALL_FAILED                ) // === E_FAIL
    //CASE_ERRCODE1(CdoE_NOT_ENOUGH_MEMORY          ) // === E_OUTOFMEMORY
    //CASE_ERRCODE1(CdoE_INVALID_PARAMETER          ) // === E_INVALIDARG
    //CASE_ERRCODE1(CdoE_INTERFACE_NOT_SUPPORTED    ) // === E_NOINTERFACE
    //CASE_ERRCODE1(CdoE_NO_ACCESS                  ) // === E_ACCESSDENIED
    //CASE_ERRCODE1(CdoE_NO_SUPPORT                 ) // === DRAGDROP_E_INVALIDHWND
      CASE_ERRCODE1(CdoE_BAD_CHARWIDTH              )
      CASE_ERRCODE1(CdoE_STRING_TOO_LONG            )
      CASE_ERRCODE1(CdoE_UNKNOWN_FLAGS              )
      CASE_ERRCODE1(CdoE_INVALID_ENTRYID            )
      CASE_ERRCODE1(CdoE_INVALID_OBJECT             )
      CASE_ERRCODE1(CdoE_OBJECT_CHANGED             )
      CASE_ERRCODE1(CdoE_OBJECT_DELETED             )
      CASE_ERRCODE1(CdoE_BUSY                       )
      CASE_ERRCODE1(CdoE_NOT_ENOUGH_DISK            )
      CASE_ERRCODE1(CdoE_NOT_ENOUGH_RESOURCES       )
      CASE_ERRCODE1(CdoE_NOT_FOUND                  )
    //CASE_ERRCODE1(CdoE_VERSION                    ) // === CLASS_E_NOAGGREGATION
    //CASE_ERRCODE1(CdoE_LOGON_FAILED               ) // === CLASS_E_CLASSNOTAVAILABLE
    //CASE_ERRCODE1(CdoE_SESSION_LIMIT              ) // === CLASS_E_NOTLICENSED
      CASE_ERRCODE1(CdoE_USER_CANCEL                )
      CASE_ERRCODE1(CdoE_UNABLE_TO_ABORT            )
      CASE_ERRCODE1(CdoE_NETWORK_ERROR              )
      CASE_ERRCODE1(CdoE_DISK_ERROR                 )
      CASE_ERRCODE1(CdoE_TOO_COMPLEX                )
      CASE_ERRCODE1(CdoE_BAD_COLUMN                 )
      CASE_ERRCODE1(CdoE_EXTENDED_ERROR             )
      CASE_ERRCODE1(CdoE_COMPUTED                   )
      CASE_ERRCODE1(CdoE_CORRUPT_DATA               )
      CASE_ERRCODE1(CdoE_UNCONFIGURED               )
      CASE_ERRCODE1(CdoE_FAILONEPROVIDER            )
      CASE_ERRCODE1(CdoE_UNKNOWN_CPID               )
      CASE_ERRCODE1(CdoE_UNKNOWN_LCID               )
      CASE_ERRCODE1(CdoE_PASSWORD_CHANGE_REQUIRED   )
      CASE_ERRCODE1(CdoE_PASSWORD_EXPIRED           )
      CASE_ERRCODE1(CdoE_INVALID_WORKSTATION_ACCOUNT)
      CASE_ERRCODE1(CdoE_INVALID_ACCESS_TIME        )
      CASE_ERRCODE1(CdoE_ACCOUNT_DISABLED           )
    //CASE_ERRCODE1(CdoE_END_OF_SESSION             ) // === EVENT_E_FIRST
    //CASE_ERRCODE1(CdoE_UNKNOWN_ENTRYID            ) // === EVENT_E_ALL_SUBSCRIBERS_FAILED
      CASE_ERRCODE1(CdoE_MISSING_REQUIRED_COLUMN    )
      CASE_ERRCODE1(CdoW_NO_SERVICE                 )
      CASE_ERRCODE1(CdoE_BAD_VALUE                  )
      CASE_ERRCODE1(CdoE_INVALID_TYPE               )
      CASE_ERRCODE1(CdoE_TYPE_NO_SUPPORT            )
      CASE_ERRCODE1(CdoE_UNEXPECTED_TYPE            )
      CASE_ERRCODE1(CdoE_TOO_BIG                    )
      CASE_ERRCODE1(CdoE_DECLINE_COPY               )
      CASE_ERRCODE1(CdoE_UNEXPECTED_ID              )
      CASE_ERRCODE1(CdoW_ERRORS_RETURNED            )
      CASE_ERRCODE1(CdoE_UNABLE_TO_COMPLETE         )
      CASE_ERRCODE1(CdoE_TIMEOUT                    )
      CASE_ERRCODE1(CdoE_TABLE_EMPTY                )
      CASE_ERRCODE1(CdoE_TABLE_TOO_BIG              )
      CASE_ERRCODE1(CdoE_INVALID_BOOKMARK           )
      CASE_ERRCODE1(CdoW_POSITION_CHANGED           )
      CASE_ERRCODE1(CdoW_APPROX_COUNT               )
      CASE_ERRCODE1(CdoE_WAIT                       )
      CASE_ERRCODE1(CdoE_CANCEL                     )
      CASE_ERRCODE1(CdoE_NOT_ME                     )
      CASE_ERRCODE1(CdoW_CANCEL_MESSAGE             )
      CASE_ERRCODE1(CdoE_CORRUPT_STORE              )
      CASE_ERRCODE1(CdoE_NOT_IN_QUEUE               )
      CASE_ERRCODE1(CdoE_NO_SUPPRESS                )
      CASE_ERRCODE1(CdoE_COLLISION                  )
      CASE_ERRCODE1(CdoE_NOT_INITIALIZED            )
      CASE_ERRCODE1(CdoE_NON_STANDARD               )
      CASE_ERRCODE1(CdoE_NO_RECIPIENTS              )
      CASE_ERRCODE1(CdoE_SUBMITTED                  )
      CASE_ERRCODE1(CdoE_HAS_FOLDERS                )
      CASE_ERRCODE1(CdoE_HAS_MESSAGES               )
      CASE_ERRCODE1(CdoE_FOLDER_CYCLE               )
      CASE_ERRCODE1(CdoW_PARTIAL_COMPLETION         )
      CASE_ERRCODE1(CdoE_AMBIGUOUS_RECIP            )
#endif // __SDK__

#ifdef __SDK__
      CASE_ERRCODE2(STRSAFE_E_INSUFFICIENT_BUFFER                                      , _T("The copy operation failed due to insufficient space. When this error occurs, the destination buffer is modified to contain a truncated version of the ideal result and is null terminated. This is useful for situations where truncation is ok."))
    //CASE_ERRCODE2(STRSAFE_E_INVALID_PARAMETER                                        , _T("The parameter is incorrect."))  // === E_INVALIDARG
      CASE_ERRCODE2(STRSAFE_E_END_OF_FILE                                              , _T("Indicates an error or end-of-file condition, use feof or ferror to determine which one has occured."))
#endif // __SDK__
      // END part extInfo == info_HResult

      // BEGIN part extInfo == info_NTStatus
#ifdef __SDK__
      CASE_ERRCODE2(STATUS_OBJECT_NAME_EXISTS                                          , _T("{Object Exists} An attempt was made to create an object and the object name already existed."))
      CASE_ERRCODE2(STATUS_THREAD_WAS_SUSPENDED                                        , _T("{Thread Suspended} A thread termination occurred while the thread was suspended. The thread was resumed, and termination proceeded."))
      CASE_ERRCODE2(STATUS_WORKING_SET_LIMIT_RANGE                                     , _T("{Working Set Range Error} An attempt was made to set the working set minimum or maximum to values which are outside of the allowable range."))
      CASE_ERRCODE2(STATUS_IMAGE_NOT_AT_BASE                                           , _T("{Image Relocated} An image file could not be mapped at the address specified in the image file. Local fixups must be performed on this image."))
      CASE_ERRCODE2(STATUS_RXACT_STATE_CREATED                                         , _T("This informational level status indicates that a specified registry sub-tree transaction state did not yet exist and had to be created."))
      CASE_ERRCODE2(STATUS_SEGMENT_NOTIFICATION                                        , _T("{Segment Load} A virtual DOS machine (VDM) is loading, unloading, or moving an MS-DOS or Win16 program segment image. An exception is raised so a debugger can load, unload or track symbols and breakpoints within these 16-bit segments."))
      CASE_ERRCODE2(STATUS_LOCAL_USER_SESSION_KEY                                      , _T("{Local Session Key} A user session key was requested for a local RPC connection. The session key returned is a constant value and not unique to this connection."))
      CASE_ERRCODE2(STATUS_BAD_CURRENT_DIRECTORY                                       , _T("{Invalid Current Directory} The process cannot switch to the startup current directory %hs. Select OK to set current directory to %hs, or select CANCEL to exit."))
      CASE_ERRCODE2(STATUS_SERIAL_MORE_WRITES                                          , _T("{Serial IOCTL Complete} A serial I/O operation was completed by another write to a serial port. (The IOCTL_SERIAL_XOFF_COUNTER reached zero.)"))
      CASE_ERRCODE2(STATUS_REGISTRY_RECOVERED                                          , _T("{Registry Recovery} One of the files containing the system's Registry data had to be recovered by use of a log or alternate copy. The recovery was successful."))
      CASE_ERRCODE2(STATUS_FT_READ_RECOVERY_FROM_BACKUP                                , _T("{Redundant Read} To satisfy a read request, the NT fault-tolerant file system successfully read the requested data from a redundant copy. This was done because the file system encountered a failure on a member of the fault-tolerant volume, but was unable to reassign the failing area of the device."))
      CASE_ERRCODE2(STATUS_FT_WRITE_RECOVERY                                           , _T("{Redundant Write} To satisfy a write request, the NT fault-tolerant file system successfully wrote a redundant copy of the information. This was done because the file system encountered a failure on a member of the fault-tolerant volume, but was not able to reassign the failing area of the device."))
      CASE_ERRCODE2(STATUS_SERIAL_COUNTER_TIMEOUT                                      , _T("{Serial IOCTL Timeout} A serial I/O operation completed because the time-out period expired. (The IOCTL_SERIAL_XOFF_COUNTER had not reached zero.)"))
      CASE_ERRCODE2(STATUS_NULL_LM_PASSWORD                                            , _T("{Password Too Complex} The Windows password is too complex to be converted to a LAN Manager password. The LAN Manager password returned is a NULL string."))
      CASE_ERRCODE2(STATUS_IMAGE_MACHINE_TYPE_MISMATCH                                 , _T("{Machine Type Mismatch} The image file %hs is valid, but is for a machine type other than the current machine. Select OK to continue, or CANCEL to fail the DLL load."))
      CASE_ERRCODE2(STATUS_RECEIVE_PARTIAL                                             , _T("{Partial Data Received} The network transport returned partial data to its client. The remaining data will be sent later."))
      CASE_ERRCODE2(STATUS_RECEIVE_EXPEDITED                                           , _T("{Expedited Data Received} The network transport returned data to its client that was marked as expedited by the remote system."))
      CASE_ERRCODE2(STATUS_RECEIVE_PARTIAL_EXPEDITED                                   , _T("{Partial Expedited Data Received} The network transport returned partial data to its client and this data was marked as expedited by the remote system. The remaining data will be sent later."))
      CASE_ERRCODE2(STATUS_EVENT_DONE                                                  , _T("{TDI Event Done} The TDI indication has completed successfully."))
      CASE_ERRCODE2(STATUS_EVENT_PENDING                                               , _T("{TDI Event Pending} The TDI indication has entered the pending state."))
      CASE_ERRCODE2(STATUS_CHECKING_FILE_SYSTEM                                        , _T("Checking file system on %wZ"))
      CASE_ERRCODE2(STATUS_FATAL_APP_EXIT                                              , _T("{Fatal Application Exit} %hs"))
      CASE_ERRCODE2(STATUS_PREDEFINED_HANDLE                                           , _T("The specified registry key is referenced by a predefined handle."))
      CASE_ERRCODE2(STATUS_WAS_UNLOCKED                                                , _T("{Page Unlocked} The page protection of a locked page was changed to 'No Access' and the page was unlocked from memory and from the process."))
      CASE_ERRCODE2(STATUS_SERVICE_NOTIFICATION                                        , _T("%hs"))
      CASE_ERRCODE2(STATUS_WAS_LOCKED                                                  , _T("{Page Locked} One of the pages to lock was already locked."))
      CASE_ERRCODE2(STATUS_LOG_HARD_ERROR                                              , _T("Application popup: %1 : %2"))
      CASE_ERRCODE2(STATUS_ALREADY_WIN32                                               , _T("STATUS_ALREADY_WIN32"))
      CASE_ERRCODE2(STATUS_WX86_UNSIMULATE                                             , _T("Exception status code used by Win32 x86 emulation subsystem."))
      CASE_ERRCODE2(STATUS_WX86_CONTINUE                                               , _T("Exception status code used by Win32 x86 emulation subsystem."))
      CASE_ERRCODE2(STATUS_WX86_SINGLE_STEP                                            , _T("Exception status code used by Win32 x86 emulation subsystem."))
      CASE_ERRCODE2(STATUS_WX86_BREAKPOINT                                             , _T("Exception status code used by Win32 x86 emulation subsystem."))
      CASE_ERRCODE2(STATUS_WX86_EXCEPTION_CONTINUE                                     , _T("Exception status code used by Win32 x86 emulation subsystem."))
      CASE_ERRCODE2(STATUS_WX86_EXCEPTION_LASTCHANCE                                   , _T("Exception status code used by Win32 x86 emulation subsystem."))
      CASE_ERRCODE2(STATUS_WX86_EXCEPTION_CHAIN                                        , _T("Exception status code used by Win32 x86 emulation subsystem."))
      CASE_ERRCODE2(STATUS_IMAGE_MACHINE_TYPE_MISMATCH_EXE                             , _T("{Machine Type Mismatch} The image file %hs is valid, but is for a machine type other than the current machine."))
      CASE_ERRCODE2(STATUS_NO_YIELD_PERFORMED                                          , _T("A yield execution was performed and no thread was available to run."))
      CASE_ERRCODE2(STATUS_TIMER_RESUME_IGNORED                                        , _T("The resumable flag to a timer API was ignored."))
      CASE_ERRCODE2(STATUS_ARBITRATION_UNHANDLED                                       , _T("The arbiter has deferred arbitration of these resources to its parent"))
      CASE_ERRCODE2(STATUS_CARDBUS_NOT_SUPPORTED                                       , _T("The device '%hs' has detected a CardBus card in its slot, but the firmware on this system is not configured to allow the CardBus controller to be run in CardBus mode. The operating system will currently accept only 16-bit (R2) pc-cards on this controller."))
      CASE_ERRCODE2(STATUS_WX86_CREATEWX86TIB                                          , _T("Exception status code used by Win32 x86 emulation subsystem."))
      CASE_ERRCODE2(STATUS_MP_PROCESSOR_MISMATCH                                       , _T("The CPUs in this multiprocessor system are not all the same revision level.  To use all processors the operating system restricts itself to the features of the least capable processor in the system.  Should problems occur with this system, contact the CPU manufacturer to see if this mix of processors is supported."))
      CASE_ERRCODE2(STATUS_HIBERNATED                                                  , _T("The system was put into hibernation."))
      CASE_ERRCODE2(STATUS_RESUME_HIBERNATION                                          , _T("The system was resumed from hibernation."))
      CASE_ERRCODE2(STATUS_FIRMWARE_UPDATED                                            , _T("Windows has detected that the system firmware (BIOS) was updated [previous firmware date = %2, current firmware date %3]."))
      CASE_ERRCODE2(STATUS_DRIVERS_LEAKING_LOCKED_PAGES                                , _T("A device driver is leaking locked I/O pages causing system degradation.  The system has automatically enabled tracking code in order to try and catch the culprit."))
      CASE_ERRCODE2(DBG_REPLY_LATER                                                    , _T("Debugger will reply later."))
      CASE_ERRCODE2(DBG_UNABLE_TO_PROVIDE_HANDLE                                       , _T("Debugger can not provide handle."))
      CASE_ERRCODE2(DBG_TERMINATE_THREAD                                               , _T("Debugger terminated thread."))
      CASE_ERRCODE2(DBG_TERMINATE_PROCESS                                              , _T("Debugger terminated process."))
      CASE_ERRCODE2(DBG_CONTROL_C                                                      , _T("Debugger got control C."))
      CASE_ERRCODE2(DBG_PRINTEXCEPTION_C                                               , _T("Debugger printed exception on control C."))
      CASE_ERRCODE2(DBG_RIPEXCEPTION                                                   , _T("Debugger received RIP exception."))
      CASE_ERRCODE2(DBG_CONTROL_BREAK                                                  , _T("Debugger received control break."))
      CASE_ERRCODE2(DBG_COMMAND_EXCEPTION                                              , _T("Debugger command communication exception."))
      CASE_ERRCODE2(STATUS_GUARD_PAGE_VIOLATION                                        , _T("{EXCEPTION} Guard Page Exception. A page of memory that marks the end of a data structure, such as a stack or an array, has been accessed."))
      CASE_ERRCODE2(STATUS_DATATYPE_MISALIGNMENT                                       , _T("{EXCEPTION} Alignment Fault. A datatype misalignment was detected in a load or store instruction."))
      CASE_ERRCODE2(STATUS_BREAKPOINT                                                  , _T("{EXCEPTION}. Breakpoint. A breakpoint has been reached."))
      CASE_ERRCODE2(STATUS_SINGLE_STEP                                                 , _T("{EXCEPTION}. Single Step. A single step or trace operation has just been completed."))
      CASE_ERRCODE2(STATUS_BUFFER_OVERFLOW                                             , _T("{Buffer Overflow}. The data was too large to fit into the specified buffer."))
      CASE_ERRCODE2(STATUS_NO_MORE_FILES                                               , _T("{No More Files}. No more files were found which match the file specification."))
      CASE_ERRCODE2(STATUS_WAKE_SYSTEM_DEBUGGER                                        , _T("{Kernel Debugger Awakened}. the system debugger was awakened by an interrupt."))
    //CASE_ERRCODE2(STATUS_HANDLES_CLOSED                                              , _T("{Handles Closed}. Handles to objects have been automatically closed as a result of the requested operation."))
      CASE_ERRCODE2(STATUS_NO_INHERITANCE                                              , _T("{Non-Inheritable ACL}. An access control list (ACL) contains no components that can be inherited."))
      CASE_ERRCODE2(STATUS_GUID_SUBSTITUTION_MADE                                      , _T("{GUID Substitution}. During the translation of a global identifier (GUID) to a Windows security ID (SID), no administratively-defined GUID prefix was found. A substitute prefix was used, which will not compromise system security. However, this may provide a more restrictive access than intended."))
      CASE_ERRCODE2(STATUS_PARTIAL_COPY                                                , _T("{Partial Copy}. Due to protection conflicts not all the requested bytes could be copied."))
      CASE_ERRCODE2(STATUS_DEVICE_PAPER_EMPTY                                          , _T("{Out of Paper}. The printer is out of paper."))
      CASE_ERRCODE2(STATUS_DEVICE_POWERED_OFF                                          , _T("{Device Power Is Off}. The printer power has been turned off."))
      CASE_ERRCODE2(STATUS_DEVICE_OFF_LINE                                             , _T("{Device Offline}. The printer has been taken offline."))
      CASE_ERRCODE2(STATUS_DEVICE_BUSY                                                 , _T("{Device Busy}. The device is currently busy."))
      CASE_ERRCODE2(STATUS_NO_MORE_EAS                                                 , _T("{No More EAs}. No more extended attributes (EAs) were found for the file."))
      CASE_ERRCODE2(STATUS_INVALID_EA_NAME                                             , _T("{Illegal EA}. The specified extended attribute (EA) name contains at least one illegal character."))
      CASE_ERRCODE2(STATUS_EA_LIST_INCONSISTENT                                        , _T("{Inconsistent EA List}. The extended attribute (EA) list is inconsistent."))
      CASE_ERRCODE2(STATUS_INVALID_EA_FLAG                                             , _T("{Invalid EA Flag}. An invalid extended attribute (EA) flag was set."))
      CASE_ERRCODE2(STATUS_VERIFY_REQUIRED                                             , _T("{Verifying Disk}. The media has changed and a verify operation is in progress so no reads or writes may be performed to the device, except those used in the verify operation."))
      CASE_ERRCODE2(STATUS_EXTRANEOUS_INFORMATION                                      , _T("{Too Much Information}. The specified access control list (ACL) contained more information than was expected."))
      CASE_ERRCODE2(STATUS_RXACT_COMMIT_NECESSARY                                      , _T("This warning level status indicates that the transaction state already exists for the registry sub-tree, but that a transaction commit was previously aborted. The commit has NOT been completed, but has not been rolled back either (so it may still be committed if desired)."))
      CASE_ERRCODE2(STATUS_NO_MORE_ENTRIES                                             , _T("{No More Entries} No more entries are available from an enumeration operation."))
      CASE_ERRCODE2(STATUS_FILEMARK_DETECTED                                           , _T("{Filemark Found} A filemark was detected."))
      CASE_ERRCODE2(STATUS_MEDIA_CHANGED                                               , _T("{Media Changed} The media may have changed."))
      CASE_ERRCODE2(STATUS_BUS_RESET                                                   , _T("{I/O Bus Reset} An I/O bus reset was detected."))
      CASE_ERRCODE2(STATUS_END_OF_MEDIA                                                , _T("{End of Media} The end of the media was encountered."))
      CASE_ERRCODE2(STATUS_BEGINNING_OF_MEDIA                                          , _T("Beginning of tape or partition has been detected."))
      CASE_ERRCODE2(STATUS_MEDIA_CHECK                                                 , _T("{Media Changed} The media may have changed."))
      CASE_ERRCODE2(STATUS_SETMARK_DETECTED                                            , _T("A tape access reached a setmark."))
      CASE_ERRCODE2(STATUS_NO_DATA_DETECTED                                            , _T("During a tape access, the end of the data written is reached."))
      CASE_ERRCODE2(STATUS_REDIRECTOR_HAS_OPEN_HANDLES                                 , _T("The redirector is in use and cannot be unloaded."))
      CASE_ERRCODE2(STATUS_SERVER_HAS_OPEN_HANDLES                                     , _T("The server is in use and cannot be unloaded."))
      CASE_ERRCODE2(STATUS_ALREADY_DISCONNECTED                                        , _T("The specified connection has already been disconnected."))
      CASE_ERRCODE2(STATUS_LONGJUMP                                                    , _T("A long jump has been executed."))
      CASE_ERRCODE2(STATUS_CLEANER_CARTRIDGE_INSTALLED                                 , _T("A cleaner cartridge is present in the tape library."))
      CASE_ERRCODE2(STATUS_PLUGPLAY_QUERY_VETOED                                       , _T("The Plug and Play query operation was not successful."))
      CASE_ERRCODE2(STATUS_UNWIND_CONSOLIDATE                                          , _T("A frame consolidation has been executed."))
      CASE_ERRCODE2(STATUS_REGISTRY_HIVE_RECOVERED                                     , _T("{Registry Hive Recovered} Registry hive (file): %hs was corrupted and it has been recovered. Some data might have been lost."))
      CASE_ERRCODE2(STATUS_DLL_MIGHT_BE_INSECURE                                       , _T("The application is attempting to run executable code from the module %hs.  This may be insecure.  An alternative, %hs, is available.  Should the application use the secure module %hs?"))
      CASE_ERRCODE2(STATUS_DLL_MIGHT_BE_INCOMPATIBLE                                   , _T("The application is loading executable code from the module %hs.  This is secure, but may be incompatible with previous releases of the operating system.  An alternative, %hs, is available.  Should the application use the secure module %hs?"))
    //CASE_ERRCODE2(DBG_EXCEPTION_NOT_HANDLED                                          , _T("Debugger did not handle the exception."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_ALREADY_UP                                     , _T("The cluster node is already up."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_ALREADY_DOWN                                   , _T("The cluster node is already down."))
      CASE_ERRCODE2(STATUS_CLUSTER_NETWORK_ALREADY_ONLINE                              , _T("The cluster network is already online."))
      CASE_ERRCODE2(STATUS_CLUSTER_NETWORK_ALREADY_OFFLINE                             , _T("The cluster network is already offline."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_ALREADY_MEMBER                                 , _T("The cluster node is already a member of the cluster."))
      CASE_ERRCODE2(STATUS_UNSUCCESSFUL                                                , _T("{Operation Failed} The requested operation was unsuccessful."))
      CASE_ERRCODE2(STATUS_NOT_IMPLEMENTED                                             , _T("{Not Implemented} The requested operation is not implemented."))
      CASE_ERRCODE2(STATUS_INVALID_INFO_CLASS                                          , _T("{Invalid Parameter} The specified information class is not a valid information class for the specified object."))
      CASE_ERRCODE2(STATUS_INFO_LENGTH_MISMATCH                                        , _T("The specified information record length does not match the length required for the specified information class."))
      CASE_ERRCODE2(STATUS_ACCESS_VIOLATION                                            , _T("The instruction at '0x%08lx' referenced memory at '0x%08lx'. The memory could not be '%s'."))
      CASE_ERRCODE2(STATUS_IN_PAGE_ERROR                                               , _T("The instruction at '0x%08lx' referenced memory at '0x%08lx'. The required data was not placed into memory because of an I/O error status of '0x%08lx'."))
      CASE_ERRCODE2(STATUS_PAGEFILE_QUOTA                                              , _T("The pagefile quota for the process has been exhausted."))
      CASE_ERRCODE2(STATUS_INVALID_HANDLE                                              , _T("An invalid HANDLE was specified."))
      CASE_ERRCODE2(STATUS_BAD_INITIAL_STACK                                           , _T("An invalid initial stack was specified in a call to NtCreateThread."))
      CASE_ERRCODE2(STATUS_BAD_INITIAL_PC                                              , _T("An invalid initial start address was specified in a call to NtCreateThread."))
      CASE_ERRCODE2(STATUS_INVALID_CID                                                 , _T("An invalid Client ID was specified."))
      CASE_ERRCODE2(STATUS_TIMER_NOT_CANCELED                                          , _T("An attempt was made to cancel or set a timer that has an associated APC and the subject thread is not the thread that originally set the timer with an associated APC routine."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER                                           , _T("An invalid parameter was passed to a service or function."))
      CASE_ERRCODE2(STATUS_NO_SUCH_DEVICE                                              , _T("A device which does not exist was specified."))
      CASE_ERRCODE2(STATUS_NO_SUCH_FILE                                                , _T("{File Not Found} The file %hs does not exist."))
      CASE_ERRCODE2(STATUS_INVALID_DEVICE_REQUEST                                      , _T("The specified request is not a valid operation for the target device."))
      CASE_ERRCODE2(STATUS_END_OF_FILE                                                 , _T("The end-of-file marker has been reached. There is no valid data in the file beyond this marker."))
      CASE_ERRCODE2(STATUS_WRONG_VOLUME                                                , _T("{Wrong Volume} The wrong volume is in the drive. Please insert volume %hs into drive %hs."))
      CASE_ERRCODE2(STATUS_NO_MEDIA_IN_DEVICE                                          , _T("{No Disk} There is no disk in the drive. Please insert a disk into drive %hs."))
      CASE_ERRCODE2(STATUS_UNRECOGNIZED_MEDIA                                          , _T("{Unknown Disk Format} The disk in drive %hs is not formatted properly. Please check the disk, and reformat if necessary."))
      CASE_ERRCODE2(STATUS_NONEXISTENT_SECTOR                                          , _T("{Sector Not Found} The specified sector does not exist."))
      CASE_ERRCODE2(STATUS_MORE_PROCESSING_REQUIRED                                    , _T("{Still Busy} The specified I/O request packet (IRP) cannot be disposed of because the I/O operation is not complete."))
      CASE_ERRCODE2(STATUS_NO_MEMORY                                                   , _T("{Not Enough Quota} Not enough virtual memory or paging file quota is available to complete the specified operation."))
      CASE_ERRCODE2(STATUS_CONFLICTING_ADDRESSES                                       , _T("{Conflicting Address Range} The specified address range conflicts with the address space."))
      CASE_ERRCODE2(STATUS_NOT_MAPPED_VIEW                                             , _T("Address range to unmap is not a mapped view."))
      CASE_ERRCODE2(STATUS_UNABLE_TO_FREE_VM                                           , _T("Virtual memory cannot be freed."))
      CASE_ERRCODE2(STATUS_UNABLE_TO_DELETE_SECTION                                    , _T("Specified section cannot be deleted."))
      CASE_ERRCODE2(STATUS_INVALID_SYSTEM_SERVICE                                      , _T("An invalid system service was specified in a system service call."))
      CASE_ERRCODE2(STATUS_ILLEGAL_INSTRUCTION                                         , _T("{EXCEPTION} Illegal Instruction. An attempt was made to execute an illegal instruction."))
      CASE_ERRCODE2(STATUS_INVALID_LOCK_SEQUENCE                                       , _T("{Invalid Lock Sequence} An attempt was made to execute an invalid lock sequence."))
      CASE_ERRCODE2(STATUS_INVALID_VIEW_SIZE                                           , _T("{Invalid Mapping} An attempt was made to create a view for a section which is bigger than the section."))
      CASE_ERRCODE2(STATUS_INVALID_FILE_FOR_SECTION                                    , _T("{Bad File} The attributes of the specified mapping file for a section of memory cannot be read."))
      CASE_ERRCODE2(STATUS_ALREADY_COMMITTED                                           , _T("{Already Committed} The specified address range is already committed."))
      CASE_ERRCODE2(STATUS_ACCESS_DENIED                                               , _T("{Access Denied} A process has requested access to an object, but has not been granted those access rights."))
      CASE_ERRCODE2(STATUS_BUFFER_TOO_SMALL                                            , _T("{Buffer Too Small} The buffer is too small to contain the entry. No information has been written to the buffer."))
      CASE_ERRCODE2(STATUS_OBJECT_TYPE_MISMATCH                                        , _T("{Wrong Type} There is a mismatch between the type of object required by the requested operation and the type of object that is specified in the request."))
      CASE_ERRCODE2(STATUS_NONCONTINUABLE_EXCEPTION                                    , _T("{EXCEPTION} Cannot Continue. Windows cannot continue from this exception."))
      CASE_ERRCODE2(STATUS_INVALID_DISPOSITION                                         , _T("An invalid exception disposition was returned by an exception handler."))
      CASE_ERRCODE2(STATUS_UNWIND                                                      , _T("Unwind exception code."))
      CASE_ERRCODE2(STATUS_BAD_STACK                                                   , _T("An invalid or unaligned stack was encountered during an unwind operation."))
      CASE_ERRCODE2(STATUS_INVALID_UNWIND_TARGET                                       , _T("An invalid unwind target was encountered during an unwind operation."))
      CASE_ERRCODE2(STATUS_NOT_LOCKED                                                  , _T("An attempt was made to unlock a page of memory which was not locked."))
      CASE_ERRCODE2(STATUS_PARITY_ERROR                                                , _T("Device parity error on I/O operation."))
      CASE_ERRCODE2(STATUS_UNABLE_TO_DECOMMIT_VM                                       , _T("An attempt was made to decommit uncommitted virtual memory."))
      CASE_ERRCODE2(STATUS_NOT_COMMITTED                                               , _T("An attempt was made to change the attributes on memory that has not been committed."))
      CASE_ERRCODE2(STATUS_INVALID_PORT_ATTRIBUTES                                     , _T("Invalid Object Attributes specified to NtCreatePort or invalid Port Attributes specified to NtConnectPort"))
      CASE_ERRCODE2(STATUS_PORT_MESSAGE_TOO_LONG                                       , _T("Length of message passed to NtRequestPort or NtRequestWaitReplyPort was longer than the maximum message allowed by the port."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_MIX                                       , _T("An invalid combination of parameters was specified."))
      CASE_ERRCODE2(STATUS_INVALID_QUOTA_LOWER                                         , _T("An attempt was made to lower a quota limit below the current usage."))
      CASE_ERRCODE2(STATUS_DISK_CORRUPT_ERROR                                          , _T("{Corrupt Disk} The file system structure on the disk is corrupt and unusable. Please run the Chkdsk utility on the volume %hs."))
      CASE_ERRCODE2(STATUS_OBJECT_NAME_INVALID                                         , _T("Object Name invalid."))
      CASE_ERRCODE2(STATUS_OBJECT_NAME_NOT_FOUND                                       , _T("Object Name not found."))
      CASE_ERRCODE2(STATUS_OBJECT_NAME_COLLISION                                       , _T("Object Name already exists."))
      CASE_ERRCODE2(STATUS_PORT_DISCONNECTED                                           , _T("Attempt to send a message to a disconnected communication port."))
      CASE_ERRCODE2(STATUS_DEVICE_ALREADY_ATTACHED                                     , _T("An attempt was made to attach to a device that was already attached to another device."))
      CASE_ERRCODE2(STATUS_OBJECT_PATH_INVALID                                         , _T("Object Path Component was not a directory object."))
      CASE_ERRCODE2(STATUS_OBJECT_PATH_NOT_FOUND                                       , _T("{Path Not Found} The path %hs does not exist."))
      CASE_ERRCODE2(STATUS_OBJECT_PATH_SYNTAX_BAD                                      , _T("Object Path Component was not a directory object."))
      CASE_ERRCODE2(STATUS_DATA_OVERRUN                                                , _T("{Data Overrun} A data overrun error occurred."))
      CASE_ERRCODE2(STATUS_DATA_LATE_ERROR                                             , _T("{Data Late} A data late error occurred."))
      CASE_ERRCODE2(STATUS_DATA_ERROR                                                  , _T("{Data Error} An error in reading or writing data occurred."))
      CASE_ERRCODE2(STATUS_CRC_ERROR                                                   , _T("{Bad CRC} A cyclic redundancy check (CRC) checksum error occurred."))
      CASE_ERRCODE2(STATUS_SECTION_TOO_BIG                                             , _T("{Section Too Large} The specified section is too big to map the file."))
      CASE_ERRCODE2(STATUS_PORT_CONNECTION_REFUSED                                     , _T("The NtConnectPort request is refused."))
      CASE_ERRCODE2(STATUS_INVALID_PORT_HANDLE                                         , _T("The type of port handle is invalid for the operation requested."))
      CASE_ERRCODE2(STATUS_SHARING_VIOLATION                                           , _T("A file cannot be opened because the share access flags are incompatible."))
      CASE_ERRCODE2(STATUS_QUOTA_EXCEEDED                                              , _T("Insufficient quota exists to complete the operation"))
      CASE_ERRCODE2(STATUS_INVALID_PAGE_PROTECTION                                     , _T("The specified page protection was not valid."))
      CASE_ERRCODE2(STATUS_MUTANT_NOT_OWNED                                            , _T("An attempt to release a mutant object was made by a thread that was not the owner of the mutant object."))
      CASE_ERRCODE2(STATUS_SEMAPHORE_LIMIT_EXCEEDED                                    , _T("An attempt was made to release a semaphore such that its maximum count would have been exceeded."))
      CASE_ERRCODE2(STATUS_PORT_ALREADY_SET                                            , _T("An attempt to set a processes DebugPort or ExceptionPort was made, but a port already exists in the process or an attempt to set a file's CompletionPort made, but a port was already set in the file."))
      CASE_ERRCODE2(STATUS_SECTION_NOT_IMAGE                                           , _T("An attempt was made to query image information on a section which does not map an image."))
      CASE_ERRCODE2(STATUS_SUSPEND_COUNT_EXCEEDED                                      , _T("An attempt was made to suspend a thread whose suspend count was at its maximum."))
      CASE_ERRCODE2(STATUS_THREAD_IS_TERMINATING                                       , _T("An attempt was made to suspend a thread that has begun termination."))
      CASE_ERRCODE2(STATUS_BAD_WORKING_SET_LIMIT                                       , _T("An attempt was made to set the working set limit to an invalid value (minimum greater than maximum, etc)."))
      CASE_ERRCODE2(STATUS_INCOMPATIBLE_FILE_MAP                                       , _T("A section was created to map a file which is not compatible to an already existing section which maps the same file."))
      CASE_ERRCODE2(STATUS_SECTION_PROTECTION                                          , _T("A view to a section specifies a protection which is incompatible with the initial view's protection."))
      CASE_ERRCODE2(STATUS_EAS_NOT_SUPPORTED                                           , _T("An operation involving EAs failed because the file system does not support EAs."))
      CASE_ERRCODE2(STATUS_EA_TOO_LARGE                                                , _T("An EA operation failed because EA set is too large."))
      CASE_ERRCODE2(STATUS_NONEXISTENT_EA_ENTRY                                        , _T("An EA operation failed because the name or EA index is invalid."))
      CASE_ERRCODE2(STATUS_NO_EAS_ON_FILE                                              , _T("The file for which EAs were requested has no EAs."))
      CASE_ERRCODE2(STATUS_EA_CORRUPT_ERROR                                            , _T("The EA is corrupt and non-readable."))
      CASE_ERRCODE2(STATUS_FILE_LOCK_CONFLICT                                          , _T("A requested read/write cannot be granted due to a conflicting file lock."))
      CASE_ERRCODE2(STATUS_LOCK_NOT_GRANTED                                            , _T("A requested file lock cannot be granted due to other existing locks."))
      CASE_ERRCODE2(STATUS_DELETE_PENDING                                              , _T("A non close operation has been requested of a file object with a delete pending."))
      CASE_ERRCODE2(STATUS_CTL_FILE_NOT_SUPPORTED                                      , _T("An attempt was made to set the control attribute on a file. This attribute is not supported in the target file system."))
      CASE_ERRCODE2(STATUS_UNKNOWN_REVISION                                            , _T("Indicates a revision number encountered or specified is not one known by the service. It may be a more recent revision than the service is aware of."))
      CASE_ERRCODE2(STATUS_REVISION_MISMATCH                                           , _T("Indicates two revision levels are incompatible."))
      CASE_ERRCODE2(STATUS_INVALID_OWNER                                               , _T("Indicates a particular Security ID may not be assigned as the owner of an object."))
      CASE_ERRCODE2(STATUS_INVALID_PRIMARY_GROUP                                       , _T("Indicates a particular Security ID may not be assigned as the primary group of an object."))
      CASE_ERRCODE2(STATUS_NO_IMPERSONATION_TOKEN                                      , _T("An attempt has been made to operate on an impersonation token by a thread that is not currently impersonating a client."))
      CASE_ERRCODE2(STATUS_CANT_DISABLE_MANDATORY                                      , _T("A mandatory group may not be disabled."))
      CASE_ERRCODE2(STATUS_NO_LOGON_SERVERS                                            , _T("There are currently no logon servers available to service the logon request."))
      CASE_ERRCODE2(STATUS_NO_SUCH_LOGON_SESSION                                       , _T("A specified logon session does not exist. It may already have been terminated."))
      CASE_ERRCODE2(STATUS_NO_SUCH_PRIVILEGE                                           , _T("A specified privilege does not exist."))
      CASE_ERRCODE2(STATUS_PRIVILEGE_NOT_HELD                                          , _T("A required privilege is not held by the client."))
      CASE_ERRCODE2(STATUS_INVALID_ACCOUNT_NAME                                        , _T("The name provided is not a properly formed account name."))
      CASE_ERRCODE2(STATUS_USER_EXISTS                                                 , _T("The specified user already exists."))
      CASE_ERRCODE2(STATUS_NO_SUCH_USER                                                , _T("The specified user does not exist."))
      CASE_ERRCODE2(STATUS_GROUP_EXISTS                                                , _T("The specified group already exists."))
      CASE_ERRCODE2(STATUS_NO_SUCH_GROUP                                               , _T("The specified group does not exist."))
      CASE_ERRCODE2(STATUS_MEMBER_IN_GROUP                                             , _T("The specified user account is already in the specified group account. Also used to indicate a group cannot be deleted because it contains a member."))
      CASE_ERRCODE2(STATUS_MEMBER_NOT_IN_GROUP                                         , _T("The specified user account is not a member of the specified group account."))
      CASE_ERRCODE2(STATUS_LAST_ADMIN                                                  , _T("Indicates the requested operation would disable or delete the last remaining administration account. This is not allowed to prevent creating a situation in which the system cannot be administrated."))
      CASE_ERRCODE2(STATUS_WRONG_PASSWORD                                              , _T("When trying to update a password, this return status indicates that the value provided as the current password is not correct."))
      CASE_ERRCODE2(STATUS_ILL_FORMED_PASSWORD                                         , _T("When trying to update a password, this return status indicates that the value provided for the new password contains values that are not allowed in passwords."))
      CASE_ERRCODE2(STATUS_PASSWORD_RESTRICTION                                        , _T("When trying to update a password, this status indicates that some password update rule has been violated. For example, the password may not meet length criteria."))
      CASE_ERRCODE2(STATUS_LOGON_FAILURE                                               , _T("The attempted logon is invalid. This is either due to a bad username or authentication information."))
      CASE_ERRCODE2(STATUS_ACCOUNT_RESTRICTION                                         , _T("Indicates a referenced user name and authentication information are valid, but some user account restriction has prevented successful authentication (such as time-of-day restrictions)."))
      CASE_ERRCODE2(STATUS_INVALID_LOGON_HOURS                                         , _T("The user account has time restrictions and may not be logged onto at this time."))
      CASE_ERRCODE2(STATUS_INVALID_WORKSTATION                                         , _T("The user account is restricted such that it may not be used to log on from the source workstation."))
      CASE_ERRCODE2(STATUS_PASSWORD_EXPIRED                                            , _T("The user account's password has expired."))
      CASE_ERRCODE2(STATUS_ACCOUNT_DISABLED                                            , _T("The referenced account is currently disabled and may not be logged on to."))
      CASE_ERRCODE2(STATUS_NONE_MAPPED                                                 , _T("None of the information to be translated has been translated."))
      CASE_ERRCODE2(STATUS_TOO_MANY_LUIDS_REQUESTED                                    , _T("The number of LUIDs requested may not be allocated with a single allocation."))
      CASE_ERRCODE2(STATUS_LUIDS_EXHAUSTED                                             , _T("Indicates there are no more LUIDs to allocate."))
      CASE_ERRCODE2(STATUS_INVALID_SUB_AUTHORITY                                       , _T("Indicates the sub-authority value is invalid for the particular use."))
      CASE_ERRCODE2(STATUS_INVALID_ACL                                                 , _T("Indicates the ACL structure is not valid."))
      CASE_ERRCODE2(STATUS_INVALID_SID                                                 , _T("Indicates the SID structure is not valid."))
      CASE_ERRCODE2(STATUS_INVALID_SECURITY_DESCR                                      , _T("Indicates the SECURITY_DESCRIPTOR structure is not valid."))
      CASE_ERRCODE2(STATUS_PROCEDURE_NOT_FOUND                                         , _T("Indicates the specified procedure address cannot be found in the DLL."))
      CASE_ERRCODE2(STATUS_INVALID_IMAGE_FORMAT                                        , _T("{Bad Image} The application or DLL %hs is not a valid Windows image. Please check this against your installation diskette."))
      CASE_ERRCODE2(STATUS_NO_TOKEN                                                    , _T("An attempt was made to reference a token that doesn't exist. This is typically done by referencing the token associated with a thread when the thread is not impersonating a client."))
      CASE_ERRCODE2(STATUS_BAD_INHERITANCE_ACL                                         , _T("Indicates that an attempt to build either an inherited ACL or ACE was not successful. This can be caused by a number of things. One of the more probable causes is the replacement of a CreatorId with an SID that didn't fit into the ACE or ACL."))
      CASE_ERRCODE2(STATUS_RANGE_NOT_LOCKED                                            , _T("The range specified in NtUnlockFile was not locked."))
      CASE_ERRCODE2(STATUS_DISK_FULL                                                   , _T("An operation failed because the disk was full."))
      CASE_ERRCODE2(STATUS_SERVER_DISABLED                                             , _T("The GUID allocation server is [already] disabled at the moment."))
      CASE_ERRCODE2(STATUS_SERVER_NOT_DISABLED                                         , _T("The GUID allocation server is [already] enabled at the moment."))
      CASE_ERRCODE2(STATUS_TOO_MANY_GUIDS_REQUESTED                                    , _T("Too many GUIDs were requested from the allocation server at once."))
      CASE_ERRCODE2(STATUS_GUIDS_EXHAUSTED                                             , _T("The GUIDs could not be allocated because the Authority Agent was exhausted."))
      CASE_ERRCODE2(STATUS_INVALID_ID_AUTHORITY                                        , _T("The value provided was an invalid value for an identifier authority."))
      CASE_ERRCODE2(STATUS_AGENTS_EXHAUSTED                                            , _T("There are no more authority agent values available for the given identifier authority value."))
      CASE_ERRCODE2(STATUS_INVALID_VOLUME_LABEL                                        , _T("An invalid volume label has been specified."))
      CASE_ERRCODE2(STATUS_SECTION_NOT_EXTENDED                                        , _T("A mapped section could not be extended."))
      CASE_ERRCODE2(STATUS_NOT_MAPPED_DATA                                             , _T("Specified section to flush does not map a data file."))
      CASE_ERRCODE2(STATUS_RESOURCE_DATA_NOT_FOUND                                     , _T("Indicates the specified image file did not contain a resource section."))
      CASE_ERRCODE2(STATUS_RESOURCE_TYPE_NOT_FOUND                                     , _T("Indicates the specified resource type cannot be found in the image file."))
      CASE_ERRCODE2(STATUS_RESOURCE_NAME_NOT_FOUND                                     , _T("Indicates the specified resource name cannot be found in the image file."))
      CASE_ERRCODE2(STATUS_ARRAY_BOUNDS_EXCEEDED                                       , _T("{EXCEPTION} Array bounds exceeded."))
      CASE_ERRCODE2(STATUS_FLOAT_DENORMAL_OPERAND                                      , _T("{EXCEPTION} Floating-point denormal operand."))
      CASE_ERRCODE2(STATUS_FLOAT_DIVIDE_BY_ZERO                                        , _T("{EXCEPTION} Floating-point division by zero."))
      CASE_ERRCODE2(STATUS_FLOAT_INEXACT_RESULT                                        , _T("{EXCEPTION} Floating-point inexact result."))
      CASE_ERRCODE2(STATUS_FLOAT_INVALID_OPERATION                                     , _T("{EXCEPTION} Floating-point invalid operation."))
      CASE_ERRCODE2(STATUS_FLOAT_OVERFLOW                                              , _T("{EXCEPTION} Floating-point overflow."))
      CASE_ERRCODE2(STATUS_FLOAT_STACK_CHECK                                           , _T("{EXCEPTION} Floating-point stack check."))
      CASE_ERRCODE2(STATUS_FLOAT_UNDERFLOW                                             , _T("{EXCEPTION} Floating-point underflow."))
      CASE_ERRCODE2(STATUS_INTEGER_DIVIDE_BY_ZERO                                      , _T("{EXCEPTION} Integer division by zero."))
      CASE_ERRCODE2(STATUS_INTEGER_OVERFLOW                                            , _T("{EXCEPTION} Integer overflow."))
      CASE_ERRCODE2(STATUS_PRIVILEGED_INSTRUCTION                                      , _T("{EXCEPTION} Privileged instruction."))
      CASE_ERRCODE2(STATUS_TOO_MANY_PAGING_FILES                                       , _T("An attempt was made to install more paging files than the system supports."))
      CASE_ERRCODE2(STATUS_FILE_INVALID                                                , _T("The volume for a file has been externally altered such that the opened file is no longer valid."))
      CASE_ERRCODE2(STATUS_ALLOTTED_SPACE_EXCEEDED                                     , _T("When a block of memory is allotted for future updates, such as the memory allocated to hold discretionary access control and primary group information, successive updates may exceed the amount of memory originally allotted. Since quota may already have been charged to several processes which have handles to the object, it is not reasonable to alter the size of the allocated memory. Instead, a request that requires more memory than has been allotted must fail and the STATUS_ALLOTED_SPACE_EXCEEDED error returned."))
      CASE_ERRCODE2(STATUS_INSUFFICIENT_RESOURCES                                      , _T("Insufficient system resources exist to complete the API."))
      CASE_ERRCODE2(STATUS_DFS_EXIT_PATH_FOUND                                         , _T("An attempt has been made to open a DFS exit path control file."))
      CASE_ERRCODE2(STATUS_DEVICE_DATA_ERROR                                           , _T("STATUS_DEVICE_DATA_ERROR"))
      CASE_ERRCODE2(STATUS_DEVICE_NOT_CONNECTED                                        , _T("STATUS_DEVICE_NOT_CONNECTED"))
      CASE_ERRCODE2(STATUS_DEVICE_POWER_FAILURE                                        , _T("STATUS_DEVICE_POWER_FAILURE"))
      CASE_ERRCODE2(STATUS_FREE_VM_NOT_AT_BASE                                         , _T("Virtual memory cannot be freed as base address is not the base of the region and a region size of zero was specified."))
      CASE_ERRCODE2(STATUS_MEMORY_NOT_ALLOCATED                                        , _T("An attempt was made to free virtual memory which is not allocated."))
      CASE_ERRCODE2(STATUS_WORKING_SET_QUOTA                                           , _T("The working set is not big enough to allow the requested pages to be locked."))
      CASE_ERRCODE2(STATUS_MEDIA_WRITE_PROTECTED                                       , _T("{Write Protect Error} The disk cannot be written to because it is write protected. Please remove the write protection from the volume %hs in drive %hs."))
      CASE_ERRCODE2(STATUS_DEVICE_NOT_READY                                            , _T("{Drive Not Ready} The drive is not ready for use; its door may be open. Please check drive %hs and make sure that a disk is inserted and that the drive door is closed."))
      CASE_ERRCODE2(STATUS_INVALID_GROUP_ATTRIBUTES                                    , _T("The specified attributes are invalid, or incompatible with the attributes for the group as a whole."))
      CASE_ERRCODE2(STATUS_BAD_IMPERSONATION_LEVEL                                     , _T("A specified impersonation level is invalid. Also used to indicate a required impersonation level was not provided."))
      CASE_ERRCODE2(STATUS_CANT_OPEN_ANONYMOUS                                         , _T("An attempt was made to open an Anonymous level token. Anonymous tokens may not be opened."))
      CASE_ERRCODE2(STATUS_BAD_VALIDATION_CLASS                                        , _T("The validation information class requested was invalid."))
      CASE_ERRCODE2(STATUS_BAD_TOKEN_TYPE                                              , _T("The type of a token object is inappropriate for its attempted use."))
      CASE_ERRCODE2(STATUS_BAD_MASTER_BOOT_RECORD                                      , _T("The type of a token object is inappropriate for its attempted use."))
      CASE_ERRCODE2(STATUS_INSTRUCTION_MISALIGNMENT                                    , _T("An attempt was made to execute an instruction at an unaligned address and the host system does not support unaligned instruction references."))
      CASE_ERRCODE2(STATUS_INSTANCE_NOT_AVAILABLE                                      , _T("The maximum named pipe instance count has been reached."))
      CASE_ERRCODE2(STATUS_PIPE_NOT_AVAILABLE                                          , _T("An instance of a named pipe cannot be found in the listening state."))
      CASE_ERRCODE2(STATUS_INVALID_PIPE_STATE                                          , _T("The named pipe is not in the connected or closing state."))
      CASE_ERRCODE2(STATUS_PIPE_BUSY                                                   , _T("The specified pipe is set to complete operations and there are current I/O operations queued so it cannot be changed to queue operations."))
      CASE_ERRCODE2(STATUS_ILLEGAL_FUNCTION                                            , _T("The specified handle is not open to the server end of the named pipe."))
      CASE_ERRCODE2(STATUS_PIPE_DISCONNECTED                                           , _T("The specified named pipe is in the disconnected state."))
      CASE_ERRCODE2(STATUS_PIPE_CLOSING                                                , _T("The specified named pipe is in the closing state."))
      CASE_ERRCODE2(STATUS_PIPE_CONNECTED                                              , _T("The specified named pipe is in the connected state."))
      CASE_ERRCODE2(STATUS_PIPE_LISTENING                                              , _T("The specified named pipe is in the listening state."))
      CASE_ERRCODE2(STATUS_INVALID_READ_MODE                                           , _T("The specified named pipe is not in message mode."))
      CASE_ERRCODE2(STATUS_IO_TIMEOUT                                                  , _T("{Device Timeout} The specified I/O operation on %hs was not completed before the time-out period expired."))
      CASE_ERRCODE2(STATUS_FILE_FORCED_CLOSED                                          , _T("The specified file has been closed by another process."))
      CASE_ERRCODE2(STATUS_PROFILING_NOT_STARTED                                       , _T("Profiling not started."))
      CASE_ERRCODE2(STATUS_PROFILING_NOT_STOPPED                                       , _T("Profiling not stopped."))
      CASE_ERRCODE2(STATUS_COULD_NOT_INTERPRET                                         , _T("The passed ACL did not contain the minimum required information."))
      CASE_ERRCODE2(STATUS_FILE_IS_A_DIRECTORY                                         , _T("The file that was specified as a target is a directory and the caller specified that it could be anything but a directory."))
      CASE_ERRCODE2(STATUS_NOT_SUPPORTED                                               , _T("The request is not supported."))
      CASE_ERRCODE2(STATUS_REMOTE_NOT_LISTENING                                        , _T("This remote computer is not listening."))
      CASE_ERRCODE2(STATUS_DUPLICATE_NAME                                              , _T("A duplicate name exists on the network."))
      CASE_ERRCODE2(STATUS_BAD_NETWORK_PATH                                            , _T("The network path cannot be located."))
      CASE_ERRCODE2(STATUS_NETWORK_BUSY                                                , _T("The network is busy."))
      CASE_ERRCODE2(STATUS_DEVICE_DOES_NOT_EXIST                                       , _T("This device does not exist."))
      CASE_ERRCODE2(STATUS_TOO_MANY_COMMANDS                                           , _T("The network BIOS command limit has been reached."))
      CASE_ERRCODE2(STATUS_ADAPTER_HARDWARE_ERROR                                      , _T("An I/O adapter hardware error has occurred."))
      CASE_ERRCODE2(STATUS_INVALID_NETWORK_RESPONSE                                    , _T("The network responded incorrectly."))
      CASE_ERRCODE2(STATUS_UNEXPECTED_NETWORK_ERROR                                    , _T("An unexpected network error occurred."))
      CASE_ERRCODE2(STATUS_BAD_REMOTE_ADAPTER                                          , _T("The remote adapter is not compatible."))
      CASE_ERRCODE2(STATUS_PRINT_QUEUE_FULL                                            , _T("The printer queue is full."))
      CASE_ERRCODE2(STATUS_NO_SPOOL_SPACE                                              , _T("Space to store the file waiting to be printed is not available on the server."))
      CASE_ERRCODE2(STATUS_PRINT_CANCELLED                                             , _T("The requested print file has been canceled."))
      CASE_ERRCODE2(STATUS_NETWORK_NAME_DELETED                                        , _T("The network name was deleted."))
      CASE_ERRCODE2(STATUS_NETWORK_ACCESS_DENIED                                       , _T("Network access is denied."))
      CASE_ERRCODE2(STATUS_BAD_DEVICE_TYPE                                             , _T("{Incorrect Network Resource Type} The specified device type (LPT, for example) conflicts with the actual device type on the remote resource."))
      CASE_ERRCODE2(STATUS_BAD_NETWORK_NAME                                            , _T("{Network Name Not Found} The specified share name cannot be found on the remote server."))
      CASE_ERRCODE2(STATUS_TOO_MANY_NAMES                                              , _T("The name limit for the local computer network adapter card was exceeded."))
      CASE_ERRCODE2(STATUS_TOO_MANY_SESSIONS                                           , _T("The network BIOS session limit was exceeded."))
      CASE_ERRCODE2(STATUS_SHARING_PAUSED                                              , _T("File sharing has been temporarily paused."))
      CASE_ERRCODE2(STATUS_REQUEST_NOT_ACCEPTED                                        , _T("No more connections can be made to this remote computer at this time because there are already as many connections as the computer can accept."))
      CASE_ERRCODE2(STATUS_REDIRECTOR_PAUSED                                           , _T("Print or disk redirection is temporarily paused."))
      CASE_ERRCODE2(STATUS_NET_WRITE_FAULT                                             , _T("A network data fault occurred."))
      CASE_ERRCODE2(STATUS_PROFILING_AT_LIMIT                                          , _T("The number of active profiling objects is at the maximum and no more may be started."))
      CASE_ERRCODE2(STATUS_NOT_SAME_DEVICE                                             , _T("{Incorrect Volume} The target file of a rename request is located on a different device than the source of the rename request."))
      CASE_ERRCODE2(STATUS_FILE_RENAMED                                                , _T("The file specified has been renamed and thus cannot be modified."))
      CASE_ERRCODE2(STATUS_VIRTUAL_CIRCUIT_CLOSED                                      , _T("{Network Request Timeout} The session with a remote server has been disconnected because the time-out interval for a request has expired."))
      CASE_ERRCODE2(STATUS_NO_SECURITY_ON_OBJECT                                       , _T("Indicates an attempt was made to operate on the security of an object that does not have security associated with it."))
      CASE_ERRCODE2(STATUS_CANT_WAIT                                                   , _T("Used to indicate that an operation cannot continue without blocking for I/O."))
      CASE_ERRCODE2(STATUS_PIPE_EMPTY                                                  , _T("Used to indicate that a read operation was done on an empty pipe."))
      CASE_ERRCODE2(STATUS_CANT_ACCESS_DOMAIN_INFO                                     , _T("Configuration information could not be read from the domain controller, either because the machine is unavailable, or access has been denied."))
      CASE_ERRCODE2(STATUS_CANT_TERMINATE_SELF                                         , _T("Indicates that a thread attempted to terminate itself by default (called NtTerminateThread with NULL) and it was the last thread in the current process."))
      CASE_ERRCODE2(STATUS_INVALID_SERVER_STATE                                        , _T("Indicates the Sam Server was in the wrong state to perform the desired operation."))
      CASE_ERRCODE2(STATUS_INVALID_DOMAIN_STATE                                        , _T("Indicates the Domain was in the wrong state to perform the desired operation."))
      CASE_ERRCODE2(STATUS_INVALID_DOMAIN_ROLE                                         , _T("This operation is only allowed for the Primary Domain Controller of the domain."))
      CASE_ERRCODE2(STATUS_NO_SUCH_DOMAIN                                              , _T("The specified Domain did not exist."))
      CASE_ERRCODE2(STATUS_DOMAIN_EXISTS                                               , _T("The specified Domain already exists."))
      CASE_ERRCODE2(STATUS_DOMAIN_LIMIT_EXCEEDED                                       , _T("An attempt was made to exceed the limit on the number of domains per server for this release."))
      CASE_ERRCODE2(STATUS_OPLOCK_NOT_GRANTED                                          , _T("Error status returned when oplock request is denied."))
      CASE_ERRCODE2(STATUS_INVALID_OPLOCK_PROTOCOL                                     , _T("Error status returned when an invalid oplock acknowledgment is received by a file system."))
      CASE_ERRCODE2(STATUS_INTERNAL_DB_CORRUPTION                                      , _T("This error indicates that the requested operation cannot be completed due to a catastrophic media failure or on-disk data structure corruption."))
      CASE_ERRCODE2(STATUS_INTERNAL_ERROR                                              , _T("An internal error occurred."))
      CASE_ERRCODE2(STATUS_GENERIC_NOT_MAPPED                                          , _T("Indicates generic access types were contained in an access mask which should already be mapped to non-generic access types."))
      CASE_ERRCODE2(STATUS_BAD_DESCRIPTOR_FORMAT                                       , _T("Indicates a security descriptor is not in the necessary format (absolute or self-relative)."))
      CASE_ERRCODE2(STATUS_INVALID_USER_BUFFER                                         , _T("An access to a user buffer failed at an 'expected' point in time. This code is defined since the caller does not want to accept STATUS_ACCESS_VIOLATION in its filter."))
      CASE_ERRCODE2(STATUS_UNEXPECTED_IO_ERROR                                         , _T("If an I/O error is returned which is not defined in the standard FsRtl filter, it is converted to the following error which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception."))
      CASE_ERRCODE2(STATUS_UNEXPECTED_MM_CREATE_ERR                                    , _T("If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception."))
      CASE_ERRCODE2(STATUS_UNEXPECTED_MM_MAP_ERROR                                     , _T("If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception."))
      CASE_ERRCODE2(STATUS_UNEXPECTED_MM_EXTEND_ERR                                    , _T("If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception."))
      CASE_ERRCODE2(STATUS_NOT_LOGON_PROCESS                                           , _T("The requested action is restricted for use by logon processes only. The calling process has not registered as a logon process."))
      CASE_ERRCODE2(STATUS_LOGON_SESSION_EXISTS                                        , _T("An attempt has been made to start a new session manager or LSA logon session with an ID that is already in use."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_1                                         , _T("An invalid parameter was passed to a service or function as the first argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_2                                         , _T("An invalid parameter was passed to a service or function as the second argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_3                                         , _T("An invalid parameter was passed to a service or function as the third argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_4                                         , _T("An invalid parameter was passed to a service or function as the fourth argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_5                                         , _T("An invalid parameter was passed to a service or function as the fifth argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_6                                         , _T("An invalid parameter was passed to a service or function as the sixth argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_7                                         , _T("An invalid parameter was passed to a service or function as the seventh argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_8                                         , _T("An invalid parameter was passed to a service or function as the eighth argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_9                                         , _T("An invalid parameter was passed to a service or function as the ninth argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_10                                        , _T("An invalid parameter was passed to a service or function as the tenth argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_11                                        , _T("An invalid parameter was passed to a service or function as the eleventh argument."))
      CASE_ERRCODE2(STATUS_INVALID_PARAMETER_12                                        , _T("An invalid parameter was passed to a service or function as the twelfth argument."))
      CASE_ERRCODE2(STATUS_REDIRECTOR_NOT_STARTED                                      , _T("An attempt was made to access a network file, but the network software was not yet started."))
      CASE_ERRCODE2(STATUS_REDIRECTOR_STARTED                                          , _T("An attempt was made to start the redirector, but the redirector has already been started."))
      CASE_ERRCODE2(STATUS_STACK_OVERFLOW                                              , _T("A new guard page for the stack cannot be created."))
      CASE_ERRCODE2(STATUS_NO_SUCH_PACKAGE                                             , _T("A specified authentication package is unknown."))
      CASE_ERRCODE2(STATUS_BAD_FUNCTION_TABLE                                          , _T("A malformed function table was encountered during an unwind operation."))
      CASE_ERRCODE2(STATUS_VARIABLE_NOT_FOUND                                          , _T("Indicates the specified environment variable name was not found in the specified environment block."))
      CASE_ERRCODE2(STATUS_DIRECTORY_NOT_EMPTY                                         , _T("Indicates that the directory trying to be deleted is not empty."))
      CASE_ERRCODE2(STATUS_FILE_CORRUPT_ERROR                                          , _T("{Corrupt File} The file or directory %hs is corrupt and unreadable. Please run the Chkdsk utility."))
      CASE_ERRCODE2(STATUS_NOT_A_DIRECTORY                                             , _T("A requested opened file is not a directory."))
      CASE_ERRCODE2(STATUS_BAD_LOGON_SESSION_STATE                                     , _T("The logon session is not in a state that is consistent with the requested operation."))
      CASE_ERRCODE2(STATUS_LOGON_SESSION_COLLISION                                     , _T("An internal LSA error has occurred. An authentication package has requested the creation of a Logon Session but the ID of an already existing Logon Session has been specified."))
      CASE_ERRCODE2(STATUS_NAME_TOO_LONG                                               , _T("A specified name string is too long for its intended use."))
      CASE_ERRCODE2(STATUS_FILES_OPEN                                                  , _T("The user attempted to force close the files on a redirected drive, but there were opened files on the drive, and the user did not specify a sufficient level of force."))
      CASE_ERRCODE2(STATUS_CONNECTION_IN_USE                                           , _T("The user attempted to force close the files on a redirected drive, but there were opened directories on the drive, and the user did not specify a sufficient level of force."))
      CASE_ERRCODE2(STATUS_MESSAGE_NOT_FOUND                                           , _T("RtlFindMessage could not locate the requested message ID in the message table resource."))
      CASE_ERRCODE2(STATUS_PROCESS_IS_TERMINATING                                      , _T("An attempt was made to duplicate an object handle into or out of an exiting process."))
      CASE_ERRCODE2(STATUS_INVALID_LOGON_TYPE                                          , _T("Indicates an invalid value has been provided for the LogonType requested."))
      CASE_ERRCODE2(STATUS_NO_GUID_TRANSLATION                                         , _T("Indicates that an attempt was made to assign protection to a file system file or directory and one of the SIDs in the security descriptor could not be translated into a GUID that could be stored by the file system. This causes the protection attempt to fail, which may cause a file creation attempt to fail."))
      CASE_ERRCODE2(STATUS_CANNOT_IMPERSONATE                                          , _T("Indicates that an attempt has been made to impersonate via a named pipe that has not yet been read from."))
      CASE_ERRCODE2(STATUS_IMAGE_ALREADY_LOADED                                        , _T("Indicates that the specified image is already loaded."))
      CASE_ERRCODE1(STATUS_ABIOS_NOT_PRESENT           )
      CASE_ERRCODE1(STATUS_ABIOS_LID_NOT_EXIST         )
      CASE_ERRCODE1(STATUS_ABIOS_LID_ALREADY_OWNED     )
      CASE_ERRCODE1(STATUS_ABIOS_NOT_LID_OWNER         )
      CASE_ERRCODE1(STATUS_ABIOS_INVALID_COMMAND       )
      CASE_ERRCODE1(STATUS_ABIOS_INVALID_LID           )
      CASE_ERRCODE1(STATUS_ABIOS_SELECTOR_NOT_AVAILABLE)
      CASE_ERRCODE1(STATUS_ABIOS_INVALID_SELECTOR      )
      CASE_ERRCODE2(STATUS_NO_LDT                                                      , _T("Indicates that an attempt was made to change the size of the LDT for a process that has no LDT."))
      CASE_ERRCODE2(STATUS_INVALID_LDT_SIZE                                            , _T("Indicates that an attempt was made to grow an LDT by setting its size, or that the size was not an even number of selectors."))
      CASE_ERRCODE2(STATUS_INVALID_LDT_OFFSET                                          , _T("Indicates that the starting value for the LDT information was not an integral multiple of the selector size."))
      CASE_ERRCODE2(STATUS_INVALID_LDT_DESCRIPTOR                                      , _T("Indicates that the user supplied an invalid descriptor when trying to set up Ldt descriptors."))
      CASE_ERRCODE2(STATUS_INVALID_IMAGE_NE_FORMAT                                     , _T("The specified image file did not have the correct format. It appears to be NE format."))
      CASE_ERRCODE2(STATUS_RXACT_INVALID_STATE                                         , _T("Indicates that the transaction state of a registry sub-tree is incompatible with the requested operation. For example, a request has been made to start a new transaction with one already in progress, or a request has been made to apply a transaction when one is not currently in progress."))
      CASE_ERRCODE2(STATUS_RXACT_COMMIT_FAILURE                                        , _T("Indicates an error has occurred during a registry transaction commit. The database has been left in an unknown, but probably inconsistent, state. The state of the registry transaction is left as COMMITTING."))
      CASE_ERRCODE2(STATUS_MAPPED_FILE_SIZE_ZERO                                       , _T("An attempt was made to map a file of size zero with the maximum size specified as zero."))
      CASE_ERRCODE2(STATUS_TOO_MANY_OPENED_FILES                                       , _T("Too many files are opened on a remote server. This error should only be returned by the Windows redirector on a remote drive."))
      CASE_ERRCODE2(STATUS_CANCELLED                                                   , _T("The I/O request was canceled."))
      CASE_ERRCODE2(STATUS_CANNOT_DELETE                                               , _T("An attempt has been made to remove a file or directory that cannot be deleted."))
      CASE_ERRCODE2(STATUS_INVALID_COMPUTER_NAME                                       , _T("Indicates a name specified as a remote computer name is syntactically invalid."))
      CASE_ERRCODE2(STATUS_FILE_DELETED                                                , _T("An I/O request other than close was performed on a file after it has been deleted, which can only happen to a request which did not complete before the last handle was closed via NtClose."))
      CASE_ERRCODE2(STATUS_SPECIAL_ACCOUNT                                             , _T("Indicates an operation has been attempted on a built-in (special) SAM account which is incompatible with built-in accounts. For example, built-in accounts cannot be deleted."))
      CASE_ERRCODE2(STATUS_SPECIAL_GROUP                                               , _T("The operation requested may not be performed on the specified group because it is a built-in special group."))
      CASE_ERRCODE2(STATUS_SPECIAL_USER                                                , _T("The operation requested may not be performed on the specified user because it is a built-in special user."))
      CASE_ERRCODE2(STATUS_MEMBERS_PRIMARY_GROUP                                       , _T("Indicates a member cannot be removed from a group because the group is currently the member's primary group."))
      CASE_ERRCODE2(STATUS_FILE_CLOSED                                                 , _T("An I/O request other than close and several other special case operations was attempted using a file object that had already been closed."))
      CASE_ERRCODE2(STATUS_TOO_MANY_THREADS                                            , _T("Indicates a process has too many threads to perform the requested action. For example, assignment of a primary token may only be performed when a process has zero or one threads."))
      CASE_ERRCODE2(STATUS_THREAD_NOT_IN_PROCESS                                       , _T("An attempt was made to operate on a thread within a specific process, but the thread specified is not in the process specified."))
      CASE_ERRCODE2(STATUS_TOKEN_ALREADY_IN_USE                                        , _T("An attempt was made to establish a token for use as a primary token but the token is already in use. A token can only be the primary token of one process at a time."))
      CASE_ERRCODE2(STATUS_PAGEFILE_QUOTA_EXCEEDED                                     , _T("Page file quota was exceeded."))
      CASE_ERRCODE2(STATUS_COMMITMENT_LIMIT                                            , _T("{Out of Virtual Memory} Your system is low on virtual memory. To ensure that Windows runs properly, increase the size of your virtual memory paging file. For more information, see Help."))
      CASE_ERRCODE2(STATUS_INVALID_IMAGE_LE_FORMAT                                     , _T("The specified image file did not have the correct format, it appears to be LE format."))
      CASE_ERRCODE2(STATUS_INVALID_IMAGE_NOT_MZ                                        , _T("The specified image file did not have the correct format, it did not have an initial MZ."))
      CASE_ERRCODE2(STATUS_INVALID_IMAGE_PROTECT                                       , _T("The specified image file did not have the correct format, it did not have a proper e_lfarlc in the MZ header."))
      CASE_ERRCODE2(STATUS_INVALID_IMAGE_WIN_16                                        , _T("The specified image file did not have the correct format, it appears to be a 16-bit Windows image."))
      CASE_ERRCODE2(STATUS_LOGON_SERVER_CONFLICT                                       , _T("The Netlogon service cannot start because another Netlogon service running in the domain conflicts with the specified role."))
      CASE_ERRCODE2(STATUS_TIME_DIFFERENCE_AT_DC                                       , _T("The time at the Primary Domain Controller is different than the time at the Backup Domain Controller or member server by too large an amount."))
      CASE_ERRCODE2(STATUS_SYNCHRONIZATION_REQUIRED                                    , _T("The SAM database on a Windows Server is significantly out of synchronization with the copy on the Domain Controller. A complete synchronization is required."))
      CASE_ERRCODE2(STATUS_DLL_NOT_FOUND                                               , _T("{Unable To Locate Component} This application has failed to start because %hs was not found. Re-installing the application may fix this problem."))
      CASE_ERRCODE2(STATUS_OPEN_FAILED                                                 , _T("The NtCreateFile API failed. This error should never be returned to an application, it is a place holder for the Windows Lan Manager Redirector to use in its internal error mapping routines."))
      CASE_ERRCODE2(STATUS_IO_PRIVILEGE_FAILED                                         , _T("{Privilege Failed} The I/O permissions for the process could not be changed."))
      CASE_ERRCODE2(STATUS_ORDINAL_NOT_FOUND                                           , _T("{Ordinal Not Found} The ordinal %ld could not be located in the dynamic link library %hs."))
      CASE_ERRCODE2(STATUS_ENTRYPOINT_NOT_FOUND                                        , _T("{Entry Point Not Found} The procedure entry point %hs could not be located in the dynamic link library %hs."))
      CASE_ERRCODE2(STATUS_CONTROL_C_EXIT                                              , _T("{Application Exit by CTRL+C} The application terminated as a result of a CTRL+C."))
      CASE_ERRCODE2(STATUS_LOCAL_DISCONNECT                                            , _T("{Virtual Circuit Closed} The network transport on your computer has closed a network connection. There may or may not be I/O requests outstanding."))
      CASE_ERRCODE2(STATUS_REMOTE_DISCONNECT                                           , _T("{Virtual Circuit Closed} The network transport on a remote computer has closed a network connection. There may or may not be I/O requests outstanding."))
      CASE_ERRCODE2(STATUS_REMOTE_RESOURCES                                            , _T("{Insufficient Resources on Remote Computer} The remote computer has insufficient resources to complete the network request. For instance, there may not be enough memory available on the remote computer to carry out the request at this time."))
      CASE_ERRCODE2(STATUS_LINK_FAILED                                                 , _T("{Virtual Circuit Closed} An existing connection (virtual circuit) has been broken at the remote computer. There is probably something wrong with the network software protocol or the network hardware on the remote computer."))
      CASE_ERRCODE2(STATUS_LINK_TIMEOUT                                                , _T("{Virtual Circuit Closed} The network transport on your computer has closed a network connection because it had to wait too long for a response from the remote computer."))
      CASE_ERRCODE2(STATUS_INVALID_CONNECTION                                          , _T("The connection handle given to the transport was invalid."))
      CASE_ERRCODE2(STATUS_INVALID_ADDRESS                                             , _T("The address handle given to the transport was invalid."))
      CASE_ERRCODE2(STATUS_DLL_INIT_FAILED                                             , _T("{DLL Initialization Failed} Initialization of the dynamic link library %hs failed. The process is terminating abnormally."))
      CASE_ERRCODE2(STATUS_MISSING_SYSTEMFILE                                          , _T("{Missing System File} The required system file %hs is bad or missing."))
      CASE_ERRCODE2(STATUS_UNHANDLED_EXCEPTION                                         , _T("{Application Error} The exception %s (0x%08lx) occurred in the application at location 0x%08lx."))
      CASE_ERRCODE2(STATUS_APP_INIT_FAILURE                                            , _T("{Application Error} The application failed to initialize properly (0x%lx). Click on OK to terminate the application."))
      CASE_ERRCODE2(STATUS_PAGEFILE_CREATE_FAILED                                      , _T("{Unable to Create Paging File} The creation of the paging file %hs failed (%lx). The requested size was %ld."))
      CASE_ERRCODE2(STATUS_NO_PAGEFILE                                                 , _T("{No Paging File Specified} No paging file was specified in the system configuration."))
      CASE_ERRCODE2(STATUS_INVALID_LEVEL                                               , _T("{Incorrect System Call Level} An invalid level was passed into the specified system call."))
      CASE_ERRCODE2(STATUS_WRONG_PASSWORD_CORE                                         , _T("{Incorrect Password to LAN Manager Server} You specified an incorrect password to a LAN Manager 2.x or MS-NET server."))
      CASE_ERRCODE2(STATUS_ILLEGAL_FLOAT_CONTEXT                                       , _T("{EXCEPTION} A real-mode application issued a floating-point instruction and floating-point hardware is not present."))
      CASE_ERRCODE2(STATUS_PIPE_BROKEN                                                 , _T("The pipe operation has failed because the other end of the pipe has been closed."))
      CASE_ERRCODE2(STATUS_REGISTRY_CORRUPT                                            , _T("{The Registry Is Corrupt} The structure of one of the files that contains Registry data is corrupt, or the image of the file in memory is corrupt, or the file could not be recovered because the alternate copy or log was absent or corrupt."))
      CASE_ERRCODE2(STATUS_REGISTRY_IO_FAILED                                          , _T("An I/O operation initiated by the Registry failed unrecoverably. The Registry could not read in, or write out, or flush, one of the files that contain the system's image of the Registry."))
      CASE_ERRCODE2(STATUS_NO_EVENT_PAIR                                               , _T("An event pair synchronization operation was performed using the thread specific client/server event pair object, but no event pair object was associated with the thread."))
      CASE_ERRCODE2(STATUS_UNRECOGNIZED_VOLUME                                         , _T("The volume does not contain a recognized file system. Please make sure that all required file system drivers are loaded and that the volume is not corrupt."))
      CASE_ERRCODE2(STATUS_SERIAL_NO_DEVICE_INITED                                     , _T("No serial device was successfully initialized. The serial driver will unload."))
      CASE_ERRCODE2(STATUS_NO_SUCH_ALIAS                                               , _T("The specified local group does not exist."))
      CASE_ERRCODE2(STATUS_MEMBER_NOT_IN_ALIAS                                         , _T("The specified account name is not a member of the local group."))
      CASE_ERRCODE2(STATUS_MEMBER_IN_ALIAS                                             , _T("The specified account name is already a member of the local group."))
      CASE_ERRCODE2(STATUS_ALIAS_EXISTS                                                , _T("The specified local group already exists."))
      CASE_ERRCODE2(STATUS_LOGON_NOT_GRANTED                                           , _T("A requested type of logon (e.g., Interactive, Network, Service) is not granted by the target system's local security policy. Please ask the system administrator to grant the necessary form of logon."))
      CASE_ERRCODE2(STATUS_TOO_MANY_SECRETS                                            , _T("The maximum number of secrets that may be stored in a single system has been exceeded. The length and number of secrets is limited to satisfy United States State Department export restrictions."))
      CASE_ERRCODE2(STATUS_SECRET_TOO_LONG                                             , _T("The length of a secret exceeds the maximum length allowed. The length and number of secrets is limited to satisfy United States State Department export restrictions."))
      CASE_ERRCODE2(STATUS_INTERNAL_DB_ERROR                                           , _T("The Local Security Authority (LSA) database contains an internal inconsistency."))
      CASE_ERRCODE2(STATUS_FULLSCREEN_MODE                                             , _T("The requested operation cannot be performed in fullscreen mode."))
      CASE_ERRCODE2(STATUS_TOO_MANY_CONTEXT_IDS                                        , _T("During a logon attempt, the user's security context accumulated too many security IDs. This is a very unusual situation. Remove the user from some global or local groups to reduce the number of security ids to incorporate into the security context."))
      CASE_ERRCODE2(STATUS_LOGON_TYPE_NOT_GRANTED                                      , _T("A user has requested a type of logon (e.g., interactive or network) that has not been granted. An administrator has control over who may logon interactively and through the network."))
      CASE_ERRCODE2(STATUS_NOT_REGISTRY_FILE                                           , _T("The system has attempted to load or restore a file into the registry, and the specified file is not in the format of a registry file."))
      CASE_ERRCODE2(STATUS_NT_CROSS_ENCRYPTION_REQUIRED                                , _T("An attempt was made to change a user password in the security account manager without providing the necessary Windows cross-encrypted password."))
      CASE_ERRCODE2(STATUS_DOMAIN_CTRLR_CONFIG_ERROR                                   , _T("A Windows Server has an incorrect configuration."))
      CASE_ERRCODE2(STATUS_FT_MISSING_MEMBER                                           , _T("An attempt was made to explicitly access the secondary copy of information via a device control to the Fault Tolerance driver and the secondary copy is not present in the system."))
      CASE_ERRCODE2(STATUS_ILL_FORMED_SERVICE_ENTRY                                    , _T("A configuration registry node representing a driver service entry was ill-formed and did not contain required value entries."))
      CASE_ERRCODE2(STATUS_ILLEGAL_CHARACTER                                           , _T("An illegal character was encountered. For a multi-byte character set this includes a lead byte without a succeeding trail byte. For the Unicode character set this includes the characters 0xFFFF and 0xFFFE."))
      CASE_ERRCODE2(STATUS_UNMAPPABLE_CHARACTER                                        , _T("No mapping for the Unicode character exists in the target multi-byte code page."))
      CASE_ERRCODE2(STATUS_UNDEFINED_CHARACTER                                         , _T("The Unicode character is not defined in the Unicode character set installed on the system."))
      CASE_ERRCODE2(STATUS_FLOPPY_VOLUME                                               , _T("The paging file cannot be created on a floppy diskette."))
      CASE_ERRCODE2(STATUS_FLOPPY_ID_MARK_NOT_FOUND                                    , _T("{Floppy Disk Error} While accessing a floppy disk, an ID address mark was not found."))
      CASE_ERRCODE2(STATUS_FLOPPY_WRONG_CYLINDER                                       , _T("{Floppy Disk Error} While accessing a floppy disk, the track address from the sector ID field was found to be different than the track address maintained by the controller."))
      CASE_ERRCODE2(STATUS_FLOPPY_UNKNOWN_ERROR                                        , _T("{Floppy Disk Error} The floppy disk controller reported an error that is not recognized by the floppy disk driver."))
      CASE_ERRCODE2(STATUS_FLOPPY_BAD_REGISTERS                                        , _T("{Floppy Disk Error} While accessing a floppy-disk, the controller returned inconsistent results via its registers."))
      CASE_ERRCODE2(STATUS_DISK_RECALIBRATE_FAILED                                     , _T("{Hard Disk Error} While accessing the hard disk, a recalibrate operation failed, even after retries."))
      CASE_ERRCODE2(STATUS_DISK_OPERATION_FAILED                                       , _T("{Hard Disk Error} While accessing the hard disk, a disk operation failed even after retries."))
      CASE_ERRCODE2(STATUS_DISK_RESET_FAILED                                           , _T("{Hard Disk Error} While accessing the hard disk, a disk controller reset was needed, but even that failed."))
      CASE_ERRCODE2(STATUS_SHARED_IRQ_BUSY                                             , _T("An attempt was made to open a device that was sharing an IRQ with other devices. At least one other device that uses that IRQ was already opened. Two concurrent opens of devices that share an IRQ and only work via interrupts is not supported for the particular bus type that the devices use."))
      CASE_ERRCODE2(STATUS_FT_ORPHANING                                                , _T("{FT Orphaning} A disk that is part of a fault-tolerant volume can no longer be accessed."))
      CASE_ERRCODE2(STATUS_BIOS_FAILED_TO_CONNECT_INTERRUPT                            , _T("The system bios failed to connect a system interrupt to the device or bus for which the device is connected."))
      CASE_ERRCODE2(STATUS_PARTITION_FAILURE                                           , _T("Tape could not be partitioned."))
      CASE_ERRCODE2(STATUS_INVALID_BLOCK_LENGTH                                        , _T("When accessing a new tape of a multivolume partition, the current blocksize is incorrect."))
      CASE_ERRCODE2(STATUS_DEVICE_NOT_PARTITIONED                                      , _T("Tape partition information could not be found when loading a tape."))
      CASE_ERRCODE2(STATUS_UNABLE_TO_LOCK_MEDIA                                        , _T("Attempt to lock the eject media mechanism fails."))
      CASE_ERRCODE2(STATUS_UNABLE_TO_UNLOAD_MEDIA                                      , _T("Unload media fails."))
      CASE_ERRCODE2(STATUS_EOM_OVERFLOW                                                , _T("Physical end of tape was detected."))
      CASE_ERRCODE2(STATUS_NO_MEDIA                                                    , _T("{No Media} There is no media in the drive. Please insert media into drive %hs."))
      CASE_ERRCODE2(STATUS_NO_SUCH_MEMBER                                              , _T("A member could not be added to or removed from the local group because the member does not exist."))
      CASE_ERRCODE2(STATUS_INVALID_MEMBER                                              , _T("A new member could not be added to a local group because the member has the wrong account type."))
      CASE_ERRCODE2(STATUS_KEY_DELETED                                                 , _T("Illegal operation attempted on a registry key which has been marked for deletion."))
      CASE_ERRCODE2(STATUS_NO_LOG_SPACE                                                , _T("System could not allocate required space in a registry log."))
      CASE_ERRCODE2(STATUS_TOO_MANY_SIDS                                               , _T("Too many Sids have been specified."))
      CASE_ERRCODE2(STATUS_LM_CROSS_ENCRYPTION_REQUIRED                                , _T("An attempt was made to change a user password in the security account manager without providing the necessary LM cross-encrypted password."))
      CASE_ERRCODE2(STATUS_KEY_HAS_CHILDREN                                            , _T("An attempt was made to create a symbolic link in a registry key that already has subkeys or values."))
      CASE_ERRCODE2(STATUS_CHILD_MUST_BE_VOLATILE                                      , _T("An attempt was made to create a Stable subkey under a Volatile parent key."))
      CASE_ERRCODE2(STATUS_DEVICE_CONFIGURATION_ERROR                                  , _T("The I/O device is configured incorrectly or the configuration parameters to the driver are incorrect."))
      CASE_ERRCODE2(STATUS_DRIVER_INTERNAL_ERROR                                       , _T("An error was detected between two drivers or within an I/O driver."))
      CASE_ERRCODE2(STATUS_INVALID_DEVICE_STATE                                        , _T("The device is not in a valid state to perform this request."))
      CASE_ERRCODE2(STATUS_IO_DEVICE_ERROR                                             , _T("The I/O device reported an I/O error."))
      CASE_ERRCODE2(STATUS_DEVICE_PROTOCOL_ERROR                                       , _T("A protocol error was detected between the driver and the device."))
      CASE_ERRCODE2(STATUS_BACKUP_CONTROLLER                                           , _T("This operation is only allowed for the Primary Domain Controller of the domain."))
      CASE_ERRCODE2(STATUS_LOG_FILE_FULL                                               , _T("Log file space is insufficient to support this operation."))
      CASE_ERRCODE2(STATUS_TOO_LATE                                                    , _T("A write operation was attempted to a volume after it was dismounted."))
      CASE_ERRCODE2(STATUS_NO_TRUST_LSA_SECRET                                         , _T("The workstation does not have a trust secret for the primary domain in the local LSA database."))
      CASE_ERRCODE2(STATUS_NO_TRUST_SAM_ACCOUNT                                        , _T("The SAM database on the Windows Server does not have a computer account for this workstation trust relationship."))
      CASE_ERRCODE2(STATUS_TRUSTED_DOMAIN_FAILURE                                      , _T("The logon request failed because the trust relationship between the primary domain and the trusted domain failed."))
      CASE_ERRCODE2(STATUS_TRUSTED_RELATIONSHIP_FAILURE                                , _T("The logon request failed because the trust relationship between this workstation and the primary domain failed."))
      CASE_ERRCODE2(STATUS_EVENTLOG_FILE_CORRUPT                                       , _T("The Eventlog log file is corrupt."))
      CASE_ERRCODE2(STATUS_EVENTLOG_CANT_START                                         , _T("No Eventlog log file could be opened. The Eventlog service did not start."))
      CASE_ERRCODE2(STATUS_TRUST_FAILURE                                               , _T("The network logon failed. This may be because the validation authority can't be reached."))
      CASE_ERRCODE2(STATUS_MUTANT_LIMIT_EXCEEDED                                       , _T("An attempt was made to acquire a mutant such that its maximum count would have been exceeded."))
      CASE_ERRCODE2(STATUS_NETLOGON_NOT_STARTED                                        , _T("An attempt was made to logon, but the netlogon service was not started."))
      CASE_ERRCODE2(STATUS_ACCOUNT_EXPIRED                                             , _T("The user's account has expired."))
      CASE_ERRCODE2(STATUS_POSSIBLE_DEADLOCK                                           , _T("{EXCEPTION} Possible deadlock condition."))
      CASE_ERRCODE2(STATUS_NETWORK_CREDENTIAL_CONFLICT                                 , _T("Multiple connections to a server or shared resource by the same user, using more than one user name, are not allowed. Disconnect all previous connections to the server or shared resource and try again."))
      CASE_ERRCODE2(STATUS_REMOTE_SESSION_LIMIT                                        , _T("An attempt was made to establish a session to a network server, but there are already too many sessions established to that server."))
      CASE_ERRCODE2(STATUS_EVENTLOG_FILE_CHANGED                                       , _T("The log file has changed between reads."))
      CASE_ERRCODE2(STATUS_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT                           , _T("The account used is an Interdomain Trust account. Use your global user account or local user account to access this server."))
      CASE_ERRCODE2(STATUS_NOLOGON_WORKSTATION_TRUST_ACCOUNT                           , _T("The account used is a Computer Account. Use your global user account or local user account to access this server."))
      CASE_ERRCODE2(STATUS_NOLOGON_SERVER_TRUST_ACCOUNT                                , _T("The account used is an Server Trust account. Use your global user account or local user account to access this server."))
      CASE_ERRCODE2(STATUS_DOMAIN_TRUST_INCONSISTENT                                   , _T("The name or SID of the domain specified is inconsistent with the trust information for that domain."))
      CASE_ERRCODE2(STATUS_FS_DRIVER_REQUIRED                                          , _T("A volume has been accessed for which a file system driver is required that has not yet been loaded."))
      CASE_ERRCODE2(STATUS_NO_USER_SESSION_KEY                                         , _T("There is no user session key for the specified logon session."))
      CASE_ERRCODE2(STATUS_USER_SESSION_DELETED                                        , _T("The remote user session has been deleted."))
      CASE_ERRCODE2(STATUS_RESOURCE_LANG_NOT_FOUND                                     , _T("Indicates the specified resource language ID cannot be found in the image file."))
      CASE_ERRCODE2(STATUS_INSUFF_SERVER_RESOURCES                                     , _T("Insufficient server resources exist to complete the request."))
      CASE_ERRCODE2(STATUS_INVALID_BUFFER_SIZE                                         , _T("The size of the buffer is invalid for the specified operation."))
      CASE_ERRCODE2(STATUS_INVALID_ADDRESS_COMPONENT                                   , _T("The transport rejected the network address specified as invalid."))
      CASE_ERRCODE2(STATUS_INVALID_ADDRESS_WILDCARD                                    , _T("The transport rejected the network address specified due to an invalid use of a wildcard."))
      CASE_ERRCODE2(STATUS_TOO_MANY_ADDRESSES                                          , _T("The transport address could not be opened because all the available addresses are in use."))
      CASE_ERRCODE2(STATUS_ADDRESS_ALREADY_EXISTS                                      , _T("The transport address could not be opened because it already exists."))
      CASE_ERRCODE2(STATUS_ADDRESS_CLOSED                                              , _T("The transport address is now closed."))
      CASE_ERRCODE2(STATUS_CONNECTION_DISCONNECTED                                     , _T("The transport connection is now disconnected."))
      CASE_ERRCODE2(STATUS_CONNECTION_RESET                                            , _T("The transport connection has been reset."))
      CASE_ERRCODE2(STATUS_TOO_MANY_NODES                                              , _T("The transport cannot dynamically acquire any more nodes."))
      CASE_ERRCODE2(STATUS_TRANSACTION_ABORTED                                         , _T("The transport aborted a pending transaction."))
      CASE_ERRCODE2(STATUS_TRANSACTION_TIMED_OUT                                       , _T("The transport timed out a request waiting for a response."))
      CASE_ERRCODE2(STATUS_TRANSACTION_NO_RELEASE                                      , _T("The transport did not receive a release for a pending response."))
      CASE_ERRCODE2(STATUS_TRANSACTION_NO_MATCH                                        , _T("The transport did not find a transaction matching the specific token."))
      CASE_ERRCODE2(STATUS_TRANSACTION_RESPONDED                                       , _T("The transport had previously responded to a transaction request."))
      CASE_ERRCODE2(STATUS_TRANSACTION_INVALID_ID                                      , _T("The transport does not recognized the transaction request identifier specified."))
      CASE_ERRCODE2(STATUS_TRANSACTION_INVALID_TYPE                                    , _T("The transport does not recognize the transaction request type specified."))
      CASE_ERRCODE2(STATUS_NOT_SERVER_SESSION                                          , _T("The transport can only process the specified request on the server side of a session."))
      CASE_ERRCODE2(STATUS_NOT_CLIENT_SESSION                                          , _T("The transport can only process the specified request on the client side of a session."))
      CASE_ERRCODE2(STATUS_CANNOT_LOAD_REGISTRY_FILE                                   , _T("{Registry File Failure} The registry cannot load the hive (file): %hs or its log or alternate. It is corrupt, absent, or not writable."))
      CASE_ERRCODE2(STATUS_DEBUG_ATTACH_FAILED                                         , _T("{Unexpected Failure in DebugActiveProcess} An unexpected failure occurred while processing a DebugActiveProcess API request. You may choose OK to terminate the process, or Cancel to ignore the error."))
      CASE_ERRCODE2(STATUS_SYSTEM_PROCESS_TERMINATED                                   , _T("{Fatal System Error} The %hs system process terminated unexpectedly with a status of 0x%08x (0x%08x 0x%08x). The system has been shut down."))
      CASE_ERRCODE2(STATUS_DATA_NOT_ACCEPTED                                           , _T("{Data Not Accepted} The TDI client could not handle the data received during an indication."))
      CASE_ERRCODE2(STATUS_NO_BROWSER_SERVERS_FOUND                                    , _T("{Unable to Retrieve Browser Server List} The list of servers for this workgroup is not currently available."))
      CASE_ERRCODE2(STATUS_VDM_HARD_ERROR                                              , _T("NTVDM encountered a hard error."))
      CASE_ERRCODE2(STATUS_DRIVER_CANCEL_TIMEOUT                                       , _T("{Cancel Timeout} The driver %hs failed to complete a cancelled I/O request in the allotted time."))
      CASE_ERRCODE2(STATUS_REPLY_MESSAGE_MISMATCH                                      , _T("{Reply Message Mismatch} An attempt was made to reply to an LPC message, but the thread specified by the client ID in the message was not waiting on that message."))
      CASE_ERRCODE2(STATUS_MAPPED_ALIGNMENT                                            , _T("{Mapped View Alignment Incorrect} An attempt was made to map a view of a file, but either the specified base address or the offset into the file were not aligned on the proper allocation granularity."))
      CASE_ERRCODE2(STATUS_IMAGE_CHECKSUM_MISMATCH                                     , _T("{Bad Image Checksum} The image %hs is possibly corrupt. The header checksum does not match the computed checksum."))
      CASE_ERRCODE2(STATUS_LOST_WRITEBEHIND_DATA                                       , _T("{Delayed Write Failed} Windows was unable to save all the data for the file %hs. The data has been lost. This error may be caused by a failure of your computer hardware or network connection. Please try to save this file elsewhere."))
      CASE_ERRCODE2(STATUS_CLIENT_SERVER_PARAMETERS_INVALID                            , _T("The parameter(s) passed to the server in the client/server shared memory window were invalid. Too much data may have been put in the shared memory window."))
      CASE_ERRCODE2(STATUS_PASSWORD_MUST_CHANGE                                        , _T("The user's password must be changed before logging on the first time."))
      CASE_ERRCODE2(STATUS_NOT_FOUND                                                   , _T("The object was not found."))
      CASE_ERRCODE2(STATUS_NOT_TINY_STREAM                                             , _T("The stream is not a tiny stream."))
      CASE_ERRCODE2(STATUS_RECOVERY_FAILURE                                            , _T("A transaction recover failed."))
      CASE_ERRCODE2(STATUS_STACK_OVERFLOW_READ                                         , _T("The request must be handled by the stack overflow code."))
      CASE_ERRCODE2(STATUS_FAIL_CHECK                                                  , _T("A consistency check failed."))
      CASE_ERRCODE2(STATUS_DUPLICATE_OBJECTID                                          , _T("The attempt to insert the ID in the index failed because the ID is already in the index."))
      CASE_ERRCODE2(STATUS_OBJECTID_EXISTS                                             , _T("The attempt to set the object's ID failed because the object already has an ID."))
      CASE_ERRCODE2(STATUS_CONVERT_TO_LARGE                                            , _T("Internal OFS status codes indicating how an allocation operation is handled. Either it is retried after the containing onode is moved or the extent stream is converted to a large stream."))
      CASE_ERRCODE2(STATUS_RETRY                                                       , _T("The request needs to be retried."))
      CASE_ERRCODE2(STATUS_FOUND_OUT_OF_SCOPE                                          , _T("The attempt to find the object found an object matching by ID on the volume but it is out of the scope of the handle used for the operation."))
      CASE_ERRCODE2(STATUS_ALLOCATE_BUCKET                                             , _T("The bucket array must be grown. Retry transaction after doing so."))
      CASE_ERRCODE2(STATUS_PROPSET_NOT_FOUND                                           , _T("The property set specified does not exist on the object."))
      CASE_ERRCODE2(STATUS_MARSHALL_OVERFLOW                                           , _T("The user/kernel marshalling buffer has overflowed."))
      CASE_ERRCODE2(STATUS_INVALID_VARIANT                                             , _T("The supplied variant structure contains invalid data."))
      CASE_ERRCODE2(STATUS_DOMAIN_CONTROLLER_NOT_FOUND                                 , _T("Could not find a domain controller for this domain."))
      CASE_ERRCODE2(STATUS_ACCOUNT_LOCKED_OUT                                          , _T("The user account has been automatically locked because too many invalid logon attempts or password change attempts have been requested."))
      CASE_ERRCODE2(STATUS_HANDLE_NOT_CLOSABLE                                         , _T("NtClose was called on a handle that was protected from close via NtSetInformationObject."))
      CASE_ERRCODE2(STATUS_CONNECTION_REFUSED                                          , _T("The transport connection attempt was refused by the remote system."))
      CASE_ERRCODE2(STATUS_GRACEFUL_DISCONNECT                                         , _T("The transport connection was gracefully closed."))
      CASE_ERRCODE2(STATUS_ADDRESS_ALREADY_ASSOCIATED                                  , _T("The transport endpoint already has an address associated with it."))
      CASE_ERRCODE2(STATUS_ADDRESS_NOT_ASSOCIATED                                      , _T("An address has not yet been associated with the transport endpoint."))
      CASE_ERRCODE2(STATUS_CONNECTION_INVALID                                          , _T("An operation was attempted on a nonexistent transport connection."))
      CASE_ERRCODE2(STATUS_CONNECTION_ACTIVE                                           , _T("An invalid operation was attempted on an active transport connection."))
      CASE_ERRCODE2(STATUS_NETWORK_UNREACHABLE                                         , _T("The remote network is not reachable by the transport."))
      CASE_ERRCODE2(STATUS_HOST_UNREACHABLE                                            , _T("The remote system is not reachable by the transport."))
      CASE_ERRCODE2(STATUS_PROTOCOL_UNREACHABLE                                        , _T("The remote system does not support the transport protocol."))
      CASE_ERRCODE2(STATUS_PORT_UNREACHABLE                                            , _T("No service is operating at the destination port of the transport on the remote system."))
      CASE_ERRCODE2(STATUS_REQUEST_ABORTED                                             , _T("The request was aborted."))
      CASE_ERRCODE2(STATUS_CONNECTION_ABORTED                                          , _T("The transport connection was aborted by the local system."))
      CASE_ERRCODE2(STATUS_BAD_COMPRESSION_BUFFER                                      , _T("The specified buffer contains ill-formed data."))
      CASE_ERRCODE2(STATUS_USER_MAPPED_FILE                                            , _T("The requested operation cannot be performed on a file with a user mapped section open."))
      CASE_ERRCODE2(STATUS_AUDIT_FAILED                                                , _T("{Audit Failed} An attempt to generate a security audit failed."))
      CASE_ERRCODE2(STATUS_TIMER_RESOLUTION_NOT_SET                                    , _T("The timer resolution was not previously set by the current process."))
      CASE_ERRCODE2(STATUS_CONNECTION_COUNT_LIMIT                                      , _T("A connection to the server could not be made because the limit on the number of concurrent connections for this account has been reached."))
      CASE_ERRCODE2(STATUS_LOGIN_TIME_RESTRICTION                                      , _T("Attempting to login during an unauthorized time of day for this account."))
      CASE_ERRCODE2(STATUS_LOGIN_WKSTA_RESTRICTION                                     , _T("The account is not authorized to login from this station."))
      CASE_ERRCODE2(STATUS_IMAGE_MP_UP_MISMATCH                                        , _T("{UP/MP Image Mismatch} The image %hs has been modified for use on a uniprocessor system, but you are running it on a multiprocessor machine. Please reinstall the image file."))
      CASE_ERRCODE2(STATUS_INSUFFICIENT_LOGON_INFO                                     , _T("There is insufficient account information to log you on."))
      CASE_ERRCODE2(STATUS_BAD_DLL_ENTRYPOINT                                          , _T("{Invalid DLL Entrypoint} The dynamic link library %hs is not written correctly. The stack pointer has been left in an inconsistent state. The entrypoint should be declared as WINAPI or STDCALL. Select YES to fail the DLL load. Select NO to continue execution. Selecting NO may cause the application to operate incorrectly."))
      CASE_ERRCODE2(STATUS_BAD_SERVICE_ENTRYPOINT                                      , _T("{Invalid Service Callback Entrypoint} The %hs service is not written correctly. The stack pointer has been left in an inconsistent state. The callback entrypoint should be declared as WINAPI or STDCALL. Selecting OK will cause the service to continue operation. However, the service process may operate incorrectly."))
      CASE_ERRCODE2(STATUS_LPC_REPLY_LOST                                              , _T("The server received the messages but did not send a reply."))
      CASE_ERRCODE2(STATUS_IP_ADDRESS_CONFLICT1                                        , _T("There is an IP address conflict with another system on the network"))
      CASE_ERRCODE2(STATUS_IP_ADDRESS_CONFLICT2                                        , _T("There is an IP address conflict with another system on the network"))
      CASE_ERRCODE2(STATUS_REGISTRY_QUOTA_LIMIT                                        , _T("{Low On Registry Space} The system has reached the maximum size allowed for the system part of the registry.  Additional storage requests will be ignored."))
      CASE_ERRCODE2(STATUS_PATH_NOT_COVERED                                            , _T("The contacted server does not support the indicated part of the DFS namespace."))
      CASE_ERRCODE2(STATUS_NO_CALLBACK_ACTIVE                                          , _T("A callback return system service cannot be executed when no callback is active."))
      CASE_ERRCODE2(STATUS_LICENSE_QUOTA_EXCEEDED                                      , _T("The service being accessed is licensed for a particular number of connections. No more connections can be made to the service at this time because there are already as many connections as the service can accept."))
      CASE_ERRCODE2(STATUS_PWD_TOO_SHORT                                               , _T("The password provided is too short to meet the policy of your user account. Please choose a longer password."))
      CASE_ERRCODE2(STATUS_PWD_TOO_RECENT                                              , _T("The policy of your user account does not allow you to change passwords too frequently. This is done to prevent users from changing back to a familiar, but potentially discovered, password. If you feel your password has been compromised then please contact your administrator immediately to have a new one assigned."))
      CASE_ERRCODE2(STATUS_PWD_HISTORY_CONFLICT                                        , _T("You have attempted to change your password to one that you have used in the past. The policy of your user account does not allow this. Please select a password that you have not previously used."))
      CASE_ERRCODE2(STATUS_PLUGPLAY_NO_DEVICE                                          , _T("You have attempted to load a legacy device driver while its device instance had been disabled."))
      CASE_ERRCODE2(STATUS_UNSUPPORTED_COMPRESSION                                     , _T("The specified compression format is unsupported."))
      CASE_ERRCODE2(STATUS_INVALID_HW_PROFILE                                          , _T("The specified hardware profile configuration is invalid."))
      CASE_ERRCODE2(STATUS_INVALID_PLUGPLAY_DEVICE_PATH                                , _T("The specified Plug and Play registry device path is invalid."))
      CASE_ERRCODE2(STATUS_DRIVER_ORDINAL_NOT_FOUND                                    , _T("{Driver Entry Point Not Found} The %hs device driver could not locate the ordinal %ld in driver %hs."))
      CASE_ERRCODE2(STATUS_DRIVER_ENTRYPOINT_NOT_FOUND                                 , _T("{Driver Entry Point Not Found} The %hs device driver could not locate the entry point %hs in driver %hs."))
      CASE_ERRCODE2(STATUS_RESOURCE_NOT_OWNED                                          , _T("{Application Error} The application attempted to release a resource it did not own. Click on OK to terminate the application."))
      CASE_ERRCODE2(STATUS_TOO_MANY_LINKS                                              , _T("An attempt was made to create more links on a file than the file system supports."))
      CASE_ERRCODE2(STATUS_QUOTA_LIST_INCONSISTENT                                     , _T("The specified quota list is internally inconsistent with its descriptor."))
      CASE_ERRCODE2(STATUS_FILE_IS_OFFLINE                                             , _T("The specified file has been relocated to offline storage."))
      CASE_ERRCODE2(STATUS_EVALUATION_EXPIRATION                                       , _T("{Windows Evaluation Notification} The evaluation period for this installation of Windows has expired. This system will shutdown in 1 hour. To restore access to this installation of Windows, please upgrade this installation using a licensed distribution of this product."))
      CASE_ERRCODE2(STATUS_ILLEGAL_DLL_RELOCATION                                      , _T("{Illegal System DLL Relocation} The system DLL %hs was relocated in memory. The application will not run properly. The relocation occurred because the DLL %hs occupied an address range reserved for Windows system DLLs. The vendor supplying the DLL should be contacted for a new DLL."))
      CASE_ERRCODE2(STATUS_LICENSE_VIOLATION                                           , _T("{License Violation} The system has detected tampering with your registered product type. This is a violation of your software license. Tampering with product type is not permitted."))
      CASE_ERRCODE2(STATUS_DLL_INIT_FAILED_LOGOFF                                      , _T("{DLL Initialization Failed} The application failed to initialize because the window station is shutting down."))
      CASE_ERRCODE2(STATUS_DRIVER_UNABLE_TO_LOAD                                       , _T("{Unable to Load Device Driver} %hs device driver could not be loaded. Error Status was 0x%x"))
      CASE_ERRCODE2(STATUS_DFS_UNAVAILABLE                                             , _T("DFS is unavailable on the contacted server."))
      CASE_ERRCODE2(STATUS_VOLUME_DISMOUNTED                                           , _T("An operation was attempted to a volume after it was dismounted."))
      CASE_ERRCODE2(STATUS_WX86_INTERNAL_ERROR                                         , _T("An internal error occurred in the Win32 x86 emulation subsystem."))
      CASE_ERRCODE2(STATUS_WX86_FLOAT_STACK_CHECK                                      , _T("Win32 x86 emulation subsystem Floating-point stack check."))
      CASE_ERRCODE2(STATUS_VALIDATE_CONTINUE                                           , _T("The validation process needs to continue on to the next step."))
      CASE_ERRCODE2(STATUS_NO_MATCH                                                    , _T("There was no match for the specified key in the index."))
      CASE_ERRCODE2(STATUS_NO_MORE_MATCHES                                             , _T("There are no more matches for the current index enumeration."))
      CASE_ERRCODE2(STATUS_NOT_A_REPARSE_POINT                                         , _T("The NTFS file or directory is not a reparse point."))
      CASE_ERRCODE2(STATUS_IO_REPARSE_TAG_INVALID                                      , _T("The Windows I/O reparse tag passed for the NTFS reparse point is invalid."))
      CASE_ERRCODE2(STATUS_IO_REPARSE_TAG_MISMATCH                                     , _T("The Windows I/O reparse tag does not match the one present in the NTFS reparse point."))
      CASE_ERRCODE2(STATUS_IO_REPARSE_DATA_INVALID                                     , _T("The user data passed for the NTFS reparse point is invalid."))
      CASE_ERRCODE2(STATUS_IO_REPARSE_TAG_NOT_HANDLED                                  , _T("The layered file system driver for this IO tag did not handle it when needed."))
      CASE_ERRCODE2(STATUS_REPARSE_POINT_NOT_RESOLVED                                  , _T("The NTFS symbolic link could not be resolved even though the initial file name is valid."))
      CASE_ERRCODE2(STATUS_DIRECTORY_IS_A_REPARSE_POINT                                , _T("The NTFS directory is a reparse point."))
      CASE_ERRCODE2(STATUS_RANGE_LIST_CONFLICT                                         , _T("The range could not be added to the range list because of a conflict."))
      CASE_ERRCODE2(STATUS_SOURCE_ELEMENT_EMPTY                                        , _T("The specified medium changer source element contains no media."))
      CASE_ERRCODE2(STATUS_DESTINATION_ELEMENT_FULL                                    , _T("The specified medium changer destination element already contains media."))
      CASE_ERRCODE2(STATUS_ILLEGAL_ELEMENT_ADDRESS                                     , _T("The specified medium changer element does not exist."))
      CASE_ERRCODE2(STATUS_MAGAZINE_NOT_PRESENT                                        , _T("The specified element is contained within a magazine that is no longer present."))
      CASE_ERRCODE2(STATUS_REINITIALIZATION_NEEDED                                     , _T("The device requires reinitialization due to hardware errors."))
      CASE_ERRCODE2(STATUS_DEVICE_REQUIRES_CLEANING                                    , _T("The device has indicated that cleaning is necessary."))
      CASE_ERRCODE2(STATUS_DEVICE_DOOR_OPEN                                            , _T("The device has indicated that it's door is open. Further operations require it closed and secured."))
      CASE_ERRCODE2(STATUS_ENCRYPTION_FAILED                                           , _T("The file encryption attempt failed."))
      CASE_ERRCODE2(STATUS_DECRYPTION_FAILED                                           , _T("The file decryption attempt failed."))
      CASE_ERRCODE2(STATUS_RANGE_NOT_FOUND                                             , _T("The specified range could not be found in the range list."))
      CASE_ERRCODE2(STATUS_NO_RECOVERY_POLICY                                          , _T("There is no encryption recovery policy configured for this system."))
      CASE_ERRCODE2(STATUS_NO_EFS                                                      , _T("The required encryption driver is not loaded for this system."))
      CASE_ERRCODE2(STATUS_WRONG_EFS                                                   , _T("The file was encrypted with a different encryption driver than is currently loaded."))
      CASE_ERRCODE2(STATUS_NO_USER_KEYS                                                , _T("There are no EFS keys defined for the user."))
      CASE_ERRCODE2(STATUS_FILE_NOT_ENCRYPTED                                          , _T("The specified file is not encrypted."))
      CASE_ERRCODE2(STATUS_NOT_EXPORT_FORMAT                                           , _T("The specified file is not in the defined EFS export format."))
      CASE_ERRCODE2(STATUS_FILE_ENCRYPTED                                              , _T("The specified file is encrypted and the user does not have the ability to decrypt it."))
      CASE_ERRCODE2(STATUS_WAKE_SYSTEM                                                 , _T("The system has awoken"))
      CASE_ERRCODE2(STATUS_WMI_GUID_NOT_FOUND                                          , _T("The guid passed was not recognized as valid by a WMI data provider."))
      CASE_ERRCODE2(STATUS_WMI_INSTANCE_NOT_FOUND                                      , _T("The instance name passed was not recognized as valid by a WMI data provider."))
      CASE_ERRCODE2(STATUS_WMI_ITEMID_NOT_FOUND                                        , _T("The data item id passed was not recognized as valid by a WMI data provider."))
      CASE_ERRCODE2(STATUS_WMI_TRY_AGAIN                                               , _T("The WMI request could not be completed and should be retried."))
      CASE_ERRCODE2(STATUS_SHARED_POLICY                                               , _T("The policy object is shared and can only be modified at the root"))
      CASE_ERRCODE2(STATUS_POLICY_OBJECT_NOT_FOUND                                     , _T("The policy object does not exist when it should"))
      CASE_ERRCODE2(STATUS_POLICY_ONLY_IN_DS                                           , _T("The requested policy information only lives in the Ds"))
      CASE_ERRCODE2(STATUS_VOLUME_NOT_UPGRADED                                         , _T("The volume must be upgraded to enable this feature"))
      CASE_ERRCODE2(STATUS_REMOTE_STORAGE_NOT_ACTIVE                                   , _T("The remote storage service is not operational at this time."))
      CASE_ERRCODE2(STATUS_REMOTE_STORAGE_MEDIA_ERROR                                  , _T("The remote storage service encountered a media error."))
      CASE_ERRCODE2(STATUS_NO_TRACKING_SERVICE                                         , _T("The tracking (workstation) service is not running."))
      CASE_ERRCODE2(STATUS_SERVER_SID_MISMATCH                                         , _T("The server process is running under a SID different than that required by client."))
      CASE_ERRCODE2(STATUS_DS_NO_ATTRIBUTE_OR_VALUE                                    , _T("The specified directory service attribute or value does not exist."))
      CASE_ERRCODE2(STATUS_DS_INVALID_ATTRIBUTE_SYNTAX                                 , _T("The attribute syntax specified to the directory service is invalid."))
      CASE_ERRCODE2(STATUS_DS_ATTRIBUTE_TYPE_UNDEFINED                                 , _T("The attribute type specified to the directory service is not defined."))
      CASE_ERRCODE2(STATUS_DS_ATTRIBUTE_OR_VALUE_EXISTS                                , _T("The specified directory service attribute or value already exists."))
      CASE_ERRCODE2(STATUS_DS_BUSY                                                     , _T("The directory service is busy."))
      CASE_ERRCODE2(STATUS_DS_UNAVAILABLE                                              , _T("The directory service is not available."))
      CASE_ERRCODE2(STATUS_DS_NO_RIDS_ALLOCATED                                        , _T("The directory service was unable to allocate a relative identifier."))
      CASE_ERRCODE2(STATUS_DS_NO_MORE_RIDS                                             , _T("The directory service has exhausted the pool of relative identifiers."))
      CASE_ERRCODE2(STATUS_DS_INCORRECT_ROLE_OWNER                                     , _T("The requested operation could not be performed because the directory service is not the master for that type of operation."))
      CASE_ERRCODE2(STATUS_DS_RIDMGR_INIT_ERROR                                        , _T("The directory service was unable to initialize the subsystem that allocates relative identifiers."))
      CASE_ERRCODE2(STATUS_DS_OBJ_CLASS_VIOLATION                                      , _T("The requested operation did not satisfy one or more constraints associated with the class of the object."))
      CASE_ERRCODE2(STATUS_DS_CANT_ON_NON_LEAF                                         , _T("The directory service can perform the requested operation only on a leaf object."))
      CASE_ERRCODE2(STATUS_DS_CANT_ON_RDN                                              , _T("The directory service cannot perform the requested operation on the Relatively Defined Name (RDN) attribute of an object."))
      CASE_ERRCODE2(STATUS_DS_CANT_MOD_OBJ_CLASS                                       , _T("The directory service detected an attempt to modify the object class of an object."))
      CASE_ERRCODE2(STATUS_DS_CROSS_DOM_MOVE_FAILED                                    , _T("An error occurred while performing a cross domain move operation."))
      CASE_ERRCODE2(STATUS_DS_GC_NOT_AVAILABLE                                         , _T("Unable to Contact the Global Catalog Server."))
      CASE_ERRCODE2(STATUS_DIRECTORY_SERVICE_REQUIRED                                  , _T("The requested operation requires a directory service, and none was available."))
      CASE_ERRCODE2(STATUS_REPARSE_ATTRIBUTE_CONFLICT                                  , _T("The reparse attribute cannot be set as it is incompatible with an existing attribute."))
      CASE_ERRCODE2(STATUS_CANT_ENABLE_DENY_ONLY                                       , _T("A group marked use for deny only  can not be enabled."))
      CASE_ERRCODE2(STATUS_FLOAT_MULTIPLE_FAULTS                                       , _T("{EXCEPTION} Multiple floating point faults."))
      CASE_ERRCODE2(STATUS_FLOAT_MULTIPLE_TRAPS                                        , _T("{EXCEPTION} Multiple floating point traps."))
      CASE_ERRCODE2(STATUS_DEVICE_REMOVED                                              , _T("The device has been removed."))
      CASE_ERRCODE2(STATUS_JOURNAL_DELETE_IN_PROGRESS                                  , _T("The volume change journal is being deleted."))
      CASE_ERRCODE2(STATUS_JOURNAL_NOT_ACTIVE                                          , _T("The volume change journal is not active."))
      CASE_ERRCODE2(STATUS_NOINTERFACE                                                 , _T("The requested interface is not supported."))
      CASE_ERRCODE2(STATUS_DS_ADMIN_LIMIT_EXCEEDED                                     , _T("A directory service resource limit has been exceeded."))
      CASE_ERRCODE2(STATUS_DRIVER_FAILED_SLEEP                                         , _T("{System Standby Failed} The driver %hs does not support standby mode. Updating this driver may allow the system to go to standby mode."))
      CASE_ERRCODE2(STATUS_MUTUAL_AUTHENTICATION_FAILED                                , _T("Mutual Authentication failed. The server's password is out of date at the domain controller."))
      CASE_ERRCODE2(STATUS_CORRUPT_SYSTEM_FILE                                         , _T("The system file %1 has become corrupt and has been replaced."))
      CASE_ERRCODE2(STATUS_DATATYPE_MISALIGNMENT_ERROR                                 , _T("{EXCEPTION} Alignment Error. A datatype misalignment error was detected in a load or store instruction."))
      CASE_ERRCODE2(STATUS_WMI_READ_ONLY                                               , _T("The WMI data item or data block is read only."))
      CASE_ERRCODE2(STATUS_WMI_SET_FAILURE                                             , _T("The WMI data item or data block could not be changed."))
      CASE_ERRCODE2(STATUS_COMMITMENT_MINIMUM                                          , _T("{Virtual Memory Minimum Too Low} Your system is low on virtual memory. Windows is increasing the size of your virtual memory paging file. During this process, memory requests for some applications may be denied. For more information, see Help."))
      CASE_ERRCODE2(STATUS_REG_NAT_CONSUMPTION                                         , _T("{EXCEPTION} Register NaT consumption faults. A NaT value is consumed on a non speculative instruction."))
      CASE_ERRCODE2(STATUS_TRANSPORT_FULL                                              , _T("The medium changer's transport element contains media, which is causing the operation to fail."))
      CASE_ERRCODE2(STATUS_DS_SAM_INIT_FAILURE                                         , _T("Security Accounts Manager initialization failed because of the following error: %hs Error Status: 0x%x. Please click OK to shutdown this system and reboot into Directory Services Restore Mode, check the event log for more detailed information."))
      CASE_ERRCODE2(STATUS_ONLY_IF_CONNECTED                                           , _T("This operation is supported only when you are connected to the server."))
      CASE_ERRCODE2(STATUS_DS_SENSITIVE_GROUP_VIOLATION                                , _T("Only an administrator can modify the membership list of an administrative group."))
      CASE_ERRCODE2(STATUS_PNP_RESTART_ENUMERATION                                     , _T("A device was removed so enumeration must be restarted."))
      CASE_ERRCODE2(STATUS_JOURNAL_ENTRY_DELETED                                       , _T("The journal entry has been deleted from the journal."))
      CASE_ERRCODE2(STATUS_DS_CANT_MOD_PRIMARYGROUPID                                  , _T("Cannot change the primary group ID of a domain controller account."))
      CASE_ERRCODE2(STATUS_SYSTEM_IMAGE_BAD_SIGNATURE                                  , _T("{Fatal System Error} The system image %s is not properly signed. The file has been replaced with the signed file. The system has been shut down."))
      CASE_ERRCODE2(STATUS_PNP_REBOOT_REQUIRED                                         , _T("Device will not start without a reboot."))
      CASE_ERRCODE2(STATUS_POWER_STATE_INVALID                                         , _T("Current device power state cannot support this request."))
      CASE_ERRCODE2(STATUS_DS_INVALID_GROUP_TYPE                                       , _T("The specified group type is invalid."))
      CASE_ERRCODE2(STATUS_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN                       , _T("In mixed domain no nesting of global group if group is security enabled."))
      CASE_ERRCODE2(STATUS_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN                        , _T("In mixed domain, cannot nest local groups with other local groups, if the group is security enabled."))
      CASE_ERRCODE2(STATUS_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER                            , _T("A global group cannot have a local group as a member."))
      CASE_ERRCODE2(STATUS_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER                        , _T("A global group cannot have a universal group as a member."))
      CASE_ERRCODE2(STATUS_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER                         , _T("A universal group cannot have a local group as a member."))
      CASE_ERRCODE2(STATUS_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER                      , _T("A global group cannot have a cross domain member."))
      CASE_ERRCODE2(STATUS_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER                 , _T("A local group cannot have another cross domain local group as a member."))
      CASE_ERRCODE2(STATUS_DS_HAVE_PRIMARY_MEMBERS                                     , _T("Can not change to security disabled group because of having primary members in this group."))
      CASE_ERRCODE2(STATUS_WMI_NOT_SUPPORTED                                           , _T("The WMI operation is not supported by the data block or method."))
      CASE_ERRCODE2(STATUS_INSUFFICIENT_POWER                                          , _T("There is not enough power to complete the requested operation."))
      CASE_ERRCODE2(STATUS_SAM_NEED_BOOTKEY_PASSWORD                                   , _T("Security Account Manager needs to get the boot password."))
      CASE_ERRCODE2(STATUS_SAM_NEED_BOOTKEY_FLOPPY                                     , _T("Security Account Manager needs to get the boot key from floppy disk."))
      CASE_ERRCODE2(STATUS_DS_CANT_START                                               , _T("Directory Service can not start."))
      CASE_ERRCODE2(STATUS_DS_INIT_FAILURE                                             , _T("Directory Services could not start because of the following error: %hs Error Status: 0x%x. Please click OK to shutdown this system and reboot into Directory Services Restore Mode, check the event log for more detailed information."))
      CASE_ERRCODE2(STATUS_SAM_INIT_FAILURE                                            , _T("Security Accounts Manager initialization failed because of the following error: %hs Error Status: 0x%x. Please click OK to shutdown this system and reboot into Safe Mode, check the event log for more detailed information."))
      CASE_ERRCODE2(STATUS_DS_GC_REQUIRED                                              , _T("The requested operation can be performed only on a global catalog server."))
      CASE_ERRCODE2(STATUS_DS_LOCAL_MEMBER_OF_LOCAL_ONLY                               , _T("A local group can only be a member of other local groups in the same domain."))
      CASE_ERRCODE2(STATUS_DS_NO_FPO_IN_UNIVERSAL_GROUPS                               , _T("Foreign security principals cannot be members of universal groups."))
      CASE_ERRCODE2(STATUS_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED                           , _T("Your computer could not be joined to the domain. You have exceeded the maximum number of computer accounts you are allowed to create in this domain. Contact your system administrator to have this limit reset or increased."))
      CASE_ERRCODE2(STATUS_MULTIPLE_FAULT_VIOLATION                                    , _T("STATUS_MULTIPLE_FAULT_VIOLATION"))
      CASE_ERRCODE2(STATUS_CURRENT_DOMAIN_NOT_ALLOWED                                  , _T("This operation can not be performed on the current domain."))
      CASE_ERRCODE2(STATUS_CANNOT_MAKE                                                 , _T("The directory or file cannot be created."))
      CASE_ERRCODE2(STATUS_SYSTEM_SHUTDOWN                                             , _T("The system is in the process of shutting down."))
      CASE_ERRCODE2(STATUS_DS_INIT_FAILURE_CONSOLE                                     , _T("Directory Services could not start because of the following error: %hs Error Status: 0x%x. Please click OK to shutdown the system. You can use the recovery console to diagnose the system further."))
      CASE_ERRCODE2(STATUS_DS_SAM_INIT_FAILURE_CONSOLE                                 , _T("Security Accounts Manager initialization failed because of the following error: %hs. Error Status: 0x%x. Please click OK to shutdown the system. You can use the recovery console to diagnose the system further."))
      CASE_ERRCODE2(STATUS_UNFINISHED_CONTEXT_DELETED                                  , _T("A security context was deleted before the context was completed.  This is considered a logon failure."))
      CASE_ERRCODE2(STATUS_NO_TGT_REPLY                                                , _T("The client is trying to negotiate a context and the server requires user-to-user but didn't send a TGT reply."))
      CASE_ERRCODE2(STATUS_OBJECTID_NOT_FOUND                                          , _T("An object ID was not found in the file."))
      CASE_ERRCODE2(STATUS_NO_IP_ADDRESSES                                             , _T("Unable to accomplish the requested task because the local machine does not have any IP addresses."))
      CASE_ERRCODE2(STATUS_WRONG_CREDENTIAL_HANDLE                                     , _T("The supplied credential handle does not match the credential associated with the security context."))
      CASE_ERRCODE2(STATUS_CRYPTO_SYSTEM_INVALID                                       , _T("The crypto system or checksum function is invalid because a required function is unavailable."))
      CASE_ERRCODE2(STATUS_MAX_REFERRALS_EXCEEDED                                      , _T("The number of maximum ticket referrals has been exceeded."))
      CASE_ERRCODE2(STATUS_MUST_BE_KDC                                                 , _T("The local machine must be a Kerberos KDC (domain controller) and it is not."))
      CASE_ERRCODE2(STATUS_STRONG_CRYPTO_NOT_SUPPORTED                                 , _T("The other end of the security negotiation is requires strong crypto but it is not supported on the local machine."))
      CASE_ERRCODE2(STATUS_TOO_MANY_PRINCIPALS                                         , _T("The KDC reply contained more than one principal name."))
      CASE_ERRCODE2(STATUS_NO_PA_DATA                                                  , _T("Expected to find PA data for a hint of what etype to use, but it was not found."))
      CASE_ERRCODE2(STATUS_PKINIT_NAME_MISMATCH                                        , _T("The client certificate does not contain a valid UPN, or does not match the client name in the logon request.  Please contact your administrator."))
      CASE_ERRCODE2(STATUS_SMARTCARD_LOGON_REQUIRED                                    , _T("Smartcard logon is required and was not used."))
      CASE_ERRCODE2(STATUS_KDC_INVALID_REQUEST                                         , _T("An invalid request was sent to the KDC."))
      CASE_ERRCODE2(STATUS_KDC_UNABLE_TO_REFER                                         , _T("The KDC was unable to generate a referral for the service requested."))
      CASE_ERRCODE2(STATUS_KDC_UNKNOWN_ETYPE                                           , _T("The encryption type requested is not supported by the KDC."))
      CASE_ERRCODE2(STATUS_SHUTDOWN_IN_PROGRESS                                        , _T("A system shutdown is in progress."))
      CASE_ERRCODE2(STATUS_SERVER_SHUTDOWN_IN_PROGRESS                                 , _T("The server machine is shutting down."))
      CASE_ERRCODE2(STATUS_NOT_SUPPORTED_ON_SBS                                        , _T("This operation is not supported on a computer running Windows Server 2003 for Small Business Server"))
      CASE_ERRCODE2(STATUS_WMI_GUID_DISCONNECTED                                       , _T("The WMI GUID is no longer available"))
      CASE_ERRCODE2(STATUS_WMI_ALREADY_DISABLED                                        , _T("Collection or events for the WMI GUID is already disabled."))
      CASE_ERRCODE2(STATUS_WMI_ALREADY_ENABLED                                         , _T("Collection or events for the WMI GUID is already enabled."))
      CASE_ERRCODE2(STATUS_MFT_TOO_FRAGMENTED                                          , _T("The Master File Table on the volume is too fragmented to complete this operation."))
      CASE_ERRCODE2(STATUS_COPY_PROTECTION_FAILURE                                     , _T("Copy protection failure."))
      CASE_ERRCODE2(STATUS_CSS_AUTHENTICATION_FAILURE                                  , _T("Copy protection error - DVD CSS Authentication failed."))
      CASE_ERRCODE2(STATUS_CSS_KEY_NOT_PRESENT                                         , _T("Copy protection error - The given sector does not contain a valid key."))
      CASE_ERRCODE2(STATUS_CSS_KEY_NOT_ESTABLISHED                                     , _T("Copy protection error - DVD session key not established."))
      CASE_ERRCODE2(STATUS_CSS_SCRAMBLED_SECTOR                                        , _T("Copy protection error - The read failed because the sector is encrypted."))
      CASE_ERRCODE2(STATUS_CSS_REGION_MISMATCH                                         , _T("Copy protection error - The given DVD's region does not correspond to the region setting of the drive."))
      CASE_ERRCODE2(STATUS_CSS_RESETS_EXHAUSTED                                        , _T("Copy protection error - The drive's region setting may be permanent."))
      CASE_ERRCODE2(STATUS_PKINIT_FAILURE                                              , _T("The kerberos protocol encountered an error while validating the KDC certificate during smartcard Logon.  There is more information in the system event log."))
      CASE_ERRCODE2(STATUS_SMARTCARD_SUBSYSTEM_FAILURE                                 , _T("The kerberos protocol encountered an error while attempting to utilize the smartcard subsystem."))
      CASE_ERRCODE2(STATUS_NO_KERB_KEY                                                 , _T("The target server does not have acceptable kerberos credentials."))
      CASE_ERRCODE2(STATUS_HOST_DOWN                                                   , _T("The transport determined that the remote system is down."))
      CASE_ERRCODE2(STATUS_UNSUPPORTED_PREAUTH                                         , _T("An unsupported preauthentication mechanism was presented to the kerberos package."))
      CASE_ERRCODE2(STATUS_EFS_ALG_BLOB_TOO_BIG                                        , _T("The encryption algorithm used on the source file needs a bigger key buffer than the one used on the destination file."))
      CASE_ERRCODE2(STATUS_PORT_NOT_SET                                                , _T("An attempt to remove a processes DebugPort was made, but a port was not already associated with the process."))
      CASE_ERRCODE2(STATUS_DEBUGGER_INACTIVE                                           , _T("An attempt to do an operation on a debug port failed because the port is in the process of being deleted."))
      CASE_ERRCODE2(STATUS_DS_VERSION_CHECK_FAILURE                                    , _T("This version of Windows is not compatible with the behavior version of directory forest, domain or domain controller."))
      CASE_ERRCODE2(STATUS_AUDITING_DISABLED                                           , _T("The specified event is currently not being audited."))
      CASE_ERRCODE2(STATUS_PRENT4_MACHINE_ACCOUNT                                      , _T("The machine account was created pre-NT4.  The account needs to be recreated."))
      CASE_ERRCODE2(STATUS_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER                            , _T("A account group can not have a universal group as a member."))
      CASE_ERRCODE2(STATUS_INVALID_IMAGE_WIN_32                                        , _T("The specified image file did not have the correct format, it appears to be a 32-bit Windows image."))
      CASE_ERRCODE2(STATUS_INVALID_IMAGE_WIN_64                                        , _T("The specified image file did not have the correct format, it appears to be a 64-bit Windows image."))
      CASE_ERRCODE2(STATUS_BAD_BINDINGS                                                , _T("Client's supplied SSPI channel bindings were incorrect."))
      CASE_ERRCODE2(STATUS_NETWORK_SESSION_EXPIRED                                     , _T("The client's session has expired, so the client must reauthenticate to continue accessing the remote resources."))
      CASE_ERRCODE2(STATUS_APPHELP_BLOCK                                               , _T("AppHelp dialog canceled thus preventing the application from starting."))
      CASE_ERRCODE2(STATUS_ALL_SIDS_FILTERED                                           , _T("The SID filtering operation removed all SIDs."))
      CASE_ERRCODE2(STATUS_NOT_SAFE_MODE_DRIVER                                        , _T("The driver was not loaded because the system is booting into safe mode."))
      CASE_ERRCODE2(STATUS_ACCESS_DISABLED_BY_POLICY_DEFAULT                           , _T("Access to %1 has been restricted by your Administrator by the default software restriction policy level."))
      CASE_ERRCODE2(STATUS_ACCESS_DISABLED_BY_POLICY_PATH                              , _T("Access to %1 has been restricted by your Administrator by location with policy rule %2 placed on path %3"))
      CASE_ERRCODE2(STATUS_ACCESS_DISABLED_BY_POLICY_PUBLISHER                         , _T("Access to %1 has been restricted by your Administrator by software publisher policy."))
      CASE_ERRCODE2(STATUS_ACCESS_DISABLED_BY_POLICY_OTHER                             , _T("Access to %1 has been restricted by your Administrator by policy rule %2."))
      CASE_ERRCODE2(STATUS_FAILED_DRIVER_ENTRY                                         , _T("The driver was not loaded because it failed it's initialization call."))
      CASE_ERRCODE2(STATUS_DEVICE_ENUMERATION_ERROR                                    , _T("The '%hs' encountered an error while applying power or reading the device configuration. This may be caused by a failure of your hardware or by a poor connection."))
      CASE_ERRCODE2(STATUS_WAIT_FOR_OPLOCK                                             , _T("An operation is blocked waiting for an oplock."))
      CASE_ERRCODE2(STATUS_MOUNT_POINT_NOT_RESOLVED                                    , _T("The create operation failed because the name contained at least one mount point which resolves to a volume to which the specified device object is not attached."))
      CASE_ERRCODE2(STATUS_INVALID_DEVICE_OBJECT_PARAMETER                             , _T("The device object parameter is either not a valid device object or is not attached to the volume specified by the file name."))
      CASE_ERRCODE2(STATUS_MCA_OCCURED                                                 , _T("A Machine Check Error has occurred. Please check the system eventlog for additional information."))
      CASE_ERRCODE2(STATUS_DRIVER_BLOCKED_CRITICAL                                     , _T("Driver %2 has been blocked from loading."))
      CASE_ERRCODE2(STATUS_DRIVER_BLOCKED                                              , _T("Driver %2 has been blocked from loading."))
      CASE_ERRCODE2(STATUS_DRIVER_DATABASE_ERROR                                       , _T("There was error [%2] processing the driver database."))
      CASE_ERRCODE2(STATUS_SYSTEM_HIVE_TOO_LARGE                                       , _T("System hive size has exceeded its limit."))
      CASE_ERRCODE2(STATUS_INVALID_IMPORT_OF_NON_DLL                                   , _T("A dynamic link library (DLL) referenced a module that was neither a DLL nor the process's executable image."))
      CASE_ERRCODE2(STATUS_DS_SHUTTING_DOWN                                            , _T("The Directory Service is shuting down."))
      CASE_ERRCODE2(STATUS_SMARTCARD_WRONG_PIN                                         , _T("An incorrect PIN was presented to the smart card"))
      CASE_ERRCODE2(STATUS_SMARTCARD_CARD_BLOCKED                                      , _T("The smart card is blocked"))
      CASE_ERRCODE2(STATUS_SMARTCARD_CARD_NOT_AUTHENTICATED                            , _T("No PIN was presented to the smart card"))
      CASE_ERRCODE2(STATUS_SMARTCARD_NO_CARD                                           , _T("No smart card available"))
      CASE_ERRCODE2(STATUS_SMARTCARD_NO_KEY_CONTAINER                                  , _T("The requested key container does not exist on the smart card"))
      CASE_ERRCODE2(STATUS_SMARTCARD_NO_CERTIFICATE                                    , _T("The requested certificate does not exist on the smart card"))
      CASE_ERRCODE2(STATUS_SMARTCARD_NO_KEYSET                                         , _T("The requested keyset does not exist"))
      CASE_ERRCODE2(STATUS_SMARTCARD_IO_ERROR                                          , _T("A communication error with the smart card has been detected."))
      CASE_ERRCODE2(STATUS_DOWNGRADE_DETECTED                                          , _T("The system detected a possible attempt to compromise security. Please ensure that you can contact the server that authenticated you."))
      CASE_ERRCODE2(STATUS_SMARTCARD_CERT_REVOKED                                      , _T("The smartcard certificate used for authentication has been revoked. Please contact your system administrator.  There may be additional information in the event log."))
      CASE_ERRCODE2(STATUS_ISSUING_CA_UNTRUSTED                                        , _T("An untrusted certificate authority was detected While processing the smartcard certificate used for authentication.  Please contact your system administrator."))
      CASE_ERRCODE2(STATUS_REVOCATION_OFFLINE_C                                        , _T("The revocation status of the smartcard certificate used for authentication could not be determined. Please contact your system administrator."))
      CASE_ERRCODE2(STATUS_PKINIT_CLIENT_FAILURE                                       , _T("The smartcard certificate used for authentication was not trusted.  Please contact your system administrator."))
      CASE_ERRCODE2(STATUS_SMARTCARD_CERT_EXPIRED                                      , _T("The smartcard certificate used for authentication has expired.  Please contact your system administrator."))
      CASE_ERRCODE2(STATUS_DRIVER_FAILED_PRIOR_UNLOAD                                  , _T("The driver could not be loaded because a previous version of the driver is still in memory."))
      CASE_ERRCODE2(STATUS_SMARTCARD_SILENT_CONTEXT                                    , _T("The smartcard provider could not perform the action since the context was acquired as silent."))
      CASE_ERRCODE2(STATUS_PER_USER_TRUST_QUOTA_EXCEEDED                               , _T("The current user's delegated trust creation quota has been exceeded."))
      CASE_ERRCODE2(STATUS_ALL_USER_TRUST_QUOTA_EXCEEDED                               , _T("The total delegated trust creation quota has been exceeded."))
      CASE_ERRCODE2(STATUS_USER_DELETE_TRUST_QUOTA_EXCEEDED                            , _T("The current user's delegated trust deletion quota has been exceeded."))
      CASE_ERRCODE2(STATUS_DS_NAME_NOT_UNIQUE                                          , _T("The requested name already exists as a unique identifier."))
      CASE_ERRCODE2(STATUS_DS_DUPLICATE_ID_FOUND                                       , _T("The requested object has a non-unique identifier and cannot be retrieved."))
      CASE_ERRCODE2(STATUS_DS_GROUP_CONVERSION_ERROR                                   , _T("The group cannot be converted due to attribute restrictions on the requested group type."))
      CASE_ERRCODE2(STATUS_VOLSNAP_PREPARE_HIBERNATE                                   , _T("{Volume Shadow Copy Service} Please wait while the Volume Shadow Copy Service prepares volume %hs for hibernation."))
      CASE_ERRCODE2(STATUS_USER2USER_REQUIRED                                          , _T("Kerberos sub-protocol User2User is required."))
      CASE_ERRCODE2(STATUS_STACK_BUFFER_OVERRUN                                        , _T("The system detected an overrun of a stack-based buffer in this application.  This overrun could potentially allow a malicious user to gain control of this application."))
      CASE_ERRCODE2(STATUS_NO_S4U_PROT_SUPPORT                                         , _T("The Kerberos subsystem encountered an error.  A service for user protocol request was made against a domain controller which does not support service for user."))
      CASE_ERRCODE2(STATUS_CROSSREALM_DELEGATION_FAILURE                               , _T("An attempt was made by this server to make a Kerberos constrained delegation request for a target outside of the server's realm.  This is not supported, and indicates a misconfiguration on this server's allowed to delegate to list.  Please contact your administrator."))
      CASE_ERRCODE2(STATUS_REVOCATION_OFFLINE_KDC                                      , _T("The revocation status of the domain controller certificate used for smartcard authentication could not be determined.  There is additional information in the system event log. Please contact your system administrator."))
      CASE_ERRCODE2(STATUS_ISSUING_CA_UNTRUSTED_KDC                                    , _T("An untrusted certificate authority was detected while processing the domain controller certificate used for authentication.  There is additional information in the system event log.  Please contact your system administrator."))
      CASE_ERRCODE2(STATUS_KDC_CERT_EXPIRED                                            , _T("The domain controller certificate used for smartcard logon has expired. Please contact your system administrator with the contents of your system event log."))
      CASE_ERRCODE2(STATUS_KDC_CERT_REVOKED                                            , _T("The domain controller certificate used for smartcard logon has been revoked. Please contact your system administrator with the contents of your system event log."))
      CASE_ERRCODE2(STATUS_PARAMETER_QUOTA_EXCEEDED                                    , _T("Data present in one of the parameters is more than the function can operate on."))
      CASE_ERRCODE2(STATUS_HIBERNATION_FAILURE                                         , _T("The system has failed to hibernate (The error code is %hs).  Hibernation will be disabled until the system is restarted."))
      CASE_ERRCODE2(STATUS_DELAY_LOAD_FAILED                                           , _T("An attempt to delay-load a .dll or get a function address in a delay-loaded .dll failed."))
      CASE_ERRCODE2(STATUS_AUTHENTICATION_FIREWALL_FAILED                              , _T("Logon Failure: The machine you are logging onto is protected by an authentication firewall.  The specified account is not allowed to authenticate to the machine."))
      CASE_ERRCODE2(STATUS_VDM_DISALLOWED                                              , _T("%hs is a 16-bit application. You do not have permissions to execute 16-bit applications. Check your permissions with your system administrator."))
      CASE_ERRCODE2(STATUS_HUNG_DISPLAY_DRIVER_THREAD                                  , _T("{Display Driver Stopped Responding} The %hs display driver has stopped working normally.  Save your work and reboot the system to restore full display functionality. The next time you reboot the machine a dialog will be displayed giving you a chance to report this failure to Microsoft."))
      CASE_ERRCODE2(STATUS_WOW_ASSERTION                                               , _T("WOW Assertion Error."))
      CASE_ERRCODE2(DBG_NO_STATE_CHANGE                                                , _T("Debugger did not perform a state change."))
      CASE_ERRCODE2(DBG_APP_NOT_IDLE                                                   , _T("Debugger has found the application is not idle."))
      CASE_ERRCODE2(RPC_NT_INVALID_STRING_BINDING                                      , _T("The string binding is invalid."))
      CASE_ERRCODE2(RPC_NT_WRONG_KIND_OF_BINDING                                       , _T("The binding handle is not the correct type."))
      CASE_ERRCODE2(RPC_NT_INVALID_BINDING                                             , _T("The binding handle is invalid."))
      CASE_ERRCODE2(RPC_NT_PROTSEQ_NOT_SUPPORTED                                       , _T("The RPC protocol sequence is not supported."))
      CASE_ERRCODE2(RPC_NT_INVALID_RPC_PROTSEQ                                         , _T("The RPC protocol sequence is invalid."))
      CASE_ERRCODE2(RPC_NT_INVALID_STRING_UUID                                         , _T("The string UUID is invalid."))
      CASE_ERRCODE2(RPC_NT_INVALID_ENDPOINT_FORMAT                                     , _T("The endpoint format is invalid."))
      CASE_ERRCODE2(RPC_NT_INVALID_NET_ADDR                                            , _T("The network address is invalid."))
      CASE_ERRCODE2(RPC_NT_NO_ENDPOINT_FOUND                                           , _T("No endpoint was found."))
      CASE_ERRCODE2(RPC_NT_INVALID_TIMEOUT                                             , _T("The timeout value is invalid."))
      CASE_ERRCODE2(RPC_NT_OBJECT_NOT_FOUND                                            , _T("The object UUID was not found."))
      CASE_ERRCODE2(RPC_NT_ALREADY_REGISTERED                                          , _T("The object UUID has already been registered."))
      CASE_ERRCODE2(RPC_NT_TYPE_ALREADY_REGISTERED                                     , _T("The type UUID has already been registered."))
      CASE_ERRCODE2(RPC_NT_ALREADY_LISTENING                                           , _T("The RPC server is already listening."))
      CASE_ERRCODE2(RPC_NT_NO_PROTSEQS_REGISTERED                                      , _T("No protocol sequences have been registered."))
      CASE_ERRCODE2(RPC_NT_NOT_LISTENING                                               , _T("The RPC server is not listening."))
      CASE_ERRCODE2(RPC_NT_UNKNOWN_MGR_TYPE                                            , _T("The manager type is unknown."))
      CASE_ERRCODE2(RPC_NT_UNKNOWN_IF                                                  , _T("The interface is unknown."))
      CASE_ERRCODE2(RPC_NT_NO_BINDINGS                                                 , _T("There are no bindings."))
      CASE_ERRCODE2(RPC_NT_NO_PROTSEQS                                                 , _T("There are no protocol sequences."))
      CASE_ERRCODE2(RPC_NT_CANT_CREATE_ENDPOINT                                        , _T("The endpoint cannot be created."))
      CASE_ERRCODE2(RPC_NT_OUT_OF_RESOURCES                                            , _T("Not enough resources are available to complete this operation."))
      CASE_ERRCODE2(RPC_NT_SERVER_UNAVAILABLE                                          , _T("The RPC server is unavailable."))
      CASE_ERRCODE2(RPC_NT_SERVER_TOO_BUSY                                             , _T("The RPC server is too busy to complete this operation."))
      CASE_ERRCODE2(RPC_NT_INVALID_NETWORK_OPTIONS                                     , _T("The network options are invalid."))
      CASE_ERRCODE2(RPC_NT_NO_CALL_ACTIVE                                              , _T("There are no remote procedure calls active on this thread."))
      CASE_ERRCODE2(RPC_NT_CALL_FAILED                                                 , _T("The remote procedure call failed."))
      CASE_ERRCODE2(RPC_NT_CALL_FAILED_DNE                                             , _T("The remote procedure call failed and did not execute."))
      CASE_ERRCODE2(RPC_NT_PROTOCOL_ERROR                                              , _T("An RPC protocol error occurred."))
      CASE_ERRCODE2(RPC_NT_UNSUPPORTED_TRANS_SYN                                       , _T("The transfer syntax is not supported by the RPC server."))
      CASE_ERRCODE2(RPC_NT_UNSUPPORTED_TYPE                                            , _T("The type UUID is not supported."))
      CASE_ERRCODE2(RPC_NT_INVALID_TAG                                                 , _T("The tag is invalid."))
      CASE_ERRCODE2(RPC_NT_INVALID_BOUND                                               , _T("The array bounds are invalid."))
      CASE_ERRCODE2(RPC_NT_NO_ENTRY_NAME                                               , _T("The binding does not contain an entry name."))
      CASE_ERRCODE2(RPC_NT_INVALID_NAME_SYNTAX                                         , _T("The name syntax is invalid."))
      CASE_ERRCODE2(RPC_NT_UNSUPPORTED_NAME_SYNTAX                                     , _T("The name syntax is not supported."))
      CASE_ERRCODE2(RPC_NT_UUID_NO_ADDRESS                                             , _T("No network address is available to use to construct a UUID."))
      CASE_ERRCODE2(RPC_NT_DUPLICATE_ENDPOINT                                          , _T("The endpoint is a duplicate."))
      CASE_ERRCODE2(RPC_NT_UNKNOWN_AUTHN_TYPE                                          , _T("The authentication type is unknown."))
      CASE_ERRCODE2(RPC_NT_MAX_CALLS_TOO_SMALL                                         , _T("The maximum number of calls is too small."))
      CASE_ERRCODE2(RPC_NT_STRING_TOO_LONG                                             , _T("The string is too long."))
      CASE_ERRCODE2(RPC_NT_PROTSEQ_NOT_FOUND                                           , _T("The RPC protocol sequence was not found."))
      CASE_ERRCODE2(RPC_NT_PROCNUM_OUT_OF_RANGE                                        , _T("The procedure number is out of range."))
      CASE_ERRCODE2(RPC_NT_BINDING_HAS_NO_AUTH                                         , _T("The binding does not contain any authentication information."))
      CASE_ERRCODE2(RPC_NT_UNKNOWN_AUTHN_SERVICE                                       , _T("The authentication service is unknown."))
      CASE_ERRCODE2(RPC_NT_UNKNOWN_AUTHN_LEVEL                                         , _T("The authentication level is unknown."))
      CASE_ERRCODE2(RPC_NT_INVALID_AUTH_IDENTITY                                       , _T("The security context is invalid."))
      CASE_ERRCODE2(RPC_NT_UNKNOWN_AUTHZ_SERVICE                                       , _T("The authorization service is unknown."))
      CASE_ERRCODE2(EPT_NT_INVALID_ENTRY                                               , _T("The entry is invalid."))
      CASE_ERRCODE2(EPT_NT_CANT_PERFORM_OP                                             , _T("The operation cannot be performed."))
      CASE_ERRCODE2(EPT_NT_NOT_REGISTERED                                              , _T("There are no more endpoints available from the endpoint mapper."))
      CASE_ERRCODE2(RPC_NT_NOTHING_TO_EXPORT                                           , _T("No interfaces have been exported."))
      CASE_ERRCODE2(RPC_NT_INCOMPLETE_NAME                                             , _T("The entry name is incomplete."))
      CASE_ERRCODE2(RPC_NT_INVALID_VERS_OPTION                                         , _T("The version option is invalid."))
      CASE_ERRCODE2(RPC_NT_NO_MORE_MEMBERS                                             , _T("There are no more members."))
      CASE_ERRCODE2(RPC_NT_NOT_ALL_OBJS_UNEXPORTED                                     , _T("There is nothing to unexport."))
      CASE_ERRCODE2(RPC_NT_INTERFACE_NOT_FOUND                                         , _T("The interface was not found."))
      CASE_ERRCODE2(RPC_NT_ENTRY_ALREADY_EXISTS                                        , _T("The entry already exists."))
      CASE_ERRCODE2(RPC_NT_ENTRY_NOT_FOUND                                             , _T("The entry is not found."))
      CASE_ERRCODE2(RPC_NT_NAME_SERVICE_UNAVAILABLE                                    , _T("The name service is unavailable."))
      CASE_ERRCODE2(RPC_NT_INVALID_NAF_ID                                              , _T("The network address family is invalid."))
      CASE_ERRCODE2(RPC_NT_CANNOT_SUPPORT                                              , _T("The requested operation is not supported."))
      CASE_ERRCODE2(RPC_NT_NO_CONTEXT_AVAILABLE                                        , _T("No security context is available to allow impersonation."))
      CASE_ERRCODE2(RPC_NT_INTERNAL_ERROR                                              , _T("An internal error occurred in RPC."))
      CASE_ERRCODE2(RPC_NT_ZERO_DIVIDE                                                 , _T("The RPC server attempted an integer divide by zero."))
      CASE_ERRCODE2(RPC_NT_ADDRESS_ERROR                                               , _T("An addressing error occurred in the RPC server."))
      CASE_ERRCODE2(RPC_NT_FP_DIV_ZERO                                                 , _T("A floating point operation at the RPC server caused a divide by zero."))
      CASE_ERRCODE2(RPC_NT_FP_UNDERFLOW                                                , _T("A floating point underflow occurred at the RPC server."))
      CASE_ERRCODE2(RPC_NT_FP_OVERFLOW                                                 , _T("A floating point overflow occurred at the RPC server."))
      CASE_ERRCODE2(RPC_NT_NO_MORE_ENTRIES                                             , _T("The list of RPC servers available for auto-handle binding has been exhausted."))
      CASE_ERRCODE2(RPC_NT_SS_CHAR_TRANS_OPEN_FAIL                                     , _T("The file designated by DCERPCCHARTRANS cannot be opened."))
      CASE_ERRCODE2(RPC_NT_SS_CHAR_TRANS_SHORT_FILE                                    , _T("The file containing the character translation table has fewer than 512 bytes."))
      CASE_ERRCODE2(RPC_NT_SS_IN_NULL_CONTEXT                                          , _T("A null context handle is passed as an [in] parameter."))
      CASE_ERRCODE2(RPC_NT_SS_CONTEXT_MISMATCH                                         , _T("The context handle does not match any known context handles."))
      CASE_ERRCODE2(RPC_NT_SS_CONTEXT_DAMAGED                                          , _T("The context handle changed during a call."))
      CASE_ERRCODE2(RPC_NT_SS_HANDLES_MISMATCH                                         , _T("The binding handles passed to a remote procedure call do not match."))
      CASE_ERRCODE2(RPC_NT_SS_CANNOT_GET_CALL_HANDLE                                   , _T("The stub is unable to get the call handle."))
      CASE_ERRCODE2(RPC_NT_NULL_REF_POINTER                                            , _T("A null reference pointer was passed to the stub."))
      CASE_ERRCODE2(RPC_NT_ENUM_VALUE_OUT_OF_RANGE                                     , _T("The enumeration value is out of range."))
      CASE_ERRCODE2(RPC_NT_BYTE_COUNT_TOO_SMALL                                        , _T("The byte count is too small."))
      CASE_ERRCODE2(RPC_NT_BAD_STUB_DATA                                               , _T("The stub received bad data."))
      CASE_ERRCODE2(RPC_NT_CALL_IN_PROGRESS                                            , _T("A remote procedure call is already in progress for this thread."))
      CASE_ERRCODE2(RPC_NT_NO_MORE_BINDINGS                                            , _T("There are no more bindings."))
      CASE_ERRCODE2(RPC_NT_GROUP_MEMBER_NOT_FOUND                                      , _T("The group member was not found."))
      CASE_ERRCODE2(EPT_NT_CANT_CREATE                                                 , _T("The endpoint mapper database entry could not be created."))
      CASE_ERRCODE2(RPC_NT_INVALID_OBJECT                                              , _T("The object UUID is the nil UUID."))
      CASE_ERRCODE2(RPC_NT_NO_INTERFACES                                               , _T("No interfaces have been registered."))
      CASE_ERRCODE2(RPC_NT_CALL_CANCELLED                                              , _T("The remote procedure call was cancelled."))
      CASE_ERRCODE2(RPC_NT_BINDING_INCOMPLETE                                          , _T("The binding handle does not contain all required information."))
      CASE_ERRCODE2(RPC_NT_COMM_FAILURE                                                , _T("A communications failure occurred during a remote procedure call."))
      CASE_ERRCODE2(RPC_NT_UNSUPPORTED_AUTHN_LEVEL                                     , _T("The requested authentication level is not supported."))
      CASE_ERRCODE2(RPC_NT_NO_PRINC_NAME                                               , _T("No principal name registered."))
      CASE_ERRCODE2(RPC_NT_NOT_RPC_ERROR                                               , _T("The error specified is not a valid Windows RPC error code."))
      CASE_ERRCODE2(RPC_NT_UUID_LOCAL_ONLY                                             , _T("A UUID that is valid only on this computer has been allocated."))
      CASE_ERRCODE2(RPC_NT_SEC_PKG_ERROR                                               , _T("A security package specific error occurred."))
      CASE_ERRCODE2(RPC_NT_NOT_CANCELLED                                               , _T("Thread is not cancelled."))
      CASE_ERRCODE2(RPC_NT_INVALID_ES_ACTION                                           , _T("Invalid operation on the encoding/decoding handle."))
      CASE_ERRCODE2(RPC_NT_WRONG_ES_VERSION                                            , _T("Incompatible version of the serializing package."))
      CASE_ERRCODE2(RPC_NT_WRONG_STUB_VERSION                                          , _T("Incompatible version of the RPC stub."))
      CASE_ERRCODE2(RPC_NT_INVALID_PIPE_OBJECT                                         , _T("The RPC pipe object is invalid or corrupted."))
      CASE_ERRCODE2(RPC_NT_INVALID_PIPE_OPERATION                                      , _T("An invalid operation was attempted on an RPC pipe object."))
      CASE_ERRCODE2(RPC_NT_WRONG_PIPE_VERSION                                          , _T("Unsupported RPC pipe version."))
      CASE_ERRCODE2(RPC_NT_PIPE_CLOSED                                                 , _T("The RPC pipe object has already been closed."))
      CASE_ERRCODE2(RPC_NT_PIPE_DISCIPLINE_ERROR                                       , _T("The RPC call completed before all pipes were processed."))
      CASE_ERRCODE2(RPC_NT_PIPE_EMPTY                                                  , _T("No more data is available from the RPC pipe."))
      CASE_ERRCODE2(RPC_NT_INVALID_ASYNC_HANDLE                                        , _T("Invalid asynchronous remote procedure call handle."))
      CASE_ERRCODE2(RPC_NT_INVALID_ASYNC_CALL                                          , _T("Invalid asynchronous RPC call handle for this operation."))
      CASE_ERRCODE2(RPC_NT_SEND_INCOMPLETE                                             , _T("Some data remains to be sent in the request buffer."))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_OPCODE                                         , _T("An attempt was made to run an invalid AML opcode"))
      CASE_ERRCODE2(STATUS_ACPI_STACK_OVERFLOW                                         , _T("The AML Interpreter Stack has overflowed"))
      CASE_ERRCODE2(STATUS_ACPI_ASSERT_FAILED                                          , _T("An inconsistent state has occurred"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_INDEX                                          , _T("An attempt was made to access an array outside of its bounds"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_ARGUMENT                                       , _T("A required argument was not specified"))
      CASE_ERRCODE2(STATUS_ACPI_FATAL                                                  , _T("A fatal error has occurred"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_SUPERNAME                                      , _T("An invalid SuperName was specified"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_ARGTYPE                                        , _T("An argument with an incorrect type was specified"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_OBJTYPE                                        , _T("An object with an incorrect type was specified"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_TARGETTYPE                                     , _T("A target with an incorrect type was specified"))
      CASE_ERRCODE2(STATUS_ACPI_INCORRECT_ARGUMENT_COUNT                               , _T("An incorrect number of arguments were specified"))
      CASE_ERRCODE2(STATUS_ACPI_ADDRESS_NOT_MAPPED                                     , _T("An address failed to translate"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_EVENTTYPE                                      , _T("An incorrect event type was specified"))
      CASE_ERRCODE2(STATUS_ACPI_HANDLER_COLLISION                                      , _T("A handler for the target already exists"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_DATA                                           , _T("Invalid data for the target was specified"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_REGION                                         , _T("An invalid region for the target was specified"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_ACCESS_SIZE                                    , _T("An attempt was made to access a field outside of the defined range"))
      CASE_ERRCODE2(STATUS_ACPI_ACQUIRE_GLOBAL_LOCK                                    , _T("The Global system lock could not be acquired"))
      CASE_ERRCODE2(STATUS_ACPI_ALREADY_INITIALIZED                                    , _T("An attempt was made to reinitialize the ACPI subsystem"))
      CASE_ERRCODE2(STATUS_ACPI_NOT_INITIALIZED                                        , _T("The ACPI subsystem has not been initialized"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_MUTEX_LEVEL                                    , _T("An incorrect mutex was specified"))
      CASE_ERRCODE2(STATUS_ACPI_MUTEX_NOT_OWNED                                        , _T("The mutex is not currently owned"))
      CASE_ERRCODE2(STATUS_ACPI_MUTEX_NOT_OWNER                                        , _T("An attempt was made to access the mutex by a process that was not the owner"))
      CASE_ERRCODE2(STATUS_ACPI_RS_ACCESS                                              , _T("An error occurred during an access to Region Space"))
      CASE_ERRCODE2(STATUS_ACPI_INVALID_TABLE                                          , _T("An attempt was made to use an incorrect table"))
      CASE_ERRCODE2(STATUS_ACPI_REG_HANDLER_FAILED                                     , _T("The registration of an ACPI event failed"))
      CASE_ERRCODE2(STATUS_ACPI_POWER_REQUEST_FAILED                                   , _T("An ACPI Power Object failed to transition state"))
      CASE_ERRCODE2(STATUS_CTX_WINSTATION_NAME_INVALID                                 , _T("Session name %1 is invalid."))
      CASE_ERRCODE2(STATUS_CTX_INVALID_PD                                              , _T("The protocol driver %1 is invalid."))
      CASE_ERRCODE2(STATUS_CTX_PD_NOT_FOUND                                            , _T("The protocol driver %1 was not found in the system path."))
      CASE_ERRCODE2(STATUS_CTX_CDM_CONNECT                                             , _T("The Client Drive Mapping Service Has Connected on Terminal Connection."))
      CASE_ERRCODE2(STATUS_CTX_CDM_DISCONNECT                                          , _T("The Client Drive Mapping Service Has Disconnected on Terminal Connection."))
      CASE_ERRCODE2(STATUS_CTX_CLOSE_PENDING                                           , _T("A close operation is pending on the Terminal Connection."))
      CASE_ERRCODE2(STATUS_CTX_NO_OUTBUF                                               , _T("There are no free output buffers available."))
      CASE_ERRCODE2(STATUS_CTX_MODEM_INF_NOT_FOUND                                     , _T("The MODEM.INF file was not found."))
      CASE_ERRCODE2(STATUS_CTX_INVALID_MODEMNAME                                       , _T("The modem (%1) was not found in MODEM.INF."))
      CASE_ERRCODE2(STATUS_CTX_RESPONSE_ERROR                                          , _T("The modem did not accept the command sent to it. Verify the configured modem name matches the attached modem."))
      CASE_ERRCODE2(STATUS_CTX_MODEM_RESPONSE_TIMEOUT                                  , _T("The modem did not respond to the command sent to it. Verify the modem is properly cabled and powered on."))
      CASE_ERRCODE2(STATUS_CTX_MODEM_RESPONSE_NO_CARRIER                               , _T("Carrier detect has failed or carrier has been dropped due to disconnect."))
      CASE_ERRCODE2(STATUS_CTX_MODEM_RESPONSE_NO_DIALTONE                              , _T("Dial tone not detected within required time. Verify phone cable is properly attached and functional."))
      CASE_ERRCODE2(STATUS_CTX_MODEM_RESPONSE_BUSY                                     , _T("Busy signal detected at remote site on callback."))
      CASE_ERRCODE2(STATUS_CTX_MODEM_RESPONSE_VOICE                                    , _T("Voice detected at remote site on callback."))
      CASE_ERRCODE2(STATUS_CTX_TD_ERROR                                                , _T("Transport driver error"))
      CASE_ERRCODE2(STATUS_CTX_LICENSE_CLIENT_INVALID                                  , _T("The client you are using is not licensed to use this system. Your logon request is denied."))
      CASE_ERRCODE2(STATUS_CTX_LICENSE_NOT_AVAILABLE                                   , _T("The system has reached its licensed logon limit. Please try again later."))
      CASE_ERRCODE2(STATUS_CTX_LICENSE_EXPIRED                                         , _T("The system license has expired. Your logon request is denied."))
      CASE_ERRCODE2(STATUS_CTX_WINSTATION_NOT_FOUND                                    , _T("The specified session cannot be found."))
      CASE_ERRCODE2(STATUS_CTX_WINSTATION_NAME_COLLISION                               , _T("The specified session name is already in use."))
      CASE_ERRCODE2(STATUS_CTX_WINSTATION_BUSY                                         , _T("The requested operation cannot be completed because the Terminal Connection is currently busy processing a connect, disconnect, reset, or delete operation."))
      CASE_ERRCODE2(STATUS_CTX_BAD_VIDEO_MODE                                          , _T("An attempt has been made to connect to a session whose video mode is not supported by the current client."))
      CASE_ERRCODE2(STATUS_CTX_GRAPHICS_INVALID                                        , _T("The application attempted to enable DOS graphics mode. DOS graphics mode is not supported."))
      CASE_ERRCODE2(STATUS_CTX_NOT_CONSOLE                                             , _T("The requested operation can be performed only on the system console. This is most often the result of a driver or system DLL requiring direct console access."))
      CASE_ERRCODE2(STATUS_CTX_CLIENT_QUERY_TIMEOUT                                    , _T("The client failed to respond to the server connect message."))
      CASE_ERRCODE2(STATUS_CTX_CONSOLE_DISCONNECT                                      , _T("Disconnecting the console session is not supported."))
      CASE_ERRCODE2(STATUS_CTX_CONSOLE_CONNECT                                         , _T("Reconnecting a disconnected session to the console is not supported."))
      CASE_ERRCODE2(STATUS_CTX_SHADOW_DENIED                                           , _T("The request to control another session remotely was denied."))
      CASE_ERRCODE2(STATUS_CTX_WINSTATION_ACCESS_DENIED                                , _T("A process has requested access to a session, but has not been granted those access rights."))
      CASE_ERRCODE2(STATUS_CTX_INVALID_WD                                              , _T("The Terminal Connection driver %1 is invalid."))
      CASE_ERRCODE2(STATUS_CTX_WD_NOT_FOUND                                            , _T("The Terminal Connection driver %1 was not found in the system path."))
      CASE_ERRCODE2(STATUS_CTX_SHADOW_INVALID                                          , _T("The requested session cannot be controlled remotely. You cannot control your own session, a session that is trying to control your session, a session that has no user logged on, nor control other sessions from the console."))
      CASE_ERRCODE2(STATUS_CTX_SHADOW_DISABLED                                         , _T("The requested session is not configured to allow remote control."))
      CASE_ERRCODE2(STATUS_RDP_PROTOCOL_ERROR                                          , _T("The RDP protocol component %2 detected an error in the protocol stream and has disconnected the client."))
      CASE_ERRCODE2(STATUS_CTX_CLIENT_LICENSE_NOT_SET                                  , _T("Your request to connect to this Terminal server has been rejected. Your Terminal Server Client license number has not been entered for this copy of the Terminal Client. Please call your system administrator for help in entering a valid, unique license number for this Terminal Server Client. Click OK to continue."))
      CASE_ERRCODE2(STATUS_CTX_CLIENT_LICENSE_IN_USE                                   , _T("Your request to connect to this Terminal server has been rejected. Your Terminal Server Client license number is currently being used by another user. Please call your system administrator to obtain a new copy of the Terminal Server Client with a valid, unique license number. Click OK to continue."))
      CASE_ERRCODE2(STATUS_CTX_SHADOW_ENDED_BY_MODE_CHANGE                             , _T("The remote control of the console was terminated because the display mode was changed. Changing the display mode in a remote control session is not supported."))
      CASE_ERRCODE2(STATUS_CTX_SHADOW_NOT_RUNNING                                      , _T("Remote control could not be terminated because the specified session is not currently being remotely controlled."))
      CASE_ERRCODE2(STATUS_PNP_BAD_MPS_TABLE                                           , _T("A device is missing in the system BIOS MPS table. This device will not be used. Please contact your system vendor for system BIOS update."))
      CASE_ERRCODE2(STATUS_PNP_TRANSLATION_FAILED                                      , _T("A translator failed to translate resources."))
      CASE_ERRCODE2(STATUS_PNP_IRQ_TRANSLATION_FAILED                                  , _T("A IRQ translator failed to translate resources."))
      CASE_ERRCODE2(STATUS_PNP_INVALID_ID                                              , _T("Driver %2 returned invalid ID for a child device (%3)."))
      CASE_ERRCODE2(STATUS_SXS_SECTION_NOT_FOUND                                       , _T("The requested section is not present in the activation context."))
      CASE_ERRCODE2(STATUS_SXS_CANT_GEN_ACTCTX                                         , _T("Windows was not able to process the application binding information. Please refer to your System Event Log for further information."))
      CASE_ERRCODE2(STATUS_SXS_INVALID_ACTCTXDATA_FORMAT                               , _T("The application binding data format is invalid."))
      CASE_ERRCODE2(STATUS_SXS_ASSEMBLY_NOT_FOUND                                      , _T("The referenced assembly is not installed on your system."))
      CASE_ERRCODE2(STATUS_SXS_MANIFEST_FORMAT_ERROR                                   , _T("The manifest file does not begin with the required tag and format information."))
      CASE_ERRCODE2(STATUS_SXS_MANIFEST_PARSE_ERROR                                    , _T("The manifest file contains one or more syntax errors."))
      CASE_ERRCODE2(STATUS_SXS_ACTIVATION_CONTEXT_DISABLED                             , _T("The application attempted to activate a disabled activation context."))
      CASE_ERRCODE2(STATUS_SXS_KEY_NOT_FOUND                                           , _T("The requested lookup key was not found in any active activation context."))
      CASE_ERRCODE2(STATUS_SXS_VERSION_CONFLICT                                        , _T("A component version required by the application conflicts with another component version already active."))
      CASE_ERRCODE2(STATUS_SXS_WRONG_SECTION_TYPE                                      , _T("The type requested activation context section does not match the query API used."))
      CASE_ERRCODE2(STATUS_SXS_THREAD_QUERIES_DISABLED                                 , _T("Lack of system resources has required isolated activation to be disabled for the current thread of execution."))
      CASE_ERRCODE2(STATUS_SXS_ASSEMBLY_MISSING                                        , _T("The referenced assembly could not be found."))
      CASE_ERRCODE2(STATUS_SXS_RELEASE_ACTIVATION_CONTEXT                              , _T("A kernel mode component is releasing a reference on an activation context."))
      CASE_ERRCODE2(STATUS_SXS_PROCESS_DEFAULT_ALREADY_SET                             , _T("An attempt to set the process default activation context failed because the process default activation context was already set."))
      CASE_ERRCODE2(STATUS_SXS_EARLY_DEACTIVATION                                      , _T("The activation context being deactivated is not the most recently activated one."))
      CASE_ERRCODE2(STATUS_SXS_INVALID_DEACTIVATION                                    , _T("The activation context being deactivated is not active for the current thread of execution."))
      CASE_ERRCODE2(STATUS_SXS_MULTIPLE_DEACTIVATION                                   , _T("The activation context being deactivated has already been deactivated."))
      CASE_ERRCODE2(STATUS_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY                 , _T("The activation context of system default assembly could not be generated."))
      CASE_ERRCODE2(STATUS_SXS_PROCESS_TERMINATION_REQUESTED                           , _T("A component used by the isolation facility has requested to terminate the process."))
      CASE_ERRCODE2(STATUS_SXS_CORRUPT_ACTIVATION_STACK                                , _T("The activation context activation stack for the running thread of execution is corrupt."))
      CASE_ERRCODE2(STATUS_SXS_CORRUPTION                                              , _T("The application isolation metadata for this process or thread has become corrupt."))
      CASE_ERRCODE2(STATUS_CLUSTER_INVALID_NODE                                        , _T("The cluster node is not valid."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_EXISTS                                         , _T("The cluster node already exists."))
      CASE_ERRCODE2(STATUS_CLUSTER_JOIN_IN_PROGRESS                                    , _T("A node is in the process of joining the cluster."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_NOT_FOUND                                      , _T("The cluster node was not found."))
      CASE_ERRCODE2(STATUS_CLUSTER_LOCAL_NODE_NOT_FOUND                                , _T("The cluster local node information was not found."))
      CASE_ERRCODE2(STATUS_CLUSTER_NETWORK_EXISTS                                      , _T("The cluster network already exists."))
      CASE_ERRCODE2(STATUS_CLUSTER_NETWORK_NOT_FOUND                                   , _T("The cluster network was not found."))
      CASE_ERRCODE2(STATUS_CLUSTER_NETINTERFACE_EXISTS                                 , _T("The cluster network interface already exists."))
      CASE_ERRCODE2(STATUS_CLUSTER_NETINTERFACE_NOT_FOUND                              , _T("The cluster network interface was not found."))
      CASE_ERRCODE2(STATUS_CLUSTER_INVALID_REQUEST                                     , _T("The cluster request is not valid for this object."))
      CASE_ERRCODE2(STATUS_CLUSTER_INVALID_NETWORK_PROVIDER                            , _T("The cluster network provider is not valid."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_DOWN                                           , _T("The cluster node is down."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_UNREACHABLE                                    , _T("The cluster node is not reachable."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_NOT_MEMBER                                     , _T("The cluster node is not a member of the cluster."))
      CASE_ERRCODE2(STATUS_CLUSTER_JOIN_NOT_IN_PROGRESS                                , _T("A cluster join operation is not in progress."))
      CASE_ERRCODE2(STATUS_CLUSTER_INVALID_NETWORK                                     , _T("The cluster network is not valid."))
      CASE_ERRCODE2(STATUS_CLUSTER_NO_NET_ADAPTERS                                     , _T("No network adapters are available."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_UP                                             , _T("The cluster node is up."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_PAUSED                                         , _T("The cluster node is paused."))
      CASE_ERRCODE2(STATUS_CLUSTER_NODE_NOT_PAUSED                                     , _T("The cluster node is not paused."))
      CASE_ERRCODE2(STATUS_CLUSTER_NO_SECURITY_CONTEXT                                 , _T("No cluster security context is available."))
      CASE_ERRCODE2(STATUS_CLUSTER_NETWORK_NOT_INTERNAL                                , _T("The cluster network is not configured for internal cluster communication."))
      CASE_ERRCODE2(STATUS_CLUSTER_POISONED                                            , _T("The cluster node has been poisoned."))
#endif // __SDK__
      // END part extInfo == info_NTStatus
      default: break;
      }

#ifdef __SDK__
      if (extInfo == info_NTStatus) {
         switch (lErrCode) {
         CASE_ERRCODE1(STATUS_WAIT_0)
         CASE_ERRCODE1(STATUS_WAIT_1)
         CASE_ERRCODE1(STATUS_WAIT_2)
         CASE_ERRCODE1(STATUS_WAIT_3)
         CASE_ERRCODE1(STATUS_WAIT_63)
       //CASE_ERRCODE2(STATUS_ABANDONED                                                   , _T("The success status codes 128 - 191 are reserved for wait completion status with an abandoned mutant object."))
         CASE_ERRCODE1(STATUS_ABANDONED_WAIT_0)
         CASE_ERRCODE1(STATUS_ABANDONED_WAIT_63)
         CASE_ERRCODE1(STATUS_USER_APC)
         CASE_ERRCODE1(STATUS_KERNEL_APC)
         CASE_ERRCODE1(STATUS_ALERTED)
         CASE_ERRCODE1(STATUS_TIMEOUT)
         CASE_ERRCODE2(STATUS_PENDING                                                     , _T("The operation that was requested is pending completion."))
         CASE_ERRCODE2(STATUS_REPARSE                                                     , _T("A reparse should be performed by the Object Manager since the name of the file resulted in a symbolic link."))
         CASE_ERRCODE2(STATUS_MORE_ENTRIES                                                , _T("Returned by enumeration APIs to indicate more information is available to successive calls."))
         CASE_ERRCODE2(STATUS_NOT_ALL_ASSIGNED                                            , _T("Indicates not all privileges referenced are assigned to the caller. This allows, for example, all privileges to be disabled without having to know exactly which privileges are assigned."))
         CASE_ERRCODE2(STATUS_SOME_NOT_MAPPED                                             , _T("Some of the information to be translated has not been translated."))
         CASE_ERRCODE2(STATUS_OPLOCK_BREAK_IN_PROGRESS                                    , _T("An open/create operation completed while an oplock break is underway."))
         CASE_ERRCODE2(STATUS_VOLUME_MOUNTED                                              , _T("A new volume has been mounted by a file system."))
         CASE_ERRCODE2(STATUS_RXACT_COMMITTED                                             , _T("This success level status indicates that the transaction state already exists for the registry sub-tree, but that a transaction commit was previously aborted. The commit has now been completed."))
         CASE_ERRCODE2(STATUS_NOTIFY_CLEANUP                                              , _T("This indicates that a notify change request has been completed due to closing the handle which made the notify change request."))
         CASE_ERRCODE2(STATUS_NOTIFY_ENUM_DIR                                             , _T("This indicates that a notify change request is being completed and that the information is not being returned in the caller's buffer. The caller now needs to enumerate the files to find the changes."))
         CASE_ERRCODE2(STATUS_NO_QUOTAS_FOR_ACCOUNT                                       , _T("{No Quotas} No system quota limits are specifically set for this account."))
         CASE_ERRCODE2(STATUS_PRIMARY_TRANSPORT_CONNECT_FAILED                            , _T("{Connect Failure on Primary Transport} An attempt was made to connect to the remote server %hs on the primary transport, but the connection failed. The computer WAS able to connect on a secondary transport."))
         CASE_ERRCODE2(STATUS_PAGE_FAULT_TRANSITION                                       , _T("Page fault was a transition fault."))
         CASE_ERRCODE2(STATUS_PAGE_FAULT_DEMAND_ZERO                                      , _T("Page fault was a demand zero fault."))
         CASE_ERRCODE2(STATUS_PAGE_FAULT_COPY_ON_WRITE                                    , _T("Page fault was a demand zero fault."))
         CASE_ERRCODE2(STATUS_PAGE_FAULT_GUARD_PAGE                                       , _T("Page fault was a demand zero fault."))
         CASE_ERRCODE2(STATUS_PAGE_FAULT_PAGING_FILE                                      , _T("Page fault was satisfied by reading from a secondary storage device."))
         CASE_ERRCODE2(STATUS_CACHE_PAGE_LOCKED                                           , _T("Cached page was locked during operation."))
         CASE_ERRCODE2(STATUS_CRASH_DUMP                                                  , _T("Crash dump exists in paging file."))
         CASE_ERRCODE2(STATUS_BUFFER_ALL_ZEROS                                            , _T("Specified buffer contains all zeros."))
         CASE_ERRCODE2(STATUS_REPARSE_OBJECT                                              , _T("A reparse should be performed by the Object Manager since the name of the file resulted in a symbolic link."))
         CASE_ERRCODE2(STATUS_RESOURCE_REQUIREMENTS_CHANGED                               , _T("The device has succeeded a query-stop and its resource requirements have changed."))
         CASE_ERRCODE2(STATUS_TRANSLATION_COMPLETE                                        , _T("The translator has translated these resources into the global space and no further translations should be performed."))
         CASE_ERRCODE2(STATUS_DS_MEMBERSHIP_EVALUATED_LOCALLY                             , _T("The directory service evaluated group memberships locally, as it was unable to contact a global catalog server."))
         CASE_ERRCODE2(STATUS_NOTHING_TO_TERMINATE                                        , _T("A process being terminated has no threads to terminate."))
         CASE_ERRCODE2(STATUS_PROCESS_NOT_IN_JOB                                          , _T("The specified process is not part of a job."))
         CASE_ERRCODE2(STATUS_PROCESS_IN_JOB                                              , _T("The specified process is part of a job."))
         CASE_ERRCODE2(STATUS_VOLSNAP_HIBERNATE_READY                                     , _T("{Volume Shadow Copy Service} The system is now ready for hibernation."))
         CASE_ERRCODE2(STATUS_FSFILTER_OP_COMPLETED_SUCCESSFULLY                          , _T("A file system or file system filter driver has successfully completed an FsFilter operation."))
         CASE_ERRCODE2(DBG_EXCEPTION_HANDLED                                              , _T("Debugger handled exception"))
         CASE_ERRCODE2(DBG_CONTINUE                                                       , _T("Debugger continued"))

         CASE_ERRCODE2(STATUS_HANDLES_CLOSED                                              , _T("{Handles Closed}. Handles to objects have been automatically closed as a result of the requested operation."))
         CASE_ERRCODE2(DBG_EXCEPTION_NOT_HANDLED                                          , _T("Debugger did not handle the exception."))
         default:
            if ((lErrCode >= STATUS_ABANDONED_WAIT_0) &&
                (lErrCode <= STATUS_ABANDONED_WAIT_63))
            {
               if (bDescription) {
                  strRes = _T("The success status code. Reserved for wait completion status with an abandoned mutant object.");
               } else {
                  strRes.Format(_T("STATUS_ABANDONED_WAIT_%i"), lErrCode-STATUS_ABANDONED_WAIT_0);
               }
            }
         }
      }
#endif // __SDK__

#ifndef ERROR_WINHTTP_PROXY_AUTH_REQUIRED
   #define ERROR_WINHTTP_PROXY_AUTH_REQUIRED 12185 // see <WinHttp.h>, part 'WinHttp API error' or define WINHTTP_ERROR_BASE and WINHTTP_ERROR_LAST
#endif

#ifdef __SDK__
      if ((extInfo == info_WinHTTP) &&
          ((lErrCode >= WINHTTP_ERROR_BASE) &&
           (lErrCode <= max(WINHTTP_ERROR_LAST, ERROR_WINHTTP_PROXY_AUTH_REQUIRED)))
         )
      {
         switch (lErrCode) {
         CASE_ERRCODE2(WINHTTP_ERROR_BASE                                   , _T("WinHttp API error. "))
         CASE_ERRCODE2(ERROR_WINHTTP_OUT_OF_HANDLES                         , _T("WinHttp API error. Obsolete; no longer used."))
         CASE_ERRCODE2(ERROR_WINHTTP_TIMEOUT                                , _T("WinHttp API error. The request has timed out."))
         CASE_ERRCODE2(ERROR_WINHTTP_INTERNAL_ERROR                         , _T("WinHttp API error. An internal error has occurred."))
         CASE_ERRCODE2(ERROR_WINHTTP_INVALID_URL                            , _T("WinHttp API error. The URL is invalid."))
         CASE_ERRCODE2(ERROR_WINHTTP_UNRECOGNIZED_SCHEME                    , _T("WinHttp API error. The URL specified a scheme other than 'http:' or 'https:'."))
         CASE_ERRCODE2(ERROR_WINHTTP_NAME_NOT_RESOLVED                      , _T("WinHttp API error. The server name could not be resolved."))
         CASE_ERRCODE2(ERROR_WINHTTP_INVALID_OPTION                         , _T("WinHttp API error. A request to WinHttpQueryOption or WinHttpSetOption specified an invalid option value."))
         CASE_ERRCODE2(ERROR_WINHTTP_OPTION_NOT_SETTABLE                    , _T("WinHttp API error. The requested option cannot be set, only queried."))
         CASE_ERRCODE2(ERROR_WINHTTP_SHUTDOWN                               , _T("WinHttp API error. The WinHTTP function support is being shut down or unloaded."))
         CASE_ERRCODE2(ERROR_WINHTTP_LOGIN_FAILURE                          , _T("WinHttp API error. The login attempt failed. When this error is encountered, the request handle should be closed with WinHttpCloseHandle. A new request handle must be created before retrying the function that originally produced this error."))
         CASE_ERRCODE2(ERROR_WINHTTP_OPERATION_CANCELLED                    , _T("WinHttp API error. The operation was canceled, usually because the handle on which the request was operating was closed before the operation completed."))
         CASE_ERRCODE2(ERROR_WINHTTP_INCORRECT_HANDLE_TYPE                  , _T("WinHttp API error. The type of handle supplied is incorrect for this operation."))
         CASE_ERRCODE2(ERROR_WINHTTP_INCORRECT_HANDLE_STATE                 , _T("WinHttp API error. The requested operation cannot be carried out because the handle supplied is not in the correct state."))
         CASE_ERRCODE2(ERROR_WINHTTP_CANNOT_CONNECT                         , _T("WinHttp API error. Returned if connection to the server failed."))
         CASE_ERRCODE2(ERROR_WINHTTP_CONNECTION_ERROR                       , _T("WinHttp API error. The connection with the server has been reset or terminated, or an incompatible SSL protocol was encountered. For example, WinHTTP version 5.1 does not support SSL2 unless the client specifically enables it."))
         CASE_ERRCODE2(ERROR_WINHTTP_RESEND_REQUEST                         , _T("WinHttp API error. The WinHTTP function failed. The desired function can be retried on the same request handle."))
         CASE_ERRCODE2(ERROR_WINHTTP_CLIENT_AUTH_CERT_NEEDED                , _T("WinHttp API error. Returned by WinHttpReceiveResponse when the server requests client authentication."))
         CASE_ERRCODE2(ERROR_WINHTTP_CANNOT_CALL_BEFORE_OPEN                , _T("WinHttpRequest Component error. Returned by the HttpRequest object if a requested operation cannot be performed before calling the Open method."))
         CASE_ERRCODE2(ERROR_WINHTTP_CANNOT_CALL_BEFORE_SEND                , _T("WinHttpRequest Component error. Returned by the HttpRequest object if a requested operation cannot be performed before calling the Send method."))
         CASE_ERRCODE2(ERROR_WINHTTP_CANNOT_CALL_AFTER_SEND                 , _T("WinHttpRequest Component error. Returned by the HttpRequest object if a requested operation cannot be performed after calling the Send method."))
         CASE_ERRCODE2(ERROR_WINHTTP_CANNOT_CALL_AFTER_OPEN                 , _T("WinHttpRequest Component error. Returned by the HttpRequest object if a specified option cannot be requested after the Open method has been called."))
         CASE_ERRCODE2(ERROR_WINHTTP_HEADER_NOT_FOUND                       , _T("HTTP API error. The requested header could not be located."))
         CASE_ERRCODE2(ERROR_WINHTTP_INVALID_SERVER_RESPONSE                , _T("HTTP API error. The server response could not be parsed."))
         CASE_ERRCODE2(ERROR_WINHTTP_INVALID_QUERY_REQUEST                  , _T("HTTP API error. Obsolete; no longer used."))
         CASE_ERRCODE2(ERROR_WINHTTP_HEADER_ALREADY_EXISTS                  , _T("HTTP API error. Obsolete; no longer used."))
         CASE_ERRCODE2(ERROR_WINHTTP_REDIRECT_FAILED                        , _T("HTTP API error. The redirection failed because either the scheme changed or all attempts made to redirect failed (default is five attempts)."))
         CASE_ERRCODE2(ERROR_WINHTTP_AUTO_PROXY_SERVICE_ERROR               , _T("Additional WinHttp API error code. Returned by WinHttpGetProxyForUrl when a proxy for the specified URL cannot be located."))
         CASE_ERRCODE2(ERROR_WINHTTP_BAD_AUTO_PROXY_SCRIPT                  , _T("Additional WinHttp API error code. An error occurred executing the script code in the Proxy Auto-Configuration (PAC) file."))
         CASE_ERRCODE2(ERROR_WINHTTP_UNABLE_TO_DOWNLOAD_SCRIPT              , _T("Additional WinHttp API error code. The PAC file could not be downloaded. For example, the server referenced by the PAC URL may not have been reachable, or the server returned a 404 NOT FOUND response."))
         CASE_ERRCODE2(ERROR_WINHTTP_NOT_INITIALIZED                        , _T("Additional WinHttp API error code. Obsolete; no longer used."))
         CASE_ERRCODE2(ERROR_WINHTTP_SECURE_FAILURE                         , _T("Additional WinHttp API error code. One or more errors were found in the Secure Sockets Layer (SSL) certificate sent by the server. To determine what type of error was encountered, check for a WINHTTP_CALLBACK_STATUS_SECURE_FAILURE notification in a status callback function. For more information, see WINHTTP_STATUS_CALLBACK."))
         CASE_ERRCODE2(ERROR_WINHTTP_SECURE_CERT_DATE_INVALID               , _T("Certificate security error. Indicates that a required certificate is not within its validity period when verifying against the current system clock or the timestamp in the signed file, or that the validity periods of the certification chain do not nest correctly (equivalent to a CERT_E_EXPIRED or a CERT_E_VALIDITYPERIODNESTING error)."))
         CASE_ERRCODE2(ERROR_WINHTTP_SECURE_CERT_CN_INVALID                 , _T("Certificate security error. Returned when a certificate's CN name does not match the passed value (equivalent to a CERT_E_CN_NO_MATCH error)."))
         CASE_ERRCODE2(ERROR_WINHTTP_SECURE_INVALID_CA                      , _T("Certificate security error. Indicates that a certificate chain was processed but terminated in a root certificate that is not trusted by the trust provider (equivalent to CERT_E_UNTRUSTEDROOT)."))
         CASE_ERRCODE2(ERROR_WINHTTP_SECURE_CERT_REV_FAILED                 , _T("Certificate security error. Indicates that revocation could not be checked because the revocation server was offline (equivalent to CRYPT_E_REVOCATION_OFFLINE)."))
         CASE_ERRCODE2(ERROR_WINHTTP_SECURE_CHANNEL_ERROR                   , _T("Certificate security error. Indicates that an error occurred having to do with a secure channel (equivalent to error codes that begin with 'SEC_E_' and 'SEC_I_' listed in the winerror.h header file )."))
         CASE_ERRCODE2(ERROR_WINHTTP_SECURE_INVALID_CERT                    , _T("Certificate security error. Indicates that a certificate is invalid (equivalent to errors such as CERT_E_ROLE, CERT_E_PATHLENCONST, CERT_E_CRITICAL, CERT_E_PURPOSE, CERT_E_ISSUERCHAINING, CERT_E_MALFORMED and CERT_E_CHAINING)."))
         CASE_ERRCODE2(ERROR_WINHTTP_SECURE_CERT_REVOKED                    , _T("Certificate security error. Indicates that a certificate has been revoked (equivalent to CRYPT_E_REVOKED)."))
         CASE_ERRCODE2(ERROR_WINHTTP_SECURE_CERT_WRONG_USAGE                , _T("Certificate security error. Indicates that a certificate is not valid for the requested usage (equivalent to CERT_E_WRONG_USAGE)."))
         CASE_ERRCODE2(ERROR_WINHTTP_AUTODETECTION_FAILED                   , _T("Additional WinHttp API error code. Returned by WinHttpDetectAutoProxyConfigUrl if WinHTTP was unable to discover the URL of the Proxy Auto-Configuration (PAC) file."))
         CASE_ERRCODE2(ERROR_WINHTTP_HEADER_COUNT_EXCEEDED                  , _T("Additional WinHttp API error code. Returned by WinHttpReceiveResponse when a larger number of headers were present in a response than WinHTTP could receive."))
         CASE_ERRCODE2(ERROR_WINHTTP_HEADER_SIZE_OVERFLOW                   , _T("Additional WinHttp API error code. Returned by WinHttpReceiveResponse when the size of headers received exceeds the limit for the request handle."))
         CASE_ERRCODE2(ERROR_WINHTTP_CHUNKED_ENCODING_HEADER_SIZE_OVERFLOW  , _T("Additional WinHttp API error code. Returned by WinHttpReceiveResponse when an overflow condition is encountered in the course of parsing chunked encoding."))
         CASE_ERRCODE2(ERROR_WINHTTP_RESPONSE_DRAIN_OVERFLOW                , _T("Additional WinHttp API error code. Returned when an incoming response exceeds an internal WinHTTP size limit."))
         CASE_ERRCODE2(ERROR_WINHTTP_PROXY_AUTH_REQUIRED                    , _T("Returned by WinHttpSendRequest on Windows Server 2003 family if an HTTP status code of 407 is returned, indicating that proxy authentication is required. This error was added to handle the case where the client is trying to establish an SSL connection to a target server via a proxy server, but the proxy server requires authentication. This error is not returned on Windows XP SP1 and Windows 2000 SP3, which leaves the client unaware that the SSL connection failed. In this case, a subsequent call to WinHttpWriteData to send some POST data, or to WinHttpReceiveResponse to get the response, fails with an INCORRECT_HANDLE_STATE error."))
         default: strRes = (bDescription ? _T("Unknown WinHttp API error code.") : _T("")); break;
         }
      }
#endif // __SDK__
   #undef CASE_ERRCODE1
   #undef CASE_ERRCODE2
   #undef CASE_ERRCODE3
   }

#endif // LOGGER_DUMMY

   //if (strRes.IsEmpty() && (lErrCode > 0x80000000)) {
   //   strRes = CLogger::HResult(lErrCode, bDescription);
   //}
   if (strRes.IsEmpty()) {
      if (bDescription) {
         strRes = (extInfo == info_HResult) ? _T("Unknown HRESULT.") : _T("Unknown Error.");
         if ((lErrCode >=  1300L                 ) && (lErrCode <=  1399L                )) strRes += _T(" Maybe  Security Status Codes."                );
         if ((lErrCode >=  1400L                 ) && (lErrCode <=  1499L                )) strRes += _T(" Maybe  WinUser Error Codes."                  );
         if ((lErrCode >=  1500L                 ) && (lErrCode <=  1599L                )) strRes += _T(" Maybe  Eventlog Status Codes."                );
         if ((lErrCode >=  1600L                 ) && (lErrCode <=  1699L                )) strRes += _T(" Maybe  MSI Error Codes."                      );
         if ((lErrCode >=  1700L                 ) && (lErrCode <=  1999L                )) strRes += _T(" Maybe  RPC Status Codes."                     );
         if ((lErrCode >=  2000L                 ) && (lErrCode <=  2009L                )) strRes += _T(" Maybe  OpenGL Error Code."                    );
         if ((lErrCode >=  2010L                 ) && (lErrCode <=  2099L                )) strRes += _T(" Maybe  Image Color Management Error Code."    );
         if ((lErrCode >=  2100L /* NERR_BASE */ ) && (lErrCode <=  2999L /* MAX_NERR */ )) strRes += _T(" Winnet32 Status Codes."                       );

         // see <LMErr.h>
         if ((lErrCode >=  2750L                 ) && (lErrCode <=  2799L                )) strRes += _T(" IBM LAN Server error code."                   );
         if ((lErrCode >=  2900L                 ) && (lErrCode <=  2999L                )) strRes += _T(" Microsoft OEMs error code."                   );
         if ((lErrCode >=  NERR_BASE+ 45         ) && (lErrCode <=  NERR_BASE+ 49        )) strRes += _T(" Config API related."                          );
         if ((lErrCode >=  NERR_BASE+ 50         ) && (lErrCode <=  NERR_BASE+ 79        )) strRes += _T(" Spooler API related."                         );
         if ((lErrCode >=  NERR_BASE+ 80         ) && (lErrCode <=  NERR_BASE+ 99        )) strRes += _T(" Service API related."                         );
         if ((lErrCode >=  NERR_BASE+100         ) && (lErrCode <=  NERR_BASE+118        )) strRes += _T(" Wksta and Logon API related."                 );
         if ((lErrCode >=  NERR_BASE+119         ) && (lErrCode <=  NERR_BASE+149        )) strRes += _T(" ACF API related (access, user, group)."       );
         if ((lErrCode >=  NERR_BASE+150         ) && (lErrCode <=  NERR_BASE+169        )) strRes += _T(" Use API related."                             );
         if ((lErrCode >=  NERR_BASE+170         ) && (lErrCode <=  NERR_BASE+209        )) strRes += _T(" Message Server related."                      );
         if ((lErrCode >=  NERR_BASE+210         ) && (lErrCode <=  NERR_BASE+229        )) strRes += _T(" Server API related."                          );
         if ((lErrCode >=  NERR_BASE+230         ) && (lErrCode <=  NERR_BASE+249        )) strRes += _T(" CharDev API related."                         );
         if ((lErrCode >=  NERR_BASE+250         ) && (lErrCode <=  NERR_BASE+269        )) strRes += _T(" NetICanonicalize NetIType NetIMakeLMFileName NetIListCanon NetINameCheck error code.");
         if ((lErrCode >=  NERR_BASE+270         ) && (lErrCode <=  NERR_BASE+276        )) strRes += _T(" NetProfile error code."                       );
         if ((lErrCode >=  NERR_BASE+277         ) && (lErrCode <=  NERR_BASE+279        )) strRes += _T(" NetAudit NetErrorLog error code."             );
         if ((lErrCode >=  NERR_BASE+280         ) && (lErrCode <=  NERR_BASE+299        )) strRes += _T(" NetRemote error code."                        );
         if ((lErrCode >=  NERR_BASE+300         ) && (lErrCode <=  NERR_BASE+329        )) strRes += _T(" NetWksta.sys (redir)  error code."            );
         if ((lErrCode >=  NERR_BASE+330         ) && (lErrCode <=  NERR_BASE+339        )) strRes += _T(" Alert error code."                            );
         if ((lErrCode >=  NERR_BASE+340         ) && (lErrCode <=  NERR_BASE+343        )) strRes += _T(" Additional Error and Audit log code."         );
         if ((lErrCode >=  NERR_BASE+350         ) && (lErrCode <=  NERR_BASE+359        )) strRes += _T(" Additional UAS and NETLOGON code."            );
         if ((lErrCode >=  NERR_BASE+360         ) && (lErrCode <=  NERR_BASE+369        )) strRes += _T(" Server Integration error code."               );
         if ((lErrCode >=  NERR_BASE+380         ) && (lErrCode <=  NERR_BASE+384        )) strRes += _T(" UPS error code."                              );
         if ((lErrCode >=  NERR_BASE+400         ) && (lErrCode <=  NERR_BASE+419        )) strRes += _T(" Remoteboot error code."                       );
         if ((lErrCode >=  NERR_BASE+425         ) && (lErrCode <=  NERR_BASE+434        )) strRes += _T(" FTADMIN API error code."                      );
         if ((lErrCode >=  NERR_BASE+450         ) && (lErrCode <=  NERR_BASE+475        )) strRes += _T(" Browser service API error code."              );
         if ((lErrCode >=  NERR_BASE+510         ) && (lErrCode <=  NERR_BASE+550        )) strRes += _T(" Additional Remoteboot error code."            );
         if ((lErrCode >=  NERR_BASE+560         ) && (lErrCode <=  NERR_BASE+590        )) strRes += _T(" Dfs API error code."                          );
         if ((lErrCode >=  NERR_BASE+591         ) && (lErrCode <=  NERR_BASE+600        )) strRes += _T(" Net setup error code."                        );
         if ((lErrCode >=  NERR_BASE+601         ) && (lErrCode <=  NERR_BASE+608        )) strRes += _T(" Some Password and account error result."      );

         if ((lErrCode >=  3000L                 ) && (lErrCode <=  3014L                )) strRes += _T(" Maybe  Win32 Spooler Error Code."            );
         if ((lErrCode >=  4000L                 ) && (lErrCode <=  4099L                )) strRes += _T(" Maybe  Wins Error Code."                     );
         if ((lErrCode >=  4100L                 ) && (lErrCode <=  4199L                )) strRes += _T(" Maybe  DHCP Error Code."                     );
         if ((lErrCode >=  4200L                 ) && (lErrCode <=  4299L                )) strRes += _T(" Maybe  WMI Error Code."                      );
         if ((lErrCode >=  4300L                 ) && (lErrCode <=  4349L                )) strRes += _T(" Maybe  NT Media Services (RSM) Error Code."  );
         if ((lErrCode >=  4350L                 ) && (lErrCode <=  4389L                )) strRes += _T(" Maybe  NT Remote Storage Service Error Code.");
         if ((lErrCode >=  4390L                 ) && (lErrCode <=  4399L                )) strRes += _T(" Maybe  NT Reparse Points Error Code."        );
         if ((lErrCode >=  4500L                 ) && (lErrCode <=  4600L                )) strRes += _T(" Maybe  NT Single Instance Store Error Code." );
         if ((lErrCode >=  5000L                 ) && (lErrCode <=  5999L                )) strRes += _T(" Maybe  Cluster Error Code."                  );
         if ((lErrCode >=  6000L                 ) && (lErrCode <=  6199L                )) strRes += _T(" Maybe  EFS Error Code."                      );
         if ((lErrCode >=  6200L                 ) && (lErrCode <=  6300L                )) strRes += _T(" Maybe  Task Scheduler Error Code."           );
         if ((lErrCode >=  7000L                 ) && (lErrCode <=  7499L                )) strRes += _T(" Maybe  Terminal Server Error Code."          );
         if ((lErrCode >=  7500L                 ) && (lErrCode <=  7999L                )) strRes += _T(" Traffic Control Error Code."                 );
         if ((lErrCode >=  8000L                 ) && (lErrCode <=  8999L                )) strRes += _T(" Active Directory Error Code."                );
         if ((lErrCode >=  9000L                 ) && (lErrCode <=  9999L                )) strRes += _T(" DNS Error Code."                             );
         if ((lErrCode >= 10000L                 ) && (lErrCode <= 11999L                )) strRes += _T(" WinSock Error Code."                         );
         if ((lErrCode >= 12000L                 ) && (lErrCode <= 12999L                )) strRes += _T(" HTTP/FTP/Internet Error code."               );
         if ((lErrCode >= 13000L                 ) && (lErrCode <= 13999L                )) strRes += _T(" Start of IPSec Error code."                  );
         if ((lErrCode >= 14000L                 ) && (lErrCode <= 14999L                )) strRes += _T(" Side By Side Error Code."                    );
      } else {
         if ((extInfo == info_HResult) || (lErrCode & 0x80000000)) {
            strRes.Format(_T("0x%08X"), lErrCode);
         } else {
            strRes.Format(_T("%i"), lErrCode);
         }
      }
   }
   return strRes;
}

/* static */ CString CLogger::QueryInfoFlag(IN DWORD dwOption) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08x"), dwOption);
#else // LOGGER_DUMMY
   if (dwOption == HTTP_QUERY_CUSTOM) {
      strRes = _T("HTTP_QUERY_CUSTOM");
      return strRes;
   }
   #define   IF_QIF(val) if (dwOption & (val)) { strRes = _T(#val)_T(" | "); dwOption ^= (val);} else
   #define CASE_QIF(val) case (val): strRes += _T(#val); break;
   IF_QIF(HTTP_QUERY_FLAG_SYSTEMTIME     )
   IF_QIF(HTTP_QUERY_FLAG_NUMBER         )
   IF_QIF(HTTP_QUERY_FLAG_REQUEST_HEADERS)
   IF_QIF(HTTP_QUERY_FLAG_COALESCE       ) {}

   switch (dwOption) {
   CASE_QIF(HTTP_QUERY_ACCEPT                   )
   CASE_QIF(HTTP_QUERY_ACCEPT_CHARSET           )
   CASE_QIF(HTTP_QUERY_ACCEPT_ENCODING          )
   CASE_QIF(HTTP_QUERY_ACCEPT_LANGUAGE          )
   CASE_QIF(HTTP_QUERY_ACCEPT_RANGES            )
   CASE_QIF(HTTP_QUERY_AGE                      )
   CASE_QIF(HTTP_QUERY_ALLOW                    )
   CASE_QIF(HTTP_QUERY_AUTHORIZATION            )
   CASE_QIF(HTTP_QUERY_CACHE_CONTROL            )
   CASE_QIF(HTTP_QUERY_CONNECTION               )
   CASE_QIF(HTTP_QUERY_CONTENT_BASE             )
   CASE_QIF(HTTP_QUERY_CONTENT_DESCRIPTION      )
   CASE_QIF(HTTP_QUERY_CONTENT_DISPOSITION      )
   CASE_QIF(HTTP_QUERY_CONTENT_ENCODING         )
   CASE_QIF(HTTP_QUERY_CONTENT_ID               )
   CASE_QIF(HTTP_QUERY_CONTENT_LANGUAGE         )
   CASE_QIF(HTTP_QUERY_CONTENT_LENGTH           )
   CASE_QIF(HTTP_QUERY_CONTENT_LOCATION         )
   CASE_QIF(HTTP_QUERY_CONTENT_MD5              )
   CASE_QIF(HTTP_QUERY_CONTENT_RANGE            )
   CASE_QIF(HTTP_QUERY_CONTENT_TRANSFER_ENCODING)
   CASE_QIF(HTTP_QUERY_CONTENT_TYPE             )
   CASE_QIF(HTTP_QUERY_COOKIE                   )
   CASE_QIF(HTTP_QUERY_COST                     )
   CASE_QIF(HTTP_QUERY_CUSTOM                   )
   CASE_QIF(HTTP_QUERY_DATE                     )
   CASE_QIF(HTTP_QUERY_DERIVED_FROM             )
#ifdef __SDK__
   CASE_QIF(HTTP_QUERY_ECHO_HEADERS             )
   CASE_QIF(HTTP_QUERY_ECHO_HEADERS_CRLF        )
   CASE_QIF(HTTP_QUERY_ECHO_REPLY               )
   CASE_QIF(HTTP_QUERY_ECHO_REQUEST             )
   CASE_QIF(HTTP_QUERY_EXPECT                   )
#endif // __SDK__
   CASE_QIF(HTTP_QUERY_ETAG                     )
   CASE_QIF(HTTP_QUERY_EXPIRES                  )
   CASE_QIF(HTTP_QUERY_FORWARDED                )
   CASE_QIF(HTTP_QUERY_FROM                     )
   CASE_QIF(HTTP_QUERY_HOST                     )
   CASE_QIF(HTTP_QUERY_IF_MATCH                 )
   CASE_QIF(HTTP_QUERY_IF_MODIFIED_SINCE        )
   CASE_QIF(HTTP_QUERY_IF_NONE_MATCH            )
   CASE_QIF(HTTP_QUERY_IF_RANGE                 )
   CASE_QIF(HTTP_QUERY_IF_UNMODIFIED_SINCE      )
   CASE_QIF(HTTP_QUERY_LAST_MODIFIED            )
   CASE_QIF(HTTP_QUERY_LINK                     )
   CASE_QIF(HTTP_QUERY_LOCATION                 )
   CASE_QIF(HTTP_QUERY_MAX_FORWARDS             )
   CASE_QIF(HTTP_QUERY_MESSAGE_ID               )
   CASE_QIF(HTTP_QUERY_MIME_VERSION             )
   CASE_QIF(HTTP_QUERY_ORIG_URI                 )
   CASE_QIF(HTTP_QUERY_PRAGMA                   )
   CASE_QIF(HTTP_QUERY_PROXY_AUTHENTICATE       )
   CASE_QIF(HTTP_QUERY_PROXY_AUTHORIZATION      )
#ifdef __SDK__
   CASE_QIF(HTTP_QUERY_PROXY_CONNECTION         )
#endif // __SDK__
   CASE_QIF(HTTP_QUERY_PUBLIC                   )
   CASE_QIF(HTTP_QUERY_RANGE                    )
   CASE_QIF(HTTP_QUERY_RAW_HEADERS              )
   CASE_QIF(HTTP_QUERY_RAW_HEADERS_CRLF         )
   CASE_QIF(HTTP_QUERY_REFERER                  )
   CASE_QIF(HTTP_QUERY_REFRESH                  )
   CASE_QIF(HTTP_QUERY_REQUEST_METHOD           )
   CASE_QIF(HTTP_QUERY_RETRY_AFTER              )
   CASE_QIF(HTTP_QUERY_SERVER                   )
   CASE_QIF(HTTP_QUERY_SET_COOKIE               )
   CASE_QIF(HTTP_QUERY_STATUS_CODE              )
   CASE_QIF(HTTP_QUERY_STATUS_TEXT              )
   CASE_QIF(HTTP_QUERY_TITLE                    )
   CASE_QIF(HTTP_QUERY_TRANSFER_ENCODING        )
#ifdef __SDK__
   CASE_QIF(HTTP_QUERY_UNLESS_MODIFIED_SINCE    )
#endif // __SDK__
   CASE_QIF(HTTP_QUERY_UPGRADE                  )
   CASE_QIF(HTTP_QUERY_URI                      )
   CASE_QIF(HTTP_QUERY_USER_AGENT               )
   CASE_QIF(HTTP_QUERY_VARY                     )
   CASE_QIF(HTTP_QUERY_VERSION                  )
   CASE_QIF(HTTP_QUERY_VIA                      )
   CASE_QIF(HTTP_QUERY_WARNING                  )
   CASE_QIF(HTTP_QUERY_WWW_AUTHENTICATE         )
   CASE_QIF(HTTP_QUERY_FLAG_COALESCE            )
   CASE_QIF(HTTP_QUERY_FLAG_NUMBER              )
   CASE_QIF(HTTP_QUERY_FLAG_REQUEST_HEADERS     )
   CASE_QIF(HTTP_QUERY_FLAG_SYSTEMTIME          )
   CASE_QIF(HTTP_QUERY_MODIFIER_FLAGS_MASK      )
   CASE_QIF(HTTP_QUERY_HEADER_MASK              )
#ifdef __SDK__
   CASE_QIF(HTTP_QUERY_PROXY_SUPPORT            )
   CASE_QIF(HTTP_QUERY_PASSPORT_URLS            )
   CASE_QIF(HTTP_QUERY_PASSPORT_CONFIG          )
#endif // __SDK__
   default:
      {
         CString strTemp; strTemp.Format(_T("0x%08x"), dwOption);
         strRes += strTemp;
      }
   }
   #undef IF_QIF
   #undef CASE_QIF
#endif // LOGGER_DUMMY
   return strRes;
}

/* static */ CString CLogger::QueryOption(IN DWORD dwOption) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08x"), dwOption);
#else // LOGGER_DUMMY
   switch (dwOption) {
   #define CASE_QO(val) case (val): strRes = _T(#val); break;
   CASE_QO(QUERY_EXPIRATION_DATE    )
   CASE_QO(QUERY_TIME_OF_LAST_CHANGE)
   CASE_QO(QUERY_CONTENT_ENCODING   )
   CASE_QO(QUERY_CONTENT_TYPE       )
   CASE_QO(QUERY_REFRESH            )
   CASE_QO(QUERY_RECOMBINE          )
   CASE_QO(QUERY_CAN_NAVIGATE       )
   CASE_QO(QUERY_USES_NETWORK       )
   CASE_QO(QUERY_IS_CACHED          )
   CASE_QO(QUERY_IS_INSTALLEDENTRY  )
   CASE_QO(QUERY_IS_CACHED_OR_MAPPED)
   CASE_QO(QUERY_USES_CACHE         )
#ifdef __SDK__
   CASE_QO(QUERY_IS_SECURE          )
   CASE_QO(QUERY_IS_SAFE            )
#endif // __SDK__
   #undef CASE_QO
   default:
      strRes.Format(_T("0x%08x"), dwOption);
   }
#endif // LOGGER_DUMMY
   return strRes;
}

/* static */ CString CLogger::ParseAction(IN DWORD dwParseAction) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08x"), dwParseAction);
#else // LOGGER_DUMMY
   switch (dwParseAction) {
   #define CASE_PA(val) case (val): strRes = _T(#val); break;
   CASE_PA(PARSE_CANONICALIZE   )
   CASE_PA(PARSE_FRIENDLY       )
   CASE_PA(PARSE_SECURITY_URL   )
   CASE_PA(PARSE_ROOTDOCUMENT   )
   CASE_PA(PARSE_DOCUMENT       )
   CASE_PA(PARSE_ANCHOR         )
   CASE_PA(PARSE_ENCODE         )
   CASE_PA(PARSE_DECODE         )
   CASE_PA(PARSE_PATH_FROM_URL  )
   CASE_PA(PARSE_URL_FROM_PATH  )
   CASE_PA(PARSE_MIME           )
   CASE_PA(PARSE_SERVER         )
   CASE_PA(PARSE_SCHEMA         )
   CASE_PA(PARSE_SITE           )
   CASE_PA(PARSE_DOMAIN         )
   CASE_PA(PARSE_LOCATION       )
   CASE_PA(PARSE_SECURITY_DOMAIN)
#ifdef __SDK__
   CASE_PA(PARSE_ESCAPE         )
   CASE_PA(PARSE_UNESCAPE       )
#endif
   #undef CASE_PA
   default:
      strRes.Format(_T("0x%08x"), dwParseAction);
   }
#endif // LOGGER_DUMMY
   return strRes;
}

/* static */ CString CLogger::InternetCombineUrlFlags(IN DWORD dwCombineFlags) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08x"), dwCombineFlags);
#else // LOGGER_DUMMY
   switch (dwCombineFlags) {
   #define CASE_ICU(val) case (val): strRes = _T(#val); break;
   CASE_ICU(ICU_ESCAPE            )
   CASE_ICU(ICU_USERNAME          )
   CASE_ICU(ICU_NO_ENCODE         )
   CASE_ICU(ICU_DECODE            )
   CASE_ICU(ICU_NO_META           )
   CASE_ICU(ICU_ENCODE_SPACES_ONLY)
   CASE_ICU(ICU_BROWSER_MODE      )
#ifdef __SDK__
   CASE_ICU(ICU_ENCODE_PERCENT    )
#endif
   #undef CASE_ICU
   default:
      strRes.Format(_T("0x%08x"), dwCombineFlags);
   }
#endif // LOGGER_DUMMY
   return strRes;
}

/* static */  CString CLogger::SystemTime(const SYSTEMTIME &st, BOOL bDate, BOOL bTime) {
   CString strRes;
   if (bDate || bTime) {
      CString strDate, strTime;
      if (bDate) {
         strDate.Format(_T("%04i.%02i.%02i"), int(st.wYear), int(st.wMonth), int(st.wDay));
      }
      if (bTime) {
         strTime.Format(_T("%02i:%02i:%02i,%03i"), int(st.wHour), int(st.wMinute), int(st.wSecond), int(st.wMilliseconds));
      }
      strRes = strDate;
      if (bDate && bTime) {
         strRes += _T(' ');
      }
      strRes += strTime;
   }
   return strRes;
}

/* static */ CString CLogger::BindFlag(IN DWORD dwBINDF) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08x"), dwBINDF);
   return strRes;
#else // LOGGER_DUMMY
   #define IF_BINDF(val) if (dwBINDF & (val)) { strRes += _T(" | ")_T(#val); }
   IF_BINDF(BINDF_ASYNCHRONOUS            )
   IF_BINDF(BINDF_ASYNCSTORAGE            )
   IF_BINDF(BINDF_NOPROGRESSIVERENDERING  )
   IF_BINDF(BINDF_OFFLINEOPERATION        )
   IF_BINDF(BINDF_GETNEWESTVERSION        )
   IF_BINDF(BINDF_NOWRITECACHE            )
   IF_BINDF(BINDF_NEEDFILE                )
   IF_BINDF(BINDF_PULLDATA                )
   IF_BINDF(BINDF_IGNORESECURITYPROBLEM   )
   IF_BINDF(BINDF_RESYNCHRONIZE           )
   IF_BINDF(BINDF_HYPERLINK               )
   IF_BINDF(BINDF_NO_UI                   )
   IF_BINDF(BINDF_SILENTOPERATION         )
   IF_BINDF(BINDF_PRAGMA_NO_CACHE         )
#ifdef __SDK__
   IF_BINDF(BINDF_GETCLASSOBJECT          )
   IF_BINDF(BINDF_RESERVED_1              )
#endif // __SDK__
   IF_BINDF(BINDF_FREE_THREADED           )
   IF_BINDF(BINDF_DIRECT_READ             )
   IF_BINDF(BINDF_FORMS_SUBMIT            )
   IF_BINDF(BINDF_GETFROMCACHE_IF_NET_FAIL)
#ifdef __SDK__
   IF_BINDF(BINDF_FROMURLMON              )
   IF_BINDF(BINDF_FWD_BACK                )
   IF_BINDF(BINDF_PREFERDEFAULTHANDLER    )
   IF_BINDF(BINDF_ENFORCERESTRICTED       )
   #undef IF_BINDF
#endif // __SDK__
   return strRes.IsEmpty() ? strRes : strRes.Mid(3);
#endif // LOGGER_DUMMY
}

/* static */ CString CLogger::BindString(IN ULONG ulStringType) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("%i"), ulStringType);
#else // LOGGER_DUMMY
   switch (ulStringType) {
   #define CASE_BINDSTRING(val) case (val): strRes = _T(#val); break;
   CASE_BINDSTRING(BINDSTRING_HEADERS            )
   CASE_BINDSTRING(BINDSTRING_ACCEPT_MIMES       )
   CASE_BINDSTRING(BINDSTRING_EXTRA_URL          )
   CASE_BINDSTRING(BINDSTRING_LANGUAGE           )
   CASE_BINDSTRING(BINDSTRING_USERNAME           )
   CASE_BINDSTRING(BINDSTRING_PASSWORD           )
   CASE_BINDSTRING(BINDSTRING_UA_PIXELS          )
   CASE_BINDSTRING(BINDSTRING_UA_COLOR           )
   CASE_BINDSTRING(BINDSTRING_OS                 )
   CASE_BINDSTRING(BINDSTRING_USER_AGENT         )
   CASE_BINDSTRING(BINDSTRING_ACCEPT_ENCODINGS   )
   CASE_BINDSTRING(BINDSTRING_POST_COOKIE        )
   CASE_BINDSTRING(BINDSTRING_POST_DATA_MIME     )
   CASE_BINDSTRING(BINDSTRING_URL                )
#ifdef __SDK__
   CASE_BINDSTRING(BINDSTRING_IID                )
   CASE_BINDSTRING(BINDSTRING_FLAG_BIND_TO_OBJECT)
   CASE_BINDSTRING(BINDSTRING_PTR_BIND_CONTEXT   )
   #undef CASE_BINDSTRING
#endif // __SDK__
   default:
      strRes.Format(_T("0x%08x"), ulStringType);
   }
#endif // LOGGER_DUMMY
   return strRes;
}

/* static */ CString CLogger::BindStatusCallbackFlag(IN WORD grfBSCF) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%04x"), grfBSCF);
   return strRes;
#else // LOGGER_DUMMY
   #define IF_BSCF(val) if (grfBSCF & (val)) { strRes += _T(" | ")_T(#val); }
   IF_BSCF(BSCF_FIRSTDATANOTIFICATION       )
   IF_BSCF(BSCF_INTERMEDIATEDATANOTIFICATION)
   IF_BSCF(BSCF_LASTDATANOTIFICATION        )
   IF_BSCF(BSCF_DATAFULLYAVAILABLE          )
   IF_BSCF(BSCF_AVAILABLEDATASIZEUNKNOWN    )
   #undef IF_BSCF
   return strRes.IsEmpty() ? strRes : strRes.Mid(3);
#endif // LOGGER_DUMMY
}

/* static */ CString CLogger::BindStatus(IN ULONG ulStatusCode) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08x"), ulStatusCode);
#else // LOGGER_DUMMY
   switch (ulStatusCode) {
   #define CASE_BINDSTATUS(val) case (val): strRes = _T(#val); break;
   CASE_BINDSTATUS(BINDSTATUS_FINDINGRESOURCE           )
   CASE_BINDSTATUS(BINDSTATUS_CONNECTING                )
   CASE_BINDSTATUS(BINDSTATUS_REDIRECTING               )
   CASE_BINDSTATUS(BINDSTATUS_BEGINDOWNLOADDATA         )
   CASE_BINDSTATUS(BINDSTATUS_DOWNLOADINGDATA           )
   CASE_BINDSTATUS(BINDSTATUS_ENDDOWNLOADDATA           )
   CASE_BINDSTATUS(BINDSTATUS_BEGINDOWNLOADCOMPONENTS   )
   CASE_BINDSTATUS(BINDSTATUS_INSTALLINGCOMPONENTS      )
   CASE_BINDSTATUS(BINDSTATUS_ENDDOWNLOADCOMPONENTS     )
   CASE_BINDSTATUS(BINDSTATUS_USINGCACHEDCOPY           )
   CASE_BINDSTATUS(BINDSTATUS_SENDINGREQUEST            )
   CASE_BINDSTATUS(BINDSTATUS_CLASSIDAVAILABLE          )
   CASE_BINDSTATUS(BINDSTATUS_MIMETYPEAVAILABLE         )
   CASE_BINDSTATUS(BINDSTATUS_CACHEFILENAMEAVAILABLE    )
   CASE_BINDSTATUS(BINDSTATUS_BEGINSYNCOPERATION        )
   CASE_BINDSTATUS(BINDSTATUS_ENDSYNCOPERATION          )
   CASE_BINDSTATUS(BINDSTATUS_BEGINUPLOADDATA           )
   CASE_BINDSTATUS(BINDSTATUS_UPLOADINGDATA             )
   CASE_BINDSTATUS(BINDSTATUS_ENDUPLOADDATA             )
   CASE_BINDSTATUS(BINDSTATUS_PROTOCOLCLASSID           )
   CASE_BINDSTATUS(BINDSTATUS_ENCODING                  )
   CASE_BINDSTATUS(BINDSTATUS_VERIFIEDMIMETYPEAVAILABLE )
   CASE_BINDSTATUS(BINDSTATUS_CLASSINSTALLLOCATION      )
   CASE_BINDSTATUS(BINDSTATUS_DECODING                  )
   CASE_BINDSTATUS(BINDSTATUS_LOADINGMIMEHANDLER        )
#ifdef __SDK__
   CASE_BINDSTATUS(BINDSTATUS_CONTENTDISPOSITIONATTACH  )
   CASE_BINDSTATUS(BINDSTATUS_FILTERREPORTMIMETYPE      )
   CASE_BINDSTATUS(BINDSTATUS_CLSIDCANINSTANTIATE       )
   CASE_BINDSTATUS(BINDSTATUS_IUNKNOWNAVAILABLE         )
   CASE_BINDSTATUS(BINDSTATUS_DIRECTBIND                )
   CASE_BINDSTATUS(BINDSTATUS_RAWMIMETYPE               )
   CASE_BINDSTATUS(BINDSTATUS_PROXYDETECTING            )
   CASE_BINDSTATUS(BINDSTATUS_ACCEPTRANGES              )
   CASE_BINDSTATUS(BINDSTATUS_COOKIE_SENT               )
   CASE_BINDSTATUS(BINDSTATUS_COMPACT_POLICY_RECEIVED   )
   CASE_BINDSTATUS(BINDSTATUS_COOKIE_SUPPRESSED         )
   CASE_BINDSTATUS(BINDSTATUS_COOKIE_STATE_UNKNOWN      )
   CASE_BINDSTATUS(BINDSTATUS_COOKIE_STATE_ACCEPT       )
   CASE_BINDSTATUS(BINDSTATUS_COOKIE_STATE_REJECT       )
   CASE_BINDSTATUS(BINDSTATUS_COOKIE_STATE_PROMPT       )
   CASE_BINDSTATUS(BINDSTATUS_COOKIE_STATE_LEASH        )
   CASE_BINDSTATUS(BINDSTATUS_COOKIE_STATE_DOWNGRADE    )
   CASE_BINDSTATUS(BINDSTATUS_POLICY_HREF               )
   CASE_BINDSTATUS(BINDSTATUS_P3P_HEADER                )
   CASE_BINDSTATUS(BINDSTATUS_SESSION_COOKIE_RECEIVED   )
   CASE_BINDSTATUS(BINDSTATUS_PERSISTENT_COOKIE_RECEIVED)
   CASE_BINDSTATUS(BINDSTATUS_SESSION_COOKIES_ALLOWED   )
   CASE_BINDSTATUS(BINDSTATUS_CACHECONTROL              )
   #undef CASE_BINDSTATUS
#endif // __SDK__
   default:
      strRes.Format(_T("0x%08x"), ulStatusCode);
   }
#endif // LOGGER_DUMMY
   return strRes;
}

/* static */ CString CLogger::StringArray(IN LPCOLESTR const *const ppwzStr, IN ULONG uSize, LPCTSTR szLeft, LPCTSTR szRight, LPCTSTR szSeparator) {
   CString strRes;
   for (ULONG i=0; i<uSize; i++) {
      strRes += szSeparator + CString(szLeft) + ppwzStr[i] + szRight;
   }
   if (!strRes.IsEmpty()) {
      strRes = strRes.Mid(lstrlen(szSeparator));
   }
   return strRes;
}

/* static */ CString CLogger::InternetStatusCallback(DWORD dwInternetStatus, CLogger::eInfoExt info) {
   CString strRes;
#ifndef LOGGER_DUMMY
   #define CASE_INETSTATUSCALLBACK(val) case (val): strRes = _T(#val); break;
   if (info != info_WinHTTP) {
      switch (dwInternetStatus) {
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_RESOLVING_NAME               )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_NAME_RESOLVED                )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_CONNECTING_TO_SERVER         )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_CONNECTED_TO_SERVER          )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_SENDING_REQUEST              )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_REQUEST_SENT                 )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_RECEIVING_RESPONSE           )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_RESPONSE_RECEIVED            )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_CTL_RESPONSE_RECEIVED        )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_PREFETCH                     )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_CLOSING_CONNECTION           )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_CONNECTION_CLOSED            )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_HANDLE_CREATED               )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_HANDLE_CLOSING               )
#ifdef __SDK__
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_DETECTING_PROXY              )
#endif // __SDK__
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_REQUEST_COMPLETE             )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_REDIRECT                     )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_INTERMEDIATE_RESPONSE        )
#ifdef __SDK__
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_USER_INPUT_REQUIRED          )
#endif // __SDK__
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_STATE_CHANGE                 )
#ifdef __SDK__
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_COOKIE_SENT                  )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_COOKIE_RECEIVED              )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_PRIVACY_IMPACTED             )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_P3P_HEADER                   )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_P3P_POLICYREF                )
      CASE_INETSTATUSCALLBACK(INTERNET_STATUS_COOKIE_HISTORY               )
#endif // __SDK__
      }
   } else {
#ifdef __SDK__
      switch (dwInternetStatus) {
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_RESOLVING_NAME       )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_NAME_RESOLVED        )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_CONNECTING_TO_SERVER )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_CONNECTED_TO_SERVER  )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_SENDING_REQUEST      )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_REQUEST_SENT         )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_RECEIVING_RESPONSE   )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_RESPONSE_RECEIVED    )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_CLOSING_CONNECTION   )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_CONNECTION_CLOSED    )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_HANDLE_CREATED       )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_HANDLE_CLOSING       )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_DETECTING_PROXY      )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_REDIRECT             )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_INTERMEDIATE_RESPONSE)
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_SECURE_FAILURE       )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_HEADERS_AVAILABLE    )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_DATA_AVAILABLE       )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_READ_COMPLETE        )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_WRITE_COMPLETE       )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_REQUEST_ERROR        )
      CASE_INETSTATUSCALLBACK(WINHTTP_CALLBACK_STATUS_SENDREQUEST_COMPLETE )
      }
#endif // __SDK__
   }
   #undef CASE_INETSTATUSCALLBACK
#endif // LOGGER_DUMMY
   if (strRes.IsEmpty()) {
      strRes.Format(_T("0x%08X"), dwInternetStatus);
   }
   return strRes;
}

/* static */ CString CLogger::WinHTTPCallbackStatusRequestError(DWORD dwValue, BOOL bDescription) {
   CString strRes;
#ifndef LOGGER_DUMMY
#ifdef __SDK__
   switch (dwValue) {
   #define CASE_WINHTTPCSRE(val, Description) case (val): strRes = (bDescription) ? (Description) : _T(#val); break;
   CASE_WINHTTPCSRE(API_RECEIVE_RESPONSE    , _T("The error occurred during a call to WinHttpReceiveResponse."   ))
   CASE_WINHTTPCSRE(API_QUERY_DATA_AVAILABLE, _T("The error occurred during a call to WinHttpQueryDataAvailable."))
   CASE_WINHTTPCSRE(API_READ_DATA           , _T("The error occurred during a call to WinHttpReadData."          ))
   CASE_WINHTTPCSRE(API_WRITE_DATA          , _T("The error occurred during a call to WinHttpWriteData."         ))
   CASE_WINHTTPCSRE(API_SEND_REQUEST        , _T("The error occurred during a call to WinHttpSendRequest."       ))
   #undef CASE_WINHTTPCSRE
   }
#endif // __SDK__
#endif // LOGGER_DUMMY
   if (strRes.IsEmpty() && !bDescription) {
      strRes.Format(_T("%i"), dwValue);
   }
   return strRes;
}

/* static */ CString CLogger::HTTPStatusCode(DWORD dwHTTPStatus, BOOL bDescription) {
   CString strRes;
#ifndef LOGGER_DUMMY
   switch (dwHTTPStatus) {
   #define CASE_HTTPSC(val, Description) case (val): strRes = (bDescription) ? (Description) : _T(#val); break;
   CASE_HTTPSC(HTTP_STATUS_CONTINUE          , _T("The request can be continued."))
   CASE_HTTPSC(HTTP_STATUS_SWITCH_PROTOCOLS  , _T("The server has switched protocols in an upgrade header."))

   CASE_HTTPSC(HTTP_STATUS_OK                , _T("The request completed successfully."))
   CASE_HTTPSC(HTTP_STATUS_CREATED           , _T("The request has been fulfilled and resulted in the creation of a new resource."))
   CASE_HTTPSC(HTTP_STATUS_ACCEPTED          , _T("The request has been accepted for processing, but the processing has not been completed."))
   CASE_HTTPSC(HTTP_STATUS_PARTIAL           , _T("The returned meta information in the entity-header is not the definitive set available from the origin server."))
   CASE_HTTPSC(HTTP_STATUS_NO_CONTENT        , _T("The server has fulfilled the request, but there is no new information to send back."))
   CASE_HTTPSC(HTTP_STATUS_RESET_CONTENT     , _T("The request has been completed, and the client program should reset the document view that caused the request to be sent to allow the user to easily initiate another input action."))
   CASE_HTTPSC(HTTP_STATUS_PARTIAL_CONTENT   , _T("The server has fulfilled the partial GET request for the resource."))

   CASE_HTTPSC(HTTP_STATUS_AMBIGUOUS         , _T("The server couldn't decide what to return."))
   CASE_HTTPSC(HTTP_STATUS_MOVED             , _T("The requested resource has been assigned to a new permanent URI (Uniform Resource Identifier), and any future references to this resource should be done using one of the returned URIs."))
   CASE_HTTPSC(HTTP_STATUS_REDIRECT          , _T("The requested resource resides temporarily under a different URI (Uniform Resource Identifier)."))
   CASE_HTTPSC(HTTP_STATUS_REDIRECT_METHOD   , _T("The response to the request can be found under a different URI (Uniform Resource Identifier) and should be retrieved using a GET HTTP verb on that resource."))
   CASE_HTTPSC(HTTP_STATUS_NOT_MODIFIED      , _T("The requested resource has not been modified."))
   CASE_HTTPSC(HTTP_STATUS_USE_PROXY         , _T("The requested resource must be accessed through the proxy given by the location field."))
   CASE_HTTPSC(HTTP_STATUS_REDIRECT_KEEP_VERB, _T("The redirected request keeps the same HTTP verb. HTTP/1.1 behavior."))

   CASE_HTTPSC(HTTP_STATUS_BAD_REQUEST       , _T("The request could not be processed by the server due to invalid syntax."))
   CASE_HTTPSC(HTTP_STATUS_DENIED            , _T("The requested resource requires user authentication."))
   CASE_HTTPSC(HTTP_STATUS_PAYMENT_REQ       , _T("Not currently implemented in the HTTP protocol."))
   CASE_HTTPSC(HTTP_STATUS_FORBIDDEN         , _T("The server understood the request, but is refusing to fulfill it."))
   CASE_HTTPSC(HTTP_STATUS_NOT_FOUND         , _T("The server has not found anything matching the requested URI (Uniform Resource Identifier)."))
   CASE_HTTPSC(HTTP_STATUS_BAD_METHOD        , _T("The HTTP verb used is not allowed."))
   CASE_HTTPSC(HTTP_STATUS_NONE_ACCEPTABLE   , _T("No responses acceptable to the client were found."))
   CASE_HTTPSC(HTTP_STATUS_PROXY_AUTH_REQ    , _T("Proxy authentication required."))
   CASE_HTTPSC(HTTP_STATUS_REQUEST_TIMEOUT   , _T("The server timed out waiting for the request."))
   CASE_HTTPSC(HTTP_STATUS_CONFLICT          , _T("The request could not be completed due to a conflict with the current state of the resource. The user should resubmit with more information."))
   CASE_HTTPSC(HTTP_STATUS_GONE              , _T("The requested resource is no longer available at the server, and no forwarding address is known."))
   CASE_HTTPSC(HTTP_STATUS_LENGTH_REQUIRED   , _T("The server refuses to accept the request without a defined content length."))
   CASE_HTTPSC(HTTP_STATUS_PRECOND_FAILED    , _T("The precondition given in one or more of the request header fields evaluated to false when it was tested on the server."))
   CASE_HTTPSC(HTTP_STATUS_REQUEST_TOO_LARGE , _T("The server is refusing to process a request because the request entity is larger than the server is willing or able to process."))
   CASE_HTTPSC(HTTP_STATUS_URI_TOO_LONG      , _T("The server is refusing to service the request because the request URI (Uniform Resource Identifier) is longer than the server is willing to interpret."))
   CASE_HTTPSC(HTTP_STATUS_UNSUPPORTED_MEDIA , _T("The server is refusing to service the request because the entity of the request is in a format not supported by the requested resource for the requested method."))
#ifdef __SDK__
   CASE_HTTPSC(HTTP_STATUS_RETRY_WITH        , _T("The request should be retried after doing the appropriate action."))
#endif // __SDK__

   CASE_HTTPSC(HTTP_STATUS_SERVER_ERROR      , _T("The server encountered an unexpected condition that prevented it from fulfilling the request."))
   CASE_HTTPSC(HTTP_STATUS_NOT_SUPPORTED     , _T("The server does not support the functionality required to fulfill the request."))
   CASE_HTTPSC(HTTP_STATUS_BAD_GATEWAY       , _T("The server, while acting as a gateway or proxy, received an invalid response from the upstream server it accessed in attempting to fulfill the request."))
   CASE_HTTPSC(HTTP_STATUS_SERVICE_UNAVAIL   , _T("The service is temporarily overloaded."))
   CASE_HTTPSC(HTTP_STATUS_GATEWAY_TIMEOUT   , _T("The request was timed out waiting for a gateway."))
   CASE_HTTPSC(HTTP_STATUS_VERSION_NOT_SUP   , _T("The server does not support, or refuses to support, the HTTP protocol version that was used in the request message."))
   #undef CASE_HTTPSC
   default:
      if (bDescription) {
         strRes = _T("Unknown HTTP status code.");
      }
      break;
   }
#endif // LOGGER_DUMMY
   if (strRes.IsEmpty() && !bDescription) {
      strRes.Format(_T("%i"), dwHTTPStatus);
   }
   return strRes;
}

/* static */ CString CLogger::WindowMessage(UINT msg) {
   CString strRes;
#ifndef LOGGER_DUMMY
   switch (msg) {
   #define CASE_WM1(val) case (val): strRes = _T(#val); break;
   #define CASE_WM2(val, str) case (val): strRes = (str); break;
   // Window Messages
   CASE_WM1(WM_NULL                  )
   CASE_WM1(WM_CREATE                )
   CASE_WM1(WM_DESTROY               )
   CASE_WM1(WM_MOVE                  )
   CASE_WM1(WM_SIZE                  )
   CASE_WM1(WM_ACTIVATE              )
   CASE_WM1(WM_SETFOCUS              )
   CASE_WM1(WM_KILLFOCUS             )
   CASE_WM1(WM_ENABLE                )
   CASE_WM1(WM_SETREDRAW             )
   CASE_WM1(WM_SETTEXT               )
   CASE_WM1(WM_GETTEXT               )
   CASE_WM1(WM_GETTEXTLENGTH         )
   CASE_WM1(WM_PAINT                 )
   CASE_WM1(WM_CLOSE                 )
   CASE_WM1(WM_QUERYENDSESSION       )
   CASE_WM1(WM_QUIT                  )
   CASE_WM1(WM_QUERYOPEN             )
   CASE_WM1(WM_ERASEBKGND            )
   CASE_WM1(WM_SYSCOLORCHANGE        )
   CASE_WM1(WM_ENDSESSION            )
   CASE_WM1(WM_SHOWWINDOW            )
   CASE_WM1(WM_SETTINGCHANGE         )
   CASE_WM1(WM_DEVMODECHANGE         )
   CASE_WM1(WM_ACTIVATEAPP           )
   CASE_WM1(WM_FONTCHANGE            )
   CASE_WM1(WM_TIMECHANGE            )
   CASE_WM1(WM_CANCELMODE            )
   CASE_WM1(WM_SETCURSOR             )
   CASE_WM1(WM_MOUSEACTIVATE         )
   CASE_WM1(WM_CHILDACTIVATE         )
   CASE_WM1(WM_QUEUESYNC             )
   CASE_WM1(WM_GETMINMAXINFO         )
   CASE_WM1(WM_PAINTICON             )
   CASE_WM1(WM_ICONERASEBKGND        )
   CASE_WM1(WM_NEXTDLGCTL            )
   CASE_WM1(WM_SPOOLERSTATUS         )
   CASE_WM1(WM_DRAWITEM              )
   CASE_WM1(WM_MEASUREITEM           )
   CASE_WM1(WM_DELETEITEM            )
   CASE_WM1(WM_VKEYTOITEM            )
   CASE_WM1(WM_CHARTOITEM            )
   CASE_WM1(WM_SETFONT               )
   CASE_WM1(WM_GETFONT               )
   CASE_WM1(WM_SETHOTKEY             )
   CASE_WM1(WM_GETHOTKEY             )
   CASE_WM1(WM_QUERYDRAGICON         )
   CASE_WM1(WM_COMPAREITEM           )
   CASE_WM1(WM_COMPACTING            )
   CASE_WM1(WM_COMMNOTIFY            )
   CASE_WM1(WM_WINDOWPOSCHANGING     )
   CASE_WM1(WM_WINDOWPOSCHANGED      )
   CASE_WM1(WM_POWER                 )
   CASE_WM1(WM_COPYDATA              )
   CASE_WM1(WM_CANCELJOURNAL         )
   CASE_WM1(WM_NOTIFY                )
   CASE_WM1(WM_INPUTLANGCHANGEREQUEST)
   CASE_WM1(WM_INPUTLANGCHANGE       )
   CASE_WM1(WM_TCARD                 )
   CASE_WM1(WM_HELP                  )
   CASE_WM1(WM_USERCHANGED           )
   CASE_WM1(WM_NOTIFYFORMAT          )
   CASE_WM1(WM_CONTEXTMENU           )
   CASE_WM1(WM_STYLECHANGING         )
   CASE_WM1(WM_STYLECHANGED          )
   CASE_WM1(WM_DISPLAYCHANGE         )
   CASE_WM1(WM_GETICON               )
   CASE_WM1(WM_SETICON               )
   CASE_WM1(WM_NCCREATE              )
   CASE_WM1(WM_NCDESTROY             )
   CASE_WM1(WM_NCCALCSIZE            )
   CASE_WM1(WM_NCHITTEST             )
   CASE_WM1(WM_NCPAINT               )
   CASE_WM1(WM_NCACTIVATE            )
   CASE_WM1(WM_GETDLGCODE            )
   CASE_WM1(WM_SYNCPAINT             )
   CASE_WM1(WM_NCMOUSEMOVE           )
   CASE_WM1(WM_NCLBUTTONDOWN         )
   CASE_WM1(WM_NCLBUTTONUP           )
   CASE_WM1(WM_NCLBUTTONDBLCLK       )
   CASE_WM1(WM_NCRBUTTONDOWN         )
   CASE_WM1(WM_NCRBUTTONUP           )
   CASE_WM1(WM_NCRBUTTONDBLCLK       )
   CASE_WM1(WM_NCMBUTTONDOWN         )
   CASE_WM1(WM_NCMBUTTONUP           )
   CASE_WM1(WM_NCMBUTTONDBLCLK       )
   CASE_WM2(WM_KEYDOWN/*WM_KEYFIRST*/, _T("WM_KEYDOWN/WM_KEYFIRST"))
   CASE_WM1(WM_KEYUP                 )
   CASE_WM1(WM_CHAR                  )
   CASE_WM1(WM_DEADCHAR              )
   CASE_WM1(WM_SYSKEYDOWN            )
   CASE_WM1(WM_SYSKEYUP              )
   CASE_WM1(WM_SYSCHAR               )
   CASE_WM1(WM_SYSDEADCHAR           )
   CASE_WM1(WM_KEYLAST               )
   CASE_WM1(WM_IME_STARTCOMPOSITION  )
   CASE_WM1(WM_IME_ENDCOMPOSITION    )
   CASE_WM1(WM_IME_COMPOSITION       )
   CASE_WM1(WM_INITDIALOG            )
   CASE_WM1(WM_COMMAND               )
   CASE_WM1(WM_SYSCOMMAND            )
   CASE_WM1(WM_TIMER                 )
   CASE_WM1(WM_HSCROLL               )
   CASE_WM1(WM_VSCROLL               )
   CASE_WM1(WM_INITMENU              )
   CASE_WM1(WM_INITMENUPOPUP         )
   CASE_WM1(WM_MENUSELECT            )
   CASE_WM1(WM_MENUCHAR              )
   CASE_WM1(WM_ENTERIDLE             )
#if (WINVER >= 0x0500)
   CASE_WM1(WM_MENURBUTTONUP         )
   CASE_WM1(WM_MENUDRAG              )
   CASE_WM1(WM_MENUGETOBJECT         )
   CASE_WM1(WM_UNINITMENUPOPUP       )
   CASE_WM1(WM_MENUCOMMAND           )
#if(_WIN32_WINNT >= 0x0500)
   CASE_WM1(WM_CHANGEUISTATE         )
   CASE_WM1(WM_UPDATEUISTATE         )
   CASE_WM1(WM_QUERYUISTATE          )
#endif /* _WIN32_WINNT >= 0x0500 */
#endif /* WINVER >= 0x0500 */

   CASE_WM1(WM_CTLCOLOR              )
   CASE_WM1(WM_CTLCOLORMSGBOX        )
   CASE_WM1(WM_CTLCOLOREDIT          )
   CASE_WM1(WM_CTLCOLORLISTBOX       )
   CASE_WM1(WM_CTLCOLORBTN           )
   CASE_WM1(WM_CTLCOLORDLG           )
   CASE_WM1(WM_CTLCOLORSCROLLBAR     )
   CASE_WM1(WM_CTLCOLORSTATIC        )
   CASE_WM1(WM_MOUSEMOVE             )
   CASE_WM1(WM_LBUTTONDOWN           )
   CASE_WM1(WM_LBUTTONUP             )
   CASE_WM1(WM_LBUTTONDBLCLK         )
   CASE_WM1(WM_RBUTTONDOWN           )
   CASE_WM1(WM_RBUTTONUP             )
   CASE_WM1(WM_RBUTTONDBLCLK         )
   CASE_WM1(WM_MBUTTONDOWN           )
   CASE_WM1(WM_MBUTTONUP             )
   CASE_WM1(WM_MBUTTONDBLCLK         )
#if (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)
   CASE_WM1(WM_MOUSEWHEEL            )
#endif
   CASE_WM1(WM_PARENTNOTIFY          )
   CASE_WM1(WM_ENTERMENULOOP         )
   CASE_WM1(WM_EXITMENULOOP          )
   CASE_WM1(WM_NEXTMENU              )
   CASE_WM1(WM_SIZING                )
   CASE_WM1(WM_CAPTURECHANGED        )
   CASE_WM1(WM_MOVING                )
   CASE_WM1(WM_POWERBROADCAST        )
   CASE_WM1(WM_DEVICECHANGE          )
   CASE_WM1(WM_IME_SETCONTEXT        )
   CASE_WM1(WM_IME_NOTIFY            )
   CASE_WM1(WM_IME_CONTROL           )
   CASE_WM1(WM_IME_COMPOSITIONFULL   )
   CASE_WM1(WM_IME_SELECT            )
   CASE_WM1(WM_IME_CHAR              )
   CASE_WM1(WM_IME_KEYDOWN           )
   CASE_WM1(WM_IME_KEYUP             )
   CASE_WM1(WM_MDICREATE             )
   CASE_WM1(WM_MDIDESTROY            )
   CASE_WM1(WM_MDIACTIVATE           )
   CASE_WM1(WM_MDIRESTORE            )
   CASE_WM1(WM_MDINEXT               )
   CASE_WM1(WM_MDIMAXIMIZE           )
   CASE_WM1(WM_MDITILE               )
   CASE_WM1(WM_MDICASCADE            )
   CASE_WM1(WM_MDIICONARRANGE        )
   CASE_WM1(WM_MDIGETACTIVE          )
   CASE_WM1(WM_MDISETMENU            )
   CASE_WM1(WM_ENTERSIZEMOVE         )
   CASE_WM1(WM_EXITSIZEMOVE          )
   CASE_WM1(WM_DROPFILES             )
   CASE_WM1(WM_MDIREFRESHMENU        )
#if(_WIN32_WINNT >= 0x0400)
   CASE_WM1(WM_MOUSEHOVER            )
   CASE_WM1(WM_MOUSELEAVE            )
#endif /* _WIN32_WINNT >= 0x0400 */
   CASE_WM1(WM_CUT                   )
   CASE_WM1(WM_COPY                  )
   CASE_WM1(WM_PASTE                 )
   CASE_WM1(WM_CLEAR                 )
   CASE_WM1(WM_UNDO                  )
   CASE_WM1(WM_RENDERFORMAT          )
   CASE_WM1(WM_RENDERALLFORMATS      )
   CASE_WM1(WM_DESTROYCLIPBOARD      )
   CASE_WM1(WM_DRAWCLIPBOARD         )
   CASE_WM1(WM_PAINTCLIPBOARD        )
   CASE_WM1(WM_VSCROLLCLIPBOARD      )
   CASE_WM1(WM_SIZECLIPBOARD         )
   CASE_WM1(WM_ASKCBFORMATNAME       )
   CASE_WM1(WM_CHANGECBCHAIN         )
   CASE_WM1(WM_HSCROLLCLIPBOARD      )
   CASE_WM1(WM_QUERYNEWPALETTE       )
   CASE_WM1(WM_PALETTEISCHANGING     )
   CASE_WM1(WM_PALETTECHANGED        )
   CASE_WM1(WM_HOTKEY                )
   CASE_WM1(WM_PRINT                 )
   CASE_WM1(WM_PRINTCLIENT           )
   CASE_WM1(WM_HANDHELDFIRST         )
   CASE_WM1(WM_HANDHELDLAST          )
#ifndef __AFX_H__
   CASE_WM1(WM_AFXFIRST              )
   CASE_WM1(WM_AFXLAST               )
#else // __AFX_H__
   CASE_WM1(WM_QUERYAFXWNDPROC       )
   CASE_WM1(WM_SIZEPARENT            )
   CASE_WM1(WM_SETMESSAGESTRING      )
   CASE_WM1(WM_IDLEUPDATECMDUI       )
   CASE_WM1(WM_INITIALUPDATE         )
   CASE_WM1(WM_COMMANDHELP           )
   CASE_WM1(WM_HELPHITTEST           )
   CASE_WM1(WM_EXITHELPMODE          )
   CASE_WM1(WM_RECALCPARENT          )
   CASE_WM1(WM_SIZECHILD             )
   CASE_WM1(WM_KICKIDLE              )
   CASE_WM1(WM_QUERYCENTERWND        )
   CASE_WM1(WM_DISABLEMODAL          )
   CASE_WM1(WM_FLOATSTATUS           )
   CASE_WM1(WM_ACTIVATETOPLEVEL      )
#ifdef WM_QUERY3DCONTROLS
   CASE_WM1(WM_QUERY3DCONTROLS       )
#endif // WM_QUERY3DCONTROLS
   CASE_WM1(WM_RESERVED_0370         )
   CASE_WM1(WM_RESERVED_0371         )
   CASE_WM1(WM_RESERVED_0372         )
   CASE_WM1(WM_SOCKET_NOTIFY         )
   CASE_WM1(WM_SOCKET_DEAD           )
   CASE_WM1(WM_POPMESSAGESTRING      )
   CASE_WM2(WM_HELPPROMPTADDR        , _T("WM_HELPPROMPTADDR/WM_OCC_LOADFROMSTREAM "))
 //CASE_WM1(WM_OCC_LOADFROMSTREAM    )
   CASE_WM1(WM_OCC_LOADFROMSTORAGE   )
   CASE_WM1(WM_OCC_INITNEW           )
   CASE_WM1(WM_OCC_LOADFROMSTREAM_EX )
   CASE_WM1(WM_OCC_LOADFROMSTORAGE_EX)
   CASE_WM1(WM_QUEUE_SENTINEL        )
   CASE_WM1(WM_RESERVED_037C         )
   CASE_WM1(WM_RESERVED_037D         )
   CASE_WM1(WM_RESERVED_037E         )
   CASE_WM1(WM_FORWARDMSG            )
#endif // __AFX_H__
   CASE_WM1(WM_PENWINFIRST           )
   CASE_WM1(WM_PENWINLAST            )
   CASE_WM1(WM_APP                   )
   CASE_WM1(WM_USER                  )
 //CASE_WM1(0x20A                    )

   // Button Control Messages
   CASE_WM1(BM_GETCHECK              )
   CASE_WM1(BM_SETCHECK              )
   CASE_WM1(BM_GETSTATE              )
   CASE_WM1(BM_SETSTATE              )
   CASE_WM1(BM_SETSTYLE              )
   CASE_WM1(BM_CLICK                 )
   CASE_WM1(BM_GETIMAGE              )
   CASE_WM1(BM_SETIMAGE              )

   // Edit Control Messages
   CASE_WM1(EM_GETSEL                )
   CASE_WM1(EM_SETSEL                )
   CASE_WM1(EM_GETRECT               )
   CASE_WM1(EM_SETRECT               )
   CASE_WM1(EM_SETRECTNP             )
   CASE_WM1(EM_SCROLL                )
   CASE_WM1(EM_LINESCROLL            )
   CASE_WM1(EM_SCROLLCARET           )
   CASE_WM1(EM_GETMODIFY             )
   CASE_WM1(EM_SETMODIFY             )
   CASE_WM1(EM_GETLINECOUNT          )
   CASE_WM1(EM_LINEINDEX             )
   CASE_WM1(EM_SETHANDLE             )
   CASE_WM1(EM_GETHANDLE             )
   CASE_WM1(EM_GETTHUMB              )
   CASE_WM1(EM_LINELENGTH            )
   CASE_WM1(EM_REPLACESEL            )
   CASE_WM1(EM_GETLINE               )
   CASE_WM1(EM_LIMITTEXT             )
   CASE_WM1(EM_CANUNDO               )
   CASE_WM1(EM_UNDO                  )
   CASE_WM1(EM_FMTLINES              )
   CASE_WM1(EM_LINEFROMCHAR          )
   CASE_WM1(EM_SETTABSTOPS           )
   CASE_WM1(EM_SETPASSWORDCHAR       )
   CASE_WM1(EM_EMPTYUNDOBUFFER       )
   CASE_WM1(EM_GETFIRSTVISIBLELINE   )
   CASE_WM1(EM_SETREADONLY           )
   CASE_WM1(EM_SETWORDBREAKPROC      )
   CASE_WM1(EM_GETWORDBREAKPROC      )
   CASE_WM1(EM_GETPASSWORDCHAR       )
   CASE_WM1(EM_SETMARGINS            )
   CASE_WM1(EM_GETMARGINS            )
 //CASE_WM1(EM_SETLIMITTEXT          )
   CASE_WM1(EM_GETLIMITTEXT          )
   CASE_WM1(EM_POSFROMCHAR           )
   CASE_WM1(EM_CHARFROMPOS           )
#if(WINVER >= 0x0500)
   CASE_WM1(EM_SETIMESTATUS          )
   CASE_WM1(EM_GETIMESTATUS          )
#endif /* WINVER >= 0x0500 */

   // Static Control Mesages
   CASE_WM1(STM_SETICON              )
   CASE_WM1(STM_GETICON              )
   CASE_WM1(STM_SETIMAGE             )
   CASE_WM1(STM_GETIMAGE             )

   // Scroll bar messages
   CASE_WM1(SBM_SETPOS               )
   CASE_WM1(SBM_GETPOS               )
   CASE_WM1(SBM_SETRANGE             )
   CASE_WM1(SBM_SETRANGEREDRAW       )
   CASE_WM1(SBM_GETRANGE             )
   CASE_WM1(SBM_ENABLE_ARROWS        )
   CASE_WM1(SBM_SETSCROLLINFO        )
   CASE_WM1(SBM_GETSCROLLINFO        )
#if(_WIN32_WINNT >= 0x0501)
   CASE_WM1(SBM_GETSCROLLBARINFO     )
#endif /* _WIN32_WINNT >= 0x0501 */
   #undef CASE_WM1
   #undef CASE_WM2
   }
#endif // LOGGER_DUMMY

   if (strRes.IsEmpty()) {
      if ((msg>=WM_HANDHELDFIRST) && (msg<=WM_HANDHELDLAST)) {
         strRes.Format(_T("WM_HANDHELDFIRST+%d"), msg-WM_HANDHELDFIRST);
      } else
      if ((msg>=WM_AFXFIRST) && (msg<=WM_AFXLAST)) {
         strRes.Format(_T("WM_AFXFIRST+%d"), msg-WM_AFXFIRST);
      } else
      if ((msg>=WM_PENWINFIRST) && (msg<=WM_PENWINLAST)) {
         strRes.Format(_T("WM_PENWINFIRST+%d"), msg-WM_PENWINFIRST);
      } else
      if ((msg>=WM_APP) && (msg<=0xBFFF)) { // Messages reserved for future use by Windows.
         strRes.Format(_T("WM_APP+%d"), msg-WM_APP);
         //strRes += _T(" Unknown application private message");
      }
   }
   if (strRes.IsEmpty()) {
      if ((msg>=0) && (msg<WM_USER)) { // Messages reserved for use by Windows.
         strRes.Format(_T("Unknown window message 0x%04X"), int(msg));
      } else
      if ((msg>=WM_USER) && (msg<=0x7FFF)) { // Integer messages for use by private window classes.
         strRes.Format(_T("Unknown user message 0x%04X"), int(msg));
      } else
      if ((msg>=0xC000) && (msg<=0xFFFF)) { // String messages for use by applications.
         strRes.Format(_T("Unknown string message 0x%04X"), int(msg));
      } else
      if (msg>0xFFFF) { // Reserved by Windows for future use.
         strRes.Format(_T("Unknown reserved message 0x%04X"), int(msg));
      }
   }
   return strRes;
}

BOOL CALLBACK nsLogger::EqualsGUIDs_Func(IN REFGUID guid, IN LPCTSTR szGUID, IN LPVOID lpUserData) {
   if (!lpUserData) return FALSE;
   nsLogger::CEqualsGUIDs_Func_Data &Data = *(nsLogger::CEqualsGUIDs_Func_Data*)lpUserData;
   if (Data.m_GUID == guid) {
      if (Data.m_szSeparator && Data.m_szSeparator[0]) {
         Data.m_strRes += Data.m_szSeparator;
      }
      Data.m_strRes += szGUID;
   }
   return TRUE; //   !
}
/* static */ CString CLogger::EqualsGUIDs(REFGUID guid, BOOL bFromRegistry, LPCTSTR szSeparator) {
   CString strRes;
   CLogger::EnumGUIDs(nsLogger::EqualsGUIDs_Func, &nsLogger::CEqualsGUIDs_Func_Data(guid, szSeparator, strRes), bFromRegistry);
   if (strRes.IsEmpty()) {
      strRes = nsLogger::GUID2String(guid);
   } else {
      if (szSeparator && szSeparator[0]) {
         strRes = strRes.Mid(lstrlen(szSeparator));
      }
   }
   return strRes;
}

BOOL CALLBACK nsLogger::CoCreateInstances_Func(IN REFGUID guid, IN LPCTSTR szGUID, IN LPVOID lpUserData) {
   if (!lpUserData) return FALSE;
   nsLogger::CCoCreateInstances_Func_Data &Data = *(nsLogger::CCoCreateInstances_Func_Data*)lpUserData;
   IUnknown *pFindInterface = NULL;
   try {
      if (SUCCEEDED(::CoCreateInstance(Data.m_CLSID, NULL, CLSCTX_ALL, guid, (void**)&pFindInterface)) && pFindInterface) {
         pFindInterface->Release();
         if (Data.m_szSeparator && Data.m_szSeparator[0]) {
            Data.m_strRes += Data.m_szSeparator;
         }
         Data.m_strRes += szGUID;
      }
   } catch(...) {}
   return TRUE; //   !
}
/* static */ CString CLogger::CoCreateInstances(REFCLSID clsid, BOOL bFromRegistry, LPCTSTR szSeparator) {
   ::CoInitialize(NULL);
   CString strRes;
   if (bFromRegistry) {
      CLogger::EnumIIDsFromRegistry(nsLogger::CoCreateInstances_Func, &nsLogger::CCoCreateInstances_Func_Data(clsid, szSeparator, strRes));
   } else {
      CLogger::EnumGUIDs           (nsLogger::CoCreateInstances_Func, &nsLogger::CCoCreateInstances_Func_Data(clsid, szSeparator, strRes), bFromRegistry);
   }
   if (!strRes.IsEmpty()) {
      if (szSeparator && szSeparator[0]) {
         strRes = strRes.Mid(lstrlen(szSeparator));
      }
   }
   return strRes;
}

BOOL CALLBACK nsLogger::QueryInterfaces_Func(IN REFGUID guid, IN LPCTSTR szGUID, IN LPVOID lpUserData) {
   if (!lpUserData) return FALSE;
   nsLogger::CQueryInterfaces_Func_Data &Data = *(nsLogger::CQueryInterfaces_Func_Data*)lpUserData;
   IUnknown *pFindInterface = NULL;
   if (Data.m_pInterface && SUCCEEDED(Data.m_pInterface->QueryInterface(guid, (void**)&pFindInterface)) && pFindInterface) {
      pFindInterface->Release();
      if (Data.m_szSeparator && Data.m_szSeparator[0]) {
         Data.m_strRes += Data.m_szSeparator;
      }
      Data.m_strRes += szGUID;
   }
   return TRUE; //   !
}
/* static */ CString CLogger::QueryInterfaces(IUnknown *pInterface, BOOL bFromRegistry, LPCTSTR szSeparator) {
   if (!pInterface) return CString();
   CString strRes;
   if (bFromRegistry) {
      CLogger::EnumIIDsFromRegistry(nsLogger::QueryInterfaces_Func, &nsLogger::CQueryInterfaces_Func_Data(pInterface, szSeparator, strRes));
   } else {
      CLogger::EnumGUIDs           (nsLogger::QueryInterfaces_Func, &nsLogger::CQueryInterfaces_Func_Data(pInterface, szSeparator, strRes), bFromRegistry);
   }
   if (!strRes.IsEmpty()) {
      if (szSeparator && szSeparator[0]) {
         strRes = strRes.Mid(lstrlen(szSeparator));
      }
   }
   return strRes;
}

/* static */ BOOL CLogger::EnumCLSIDsFromRegistry(IN CLogger::GUIDENUMPROC pEnumFunc, IN LPVOID lpUserData) {
   return nsLogger::EnumGUIDsFromRegistry(_T("CLSID"), pEnumFunc, lpUserData);
}
/* static */ BOOL CLogger::EnumIIDsFromRegistry(IN CLogger::GUIDENUMPROC pEnumFunc, IN LPVOID lpUserData) {
   return nsLogger::EnumGUIDsFromRegistry(_T("Interface"), pEnumFunc, lpUserData);
}
/* static */ BOOL CLogger::EnumGUIDs(IN CLogger::GUIDENUMPROC pEnumFunc, IN LPVOID lpUserData, BOOL bFromRegistry) {
   if (!pEnumFunc) return FALSE;
#ifdef LOGGER_DUMMY
   bFromRegistry = TRUE;
#endif // LOGGER_DUMMY

   BOOL bRes = FALSE;
   if (bFromRegistry) {
      bRes = CLogger::EnumCLSIDsFromRegistry(pEnumFunc, lpUserData) &&
             CLogger::EnumIIDsFromRegistry  (pEnumFunc, lpUserData);
   }

#ifndef LOGGER_DUMMY
   //     (..  ) GUID'
   else do {

      #define CALL_ENUM_FUNC1(guid)                      bRes = pEnumFunc(        (guid), _T(#guid), lpUserData); if (!bRes) break;
      #define CALL_ENUM_FUNC2(guid) {GUID _guid_ = guid; bRes = pEnumFunc(        _guid_, _T(#guid), lpUserData); if (!bRes) break; }
      #define CALL_ENUM_FUNC3(guid)                      bRes = pEnumFunc(__uuidof(guid), _T(#guid), lpUserData); if (!bRes) break;

      CALL_ENUM_FUNC1(IID_IOleAdviseHolder                  )
      CALL_ENUM_FUNC1(IID_IOleCache                         )
      CALL_ENUM_FUNC1(IID_IOleCache2                        )
      CALL_ENUM_FUNC1(IID_IOleCacheControl                  )
      CALL_ENUM_FUNC1(IID_IParseDisplayName                 )
      CALL_ENUM_FUNC1(IID_IOleContainer                     )
      CALL_ENUM_FUNC1(IID_IOleClientSite                    )
      CALL_ENUM_FUNC1(IID_IOleObject                        )
      CALL_ENUM_FUNC1(IID_IOleWindow                        )
      CALL_ENUM_FUNC1(IID_IOleLink                          )
      CALL_ENUM_FUNC1(IID_IOleItemContainer                 )
      CALL_ENUM_FUNC1(IID_IOleInPlaceUIWindow               )
      CALL_ENUM_FUNC1(IID_IOleInPlaceActiveObject           )
      CALL_ENUM_FUNC1(IID_IOleInPlaceFrame                  )
      CALL_ENUM_FUNC1(IID_IOleInPlaceObject                 )
      CALL_ENUM_FUNC1(IID_IOleInPlaceSite                   )
      CALL_ENUM_FUNC1(IID_IContinue                         )
      CALL_ENUM_FUNC1(IID_IViewObject                       )
      CALL_ENUM_FUNC1(IID_IViewObject2                      )
      CALL_ENUM_FUNC1(IID_IDropSource                       )
      CALL_ENUM_FUNC1(IID_IDropTarget                       )
      CALL_ENUM_FUNC1(IID_IEnumOLEVERB                      )
      CALL_ENUM_FUNC1(IID_IOleDocument                      )
      CALL_ENUM_FUNC1(IID_IOleDocumentSite                  )
      CALL_ENUM_FUNC1(IID_IOleDocumentView                  )
      CALL_ENUM_FUNC1(IID_IEnumOleDocumentViews             )
      CALL_ENUM_FUNC1(IID_IContinueCallback                 )
      CALL_ENUM_FUNC1(IID_IPrint                            )
      CALL_ENUM_FUNC1(IID_IOleCommandTarget                 )
      CALL_ENUM_FUNC1(IID_IEnumConnections                  )
      CALL_ENUM_FUNC1(IID_IConnectionPoint                  )
      CALL_ENUM_FUNC1(IID_IEnumConnectionPoints             )
      CALL_ENUM_FUNC1(IID_IConnectionPointContainer         )
      CALL_ENUM_FUNC1(IID_IClassFactory                     )
      CALL_ENUM_FUNC1(IID_IClassFactory2                    )
      CALL_ENUM_FUNC1(IID_IProvideClassInfo                 )
      CALL_ENUM_FUNC1(IID_IProvideClassInfo2                )
      CALL_ENUM_FUNC1(IID_IProvideMultipleClassInfo         )
      CALL_ENUM_FUNC1(IID_IOleControl                       )
      CALL_ENUM_FUNC1(IID_IOleControlSite                   )
      CALL_ENUM_FUNC1(IID_IPropertyPage                     )
      CALL_ENUM_FUNC1(IID_IPropertyPage2                    )
      CALL_ENUM_FUNC1(IID_IPropertyPageSite                 )
      CALL_ENUM_FUNC1(IID_IPropertyNotifySink               )
      CALL_ENUM_FUNC1(IID_ISpecifyPropertyPages             )
      CALL_ENUM_FUNC1(IID_IPersistMemory                    )
      CALL_ENUM_FUNC1(IID_IPersistStreamInit                )
      CALL_ENUM_FUNC1(IID_ISimpleFrameSite                  )
      CALL_ENUM_FUNC1(IID_IFont                             )
      CALL_ENUM_FUNC1(IID_IPicture                          )
      CALL_ENUM_FUNC1(IID_IFontEventsDisp                   )
      CALL_ENUM_FUNC1(IID_IFontDisp                         )
      CALL_ENUM_FUNC1(IID_IPictureDisp                      )
      CALL_ENUM_FUNC1(IID_IOleInPlaceObjectWindowless       )
      CALL_ENUM_FUNC1(IID_IOleInPlaceSiteEx                 )
      CALL_ENUM_FUNC1(IID_IOleInPlaceSiteWindowless         )
      CALL_ENUM_FUNC1(IID_IViewObjectEx                     )
      CALL_ENUM_FUNC1(IID_IOleUndoUnit                      )
      CALL_ENUM_FUNC1(IID_IOleParentUndoUnit                )
      CALL_ENUM_FUNC1(IID_IEnumOleUndoUnits                 )
      CALL_ENUM_FUNC1(IID_IOleUndoManager                   )
      CALL_ENUM_FUNC1(IID_IPointerInactive                  )
      CALL_ENUM_FUNC1(IID_IObjectWithSite                   )
      CALL_ENUM_FUNC1(IID_IPerPropertyBrowsing              )
      CALL_ENUM_FUNC1(IID_IPropertyBag                      )
      CALL_ENUM_FUNC1(IID_IPropertyBag2                     )
      CALL_ENUM_FUNC1(IID_IPersistPropertyBag               )
      CALL_ENUM_FUNC1(IID_IPersistPropertyBag2              )
      CALL_ENUM_FUNC1(IID_IAdviseSinkEx                     )
      CALL_ENUM_FUNC1(IID_IQuickActivate                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_AsyncIUnknown                     )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IServiceProvider                  )
      CALL_ENUM_FUNC1(CLSID_ShellDesktop                    )
      CALL_ENUM_FUNC1(CLSID_ShellLink                       )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_NetworkPlaces                   )
      CALL_ENUM_FUNC1(CLSID_NetworkDomain                   )
      CALL_ENUM_FUNC1(CLSID_NetworkServer                   )
      CALL_ENUM_FUNC1(CLSID_NetworkShare                    )
      CALL_ENUM_FUNC1(CLSID_MyComputer                      )
      CALL_ENUM_FUNC1(CLSID_Internet                        )
      CALL_ENUM_FUNC1(CLSID_ShellFSFolder                   )
      CALL_ENUM_FUNC1(CLSID_RecycleBin                      )
      CALL_ENUM_FUNC1(CLSID_ControlPanel                    )
      CALL_ENUM_FUNC1(CLSID_Printers                        )
      CALL_ENUM_FUNC1(CLSID_MyDocuments                     )
#endif // __SDK__
      CALL_ENUM_FUNC1(CATID_BrowsableShellExt               )
      CALL_ENUM_FUNC1(CATID_BrowseInPlace                   )
      CALL_ENUM_FUNC1(CATID_DeskBand                        )
      CALL_ENUM_FUNC1(CATID_InfoBand                        )
      CALL_ENUM_FUNC1(CATID_CommBand                        )
      CALL_ENUM_FUNC1(FMTID_Intshcut                        )
      CALL_ENUM_FUNC1(FMTID_InternetSite                    )
      CALL_ENUM_FUNC1(CGID_Explorer                         )
      CALL_ENUM_FUNC1(CGID_ShellDocView                     )
      CALL_ENUM_FUNC1(CGID_ShellServiceObject               )
      CALL_ENUM_FUNC1(CGID_ExplorerBarDoc                   )
      CALL_ENUM_FUNC1(IID_IShellBrowser                     )
      CALL_ENUM_FUNC1(IID_IShellIcon                        )
      CALL_ENUM_FUNC1(IID_IShellExtInit                     )
      CALL_ENUM_FUNC1(IID_IShellPropSheetExt                )
      CALL_ENUM_FUNC1(IID_IPersistFolder                    )
      CALL_ENUM_FUNC1(IID_IShellDetails                     )
      CALL_ENUM_FUNC1(IID_IDelayedRelease                   )
      CALL_ENUM_FUNC1(IID_IEnumIDList                       )
      CALL_ENUM_FUNC1(IID_IFileViewerSite                   )
      CALL_ENUM_FUNC1(IID_IContextMenu                      )
      CALL_ENUM_FUNC1(IID_IContextMenu2                     )
      CALL_ENUM_FUNC1(IID_IContextMenu3                     )
      CALL_ENUM_FUNC1(IID_IPropSheetPage                    )
      CALL_ENUM_FUNC1(IID_IFileViewerW                      )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IRemoteComputer                   )
      CALL_ENUM_FUNC1(IID_ICopyHookA                        )
      CALL_ENUM_FUNC1(IID_ICopyHookW                        )
      CALL_ENUM_FUNC1(SID_LinkSite                          )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IQueryInfo                        )
      CALL_ENUM_FUNC1(IID_IBriefcaseStg                     )
      CALL_ENUM_FUNC1(IID_IShellView                        )
      CALL_ENUM_FUNC1(IID_IShellView2                       )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IShellLinkDataList                )
      CALL_ENUM_FUNC1(IID_IResolveShellLink                 )
      CALL_ENUM_FUNC1(IID_ISearchContext                    )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IURLSearchHook                    )
 #ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IURLSearchHook2                   )
      CALL_ENUM_FUNC1(IID_IDefViewID                        )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IUnknown                          )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_FolderShortcut                  )
      CALL_ENUM_FUNC1(CLSID_StgFolder                       )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IInputObject                      )
      CALL_ENUM_FUNC1(IID_IInputObjectSite                  )
      CALL_ENUM_FUNC1(IID_IDockingWindowSite                )
      CALL_ENUM_FUNC1(IID_IDockingWindowFrame               )
      CALL_ENUM_FUNC1(IID_IShellIconOverlay                 )
      CALL_ENUM_FUNC1(IID_IShellIconOverlayIdentifier       )
      CALL_ENUM_FUNC1(IID_ICommDlgBrowser                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_ICommDlgBrowser2                  )
      CALL_ENUM_FUNC1(SID_ShellFolderViewCB                 )
      CALL_ENUM_FUNC1(IID_IShellFolderViewCB                )
      CALL_ENUM_FUNC1(IID_IPersistFolder3                   )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_CFSIconOverlayManager           )
      CALL_ENUM_FUNC1(IID_IShellIconOverlayManager          )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IRunnableTask                     )
      CALL_ENUM_FUNC1(IID_IThumbnailCapture                 )
      CALL_ENUM_FUNC1(IID_IShellImageStore                  )
      CALL_ENUM_FUNC1(IID_IEnumShellImageStore              )
      CALL_ENUM_FUNC1(CLSID_ShellThumbnailDiskCache         )
      CALL_ENUM_FUNC1(SID_DefView                           )
      CALL_ENUM_FUNC1(CGID_DefView                          )
      CALL_ENUM_FUNC1(CLSID_MenuBand                        )
      CALL_ENUM_FUNC1(IID_IShellFolderBand                  )
      CALL_ENUM_FUNC1(IID_IDefViewFrame                     )
      CALL_ENUM_FUNC1(VID_LargeIcons                        )
      CALL_ENUM_FUNC1(VID_SmallIcons                        )
      CALL_ENUM_FUNC1(VID_List                              )
      CALL_ENUM_FUNC1(VID_Details                           )
      CALL_ENUM_FUNC1(VID_Tile                              )
      CALL_ENUM_FUNC1(VID_Thumbnails                        )
      CALL_ENUM_FUNC1(VID_ThumbStrip                        )
#endif // __SDK__
      CALL_ENUM_FUNC1(SID_SShellBrowser                     )
      CALL_ENUM_FUNC1(SID_SShellDesktop                     )
      CALL_ENUM_FUNC1(IID_IDiscardableBrowserProperty       )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IShellChangeNotify                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IFileViewer                       )
      CALL_ENUM_FUNC1(IID_IFileViewerA                      )
      CALL_ENUM_FUNC1(IID_IShellLink                        )
      CALL_ENUM_FUNC1(IID_IShellLinkW                       )
      CALL_ENUM_FUNC1(IID_IShellLinkA                       )
      CALL_ENUM_FUNC1(IID_IExtractIcon                      )
      CALL_ENUM_FUNC1(IID_IExtractIconW                     )
      CALL_ENUM_FUNC1(IID_IExtractIconA                     )
      CALL_ENUM_FUNC1(IID_IShellCopyHook                    )
      CALL_ENUM_FUNC1(IID_IShellCopyHookW                   )
      CALL_ENUM_FUNC1(IID_IShellCopyHookA                   )
      CALL_ENUM_FUNC1(IID_IShellExecuteHook                 )
      CALL_ENUM_FUNC1(IID_IShellExecuteHookW                )
      CALL_ENUM_FUNC1(IID_IShellExecuteHookA                )
      CALL_ENUM_FUNC1(IID_INewShortcutHook                  )
      CALL_ENUM_FUNC1(IID_INewShortcutHookW                 )
      CALL_ENUM_FUNC1(IID_INewShortcutHookA                 )
      CALL_ENUM_FUNC1(SID_SUrlHistory                       )
      CALL_ENUM_FUNC1(CLSID_CUrlHistory                     )
      CALL_ENUM_FUNC1(CLSID_CURLSearchHook                  )
      CALL_ENUM_FUNC1(SID_SInternetExplorer                 )
      CALL_ENUM_FUNC1(SID_SWebBrowserApp                    )
      CALL_ENUM_FUNC1(IID_IWebBrowserApp                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IAutoCompList                     )
      CALL_ENUM_FUNC1(IID_IObjMgr                           )
      CALL_ENUM_FUNC1(IID_IACList                           )
      CALL_ENUM_FUNC1(IID_IACList2                          )
      CALL_ENUM_FUNC1(IID_ICurrentWorkingDirectory          )
      CALL_ENUM_FUNC1(CLSID_AutoComplete                    )
      CALL_ENUM_FUNC1(CLSID_ACLHistory                      )
      CALL_ENUM_FUNC1(CLSID_ACListISF                       )
      CALL_ENUM_FUNC1(CLSID_ACLMRU                          )
      CALL_ENUM_FUNC1(CLSID_ACLMulti                        )
#if (_WIN32_IE >= 0x0600)
      CALL_ENUM_FUNC1(CLSID_ACLCustomMRU                    )
#endif
      CALL_ENUM_FUNC1(CLSID_ProgressDialog                  )
      CALL_ENUM_FUNC1(IID_IProgressDialog                   )
      CALL_ENUM_FUNC1(SID_SProgressUI                       )
#endif // __SDK__
      CALL_ENUM_FUNC1(SID_STopLevelBrowser                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_FileTypes                       )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_ActiveDesktop                   )
      CALL_ENUM_FUNC1(IID_IActiveDesktop                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IActiveDesktopP                   )
      CALL_ENUM_FUNC1(IID_IADesktopP2                       )
      CALL_ENUM_FUNC1(IID_ISynchronizedCallBack             )
      CALL_ENUM_FUNC1(IID_IShellDetails3                    )
      CALL_ENUM_FUNC1(IID_IQueryAssociations                )
      CALL_ENUM_FUNC1(CLSID_QueryAssociations               )
      CALL_ENUM_FUNC1(IID_IColumnProvider                   )
      CALL_ENUM_FUNC1(CLSID_DocFileColumnProvider           )
      CALL_ENUM_FUNC1(CLSID_LinkColumnProvider              )
      CALL_ENUM_FUNC1(CLSID_FileSysColumnProvider           )
      CALL_ENUM_FUNC1(CGID_ShortCut                         )
      CALL_ENUM_FUNC1(IID_INamedPropertyBag                 )
      CALL_ENUM_FUNC1(CLSID_InternetButtons                 )
      CALL_ENUM_FUNC1(CLSID_MSOButtons                      )
      CALL_ENUM_FUNC1(CLSID_ToolbarExtButtons               )
      CALL_ENUM_FUNC1(CLSID_DarwinAppPublisher              )
      CALL_ENUM_FUNC1(CLSID_DocHostUIHandler                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IShellFolder                      )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IShellFolder2                     )
      CALL_ENUM_FUNC1(FMTID_ShellDetails                    )
      CALL_ENUM_FUNC1(FMTID_Storage                         )
      CALL_ENUM_FUNC1(FMTID_ImageProperties                 )
      CALL_ENUM_FUNC1(FMTID_Displaced                       )
      CALL_ENUM_FUNC1(FMTID_Briefcase                       )
      CALL_ENUM_FUNC1(FMTID_Misc                            )
      CALL_ENUM_FUNC1(FMTID_WebView                         )
      CALL_ENUM_FUNC1(FMTID_MUSIC                           )
      CALL_ENUM_FUNC1(FMTID_DRM                             )
      CALL_ENUM_FUNC1(FMTID_Volume                          )
      CALL_ENUM_FUNC1(FMTID_Query                           )
      CALL_ENUM_FUNC1(IID_IEnumExtraSearch                  )
      CALL_ENUM_FUNC1(CLSID_MountedVolume                   )
      CALL_ENUM_FUNC1(CLSID_HWShellExecute                  )
      CALL_ENUM_FUNC1(IID_IMountedVolume                    )
      CALL_ENUM_FUNC1(CLSID_DragDropHelper                  )
      CALL_ENUM_FUNC1(IID_IDropTargetHelper                 )
      CALL_ENUM_FUNC1(IID_IDragSourceHelper                 )
      CALL_ENUM_FUNC1(CLSID_CAnchorBrowsePropertyPage       )
      CALL_ENUM_FUNC1(CLSID_CImageBrowsePropertyPage        )
      CALL_ENUM_FUNC1(CLSID_CDocBrowsePropertyPage          )
      CALL_ENUM_FUNC1(IID_IFileSystemBindData               )
      CALL_ENUM_FUNC1(SID_STopWindow                        )
      CALL_ENUM_FUNC1(SID_SGetViewFromViewDual              )
      CALL_ENUM_FUNC1(CLSID_FolderItem                      )
      CALL_ENUM_FUNC1(CLSID_FolderItemsFDF                  )
      CALL_ENUM_FUNC1(CLSID_NewMenu                         )
      CALL_ENUM_FUNC1(BHID_SFObject                         )
      CALL_ENUM_FUNC1(BHID_SFUIObject                       )
      CALL_ENUM_FUNC1(BHID_SFViewObject                     )
      CALL_ENUM_FUNC1(BHID_Storage                          )
      CALL_ENUM_FUNC1(BHID_Stream                           )
      CALL_ENUM_FUNC1(BHID_LinkTargetItem                   )
      CALL_ENUM_FUNC1(BHID_StorageEnum                      )
#if _WIN32_IE >= 0x0600
      CALL_ENUM_FUNC1(SID_CtxQueryAssociations              )
#endif // _WIN32_IE >= 0x0600
      CALL_ENUM_FUNC1(IID_IDocViewSite                      )
      CALL_ENUM_FUNC1(CLSID_QuickLinks                      )
      CALL_ENUM_FUNC1(CLSID_ISFBand                         )
      CALL_ENUM_FUNC1(IID_CDefView                          )
      CALL_ENUM_FUNC1(CLSID_ShellFldSetExt                  )
      CALL_ENUM_FUNC1(SID_SMenuBandChild                    )
      CALL_ENUM_FUNC1(SID_SMenuBandParent                   )
      CALL_ENUM_FUNC1(SID_SMenuPopup                        )
      CALL_ENUM_FUNC1(SID_SMenuBandBottomSelected           )
      CALL_ENUM_FUNC1(SID_SMenuBandBottom                   )
      CALL_ENUM_FUNC1(SID_MenuShellFolder                   )
      CALL_ENUM_FUNC1(CGID_MENUDESKBAR                      )
      CALL_ENUM_FUNC1(SID_SMenuBandTop                      )
      CALL_ENUM_FUNC1(CLSID_MenuToolbarBase                 )
      CALL_ENUM_FUNC1(IID_IBanneredBar                      )
      CALL_ENUM_FUNC1(CLSID_MenuBandSite                    )
      CALL_ENUM_FUNC1(SID_SCommDlgBrowser                   )
      CALL_ENUM_FUNC1(IID_ITargetFrame                      )
      CALL_ENUM_FUNC1(IID_ITargetEmbedding                  )
      CALL_ENUM_FUNC1(IID_ITargetFramePriv                  )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IMimeInfo                         )
      CALL_ENUM_FUNC1(IID_IEnumSTATURL                      )
      CALL_ENUM_FUNC1(IID_IUrlHistoryStg                    )
      CALL_ENUM_FUNC1(IID_IUrlHistoryStg2                   )
      CALL_ENUM_FUNC1(IID_IUrlHistoryNotify                 )
      CALL_ENUM_FUNC1(IID_IHTMLFiltersCollection            )
      CALL_ENUM_FUNC1(LIBID_MSHTML                          )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IElementBehaviorSite              )
      CALL_ENUM_FUNC1(IID_IElementBehavior                  )
      CALL_ENUM_FUNC1(IID_IElementBehaviorFactory           )
      CALL_ENUM_FUNC1(IID_IElementBehaviorRender            )
      CALL_ENUM_FUNC1(IID_IElementBehaviorSiteRender        )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLStyle                        )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLStyle2                       )
      CALL_ENUM_FUNC1(IID_IHTMLStyle3                       )
      CALL_ENUM_FUNC1(IID_IHTMLStyle4                       )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLRuleStyle                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLRuleStyle2                   )
      CALL_ENUM_FUNC1(IID_IHTMLRuleStyle3                   )
      CALL_ENUM_FUNC1(IID_IHTMLRuleStyle4                   )
      CALL_ENUM_FUNC1(DIID_DispHTMLStyle                    )
      CALL_ENUM_FUNC1(DIID_DispHTMLRuleStyle                )
      CALL_ENUM_FUNC1(IID_IHTMLRenderStyle                  )
      CALL_ENUM_FUNC1(DIID_DispHTMLRenderStyle              )
      CALL_ENUM_FUNC1(IID_IHTMLCurrentStyle                 )
      CALL_ENUM_FUNC1(IID_IHTMLCurrentStyle2                )
      CALL_ENUM_FUNC1(IID_IHTMLCurrentStyle3                )
      CALL_ENUM_FUNC1(DIID_DispHTMLCurrentStyle             )
      CALL_ENUM_FUNC1(IID_IHTMLRect                         )
      CALL_ENUM_FUNC1(IID_IHTMLRectCollection               )
      CALL_ENUM_FUNC1(IID_IHTMLDOMNode                      )
      CALL_ENUM_FUNC1(IID_IHTMLDOMNode2                     )
      CALL_ENUM_FUNC1(IID_IHTMLDOMAttribute                 )
      CALL_ENUM_FUNC1(IID_IHTMLDOMAttribute2                )
      CALL_ENUM_FUNC1(IID_IHTMLDOMTextNode                  )
      CALL_ENUM_FUNC1(IID_IHTMLDOMTextNode2                 )
      CALL_ENUM_FUNC1(IID_IHTMLDOMImplementation            )
      CALL_ENUM_FUNC1(DIID_DispHTMLDOMAttribute             )
      CALL_ENUM_FUNC1(DIID_DispHTMLDOMTextNode              )
      CALL_ENUM_FUNC1(DIID_DispHTMLDOMImplementation        )
      CALL_ENUM_FUNC1(IID_IHTMLAttributeCollection          )
      CALL_ENUM_FUNC1(IID_IHTMLAttributeCollection2         )
      CALL_ENUM_FUNC1(IID_IHTMLDOMChildrenCollection        )
      CALL_ENUM_FUNC1(DIID_DispHTMLAttributeCollection      )
      CALL_ENUM_FUNC1(DIID_DispDOMChildrenCollection        )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLElementEvents                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLElementEvents2               )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLElement                      )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLElement2                     )
      CALL_ENUM_FUNC1(IID_IHTMLElement3                     )
      CALL_ENUM_FUNC1(IID_IHTMLElement4                     )
      CALL_ENUM_FUNC1(IID_IHTMLElementRender                )
      CALL_ENUM_FUNC1(IID_IHTMLUniqueName                   )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLDatabinding                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLElementDefaults              )
      CALL_ENUM_FUNC1(DIID_DispHTMLDefaults                 )
      CALL_ENUM_FUNC1(IID_IHTCDefaultDispatch               )
      CALL_ENUM_FUNC1(IID_IHTCPropertyBehavior              )
      CALL_ENUM_FUNC1(IID_IHTCMethodBehavior                )
      CALL_ENUM_FUNC1(IID_IHTCEventBehavior                 )
      CALL_ENUM_FUNC1(IID_IHTCAttachBehavior                )
      CALL_ENUM_FUNC1(IID_IHTCAttachBehavior2               )
      CALL_ENUM_FUNC1(IID_IHTCDescBehavior                  )
      CALL_ENUM_FUNC1(DIID_DispHTCDefaultDispatch           )
      CALL_ENUM_FUNC1(DIID_DispHTCPropertyBehavior          )
      CALL_ENUM_FUNC1(DIID_DispHTCMethodBehavior            )
      CALL_ENUM_FUNC1(DIID_DispHTCEventBehavior             )
      CALL_ENUM_FUNC1(DIID_DispHTCAttachBehavior            )
      CALL_ENUM_FUNC1(DIID_DispHTCDescBehavior              )
      CALL_ENUM_FUNC1(IID_IHTMLUrnCollection                )
      CALL_ENUM_FUNC1(IID_IHTMLGenericElement               )
      CALL_ENUM_FUNC1(DIID_DispHTMLGenericElement           )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLStyleSheetRule               )
      CALL_ENUM_FUNC1(IID_IHTMLStyleSheetRulesCollection    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLStyleSheetPage               )
      CALL_ENUM_FUNC1(IID_IHTMLStyleSheetPagesCollection    )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLStyleSheetsCollection        )
      CALL_ENUM_FUNC1(IID_IHTMLStyleSheet                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLStyleSheet2                  )
      CALL_ENUM_FUNC1(DIID_DispHTMLStyleSheet               )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLLinkElementEvents            )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLLinkElementEvents2           )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLLinkElement                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLLinkElement2                 )
      CALL_ENUM_FUNC1(IID_IHTMLLinkElement3                 )
      CALL_ENUM_FUNC1(DIID_DispHTMLLinkElement              )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTxtRange                     )
      CALL_ENUM_FUNC1(IID_IHTMLTextRangeMetrics             )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTextRangeMetrics2            )
      CALL_ENUM_FUNC1(IID_IHTMLTxtRangeCollection           )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLFormElementEvents            )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLFormElementEvents2           )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFormElement                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFormElement2                 )
      CALL_ENUM_FUNC1(IID_IHTMLFormElement3                 )
      CALL_ENUM_FUNC1(IID_IHTMLSubmitData                   )
      CALL_ENUM_FUNC1(DIID_DispHTMLFormElement              )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLControlElementEvents         )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLControlElementEvents2        )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLControlElement               )
      CALL_ENUM_FUNC1(IID_IHTMLTextElement                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLTextElement              )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLTextContainerEvents          )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLTextContainerEvents2         )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTextContainer                )
      CALL_ENUM_FUNC1(IID_IHTMLControlRange                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLControlRange2                )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLImgEvents                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLImgEvents2                   )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLImgElement                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLImgElement2                  )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLImageElementFactory          )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLImg                      )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLBodyElement                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLBodyElement2                 )
      CALL_ENUM_FUNC1(DIID_DispHTMLBody                     )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFontElement                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLFontElement              )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLAnchorEvents                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLAnchorEvents2                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLAnchorElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLAnchorElement2               )
      CALL_ENUM_FUNC1(DIID_DispHTMLAnchorElement            )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLLabelEvents                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLLabelEvents2                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLLabelElement                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLLabelElement2                )
      CALL_ENUM_FUNC1(DIID_DispHTMLLabelElement             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLListElement                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLListElement2                 )
      CALL_ENUM_FUNC1(DIID_DispHTMLListElement              )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLUListElement                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLUListElement             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLOListElement                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLOListElement             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLLIElement                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLLIElement                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLBlockElement                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLBlockElement2                )
      CALL_ENUM_FUNC1(DIID_DispHTMLBlockElement             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLDivElement                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLDivElement               )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLDDElement                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLDDElement                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLDTElement                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLDTElement                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLBRElement                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLBRElement                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLDListElement                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLDListElement             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLHRElement                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLHRElement                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLParaElement                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLParaElement              )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLElementCollection            )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLElementCollection2           )
      CALL_ENUM_FUNC1(IID_IHTMLElementCollection3           )
      CALL_ENUM_FUNC1(DIID_DispHTMLElementCollection        )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLHeaderElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLHeaderElement            )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLSelectElementEvents          )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLSelectElementEvents2         )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLSelectElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLSelectElement2               )
      CALL_ENUM_FUNC1(IID_IHTMLSelectElement4               )
      CALL_ENUM_FUNC1(DIID_DispHTMLSelectElement            )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLSelectionObject              )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLSelectionObject2             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLOptionElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLOptionElement3               )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLOptionElementFactory         )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLOptionElement            )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLButtonElementEvents          )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLButtonElementEvents2         )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLInputTextElementEvents       )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLInputTextElementEvents2      )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLOptionButtonElementEvents    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLOptionButtonElementEvents2   )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLInputFileElementEvents       )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLInputFileElementEvents2      )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLInputImageEvents             )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLInputImageEvents2            )
      CALL_ENUM_FUNC1(IID_IHTMLInputElement                 )
      CALL_ENUM_FUNC1(IID_IHTMLInputElement2                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLInputButtonElement           )
      CALL_ENUM_FUNC1(IID_IHTMLInputHiddenElement           )
      CALL_ENUM_FUNC1(IID_IHTMLInputTextElement             )
      CALL_ENUM_FUNC1(IID_IHTMLInputFileElement             )
      CALL_ENUM_FUNC1(IID_IHTMLOptionButtonElement          )
      CALL_ENUM_FUNC1(IID_IHTMLInputImage                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLInputElement             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTextAreaElement              )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLTextAreaElement          )
      CALL_ENUM_FUNC1(DIID_DispHTMLRichtextElement          )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLButtonElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLButtonElement            )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLMarqueeElementEvents         )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLMarqueeElementEvents2        )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLMarqueeElement               )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLMarqueeElement           )
      CALL_ENUM_FUNC1(IID_IHTMLHtmlElement                  )
      CALL_ENUM_FUNC1(IID_IHTMLHeadElement                  )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTitleElement                 )
      CALL_ENUM_FUNC1(IID_IHTMLMetaElement                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLMetaElement2                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLBaseElement                  )
      CALL_ENUM_FUNC1(IID_IHTMLIsIndexElement               )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLIsIndexElement2              )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLNextIdElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLHtmlElement              )
      CALL_ENUM_FUNC1(DIID_DispHTMLHeadElement              )
      CALL_ENUM_FUNC1(DIID_DispHTMLTitleElement             )
      CALL_ENUM_FUNC1(DIID_DispHTMLMetaElement              )
      CALL_ENUM_FUNC1(DIID_DispHTMLBaseElement              )
      CALL_ENUM_FUNC1(DIID_DispHTMLIsIndexElement           )
      CALL_ENUM_FUNC1(DIID_DispHTMLNextIdElement            )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLBaseFontElement              )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLBaseFontElement          )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLUnknownElement               )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLUnknownElement           )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IOmHistory                        )
      CALL_ENUM_FUNC1(IID_IHTMLMimeTypesCollection          )
      CALL_ENUM_FUNC1(IID_IHTMLPluginsCollection            )
      CALL_ENUM_FUNC1(IID_IHTMLOpsProfile                   )
      CALL_ENUM_FUNC1(IID_IOmNavigator                      )
      CALL_ENUM_FUNC1(IID_IHTMLLocation                     )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLBookmarkCollection           )
      CALL_ENUM_FUNC1(IID_IHTMLDataTransfer                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLEventObj                     )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLEventObj2                    )
      CALL_ENUM_FUNC1(IID_IHTMLEventObj3                    )
      CALL_ENUM_FUNC1(IID_IHTMLEventObj4                    )
      CALL_ENUM_FUNC1(DIID_DispCEventObj                    )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLWindowEvents                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLWindowEvents2                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLDocument                     )
      CALL_ENUM_FUNC1(IID_IHTMLDocument2                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLDocument3                    )
      CALL_ENUM_FUNC1(IID_IHTMLDocument4                    )
      CALL_ENUM_FUNC1(IID_IHTMLDocument5                    )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFramesCollection2            )
      CALL_ENUM_FUNC1(IID_IHTMLWindow2                      )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLWindow3                      )
      CALL_ENUM_FUNC1(IID_IHTMLWindow4                      )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLScreen                       )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLScreen2                      )
      CALL_ENUM_FUNC1(DIID_DispHTMLScreen                   )
      CALL_ENUM_FUNC1(DIID_DispHTMLWindow2                  )
      CALL_ENUM_FUNC1(DIID_DispHTMLWindowProxy              )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLDocumentEvents               )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLDocumentEvents2              )
      CALL_ENUM_FUNC1(DIID_DispHTMLDocument                 )
      CALL_ENUM_FUNC1(DIID_DWebBridgeEvents                 )
      CALL_ENUM_FUNC1(IID_IWebBridge                        )
      CALL_ENUM_FUNC1(IID_IWBScriptControl                  )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLEmbedElement                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLEmbed                    )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLMapEvents                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLMapEvents2                   )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLAreasCollection              )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLAreasCollection2             )
      CALL_ENUM_FUNC1(IID_IHTMLAreasCollection3             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLMapElement                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLAreasCollection          )
      CALL_ENUM_FUNC1(DIID_DispHTMLMapElement               )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLAreaEvents                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLAreaEvents2                  )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLAreaElement                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLAreaElement              )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTableCaption                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLTableCaption             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLCommentElement               )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLCommentElement2              )
      CALL_ENUM_FUNC1(DIID_DispHTMLCommentElement           )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLPhraseElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLPhraseElement2               )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLSpanElement                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLPhraseElement            )
      CALL_ENUM_FUNC1(DIID_DispHTMLSpanElement              )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLTableEvents                  )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLTableEvents2                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTable                        )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTable2                       )
      CALL_ENUM_FUNC1(IID_IHTMLTable3                       )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTableCol                     )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTableCol2                    )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTableSection                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTableSection2                )
      CALL_ENUM_FUNC1(IID_IHTMLTableSection3                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTableRow                     )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTableRow2                    )
      CALL_ENUM_FUNC1(IID_IHTMLTableRow3                    )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTableCell                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLTableCell2                   )
      CALL_ENUM_FUNC1(DIID_DispHTMLTable                    )
      CALL_ENUM_FUNC1(DIID_DispHTMLTableCol                 )
      CALL_ENUM_FUNC1(DIID_DispHTMLTableSection             )
      CALL_ENUM_FUNC1(DIID_DispHTMLTableRow                 )
      CALL_ENUM_FUNC1(DIID_DispHTMLTableCell                )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLScriptEvents                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLScriptEvents2                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLScriptElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLScriptElement2               )
      CALL_ENUM_FUNC1(DIID_DispHTMLScriptElement            )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLNoShowElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLNoShowElement            )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLObjectElementEvents          )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLObjectElementEvents2         )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLObjectElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLObjectElement2               )
      CALL_ENUM_FUNC1(IID_IHTMLObjectElement3               )
      CALL_ENUM_FUNC1(IID_IHTMLParamElement                 )
      CALL_ENUM_FUNC1(DIID_DispHTMLObjectElement            )
      CALL_ENUM_FUNC1(DIID_DispHTMLParamElement             )
      CALL_ENUM_FUNC1(DIID_HTMLFrameSiteEvents              )
      CALL_ENUM_FUNC1(DIID_HTMLFrameSiteEvents2             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFrameBase                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFrameBase2                   )
      CALL_ENUM_FUNC1(IID_IHTMLFrameBase3                   )
      CALL_ENUM_FUNC1(DIID_DispHTMLFrameBase                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFrameElement                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFrameElement2                )
      CALL_ENUM_FUNC1(DIID_DispHTMLFrameElement             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLIFrameElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLIFrameElement2               )
      CALL_ENUM_FUNC1(DIID_DispHTMLIFrame                   )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLDivPosition                  )
      CALL_ENUM_FUNC1(IID_IHTMLFieldSetElement              )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFieldSetElement2             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLLegendElement                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLLegendElement2               )
      CALL_ENUM_FUNC1(DIID_DispHTMLDivPosition              )
      CALL_ENUM_FUNC1(DIID_DispHTMLFieldSetElement          )
      CALL_ENUM_FUNC1(DIID_DispHTMLLegendElement            )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLSpanFlow                     )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLSpanFlow                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFrameSetElement              )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFrameSetElement2             )
      CALL_ENUM_FUNC1(DIID_DispHTMLFrameSetSite             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLBGsound                      )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLBGsound                  )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLFontNamesCollection          )
      CALL_ENUM_FUNC1(IID_IHTMLFontSizesCollection          )
      CALL_ENUM_FUNC1(IID_IHTMLOptionsHolder                )
      CALL_ENUM_FUNC1(DIID_HTMLStyleElementEvents           )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_HTMLStyleElementEvents2          )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLStyleElement                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DispHTMLStyleElement             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLStyleFontFace                )
      CALL_ENUM_FUNC1(IID_ICSSFilterSite                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IMarkupContainer                  )
      CALL_ENUM_FUNC1(IID_IMarkupContainer2                 )
      CALL_ENUM_FUNC1(IID_IHTMLChangeLog                    )
      CALL_ENUM_FUNC1(IID_IHTMLChangeSink                   )
      CALL_ENUM_FUNC1(IID_IActiveIMMApp                     ) //    <MsHTML.h>   <Dimm.h>
      CALL_ENUM_FUNC1(IID_ISegmentList                      )
      CALL_ENUM_FUNC1(IID_ISegmentListIterator              )
      CALL_ENUM_FUNC1(IID_IHTMLCaret                        )
      CALL_ENUM_FUNC1(IID_ISegment                          )
      CALL_ENUM_FUNC1(IID_IElementSegment                   )
      CALL_ENUM_FUNC1(IID_IHighlightSegment                 )
      CALL_ENUM_FUNC1(IID_IHighlightRenderingServices       )
      CALL_ENUM_FUNC1(IID_ILineInfo                         )
      CALL_ENUM_FUNC1(IID_IDisplayPointer                   )
      CALL_ENUM_FUNC1(IID_IDisplayServices                  )
      CALL_ENUM_FUNC1(IID_IHtmlDlgSafeHelper                )
      CALL_ENUM_FUNC1(IID_IBlockFormats                     )
      CALL_ENUM_FUNC1(IID_IFontNames                        )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_ICSSFilter                        )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_ISecureUrlHost                    )
      CALL_ENUM_FUNC1(IID_IMarkupServices                   )
      CALL_ENUM_FUNC1(IID_IMarkupServices2                  )
      CALL_ENUM_FUNC1(IID_IHTMLChangePlayback               )
      CALL_ENUM_FUNC1(IID_IMarkupPointer                    )
      CALL_ENUM_FUNC1(IID_IMarkupPointer2                   )
      CALL_ENUM_FUNC1(IID_IMarkupTextFrags                  )
      CALL_ENUM_FUNC1(IID_IXMLGenericParse                  )
      CALL_ENUM_FUNC1(IID_IHTMLEditHost                     )
      CALL_ENUM_FUNC1(IID_IHTMLEditHost2                    )
      CALL_ENUM_FUNC1(IID_ISequenceNumber                   )
      CALL_ENUM_FUNC1(IID_IIMEServices                      )
      CALL_ENUM_FUNC1(IID_ISelectionServicesListener        )
      CALL_ENUM_FUNC1(IID_ISelectionServices                )
      CALL_ENUM_FUNC1(IID_IHTMLEditDesigner                 )
      CALL_ENUM_FUNC1(IID_IHTMLEditServices                 )
      CALL_ENUM_FUNC1(IID_IHTMLEditServices2                )
      CALL_ENUM_FUNC1(DIID_HTMLNamespaceEvents              )
      CALL_ENUM_FUNC1(IID_IHTMLNamespace                    )
      CALL_ENUM_FUNC1(IID_IHTMLNamespaceCollection          )
      CALL_ENUM_FUNC1(IID_IHTMLPainter                      )
      CALL_ENUM_FUNC1(IID_IHTMLPaintSite                    )
      CALL_ENUM_FUNC1(IID_IHTMLPainterEventInfo             )
      CALL_ENUM_FUNC1(IID_IHTMLPainterOverlay               )
      CALL_ENUM_FUNC1(IID_IHTMLIPrintCollection             )
      CALL_ENUM_FUNC1(IID_IEnumPrivacyRecords               )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLDialog                       )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHTMLDialog2                      )
      CALL_ENUM_FUNC1(IID_IHTMLDialog3                      )
      CALL_ENUM_FUNC1(IID_IHTMLModelessInit                 )
      CALL_ENUM_FUNC1(IID_IHTMLPopup                        )
      CALL_ENUM_FUNC1(DIID_DispHTMLPopup                    )
      CALL_ENUM_FUNC1(IID_IHTMLAppBehavior                  )
      CALL_ENUM_FUNC1(IID_IHTMLAppBehavior2                 )
      CALL_ENUM_FUNC1(IID_IHTMLAppBehavior3                 )
      CALL_ENUM_FUNC1(DIID_DispHTMLAppBehavior              )
#endif // __SDK__
      CALL_ENUM_FUNC1(DIID_DispIHTMLInputButtonElement      )
      CALL_ENUM_FUNC1(DIID_DispIHTMLInputTextElement        )
      CALL_ENUM_FUNC1(DIID_DispIHTMLInputFileElement        )
      CALL_ENUM_FUNC1(DIID_DispIHTMLOptionButtonElement     )
      CALL_ENUM_FUNC1(DIID_DispIHTMLInputImage              )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IElementNamespace                 )
      CALL_ENUM_FUNC1(IID_IElementNamespaceTable            )
      CALL_ENUM_FUNC1(IID_IElementNamespaceFactory          )
      CALL_ENUM_FUNC1(IID_IElementNamespaceFactory2         )
      CALL_ENUM_FUNC1(IID_IElementNamespaceFactoryCallback  )
      CALL_ENUM_FUNC1(IID_IElementBehaviorSiteOM            )
      CALL_ENUM_FUNC1(IID_IElementBehaviorSiteOM2           )
      CALL_ENUM_FUNC1(IID_IElementBehaviorCategory          )
      CALL_ENUM_FUNC1(IID_IElementBehaviorSiteCategory      )
      CALL_ENUM_FUNC1(IID_IElementBehaviorSubmit            )
      CALL_ENUM_FUNC1(IID_IElementBehaviorFocus             )
      CALL_ENUM_FUNC1(IID_IElementBehaviorLayout            )
      CALL_ENUM_FUNC1(IID_IElementBehaviorLayout2           )
      CALL_ENUM_FUNC1(IID_IElementBehaviorSiteLayout        )
      CALL_ENUM_FUNC1(IID_IElementBehaviorSiteLayout2       )
      CALL_ENUM_FUNC1(IID_IHostBehaviorInit                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IAsyncMoniker                     )
      CALL_ENUM_FUNC1(CLSID_StdURLMoniker                   )
      CALL_ENUM_FUNC1(CLSID_HttpProtocol                    )
      CALL_ENUM_FUNC1(CLSID_FtpProtocol                     )
      CALL_ENUM_FUNC1(CLSID_GopherProtocol                  )
      CALL_ENUM_FUNC1(CLSID_HttpSProtocol                   )
      CALL_ENUM_FUNC1(CLSID_FileProtocol                    )
      CALL_ENUM_FUNC1(CLSID_MkProtocol                      )
      CALL_ENUM_FUNC1(CLSID_StdURLProtocol                  )
      CALL_ENUM_FUNC1(CLSID_UrlMkBindCtx                    )
      CALL_ENUM_FUNC1(CLSID_StdEncodingFilterFac            )
      CALL_ENUM_FUNC1(CLSID_DeCompMimeFilter                )
      CALL_ENUM_FUNC1(CLSID_CdlProtocol                     )
      CALL_ENUM_FUNC1(CLSID_ClassInstallFilter              )
      CALL_ENUM_FUNC1(IID_IAsyncBindCtx                     )
      CALL_ENUM_FUNC1(IID_IPersistMoniker                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IMonikerProp                      )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IBindProtocol                     )
      CALL_ENUM_FUNC1(IID_IBinding                          )
      CALL_ENUM_FUNC1(IID_IBindStatusCallback               )
      CALL_ENUM_FUNC1(IID_IAuthenticate                     )
      CALL_ENUM_FUNC1(IID_IHttpNegotiate                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IHttpNegotiate2                   )
      CALL_ENUM_FUNC1(IID_IWinInetFileStream                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IWindowForBindingUI               )
      CALL_ENUM_FUNC1(IID_ICodeInstall                      )
      CALL_ENUM_FUNC1(IID_IWinInetInfo                      )
      CALL_ENUM_FUNC1(IID_IHttpSecurity                     )
      CALL_ENUM_FUNC1(IID_IWinInetHttpInfo                  )
      CALL_ENUM_FUNC1(IID_IBindHost                         )
      CALL_ENUM_FUNC1(IID_IInternet                         )
      CALL_ENUM_FUNC1(IID_IInternetBindInfo                 )
      CALL_ENUM_FUNC1(IID_IInternetProtocolRoot             )
      CALL_ENUM_FUNC1(IID_IInternetProtocol                 )
      CALL_ENUM_FUNC1(IID_IInternetProtocolSink             )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IInternetProtocolSinkStackable    )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IInternetSession                  )
      CALL_ENUM_FUNC1(IID_IInternetThreadSwitch             )
      CALL_ENUM_FUNC1(IID_IInternetPriority                 )
      CALL_ENUM_FUNC1(IID_IInternetProtocolInfo             )
      CALL_ENUM_FUNC1(CLSID_InternetSecurityManager         )
      CALL_ENUM_FUNC1(CLSID_InternetZoneManager             )
      CALL_ENUM_FUNC1(SID_SInternetSecurityManager          )
      CALL_ENUM_FUNC1(SID_SInternetHostSecurityManager      )
      CALL_ENUM_FUNC1(IID_IInternetSecurityMgrSite          )
      CALL_ENUM_FUNC1(IID_IInternetSecurityManager          )
      CALL_ENUM_FUNC1(IID_IInternetHostSecurityManager      )
      CALL_ENUM_FUNC1(IID_IInternetZoneManager              )
      CALL_ENUM_FUNC1(CLSID_SoftDistExt                     )
      CALL_ENUM_FUNC1(IID_ISoftDistExt                      )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_ICatalogFileInfo                  )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IDataFilter                       )
      CALL_ENUM_FUNC1(IID_IEncodingFilterFactory            )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IWrappedProtocol                  )
#endif // __SDK__
      CALL_ENUM_FUNC1(SID_IBindHost                         )
      CALL_ENUM_FUNC1(SID_SBindHost                         )
      CALL_ENUM_FUNC1(LIBID_SHDocVw                         )
      CALL_ENUM_FUNC1(IID_IWebBrowser                       )
      CALL_ENUM_FUNC1(IID_IWebBrowser2                      )
      CALL_ENUM_FUNC1(DIID_DWebBrowserEvents                )
      CALL_ENUM_FUNC1(DIID_DWebBrowserEvents2               )
      CALL_ENUM_FUNC1(DIID_DShellWindowsEvents              )
      CALL_ENUM_FUNC1(IID_IShellWindows                     )
      CALL_ENUM_FUNC1(IID_IShellUIHelper                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(DIID_DShellNameSpaceEvents            )
      CALL_ENUM_FUNC1(IID_IShellFavoritesNameSpace          )
      CALL_ENUM_FUNC1(IID_IShellNameSpace                   )
      CALL_ENUM_FUNC1(IID_IScriptErrorList                  )
      CALL_ENUM_FUNC1(IID_ISearch                           )
      CALL_ENUM_FUNC1(IID_ISearches                         )
      CALL_ENUM_FUNC1(IID_ISearchAssistantOC                )
      CALL_ENUM_FUNC1(IID_ISearchAssistantOC2               )
      CALL_ENUM_FUNC1(IID_ISearchAssistantOC3               )
      CALL_ENUM_FUNC1(DIID__SearchAssistantEvents           )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_WebBrowser_V1                   )
      CALL_ENUM_FUNC1(CLSID_WebBrowser                      )
      CALL_ENUM_FUNC1(CLSID_InternetExplorer                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_ShellBrowserWindow              )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_ShellWindows                    )
      CALL_ENUM_FUNC1(CLSID_ShellUIHelper                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_ShellNameSpace                  )
      CALL_ENUM_FUNC1(CLSID_CScriptErrorList                )
      CALL_ENUM_FUNC1(CLSID_SearchAssistantOC               )
#endif // __SDK__

      CALL_ENUM_FUNC1(CMDSETID_Forms3                       )
      CALL_ENUM_FUNC1(CLSID_MHTMLDocument                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HTADocument                     )
      CALL_ENUM_FUNC1(CLSID_HTMLApplication                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLPluginDocument              )

    //CALL_ENUM_FUNC1(SID_SEditCommandTarget                )
    //CALL_ENUM_FUNC1(CGID_EditStateCommands                )
    //CALL_ENUM_FUNC1(SID_SHTMLEditHost                     )

#ifdef __SDK__
      CALL_ENUM_FUNC1(SID_SHTMLEditServices                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(SID_SHTMLWindow                       )
#ifdef __SDK__
      CALL_ENUM_FUNC1(SID_SElementBehaviorFactory           )
#endif // __SDK__

    //CALL_ENUM_FUNC1(CLSID_CStyle                          )
    //CALL_ENUM_FUNC1(CLSID_CRuleStyle                      )
    //CALL_ENUM_FUNC1(CLSID_CRenderStyle                    )
    //CALL_ENUM_FUNC1(CLSID_CCurrentStyle                   )
    //CALL_ENUM_FUNC1(CLSID_CAttribute                      )
    //CALL_ENUM_FUNC1(CLSID_CDOMTextNode                    )
    //CALL_ENUM_FUNC1(CLSID_CDOMImplementation              )
    //CALL_ENUM_FUNC1(CLSID_CAttrCollectionator             )
    //CALL_ENUM_FUNC1(CLSID_CDOMChildrenCollection          )
    //CALL_ENUM_FUNC1(CLSID_CDefaults                       )
    //CALL_ENUM_FUNC1(CLSID_CHtmlComponentDD                )
    //CALL_ENUM_FUNC1(CLSID_CHtmlComponentProperty          )
    //CALL_ENUM_FUNC1(CLSID_CHtmlComponentMethod            )
    //CALL_ENUM_FUNC1(CLSID_CHtmlComponentEvent             )
    //CALL_ENUM_FUNC1(CLSID_CHtmlComponentAttach            )
    //CALL_ENUM_FUNC1(CLSID_CHtmlComponentDesc              )
    //CALL_ENUM_FUNC1(CLSID_CPeerUrnCollection              )
    //CALL_ENUM_FUNC1(CLSID_CGenericElement                 )
    //CALL_ENUM_FUNC1(CLSID_CStyleSheetRule                 )
    //CALL_ENUM_FUNC1(CLSID_CStyleSheetRuleArray            )
    //CALL_ENUM_FUNC1(CLSID_CStyleSheetPage                 )
    //CALL_ENUM_FUNC1(CLSID_CStyleSheetPageArray            )
    //CALL_ENUM_FUNC1(CLSID_CStyleSheet                     )
    //CALL_ENUM_FUNC1(CLSID_CStyleSheetArray                )
    //CALL_ENUM_FUNC1(CLSID_CLinkElement                    )
    //CALL_ENUM_FUNC1(CLSID_CFormElement                    )
    //CALL_ENUM_FUNC1(CLSID_CTextElement                    )
    //CALL_ENUM_FUNC1(CLSID_CImgElement                     )
    //CALL_ENUM_FUNC1(CLSID_CImageElementFactory            )
    //CALL_ENUM_FUNC1(CLSID_CBodyElement                    )
    //CALL_ENUM_FUNC1(CLSID_CFontElement                    )
    //CALL_ENUM_FUNC1(CLSID_CAnchorElement                  )
    //CALL_ENUM_FUNC1(CLSID_CLabelElement                   )
    //CALL_ENUM_FUNC1(CLSID_CListElement                    )
    //CALL_ENUM_FUNC1(CLSID_CUListElement                   )
    //CALL_ENUM_FUNC1(CLSID_COListElement                   )
    //CALL_ENUM_FUNC1(CLSID_CLIElement                      )
    //CALL_ENUM_FUNC1(CLSID_CBlockElement                   )
    //CALL_ENUM_FUNC1(CLSID_CDivElement                     )
    //CALL_ENUM_FUNC1(CLSID_CDDElement                      )
    //CALL_ENUM_FUNC1(CLSID_CDTElement                      )
    //CALL_ENUM_FUNC1(CLSID_CBRElement                      )
    //CALL_ENUM_FUNC1(CLSID_CDListElement                   )
    //CALL_ENUM_FUNC1(CLSID_CHRElement                      )
    //CALL_ENUM_FUNC1(CLSID_CParaElement                    )
    //CALL_ENUM_FUNC1(CLSID_CElementCollection              )
    //CALL_ENUM_FUNC1(CLSID_CHeaderElement                  )
    //CALL_ENUM_FUNC1(CLSID_CSelectElement                  )
    //CALL_ENUM_FUNC1(CLSID_COptionElement                  )
    //CALL_ENUM_FUNC1(CLSID_COptionElementFactory           )
    //CALL_ENUM_FUNC1(CLSID_CInput                          )
    //CALL_ENUM_FUNC1(CLSID_CTextArea                       )
    //CALL_ENUM_FUNC1(CLSID_CRichtext                       )
    //CALL_ENUM_FUNC1(CLSID_CButton                         )
    //CALL_ENUM_FUNC1(CLSID_CMarquee                        )
    //CALL_ENUM_FUNC1(CLSID_CHtmlElement                    )
    //CALL_ENUM_FUNC1(CLSID_CHeadElement                    )
    //CALL_ENUM_FUNC1(CLSID_CTitleElement                   )
    //CALL_ENUM_FUNC1(CLSID_CMetaElement                    )
    //CALL_ENUM_FUNC1(CLSID_CBaseElement                    )
    //CALL_ENUM_FUNC1(CLSID_CIsIndexElement                 )
    //CALL_ENUM_FUNC1(CLSID_CNextIdElement                  )
    //CALL_ENUM_FUNC1(CLSID_CBaseFontElement                )
    //CALL_ENUM_FUNC1(CLSID_CUnknownElement                 )
    //CALL_ENUM_FUNC1(CLSID_COmHistory                      )
    //CALL_ENUM_FUNC1(CLSID_COmNavigator                    )
    //CALL_ENUM_FUNC1(CLSID_COmLocation                     )
    //CALL_ENUM_FUNC1(CLSID_CFramesCollection               )
    //CALL_ENUM_FUNC1(CLSID_CScreen                         )
    //CALL_ENUM_FUNC1(CLSID_CWindow                         )
    //CALL_ENUM_FUNC1(CLSID_COmWindowProxy                  )
    //CALL_ENUM_FUNC1(CLSID_CDocument                       )
    //CALL_ENUM_FUNC1(CLSID_CScriptlet                      )
    //CALL_ENUM_FUNC1(CLSID_CPluginSite                     )
    //CALL_ENUM_FUNC1(CLSID_CAreasCollection                )
    //CALL_ENUM_FUNC1(CLSID_CMapElement                     )
    //CALL_ENUM_FUNC1(CLSID_CAreaElement                    )
    //CALL_ENUM_FUNC1(CLSID_CTableCaption                   )
    //CALL_ENUM_FUNC1(CLSID_CCommentElement                 )
    //CALL_ENUM_FUNC1(CLSID_CPhraseElement                  )
    //CALL_ENUM_FUNC1(CLSID_CSpanElement                    )
    //CALL_ENUM_FUNC1(CLSID_CTable                          )
    //CALL_ENUM_FUNC1(CLSID_CTableCol                       )
    //CALL_ENUM_FUNC1(CLSID_CTableSection                   )
    //CALL_ENUM_FUNC1(CLSID_CTableRow                       )
    //CALL_ENUM_FUNC1(CLSID_CTableCell                      )
    //CALL_ENUM_FUNC1(CLSID_CScriptElement                  )
    //CALL_ENUM_FUNC1(CLSID_CNoShowElement                  )
    //CALL_ENUM_FUNC1(CLSID_CObjectElement                  )
    //CALL_ENUM_FUNC1(CLSID_CParamElement                   )
    //CALL_ENUM_FUNC1(CLSID_CFrameSite                      )
    //CALL_ENUM_FUNC1(CLSID_CFrameElement                   )
    //CALL_ENUM_FUNC1(CLSID_CIFrameElement                  )
    //CALL_ENUM_FUNC1(CLSID_C1DElement                      )
    //CALL_ENUM_FUNC1(CLSID_CFieldSetElement                )
    //CALL_ENUM_FUNC1(CLSID_CLegendElement                  )
    //CALL_ENUM_FUNC1(CLSID_CSpanSite                       )
    //CALL_ENUM_FUNC1(CLSID_CFrameSetSite                   )
    //CALL_ENUM_FUNC1(CLSID_CBGsound                        )
    //CALL_ENUM_FUNC1(CLSID_CStyleElement                   )
    //CALL_ENUM_FUNC1(CLSID_CFontFace                       )
    //CALL_ENUM_FUNC1(CLSID_CHTMLNamespace                  )
    //CALL_ENUM_FUNC1(CLSID_CHTMLNamespaceCollection        )
    //CALL_ENUM_FUNC1(CLSID_CThreadDialogProcParam          )
    //CALL_ENUM_FUNC1(CLSID_CHTMLDlg                        )
    //CALL_ENUM_FUNC1(CLSID_CHTMLPopup                      )
    //CALL_ENUM_FUNC1(CLSID_CAppBehavior                    )

    //CALL_ENUM_FUNC1(SID_BindHost                          )

    //CALL_ENUM_FUNC1(CLSID_SBS_StdURLMoniker               )
    //CALL_ENUM_FUNC1(CLSID_SBS_HttpProtocol                )
    //CALL_ENUM_FUNC1(CLSID_SBS_FtpProtocol                 )
    //CALL_ENUM_FUNC1(CLSID_SBS_GopherProtocol              )
    //CALL_ENUM_FUNC1(CLSID_SBS_HttpSProtocol               )
    //CALL_ENUM_FUNC1(CLSID_SBS_FileProtocol                )
    //CALL_ENUM_FUNC1(CLSID_SBS_MkProtocol                  )
    //CALL_ENUM_FUNC1(CLSID_SBS_UrlMkBindCtx                )
    //CALL_ENUM_FUNC1(CLSID_SBS_SoftDistExt                 )
    //CALL_ENUM_FUNC1(CLSID_SBS_StdEncodingFilterFac        )
    //CALL_ENUM_FUNC1(CLSID_SBS_DeCompMimeFilter            )
    //CALL_ENUM_FUNC1(CLSID_SBS_CdlProtocol                 )
    //CALL_ENUM_FUNC1(CLSID_SBS_ClassInstallFilter          )
    //CALL_ENUM_FUNC1(CLSID_SBS_InternetSecurityManager     )
    //CALL_ENUM_FUNC1(CLSID_SBS_InternetZoneManager         )
    //CALL_ENUM_FUNC1(CLSID_LocalCopyHelper                 )
    //CALL_ENUM_FUNC1(BHID_LocalCopyHelper                  )

      CALL_ENUM_FUNC1(CGID_MSHTML                           )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HostDialogHelper                )
      CALL_ENUM_FUNC1(IID_IHostDialogHelper                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IDocHostUIHandler                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IDocHostUIHandler2                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_ICustomDoc                        )
      CALL_ENUM_FUNC1(IID_IDocHostShowUI                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IClassFactoryEx                   )
#endif // __SDK__

      CALL_ENUM_FUNC1(IID_ICreateTypeInfo                   )
      CALL_ENUM_FUNC1(IID_ICreateTypeInfo2                  )
      CALL_ENUM_FUNC1(IID_ICreateTypeLib                    )
      CALL_ENUM_FUNC1(IID_ICreateTypeLib2                   )
      CALL_ENUM_FUNC1(IID_IDispatch                         )
      CALL_ENUM_FUNC1(IID_IEnumVARIANT                      )
      CALL_ENUM_FUNC1(IID_ITypeComp                         )
      CALL_ENUM_FUNC1(IID_ITypeInfo                         )
      CALL_ENUM_FUNC1(IID_ITypeInfo2                        )
      CALL_ENUM_FUNC1(IID_ITypeLib                          )
      CALL_ENUM_FUNC1(IID_ITypeLib2                         )
      CALL_ENUM_FUNC1(IID_ITypeChangeEvents                 )
      CALL_ENUM_FUNC1(IID_IErrorInfo                        )
      CALL_ENUM_FUNC1(IID_ICreateErrorInfo                  )
      CALL_ENUM_FUNC1(IID_ISupportErrorInfo                 )
      CALL_ENUM_FUNC1(IID_ITypeFactory                      )
      CALL_ENUM_FUNC1(IID_ITypeMarshal                      )
      CALL_ENUM_FUNC1(IID_IRecordInfo                       )
      CALL_ENUM_FUNC1(IID_IErrorLog                         )

      CALL_ENUM_FUNC1(CLSID_HTMLStyle                       )
      CALL_ENUM_FUNC1(CLSID_HTMLRuleStyle                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLRenderStyle                 )
      CALL_ENUM_FUNC1(CLSID_HTMLCurrentStyle                )
      CALL_ENUM_FUNC1(CLSID_HTMLDOMAttribute                )
      CALL_ENUM_FUNC1(CLSID_HTMLDOMTextNode                 )
      CALL_ENUM_FUNC1(CLSID_HTMLDOMImplementation           )
      CALL_ENUM_FUNC1(CLSID_HTMLAttributeCollection         )
      CALL_ENUM_FUNC1(CLSID_DOMChildrenCollection           )
      CALL_ENUM_FUNC1(CLSID_HTMLDefaults                    )
      CALL_ENUM_FUNC1(CLSID_HTCDefaultDispatch              )
      CALL_ENUM_FUNC1(CLSID_HTCPropertyBehavior             )
      CALL_ENUM_FUNC1(CLSID_HTCMethodBehavior               )
      CALL_ENUM_FUNC1(CLSID_HTCEventBehavior                )
      CALL_ENUM_FUNC1(CLSID_HTCAttachBehavior               )
      CALL_ENUM_FUNC1(CLSID_HTCDescBehavior                 )
      CALL_ENUM_FUNC1(CLSID_HTMLUrnCollection               )
      CALL_ENUM_FUNC1(CLSID_HTMLGenericElement              )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLStyleSheetRule              )
      CALL_ENUM_FUNC1(CLSID_HTMLStyleSheetRulesCollection   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLStyleSheetPage              )
      CALL_ENUM_FUNC1(CLSID_HTMLStyleSheetPagesCollection   )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLStyleSheet                  )
      CALL_ENUM_FUNC1(CLSID_HTMLStyleSheetsCollection       )
      CALL_ENUM_FUNC1(CLSID_HTMLLinkElement                 )
      CALL_ENUM_FUNC1(CLSID_HTMLFormElement                 )
      CALL_ENUM_FUNC1(CLSID_HTMLTextElement                 )
      CALL_ENUM_FUNC1(CLSID_HTMLImg                         )
      CALL_ENUM_FUNC1(CLSID_HTMLImageElementFactory         )
      CALL_ENUM_FUNC1(CLSID_HTMLBody                        )
      CALL_ENUM_FUNC1(CLSID_HTMLFontElement                 )
      CALL_ENUM_FUNC1(CLSID_HTMLAnchorElement               )
      CALL_ENUM_FUNC1(CLSID_HTMLLabelElement                )
      CALL_ENUM_FUNC1(CLSID_HTMLListElement                 )
      CALL_ENUM_FUNC1(CLSID_HTMLUListElement                )
      CALL_ENUM_FUNC1(CLSID_HTMLOListElement                )
      CALL_ENUM_FUNC1(CLSID_HTMLLIElement                   )
      CALL_ENUM_FUNC1(CLSID_HTMLBlockElement                )
      CALL_ENUM_FUNC1(CLSID_HTMLDivElement                  )
      CALL_ENUM_FUNC1(CLSID_HTMLDDElement                   )
      CALL_ENUM_FUNC1(CLSID_HTMLDTElement                   )
      CALL_ENUM_FUNC1(CLSID_HTMLBRElement                   )
      CALL_ENUM_FUNC1(CLSID_HTMLDListElement                )
      CALL_ENUM_FUNC1(CLSID_HTMLHRElement                   )
      CALL_ENUM_FUNC1(CLSID_HTMLParaElement                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLElementCollection           )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLHeaderElement               )
      CALL_ENUM_FUNC1(CLSID_HTMLSelectElement               )
      CALL_ENUM_FUNC1(CLSID_HTMLOptionElement               )
      CALL_ENUM_FUNC1(CLSID_HTMLOptionElementFactory        )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLInputElement                )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLTextAreaElement             )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLRichtextElement             )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLButtonElement               )
      CALL_ENUM_FUNC1(CLSID_HTMLMarqueeElement              )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLHtmlElement                 )
      CALL_ENUM_FUNC1(CLSID_HTMLHeadElement                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLTitleElement                )
      CALL_ENUM_FUNC1(CLSID_HTMLMetaElement                 )
      CALL_ENUM_FUNC1(CLSID_HTMLBaseElement                 )
      CALL_ENUM_FUNC1(CLSID_HTMLIsIndexElement              )
      CALL_ENUM_FUNC1(CLSID_HTMLNextIdElement               )
      CALL_ENUM_FUNC1(CLSID_HTMLBaseFontElement             )
      CALL_ENUM_FUNC1(CLSID_HTMLUnknownElement              )
      CALL_ENUM_FUNC1(CLSID_HTMLHistory                     )
      CALL_ENUM_FUNC1(CLSID_CMimeTypes                      )
      CALL_ENUM_FUNC1(CLSID_CPlugins                        )
      CALL_ENUM_FUNC1(CLSID_COpsProfile                     )
      CALL_ENUM_FUNC1(CLSID_HTMLNavigator                   )
      CALL_ENUM_FUNC1(CLSID_HTMLLocation                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_CEventObj                       )
      CALL_ENUM_FUNC1(CLSID_FramesCollection                )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLScreen                      )
      CALL_ENUM_FUNC1(CLSID_HTMLWindow2                     )
      CALL_ENUM_FUNC1(CLSID_HTMLWindowProxy                 )
      CALL_ENUM_FUNC1(CLSID_HTMLDocument                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_Scriptlet                       )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLEmbed                       )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLAreasCollection             )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLMapElement                  )
      CALL_ENUM_FUNC1(CLSID_HTMLAreaElement                 )
      CALL_ENUM_FUNC1(CLSID_HTMLTableCaption                )
      CALL_ENUM_FUNC1(CLSID_HTMLCommentElement              )
      CALL_ENUM_FUNC1(CLSID_HTMLPhraseElement               )
      CALL_ENUM_FUNC1(CLSID_HTMLSpanElement                 )
      CALL_ENUM_FUNC1(CLSID_HTMLTable                       )
      CALL_ENUM_FUNC1(CLSID_HTMLTableCol                    )
      CALL_ENUM_FUNC1(CLSID_HTMLTableSection                )
      CALL_ENUM_FUNC1(CLSID_HTMLTableRow                    )
      CALL_ENUM_FUNC1(CLSID_HTMLTableCell                   )
      CALL_ENUM_FUNC1(CLSID_HTMLScriptElement               )
      CALL_ENUM_FUNC1(CLSID_HTMLNoShowElement               )
      CALL_ENUM_FUNC1(CLSID_HTMLObjectElement               )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLParamElement                )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLFrameBase                   )
      CALL_ENUM_FUNC1(CLSID_HTMLFrameElement                )
      CALL_ENUM_FUNC1(CLSID_HTMLIFrame                      )
      CALL_ENUM_FUNC1(CLSID_HTMLDivPosition                 )
      CALL_ENUM_FUNC1(CLSID_HTMLFieldSetElement             )
      CALL_ENUM_FUNC1(CLSID_HTMLLegendElement               )
      CALL_ENUM_FUNC1(CLSID_HTMLSpanFlow                    )
      CALL_ENUM_FUNC1(CLSID_HTMLFrameSetSite                )
      CALL_ENUM_FUNC1(CLSID_HTMLBGsound                     )
      CALL_ENUM_FUNC1(CLSID_HTMLStyleElement                )
      CALL_ENUM_FUNC1(CLSID_HTMLStyleFontFace               )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HtmlDlgSafeHelper               )
      CALL_ENUM_FUNC1(CLSID_BlockFormats                    )
      CALL_ENUM_FUNC1(CLSID_FontNames                       )
      CALL_ENUM_FUNC1(CLSID_HTMLNamespace                   )
      CALL_ENUM_FUNC1(CLSID_HTMLNamespaceCollection         )
      CALL_ENUM_FUNC1(CLSID_ThreadDialogProcParam           )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLDialog                      )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_HTMLPopup                       )
      CALL_ENUM_FUNC1(CLSID_HTMLAppBehavior                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(CLSID_OldHTMLDocument                 )
      CALL_ENUM_FUNC1(CLSID_OldHTMLFormElement              )
      CALL_ENUM_FUNC1(CLSID_HTMLInputButtonElement          )
      CALL_ENUM_FUNC1(CLSID_HTMLInputTextElement            )
      CALL_ENUM_FUNC1(CLSID_HTMLInputFileElement            )
      CALL_ENUM_FUNC1(CLSID_HTMLOptionButtonElement         )
      CALL_ENUM_FUNC1(CLSID_HTMLInputImage                  )

    //CALL_ENUM_FUNC3(ITargetNotify                         ) // see <vervec.h> - Headers and Libraries for Internet Explorer 5.5
    //CALL_ENUM_FUNC3(ITargetNotify2                        ) // see <vervec.h> - Headers and Libraries for Internet Explorer 5.5
    //CALL_ENUM_FUNC3(ITargetFrame2                         ) // see <vervec.h> - Headers and Libraries for Internet Explorer 5.5
    //CALL_ENUM_FUNC3(ITargetContainer                      ) // see <vervec.h> - Headers and Libraries for Internet Explorer 5.5
    //CALL_ENUM_FUNC3(IVersionVector                        ) // see <vervec.h> - Headers and Libraries for Internet Explorer 5.5
    //CALL_ENUM_FUNC1(SID_SVersionHost                      ) // see <vervec.h> - Headers and Libraries for Internet Explorer 5.5
    //CALL_ENUM_FUNC3(IVersionHost                          ) // see <vervec.h> - Headers and Libraries for Internet Explorer 5.5

      CALL_ENUM_FUNC1(IID_IMarshal                          )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IMarshal2                         )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IMalloc                           )
      CALL_ENUM_FUNC1(IID_IMallocSpy                        )
      CALL_ENUM_FUNC1(IID_IStdMarshalInfo                   )
      CALL_ENUM_FUNC1(IID_IExternalConnection               )
      CALL_ENUM_FUNC1(IID_IMultiQI                          )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_AsyncIMultiQI                     )
      CALL_ENUM_FUNC1(IID_IInternalUnknown                  )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IEnumUnknown                      )
      CALL_ENUM_FUNC1(IID_IBindCtx                          )
      CALL_ENUM_FUNC1(IID_IEnumMoniker                      )
      CALL_ENUM_FUNC1(IID_IRunnableObject                   )
      CALL_ENUM_FUNC1(IID_IRunningObjectTable               )
      CALL_ENUM_FUNC1(IID_IPersist                          )
      CALL_ENUM_FUNC1(IID_IPersistStream                    )
      CALL_ENUM_FUNC1(IID_IMoniker                          )
      CALL_ENUM_FUNC1(IID_IROTData                          )
      CALL_ENUM_FUNC1(IID_IEnumString                       )
      CALL_ENUM_FUNC1(IID_ISequentialStream                 )
      CALL_ENUM_FUNC1(IID_IStream                           )
      CALL_ENUM_FUNC1(IID_IEnumSTATSTG                      )
      CALL_ENUM_FUNC1(IID_IStorage                          )
      CALL_ENUM_FUNC1(IID_IPersistFile                      )
      CALL_ENUM_FUNC1(IID_IPersistStorage                   )
      CALL_ENUM_FUNC1(IID_ILockBytes                        )
      CALL_ENUM_FUNC1(IID_IEnumFORMATETC                    )
      CALL_ENUM_FUNC1(IID_IEnumSTATDATA                     )
      CALL_ENUM_FUNC1(IID_IRootStorage                      )
      CALL_ENUM_FUNC1(IID_IAdviseSink                       )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_AsyncIAdviseSink                  )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IAdviseSink2                      )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_AsyncIAdviseSink2                 )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IDataObject                       )
      CALL_ENUM_FUNC1(IID_IDataAdviseHolder                 )
      CALL_ENUM_FUNC1(IID_IMessageFilter                    )
      CALL_ENUM_FUNC1(IID_IRpcChannelBuffer                 )
      CALL_ENUM_FUNC1(IID_IRpcChannelBuffer2                )
      CALL_ENUM_FUNC1(IID_IRpcChannelBuffer3                )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IAsyncRpcChannelBuffer            )
      CALL_ENUM_FUNC1(IID_IRpcSyntaxNegotiate               )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IRpcProxyBuffer                   )
      CALL_ENUM_FUNC1(IID_IRpcStubBuffer                    )
      CALL_ENUM_FUNC1(IID_IPSFactoryBuffer                  )
    //CALL_ENUM_FUNC3(IChannelHook                          )
    //CALL_ENUM_FUNC3(IClientSecurity                       )
    //CALL_ENUM_FUNC3(IServerSecurity                       )
    //CALL_ENUM_FUNC3(IClassActivator                       )
    //CALL_ENUM_FUNC3(IRpcOptions                           )
      CALL_ENUM_FUNC1(IID_IFillLockBytes                    )
      CALL_ENUM_FUNC1(IID_IProgressNotify                   )
      CALL_ENUM_FUNC1(IID_ILayoutStorage                    )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IBlockingLock                     )
      CALL_ENUM_FUNC1(IID_ITimeAndNoticeControl             )
      CALL_ENUM_FUNC1(IID_IOplockStorage                    )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_ISurrogate                        )
      CALL_ENUM_FUNC1(IID_IGlobalInterfaceTable             )
      CALL_ENUM_FUNC1(IID_IDirectWriterLock                 )
      CALL_ENUM_FUNC1(IID_ISynchronize                      )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_ISynchronizeHandle                )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_ISynchronizeEvent                 )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_ISynchronizeContainer             )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_ISynchronizeMutex                 )
      CALL_ENUM_FUNC1(IID_ICancelMethodCalls                )
      CALL_ENUM_FUNC1(IID_IAsyncManager                     )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_ICallFactory                      )
      CALL_ENUM_FUNC1(IID_IRpcHelper                        )
      CALL_ENUM_FUNC1(IID_IReleaseMarshalBuffers            )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IWaitMultiple                     )
      CALL_ENUM_FUNC1(IID_IUrlMon                           )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IForegroundTransfer               )
      CALL_ENUM_FUNC1(IID_IAddrTrackingControl              )
      CALL_ENUM_FUNC1(IID_IAddrExclusionControl             )
      CALL_ENUM_FUNC1(IID_IPipeByte                         )
      CALL_ENUM_FUNC1(IID_AsyncIPipeByte                    )
      CALL_ENUM_FUNC1(IID_IPipeLong                         )
      CALL_ENUM_FUNC1(IID_AsyncIPipeLong                    )
      CALL_ENUM_FUNC1(IID_IPipeDouble                       )
      CALL_ENUM_FUNC1(IID_AsyncIPipeDouble                  )
      CALL_ENUM_FUNC1(IID_IThumbnailExtractor               )
      CALL_ENUM_FUNC1(IID_IDummyHICONIncluder               )
#endif // __SDK__
    //CALL_ENUM_FUNC3(IEnumContextProps                     )
    //CALL_ENUM_FUNC3(IContext                              )
    //CALL_ENUM_FUNC3(IObjContext                           )
#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IProcessLock                      )
      CALL_ENUM_FUNC1(IID_ISurrogateService                 )
      CALL_ENUM_FUNC1(IID_IComThreadingInfo                 )
      CALL_ENUM_FUNC1(IID_IProcessInitControl               )
#endif // __SDK__
    //CALL_ENUM_FUNC3(IInitializeSpy                        )

    //CALL_ENUM_FUNC1(StdMarshal                            )
    //CALL_ENUM_FUNC1(IdentityUnmarshal                     )
    //CALL_ENUM_FUNC1(InProcFreeMarshaler                   )
    //CALL_ENUM_FUNC1(PSGenObject                           )
    //CALL_ENUM_FUNC1(PSClientSite                          )
    //CALL_ENUM_FUNC1(PSClassObject                         )
    //CALL_ENUM_FUNC1(PSInPlaceActive                       )
    //CALL_ENUM_FUNC1(PSInPlaceFrame                        )
    //CALL_ENUM_FUNC1(PSDragDrop                            )
    //CALL_ENUM_FUNC1(PSBindCtx                             )
    //CALL_ENUM_FUNC1(PSEnumerators                         )
    //CALL_ENUM_FUNC1(Picture_Metafile                      )
    //CALL_ENUM_FUNC1(StaticMetafile                        )
    //CALL_ENUM_FUNC1(Picture_Dib                           )
    //CALL_ENUM_FUNC1(StaticDib                             )
    //CALL_ENUM_FUNC1(Picture_EnhMetafile                   )
    //CALL_ENUM_FUNC1(DCOMAccessControl                     )
    //CALL_ENUM_FUNC1(ShellDesktop                          )
    //CALL_ENUM_FUNC1(ShellLink                             )
    //CALL_ENUM_FUNC1(InternetExplorer                      )
    //CALL_ENUM_FUNC1(StdComponentCategoriesMgr             )
    //CALL_ENUM_FUNC1(WebCrawlerAgent                       )
    //CALL_ENUM_FUNC1(ShellDispatchInproc                   )
    //CALL_ENUM_FUNC1(OldHTMLFormElement                    )
    //CALL_ENUM_FUNC1(CFontPropPage                         )
    //CALL_ENUM_FUNC1(CColorPropPage                        )
    //CALL_ENUM_FUNC1(CPicturePropPage                      )
    //CALL_ENUM_FUNC1(StdFont                               )
    //CALL_ENUM_FUNC1(StdPicture                            )
    //CALL_ENUM_FUNC1(ShellLinkObject                       )
    //CALL_ENUM_FUNC1(HTMLLocation                          )
    //CALL_ENUM_FUNC1(WebViewFolderContents                 )
    //CALL_ENUM_FUNC1(HTMLDocument                          )
    //CALL_ENUM_FUNC1(HTMLPluginDocument                    )
    //CALL_ENUM_FUNC1(CMultiLanguage                        )
    //CALL_ENUM_FUNC1(HTMLImg                               )
    //CALL_ENUM_FUNC1(HTMLSelectElement                     )
    //CALL_ENUM_FUNC1(HTMLTableCell                         )
    //CALL_ENUM_FUNC1(HTMLAnchorElement                     )
    //CALL_ENUM_FUNC1(HTMLDivPosition                       )
    //CALL_ENUM_FUNC1(HTMLBody                              )
    //CALL_ENUM_FUNC1(HTMLOptionElement                     )
    //CALL_ENUM_FUNC1(HTMLObjectElement                     )
    //CALL_ENUM_FUNC1(HTMLFormElement                       )
    //CALL_ENUM_FUNC1(HTMLHRElement                         )
    //CALL_ENUM_FUNC1(HTMLEmbed                             )
    //CALL_ENUM_FUNC1(HTMLUnknownElement                    )
    //CALL_ENUM_FUNC1(HTMLUListElement                      )
    //CALL_ENUM_FUNC1(HTMLTextElement                       )
    //CALL_ENUM_FUNC1(HTMLTable                             )
    //CALL_ENUM_FUNC1(HTMLTableCol                          )
    //CALL_ENUM_FUNC1(HTMLTableRow                          )
    //CALL_ENUM_FUNC1(HTMLPhraseElement                     )
    //CALL_ENUM_FUNC1(HTMLParaElement                       )
    //CALL_ENUM_FUNC1(HTMLOListElement                      )
    //CALL_ENUM_FUNC1(HTMLMapElement                        )
    //CALL_ENUM_FUNC1(HTMLListElement                       )
    //CALL_ENUM_FUNC1(HTMLLIElement                         )
    //CALL_ENUM_FUNC1(HTMLMetaElement                       )
    //CALL_ENUM_FUNC1(HTMLBaseElement                       )
    //CALL_ENUM_FUNC1(HTMLLinkElement                       )
    //CALL_ENUM_FUNC1(HTMLIsIndexElement                    )
    //CALL_ENUM_FUNC1(HTMLNextIdElement                     )
    //CALL_ENUM_FUNC1(HTMLHeaderElement                     )
    //CALL_ENUM_FUNC1(HTMLFontElement                       )
    //CALL_ENUM_FUNC1(HTMLDTElement                         )
    //CALL_ENUM_FUNC1(HTMLDListElement                      )
    //CALL_ENUM_FUNC1(HTMLDivElement                        )
    //CALL_ENUM_FUNC1(HTMLDDElement                         )
    //CALL_ENUM_FUNC1(HTMLBRElement                         )
    //CALL_ENUM_FUNC1(HTMLBlockElement                      )
    //CALL_ENUM_FUNC1(HTMLBaseFontElement                   )
    //CALL_ENUM_FUNC1(HTMLAreaElement                       )
    //CALL_ENUM_FUNC1(HTMLTitleElement                      )
    //CALL_ENUM_FUNC1(HTMLStyle                             )
    //CALL_ENUM_FUNC1(HTMLDialog                            )
    //CALL_ENUM_FUNC1(HTMLScriptElement                     )
    //CALL_ENUM_FUNC1(HTMLInputTextElement                  )
    //CALL_ENUM_FUNC1(HTMLTextAreaElement                   )
    //CALL_ENUM_FUNC1(HTMLInputFileElement                  )
    //CALL_ENUM_FUNC1(HTMLInputButtonElement                )
    //CALL_ENUM_FUNC1(HTMLMarqueeElement                    )
    //CALL_ENUM_FUNC1(HTMLOptionButtonElement               )
    //CALL_ENUM_FUNC1(HTMLInputImage                        )
    //CALL_ENUM_FUNC1(HTMLButtonElement                     )
    //CALL_ENUM_FUNC1(HTMLStyleSheet                        )
    //CALL_ENUM_FUNC1(HTMLTableSection                      )
    //CALL_ENUM_FUNC1(HTMLTableCaption                      )
    //CALL_ENUM_FUNC1(HTMLFrameBase                         )
    //CALL_ENUM_FUNC1(HTMLFrameElement                      )
    //CALL_ENUM_FUNC1(HTMLIFrame                            )
    //CALL_ENUM_FUNC1(HTMLCommentElement                    )
    //CALL_ENUM_FUNC1(HTMLFrameSetSite                      )
    //CALL_ENUM_FUNC1(HTMLLabelElement                      )
    //CALL_ENUM_FUNC1(HTMLScreen                            )
    //CALL_ENUM_FUNC1(HTMLBGsound                           )
    //CALL_ENUM_FUNC1(HTMLStyleElement                      )
    //CALL_ENUM_FUNC1(HTMLStyleSheetsCollection             )
    //CALL_ENUM_FUNC1(HTMLNoShowElement                     )
    //CALL_ENUM_FUNC1(HTMLOptionElementFactory              )
    //CALL_ENUM_FUNC1(HTMLImageElementFactory               )
    //CALL_ENUM_FUNC1(HTMLWindowProxy                       )
    //CALL_ENUM_FUNC1(HTMLStyleSheetRulesCollection         )
    //CALL_ENUM_FUNC1(HTMLStyleSheetRule                    )
    //CALL_ENUM_FUNC1(HTMLRuleStyle                         )
    //CALL_ENUM_FUNC1(HTMLStyleFontFace                     )
    //CALL_ENUM_FUNC1(HTMLSpanFlow                          )
    //CALL_ENUM_FUNC1(HTMLFieldSetElement                   )
    //CALL_ENUM_FUNC1(HTMLLegendElement                     )
    //CALL_ENUM_FUNC1(HTMLFiltersCollection                 )
    //CALL_ENUM_FUNC1(HTMLSpanElement                       )
    //CALL_ENUM_FUNC1(CMimeTypes                            )
    //CALL_ENUM_FUNC1(CPlugins                              )
    //CALL_ENUM_FUNC1(COpsProfile                           )
    //CALL_ENUM_FUNC1(MHTMLDocument                         )
    //CALL_ENUM_FUNC1(ClassInstallFilter                    )
    //CALL_ENUM_FUNC1(CUrlHistory                           )
    //CALL_ENUM_FUNC1(CdlProtocol                           )
    //CALL_ENUM_FUNC1(StdEncodingFilterFac                  )
    //CALL_ENUM_FUNC1(TaskbarList                           )
    //CALL_ENUM_FUNC1(ShellFolderView                       )
    //CALL_ENUM_FUNC1(CFSIconOverlayManager                 )
    //CALL_ENUM_FUNC1(ShellUIHelper                         )
    //CALL_ENUM_FUNC1(ActiveDesktop                         )
    //CALL_ENUM_FUNC1(StdHlink                              )
    //CALL_ENUM_FUNC1(StdHlinkBrowseContext                 )
    //CALL_ENUM_FUNC1(StdURLMoniker                         )
    //CALL_ENUM_FUNC1(StdURLProtocol                        )
    //CALL_ENUM_FUNC1(HttpProtocol                          )
    //CALL_ENUM_FUNC1(FtpProtocol                           )
    //CALL_ENUM_FUNC1(GopherProtocol                        )
    //CALL_ENUM_FUNC1(HttpSProtocol                         )
    //CALL_ENUM_FUNC1(MkProtocol                            )
    //CALL_ENUM_FUNC1(FileProtocol                          )
    //CALL_ENUM_FUNC1(UrlMkBindCtx                          )
    //CALL_ENUM_FUNC1(InternetSecurityManager               )
    //CALL_ENUM_FUNC1(InternetZoneManager                   )
    //CALL_ENUM_FUNC1(CDLAgent                              )
    //CALL_ENUM_FUNC1(OverlayIdentifier_SlowFile            )
    //CALL_ENUM_FUNC1(StockFontPage                         )
    //CALL_ENUM_FUNC1(StockColorPage                        )
    //CALL_ENUM_FUNC1(StockPicturePage                      )
    //CALL_ENUM_FUNC1(WebBrowser                            )
    //CALL_ENUM_FUNC1(DeCompMimeFilter                      )
    //CALL_ENUM_FUNC1(ShellFolderViewOC                     )
    //CALL_ENUM_FUNC1(ShellWindows                          )
    //CALL_ENUM_FUNC1(SubscriptionMgr                       )
    //CALL_ENUM_FUNC1(ChannelMgr                            )
    //CALL_ENUM_FUNC1(CMLangString                          )
    //CALL_ENUM_FUNC1(HTMLWindow2                           )
    //CALL_ENUM_FUNC1(OldHTMLDocument                       )
    //CALL_ENUM_FUNC1(CMLangConvertCharset                  )
    //CALL_ENUM_FUNC1(WebBrowser_V1                         )
    //CALL_ENUM_FUNC1(HTMLHistory                           )
    //CALL_ENUM_FUNC1(HTMLNavigator                         )
    //CALL_ENUM_FUNC1(SoftDistExt                           )
    //CALL_ENUM_FUNC1(CURLSearchHook                        )
    //CALL_ENUM_FUNC1(ChannelAgent                          )
    //CALL_ENUM_FUNC1(PersistPropset                        )
    //CALL_ENUM_FUNC1(ConvertVBX                            )
    //CALL_ENUM_FUNC1(InternetShortcut                      )

#ifdef __SDK__
      CALL_ENUM_FUNC3(IAzAuthorizationStore                 )
    //CALL_ENUM_FUNC1(CLSID_AzAuthorizationStore            )
      CALL_ENUM_FUNC3(IAzBizRuleContext                     )
    //CALL_ENUM_FUNC1(CLSID_AzBizRuleContext                )
      CALL_ENUM_FUNC3(IAzApplication                        )
      CALL_ENUM_FUNC3(IAzApplications                       )
      CALL_ENUM_FUNC3(IAzOperation                          )
      CALL_ENUM_FUNC3(IAzOperations                         )
      CALL_ENUM_FUNC3(IAzTask                               )
      CALL_ENUM_FUNC3(IAzTasks                              )
      CALL_ENUM_FUNC3(IAzScope                              )
      CALL_ENUM_FUNC3(IAzScopes                             )
      CALL_ENUM_FUNC3(IAzApplicationGroup                   )
      CALL_ENUM_FUNC3(IAzApplicationGroups                  )
      CALL_ENUM_FUNC3(IAzRole                               )
      CALL_ENUM_FUNC3(IAzRoles                              )
      CALL_ENUM_FUNC3(IAzClientContext                      )
    //CALL_ENUM_FUNC1(LIBID_AZROLESLib                      )
#endif // __SDK__

      CALL_ENUM_FUNC1(IID_IEnumGUID                         )
      CALL_ENUM_FUNC1(IID_IEnumCLSID                        )
      CALL_ENUM_FUNC1(IID_IEnumCATID                        )
      CALL_ENUM_FUNC1(IID_IEnumCATEGORYINFO                 )
      CALL_ENUM_FUNC1(IID_ICatRegister                      )
      CALL_ENUM_FUNC1(IID_ICatInformation                   )

      CALL_ENUM_FUNC1(CLSID_StdComponentCategoriesMgr       )
      CALL_ENUM_FUNC1(CATID_Insertable                      )
      CALL_ENUM_FUNC1(CATID_Control                         )
      CALL_ENUM_FUNC1(CATID_Programmable                    )
      CALL_ENUM_FUNC1(CATID_IsShortcut                      )
      CALL_ENUM_FUNC1(CATID_NeverShowExt                    )
      CALL_ENUM_FUNC1(CATID_DocObject                       )
      CALL_ENUM_FUNC1(CATID_Printable                       )
      CALL_ENUM_FUNC1(CATID_RequiresDataPathHost            )
      CALL_ENUM_FUNC1(CATID_PersistsToMoniker               )
      CALL_ENUM_FUNC1(CATID_PersistsToStorage               )
      CALL_ENUM_FUNC1(CATID_PersistsToStreamInit            )
      CALL_ENUM_FUNC1(CATID_PersistsToStream                )
      CALL_ENUM_FUNC1(CATID_PersistsToMemory                )
      CALL_ENUM_FUNC1(CATID_PersistsToFile                  )
      CALL_ENUM_FUNC1(CATID_PersistsToPropertyBag           )
      CALL_ENUM_FUNC1(CATID_InternetAware                   )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CATID_DesignTimeUIActivatableControl  )
#endif

#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IPrintDialogCallback              )
      CALL_ENUM_FUNC1(IID_IPrintDialogServices              )
#endif // __SDK__

#ifdef __SDK__
      CALL_ENUM_FUNC1(LIBID_ActiveIMM                       )
      CALL_ENUM_FUNC1(IID_IEnumRegisterWordA                )
      CALL_ENUM_FUNC1(IID_IEnumRegisterWordW                )
      CALL_ENUM_FUNC1(IID_IEnumInputContext                 )
      CALL_ENUM_FUNC1(IID_IActiveIMMRegistrar               )
      CALL_ENUM_FUNC1(IID_IActiveIMMMessagePumpOwner        )
      CALL_ENUM_FUNC3(IActiveIMMApp                         ) //    <MsHTML.h>   <Dimm.h>
      CALL_ENUM_FUNC1(IID_IActiveIMMIME                     )
      CALL_ENUM_FUNC1(IID_IActiveIME                        )
      CALL_ENUM_FUNC1(IID_IActiveIME2                       )
#endif // __SDK__


#ifdef __SDK__
    //CALL_ENUM_FUNC1(CDO::IID_IDataSource                  )
    //CALL_ENUM_FUNC1(CDO::IID_IMessage                     )
    //CALL_ENUM_FUNC1(CDO::IID_IBodyPart                    )
    //CALL_ENUM_FUNC1(CDO::IID_IConfiguration               )
    //CALL_ENUM_FUNC1(CDO::IID_IMessages                    )
    //CALL_ENUM_FUNC1(CDO::IID_IDropDirectory               )
    //CALL_ENUM_FUNC1(CDO::IID_IBodyParts                   )
    //CALL_ENUM_FUNC1(CDO::IID_ISMTPScriptConnector         )
    //CALL_ENUM_FUNC1(CDO::IID_INNTPEarlyScriptConnector    )
    //CALL_ENUM_FUNC1(CDO::IID_INNTPPostScriptConnector     )
    //CALL_ENUM_FUNC1(CDO::IID_INNTPFinalScriptConnector    )
    //CALL_ENUM_FUNC1(CDO::IID_ISMTPOnArrival               )
    //CALL_ENUM_FUNC1(CDO::IID_INNTPOnPostEarly             )
    //CALL_ENUM_FUNC1(CDO::IID_INNTPOnPost                  )
    //CALL_ENUM_FUNC1(CDO::IID_INNTPOnPostFinal             )
    //CALL_ENUM_FUNC1(CDO::IID_IProxyObject                 )
    //CALL_ENUM_FUNC1(CDO::IID_IItem                        )
    //CALL_ENUM_FUNC1(CDO::IID_IAppointment                 )
    //CALL_ENUM_FUNC1(CDO::IID_ICalendarMessage             )
    //CALL_ENUM_FUNC1(CDO::IID_IIntegers                    )
    //CALL_ENUM_FUNC1(CDO::IID_IVariants                    )
    //CALL_ENUM_FUNC1(CDO::IID_IRecurrencePattern           )
    //CALL_ENUM_FUNC1(CDO::IID_IException                   )
    //CALL_ENUM_FUNC1(CDO::IID_IRecurrencePatterns          )
    //CALL_ENUM_FUNC1(CDO::IID_IExceptions                  )
    //CALL_ENUM_FUNC1(CDO::IID_ICalendarPart                )
    //CALL_ENUM_FUNC1(CDO::IID_ICalendarParts               )
    //CALL_ENUM_FUNC1(CDO::IID_IAttendee                    )
    //CALL_ENUM_FUNC1(CDO::IID_IAttendees                   )
    //CALL_ENUM_FUNC1(CDO::IID_IMailbox                     )
    //CALL_ENUM_FUNC1(CDO::IID_IFolder                      )
    //CALL_ENUM_FUNC1(CDO::IID_IContactGroupMembers         )
    //CALL_ENUM_FUNC1(CDO::IID_IPerson                      )
    //CALL_ENUM_FUNC1(CDO::IID_IAddressee                   )
    //CALL_ENUM_FUNC1(CDO::IID_IAddressees                  )
    //CALL_ENUM_FUNC1(CDO::IID_IGetInterface                )
    //CALL_ENUM_FUNC1(CDO::LIBID_CDO                        )
    //CALL_ENUM_FUNC1(CDO::CLSID_Message                    )
    //CALL_ENUM_FUNC1(CDO::CLSID_Configuration              )
    //CALL_ENUM_FUNC1(CDO::CLSID_DropDirectory              )
    //CALL_ENUM_FUNC1(CDO::CLSID_SMTPConnector              )
    //CALL_ENUM_FUNC1(CDO::CLSID_NNTPEarlyConnector         )
    //CALL_ENUM_FUNC1(CDO::CLSID_NNTPPostConnector          )
    //CALL_ENUM_FUNC1(CDO::CLSID_NNTPFinalConnector         )
    //CALL_ENUM_FUNC1(CDO::CLSID_Item                       )
    //CALL_ENUM_FUNC1(CDO::CLSID_Appointment                )
    //CALL_ENUM_FUNC1(CDO::CLSID_CalendarMessage            )
    //CALL_ENUM_FUNC1(CDO::CLSID_Folder                     )
    //CALL_ENUM_FUNC1(CDO::CLSID_Person                     )
    //CALL_ENUM_FUNC1(CDO::CLSID_Attendee                   )
    //CALL_ENUM_FUNC1(CDO::CLSID_Addressee                  )

    //CALL_ENUM_FUNC1(CDO::LIBID_CDOEXM                     )
    //CALL_ENUM_FUNC1(CDO::IID_IDistributionList            )
    //CALL_ENUM_FUNC1(CDO::IID_IMailRecipient               )
    //CALL_ENUM_FUNC1(CDO::IID_IMailboxStore                )
    //CALL_ENUM_FUNC1(CDO::CLSID_MailGroup                  )
    //CALL_ENUM_FUNC1(CDO::CLSID_MailRecipient              )
    //CALL_ENUM_FUNC1(CDO::CLSID_Mailbox                    )
    //CALL_ENUM_FUNC1(CDO::CLSID_FolderAdmin                )
    //CALL_ENUM_FUNC1(CDO::CLSID_ExchangeServer             )
    //CALL_ENUM_FUNC1(CDO::CLSID_FolderTree                 )
    //CALL_ENUM_FUNC1(CDO::CLSID_PublicStoreDB              )
    //CALL_ENUM_FUNC1(CDO::CLSID_MailboxStoreDB             )
    //CALL_ENUM_FUNC1(CDO::CLSID_StorageGroup               )
#endif // __SDK__

      CALL_ENUM_FUNC1(GUID_NULL                             )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CATID_MARSHALER                       )
#endif // __SDK__
      CALL_ENUM_FUNC1(IID_IRpcChannel                       )
      CALL_ENUM_FUNC1(IID_IRpcStub                          )
      CALL_ENUM_FUNC1(IID_IStubManager                      )
      CALL_ENUM_FUNC1(IID_IRpcProxy                         )
      CALL_ENUM_FUNC1(IID_IProxyManager                     )
      CALL_ENUM_FUNC1(IID_IPSFactory                        )
      CALL_ENUM_FUNC1(IID_IInternalMoniker                  )
      CALL_ENUM_FUNC1(IID_IDfReserved1                      )
      CALL_ENUM_FUNC1(IID_IDfReserved2                      )
      CALL_ENUM_FUNC1(IID_IDfReserved3                      )
      CALL_ENUM_FUNC1(CLSID_StdMarshal                      )
    //CALL_ENUM_FUNC1(CLSID_AggStdMarshal                   )
      CALL_ENUM_FUNC1(CLSID_StdAsyncActManager              )
      CALL_ENUM_FUNC1(IID_IStub                             )
      CALL_ENUM_FUNC1(IID_IProxy                            )
      CALL_ENUM_FUNC1(IID_IEnumGeneric                      )
      CALL_ENUM_FUNC1(IID_IEnumHolder                       )
      CALL_ENUM_FUNC1(IID_IEnumCallback                     )
      CALL_ENUM_FUNC1(IID_IOleManager                       )
      CALL_ENUM_FUNC1(IID_IOlePresObj                       )
      CALL_ENUM_FUNC1(IID_IDebug                            )
      CALL_ENUM_FUNC1(IID_IDebugStream                      )
      CALL_ENUM_FUNC1(CLSID_PSGenObject                     )
      CALL_ENUM_FUNC1(CLSID_PSClientSite                    )
      CALL_ENUM_FUNC1(CLSID_PSClassObject                   )
      CALL_ENUM_FUNC1(CLSID_PSInPlaceActive                 )
      CALL_ENUM_FUNC1(CLSID_PSInPlaceFrame                  )
      CALL_ENUM_FUNC1(CLSID_PSDragDrop                      )
      CALL_ENUM_FUNC1(CLSID_PSBindCtx                       )
      CALL_ENUM_FUNC1(CLSID_PSEnumerators                   )
      CALL_ENUM_FUNC1(CLSID_StaticMetafile                  )
      CALL_ENUM_FUNC1(CLSID_StaticDib                       )
    //CALL_ENUM_FUNC1(CID_CDfsVolume                        )
      CALL_ENUM_FUNC1(CLSID_DCOMAccessControl               )
      CALL_ENUM_FUNC1(CLSID_StdGlobalInterfaceTable         )
      CALL_ENUM_FUNC1(CLSID_ComBinding                      )
#ifdef __SDK__
      CALL_ENUM_FUNC1(CLSID_StdEvent                        )
      CALL_ENUM_FUNC1(CLSID_ManualResetEvent                )
      CALL_ENUM_FUNC1(CLSID_SynchronizeContainer            )
      CALL_ENUM_FUNC1(CLSID_AddrControl                     )
#endif // __SDK__
    //CALL_ENUM_FUNC1(CLSID_CCDFormKrnl                     )
    //CALL_ENUM_FUNC1(CLSID_CCDPropertyPage                 )
    //CALL_ENUM_FUNC1(CLSID_CCDFormDialog                   )
    //CALL_ENUM_FUNC1(CLSID_CCDCommandButton                )
    //CALL_ENUM_FUNC1(CLSID_CCDComboBox                     )
    //CALL_ENUM_FUNC1(CLSID_CCDTextBox                      )
    //CALL_ENUM_FUNC1(CLSID_CCDCheckBox                     )
    //CALL_ENUM_FUNC1(CLSID_CCDLabel                        )
    //CALL_ENUM_FUNC1(CLSID_CCDOptionButton                 )
    //CALL_ENUM_FUNC1(CLSID_CCDListBox                      )
    //CALL_ENUM_FUNC1(CLSID_CCDScrollBar                    )
    //CALL_ENUM_FUNC1(CLSID_CCDGroupBox                     )
    //CALL_ENUM_FUNC1(CLSID_CCDGeneralPropertyPage          )
    //CALL_ENUM_FUNC1(CLSID_CCDGenericPropertyPage          )
    //CALL_ENUM_FUNC1(CLSID_CCDFontPropertyPage             )
    //CALL_ENUM_FUNC1(CLSID_CCDColorPropertyPage            )
    //CALL_ENUM_FUNC1(CLSID_CCDLabelPropertyPage            )
    //CALL_ENUM_FUNC1(CLSID_CCDCheckBoxPropertyPage         )
    //CALL_ENUM_FUNC1(CLSID_CCDTextBoxPropertyPage          )
    //CALL_ENUM_FUNC1(CLSID_CCDOptionButtonPropertyPage     )
    //CALL_ENUM_FUNC1(CLSID_CCDListBoxPropertyPage          )
    //CALL_ENUM_FUNC1(CLSID_CCDCommandButtonPropertyPage    )
    //CALL_ENUM_FUNC1(CLSID_CCDComboBoxPropertyPage         )
    //CALL_ENUM_FUNC1(CLSID_CCDScrollBarPropertyPage        )
    //CALL_ENUM_FUNC1(CLSID_CCDGroupBoxPropertyPage         )
    //CALL_ENUM_FUNC1(CLSID_CCDXObjectPropertyPage          )
    //CALL_ENUM_FUNC1(CLSID_CStdPropertyFrame               )
    //CALL_ENUM_FUNC1(CLSID_CFormPropertyPage               )
    //CALL_ENUM_FUNC1(CLSID_CGridPropertyPage               )
    //CALL_ENUM_FUNC1(CLSID_CWSJArticlePage                 )
    //CALL_ENUM_FUNC1(CLSID_CSystemPage                     )
    //CALL_ENUM_FUNC1(CLSID_IdentityUnmarshal               )
      CALL_ENUM_FUNC1(CLSID_InProcFreeMarshaler             )
      CALL_ENUM_FUNC1(CLSID_Picture_Metafile                )
      CALL_ENUM_FUNC1(CLSID_Picture_EnhMetafile             )
      CALL_ENUM_FUNC1(CLSID_Picture_Dib                     )

      CALL_ENUM_FUNC1(IID_IDispatchEx                       )
      CALL_ENUM_FUNC1(IID_IDispError                        )
      CALL_ENUM_FUNC1(IID_IVariantChangeType                )
      CALL_ENUM_FUNC1(IID_IObjectIdentity                   )
    //CALL_ENUM_FUNC1(SID_VariantConversion                 )
    //CALL_ENUM_FUNC1(SID_GetCaller                         )

#ifdef __SDK__
      CALL_ENUM_FUNC1(IID_IRTCClient                        )
      CALL_ENUM_FUNC1(IID_IRTCClientPresence                )
      CALL_ENUM_FUNC1(IID_IRTCClientProvisioning            )
      CALL_ENUM_FUNC1(IID_IRTCProfile                       )
      CALL_ENUM_FUNC1(IID_IRTCSession                       )
      CALL_ENUM_FUNC1(IID_IRTCParticipant                   )
      CALL_ENUM_FUNC1(IID_IRTCProfileEvent                  )
      CALL_ENUM_FUNC1(IID_IRTCClientEvent                   )
      CALL_ENUM_FUNC1(IID_IRTCRegistrationStateChangeEvent  )
      CALL_ENUM_FUNC1(IID_IRTCSessionStateChangeEvent       )
      CALL_ENUM_FUNC1(IID_IRTCSessionOperationCompleteEvent )
      CALL_ENUM_FUNC1(IID_IRTCParticipantStateChangeEvent   )
      CALL_ENUM_FUNC1(IID_IRTCMediaEvent                    )
      CALL_ENUM_FUNC1(IID_IRTCIntensityEvent                )
      CALL_ENUM_FUNC1(IID_IRTCMessagingEvent                )
      CALL_ENUM_FUNC1(IID_IRTCBuddyEvent                    )
      CALL_ENUM_FUNC1(IID_IRTCWatcherEvent                  )
      CALL_ENUM_FUNC1(IID_IRTCCollection                    )
      CALL_ENUM_FUNC1(IID_IRTCEnumParticipants              )
      CALL_ENUM_FUNC1(IID_IRTCEnumProfiles                  )
      CALL_ENUM_FUNC1(IID_IRTCEnumBuddies                   )
      CALL_ENUM_FUNC1(IID_IRTCEnumWatchers                  )
      CALL_ENUM_FUNC1(IID_IRTCPresenceContact               )
      CALL_ENUM_FUNC1(IID_IRTCBuddy                         )
      CALL_ENUM_FUNC1(IID_IRTCWatcher                       )
      CALL_ENUM_FUNC1(IID_IRTCEventNotification             )
      CALL_ENUM_FUNC1(IID_IRTCPortManager                   )
      CALL_ENUM_FUNC1(IID_IRTCSessionPortManagement         )
      CALL_ENUM_FUNC1(LIBID_RTCCORELib                      )
      CALL_ENUM_FUNC1(DIID_IRTCDispatchEventNotification    )
      CALL_ENUM_FUNC1(CLSID_RTCClient                       )
#endif // __SDK__

#ifndef __SDK__
#ifdef __msxml_h__ // #include <MsXml.h>
      CALL_ENUM_FUNC1(LIBID_MSXML                           )
      CALL_ENUM_FUNC1(IID_IXMLDOMImplementation             )
      CALL_ENUM_FUNC1(IID_IXMLDOMNode                       )
      CALL_ENUM_FUNC1(IID_IXMLDOMDocumentFragment           )
      CALL_ENUM_FUNC1(IID_IXMLDOMDocument                   )
      CALL_ENUM_FUNC1(IID_IXMLDOMNodeList                   )
      CALL_ENUM_FUNC1(IID_IXMLDOMNamedNodeMap               )
      CALL_ENUM_FUNC1(IID_IXMLDOMCharacterData              )
      CALL_ENUM_FUNC1(IID_IXMLDOMAttribute                  )
      CALL_ENUM_FUNC1(IID_IXMLDOMElement                    )
      CALL_ENUM_FUNC1(IID_IXMLDOMText                       )
      CALL_ENUM_FUNC1(IID_IXMLDOMComment                    )
      CALL_ENUM_FUNC1(IID_IXMLDOMProcessingInstruction      )
      CALL_ENUM_FUNC1(IID_IXMLDOMCDATASection               )
      CALL_ENUM_FUNC1(IID_IXMLDOMDocumentType               )
      CALL_ENUM_FUNC1(IID_IXMLDOMNotation                   )
      CALL_ENUM_FUNC1(IID_IXMLDOMEntity                     )
      CALL_ENUM_FUNC1(IID_IXMLDOMEntityReference            )
      CALL_ENUM_FUNC1(IID_IXMLDOMParseError                 )
      CALL_ENUM_FUNC1(IID_IXTLRuntime                       )
      CALL_ENUM_FUNC1(DIID_XMLDOMDocumentEvents             )
      CALL_ENUM_FUNC1(IID_IXMLHttpRequest                   )
      CALL_ENUM_FUNC1(IID_IXMLDSOControl                    )
      CALL_ENUM_FUNC1(IID_IXMLElementCollection             )
      CALL_ENUM_FUNC1(IID_IXMLDocument                      )
      CALL_ENUM_FUNC1(IID_IXMLDocument2                     )
      CALL_ENUM_FUNC1(IID_IXMLElement                       )
      CALL_ENUM_FUNC1(IID_IXMLElement2                      )
      CALL_ENUM_FUNC1(IID_IXMLAttribute                     )
      CALL_ENUM_FUNC1(IID_IXMLError                         )
      CALL_ENUM_FUNC3(DOMDocument                           )
      CALL_ENUM_FUNC1(CLSID_DOMFreeThreadedDocument         )
      CALL_ENUM_FUNC1(CLSID_XMLHTTPRequest                  )
      CALL_ENUM_FUNC1(CLSID_XMLDSOControl                   )
      CALL_ENUM_FUNC1(CLSID_XMLDocument                     )
#endif // __msxml_h__
#else // __SDK__
#ifdef __msxml2_h__ // #include <MsXml2.h>
    //CALL_ENUM_FUNC1(LIBID_MSXML2                          )
      CALL_ENUM_FUNC1(IID_IXMLDOMImplementation             )
      CALL_ENUM_FUNC1(IID_IXMLDOMNode                       )
      CALL_ENUM_FUNC1(IID_IXMLDOMDocumentFragment           )
      CALL_ENUM_FUNC1(IID_IXMLDOMDocument                   )
      CALL_ENUM_FUNC3(IXMLDOMDocument2                      )
      CALL_ENUM_FUNC1(IID_IXMLDOMNodeList                   )
      CALL_ENUM_FUNC1(IID_IXMLDOMNamedNodeMap               )
      CALL_ENUM_FUNC1(IID_IXMLDOMCharacterData              )
      CALL_ENUM_FUNC1(IID_IXMLDOMAttribute                  )
      CALL_ENUM_FUNC1(IID_IXMLDOMElement                    )
      CALL_ENUM_FUNC1(IID_IXMLDOMText                       )
      CALL_ENUM_FUNC1(IID_IXMLDOMComment                    )
      CALL_ENUM_FUNC1(IID_IXMLDOMProcessingInstruction      )
      CALL_ENUM_FUNC1(IID_IXMLDOMCDATASection               )
      CALL_ENUM_FUNC1(IID_IXMLDOMDocumentType               )
      CALL_ENUM_FUNC1(IID_IXMLDOMNotation                   )
      CALL_ENUM_FUNC1(IID_IXMLDOMEntity                     )
      CALL_ENUM_FUNC1(IID_IXMLDOMEntityReference            )
      CALL_ENUM_FUNC1(IID_IXMLDOMParseError                 )
      CALL_ENUM_FUNC3(IXMLDOMSchemaCollection               )
      CALL_ENUM_FUNC1(IID_IXTLRuntime                       )
      CALL_ENUM_FUNC3(IXSLTemplate                          )
      CALL_ENUM_FUNC3(IXSLProcessor                         )
      CALL_ENUM_FUNC3(ISAXXMLReader                         )
      CALL_ENUM_FUNC3(ISAXXMLFilter                         )
      CALL_ENUM_FUNC3(ISAXLocator                           )
      CALL_ENUM_FUNC3(ISAXEntityResolver                    )
      CALL_ENUM_FUNC3(ISAXContentHandler                    )
      CALL_ENUM_FUNC3(ISAXDTDHandler                        )
      CALL_ENUM_FUNC3(ISAXErrorHandler                      )
      CALL_ENUM_FUNC3(ISAXLexicalHandler                    )
      CALL_ENUM_FUNC3(ISAXDeclHandler                       )
      CALL_ENUM_FUNC3(ISAXAttributes                        )
      CALL_ENUM_FUNC3(IVBSAXXMLReader                       )
      CALL_ENUM_FUNC3(IVBSAXXMLFilter                       )
      CALL_ENUM_FUNC3(IVBSAXLocator                         )
      CALL_ENUM_FUNC3(IVBSAXEntityResolver                  )
      CALL_ENUM_FUNC3(IVBSAXContentHandler                  )
      CALL_ENUM_FUNC3(IVBSAXDTDHandler                      )
      CALL_ENUM_FUNC3(IVBSAXErrorHandler                    )
      CALL_ENUM_FUNC3(IVBSAXLexicalHandler                  )
      CALL_ENUM_FUNC3(IVBSAXDeclHandler                     )
      CALL_ENUM_FUNC3(IVBSAXAttributes                      )
      CALL_ENUM_FUNC3(IMXWriter                             )
      CALL_ENUM_FUNC3(IMXAttributes                         )
      CALL_ENUM_FUNC3(IMXReaderControl                      )
      CALL_ENUM_FUNC3(IMXSchemaDeclHandler                  )
      CALL_ENUM_FUNC3(IXMLDOMSchemaCollection2              )
      CALL_ENUM_FUNC3(ISchemaStringCollection               )
      CALL_ENUM_FUNC3(ISchemaItemCollection                 )
      CALL_ENUM_FUNC3(ISchemaItem                           )
      CALL_ENUM_FUNC3(ISchema                               )
      CALL_ENUM_FUNC3(ISchemaParticle                       )
      CALL_ENUM_FUNC3(ISchemaAttribute                      )
      CALL_ENUM_FUNC3(ISchemaElement                        )
      CALL_ENUM_FUNC3(ISchemaType                           )
      CALL_ENUM_FUNC3(ISchemaComplexType                    )
      CALL_ENUM_FUNC3(ISchemaAttributeGroup                 )
      CALL_ENUM_FUNC3(ISchemaModelGroup                     )
      CALL_ENUM_FUNC3(ISchemaAny                            )
      CALL_ENUM_FUNC3(ISchemaIdentityConstraint             )
      CALL_ENUM_FUNC3(ISchemaNotation                       )
      CALL_ENUM_FUNC1(IID_IXMLElementCollection             )
      CALL_ENUM_FUNC1(IID_IXMLDocument                      )
      CALL_ENUM_FUNC1(IID_IXMLDocument2                     )
      CALL_ENUM_FUNC1(IID_IXMLElement                       )
      CALL_ENUM_FUNC1(IID_IXMLElement2                      )
      CALL_ENUM_FUNC1(IID_IXMLAttribute                     )
      CALL_ENUM_FUNC1(IID_IXMLError                         )
      CALL_ENUM_FUNC3(IXMLDOMSelection                      )
      CALL_ENUM_FUNC1(DIID_XMLDOMDocumentEvents             )
      CALL_ENUM_FUNC3(IDSOControl                           )
      CALL_ENUM_FUNC3(IXMLHTTPRequest                       )
      CALL_ENUM_FUNC3(IServerXMLHTTPRequest                 )
      CALL_ENUM_FUNC3(IServerXMLHTTPRequest2                )
      CALL_ENUM_FUNC3(IMXNamespacePrefixes                  )
      CALL_ENUM_FUNC3(IVBMXNamespaceManager                 )
      CALL_ENUM_FUNC3(IMXNamespaceManager                   )
      CALL_ENUM_FUNC3(DOMDocument                           )
      CALL_ENUM_FUNC3(DOMDocument26                         )
      CALL_ENUM_FUNC3(DOMDocument30                         )
      CALL_ENUM_FUNC3(DOMDocument40                         )
      CALL_ENUM_FUNC3(FreeThreadedDOMDocument               )
      CALL_ENUM_FUNC3(FreeThreadedDOMDocument26             )
      CALL_ENUM_FUNC3(FreeThreadedDOMDocument30             )
      CALL_ENUM_FUNC3(FreeThreadedDOMDocument40             )
      CALL_ENUM_FUNC3(XMLSchemaCache                        )
      CALL_ENUM_FUNC3(XMLSchemaCache26                      )
      CALL_ENUM_FUNC3(XMLSchemaCache30                      )
      CALL_ENUM_FUNC3(XMLSchemaCache40                      )
      CALL_ENUM_FUNC3(XSLTemplate                           )
      CALL_ENUM_FUNC3(XSLTemplate26                         )
      CALL_ENUM_FUNC3(XSLTemplate30                         )
      CALL_ENUM_FUNC3(XSLTemplate40                         )
      CALL_ENUM_FUNC3(DSOControl                            )
      CALL_ENUM_FUNC3(DSOControl26                          )
      CALL_ENUM_FUNC3(DSOControl30                          )
      CALL_ENUM_FUNC3(DSOControl40                          )
      CALL_ENUM_FUNC3(XMLHTTP                               )
      CALL_ENUM_FUNC3(XMLHTTP26                             )
      CALL_ENUM_FUNC3(XMLHTTP30                             )
      CALL_ENUM_FUNC3(XMLHTTP40                             )
      CALL_ENUM_FUNC3(ServerXMLHTTP                         )
      CALL_ENUM_FUNC3(ServerXMLHTTP30                       )
      CALL_ENUM_FUNC3(ServerXMLHTTP40                       )
      CALL_ENUM_FUNC3(SAXXMLReader                          )
      CALL_ENUM_FUNC3(SAXXMLReader30                        )
      CALL_ENUM_FUNC3(SAXXMLReader40                        )
      CALL_ENUM_FUNC3(MXXMLWriter                           )
      CALL_ENUM_FUNC3(MXXMLWriter30                         )
      CALL_ENUM_FUNC3(MXXMLWriter40                         )
      CALL_ENUM_FUNC3(MXHTMLWriter                          )
      CALL_ENUM_FUNC3(MXHTMLWriter30                        )
      CALL_ENUM_FUNC3(MXHTMLWriter40                        )
      CALL_ENUM_FUNC3(SAXAttributes                         )
      CALL_ENUM_FUNC3(SAXAttributes30                       )
      CALL_ENUM_FUNC3(SAXAttributes40                       )
      CALL_ENUM_FUNC3(MXNamespaceManager                    )
      CALL_ENUM_FUNC3(MXNamespaceManager40                  )
      CALL_ENUM_FUNC1(CLSID_XMLDocument                     )
#endif // __msxml2_h__
#endif // __SDK__

#ifdef __mssoap30_h__ // 'SOAP Toolkit 3.0'
    //CALL_ENUM_FUNC1(LIBID_MSSOAPLib30                     )
      CALL_ENUM_FUNC3(ISoapReader                           )
      CALL_ENUM_FUNC3(ISoapSerializer                       )
      CALL_ENUM_FUNC3(ISoapMapper                           )
      CALL_ENUM_FUNC3(IDataEncoder                          )
      CALL_ENUM_FUNC3(IDataEncoderFactory                   )
      CALL_ENUM_FUNC3(IAttachment                           )
      CALL_ENUM_FUNC3(IFileAttachment                       )
      CALL_ENUM_FUNC3(FileAttachment30                      )
      CALL_ENUM_FUNC3(IStringAttachment                     )
      CALL_ENUM_FUNC3(StringAttachment30                    )
      CALL_ENUM_FUNC3(IByteArrayAttachment                  )
      CALL_ENUM_FUNC3(ByteArrayAttachment30                 )
      CALL_ENUM_FUNC3(IStreamAttachment                     )
      CALL_ENUM_FUNC3(StreamAttachment30                    )
      CALL_ENUM_FUNC3(IReceivedAttachment                   )
      CALL_ENUM_FUNC3(ISentAttachments                      )
      CALL_ENUM_FUNC3(SentAttachments30                     )
      CALL_ENUM_FUNC3(IReceivedAttachments                  )
      CALL_ENUM_FUNC3(ReceivedAttachments30                 )
      CALL_ENUM_FUNC3(IComposerDestination                  )
      CALL_ENUM_FUNC3(IGetComposerDestination               )
      CALL_ENUM_FUNC3(IMessageComposer                      )
      CALL_ENUM_FUNC3(IDimeComposer                         )
      CALL_ENUM_FUNC3(ISimpleComposer                       )
      CALL_ENUM_FUNC3(IParserSource                         )
      CALL_ENUM_FUNC3(IGetParserSource                      )
      CALL_ENUM_FUNC3(IMessageParser                        )
      CALL_ENUM_FUNC3(IDimeParser                           )
      CALL_ENUM_FUNC3(ISimpleParser                         )
      CALL_ENUM_FUNC3(DataEncoderFactory30                  )
      CALL_ENUM_FUNC3(DimeComposer30                        )
      CALL_ENUM_FUNC3(DimeParser30                          )
      CALL_ENUM_FUNC3(SimpleComposer30                      )
      CALL_ENUM_FUNC3(SimpleParser30                        )
      CALL_ENUM_FUNC3(SoapReader30                          )
      CALL_ENUM_FUNC3(SoapSerializer30                      )
      CALL_ENUM_FUNC3(ISoapClient                           )
      CALL_ENUM_FUNC3(ISoapServer                           )
      CALL_ENUM_FUNC3(SoapServer30                          )
      CALL_ENUM_FUNC3(SoapClient30                          )
      CALL_ENUM_FUNC3(ISoapTypeMapperFactory                )
      CALL_ENUM_FUNC3(IHeaderHandler                        )
      CALL_ENUM_FUNC3(ISoapTypeMapper                       )
      CALL_ENUM_FUNC3(IEnumSoapMappers                      )
      CALL_ENUM_FUNC3(IWSDLMessage                          )
      CALL_ENUM_FUNC3(IWSDLOperation                        )
      CALL_ENUM_FUNC3(IEnumWSDLOperations                   )
      CALL_ENUM_FUNC3(IWSDLPort                             )
      CALL_ENUM_FUNC3(IEnumWSDLPorts                        )
      CALL_ENUM_FUNC3(IWSDLService                          )
      CALL_ENUM_FUNC3(IEnumWSDLService                      )
      CALL_ENUM_FUNC3(IWSDLReader                           )
      CALL_ENUM_FUNC3(IWSDLBinding                          )
      CALL_ENUM_FUNC3(WSDLReader30                          )
      CALL_ENUM_FUNC3(SoapTypeMapperFactory30               )
      CALL_ENUM_FUNC3(GenericCustomTypeMapper30             )
      CALL_ENUM_FUNC3(UDTMapper30                           )
      CALL_ENUM_FUNC3(ISoapConnector                        )
      CALL_ENUM_FUNC3(ISoapConnectorFactory                 )
      CALL_ENUM_FUNC3(SoapConnector30                       )
      CALL_ENUM_FUNC3(SoapConnectorFactory30                )
      CALL_ENUM_FUNC3(HttpConnector30                       )
      CALL_ENUM_FUNC3(ISoapError                            )
      CALL_ENUM_FUNC3(ISoapErrorInfo                        )
      CALL_ENUM_FUNC3(IGCTMObjectFactory                    )
#endif // __mssoap30_h__
#ifdef __SDK__
      CALL_ENUM_FUNC2(PSGUID_INTERNETSHORTCUT               )
      CALL_ENUM_FUNC2(PSGUID_INTERNETSITE                   )
      CALL_ENUM_FUNC2(PSGUID_SHELLDETAILS                   )
      CALL_ENUM_FUNC2(PSGUID_IMAGEPROPERTIES                )
      CALL_ENUM_FUNC2(PSGUID_DISPLACED                      )
      CALL_ENUM_FUNC2(PSGUID_BRIEFCASE                      )
      CALL_ENUM_FUNC2(PSGUID_MISC                           )
      CALL_ENUM_FUNC2(PSGUID_WEBVIEW                        )
      CALL_ENUM_FUNC2(PSGUID_MUSIC                          )
      CALL_ENUM_FUNC2(PSGUID_DRM                            )
      CALL_ENUM_FUNC2(PSGUID_VIDEO                          )
      CALL_ENUM_FUNC2(PSGUID_AUDIO                          )
      CALL_ENUM_FUNC2(PSGUID_CONTROLPANEL                   )
      CALL_ENUM_FUNC2(PSGUID_VOLUME                         )
      CALL_ENUM_FUNC2(PSGUID_SHARE                          )
      CALL_ENUM_FUNC2(PSGUID_LINK                           )
      CALL_ENUM_FUNC2(PSGUID_QUERY_D                        )
      CALL_ENUM_FUNC2(PSGUID_SUMMARYINFORMATION             )
      CALL_ENUM_FUNC2(PSGUID_DOCUMENTSUMMARYINFORMATION     )
      CALL_ENUM_FUNC2(PSGUID_MEDIAFILESUMMARYINFORMATION    )
      CALL_ENUM_FUNC2(PSGUID_IMAGESUMMARYINFORMATION        )
#endif // __SDK__

      #undef CALL_ENUM_FUNC1
      #undef CALL_ENUM_FUNC2
      #undef CALL_ENUM_FUNC3

   } while(false);
#endif // LOGGER_DUMMY

   return bRes;
}

/* static */ CString CLogger::ProgID(REFCLSID clsid) {
   CString strId;

   // 1.    
   strId = nsLogger::GUID2String(clsid);
   HKEY hKey = NULL;
   CString strLastSubKey(_T("ProgID"));
anew:
   DWORD dwErrCode = ::RegCreateKey(HKEY_CLASSES_ROOT, _T("CLSID\\")+strId+_T('\\')+strLastSubKey, &hKey);
   CString strRes;
   if (dwErrCode == ERROR_SUCCESS) {
      TCHAR szValueName[1] = {0}; //     ,   0 !    1 ...
      DWORD dwSizeValueName=1,
            dwType,
            dwSizeData=1024;
      BYTE pbData[1024] = {0};

      dwErrCode = ::RegEnumValue(hKey, 0, szValueName, &dwSizeValueName, NULL, &dwType, pbData, &dwSizeData);
      ::RegCloseKey(hKey); hKey = NULL;
      if ((dwErrCode == ERROR_SUCCESS) &&
          (dwType == REG_SZ) &&
          (szValueName[0] == 0))
      {
         LPCTSTR szRes = (LPCTSTR)pbData;
         if (szRes && szRes[0]) {
            strRes = szRes;
         }
      }
   }
   if (strRes.IsEmpty() && !strLastSubKey.IsEmpty()) {
      strLastSubKey.Empty();
      goto anew;
   }

   // 2.    ProgIDFromCLSID
   if (strRes.IsEmpty()) {
      LPOLESTR szCLSID = NULL;
      HRESULT hRes = ::ProgIDFromCLSID(clsid, &szCLSID);
      if (SUCCEEDED(hRes) && szCLSID && szCLSID[0]) {
         strRes = szCLSID;
         ::SysFreeString(szCLSID); szCLSID = NULL;
      }
   }
   if (strRes.IsEmpty()) {
      strRes = strId;
   }
   return strRes;
}

/* static */ CString CLogger::InterfaceID(REFIID iid) {
   CString strId;
   strId = nsLogger::GUID2String(iid);
   HKEY hKey = NULL;
   DWORD dwErrCode = ::RegCreateKey(HKEY_CLASSES_ROOT, _T("Interface\\")+strId, &hKey);
   CString strRes;
   if (dwErrCode == ERROR_SUCCESS) {
      TCHAR szValueName[1] = {0}; //     ,   0 !    1 ...
      DWORD dwSizeValueName=1,
            dwType,
            dwSizeData=1024;
      BYTE pbData[1024] = {0};

      dwErrCode = ::RegEnumValue(hKey, 0, szValueName, &dwSizeValueName, NULL, &dwType, pbData, &dwSizeData);
      ::RegCloseKey(hKey); hKey = NULL;
      if ((dwErrCode == ERROR_SUCCESS) &&
          (dwType == REG_SZ) &&
          (szValueName[0] == 0))
      {
         LPCTSTR szRes = (LPCTSTR)pbData;
         if (szRes && szRes[0]) {
            strRes = szRes;
         }
      }
   }
   if (strRes.IsEmpty()) {
      strRes = strId;
   }
   return strRes;
}

// Window Styles to string
/* static */ CString CLogger::WindowStyle(HWND hWnd) {
   LONG lStyle = ::GetWindowLong(hWnd, GWL_STYLE);
   if ((lStyle == 0) && (::GetLastError() != ERROR_SUCCESS)) {
      return CString();
   }

   CString strClassName;
   { // get class name
      TCHAR szClassName[256] = {0};
      int iRes = ::GetClassName(hWnd, szClassName, 256);
      if (iRes)
         strClassName = szClassName;
   }

   return CLogger::WindowStyle((DWORD)lStyle, strClassName);
}

/* static */ CString CLogger::WindowStyle(DWORD dwStyle, LPCTSTR szClassName) {
   CString strRes;

#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08X"), dwStyle);
   return strRes;
#else // LOGGER_DUMMY

   #define IF_WS(val)         if ( dwStyle &      (val)) { strRes += _T(" | ")_T(#val); }
   #define IF_WS_F(flag, val) if ((dwStyle&flag)==(val)) { strRes += _T(" | ")_T(#val); }
   #define CASE_WS(val)                      case (val): { strRes += _T(" | ")_T(#val); } break;
   { // Window Styles
      IF_WS(WS_OVERLAPPED  )
      IF_WS(WS_POPUP       )
      IF_WS(WS_CHILD       )
      IF_WS(WS_MINIMIZE    )
      IF_WS(WS_VISIBLE     )
      IF_WS(WS_DISABLED    )
      IF_WS(WS_CLIPSIBLINGS)
      IF_WS(WS_CLIPCHILDREN)
      IF_WS(WS_MAXIMIZE    )
      IF_WS_F(WS_CAPTION, WS_CAPTION)
      else {
         IF_WS(WS_BORDER   )
         IF_WS(WS_DLGFRAME )
      }
      IF_WS(WS_VSCROLL     )
      IF_WS(WS_HSCROLL     )
      IF_WS(WS_SYSMENU     )
      IF_WS(WS_THICKFRAME  )
      if (dwStyle & WS_CHILD) {
         IF_WS(WS_GROUP      )
         IF_WS(WS_TABSTOP    )
      } else {
         IF_WS(WS_MINIMIZEBOX)
         IF_WS(WS_MAXIMIZEBOX)
      }
   }
   if (szClassName && (lstrcmp(szClassName, _T("#32770")) == 0))
   { // Dialog Styles
      IF_WS(DS_ABSALIGN     )
      IF_WS(DS_SYSMODAL     )
      IF_WS(DS_LOCALEDIT    )
      IF_WS(DS_SETFONT      )
      IF_WS(DS_MODALFRAME   )
      IF_WS(DS_NOIDLEMSG    )
      IF_WS(DS_SETFOREGROUND)

      IF_WS(DS_3DLOOK       )
      IF_WS(DS_FIXEDSYS     )
      IF_WS(DS_NOFAILCREATE )
      IF_WS(DS_CONTROL      )
      IF_WS(DS_CENTER       )
      IF_WS(DS_CENTERMOUSE  )
      IF_WS(DS_CONTEXTHELP  )
   } else
   if (szClassName && (lstrcmpi(szClassName, _T("BUTTON")) == 0))
   { // Button Control Styles
      switch (dwStyle & BS_TYPEMASK) {
      CASE_WS(BS_PUSHBUTTON     )
      CASE_WS(BS_DEFPUSHBUTTON  )
      CASE_WS(BS_CHECKBOX       )
      CASE_WS(BS_AUTOCHECKBOX   )
      CASE_WS(BS_RADIOBUTTON    )
      CASE_WS(BS_3STATE         )
      CASE_WS(BS_AUTO3STATE     )
      CASE_WS(BS_GROUPBOX       )
      CASE_WS(BS_USERBUTTON     )
      CASE_WS(BS_AUTORADIOBUTTON)
      CASE_WS(BS_OWNERDRAW      )
      }
      switch (dwStyle & 0xF0) {
      CASE_WS(BS_LEFTTEXT)
      CASE_WS(BS_TEXT    )
      CASE_WS(BS_ICON    )
      CASE_WS(BS_BITMAP  )
      }
      switch (dwStyle & 0x300) {
      CASE_WS(BS_LEFT  )
      CASE_WS(BS_RIGHT )
      CASE_WS(BS_CENTER)
      }
      switch (dwStyle & 0xC00) {
      CASE_WS(BS_TOP    )
      CASE_WS(BS_BOTTOM )
      CASE_WS(BS_VCENTER)
      }
      IF_WS(BS_PUSHLIKE )
      IF_WS(BS_MULTILINE)
      IF_WS(BS_NOTIFY   )
      IF_WS(BS_FLAT     )
   } else
   if (szClassName && ((lstrcmpi(szClassName, _T("EDIT")) == 0) /*||
                       (lstrcmp (szClassName, RICHEDIT_CLASS) == 0)*/))
   { // Edit Control Styles
      IF_WS_F(0xF, ES_LEFT  )
      IF_WS_F(0xF, ES_CENTER)
      IF_WS_F(0xF, ES_RIGHT )
      IF_WS(ES_MULTILINE  )
      IF_WS(ES_UPPERCASE  )
      IF_WS(ES_LOWERCASE  )
      IF_WS(ES_PASSWORD   )
      IF_WS(ES_AUTOVSCROLL)
      IF_WS(ES_AUTOHSCROLL)
      IF_WS(ES_NOHIDESEL  )
      IF_WS(ES_OEMCONVERT )
      IF_WS(ES_READONLY   )
      IF_WS(ES_WANTRETURN )
      IF_WS(ES_NUMBER     )
   } else
   if (szClassName && (lstrcmpi(szClassName, _T("STATIC")) == 0))
   { // Static Control
      switch (dwStyle & SS_TYPEMASK) {
      CASE_WS(SS_LEFT          )
      CASE_WS(SS_CENTER        )
      CASE_WS(SS_RIGHT         )
      CASE_WS(SS_ICON          )
      CASE_WS(SS_BLACKRECT     )
      CASE_WS(SS_GRAYRECT      )
      CASE_WS(SS_WHITERECT     )
      CASE_WS(SS_BLACKFRAME    )
      CASE_WS(SS_GRAYFRAME     )
      CASE_WS(SS_WHITEFRAME    )
      CASE_WS(SS_USERITEM      )
      CASE_WS(SS_SIMPLE        )
      CASE_WS(SS_LEFTNOWORDWRAP)
      CASE_WS(SS_OWNERDRAW     )
      CASE_WS(SS_BITMAP        )
      CASE_WS(SS_ENHMETAFILE   )
      CASE_WS(SS_ETCHEDHORZ    )
      CASE_WS(SS_ETCHEDVERT    )
      CASE_WS(SS_ETCHEDFRAME   )
      }
      IF_WS(SS_REALSIZECONTROL)
      IF_WS(SS_NOPREFIX       )
      IF_WS(SS_NOTIFY         )
      IF_WS(SS_CENTERIMAGE    )
      IF_WS(SS_RIGHTJUST      )
      IF_WS(SS_REALSIZEIMAGE  )
      IF_WS(SS_SUNKEN         )
      switch (dwStyle & SS_ELLIPSISMASK) {
      CASE_WS(SS_WORDELLIPSIS)
      CASE_WS(SS_ENDELLIPSIS )
      CASE_WS(SS_PATHELLIPSIS)
      }
   } else
   if (szClassName && ((lstrcmpi(szClassName, _T("COMBOBOX")) == 0) ||
                       (lstrcmp (szClassName, WC_COMBOBOXEX) == 0)))
   { // Combo Box styles
      switch (dwStyle & 0x3) {
      CASE_WS(CBS_DROPDOWNLIST)
      CASE_WS(CBS_SIMPLE      )
      CASE_WS(CBS_DROPDOWN    )
      }
      IF_WS(CBS_OWNERDRAWFIXED   )
      IF_WS(CBS_OWNERDRAWVARIABLE)
      IF_WS(CBS_AUTOHSCROLL      )
      IF_WS(CBS_OEMCONVERT       )
      IF_WS(CBS_SORT             )
      IF_WS(CBS_HASSTRINGS       )
      IF_WS(CBS_NOINTEGRALHEIGHT )
      IF_WS(CBS_DISABLENOSCROLL  )
      IF_WS(CBS_UPPERCASE        )
      IF_WS(CBS_LOWERCASE        )
   } else
   if (szClassName && (lstrcmp(szClassName, _T("LISTBOX")) == 0))
   { // Listbox Styles
      IF_WS(LBS_NOTIFY           )
      IF_WS(LBS_SORT             )
      IF_WS(LBS_NOREDRAW         )
      IF_WS(LBS_MULTIPLESEL      )
      IF_WS(LBS_OWNERDRAWFIXED   )
      IF_WS(LBS_OWNERDRAWVARIABLE)
      IF_WS(LBS_HASSTRINGS       )
      IF_WS(LBS_USETABSTOPS      )
      IF_WS(LBS_NOINTEGRALHEIGHT )
      IF_WS(LBS_MULTICOLUMN      )
      IF_WS(LBS_WANTKEYBOARDINPUT)
      IF_WS(LBS_EXTENDEDSEL      )
      IF_WS(LBS_DISABLENOSCROLL  )
      IF_WS(LBS_NODATA           )
      IF_WS(LBS_NOSEL            )
   } else {
/* @TODO:         ...
      WC_LISTVIEW          LVS_ICON
      SCROLLBAR            SBS_HORZ
      UPDOWN_CLASS         TBS_HORZ
      WC_TREEVIEW          TVS_HASBUTTONS
      WC_TABCONTROL        TCS_TABS
      ANIMATE_CLASS        ACS_TRANSPARENT
      DATETIMEPICK_CLASS   DTS_SHORTDATEFORMAT
      MONTHCAL_CLASS       MCS_NOTODAY
*/
   #undef IF_WS
   #undef IF_WS_F
   #undef CASE_WS
      // unknown control
      if (dwStyle & 0xFFFF) {
         CString str; str.Format(_T("0x%04X"), dwStyle & 0xFFFF);
         strRes += _T(" | ") + str;
      }
   }
   return strRes.IsEmpty() ? strRes : strRes.Mid(3);
#endif // LOGGER_DUMMY
}

/* static */ CString CLogger::WindowStyleEx(HWND hWnd) {
   LONG lStyleEx = ::GetWindowLong(hWnd, GWL_EXSTYLE);
   if ((lStyleEx == 0) && (::GetLastError() != ERROR_SUCCESS)) {
      return CString();
   }
   return CLogger::WindowStyleEx((DWORD)lStyleEx);
}

/* static */ CString CLogger::WindowStyleEx(DWORD dwStyleEx) {
   CString strRes;

#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08X"), dwStyleEx);
   return strRes;
#else // LOGGER_DUMMY
   #define IF_WSE(val) if (dwStyleEx & (val)) {strRes += _T(" | ")_T(#val);}
   IF_WSE(WS_EX_DLGMODALFRAME )
   IF_WSE(WS_EX_NOPARENTNOTIFY)
   IF_WSE(WS_EX_TOPMOST       )
   IF_WSE(WS_EX_ACCEPTFILES   )
   IF_WSE(WS_EX_TRANSPARENT   )

   IF_WSE(WS_EX_MDICHILD      )
   IF_WSE(WS_EX_TOOLWINDOW    )
   IF_WSE(WS_EX_WINDOWEDGE    )
   IF_WSE(WS_EX_CLIENTEDGE    )
   IF_WSE(WS_EX_CONTEXTHELP   )

   IF_WSE(WS_EX_RIGHT         )
 //IF_WSE(WS_EX_LEFT          )
   IF_WSE(WS_EX_RTLREADING    )
 //IF_WSE(WS_EX_LTRREADING    )
   IF_WSE(WS_EX_LEFTSCROLLBAR )
 //IF_WSE(WS_EX_RIGHTSCROLLBAR)

   IF_WSE(WS_EX_CONTROLPARENT )
   IF_WSE(WS_EX_STATICEDGE    )
   IF_WSE(WS_EX_APPWINDOW     )
   #undef IF_WSE

   //#define WS_EX_OVERLAPPEDWINDOW (WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE)
   //#define WS_EX_PALETTEWINDOW    (WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST)

   return strRes.IsEmpty() ? strRes : strRes.Mid(3);
#endif // LOGGER_DUMMY
}

/* static */ CString CLogger::SetWindowPos(UINT flags) {
   CString strRes;

#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%04X"), flags);
   return strRes;
#else // LOGGER_DUMMY

   #define IF_SWP(val) if (flags & (val)) {strRes += _T(" | ")_T(#val);}
   IF_SWP(SWP_NOSIZE        )
   IF_SWP(SWP_NOMOVE        )
   IF_SWP(SWP_NOZORDER      )
   IF_SWP(SWP_NOREDRAW      )
   IF_SWP(SWP_NOACTIVATE    )
   IF_SWP(SWP_FRAMECHANGED  )
   IF_SWP(SWP_SHOWWINDOW    )
   IF_SWP(SWP_HIDEWINDOW    )
   IF_SWP(SWP_NOCOPYBITS    )
   IF_SWP(SWP_NOOWNERZORDER )
   IF_SWP(SWP_NOSENDCHANGING)
   IF_SWP(SWP_DEFERERASE    )
   IF_SWP(SWP_ASYNCWINDOWPOS)
   #undef IF_SWP

   return strRes.IsEmpty() ? strRes : strRes.Mid(3);
#endif // LOGGER_DUMMY
}

/* static */ CString CLogger::DialogCode(int iCode) {
   CString strRes;

#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%04X"), iCode);
#else // LOGGER_DUMMY
   switch (iCode) {
   #define CASE_DC1(val)     case (val): strRes = _T(#val); break;
   #define CASE_DC2(val, sz) case (val): strRes = (sz); break;
   CASE_DC1(DLGC_WANTARROWS     )
   CASE_DC1(DLGC_WANTTAB        )
   CASE_DC2(DLGC_WANTALLKEYS    , _T("DLGC_WANTALLKEYS == DLGC_WANTMESSAGE"))
 //CASE_DC1(DLGC_WANTMESSAGE    )
   CASE_DC1(DLGC_HASSETSEL      )
   CASE_DC1(DLGC_DEFPUSHBUTTON  )
   CASE_DC1(DLGC_UNDEFPUSHBUTTON)
   CASE_DC1(DLGC_RADIOBUTTON    )
   CASE_DC1(DLGC_WANTCHARS      )
   CASE_DC1(DLGC_STATIC         )
   CASE_DC1(DLGC_BUTTON         )
   #undef CASE_DC1
   #undef CASE_DC2
   default:
      strRes.Format(_T("0x%08X"), iCode ); break;
   }
#endif // LOGGER_DUMMY

   return strRes;
}

/* static */ CString CLogger::ButtonState(int iState) {
   CString strRes;

#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08X"), iState);
   return strRes;
#else // LOGGER_DUMMY

   if (iState & 0xFFFFFFF0) {
      strRes.Format(_T(" | 0x%08X"), iState & 0xFFFFFFF0);
   }
   if (iState & BST_PUSHED) strRes += _T(" | BST_PUSHED");
   if (iState & BST_FOCUS ) strRes += _T(" | BST_FOCUS" );
   switch (iState & 0x3) {
   case BST_UNCHECKED    : strRes += _T(" | BST_UNCHECKED"    ); break;
   case BST_CHECKED      : strRes += _T(" | BST_CHECKED"      ); break;
   case BST_INDETERMINATE: strRes += _T(" | BST_INDETERMINATE"); break;
   default               : strRes += _T(" | 0x3"); // three-state check box
   }
   if (strRes.IsEmpty())
      return _T("0x00000000");
   else
      return strRes.Mid(3);
#endif // LOGGER_DUMMY
}

/* static */ CString CLogger::PrinterStatus(DWORD dwStatus) {
   CString strRes;

#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08X"), dwStatus);
   return strRes;
#else // LOGGER_DUMMY

   #define IF_PS(val) if (dwStatus & (val)) {strRes += _T(" | ")_T(#val);}
   IF_PS(PRINTER_STATUS_PAUSED           )
   IF_PS(PRINTER_STATUS_ERROR            )
   IF_PS(PRINTER_STATUS_PENDING_DELETION )
   IF_PS(PRINTER_STATUS_PAPER_JAM        )
   IF_PS(PRINTER_STATUS_PAPER_OUT        )
   IF_PS(PRINTER_STATUS_MANUAL_FEED      )
   IF_PS(PRINTER_STATUS_PAPER_PROBLEM    )
   IF_PS(PRINTER_STATUS_OFFLINE          )
   IF_PS(PRINTER_STATUS_IO_ACTIVE        )
   IF_PS(PRINTER_STATUS_BUSY             )
   IF_PS(PRINTER_STATUS_PRINTING         )
   IF_PS(PRINTER_STATUS_OUTPUT_BIN_FULL  )
   IF_PS(PRINTER_STATUS_NOT_AVAILABLE    )
   IF_PS(PRINTER_STATUS_WAITING          )
   IF_PS(PRINTER_STATUS_PROCESSING       )
   IF_PS(PRINTER_STATUS_INITIALIZING     )
   IF_PS(PRINTER_STATUS_WARMING_UP       )
   IF_PS(PRINTER_STATUS_TONER_LOW        )
   IF_PS(PRINTER_STATUS_NO_TONER         )
   IF_PS(PRINTER_STATUS_PAGE_PUNT        )
   IF_PS(PRINTER_STATUS_USER_INTERVENTION)
   IF_PS(PRINTER_STATUS_OUT_OF_MEMORY    )
   IF_PS(PRINTER_STATUS_DOOR_OPEN        )
   IF_PS(PRINTER_STATUS_SERVER_UNKNOWN   )
   IF_PS(PRINTER_STATUS_POWER_SAVE       )
 //IF_PS(PRINTER_STATUS_UNAVAILABLE      )
   #undef IF_PS

   return strRes.IsEmpty() ? strRes : strRes.Mid(3);
#endif // LOGGER_DUMMY
}

/* static */ CString CLogger::PrinterAttributes(DWORD dwAttributes) {
   CString strRes;

#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08X"), dwAttributes);
   return strRes;
#else // LOGGER_DUMMY

   #define IF_PA(val) if (dwAttributes & (val)) {strRes += _T(" | ")_T(#val);}
   IF_PA(PRINTER_ATTRIBUTE_QUEUED           )
   IF_PA(PRINTER_ATTRIBUTE_DIRECT           )
   IF_PA(PRINTER_ATTRIBUTE_DEFAULT          )
   IF_PA(PRINTER_ATTRIBUTE_SHARED           )
   IF_PA(PRINTER_ATTRIBUTE_NETWORK          )
   IF_PA(PRINTER_ATTRIBUTE_HIDDEN           )
   IF_PA(PRINTER_ATTRIBUTE_LOCAL            )
   IF_PA(PRINTER_ATTRIBUTE_ENABLE_DEVQ      )
   IF_PA(PRINTER_ATTRIBUTE_KEEPPRINTEDJOBS  )
   IF_PA(PRINTER_ATTRIBUTE_DO_COMPLETE_FIRST)
   IF_PA(PRINTER_ATTRIBUTE_WORK_OFFLINE     )
   IF_PA(PRINTER_ATTRIBUTE_ENABLE_BIDI      )
   IF_PA(PRINTER_ATTRIBUTE_RAW_ONLY         )
   IF_PA(PRINTER_ATTRIBUTE_PUBLISHED        )
#ifdef __SDK__
   IF_PA(PRINTER_ATTRIBUTE_FAX              )
   IF_PA(PRINTER_ATTRIBUTE_TS               )
#endif // __SDK__
   #undef IF_PA

   return strRes.IsEmpty() ? strRes : strRes.Mid(3);
#endif // LOGGER_DUMMY
}

/* static */ CString CLogger::PrinterJobStatus(DWORD dwJobStatus) {
   CString strRes;

#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08X"), dwJobStatus);
   return strRes;
#else // LOGGER_DUMMY

   #define IF_PJS(val) if (dwJobStatus & (val)) {strRes += _T(" | ")_T(#val);}
   IF_PJS(JOB_STATUS_PAUSED           )
   IF_PJS(JOB_STATUS_ERROR            )
   IF_PJS(JOB_STATUS_DELETING         )
   IF_PJS(JOB_STATUS_SPOOLING         )
   IF_PJS(JOB_STATUS_PRINTING         )
   IF_PJS(JOB_STATUS_OFFLINE          )
   IF_PJS(JOB_STATUS_PAPEROUT         )
   IF_PJS(JOB_STATUS_PRINTED          )
   IF_PJS(JOB_STATUS_DELETED          )
   IF_PJS(JOB_STATUS_BLOCKED_DEVQ     )
   IF_PJS(JOB_STATUS_USER_INTERVENTION)
   IF_PJS(JOB_STATUS_RESTART          )
#ifdef __SDK__
   IF_PJS(JOB_STATUS_COMPLETE         )
#endif // __SDK__
   #undef IF_PJS

   return strRes.IsEmpty() ? strRes : strRes.Mid(3);
#endif // LOGGER_DUMMY
}

/* static */ CString CLogger::ExceptionCode(DWORD dwExceptionCode, BOOL bDescription) {
   CString strRes;
#ifdef LOGGER_DUMMY
   {
#else // LOGGER_DUMMY
   switch (dwExceptionCode) {
   #define CASE_EC(val, Description) case (val): strRes = ((bDescription) ? (Description) : _T(#val)); break;
   CASE_EC(EXCEPTION_ACCESS_VIOLATION        , _T("The thread tried to read from or write to a virtual address for which it does not have the appropriate access."                                                                                                        ))
   CASE_EC(EXCEPTION_ARRAY_BOUNDS_EXCEEDED   , _T("The thread tried to access an array element that is out of bounds and the underlying hardware supports bounds checking."                                                                                               ))
   CASE_EC(EXCEPTION_BREAKPOINT              , _T("A breakpoint was encountered."                                                                                                                                                                                         ))
   CASE_EC(EXCEPTION_DATATYPE_MISALIGNMENT   , _T("The thread tried to read or write data that is misaligned on hardware that does not provide alignment. For example, 16-bit values must be aligned on 2-byte boundaries; 32-bit values on 4-byte boundaries, and so on."))
   CASE_EC(EXCEPTION_FLT_DENORMAL_OPERAND    , _T("One of the operands in a floating-point operation is denormal. A denormal value is one that is too small to represent as a standard floating-point value."                                                             ))
   CASE_EC(EXCEPTION_FLT_DIVIDE_BY_ZERO      , _T("The thread tried to divide a floating-point value by a floating-point divisor of zero."                                                                                                                                ))
   CASE_EC(EXCEPTION_FLT_INEXACT_RESULT      , _T("The result of a floating-point operation cannot be represented exactly as a decimal fraction."                                                                                                                         ))
   CASE_EC(EXCEPTION_FLT_INVALID_OPERATION   , _T("This exception represents any floating-point exception not included in this list."                                                                                                                                     ))
   CASE_EC(EXCEPTION_FLT_OVERFLOW            , _T("The exponent of a floating-point operation is greater than the magnitude allowed by the corresponding type."                                                                                                           ))
   CASE_EC(EXCEPTION_FLT_STACK_CHECK         , _T("The stack overflowed or underflowed as the result of a floating-point operation."                                                                                                                                      ))
   CASE_EC(EXCEPTION_FLT_UNDERFLOW           , _T("The exponent of a floating-point operation is less than the magnitude allowed by the corresponding type."                                                                                                              ))
   CASE_EC(EXCEPTION_ILLEGAL_INSTRUCTION     , _T("The thread tried to execute an invalid instruction."                                                                                                                                                                   ))
   CASE_EC(EXCEPTION_IN_PAGE_ERROR           , _T("The thread tried to access a page that was not present, and the system was unable to load the page. For example, this exception might occur if a network connection is lost while running a program over the network." ))
   CASE_EC(EXCEPTION_INT_DIVIDE_BY_ZERO      , _T("The thread tried to divide an integer value by an integer divisor of zero."                                                                                                                                            ))
   CASE_EC(EXCEPTION_INT_OVERFLOW            , _T("The result of an integer operation caused a carry out of the most significant bit of the result."                                                                                                                      ))
   CASE_EC(EXCEPTION_INVALID_DISPOSITION     , _T("An exception handler returned an invalid disposition to the exception dispatcher. Programmers using a high-level language such as C should never encounter this exception."                                            ))
   CASE_EC(EXCEPTION_NONCONTINUABLE_EXCEPTION, _T("The thread tried to continue execution after a noncontinuable exception occurred."                                                                                                                                     ))
   CASE_EC(EXCEPTION_PRIV_INSTRUCTION        , _T("The thread tried to execute an instruction whose operation is not allowed in the current machine mode."                                                                                                                ))
   CASE_EC(EXCEPTION_SINGLE_STEP             , _T("A trace trap or other single-instruction mechanism signaled that one instruction has been executed."                                                                                                                   ))
   CASE_EC(EXCEPTION_STACK_OVERFLOW          , _T("The thread used up its stack."                                                                                                                                                                                         ))
   #undef CASE_EC
   default:
#endif // LOGGER_DUMMY
      if (bDescription) {
         strRes = _T("Unknown exception");
      } else {
         strRes.Format(_T("0x%08X"), dwExceptionCode);
      }
   }
   return strRes;
}

/* static */ CString CLogger::ShellExec(HINSTANCE hInst, BOOL bDescription) {
   CString strRes;

   if (DWORD(hInst) > 32) {
      if (bDescription) {
         strRes = _T("Valid HINSTANCE.");
      } else {
         strRes.Format(_T("0x%08X"), hInst);
      }
   } else {
#ifdef LOGGER_DUMMY
      {
#else // LOGGER_DUMMY
      switch (DWORD(hInst)) {
      #define CASE_SE(val, Description) case (val): strRes = ((bDescription) ? (Description) : _T(#val)); break;
      CASE_SE(0                     , _T("The operating system is out of memory or resources."))
      CASE_SE(ERROR_FILE_NOT_FOUND  , _T("The specified file was not found. "))
      CASE_SE(ERROR_PATH_NOT_FOUND  , _T("The specified path was not found. "))
      CASE_SE(ERROR_BAD_FORMAT      , _T("The .exe file is invalid (non-Microsoft Win32 .exe or error in .exe image). "))
      CASE_SE(SE_ERR_ACCESSDENIED   , _T("The operating system denied access to the specified file. "))
      CASE_SE(SE_ERR_ASSOCINCOMPLETE, _T("The file name association is incomplete or invalid. "))
      CASE_SE(SE_ERR_DDEBUSY        , _T("The Dynamic Data Exchange (DDE) transaction could not be completed because other DDE transactions were being processed. "))
      CASE_SE(SE_ERR_DDEFAIL        , _T("The DDE transaction failed. "))
      CASE_SE(SE_ERR_DDETIMEOUT     , _T("The DDE transaction could not be completed because the request timed out. "))
      CASE_SE(SE_ERR_DLLNOTFOUND    , _T("The specified dynamic-link library (DLL) was not found. "))
    //CASE_SE(SE_ERR_FNF            , _T("The specified file was not found. "))
      CASE_SE(SE_ERR_NOASSOC        , _T("There is no application associated with the given file name extension. This error will also be returned if you attempt to print a file that is not printable. "))
      CASE_SE(SE_ERR_OOM            , _T("There was not enough memory to complete the operation. "))
    //CASE_SE(SE_ERR_PNF            , _T("The specified path was not found. "))
      CASE_SE(SE_ERR_SHARE          , _T("A sharing violation occurred."))
      #undef CASE_SE
      default:
#endif // LOGGER_DUMMY
         if (bDescription) {
            strRes = _T("Unknown error.");
         } else {
            strRes.Format(_T("%i"), hInst);
         }
      }
   }
   return strRes;
}

/* static */ CString CLogger::ResourceType(LPCTSTR lpszType, BOOL bDescription) {
   CString strRes;
#ifdef LOGGER_DUMMY
   {
#else // LOGGER_DUMMY
   switch ((ULONG_PTR)lpszType) {
   #define CASE_RT(val, Description) case (val): strRes = ((bDescription) ? (Description) : _T(#val)); break;
   CASE_RT(RT_ACCELERATOR  , _T("Accelerator table."                      ))
   CASE_RT(RT_ANICURSOR    , _T("Animated cursor."                        ))
   CASE_RT(RT_ANIICON      , _T("Animated icon."                          ))
   CASE_RT(RT_BITMAP       , _T("Bitmap resource."                        ))
   CASE_RT(RT_CURSOR       , _T("Hardware-dependent cursor resource."     ))
   CASE_RT(RT_DIALOG       , _T("Dialog box."                             ))
   CASE_RT(RT_DLGINCLUDE   , _T("Resource editing tool."                  ))
   CASE_RT(RT_FONT         , _T("Font resource."                          ))
   CASE_RT(RT_FONTDIR      , _T("Font directory resource."                ))
   CASE_RT(RT_GROUP_CURSOR , _T("Hardware-independent cursor resource."   ))
   CASE_RT(RT_GROUP_ICON   , _T("Hardware-independent icon resource."     ))
   CASE_RT(RT_HTML         , _T("HTML."                                   ))
   CASE_RT(RT_ICON         , _T("Hardware-dependent icon resource."       ))
   CASE_RT(RT_MANIFEST     , _T("Side-by-Side Assembly XML Manifest."     ))
   CASE_RT(RT_MENU         , _T("Menu resource."                          ))
   CASE_RT(RT_MESSAGETABLE , _T("Message-table entry."                    ))
   CASE_RT(RT_PLUGPLAY     , _T("Plug and Play resource."                 ))
   CASE_RT(RT_RCDATA       , _T("Application-defined resource (raw data)."))
   CASE_RT(RT_STRING       , _T("String-table entry."                     ))
   CASE_RT(RT_VERSION      , _T("Version resource."                       ))
   CASE_RT(RT_VXD          , _T("VXD."                                    ))
   #undef CASE_RT
   default:
#endif // LOGGER_DUMMY
      if (bDescription) {
         strRes = _T("Unknown resource.");
      } else {
         if (IS_INTRESOURCE(lpszType))
            strRes.Format(_T("%i"), lpszType);
         else
            strRes = lpszType;
      }
   }
   return strRes;
}

/* static */ CString CLogger::OwnerDrawCtlType(UINT iCtlType) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08X"), iCtlType);
#else // LOGGER_DUMMY
   switch (iCtlType) {
   #define CASE_ODCT(val) case (val): strRes = _T(#val); break;
   CASE_ODCT(ODT_MENU    )
   CASE_ODCT(ODT_LISTBOX )
   CASE_ODCT(ODT_COMBOBOX)
   CASE_ODCT(ODT_BUTTON  )
   CASE_ODCT(ODT_STATIC  )
   CASE_ODCT(ODT_HEADER  )
   CASE_ODCT(ODT_TAB     )
   CASE_ODCT(ODT_LISTVIEW)
   #undef CASE_ODCT
   default:
      strRes.Format(_T("0x%08X"), iCtlType);
   }
#endif // LOGGER_DUMMY
   return strRes;
}

/* static */ CString CLogger::OwnerDrawItemAction(UINT itemAction) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08X"), itemAction);
#else // LOGGER_DUMMY
   #define IF_ODIA(val) if (itemAction & (val)) {strRes += _T(" | ")_T(#val);}
   IF_ODIA(ODA_DRAWENTIRE)
   IF_ODIA(ODA_FOCUS     )
   IF_ODIA(ODA_SELECT    )
   #undef IF_ODIA
   if (!strRes.IsEmpty())
      strRes = strRes.Mid(3);
#endif // LOGGER_DUMMY
   return strRes;
}


/* static */ CString CLogger::OwnerDrawItemState(UINT itemState) {
   CString strRes;
#ifdef LOGGER_DUMMY
   strRes.Format(_T("0x%08X"), itemState);
#else // LOGGER_DUMMY
   #define IF_ODIS(val) if (itemState & (val)) {strRes += _T(" | ")_T(#val);}
   IF_ODIS(ODS_CHECKED     )
   IF_ODIS(ODS_COMBOBOXEDIT)
   IF_ODIS(ODS_DEFAULT     )
   IF_ODIS(ODS_DISABLED    )
   IF_ODIS(ODS_FOCUS       )
   IF_ODIS(ODS_GRAYED      )
   IF_ODIS(ODS_HOTLIGHT    )
   IF_ODIS(ODS_INACTIVE    )
   IF_ODIS(ODS_NOACCEL     )
   IF_ODIS(ODS_NOFOCUSRECT )
   IF_ODIS(ODS_SELECTED    )
   #undef IF_ODIS
   if (!strRes.IsEmpty())
      strRes = strRes.Mid(3);
#endif // LOGGER_DUMMY
   return strRes;
}

#endif // LOGGER_UNDEF
